let sr = require("./lib/sr-sdk-wxapp.js").init({
  appid: "wx29d1ac1fcd50aeb6", // 微信小程序appID，以wx开头
  token: "bi8eb4078127bd45ff", // 测试：bi50fbec6d1cc84ce5 正式：bi8eb4078127bd45ff
  //token是唯一必须配置的参数，请联系有数数据服务sr_data_service@tencent.com提供
  openSdkShareDepth: true, //是否打开分享链路记录功能，默认值为false，打开后，将记录用户分享链路A->B->C->D
  trackApp: true, //SDK 默认上报小程序的 启动 、显示 、隐藏 事件，trackApp: false 关闭该功能。
  proxyPage: true, // 是否开启自动代理 Page，默认是：false。
  usePlugin: true, //是否使用了小程序插件，默认是：false
  autoStart: true, //是否开启自动开始上报，默认是：false，open_id 无法自动获取，一般在 login 业务之后手动调用 sr.startReport 方法开启上报
  openAutoTrackOpenId: true,
  debug: true,
});

import {
  REQUEST,
  API,
  UTIL,
  SHOPCARTSERVER
} from "./utils/index.js";
import {
  WGAUTH,
  WGCOMMON,
  WGTRACK,
  wgPageUtil,
  WGHTTP
} from "./wgUtils/index";
import Tracker from "./wgUtils/wgTrack/libs/index";
import trackConfig from "./wgUtils/wgTrack/wgTrackConfig";
import env1 from "./utils/env1";
import WGAPI from './api/index'

// 初始化有数配置
const tracker = new Tracker({
  tracks: trackConfig,
});
// var xm_bi = require("/utils/xm_analysis.js");

let livePlayer = null

if (env1 == 'PROD') {
  livePlayer = requirePlugin("live-player-plugin"); //-- 直播代码
}

const globalData = {
  queryObj: null,
  campaign: "wechat",
  cusId: wx.getStorageSync("cusId"),
  openId: wx.getStorageSync("openId"),
  secretId: "AKIDXuRowcRVZ5dMuh6KzdH1IVZdzBOoJ5xe", //腾讯云账号的secretId
  secretKey: "dz7oLxBC3kW5VY7UgAUfaeT43tfhbHiK", //腾讯云账号的secretKey
  version: "2019-01-21",
  session_key: "",
  commentDetail: null,
  refundDetail: null,
  adIndex: null,
  actType: 0,
  returnFormDetail: null,
  leaveMessage: "",
  tickets: {
    ticket1: null, // 满减
    ticket2: null, // 满赠
    ticket3: null, // 积分
  },
  preData: {
    prePrice: "",
    lastPrice: "",
    frontMoneyStartTime: "",
    frontMoneyEndTime: "",
    balancePaymentStartTime: "",
    balancePaymentEndTime: "",
  },
  orderOrigin: null, // 订单来源：1-产品下单，0-加购下单
  userAvatarUrl: "",
  nickName: "",
  scene: null,
  selectedData: null,
  addtominiprogram: false, // 是否添加到我的小程序
  installmentDate: [],
  myCardNum: 0,
  switchTabQueryObj: null,
  userCoupons: [], // 用户的专享优惠券
};
const methods = {
  saveUnionId(data) {
    if (data.unionid) {
      let url =
        API.post_save_unionId +
        "?openId=" +
        data.openid +
        "&unionId=" +
        data.unionid;
      REQUEST.post(url, {
          header: {
            "content-type": "application/json",
          },
        })
        .then(() => {})
        .catch(() => {});
    }
  },
  getKey(code) {
    return new Promise((resolve, reject) => {
      let url = API.get_openid + "?jsCode=" + code;
      REQUEST.get(url)
        .then((res) => {
          if (res.statusCode == 200) {
            wx.setStorageSync("openId", JSON.parse(res.data).openid);
            resolve(JSON.parse(res.data));
          }
        })
        .catch((e) => {
          reject(e);
        });
    });
  },
};
App({
  globalData: globalData,
  ...methods,
  sr,
  onLaunch: function (options) {
    WGAUTH.wxLogin()
    WGTRACK.setUserOpenId(wx.getStorageSync("openId"));
    // xm_bi.App.init({
    //   appKey: "P7YU23LZ4GHN", //请填写 step 3 记录的 appKey
    //   requestUrl: "https://zjmpa.cloud.tencent.com/", //上报 url
    //   lauchOpts: options, //渠道分析,需在 onLaunch 方法传入 options
    //   statPullDownFresh: true, //下拉刷新统计
    //   statShareApp: true, //分享统计
    //   statReachBottom: true, //页面触底统计
    //   openId: wx.getStorageSync("openId") ? wx.getStorageSync("openId") : "", //如有获取可设置，进行 openid 帐号分析
    //   statAutoReport: true, //自动上报开关，开启后页面自动上报
    //   channelTag: "zjChanId", //设置后可统计珠玑推文带来的小程序点击
    //   ignoreParams: ["time"], //忽略某些参数上报
    // });
    console.log('场景值', wx.getLaunchOptionsSync().scene)
    if(wx.getStorageSync('cusId')) {
      WGAPI.coupons.queryValidTicketActivitys(wx.getStorageSync('cusId')).then(res => {
        this.globalData.userCoupons = res
      })
      SHOPCARTSERVER.refreshCartByServer()
    }
  },
  onShow: function (options) {
    WGAUTH.qyLogin();
    UTIL.setCartNum();
    let _self = this;
    let lanchOptions = wx.getLaunchOptionsSync();
    if (wx.getStorageSync("flag")) { // 已经显示过
      this.globalData.addtominiprogram = false;
    } else {
      this.globalData.addtominiprogram = true;
    }
    _self.globalData.scene = lanchOptions.scene;
    WGTRACK.setChanInfo(lanchOptions);
    WGTRACK.setUserOpenId(wx.getStorageSync("openId"));
    //直播业务
    // 分享卡片入口场景才调用getShareParams接口获取以下参数
    if (env1 == 'PROD') {
      if (options.scene == 1007 || options.scene == 1008 || options.scene == 1044) {
        livePlayer
          .getShareParams()
          .then((res) => {
            // 房间号 res.room_id
            // 用户openid res.openid
            // res.share_openid); // 分享者openid，分享卡片进入场景才有 res.share_openid
            // 开发者在跳转进入直播间页面时，页面路径上携带的自定义参数，这里传回给开发者 res.custom_params
            if (res.custom_params.staffId && res.custom_params.staffId.length > 0) {
              const params = {
                openId: res.openid,
                staffId: res.custom_params.staffId,
                roomId: res.room_id,
                liveStatus: 101,
              };
              //分包里的接口, 由于主包加载较早,不能先 import 分包的 API. 在这里直接用变量记录
              const staffInfoSubscribe = "wechat-miniprogram-service/miniLive/subscribeMsg";
              WGHTTP.get(staffInfoSubscribe, params).then((res) => {});
            }
          })
          .catch((err) => {
            console.log("get share params", err);
          });
      }
    }
  },
  onHide: function () {
    globalData.selectedData = null;
  },
  watch(method) {
    var obj = this.globalData;
    Object.defineProperty(obj, "myCardNum", {
      configurable: true,
      enumerable: true,
      set(val) {
        this._myCardNum = val;
        method(val);
      },
      get() {
        return this._myCardNum;
      },
    })

    Object.defineProperty(obj, 'showSubscribeGif', {
      configurable: true,
      enumerable: true,
      set: function (value) {
        this._showSubscribeGif = value
        method(value)
      },
      get: function (value) {
        return this._showSubscribeGif
      },
    })

  },
});