import { REQUEST, API, TOAST } from '../../utils/index'
const app = getApp()
const data = {
  msg: '暂无数据'
}
const methods = {
  getAddressList(id) {
    let cusId = wx.getStorageSync('cusId')
    if(cusId) {
      REQUEST.get(API.get_address, {
        data: {
          openId: '',
          cusId: cusId
        }
      }).then((res) => {
        const {
          status,
          data
        } = res.data
        if (status == 0) {
          if (data.length > 0) {
            for (let i = 0; i < data.length; i++) {
              if (data[i].isDefault) {
                if (app.globalData.adIndex == id) {
                  app.globalData.adIndex = data[i].id
                }
                data[i].isChecked = true
                break;
              }
              data[i].isChecked = false
            }
            this.setData({
              addressModule: data
            })
          } else {
            this.setData({
              addressModule: []
            })
          }
        } else if (status == 10021) { // 地址无效: 地址为空
          this.setData({
            addressModule: []
          })
        }
      }).catch((e) => {
      })
    }
  },
  setDefault(event) {
    if (event.currentTarget.dataset.item.isDefault) {
      TOAST.warning({
        title: '已是默认地址'
      })
      return
    }
    let url = API.get_defaultadress + event.currentTarget.dataset.item.id
    REQUEST.get(url).then((res) => {
      this.getAddressList()
    })
    app.globalData.adIndex = null
  },
  edit(e) {
    let params = {
      'type': e.currentTarget.dataset.type,
      'item': e.currentTarget.dataset.detail
    }
    if (e.currentTarget.dataset.type == 'true') {
      wx.setStorageSync('add', 3) // 订单列表新增
    } else {
      wx.setStorageSync('add', 2)
      params = {
        'type': e.currentTarget.dataset.type,
        'item': e.currentTarget.dataset.detail
      }
    }
    if (this.data.origin == 'user') {
      wx.setStorageSync('add', 4)
    }
    this.triggerEvent('edit', params)
  },
  del(event) {
    let _self = this
    wx.showModal({
      title: '提示',
      content: '确定要删除地址吗？',
      confirmColor: '#FF4318',
      success: function (res) {
        if (res.confirm) {
          let url = API.del_adress + event.currentTarget.dataset.id
          REQUEST.get(url).then((res) => {
            const { status, msg } = res.data
            if (status == 0) {
              _self.getAddressList(event.currentTarget.dataset.id)
            } else {
              TOAST.warning({ title: msg })
            }
          }).catch((e) => {
          })
        }
      }
    })
  }
}
Component({
  properties: {
    origin: {
      type: String,
      observe: function(newVal, oldVal) {
      }
    },
    addressModule: {
      type: Array
    }
  },
  data,
  methods,
  ready() {
  }
})
