import { WGAUTH } from '../../wgUtils/index'

/**
 * 通用授权插件 @type
 * 0 需要cusId：授权手机号
 * 1 需要用户头像昵称：授权头像昵称
 * 2 需要cusId和头像昵称：授权手机号和头像昵称
 */
Component({
  properties: {
    type: {  
      type: Number,
      default: 2,
    },
  },
  data: {
    authType: 1, /** 授权类型：1手机号，2用户信息 */
    canIUseGetUserProfile: false,
  },
  methods: {
    bindgetphonenumber(e) {
      WGAUTH.getPhoneNumber(e).then(() => {
        this.triggerEvent('success')
      }).catch(() => {
        this.triggerEvent('fail')
      })
    },
    bindgetuserinfo(e) {
      WGAUTH.getUserInfo(e).then(() => {
        if(this.data.type == 2) {
          this.setData({ authType: 1 })
        } else {
          this.triggerEvent('success')
        }
      }).catch(() => {
        this.triggerEvent('fail')
      })
    },
    getUserProfile(e) {
      WGAUTH.getUserProfile().then(() => {
        if(this.data.type == 2) {
          this.setData({ authType: 1 })
        } else {
          this.triggerEvent('success')
        }
      }).catch(() => {
        this.triggerEvent('fail')
      })
    },
  },
  lifetimes: {
    attached: function() {
      if (wx.getUserProfile) {
        this.setData({
          canIUseGetUserProfile: true
        })
      }
      // 在组件实例进入页面节点树时执行
      // let unionId = wx.getStorageSync('unionId')
      // let cusId = wx.getStorageSync('cusId')
      // let nickName = wx.getStorageSync('nickName')
      // let avatarUrl = wx.getStorageSync('avatarUrl')
      this.setData({
        authType: this.data.type == 0?1:2   // 没有unionid需要全部授权，有unionid就只授权手机号
      })
    },
    detached: function() {
      // 在组件实例被从页面节点树移除时执行
    },
  }
})