import api from '../../api/index'
import { LOADING } from '../../utils/index'
import { WGAUTH, WGTRACK } from '../../wgUtils/index'
const app = getApp()
Component({
  properties: {
    bannerData: Array,
    currentIndex: {
      type: Number,
      value: 0
    },
    bannerHeight: {
      type: Number,
      value: 350
    },
    bannerWidth: {
      type: Number,
      value: 750
    },
    indicatorDots: {
      type: Boolean,
      value: true,
    },
    interval: {  //轮播间隔
      type: Number,
      value: 5000
    },
  },
  data: {
    hideLoginPanel: true,
    loadingNum: 0,
  },
  observers: {
    'bannerData': function(val) {
      this.setData({
        loadingNum: val.length
      })
    }
  },
  methods: {
    loadImg(e) {
      // 只加载一次，否则瀑布流有问题
      if(this.data.loadingNum == 1){
        var imgh = e.detail.height;　　　　　　　　　　　　　　　　 //图片高度
        var imgw = e.detail.width;
        this.triggerEvent('bannerHeightFn', {bannerHeight: (imgh / imgw) * this.data.bannerWidth, })
        this.setData({
          bannerHeight: (imgh / imgw) * this.data.bannerWidth,
        })
      } else {
        this.setData({
          loadingNum: this.data.loadingNum - 1
        })
      }
    },
    linkToOtherPage(url, query, cellId) {
      api.modules.getActivityPageId(url).then(r => {
        if (r.id) {
          wx.navigateTo({
            url: '/pages/ActivityPage/ActivityPage?id=' + r.id + '&unit_id=' + cellId + '&' + query
          })
        }
      })
    },
    linkToPage(e) {
      let obj = e.currentTarget.dataset.item
      obj.link = obj.link ? obj.link.toString() : ''
      if(obj.advertisingType == 1){  //视频号
        WGTRACK.logCustomEvent('click_channelsActivity', {finderUserName: obj.wechatChannelId,feedId: obj.wechatVideoId})
        if(obj.wechatChannelId && obj.wechatVideoId){
          try {
            if(wx.openChannelsActivity) {
               // 有视频ID， 直接进入对应视频
              wx.openChannelsActivity({
                finderUserName: obj.wechatChannelId,
                feedId: obj.wechatVideoId,
                success: function(res){
                  console.log(res)
                },
                fail(res) {
                  console.log('跳转视频号失败',res)
                }
              })
            } else {
              throw new Error('openChannelsActivity error')
            }
          } catch (error) {
            wx.navigateTo({
              url: '/pages/WebView/WebView?url=https://mp.weixin.qq.com/s/GVIW7f-wVsBeHCaoHtQFIg'
            })
            console.log('微信版本太低，不支持直接跳转视频号')
          }
        
        } else if(obj.wechatChannelId) {
          try {
            if(wx.openChannelsUserProfile) {
               // 没有对应视频ID， 进入视频号主页
              wx.openChannelsUserProfile({
                finderUserName: obj.wechatChannelId,
                success: function(res){
                  console.log(res)
                },
                fail(res) {
                  console.log('跳转视频号主页失败',res)
                }
              })
            } else {
              throw new Error('openChannelsActivity error')
            }
          } catch (error) {
            wx.navigateTo({
              url: '/pages/WebView/WebView?url=https://mp.weixin.qq.com/s/GVIW7f-wVsBeHCaoHtQFIg'
            })
            console.log('微信版本太低，不支持直接跳转视频号主页')
          }
        
        }
      } else 
      if (!obj.appId && (obj.link.indexOf('modules/FanCommunity/pages/WgFans/WgFans') != -1 || obj.link.indexOf('/pages/ProductIndex/ProductIndex') != -1 || obj.link.indexOf('/pages/MyCart/MyCart') != -1 || obj.link.indexOf('/pages/PersonalCenter/PersonalCenter') != -1 || obj.link.indexOf('/pages/Home/Home') != -1)) { // 首页 + 超级会员
        let query = obj.link.split('?')
        if (query.length > 1) {
          let queryObj = {}
          let queryArr = query[1].split('&')
          for (let i = 0; i < queryArr.length; i++) {
            let tmp = queryArr[i].split('=')
            queryObj[tmp[0]] = tmp[1]
          }
          queryObj['unit_id'] = obj.id
          app.globalData.switchTabQueryObj = queryObj
        }
        wx.switchTab({
          url: query[0]
        })
      } else if (obj.link == 'top' || obj.link == 'Top' || obj.link == 'TOP') { // 回到顶部
        wx.pageScrollTo({
          scrollTop: 0,
          duration: 300
        })
      } else if (obj.appId && obj.link) { // 优惠券 & 二级页面 & 小程序页面
        if (obj.appId == '优惠券') {
          let cusId = wx.getStorageSync('cusId')
          if (cusId) {
            api.coupons.detail(obj.link).then(r => {
              if (r.needPoints == 0) {
                api.coupons.receive(cusId, obj.link, r.userTkcpAmount)
              } else {
                wx.showModal({
                  title: '提示',
                  content: '领一张券需扣您' + r.needPoints + '积分，您确定要领吗?',
                  success(res) {
                    if (res.confirm) {
                      api.coupons.receive(cusId, obj.link, r.userTkcpAmount)
                    }
                  }
                })
              }
            })
          } else {
            this.setData({
              hideLoginPanel: false
            })
          }
        } else if (obj.appId == '二级页面') {
          wx.navigateTo({
            url: '/pages/ActivityPage/ActivityPage?id=' + obj.link + '&unit_id=' + obj.id
          })
        } else if (obj.appId == 'miniappPage') { // 小程序二级页面
          wx.navigateTo({
            url: `/pages/ActivePage/ActivePage?id=${obj.link}&unit_id=${obj.id}`
          })
        } else {
          wx.navigateToMiniProgram({
            appId: obj.appId,
            path: obj.link,
            extraData: {
              foo: 'bar'
            },
            envVersion: 'release',
            success(res) { }
          })
          console.log('打开其他小程序', obj)
        }
      } else if (obj.link.indexOf('.wgmf.com/wechat-html/html/shop/product/') != -1) { // 二级页面
        let arr = obj.link.split('?')
        let a = arr[0]
        let b = a.split('/')
        let url = b[b.length - 1]
        let query = arr.length > 1 ? arr[1] : ''
        this.linkToOtherPage(url, query, obj.id)
      } else if (obj.link) { // 其他页面
        if(obj.link.indexOf('?') === -1) {
          obj.link += `?unit_id=${obj.id}`
        } else {
          obj.link += `&unit_id=${obj.id}`
        }
        wx.navigateTo({
          url: obj.link
        })
      }
    },
    closeModal() {
      this.setData({
        hideLoginPanel: true
      })
    },
    getPhoneNumber(e) {
      let _self = this
      if (e.detail.errMsg === 'getPhoneNumber:ok') {
        LOADING.show({
          title: '登录中...'
        })
        WGAUTH.getPhoneNumber(e).then((res) => {
          LOADING.hide()
          // _self.triggerEvent('login', true)
          this.setData({
            hideLoginPanel: true
          })
        })
      }
    },
    swiperChange(e){
      if(!this.data.indicatorDots){
        this.setData({
          currentIndex: e.detail.current
        })
      }

    },
  },
  created() {
    // console.log(this.bannerData)
  }
})