const app = getApp()
const globalData = getApp().globalData
import wgApi from '../../api/index'
import { WGCOMMON } from '../../wgUtils/index'

Component({
  data: {
    address: { /** 收货地址 */
      addressModule: [], // 我的收货地址列表
      selectedAddress: null, // 选中的收货地址
    },
    deliverFee: 0, // 运费
  },
  methods: {
    getDefaulAddress() { // 获取默认收货地址
      let _self = this
      let cusId = wx.getStorageSync('cusId')
      if (cusId) {
        wgApi.address.list({
          cusId: cusId,
          openId: wx.getStorageSync('openId')
        }).then(res => {
          let tmpObj = {
            addressModule: res,
            selectedAddress: null
          }
          for(let i=0;i<res.length;i++) {
            if(app.globalData.adIndex != null) {
              if( res[i].id == app.globalData.adIndex ) {
                tmpObj.selectedAddress = res[i]
                break
              }
            } else {
              if(res[i].isDefault) {
                tmpObj.selectedAddress = res[i]
                break
              }
            }
          }
          if(!tmpObj.selectedAddress && res.length > 0) {
            tmpObj.selectedAddress = res[0]
          }
          _self.setData({
            address: tmpObj
          })
          this.getTransportFee()
        }).catch( e => {
          WGCOMMON.showModal('提示', '你的收货地址为空，是否添加新的收货地址？').then(() => {
            wx.setStorageSync('add', 1)
            wx.navigateTo({
              url: '/pages/AddressManage/AddressManage?isEdit=true&actType=0',
            })
          })
        })
      } else {
        WGCOMMON.toast('无cusId无法获取地址！')
      }
    },
    selectOtherAddress() { // 去选择其他地址
      wx.navigateTo({
        url: '/pages/AddressList/AddressList'
      })
    },
    addAddress() { // 新增收货地址
      wx.setStorageSync('add', 1)
      wx.navigateTo({
        url: '/pages/AddressManage/AddressManage?isEdit=true&actType=0',
      })
    },
    getTransportFee() { // 根据收货地址获取运费
      if(this.data.address.selectedAddress) {
        let tmp = this.data.address.selectedAddress
        wgApi.address.deliveFee({
          provinceId: tmp.provinceId,
          cityId: tmp.cityId,
          distId: tmp.distId?tmp.distId:''
        }).then(res => {
          let deliveFee = res.postage > 0 ? res.postage : 0
          this.triggerEvent('success', {
            address: tmp,
            deliveFee: deliveFee
          })
        })
      }
    },
  },
  pageLifetimes: {
    show: function() {
      console.log('chooseAddress onShow', app.globalData.adIndex)
      this.getDefaulAddress()
    },
  }
})