import {
  SHOPCARTSERVER,
  REQUEST,
  API,
  PAY,
  SRTRACK,
  UTIL,
  TOAST,
  LOADING
} from '../../utils/index.js'
import env from '../../utils/env1'
import staffShare from '../../utils/staffShare.js'
import { WGTRACK } from '../../wgUtils/index.js';
const data = {
  disabled: false,
  id: ''
}
const app = getApp()
const methods = {
  pay(e) {
    if (this.data.info.length == 0) { // 无商品
      TOAST.warning({
        title: '请选择一个赠品！',
        duration: 1000
      })
      return
    }
    if (this.data.actType == 6 && !this.data.isAgree) { // 预付定金，预售需要用户先同意预售规则方可支付
      TOAST.warning({
        title: '请同意预付款规则'
      })
      return false
    }
    if (this.data.address == null) { // 收货地址为空
      TOAST.warning({
        title: '请填写地址'
      })
      return false
    }
    LOADING.show({
      title: '数据提交中...'
    })
    let info = this.data.info
    let flag = true
    let _self = this
    if (flag) {
      let orderDetails = []
      let productIds = []
      let ids = []
      let proList = []
      let params = {}
      params.isSvipCustomer = this.data.userInfo.vipCusStatus ==  1 ? 1 : 0 // 是否是未过期会员 0-否，1-是
      this.data.info.forEach((item) => {
        proList.push({
          code: item.productId,
          name: item.name,
          num: item.quantity,
          price: item.isRedeem ? 0 : item.originPrice,
          redeemPrice: item.redeemPrice, // TODU
          specialPrice: 0 //TODU
        })
      })
      params.addressId = this.data.address.id
      let ticketList1 = this.data.ticketListA
      let ticketList2 = this.data.ticketListB
      let ticketList3 = this.data.ticketListC
      let ticketList4 = this.data.ticketListD
      if (ticketList3) {
        if (ticketList3.activityInfo) {
          if (ticketList3.activityInfo.activityType == 13) {
            for (let i = 0; i < ticketList3.validProList.length; i++) {
              for (let j = 0; j < info.length; j++) {
                if (ticketList3.validProList[i].code == info[j].productId) {
                  info[j].activityGrade = ticketList3.giftRuleResultContext.multiplePoint
                }
              }
            }
          }
        }
      }
      if (ticketList1 && ticketList1.validProList && ticketList1.giftRuleResultContext) { // 满减
        if (ticketList1.activityInfo.couponsId) {
          params.couponId = ticketList1.activityInfo.couponsId // true
        }
        let proList1 = []
        params.expand = ticketList1.activityInfo.expand
        params.productIds = []
        let tplIds = []
        let list1 = ticketList1.activityInfo.rule.productInfo // null
        let list2 = ticketList1.activityInfo.rule.proGroupInfo // null
        let list4 = ticketList1.validProList
        if (list1 && list1.length > 0) {
          for (let i = 0; i < list1.length; i++) {
            tplIds.push(list1[i].code)
          }
        }
        if (list2 && list2.length > 0) {
          for (let i = 0; i < list2.length; i++) {
            for (let j = 0; j < list2[i].product.length; j++) {
              tplIds.push(list2[i].product[j].code)
            }
          }
        }
        if (list4 && list4.length > 0) {
          for (let i = 0; i < list4.length; i++) {
            tplIds.push(list4[i].code)
          }
        }
        if (tplIds.length > 0) {
          let setIds = [...new Set(tplIds)]
          for (let i = 0; i < setIds.length; i++) {
            this.data.info.forEach((item) => {
              if (setIds[i] == item.productId) {
                proList1.push({
                  code: item.productId,
                  name: item.name,
                  num: item.quantity,
                  price: item.isRedeem ? 0 : item.originPrice,
                  redeemPrice: item.redeemPrice, // TODU
                  specialPrice: 0 //TODU
                })
                params.productIds.push(item.productId)
              }
            })
          }
        }
        if (this.data.actType != 6 && this.data.actType != 17) {  // 非预售非秒杀
          params.activityParams = [{
            activityId: ticketList1.activityInfo.activityId,
            openId: '',
            cusId: wx.getStorageSync('cusId'),
            orderContext: {
              proList: proList
            }
          }]
          if (ticketList1.giftRuleResultContext) {
            params.activityParams[0].orderResultContext = {
              giftMoney: ticketList1.giftRuleResultContext.giftMoney,
              giftPoint: ticketList1.giftRuleResultContext.giftPoint,
              addOnMoney: ticketList1.activityInfo.giftRule.addOnMoney,
              giftProductInfo: ticketList1.giftRuleResultContext.giftProductInfo
            }
          }
        }

      }
      if (ticketList3 && ticketList3.validProList && ticketList3.giftRuleResultContext) { // 积分
        if (ticketList3.activityInfo.couponsId) {
          params.couponsId = ticketList3.activityInfo.couponsId
        }
        let integralParams = {
          activityId: ticketList3.activityInfo.activityId,
          openId: '',
          cusId: wx.getStorageSync('cusId'),
          orderContext: {
            proList: proList
          }
        }
        if (ticketList3.giftRuleResultContext) {
          integralParams.orderResultContext = {
            giftMoney: ticketList3.giftRuleResultContext.giftMoney,
            giftPoint: ticketList3.giftRuleResultContext.giftPoint,
            addOnMoney: ticketList3.activityInfo.giftRule.addOnMoney,
            giftProductInfo: ticketList3.giftRuleResultContext.giftProductInfo
          }
        }
        if (params.activityParams) {
          params.activityParams.push(integralParams)
        } else {
          params.activityParams = [integralParams]
        }
      }
      if (ticketList2 && ticketList2.giftRuleResultContext) { // 满赠
        if (ticketList2.activityInfo.couponsId) {
          params.couponId = ticketList2.activityInfo.couponsId
        }
        let activeItem = {
          activityId: ticketList2.activityInfo.activityId,
          openId: '',
          cusId: wx.getStorageSync('cusId'),
          orderContext: {
            proList: proList
          }
        }
        if (ticketList2.giftRuleResultContext) {
          activeItem.orderResultContext = {
            giftMoney: ticketList2.giftRuleResultContext.giftMoney,
            giftPoint: ticketList2.giftRuleResultContext.giftPoint,
            addOnMoney: ticketList2.activityInfo.giftRule.addOnMoney,
            giftProductInfo: ticketList2.giftRuleResultContext.giftProductInfo
          }
        }
        if (params.activityParams) {
          params.activityParams.push(activeItem)
        } else {
          params.activityParams = [activeItem]
        }
      }
      if (ticketList4 && ticketList4.giftRuleResultContext) { // 满赠
        if (ticketList4.activityInfo.couponsId) {
          params.couponId = ticketList4.activityInfo.couponsId
        }
        let activeItem = {
          activityId: ticketList4.activityInfo.activityId,
          openId: '',
          cusId: wx.getStorageSync('cusId'),
          orderContext: {
            proList: proList
          }
        }
        if (ticketList4.giftRuleResultContext) {
          activeItem.orderResultContext = {
            giftMoney: ticketList4.giftRuleResultContext.giftMoney,
            giftPoint: ticketList4.giftRuleResultContext.giftPoint,
            addOnMoney: ticketList4.activityInfo.giftRule.addOnMoney,
            giftProductInfo: ticketList4.giftRuleResultContext.giftProductInfo
          }
        }
        if (params.activityParams) {
          params.activityParams.push(activeItem)
        } else {
          params.activityParams = [activeItem]
        }
      }
      params.customerId = wx.getStorageSync('cusId')
      params.miniOpenId = wx.getStorageSync('openId')
      params.campaign =   WGTRACK.getCampaign()
      params.orderAttribution = this.data.orderAttribution
      params.customerOpenId = ''
      // 测试小程序增加 （|| '测试单不要发货'）
      if(env == 'TEST') {
        params.buyerMemo = this.data.buyerMemo || '测试单不要发货'
      } else {
        params.buyerMemo = this.data.buyerMemo
      }
      params.orderDetails = []
      params.isPurchaseOrder = 0 // 非代购单
      let typeFlag = false
      this.data.info.forEach((item) => {
        params.orderDetails.push({
          productId: item.productId,
          quantity: item.quantity,
          activityGrade: item.activityGrade || 1
        })
        productIds.push(item.productId)
        if (item.productId == 58) {
          params.orderSpActivityId = 2
        } else if (item.productId == 3) {
          typeFlag = true
        }
      })
      for (let i = 0; i < orderDetails.length; i++) {
        ids.push(orderDetails[i].productId)
      }
      if (this.data.groupPurchaseId) { // 拼团
        console.log('拼团id与拼团头像------', this.data.groupPurchaseId, app.globalData.userAvatarUrl)
        params.groupPurchaseId = this.data.groupPurchaseId
        params.grouppurchaseCode = this.data.grouppurchaseCode || null
        params.orderActivityId = this.data.groupPurchaseId
        params.groupHeadImgUrl = app.globalData.userAvatarUrl
        params.nickName = app.globalData.nickName
      }
      params.orderType = this.data.actType
      if (this.data.actType == 6) { // 预付定金
        params.orderActivityId = this.data.yfk
      }
      if(this.data.actType == 17) { // 秒杀
        params.buyNowId = this.data.buyNowId
        params.orderType = 5
      }
      if(this.data.actType == 18) { // 分期发货
        params.orderActivityId  = this.data.divideId 
        params.orderType = 9
      }
      if(this.data.actType == 11) { // 购买优惠券
        params.orderActivityId = this.data.orderActivityId
        params.orderType = 11
      }
      console.log('actType--------------', this.data.actType)
      if(this.data.actType == 19) { // 套餐搭配
        params.orderActivityId = this.data.orderActivityId
        params.comboActivityId = this.data.orderActivityId
        params.orderType = 7
      }
      params.orderOrigin = this.data.orderOrigin // 1-从产品下单，0-加购
      params.source = 2 // 来源：小程序
      if (!this.data.isSvip) { // 
        params.virtualMoney = Math.round(this.data.virtualNum * 100) / 100
        params.productTotal = this.data.productTotal
      } else {
        params.referrerCustomerId = this.data.referrerCustomerId
      }
      if ((params.productIds instanceof Array) && params.productIds.length == 0) {
        params.productIds = productIds
      }
      let url = this.data.isSvip ? API.svipOrder : API.get_order
      console.log(this.data.isSvip) 
      if(this.data.isSvip == '1') {
        console.log('购买超级会员')
        params.orderType = 14
        params.roleType = wx.getStorageSync('isJinGu')
        params.isRenewal = this.data.isRenewal
      }
      if(this.data.staffId) {
        params.integralStatus = 1
        params.integralStaffId = this.data.staffId
      }
      //staffId (string, optional):推荐营养顾问工号
      params.staffId = staffShare.getShareStaffId()
      console.log('actType与orderType', this.data.actType, params.orderType)
      console.log('下单接口params-----------', params);
      console.log('orderType', params.orderType)
      if(params.orderType == '5' || params.orderType == 5) {
        url = API.order_seckill
      }
      console.log('下单接口', url)
      // return 

      REQUEST.post(url, {
        header: {
          'content-type': 'application/json'
        },
        data: params
      }).then((res) => {
        const {
          status,
          data,
          msg
        } = res.data
        LOADING.hide()
        this.setData({
          // disabled: false
        })
        if (status == 0) {
          SHOPCARTSERVER.removeProducts(productIds, this.data.pd)
          this.setData({
            id: data.id
          })
          let params = {
            orderCode: data.orderCode,
            orderType: data.orderType,
            id: data.id,
            orderStatus: {
              id: 1
            }
          }
          if (data.orderType == 6) {
            params.orderDownPayment = {
              frontMoneyStartTime: app.globalData.preData.frontMoneyStartTime,
              frontMoneyEndTime: app.globalData.preData.frontMoneyEndTime,
              balancePaymentStartTime: app.globalData.preData.balancePaymentStartTime,
              balancePaymentEndTime: app.globalData.preData.balancePaymentEndTime
            }
          } 
          PAY({
            params,
            paySuccessFn: _self.paySuccessFn.bind(this),
            payErrorFn: _self.payErrorFn.bind(this),
            isSvip: this.data.isSvip,
            isBuyCoupon: (this.data.actType == 11)?true:false,
            orderType: data.orderType,
            customOrderParams: this.data
          })
        } else if (status == 10061) {
          this.triggerEvent('closeSku', true)
        } else {
          TOAST.warning({
            title: res.data.msg,
            duration: 3000
          })
        }
      }).catch((e) => {
        console.error(e);
        wx.showToast({
          title: '网络异常或服务器端错误',
          icon: 'none'
        })
        LOADING.hide()
      })
    }
  },
  paySuccessFn() {}, // 支付成功
  payErrorFn() {}, // 支付失败
  goOrderDetail() { // 跳转到订单详情
    wx.navigateTo({
      url: '/pages/OrderDetail/OrderDetail?billId=' + this.data.id,
    })
  },
}
Component({
  properties: {
    info: {
      type: Array,
      value: ''
    },
    total: {
      type: Number,
      observer: function(newVal) {
        this.setData({
          total: newVal.toFixed(2)
        })
      }
    },
    address: {
      type: Object,
      value: {
        id: ''
      },
      observer: function(newVal, oldVal) {
        this.setData({
          address: newVal
        })
      }
    },
    buyNowId: {
      type: Number
    },
    divideId: {
      type: Number
    },
    orderActivityId: {
      type: Number
    },
    buyerMemo: {
      type: String
    },
    pd: {
      type: String
    },
    ticketListA: { // 满减
      type: Object,
      observer: function(newVal, oldVal) {
      }
    },
    ticketListB: { // 满赠
      type: Object
    },
    ticketListC: { // 积分
      type: Object
    },
    ticketListD: { // 加购
      type: Object
    },
    groupPurchaseId: {
      type: String
    },
    grouppurchaseCode: {
      type: String
    },
    virtualNum: {
      type: Number
    },
    productTotal: {
      type: Number
    },
    isAgree: {
      type: Boolean
    },
    actType: {
      type: String
    },
    yfk: {
      type: String
    },
    orderOrigin: {
      type: Number
    },
    defaultAddress: {
      type: Object
    },
    isSvip: {
      type: Number
    },
    referrerCustomerId: {
      type: String
    },
    userInfo: {
      type: Object
    },
    staffId: {
      type: String
    },
    orderAttribution: {
      type: String,
      default: ''
    },
    isRenewal: {
      type: Number,
      default: 0
    }
  },
  data,
  methods,
  ready() {}
})
