import {
  TOAST,
  SHOPCARTSERVER,
  FILTER,
  SRTRACK,
  UTIL
} from '../../utils/index'
const app = getApp()
let vipCusStatus = ''
const data = {
  orderInfo: { // 选中规格信息
    curSKUId: '', //
    curSKUName: '',
    curSKUStock: '',
    curSKUPrice: '',
    productTemplateId: 0,
    price: 0,
    originPrice: 0,
    thumb: '',
    divide: {
      times: 0,
      interval: 0
    }
  },
  curSKUId: '',
  quantity: 1,
  orderTips: {
    curSKUId: '请选择产品规格'
  },
  selected: false,
  canReduce: true,
  canAdd: true,
  cartNum: 0,
  divideProduct: null
}
const properties = {
  referrerCustomerId: {
    type: String,
    value: ''
  },
  info: {
    type: Object,
    value: {
      skuName: '请选择分类',
      price: '',
      vipCusStatus: 0 // 0-非会员,1-未过期，2-已过期
    },
    observer: '_propertyChange'
  },
  types: {
    type: Number
  },
  cur: {
    type: Object,
    value: {
      cur_skuid: '',
      cur_skuname: '',
      cur_stock: '',
      cur_price: '',
      cur_thumb: ''
    }
  },
  isStaffGroupB: Boolean,
  mainPosition: {  //多层嵌套，可能导致定位不准，首页改为固定定位，所以会传参
    type: String,
    value: 'absolute'
  }
}
const methods = {
  fnVerifyForm(fieldList = []) {  // 被submit()调用 未选择规格，弹窗提示用户选择
    let _self = this
    for (let item of fieldList) {
      let val = _self.data.orderInfo[item]
      let tips = _self.data.orderTips[item]
      if (val == '') {
        TOAST.success({
          title: tips
        })
        return false
      }
    }
    return true
  },
  closeSku() { // 关闭弹窗
    var myEventOption = {
      bubbles: false
    }
    this.triggerEvent('closeSku', false, myEventOption)
    app.globalData.selectedData = null
  },
  chooseSize(event) { // 选择规格
    let cur = event.currentTarget.dataset.item
    let vipCusStatus = this.data.info.vipCusStatus
    if (cur.stock <= 0) {  // 库存不足
      TOAST.success({
        title: '库存不足'
      })
      return false
    }
    if ((this.data.info.actType == 8 && this.data.info.operationType == 2) || (this.data.info.actType == 16 && this.data.info.operationType == 2)) { // 拼团直接购买 & 团购直接购买
      let limit = Math.min(cur.groupLimit, cur.stock)
      if(this.data.info.actType == 16) {
        limit = cur.stock
      }
      if (limit == 1) {
        this.setData({
          canAdd: false
        })
      } else {
        this.setData({
          canAdd: true
        })
      }
      console.log("++++++++++++++++++++++++++++++++++++++++++++++++")
      this.setData({
        "orderInfo.price": vipCusStatus == 1 ? FILTER.getPriceRange([cur.groupPrice], 0.95) : cur.groupPrice,
        "orderInfo.originPrice": cur.groupPrice,
        'orderInfo.noSvipPrice': cur.groupPrice,
        "orderInfo.groupPrice": cur.groupPrice,
        'orderInfo.purchaseLimitQuantity': limit,
        message: cur
      })
      if (this.data.types == 0) { // 从详情开团
        console.log("++++++++++++++++++++++++++++++++++++++++++++++++")
        this.setData({
          "orderInfo.primaryPrice": cur.groupprimaryPurchasePrice, // 团长价
          "orderInfo.price": vipCusStatus == 1 ? FILTER.getPriceRange([cur.groupPrice], 0.95) : cur.groupPrice,
          "orderInfo.originPrice": cur.groupPrice,
          message: cur
        })
        // 营养顾问开团
        // if(this.data.info.actType == 16 && this.data.isStaffGroupB) { // 营养顾问团购 & 是团长
        //   params.price = 0.01
        //   params.originPrice = 0.01
        //   params.quantity = 1
        //   // this.setData（
        // }
      }
    } else if(this.data.info.actType == 18 && this.data.info.operationType == 3) { // 分期发货购买
      let limit = Math.min(cur.product.purchaseLimitQuantity, cur.product.stock)
      console.log("++++++++++++++++++++++++++++++++++++++++++++++++")
      this.setData({
        "orderInfo.price": vipCusStatus == 1 ? FILTER.getPriceRange([cur.deliveryPrice], 0.95) : cur.deliveryPrice,
        "orderInfo.originPrice": cur.deliveryPrice,
        'orderInfo.noSvipPrice': cur.deliveryPrice,
        'orderInfo.purchaseLimitQuantity': limit,
        message: cur,
        canAdd: (this.data.quantity >= limit)?false:true,
      })
    } else { // 普通：直接购买/加入购物车
      console.log('直接购买 / 加入购物车')
      let limit = Math.min(cur.purchaseLimitQuantity, cur.stock)
      let cartNum = SHOPCARTSERVER.getCartOneNum(cur.id)
      let canAdd = true
      if (this.data.info.operationType == 0) { // 加入购物车
        if (this.data.quantity >= (limit - cartNum)) {
          canAdd = false
        }
        console.log("++++++++++++++++++++++++++++++++++++++++++++++++")
        this.setData({
          "orderInfo.price": vipCusStatus == 1 ? FILTER.getPriceRange([cur.price], 0.95) : cur.price,
          "orderInfo.originPrice": cur.originPrice?cur.originPrice:cur.price,
          'orderInfo.noSvipPrice': cur.price,
          'orderInfo.purchaseLimitQuantity': limit,
          message: cur,
          'canAdd': canAdd
        })
        if (this.data.info.actType == 9) { // 积分兑换
          console.log("++++++++++++++++++++++++++++++++++++++++++++++++")
          this.setData({
            "orderInfo.price": cur.isRedeem ? cur.redeemPrice : (vipCusStatus == 1 ? FILTER.getPriceRange([cur.price], 0.95) : cur.price),
            "orderInfo.originPrice": cur.isRedeem ? cur.redeemPrice : cur.price,
            "orderInfo.isRedeem": cur.isRedeem
          })
        }
      } else { // 立即购买
        if (limit == 1) {
          canAdd = false
        }
        this.setData({
          'orderInfo.purchaseLimitQuantity': limit,
          'orderInfo.noSvipPrice': cur.price,
          message: cur,
          canAdd: canAdd
        })
        let limit1 = Math.min(cur.purchaseLimitQuantity, cur.stock)
        if (this.data.info.actType == 6) { // 预售活动
          console.log("++++++++++++++++++++++++++++++++++++++++++++++++")
          this.setData({
            'orderInfo.prePrice': vipCusStatus == 1 ? FILTER.getPriceRange([cur.prePrice], 0.95) : cur.prePrice,
            'orderInfo.originPrice': cur.prePrice,
            'orderInfo.noSvipPrice': cur.prePrice,
            'orderInfo.purchaseLimitQuantity': limit1,
            'orderInfo.price': vipCusStatus == 1 ? FILTER.getPriceRange([cur.price], 0.95) : cur.price,
            'orderInfo.prePriceorigin': cur.price
          })
        } else if (this.data.info.actType == 9) { // 积分兑换
          console.log("++++++++++++++++++++++++++++++++++++++++++++++++")
          this.setData({
            'orderInfo.price': cur.redeemPrice,
            // 'orderInfo.originPrice': vipCusStatus == 1 ? FILTER.getPriceRange([cur.redeemPrice], 0.95) : cur.redeemPrice,
            "orderInfo.isRedeem": cur.isRedeem
          })
        } else {
          console.log("++++++++++++++++++++++++++++++++++++++++++++++++")
          this.setData({
            'orderInfo.price': vipCusStatus == 1 ? FILTER.getPriceRange([cur.price], 0.95) : cur.price,
            'orderInfo.originPrice' : cur.price,
            'orderInfo.noSvipPrice': cur.price,
          })
        }
      }
    }
    let imgUrl = cur.imgUrl ? cur.imgUrl : ((this.data.info.groupedImages.icon && this.data.info.groupedImages.icon[0].imageUrl) ? this.data.info.groupedImages.icon[0].imageUrl : this.data.info.groupedImages.banner[0].imageUrl)
    if(this.data.info.actType != 18) {  // 非分期发货
      this.setData({
        "orderInfo.curSKUId": cur.id,
        "orderInfo.stock": cur.stock,
        "orderInfo.curSKUName": `已选：${cur.skuName}`,
        "orderInfo.productTemplateId": cur.productTemplateId,
        "selected": true,
        "canReduce": false,
        "orderInfo.thumb": imgUrl,
        "orderInfo.imgUrl": imgUrl,
        "orderInfo.iconImgUrl": imgUrl,
        'quantity': 1,
      })
    } else { // 分期发货
      this.setData({
        "orderInfo.curSKUId": cur.product.id,
        "orderInfo.stock": cur.product.stock,
        "orderInfo.curSKUName": `已选：${cur.product.skuName}`,
        "orderInfo.productTemplateId": cur.product.productTemplateId,
        "selected": true,
        "canReduce": false,
        "orderInfo.thumb": imgUrl,
        "orderInfo.imgUrl": imgUrl,
        "orderInfo.iconImgUrl": imgUrl,
        'quantity': 1,
        'orderInfo.divideTimes': cur.deliveryTimes,
        'orderInfo.divideInterval': cur.deliveryInterval,
      })
      wx.setStorageSync("divideTimes", cur.deliveryTimes)
      wx.setStorageSync("divideInterval", cur.deliveryInterval)
    }
    app.globalData.selectedData = this.data
  },
  reduce() { // 数量-1
    if (this.data.selected) { // 已选择产品规格
      let quantity = this.data.quantity
      if (quantity > 1) {
          this.setData({
            quantity: quantity - 1,
            canAdd: true
          })
      } else {
        if (this.data.info.operationType == 0) { // 加入购物车
          let cartNum = SHOPCARTSERVER.getCartOneNum(this.data.orderInfo.curSKUId)
          if (this.data.quantity >= this.data.orderInfo.purchaseLimitQuantity - cartNum) {
            this.setData({
              canReduce: false,
              canAdd: false
            })
          } else {
            this.setData({
              canAdd: true,
              canReduce: false
            })
          }
        } 
      }
    } else { // 未选择产品规格
      TOAST.success({
        title: '请选择产品规格',
        duration: 1000
      })
    }
  },
  add(e) { // 数量+1
    let _self = this
    if (_self.data.selected) {
      if (_self.data.quantity >= this.data.info.stock) { // 大于库存，不可添加
        _self.setData({
          canAdd: false,
          canReduce: true
        })
      } else {
        if (this.data.info.operationType == 0) { // 加入购物车
          let cartNum = SHOPCARTSERVER.getCartOneNum(_self.data.orderInfo.curSKUId)
          if (_self.data.quantity >= _self.data.orderInfo.purchaseLimitQuantity - cartNum) {
            _self.setData({
              canReduce: true
            })
          } else {
            _self.setData({
              quantity: _self.data.quantity + 1,
              canReduce: true
            })
          }
          if (_self.data.quantity >= _self.data.orderInfo.purchaseLimitQuantity - cartNum) {
            _self.setData({
              canAdd: false
            })
          }
        } else { // 直接购买，剔除购物车
          if (_self.data.quantity >= _self.data.orderInfo.purchaseLimitQuantity) {
            _self.setData({
              quantity: _self.data.orderInfo.purchaseLimitQuantity,
              canReduce: true
            })
          } else {
            _self.setData({
              quantity: _self.data.quantity + 1,
              canReduce: true
            })
          }
          if (_self.data.quantity >= _self.data.orderInfo.purchaseLimitQuantity) {
            _self.setData({
              canAdd: false
            })
          }
        }
      }
    } else {
      TOAST.success({
        title: '请选择产品规格',
        duration: 1000
      })
    }
  },
  submit() { // 确认添加至购物车
    const fieldList = ['curSKUId']
    let orderInfo = this.data.orderInfo
    let info = this.data.info
    var params = {
      skuName: orderInfo.curSKUName,
      // skuId: orderInfo.curSKUId,
      id: orderInfo.curSKUId,
      productId: orderInfo.curSKUId,
      // pId: orderInfo.productTemplateId,
      productTemplateId: orderInfo.productTemplateId,
      // pName: info.productTemplateName,
      name: info.productTemplateName,
      quantity: this.data.quantity,
      price: info.actType != 6 ? (info.actType == 9 ? 0 : orderInfo.price) : orderInfo.prePrice,
      originPrice: info.originPrice?info.originPrice:orderInfo.originPrice,
      redeemPrice: info.actType == 9 ? orderInfo.price : 0,
      noSvipPrice: orderInfo.noSvipPrice,
      isChecked: true,
      icon: orderInfo.imgUrl ? orderInfo.imgUrl : orderInfo.iconImgUrl,
      stock: orderInfo.stock,
      limitQuantity: orderInfo.purchaseLimitQuantity,
      warehouseCode: orderInfo.warehouseCode,
      isRedeem: info.actType == 9 ? orderInfo.isRedeem : 0,
      integralStatus: info.integralStatus,
      cartProTag: info.cartProTag, // 商品的活动标签
      endTime: info.endTime,
      productCategory: info.productCategory,
    }
    // console.dir(orderInfo)
    // console.dir(info)
    if (info.actType == 6) { // 预付定金
      app.globalData.preData = {
        lastPrice: (orderInfo.price - orderInfo.originPrice) * this.data.quantity,
        prePrice: orderInfo.originPrice * this.data.quantity,
        frontMoneyStartTime: info.presell.frontMoneyStartTime,
        frontMoneyEndTime: info.presell.frontMoneyEndTime,
        balancePaymentStartTime: info.presell.balancePaymentStartTime,
        balancePaymentEndTime: info.presell.balancePaymentEndTime
      }
      params.presellProductMoney = orderInfo.prePriceorigin
    } else if(info.actType === 17) { // 秒杀
      params.buyNowId = info.buyNowId
      params.isGwtStatus = info.isGwtStatus
    } else if(info.actType === 18) { // 分期发货
      params.divideId = info.divideId

    } else if(info.actType === 11) { // 购买优惠券
      params.buyCouponId = info.buyCouponId
    }
    if (info.operationType == 0) { // 加入购物车
      if (this.fnVerifyForm(fieldList)) {
        SHOPCARTSERVER.addCart(params)
        UTIL.setCartNum()
        app.globalData.myCardNum = SHOPCARTSERVER.getCartNum()
        SRTRACK.setAddCartData(this.data)
        this.closeSku()
      } 
    } else { // 购买
      if (this.fnVerifyForm(fieldList)) {
        if (info.operationType == 2 && (info.actType == 8 || info.actType == 16)) { // 拼团购买
          console.log(`拼团购买${this.data.types == 0?'团长价':'团员价'}，${orderInfo.primaryPrice}${orderInfo.price}`)
          if (this.data.types == 0) { // 团长价
            params.price = orderInfo.primaryPrice
            params.originPrice = orderInfo.primaryPrice
            params.noSvipPrice = orderInfo.primaryPrice
            if(info.actType == 16 && this.data.isStaffGroupB) { // 营养顾问团购 & 是团长
              params.price = 0.01
              params.originPrice = 0.01
              params.quantity = 1
            }
            console.log('拼团/团购 团长价')
          } else { // 团员价
            params.price = orderInfo.price
          }
        }
        console.log(info.productCategory )

        if(info.productCategory == 9) {
          params.type = 29
        }
        console.log(params)
        SHOPCARTSERVER.setBuyNow(params)
        let moreQuery = '&'
        if(wx.getStorageSync('orderAttribution')) {
          let orderAttribution = JSON.parse(wx.getStorageSync('orderAttribution'))
          if(this.data.info.hasOwnProperty('id') && orderAttribution.hasOwnProperty(this.data.info.id.toString())) {
            let obj = orderAttribution[this.data.info.id.toString()]
            let expiresTime = Number(obj.expiresTime) // 过期时间
            let now = (new Date().getTime())/1000
            if(now > expiresTime) { // 已经过期了
              delete orderAttribution[this.data.info.id.toString()]
              this.setData({
                orderAttribution: JSON.stringify(orderAttribution)
              })
            } else {
              moreQuery += `orderAttribution=${obj.referer}&`
            }
          }
        }
        moreQuery += `isSendIntergral=${info.isSendIntergral}&`
        if(info.actType == 11) { // 优惠券类型
          moreQuery += `couponType=${info.couponType}&`
        }
        if(this.data.referrerCustomerId) {
          moreQuery += `referrerCustomerId=${this.data.referrerCustomerId}&`
        }
        if (info.actType == 8 || info.actType == 16) { // 拼团购买 & 团购购买
          if (info.groupObj.code && info.groupObj.code != 'undefined') {
            wx.navigateTo({
              url: `/pages/PayOrder/PayOrder?productId=${params.id}&groupPurchaseId=${info.groupObj.id}&grouppurchaseCode=${info.groupObj.code}&type=${info.operationType == '1' ? 0 : info.actType}${moreQuery}`
            })
          } else {
            wx.navigateTo({
              url: `/pages/PayOrder/PayOrder?productId=${params.id}&groupPurchaseId=${info.groupObj.id}&type=${info.operationType == '1' ? 0 : info.actType}&isStaff=${this.data.isStaffGroupB}${moreQuery}`,
            })
          }
        } else if (info.actType == 6) { // 预付定金
          wx.navigateTo({
            url: `/pages/PayOrder/PayOrder?productId=${params.id}&type=6&yfk=${info.presell.id}${moreQuery}`
          })
        } else if (info.actType == 0 || info.actType == 9 || info.actType == 17 || info.actType == 18 || info.actType == 11) { // 普通商品 兑换积分 秒杀 分期发货 购买优惠券
          wx.navigateTo({
            url: `/pages/PayOrder/PayOrder?productId=${params.id}&type=${info.actType}${moreQuery}`
          })
        } 
        this.closeSku()
      }
    }
  },
  _propertyChange(newVal, oldVal) {
    if (!app.globalData.selectedData) { // 首次进来
      if (newVal && newVal.products) {
        vipCusStatus = newVal.vipCusStatus
        let products1 = []
        let priceArr = [] 
        for (let i = 0; i < newVal.products.length; i++) {
          if (newVal.products[i].enable == 0) {
            products1.push(newVal.products[i])
            priceArr.push(newVal.products[i].price)
          }
        }
        this.data.selected = false
        let products = newVal.products
        let imgUrl = (newVal.groupedImages.icon && newVal.groupedImages.icon[0].imageUrl)? newVal.groupedImages.icon[0].imageUrl : newVal.groupedImages.banner[0].imageUrl
        let imgUrl0 = products[0].imgUrl ? products[0].imgUrl : imgUrl // 只有一款产品可选
        this.setData({
          quantity: 1,
          'info.products': products1,
          'orderInfo.thumb': imgUrl,
          'orderInfo.warehouseCode': newVal.warehouseCode
        })
        if (newVal.actType != 2) { // 普通商品/预售
          if (products.length == 1) { // 只有一款可选
            let limit = Math.min(products[0].purchaseLimitQuantity, products[0].stock) // 库存和限购取最小值
            // if(newVal.actType == 16) { // 团购产品
            //   limit = products[0].stock
            // }
            let cartNum = SHOPCARTSERVER.getCartOneNum(products[0].id)
            let canAdd = true
            if (cartNum >= limit - 1) {
              canAdd = false
            }
            this.data.selected = true
            console.log("++++++++++++++++++++++++++++++++++++++++++++++++")
            this.setData({
              'orderInfo.price': vipCusStatus == 1 ? FILTER.getPriceRange([products[0].price], 0.95) : products[0].price,
              'orderInfo.originPrice': products[0].originPrice?products[0].originPrice:products[0].price,
              'orderInfo.noSvipPrice': products[0].price, 
              'orderInfo.stock': products[0].stock,
              'orderInfo.curSKUName': `已选：${products[0].skuName}`,
              'orderInfo.curSKUId': products[0].id,
              'orderInfo.productTemplateId': products[0].productTemplateId,
              'orderInfo.purchaseLimitQuantity': limit,
              canAdd: canAdd,
              canReduce: false,
              'orderInfo.thumb': imgUrl0,
              "orderInfo.imgUrl": imgUrl0,
              "orderInfo.iconImgUrl": imgUrl0
            })
            if(newVal.productCategory==9){
              this.setData({
                'orderInfo.price': newVal.price,
              })
            }
            if (newVal.actType == 6) { // 预售
              console.log("++++++++++++++++++++++++++++++++++++++++++++++++")
              this.setData({
                'orderInfo.prePrice': vipCusStatus == 1 ? FILTER.getPriceRange([products[0].prePrice], 0.95) : products[0].prePrice,
                'orderInfo.price': vipCusStatus == 1 ? FILTER.getPriceRange([newVal.presellProductMoney], 0.95) : newVal.presellProductMoney,
                'orderInfo.originPrice': products[0].prePrice,
                'orderInfo.prePriceorigin': products[0].price,
                'orderInfo.noSvipPrice': products[0].prePrice
              })
              console.log(this.data.orderInfo.noSvipPrice )
            } else if (newVal.actType == 9) { // 积分兑换
              console.log("++++++++++++++++++++++++++++++++++++++++++++++++")
              this.setData({
                'orderInfo.price': products[0].isRedeem ? products[0].redeemPrice : products[0].price,
                'orderInfo.isRedeem': products[0].isRedeem
              })
            }
          } else {
            console.log("++++++++++++++++++++++++++++++++++++++++++++++++")
            this.setData({
              'orderInfo.price': vipCusStatus == 1 ? newVal.superPrice : newVal.price,
              'orderInfo.stock': newVal.stock,
              'orderInfo.curSKUName': '请选择分类',
              'orderInfo.curSKUId': '',
              'orderInfo.productTemplateId': '',
              'orderInfo.purchaseLimitQuantity': ''
            })
            if (newVal.actType == 6) { // 预售
              console.log("++++++++++++++++++++++++++++++++++++++++++++++++")
              this.setData({
                'orderInfo.prePrice': vipCusStatus == 1 ? newVal.superPrePrice : newVal.presellMoney,
                'orderInfo.price': vipCusStatus == 1 ? FILTER.getPriceRange(priceArr, 0.95) : newVal.presellProductMoney,
                'orderInfo.originPrePrice': newVal.presellMoney,
                'orderInfo.originPrice': newVal.presellProductMoney
              })
            } else if (newVal.actType == 9) { // 积分兑换
              console.log("++++++++++++++++++++++++++++++++++++++++++++++++")
              this.setData({
                'orderInfo.price': newVal.redeemPrices,
                'orderInfo.isRedeem': 1
              })
            }
          }
        } 
        if (newVal.actType == 8 || newVal.actType == 16) {  // 拼团 & 团购
          if (newVal.operationType == 1) { // 单独买
            if (products.length == 1) { // 只有一款可选
              let limit = Math.min(products[0].purchaseLimitQuantity, products[0].stock, 100)
              if(newVal.actType == 16) { // 团购产品
                limit = products[0].stock
              }
              this.data.selected = true
              console.log("++++++++++++++++++++++++++++++++++++++++++++++++")
              this.setData({
                'orderInfo.price': vipCusStatus == 1 ? FILTER.getPriceRange([products[0].price], 0.95) : products[0].price,
                'orderInfo.originPrice': products[0].price,
                'orderInfo.noSvipPrice': products[0].price,
                'orderInfo.stock': products[0].stock,
                'orderInfo.curSKUName': `已选：${products[0].skuName}`,
                'orderInfo.curSKUId': products[0].id,
                'orderInfo.productTemplateId': products[0].productTemplateId,
                'orderInfo.purchaseLimitQuantity': limit,
                canAdd: true,
                'orderInfo.thumb': imgUrl0,
                "orderInfo.imgUrl": imgUrl0,
                "orderInfo.iconImgUrl": imgUrl0
              })
              if (limit == 1) {
                this.setData({
                  canAdd: false
                })
              }
            } else {
              console.log("++++++++++++++++++++++++++++++++++++++++++++++++")
              this.setData({
                'orderInfo.price': vipCusStatus == 1 ? newVal.superOwnPrice : newVal.price,
                'orderInfo.originPrice': newVal.groupPrice,
                'orderInfo.noSvipPrice': newVal.groupPrice,
                'orderInfo.stock': newVal.stock,
                'orderInfo.curSKUName': '请选择分类',
                'orderInfo.curSKUId': '',
                'orderInfo.productTemplateId': '',
                'orderInfo.purchaseLimitQuantity': ''
              })
            }
          } else { // 拼团买
            if (products.length == 1) { // 只有一款可选
              let limit = Math.min(products[0].groupLimit, products[0].stock)
              if(newVal.actType == 16) {
                limit = products[0].stock
              }
              this.data.selected = true
              console.log("++++++++++++++++++++++++++++++++++++++++++++++++")
              this.setData({
                'orderInfo.price': vipCusStatus == 1 ? FILTER.getPriceRange([products[0].groupPrice], 0.95) : products[0].groupPrice,
                'orderInfo.originPrice': products[0].groupPrice,
                'orderInfo.noSvipPrice': products[0].groupPrice,
                'orderInfo.stock': products[0].stock,
                'orderInfo.curSKUName': '已选：' + products[0].skuName,
                'orderInfo.curSKUId': products[0].id,
                'orderInfo.productTemplateId': products[0].productTemplateId,
                'orderInfo.purchaseLimitQuantity': limit,
                'orderInfo.primaryPrice': products[0].groupprimaryPurchasePrice,
                'orderInfo.groupPrice': products[0].groupPrice,
                canAdd: true,
                'orderInfo.thumb': imgUrl0,
                "orderInfo.imgUrl": imgUrl0,
                "orderInfo.iconImgUrl": imgUrl0
              })
              if (limit == 1) {
                this.setData({
                  canAdd: false
                })
              }
            } else {
              console.log("++++++++++++++++++++++++++++++++++++++++++++++++")
              this.setData({
                'orderInfo.price': vipCusStatus == 1 ? newVal.superPrice : newVal.groupPrice,
                'orderInfo.originPrice': newVal.groupPrice,
                'orderInfo.stock': newVal.stock,
                'orderInfo.curSKUName': '请选择分类',
                'orderInfo.curSKUId': '',
                'orderInfo.productTemplateId': ''
              })
            }
          }
        }
        if (newVal.actType == 18) {  // 分期发货
          let products = newVal.divideSku.divideDeliverySkus
          if (products.length == 1) { // 只有一款可选
            let limit = Math.min(products[0].product.purchaseLimitQuantity, products[0].product.stock)
            let canAdd = true
            this.data.selected = true
            console.log("++++++++++++++++++++++++++++++++++++++++++++++++")
            this.setData({
              'orderInfo.price': vipCusStatus == 1 ? FILTER.getPriceRange([products[0].deliveryPrice], 0.95) : products[0].deliveryPrice,
              'orderInfo.originPrice': products[0].deliveryPrice,
              'orderInfo.noSvipPrice': products[0].deliveryPrice,
              'orderInfo.stock': products[0].product.stock,
              'orderInfo.curSKUName': '已选：' + products[0].product.skuName,
              'orderInfo.curSKUId': products[0].product.id,
              'orderInfo.productTemplateId': products[0].product.productTemplateId,
              'orderInfo.purchaseLimitQuantity': limit,
              'orderInfo.dividePrice': products[0].deliveryPrice,
              canAdd: canAdd,
              'orderInfo.divideTimes': products[0].deliveryTimes,
              'orderInfo.divideInterval': products[0].deliveryInterval,
              'orderInfo.thumb': imgUrl0,
              "orderInfo.imgUrl": imgUrl0,
              "orderInfo.iconImgUrl": imgUrl0
            })
            if (limit == 1 || this.data.quantity >= limit) {
              canAdd = false
            }
            wx.setStorageSync("divideTimes", products[0].deliveryTimes)
            wx.setStorageSync("divideInterval", products[0].deliveryInterval)
          } else {
            let times = { min: 999, max: -1}
            let interval = { min: 999, max: -1}
            for(let i=0,len=products.length;i<len;i++) {
              times.min = (products[i].deliveryTimes < times.min)?products[i].deliveryTimes:times.min
              times.max = (products[i].deliveryTimes > times.max)?products[i].deliveryTimes:times.max
              interval.min = (products[i].deliveryInterval < interval.min)?products[i].deliveryInterval:interval.min
              interval.max = (products[i].deliveryInterval > interval.max)?products[i].deliveryInterval:interval.max        
            }
            
      console.log("++++++++++++++++++++++++++++++++++++++++++++++++")
            this.setData({
              'orderInfo.price': vipCusStatus == 1 ? newVal.superDividePrice : newVal.dividePrice,
              'orderInfo.originPrice': newVal.dividePrice,
              'orderInfo.stock': newVal.stock,
              'orderInfo.curSKUName': '请选择分类',
              'orderInfo.curSKUId': '',
              'orderInfo.productTemplateId': '',
              "orderInfo.divideTimes": (times.min == times.max)?`${times.min}`:`${times.min}~${times.max}`,
              "orderInfo.divideInterval": (interval.min == interval.max)?`${interval.min}`:`${interval.min}~${interval.max}`
            })
            // console.log(this.data.orderInfo)
          }
        }
      }
    } else { // 预览之后
      let data1 = app.globalData.selectedData
      this.data.selected = data1.selected
      this.setData({
        orderInfo: data1.orderInfo,
        curSKUId: data1.curSKUId,
        quantity: data1.quantity,
        orderTips: {
          curSKUId: '请选择产品规格'
        },
        canReduce: data1.canReduce,
        canAdd: data1.canAdd,
        cartNum: data1.cartNum
      })
      wx.setStorageSync('preFlag', false)
    }
  },
  previewImg(e) { // 预览图片
    UTIL.previewImg(e.currentTarget.dataset.url, [e.currentTarget.dataset.url])
  }
}
Component({
  data,
  properties,
  methods,
  behaviors: [],
  pageLifetimes: {
    show() {
    }
  },
  observers: {
    "info"(nv) {
      if(nv && nv.hasOwnProperty('products')) {
        nv.products.sort(function(a, b) {
          if(!a.hasOwnProperty('displayPriority')) {
            a['displayPriority'] = -1
          }
          if(!b.hasOwnProperty('displayPriority')) {
            b['displayPriority'] = -1
          }
          return b.displayPriority - a.displayPriority
        })
        console.log(nv)
      }
    }
  }
})