import {
  REQUEST,
  API,
  LOADING,
  FILTER,
  UTIL
} from '../../utils/index'
import {
  WGFORMAT
} from '../../wgUtils/index'
const data = {
  curPage: 1,
  pageSize: 20,
  starHot: 'https://img.wgmf.com/ic_xingxing@2x.png', // 评价星级
  starDefault: 'https://img.wgmf.com/ic_huixingxing@2x.png',
  commentModule: [],
  moreTxt: '查看更多...'
}
const methods = {
  getCommentList() {
    if (this.data.moreTxt == '没有更多了') return false
    let commentModule = this.data.commentModule
    let curPage = this.data.curPage
    REQUEST.get(API.get_commentList, {
      data: {
        productTemplateId: this.data.pId,
        pageSize: this.data.pageSize,
        curPage: this.data.curPage
      }
    }).then((res) => {
      const {
        status,
        data
      } = res.data
      if (status === 0) {
        if (data.length != 0) {
          for (let i = 0; i < data.length; i++) {
            data[i].createDate = WGFORMAT.formatDate(data[i].createDate, 'yyyy-MM-dd')
            // data[i].createDate = FILTER.dateFormat(data[i].createDate, 'yyyy-MM-dd')
            commentModule.push(data[i])
          }
          this.data.curPage = curPage + 1
          this.setData({
            commentModule: commentModule
          })
        }
      } else {
        this.setData({
          moreTxt: '没有更多了'
        })
      }
    }).catch((e) => {})
  },
  closeComment() {
    this.triggerEvent('closeComment', false)
  },
  previewImg(e) { // 图片预览
    let imgs = [e.currentTarget.dataset.url]
    let img = e.currentTarget.dataset.url
    UTIL.previewImg(img, imgs)
  }
}
Component({
  properties: {
    pId: {
      type: Number,
      value: 0
    }
  },
  data,
  methods,
  ready() {
    this.getCommentList()
    this.data.animation = 'slideUp 0.3s linear'
  }
})