import api from '../../api/index'

Component({
  properties: {
    start: Number,  // 开始时间
    end: Number // 结束时间
  },
  data: {
    status: 0, // 0未开始 1进行中 2已结束
    time: { h: '00', m: '00', s: '00' },
    ticker: null,
  },
  methods: {
    startTick() {
      api.getTime().then(now => {
        if(!now) now = new Date().getTime()
        let status = 0
        if(now > this.data.end) status = 2
        if(now < this.data.start) status = 0
        if(now <= this.data.end && now >= this.data.start) status = 1
        this.setData({status: status})
        if(status == 2) return
        if(status == 0) this.tickHandle(now, this.data.start)
        if(status == 1) this.tickHandle(now, this.data.end)
      })
    },
    tickHandle(mintime, maxtime) {
      const that = this
      let yu = (maxtime - mintime) / 1000
      let h = 0, m = 0, s = 0
      let tickFn = setInterval(function() {
        h = parseInt(yu/3600)
        m = parseInt((yu - h*3600)/60)
        s = parseInt(yu - h*3600 - m*60)
        that.setData({
          time: {
            h: h<10?'0'+h:h,
            m:m<10?'0'+m:m,
            s:s<10?'0'+s:s
          }
        })
        yu--
        if(yu <= 0) {
          clearInterval(tickFn)
          clearInterval(that.data.ticker)
        }
      }, 1000)
      if(that.data.ticker) {
        clearInterval(that.data.ticker)
      }
      that.setData({
        ticker: tickFn
      })
    },
  },
  ready() {
    // console.log('ready')
    this.startTick()
  },
  // pageLifetimes: {
  //   show: function() {
  //     // 页面被展示
  //     this.startTick()
  //   },
  //   hide: function() {
  //     // 页面被隐藏
  //     clearInterval(this.data.ticker)
  //   }
  // }
})