import {
  LOADING,
  UTIL
} from '../../utils/index.js'
import {
  WGAUTH
} from '../../wgUtils/index'

const data = {
  isLogin: (UTIL.getInfo('cusId').length != 0) && (UTIL.getInfo('openId').length != 0),
  cusId: wx.getStorageSync('cusId'),
  level: '',
  isNoOrderConsult: true,
  ysf: {
    title: '详情页',
    config: JSON.stringify({
      "level": '', // vip等级
      "foreignid": wx.getStorageSync('cusId'),
      "data": JSON.stringify([{
        "index": 7,
        "type": "crm_param",
        "key": "partnerId",
        "value": 'cs' + wx.getStorageSync('cusId')
      }])
    })
  }
}
Component({
  data,
  methods: {
    getLevel() {
      let cusId = wx.getStorageSync('cusId')
      if (cusId) {
        let that = this
        wx.request({
          url: 'https://app.wgmf.com/app/information/getCrmCusInfo?cusId=' + cusId,
          success(res) {
            if (res.data.msgCode == 0) {
              if (res.data.resultInfo.level == 1) {
                that.data.level = res.data.resultInfo.level
                that.setData({
                  ysf: {
                    title: '详情页',
                    config: JSON.stringify({
                      "level": 1, // vip等级
                      "foreignid": cusId,
                      "data": JSON.stringify([{
                        "index": 7,
                        "type": "crm_param",
                        "key": "partnerId",
                        "value": 'cs' + cusId
                      }])
                    })
                  }
                })
              }
            }
            console.log(that.data.ysf.config)
          }
        })
      }
    },
    getValid(){
      let cusId = wx.getStorageSync('cusId')
      if (cusId) {
        let that = this
        wx.request({
          url: 'https://newapi.wgmf.com/crm/mini/customer/event/record/no/order/consult/valid',
          header: {
            'token': 'wgmf',
          },
          method: 'POST',
          data: {
            cusId: cusId,
          },
          success(res) {
            if(res.data.code == 0){
              that.setData({
                isNoOrderConsult:res.data.payload.isNoOrderConsult,
                ysf: {
                  title: '详情页',
                  config: JSON.stringify({
                    "level": that.data.level == 1 ? 1 : '', // vip等级
                    "foreignid": wx.getStorageSync('cusId'),
                    "data": JSON.stringify([{
                      "index": 7,
                      "type": "crm_param",
                      "key": "partnerId",
                      "value": 'cs' + wx.getStorageSync('cusId')
                    },{
                      "index": 6,
                      "type": "crm_isNoOrderConsult",
                      "key": "isNoOrderConsult",
                      "value": (res.data.payload.isNoOrderConsult==true)?'在48小时内咨询过且未下单':'在48小时内咨询后已经下单'
                    }])
                  })
                }
              })
              console.log(that.data.ysf.config)
            }
          }
        })
      }
    },
    handleContact(e) {
      let config = this.computedConfig()
      // let config2 = this.getValid()
      if (config) {
        this.setData({
          ysf: config.ysf
        })
      }
      // if (config2) {
      //   this.setData({
      //     ysf: config2.ysf
      //   })
      // }
      var path = e.detail.path,
     
        query = e.detail.query,
        params = '';
        
      if (path) {
        for (var key in query) {
          params = key + '=' + query[key] + '&';
        }
        params = params.slice(0, params.length - 1);
        if(path.indexOf('Home/Home') != -1 || path.indexOf('ProductIndex/ProductIndex') != -1 || path.indexOf('FanCommunity/pages/Index/Index') != -1 || path.indexOf('MyCart/MyCart') != -1 || path.indexOf('PersonalCenter/PersonalCenter') != -1) {
          wx.switchTab({
            url: path + '?' + params
          })
        } else {
          wx.navigateTo({
            url: path + '?' + params
          })
        }
      }
      console.log('ysf.config后', this.data.ysf.config)
    },
    handleContactNew(){
      console.log("++++++++++++");
      //
      function compareVersion(v1, v2) {
        v1 = v1.split('.')
        v2 = v2.split('.')
        const len = Math.max(v1.length, v2.length)
        while (v1.length < len) {
          v1.push('0')
        }
        while (v2.length < len) {
          v2.push('0')
        }
        for (let i = 0; i < len; i++) {
          const num1 = parseInt(v1[i])
          const num2 = parseInt(v2[i])
          if (num1 > num2) {
            return 1
          } else if (num1 < num2) {
            return -1
          }
        }
        return 0
      };
      const version = wx.getSystemInfoSync();
      console.log(version.SDKVersion);
      console.log(compareVersion(version.SDKVersion,'2.19.0'));
      if (compareVersion(version.SDKVersion,'2.19.0')>= 0) {
        wx.openCustomerServiceChat({
          extInfo: {url: 'https://work.weixin.qq.com/kfid/kfcec1cf9074f3c28f3'},
          corpId: 'wx281daee1c2526c2c',
          success(res) {
            console.log("---------------------");
            console.log(res);
          }
        })
      } else {
        // 如果希望用户在最新版本的客户端上体验您的小程序，可以这样子提示
        wx.showModal({
          title: '提示',
          content: '当前微信版本过低，无法使用该功能，请升级到最新微信版本后重试。'
        })
      }
      wx.openCustomerServiceChat({
        extInfo: {url: 'https://work.weixin.qq.com/kfid/kfcec1cf9074f3c28f3'},
        corpId: 'wx281daee1c2526c2c',
        success(res) {
          console.log("---------------------");
          console.log(res);
        }
      })
    },
    getPhoneNumber(e) {
      if (e.detail.errMsg === 'getPhoneNumber:ok') {
        LOADING.show({
          title: '登录中...'
        })
        WGAUTH.getPhoneNumber(e).then(res => {
          LOADING.hide()
          this.getValid()
          // this.handleContact()
          this.setData({
            isLogin: true,
            cusId: wx.getStorageSync('cusId'),
          })
        })
      }
    },
    computedConfig() {
      if (this.data.cusId) return false;
      this.setData({
        cusId: wx.getStorageSync('cusId')
      })
      return {
        ysf: {
          title: '详情页',
          config: JSON.stringify({
            "level": this.data.level == 1 ? 1 : '', // vip等级
            "foreignid": wx.getStorageSync('cusId'),
            "data": JSON.stringify([{
              "index": 7,
              "type": "crm_param",
              "key": "partnerId",
              "value": 'cs' + wx.getStorageSync('cusId')
            },{
              "index": 6,
              "type": "crm_isNoOrderConsult",
              "key": "isNoOrderConsult",
              "value": (this.data.isNoOrderConsult==true)?'在48小时内咨询过且未下单':'在48小时内咨询后已经下单'
            }])
          })
        }
      }
    }
  },
  ready() {},
  pageLifetimes: {
    show() {
      if (this.data.isLogin == false && wx.getStorageSync('cusId')) {
        this.setData({
          cusId: wx.getStorageSync('cusId'),
          isLogin: true,
          ysf: {
            title: '详情页',
            config: JSON.stringify({
              "level": '', // vip等级
              "foreignid": wx.getStorageSync('cusId'),
              "data": JSON.stringify([{
                "index": 7,
                "type": "crm_param",
                "key": "partnerId",
                "value": 'cs' + wx.getStorageSync('cusId')
              }])
            })
          }
        })
        this.getLevel()
        this.getValid()
      }
      if (wx.getStorageSync('cusId')) {
        this.setData({
          isLogin: true,
          cusId: wx.getStorageSync('cusId')
        })
        this.getLevel()
        this.getValid()
      } else {
        this.setData({
          isLogin: false
        })
      }
    }
  }
})