Component({
  properties: {
    coupon: {
      type: Object,
      observer: '_propertyChange'
    },
    couponType: {
      type: String
    },
    activeCoupon: {
      type: String,
      observer: '_activeChange'
    }
  },
  data: {
    no: false
  },
  methods: {
    closeCo() {
      this.triggerEvent('closeCo', false)
    },
    _propertyChange(newVal, oldVal) {
      let _self = this
      let len = newVal.detail.length
      for (let i = 0; i < len; i++) {
        if (newVal.activeCoupon == 0) { // 初始化
          newVal.detail[i].isChecked = false
          newVal.detail[0].isChecked = true
        } else if (newVal.activeCoupon == -1) { // 不使用优惠券
          newVal.detail[i].isChecked = false
          _self.setData({
            no: false
          })
        } else {
          if (newVal.activeCoupon != null) {
            if (newVal.detail[i].activityInfo.couponsId == newVal.activeCoupon) {
              newVal.detail[i].isChecked = true
            } else {
              newVal.detail[i].isChecked = false
            }
          } else if (newVal.activeId != null) {
            if (newVal.detail[i].activityInfo.activityId == newVal.activeId) {
              newVal.detail[i].isChecked = true
            } else {
              newVal.detail[i].isChecked = false
            }
          }
        }
      }
      _self.setData({
        coupon: newVal
      })
    },
    select(e) {
      let newVal = this.data.coupon
      for (let i = 0; i < newVal.detail.length; i++) {
        newVal.detail[i].isChecked = false
      }
      newVal.detail[e.currentTarget.dataset.index].isChecked = true
      this.setData({
        coupon: newVal,
        no: false
      })
      let params = {
        couponType: this.data.couponType,
        item: e.currentTarget.dataset.item
      }
      this.triggerEvent('closeCoupon', params)
    },
    selectNo() {
      let newVal = this.data.coupon
      for (let i = 0; i < newVal.detail.length; i++) {
        newVal.detail[i].isChecked = false
      }
      this.setData({
        coupon: newVal,
        no: true
      })
      let params = {
        couponType: this.data.couponType,
        item: -1
      }
      this.triggerEvent('closeCoupon', params)
    },
    _activeChange() {}
  },
  ready() {
  }
})