import { FILTER } from '../../utils/index.js'
import api from '../../api/index'

const data = {
  discountPrice: '',
  originalPrice: '',
  day: 0,
  hour: 0,
  minute: 0,
  second: 0
}
const methods = {
  intervalTicker(endTime) {
    api.getTime().then(res => {
      let yu = endTime - res,
        d = 0,
        h = 0,
        m = 0,
        s = 0,
        self = this;

      const ticker = setInterval(function () {
        yu = yu - 1000
        if (yu <= 0) {
          clearInterval(ticker)
          self.refreshPage()
        } else {
          d = parseInt(yu / 86400000)
          h = parseInt((yu - d * 86400000) / 3600000)
          m = parseInt((yu - d * 86400000 - h * 3600000) / 60000)
          s = parseInt((yu - d * 86400000 - h * 3600000 - m * 60000) / 1000)
          self.setData({
            day: d,
            hour: h,
            minute: m,
            second: s
          })
        }
      }, 1000)
    })
  },
  refreshPage() {
    wx.redirectTo({
      url: 'ProductDetail?pId=' + this.data.pId
    })
  }
}
Component({
  data,
  properties: {
    discountProduct: {
      type: Object,
      value: null
    },
    pId: {
      type: Number
    }
  },
  methods,
  ready() {
    if (this.data.discountProduct) {
      let tmp = this.data.discountProduct.productDiscountScheduleSkus
      let originalPriceArr = []
      for (let i = 0; i < tmp.length; i++) {
        originalPriceArr.push(tmp[i].originalPrice)
      }
      let originalPrice = FILTER.getPriceRange(originalPriceArr, 1)
      this.setData({
        discountPrice: this.data.discountProduct.price,
        originalPrice: originalPrice
      })
      let endT = this.data.discountProduct.endTime;
      api.getTime().then(now => {
        if (now < endT) {
          this.intervalTicker(endT);
        }
      })
    }
  }
})