import { LOADING } from '../../utils/index'
import { WGAUTH, WGCOMMON, WGUSER } from '../../wgUtils/index'

Component({
  properties: {},
  data: {
    canIUseGetUserProfile: false,
    loginType: 2  // 1-授权头像+昵称，2-授权手机号
  },
  methods: {
    getPhoneNumber(e) {
      if (e.detail.errMsg === 'getPhoneNumber:ok') {
        LOADING.show({
          title: '登录中...'
        })
        WGAUTH.getPhoneNumber(e).then(() => {
          LOADING.hide()
          this.checkLoginType()
        }).catch(() => {
          WGAUTH.wxLogin().then(() => {
            this.checkLoginType()
          })
        })
      }
    },
    bindgetuserinfo (e) {
      LOADING.show()
      WGAUTH.getUserInfo(e).then(() => {
        LOADING.hide()
        this.checkLoginType()
      }).catch(() => {
        WGAUTH.wxLogin().then(() => {
          this.checkLoginType()
        })
      })
    },
    getUserProfile() {
      LOADING.show()
      WGAUTH.getUserProfile().then(res => {
        LOADING.hide()
        this.checkLoginType()
      }).catch(() => {
        WGAUTH.wxLogin().then(() => {
          this.checkLoginType()
        })
      })
    },
    checkLoginType() {
      let cusId = wx.getStorageSync('cusId')
      let unionId = wx.getStorageSync('unionId')
      let custChannel = wx.getStorageSync('custChannel')
      let phone = wx.getStorageSync('phone')
      if(!unionId) { // 没有unionid需要先授权头像获取unionid
        this.setData({
          loginType: 1
        })
        console.log('没有unionid需要先授权头像获取unionid')
      } else if(unionId && !cusId) { // 有unionid但是没有cusid,并且没有手机号需要授权手机号进行登录
        this.setData({
          loginType: 2
        })
        console.log('有unionid但是没有cusid需要授权手机号进行登录')
      } else if(custChannel === ''){
        WGUSER.webLogin().then(()=>{
          this.setData({
            loginType: 0
          })
          this.triggerEvent('login', true)
        })
      } else {
        this.setData({
          loginType: 0
        })
        this.triggerEvent('login', true)
      }
      return
    },
  },
  lifetimes: {
    attached() {
      this.checkLoginType()
    }
  },
  pageLifetimes: {
    show() {    
      if (wx.getUserProfile) {
        this.setData({
          canIUseGetUserProfile: true
        })
      }
      this.checkLoginType()
    }
  }
})