import { orderOperator, FILTER, SRTRACK } from '../../utils/index'
import env1 from '../../utils/env1'
const app = getApp()
let methods = {
  propertyChange1 (newVal, oldVal) { // 商品详情模块
    if (newVal.orderDetails) {
      for (let i = 0; i < newVal.orderDetails.length; i++) {
        let p_actual = newVal.orderDetails[i].priceActual
        let p = newVal.orderDetails[i].pricePerUnit * newVal.orderDetails[i].quantity
        let m = newVal.orderDetails[i].priceActual * 100
        let n = newVal.orderDetails[i].quantity
        let p_discount = Math.round(m / n) / 100
        newVal.orderDetails[i].discountPrice = '¥' + p_discount.toFixed(2) + 'x' + n // 折扣价
        if (!newVal.orderDetails[i].giftStatus && (p_actual != p)) {
          newVal.orderDetails[i].offer = true
        } else {
          newVal.orderDetails[i].offer = false
        }

        // 判断是否可申请售后
        /**申请退款按钮要同时满足以下条件：
          （1）订单类型不是优惠券单、不是积分兑换单、不是月卡单、不是购买超级会员单  flag5
          （2）订单状态不是已退款或拼团中 flag4
          （3）产品状态为空，或部分退款、或取消退款
          （4）订单pay status =1  flag3
          （5）没有shippingtime，或shippingtime <= 15天 flag2
          （6）产品分摊金额 > 0 flag1
          （7）不是月卡产品 flag6
          （8）不是年卡产品 flag7
        */
        let flag1 = ([3, 4].indexOf(newVal.orderDetails[i].productStatusId) > -1) || !newVal.orderDetails[i].productStatusId
        let list = newVal.orderDelivery
        let flag2 = true
        let dates = []
        if (list && list.length > 0) {
          for (let i = 0; i < list.length; i++) {
            dates.push(list[i].shippingDate)
          }
          let minDate = Math.min.apply(null, dates)
          flag2 = (Date.now() - minDate - 15 * 24 * 60 * 60 * 1000) <= 0
        }
        let flag3 = (newVal.payStatus === 1)  // 已付款
        let flag4 = ([8, 16].indexOf(newVal.orderStatusId) === -1) // 8已退款，16拼团中
        let flag5 = ([11, 13, 20, 21, 14].indexOf(newVal.orderType) === -1) // 优惠券单&积分兑换单&月卡单
        let flag6 = newVal.orderDetails[i].productTemplateId == (env1 == 'TEST'?1276:1662)
        let svipProductIds = (env1 == 'TEST'?[1290, 1291]:[1936, 1935]) // 超级会员年卡虚拟产品
        let flag7 = (svipProductIds.indexOf(newVal.orderDetails[i].productTemplateId) == -1) // 不是超级会员年卡产品
        newVal.orderDetails[i].refund = (flag1 && flag2 && flag3 && flag4 && flag5 && !flag6 && flag7)
      }
      this.setData({
        itemModule: newVal
      })
    }
  },
  propertyChange2 (newVal, oldVal) {
  },
  cancelRefund (e) { // 取消退款
    orderOperator.cancelRefund(e.currentTarget.dataset.id).then((res) => {
      this.triggerEvent('getData', true)
    })
  },
  editReturnForm (e) { // 填写退货信息
    let detail = e.currentTarget.dataset.detail
    let _self = this
    // return false
    let params = {
      orderId: this.data.itemModule.id,
      customerId: wx.getStorageSync('cusId'),
      orderDetailId: detail.id,
      retrunedDetails: [{
        productId: detail.productId,
        productTemplateId: detail.productTemplateId,
        quantity: detail.quantity
      }]
    }
    app.globalData.returnFormDetail = params
    wx.navigateTo({
      url: '/pages/ReturnForm/ReturnForm?billId=' + _self.data.id1 + '&origin=detail' 
    })
  },
  applyRefundOrder (e) { // 申请退款
    let params = orderOperator.applyRefundOrder(e.currentTarget.dataset.detail, e.currentTarget.dataset.id)
    app.globalData.refundDetail = params
    SRTRACK.customOrder(e.currentTarget.dataset.item, "refund")
    if (app.globalData.refundDetail) {
      wx.navigateTo({
        url: `/pages/SaleServer/SaleServer?orderId=${e.currentTarget.dataset.id}&orderDetailId=${e.currentTarget.dataset.detail.id}&origin=detail&orderCode=${e.currentTarget.dataset.item.orderCode}`,
      })
    }
  },
  goDetail (e) {
    let monthSvipPid = (env1 == 'TEST' ? 1276 : 1662)
    // 199超会
    let superMember199 = (env1 == 'TEST' ? 1291 : 1936)
    // 99超会
    let superMember99 = (env1 == 'TEST' ? 1290 : 1935)
    if(this.data.itemModule.orderType != 20 && e.currentTarget.dataset.id != monthSvipPid && e.currentTarget.dataset.id != superMember199 && e.currentTarget.dataset.id != superMember99 ) {
      wx.navigateTo({
        url: '/pages/ProductDetail/ProductDetail?pId=' + e.currentTarget.dataset.id,
      })
    }
  }
}
Component({
  /**
   * 组件的属性列表
   */
  properties: {
    itemModule: {
      type: Object,
      observer: 'propertyChange1'
    },
    orderDetails: {
      type: Array,
      observer: 'propertyChange2'
    },
    id1: {
      type: String
    }
  },

  /**
   * 组件的初始数据
   */
  data: {

  },

  /**
   * 组件的方法列表
   */
  methods
})
