import {
  REQUEST,
  API,
  orderOperator,
  PAY,
  order,
  SRTRACK,
  TOAST,
  LOADING,
  FILTER
} from '../../utils/index'
import { WGCOMMON, WGENV } from '../../wgUtils/index';
const app = getApp()
const properties = {
  orderModule: {
    type: Object,
    observer: '_propertyChange1'
  }
}
const data = {
  isGroupBing: false,
}
const methods = {
  delOrder(event) {
    let _self = this
    orderOperator.delOrder(event.currentTarget.dataset.id).then(() => {
      _self.triggerEvent('updateData', true)
    }).catch((e) => {
      TOAST.warning({
        title: '操作失败'
      })
    })
  },
  goEquityCard(){
    wx.navigateTo({
      url: '/pages/EquityCard/EquityCard'
    })
  },
  goSaveCard() {
    wx.navigateTo({
      url: '/modules/MallPromotion/pages/SaveMoneyCard/SaveMoneyCard'
    })
  },
  goDetail(event) {
    wx.navigateTo({
      url: '/pages/OrderDetail/OrderDetail?billId=' + event.currentTarget.dataset.id
    })
  },
  getServerTime() {
    return new Promise((resolve, reejct) => {
      REQUEST.get(API.get_serverTime).then((res) => {
        const {
          status,
          data
        } = res.data
        if (status == 0 && data) {
          resolve(data)
        } else {
          reject()
        }
      }).catch(() => {
        reject()
      })
    })
  },
  _propertyChange1(newVal, oldVal) { // 商品详情模块
    let _self = this
    if (newVal == '') return false
    this.getServerTime().then((curTime) => {
      for (let i = 0; i < newVal.length; i++) {
        for (let j = 0; j < newVal[i].orderDetails.length; j++) {
          let p_actual = newVal[i].orderDetails[j].priceActual
          let p = newVal[i].orderDetails[j].pricePerUnit * newVal[i].orderDetails[j].quantity
          let m = newVal[i].orderDetails[j].priceActual * 100
          let n = newVal[i].orderDetails[j].quantity
          let p_discount = Math.round(m / n) / 100
          newVal[i].orderDetails[j].discountPrice = '¥' + p_discount.toFixed(2) + 'x' + n // 折扣价
          if (!newVal[i].orderDetails[j].giftStatus && (p_actual != p)) {
            newVal[i].orderDetails[j].offer = true
          } else {
            newVal[i].orderDetails[j].offer = false
          }
          if (newVal[i].orderDetails[j].product.imgUrl) {
            newVal[i].orderDetails[j].icon = newVal[i].orderDetails[j].product.imgUrl
          } else {
            if (newVal[i].orderDetails[j].productTemplate.groupedImages.icon && newVal[i].orderDetails[j].productTemplate.groupedImages.icon[0].imageUrl) {
              newVal[i].orderDetails[j].icon = newVal[i].orderDetails[j].productTemplate.groupedImages.icon[0].imageUrl
            }
          }
          // 判断是否可申请售后
          let flag1 = ([3, 4].indexOf(newVal[i].orderDetails[j].productStatusId) > -1) || !newVal[i].orderDetails[j].productStatusId
          let list = newVal[i].orderDelivery
          let flag2 = true
          let dates = []
          if (list && list.length > 0) {
            for (let x = 0; x < list.length; x++) {
              dates.push(list[x].shippingDate)
            }
            let minDate = Math.min.apply(null, dates)
            flag2 = (Date.now() - minDate - 15 * 24 * 60 * 60 * 1000) <= 0
          }
          let flag3 = (newVal[i].payStatus == 1) // 已付款
          let flag4 = [8, 16].indexOf(newVal[i].orderStatusId) == -1 // 8已退款，16拼团中
          let flag5 = ([11, 13, 20, 21, 14].indexOf(newVal[i].orderType) === -1)
          // let flag5 = (newVal[i].orderType != 11 && newVal[i].orderType != 13 && newVal[i].orderType != 20) // 不是优惠券订单、不是积分兑换单、不是月卡单
          let flag6 = newVal[i].orderDetails[j].productTemplateId == (WGENV.env == 'TEST'?1276:1662)
          let svipProductIds = (WGENV.env == 'TEST'?[1290, 1291]:[1936, 1935]) // 超级会员年卡虚拟产品
          let flag7 = (svipProductIds.indexOf(newVal[i].orderDetails[j].productTemplateId) == -1) // 不是超级会员年卡产品
          newVal[i].orderTex = order.orderType(newVal[i]) ? order.orderType(newVal[i]) : ''
          /** 拼团 */
          newVal[i].groupStatus = _self.checkGroup(newVal[i])
          newVal[i].groupStatus2 = _self.checkGroup(newVal[i], true)
          /** 团购 */
          newVal[i].groupBStatus = _self.checkGroupB(newVal[i])
          newVal[i].groupBStatus2 = _self.checkGroupB(newVal[i], true)
          if (newVal[i].orderStatusId == 16 && newVal[i].orderType == 16) {
            newVal[i].isGroupBing = true
          }
          /**申请退款按钮要同时满足以下条件：
          （1）订单类型不是优惠券单、不是积分兑换单、不是月卡单、不是年卡单  flag5
          （2）订单状态不是已退款或拼团中 flag4
          （3）产品状态为空，或部分退款、或取消退款
          （4）订单pay status =1  flag3
          （5）没有shippingtime，或shippingtime <= 15天 flag2
          （6）产品分摊金额 > 0 flag1
          （7）不是月卡产品 flag6
          （8）不是年卡产品 flag7
          */
          newVal[i].orderDetails[j].refund = (flag3 && flag1 && flag2 && flag4 && flag5 && !flag6 && flag7)
          newVal[i].transportFee = newVal[i].orderDetails[j].transportFee
          newVal[i].isComment = _self.checkComment(newVal[i])
          newVal[i].isDel = [6, 7, 8].indexOf(newVal[i].orderStatusId) > -1
          newVal[i].isPayFinal = false
          if (newVal[i].orderType == 6 && newVal[i].orderStatus.id == 15) { // 预售活动:已付定金未付尾款
            let balancePaymentStartTime = newVal[i].orderDownPayment.balancePaymentStartTime
            let balancePaymentEndTime = newVal[i].orderDownPayment.balancePaymentEndTime
            if (curTime >= balancePaymentStartTime && curTime <= balancePaymentEndTime) {
              newVal[i].isPayFinal = true
              newVal[i].tail = '¥' + FILTER.currency(newVal[i].totalFee - newVal[i].orderDownPayment.presellMoney)
            }
          }
        }
      }
      console.log('newVal-----------', newVal)
      _self.setData({
        orderModule: newVal
      })
    })
  },
  checkComment(order) {
    var flag1 = order.evaluationStatus != 1
    var flag2 = order.orderStatus.id == 6
    var flag3 = false
    var list = order.orderDelivery
    var dates = []
    if (list && list.length > 0) {
      for (var i = 0; i < list.length; i++) {
        dates.push(list[i].shippingDate)
      }
      var minDate = Math.min.apply(null, dates)
      flag3 = Date.now() - minDate - 60 * 24 * 60 * 60 * 1000 <= 0
    }
    return flag1 && flag2 && flag3
  },
  applyRefundOrder(e) { // 申请退款
    let params = orderOperator.applyRefundOrder(e.currentTarget.dataset.detail, e.currentTarget.dataset.id)
    app.globalData.refundDetail = params
    SRTRACK.customOrder(e.currentTarget.dataset.item, "refund")
    wx.navigateTo({
      url: `/pages/SaleServer/SaleServer?orderId=${e.currentTarget.dataset.id}&orderDetailId=${e.currentTarget.dataset.detail.id}&orderCode=${e.currentTarget.dataset.item.orderCode}`,
    })
  },
  cancelRefund(e) { // 取消退款
    let _self = this
    orderOperator.cancelRefund(e.currentTarget.dataset.id).then(() => {
      // TODU 交互
      // TOAST.success({ title: '取消成功' }).then(() => {
      _self.triggerEvent('updateData', true)
      // })
    }).catch((e) => {
      // TODU 错误处理
      TOAST.warning({
        title: '操作失败'
      })
    })
  },
  pay(e) { // 支付
    // if (e.currentTarget.dataset.item.source != 2) {
    //   TOAST.warning({
    //     title: '订单不能跨平台支付，请去您下单的地方支付！'
    //   })
    // } else {
    PAY({
      params: e.currentTarget.dataset.item,
      paySuccessFn: this.paySuccessFn.bind(this),
      payErrorFn: this.payErrorFn.bind(this),
      isSvip: 0,
      customOrderParams: e.currentTarget.dataset.item
    })
    // }
  },
  paySuccessFn() {},
  payErrorFn() {
    TOAST.warning('支付失败').then(() => {
      wx.navigateTo({
        url: '/pages/OrderDetail/OrderDetail?billId=' + this.data.id,
      })
    })
  },
  cancelOrder(e) { // 取消交易
    let _self = this
    SRTRACK.customOrder(e.currentTarget.dataset.item, "cancel_give_order")
    orderOperator.cancelOrder(e.currentTarget.dataset.id).then((res) => {
      // TOAST.success({ title: '取消成功' }).then(() => {
      _self.triggerEvent('updateData', true)
      // })
    }).catch((e) => {
      // TODU 错误处理
      TOAST.warning({
        title: '操作失败'
      })
    })
  },
  goGroupDetail(e) { //查看拼团详情 
    wx.navigateTo({
      url: '/pages/GroupDetail/GroupDetail?grouppurchaseCode=' + e.currentTarget.dataset.code,
    })
  },
  goGroupBDetail(e) { //查看团购详情 
    wx.navigateTo({
      url: '/pages/GroupBDetail/GroupBDetail?grouppurchaseCode=' + e.currentTarget.dataset.code,
    })
  },
  goLogistics(e) { // 查看物流
    this.triggerEvent('goLogistics', e.currentTarget.dataset.item)
  },
  goLogisticsList() { // 关闭物流MODAL
    this.triggerEvent('goLogisticsList', false)
  },
  goComment(e) { // 去评价
    app.globalData.commentDetail = e.currentTarget.dataset.item
    let orderType = e.currentTarget.dataset.ordertype
    let isTrial = e.currentTarget.dataset.istrial
    if(orderType == 19 || isTrial == 1) {
      WGCOMMON.toast('前往试用中心填写或查看试用报告哦~', 3000)
      setTimeout(function() {
        wx.navigateTo({  // 跳转到我的试用
          url: '/modules/ProductTrial/pages/TrialCenter/TrialCenter?tabIndex=1'
        })
      }, 3000)
    } else {
      wx.navigateTo({
        url: '/pages/OrderComment/OrderComment?orderType=' + orderType
      })
    }
  },
  checkGroup(order, flag) {
    let flag1 = order.orderType == 8
    let flag2 = order.orderStatusId == 16
    if (flag) { // 邀请好友
      return flag1 && flag2
    } else { // 查看拼团详情
      let flag3 = order.payStatus == 1
      return flag1 && !flag2 && flag3
    }
  },
  checkGroupB(order, flag) {
    let flag1 = order.orderType == 16 // 团购
    let flag2 = order.orderStatusId == 16 // 团购中
    let flag3 = order.payStatus == 1 // 已支付
    if (flag) return flag1 && flag2
    return flag1 && !flag2 && flag3
  },
  confirmOrder(e) { // 确认收货
    orderOperator.confirmOrder(e.currentTarget.dataset.id).then(() => {
      app.globalData.commentDetail = e.currentTarget.dataset.item.orderDetails
      if(e.currentTarget.dataset.item.orderType == 19) {
        WGCOMMON.toast('确认收货后前往试用中心填写试用报告哦~', 3000)
        setTimeout(function() {
          wx.navigateTo({  // 跳转到我的试用
            url: '/modules/ProductTrial/pages/TrialCenter/TrialCenter?tabIndex=1'
          })
        }, 3000)
      } else {
        wx.navigateTo({
          url: '/pages/OrderComment/OrderComment?orderType=' + e.currentTarget.dataset.item.orderType
        })
      }
    }).catch(() => {
      TOAST.warning({
        title: '操作失败'
      })
    })
  },
  editReturnForm(e) { // 填写退货信息
    let item = e.currentTarget.dataset.item
    let detail = e.currentTarget.dataset.detail
    let params = {
      orderId: item.id,
      customerId: wx.getStorageSync('cusId'),
      orderDetailId: detail.id,
      retrunedDetails: [{
        productId: detail.productId,
        productTemplateId: detail.productTemplateId,
        quantity: detail.quantity
      }]
    }
    app.globalData.returnFormDetail = params
    wx.navigateTo({
      url: '/pages/ReturnForm/ReturnForm'
    })
  },
}
Component({
  /**
   * 组件的属性列表
   */
  properties,

  /**
   * 组件的初始数据
   */
  data,

  /**
   * 组件的方法列表
   */
  methods,
  ready() {

  }
})