Component({
  properties: {
    product: {
      type: Object
    },
  },
  observers: {
    "product"(newVal, oldVal) {
      if(newVal) {  
        this.initShare()
        console.log('product', newVal)
        this.initRedeem(newVal.products)
      }
    }
  },
  data: {
    isRedeem: false,
    showShare: false,
    shareProduct: {
      item_code: '1',
      title: 'null',
      category_list: ['食品', '五谷', '杂粮'],
      image_list: [],
      src_mini_program_path: 'pages/ProductDetail/ProductDetail?pId=1'
    }
  },
  methods: {
    on_error(e) {
      console.error('好物圈接口报错', e)
    },
    initShare() {
      let data = this.properties.product
      if(data.id) {
        let shareProduct = {
          item_code: `${data.id}`,
          title: data.productTemplateName,
          category_list: ['食品', '五谷', '杂粮'],
          image_list: [],
          src_mini_program_path: 'pages/ProductDetail/ProductDetail?pId=' + data.id
        }
        let banner = data.groupedImages.banner;
        for (var i = 0; i < banner.length; i++) {
          shareProduct.image_list.push(banner[i].imageUrl)
        }
        this.setData({
          shareProduct: shareProduct
        })
      }
      if(data.pIds) {
        let shareProduct = {
          item_code: `${data.pIds}`,
          title: data.productTemplateName,
          category_list: ['食品', '五谷', '杂粮'],
          image_list: data.banner,
          src_mini_program_path: 'pages/PackageDetail/PackageDetail?pIds=' + data.pIds
        }
        this.setData({
          shareProduct: shareProduct,
          showShare: true  // 当发一版后可以注释掉为false
        })
      }
    },
    initRedeem (products) {
      if(products) {
        for(let i=0,len=products.length;i<len;i++) {
          if(products[i].isRedeem === 1 && products[i].enable === 0) {
            this.setData({
              isRedeem: true
            })
            break
          }
        }
      }
    }
  }
});