import { REQUEST, API, LOADING, UTIL } from '../../utils/index'
import { WGFORMAT } from '../../wgUtils/index'
import api from '../../api/index';
const methods = {
  selectTab (event) {
    if (event.currentTarget.dataset.type == 1) {
      this.getNotice()
    }
    this.setData({
      tabNum: event.currentTarget.dataset.type
    })
  },
  getNotice () {
    REQUEST.get(API.get_notice).then((res) => {
      const { status, data } = res.data
      if(status === 0) {
        this.setData({
          noticeModule: data
        })
      }
    }).catch((e) => {})
  },
  previewImg(e) { // 预览图片
    UTIL.previewImg(e.currentTarget.dataset.url, [e.currentTarget.dataset.url])
  },
  linkToOtherPage(url, query) {
    api.modules.getActivityPageId(url).then(r => {
      if (r.id) {
        wx.navigateTo({
          url: '/pages/ActivityPage/ActivityPage?id=' + r.id + '&' + query
        })
      }
    })
  },
  toBannerTarget() {
    let link = this.data.bannerTarget
    if(!link) return
    if(link.indexOf('shop-web/shop/productIndex.html') != -1 || link.indexOf('/Home/Home') != -1) { // 首页
      wx.switchTab({
        url: '/pages/Home/Home'
      })
    } else if(link.indexOf('.wgmf.com/wechat-html/html/shop/product/') != -1) { // H5二级页面
      let arr = link.split('?')
      let a = arr[0]
      let b = a.split('/')
      let url = b[b.length - 1]
      let query = arr.length > 1 ? arr[1] : ''
      this.linkToOtherPage(url, query)
    } else if(link.indexOf('orderList.html') != -1 || link.indexOf('OrderList/OrderList') != -1) { // 订单列表
      wx.navigateTo({
        url: '/pages/OrderList/OrderList?orderType=1'
      })
    } else if (link.indexOf('productList.html') != -1) { // 分类页
      wx.switchTab({
        url: '/pages/ProductIndex/ProductIndex'
      })
    } else if (link.indexOf('myCart.html') != -1 || link.indexOf('MyCart/MyCart') != -1) { // 购物车
      wx.switchTab({
        url: '/pages/MyCart/MyCart'
      })
    } else if(link.indexOf('superMember.html') != -1) { // 超级会员页
      wx.navigateTo({ 
        url: "/pages/superMember/superMember" 
      })
    } else if(link.indexOf('/WgFans/WgFans') != -1) {  // 谷粉社区
      wx.switchTab({
        url: '/modules/FanCommunity/pages/WgFans/WgFans'
      })
    } else {
      wx.navigateTo({
        url: link
      })
    }
  },
}
Component({
  properties: {
    info: {
      type: Object
    },
    actType: {
      type: Number,
      value: 0
    }
  },
  data: {
    tabNum: 0,
    weikBanner: false,
    noticeModule: null, // notice相关信息
    bannerTarget: '',
    bannerUrl: ''
  },
  methods,
  lifetimes: {
    attached() {
      let now = new Date().getTime()
      api.product.banner().then(res => {
        if(res) {
          for(let i=0;i<res.length;i++) {
            if(res[i].isDeleted == 0 && WGFORMAT.targetDateInDateBetwen(res[i].startTime, res[i].endTime, now)) {
              this.setData({
                weikBanner: true,
                bannerUrl: res[i].imgUrl,
                bannerTarget: res[i].noticeLink
              })
            }
          }
        }
      })
    }
  }
})
