import API from '../../../api/index'
import { WGCOMMON } from '../../../wgUtils/index';
Component({
  properties: {
    pId: Number
  },
  data: {
    cardUrl: '',
    cardData: null,
    isReceive: false,
    isQuesting: false, // 正在领取卡片中
  },
  methods: { 
    closeModal() { // 关闭弹窗
      this.setData({
        cardUrl: null
      })
    },
    receiveCard() { // 领取卡片
      if(!this.data.isReceive) {
        if(this.data.isQuesting) {
          return
        }
        this.data.isQuesting = true
        WGCOMMON.showLoading('领取中')
        API.promotion.confirmCardDetail(wx.getStorageSync('cusId'), this.data.pId ,wx.getStorageSync('openId'), this.data.cardData.cardCollectionLines[0].id).then(res => {
          if(res) {
            this.setData({
              cardUrl: this.data.cardData.cardCollectionLines[0].dialogImgUrl + '?imageslim',
              isReceive: true
            })
          }
          this.data.isQuesting = false
          WGCOMMON.hideLoading()
        }).catch(() => {
          this.data.isQuesting = false
          WGCOMMON.hideLoading()
        })
      } else {
        this.toCardCollection()
      }
    },
    checkCard() { // 检查是否有卡片
      if(wx.getStorageSync('cusId') && this.data.pId) {
        API.promotion.getCardDetail(this.data.pId, wx.getStorageSync('cusId')).then(res => {
          if(res && res.data.status == 0) {
            this.setData({
              cardData: res.data.data,
              cardUrl: 'https://img.wgmf.com/wgmall/collect-card/img_pop_red_envelope.png?imageslim'
            })
          } else {
            this.closeModal()
          }
        })
      } else {
        this.closeModal()
      }
    },
    toCardCollection() { // 去我的集卡中心
      wx.navigateTo({
        url: '/modules/MallPromotion/pages/CollectCard/CollectCard'
      })
    },
  },
  pageLifetimes: {
    show() {
      this.checkCard()
    }
  }
})