import api from '../../../api/index'
import { WGCOMMON, WGFORMAT } from '../../../wgUtils/index'
Component({
  properties: {
    martopS: Boolean
  },
  data: {
    showHbPopup: false,  // 是否显示天降红包——默认不显示红包，只有处于活动期间才会显示
    hbType: 1, // 1普通红包，2特殊活动红包
    showHb: 1,  // 1-红包关闭状态；2-红包打开状态
    myMoney: 0, // 红包金额
    hbTip: '', // 红包的券面提示
    storageKey: '2022114HB'
  },
  methods: {
    changeHb() { // 拆红包
      wx.setStorageSync(this.data.storageKey, this.data.myMoney) // 设置已领取了天降红包的缓存
      this.setData({
        showHb: 2
      })
    },
    closeHbPopup() { // 关闭红包
      this.setData({
        showHbPopup: false,
        showHb: 1
      })
    },
    reciveCoupon() { // 立即领取
      wx.navigateTo({
        url: '/pages/TicketsAccount/TicketsAccount'
      })
    },
    initCoupon() { // 获取优惠券
      let timeValid = WGFORMAT.targetDateInDateBetwen('2022-01-14 00:00:00', '2022-01-16 23:59:59', new Date().getTime()) // 是否在活动时间内 正式
      if(timeValid && !wx.getStorageSync(this.data.storageKey)) { // 处于活动时间 && 用户没有拆过红包
        let cusId = wx.getStorageSync('cusId')
        this.setData({
          showHbPopup: true
        })
        // let cusId = 16813680
        api.coupons.receiveRedPacket(cusId).then(res => {
          if(res.data.msgCode == 0) {
            if(res.data.resultInfo.value > 0) {
              this.setData({
                // showHbPopup: true, 
                myMoney: res.data.resultInfo.value
              })
            }
          }
        })
        
      } else {
        // this.setData({ showHbPopup: false })
      }
    },
  },
  lifetimes: {
  },
  pageLifetimes: {
    show() {
      if(wx.getStorageSync('cusId')) {
        this.initCoupon()
      }
    },
    hide() {
    }
  },
})