//Component Object
Component({
  properties: {
    endTime: {
      type: Number
    },
    startTime: {
      type: Number
    }
  },
  data: {
    time: {
      h: '00',
      m: '00',
      s: '00'
    },
    isStart: false
  },
  methods: {
    initTime(time) {
      let now = new Date().getTime()
      let cha = (time - now)/1000
      let h = parseInt(cha/3600)
      let m = parseInt((cha-h*3600)/60)
      let s = parseInt(cha-h*3600-m*60)
      this.setData({
        time: {
          h: h < 10?'0'+h:h,
          m: m < 10?'0'+m:m,
          s: s < 10?'0'+s:s
        }
      })
    },
    startTick(time) {
      let now = new Date().getTime()
      let that = this
      var tick = setInterval(function() {
        if(time - now < 0) {
          clearInterval(tick)
          this.changeTick()
        } else {
          that.initTime(time)
        }
      }, 1000)
    },
    changeTick() {
      let now = new Date().getTime()
      if(now > this.data.startTime && now < this.data.endTime) {  // 已开始但未结束
        this.setData({
          isStart: true
        })
        this.startTick(this.data.endTime)
      }
    }
  },
  observers: {
    "startTime"(nv) {
      let now = new Date().getTime()
      if(now > nv) { // 已开始
        this.setData({
          isStart: true
        })
      } else { // 未开始,进行开始倒计时
        this.setData({
          isStart: false
        })
        this.startTick(nv)
      }
    },
    "endTime"(nv) {
      let now = new Date().getTime()
      if(now > this.data.startTime && now < nv) {  // 已开始但未结束，进行结束倒计时
        this.setData({
          isStart: true
        })
        this.startTick(nv)
      } 
    }
  },
  pageLifetimes: {

  },
});