//Component Object
import api from '../../../api/index'
Component({
  properties: {
    skuIds: {
      type: String,
      value:'',
    },
  },
  data: {
    hasPackage: false,
    series: [],
  },
  methods: {
    initPackage(ids) { // 套餐搭配活动 - @author-wucl
      api.package.list(ids).then( res => {
        if(!res || res.length <= 0) {  // 无套餐搭配
          this.setData({
            hasPackage: false
          })
        } else {
          console.log('套餐搭配活动-------------', res)
          let series = []
          let needIcon = false
          let needIconIds = []
          let needIconIdsIndex = []
          for(let i=0;i<res.length;i++) {
            let tmp = res[i].rule.productInfo
            let ids = []   
            let startTime = new Date(res[i].startTime.replace(/\-/g, '/')).getTime()
            let endTime = new Date(res[i].endTime.replace(/\-/g, '/')).getTime()
            console.log(startTime, endTime)
            // let now = new Date().getTime()
            api.getTime().then(now => {
              if(!now) {
                now = new Date().getTime()
              }
              if(startTime < now && now < endTime) { // 套餐活动已开始但未结束
                console.log('套餐活动已开始但未结束')
                for(let j=0;j<tmp.length;j++) {
                  ids.push(tmp[j].code)
                  if(!tmp[j].proImage) {
                    needIcon = true
                    needIconIds.push({productId: tmp[j].templateId})
                    needIconIdsIndex.push({series: i, products: j})
                  }
                }
                series.push({
                  products: tmp,
                  ids: ids.join(',')
                })
                this.setData({
                  hasPackage: true,
                  series: series
                })
                if(needIcon) {
                  this.initImg(needIconIds, needIconIdsIndex)
                }
                console.log(series, 'series')
              }
            })
          }
        }
      })
    },
    initImg(ids, idsIndex) {
      api.product.list(ids).then(res => {
        for(let i=0;i<res.length;i++) {
          let img1 = res[i].product.imgUrl
          let img2 = res[i].productTemplate.groupedImages.icon[0].imageUrl
          let img = img2?img2:img1
          let key = "series[" + idsIndex[i].series + "].products[" + idsIndex[i].products + "].proImage"
          this.setData({
            [key]: img
          })
        }
      }).catch( e => {
        console.error('product/info/list报错', e)
      })
    },
    toDetail(e) {
      wx.navigateTo({
        url: '/pages/PackageDetail/PackageDetail?type=7&pIds=' + this.data.skuIds
      })
    },
  },
  observers: {
    "skuIds"(nv) {
      if(nv != '') {
        this.initPackage(nv)
      }
    }
  },
});