import { WGDATATYPE, WGFORMAT,WGTRACK } from '../../../wgUtils/index'
import API from '../../../api/index'
/**
 * 弹窗类型 type  
 *          1-活动期间首次进入商城只显示一次；
 *          2-活动期间进入商城显示，当点击了弹窗，不再显示；未点击，活动期间每次进入商城都会显示；
 *          3-活动期间进入商城每天都显示一次
 * 弹窗场景 scene
 *          0-首页
 *          1-产品详情页
 *          2-社区首页
 * 弹窗图片 imgUrl
 * 弹窗名称 name
 * 点击弹窗的跳转链接 linkUrl
 * 开始时间 startTime
 * 结束时间 endTime
 * 是否禁用 isEnable 后期接口需要优化，禁用的弹窗不用返回 
 * 是否仅限超会显示  isVipOnly
 */
Component({
  properties: {
    pId: Number,
    scene: Number, // 弹窗的场景
  },
  data: {
    allActivityPopUp: [],
    isShow: false, // 是否展示弹窗
    activePopUp: null, // 当前弹窗对象
    goLiveInfo: false
  },
  methods: {
    closeMask(isClickPopUp) { // 关闭弹窗
      this.setData({
        isShow: false
      })
      if(!isClickPopUp) {
       WGTRACK.logCustomEvent('close_openScreen',this.data.activePopUp.id)
      }
      this.setStorage(isClickPopUp)
    },
    toDetail() { // 点击弹窗后的跳转动作
      this.closeMask('fromPopUp')
      WGTRACK.logCustomEvent('click_openScreen',this.data.activePopUp.id)
      if (this.data.activePopUp.linkUrl== 'liveInfo' ||this.data.activePopUp.linkUrl== 'LiveInfo' ||this.data.activePopUp.linkUrl == 'LIVEINFO') { // 跳转到直播间
        //跳转直播间
            console.log(this.data.activePopUp.linkUrl)
            console.log(this.data.goLiveInfo)
            let that = this
            wx.getChannelsLiveInfo({
              finderUserName: 'sphmTN8rmxUL5cq',
              success(res) {
                console.log(res)
                if(res.status == 2) {
                  //直播中
                  that.setData({
                    goLiveInfo: true,
                    getChannelsLiveInfoRes: res
                  })
                  if(that.data.goLiveInfo == true) {
                    wx.openChannelsLive({
                      finderUserName: 'sphmTN8rmxUL5cq',
                      feedId: that.data.getChannelsLiveInfoRes.feedId,
                      nonceId: that.data.getChannelsLiveInfoRes.nonceId,
                      success(_res) {
                        console.log(_res)
                      },
                      fail(_res) {
                        console.log('跳转视频号失败',_res)
                      }
                    })
                  }
                } else if (res.status == 3) {
                  console.log('直播已结束', res)
                  //直播已结束
                  that.setData({
                    goLiveInfo: true,
                    getChannelsLiveInfoRes: res
                  })
                  if(that.data.goLiveInfo == true) {
                    wx.openChannelsLive({
                      finderUserName: 'sphmTN8rmxUL5cq',
                      feedId: that.data.getChannelsLiveInfoRes.feedId,
                      nonceId: that.data.getChannelsLiveInfoRes.nonceId,
                      success(_res) {
                        console.log(_res)
                      },
                      fail(_res) {
                        console.log('跳转视频号失败',_res)
                      }
                    })
                  }
                } else {
                  wx.showToast({
                    icon: 'none',
                    title: '当前暂无直播',
                    duration: 1500
                  })
                }
              },
              fail(res) {
                console.log('视频号直播信息获取失败',res)
              }
            })
      }  else if (this.data.activePopUp.linkUrl == 'liveNoticeInfo' || this.data.activePopUp.linkUrl== 'LiveNoticeInfo' || this.data.activePopUp.linkUrl == 'LIVENOTICEINFO') { // 预约直播
        //预约直播
            console.log(this.data.activePopUp.linkUrl)
        wx.getChannelsLiveNoticeInfo({
          finderUserName: 'sphmTN8rmxUL5cq',
          success(res) {
            console.log(res)
            wx.reserveChannelsLive({
              noticeId: res.noticeId,
              success(_res) {
                console.log(_res)
              },
              fail(_res) {
                wx.showToast({
                  icon: 'none',
                  title: '跳转直播预约失败',
                  duration: 1500
                })
              }
            })
          },
          fail(_res) {
            wx.showToast({
              icon: 'none',
              title: '当前暂无可预约的直播',
              duration: 1500
            })
          }
        })
      }else if(this.data.activePopUp.linkUrl) {
        if(this.data.activePopUp.appId) {
          wx.navigateToMiniProgram({
            appId: this.data.activePopUp.appId,
            path: this.data.activePopUp.linkUrl,
            extraData: {
              foo: 'bar'
            },
            envVersion: 'release',
            success(res) {}
          })
        } else {
          wx.navigateTo({
            url: this.data.activePopUp.linkUrl
          })
        }
      }
    },
    setStorage(isClickPopUp) { // 根据弹窗类型确定缓存
      let storageKey = 'popup_' + this.data.activePopUp.id
      let type = this.data.activePopUp.type
      if(type == 1) { // 活动期间首次进入商城只显示一次
        wx.setStorageSync(storageKey, 1)
        return
      }
      if(type == 2 && isClickPopUp == 'fromPopUp') { // 活动期间进入商城显示，当点击了弹窗，不再显示;未点击活动期间每次进入商城都会显示
        wx.setStorageSync(storageKey, 1)
        return
      }
      if(type == 3) { // 活动期间进入商城每天都显示一次
        wx.setStorageSync(storageKey + '_' + new Date().getDate(), 1)
        return
      }
    },

    fliterByScene(arr) { // 场景过滤
      let newarr = []
      let vipCusStatus = wx.getStorageSync('vipCusStatus')
      for(let i=0;i<arr.length;i++) {
        arr[i]['isVipOnly'] = 0
        /**
         * 特殊处理超会匹配逻辑
         */
        if(arr[i].id === 41) arr[i]['isVipOnly'] = 1
        // if(arr[i].id === 7) arr[i]['isVipOnly'] = 1
        // 用户身份不是超会且弹窗配置了仅超会可见
        if(arr[i]['isVipOnly'] == 0 || (arr[i]['isVipOnly'] == 1 && vipCusStatus == 1)) { // 不显示弹窗
          if(arr[i].scene == this.data.scene) { // 场景匹配上了
            if(this.data.scene == 1 && arr[i].pId) { // 产品详情页并且有配置pId
              if(arr[i].pId == this.data.pId) {
                newarr.push(arr[i])
              }
            } else {
              newarr.push(arr[i])
            }
          } else if(this.data.scene == 0 && arr[i].scene == null) { // 默认首页场景
            newarr.push(arr[i])
          }
        }
        // console.error(arr[i]['isVipOnly'] == 0 || (arr[i]['isVipOnly'] == 1 && vipCusStatus == 1))
      }
      return newarr
    }
  },
  pageLifetimes: {
    show() {
      let cusId = wx.getStorageSync('cusId')
      if(cusId) {
        API.modules.validDialogListByCusId(cusId, this.data.pId).then(res => {
          if(!WGDATATYPE.isArray(res)) {
            res = []
          }
          // if(WGDATATYPE.isArray(res)) {
          //   res.push({
          //     endTime: "2021-04-21 23:59:59",
          //     id: 421,
          //     imgUrl: "http://img.wgmf.com/pro_tanchuang04161618541117004.png",
          //     isEnable: 1,
          //     linkUrl: "",
          //     name: "20210416弹窗",
          //     scene: 1,
          //     startTime: "2021-04-16 00:00:49",
          //     type: 2,
          //     pId: 1937
          //   })
          // }
          console.log(res)
          if(res.length > 0) {
            res = this.fliterByScene(res)
            this.data.allActivityPopUp = res
            let tmp = res
            let now = new Date()
            let len = tmp.length
            for(let i=0;i<len;i++) {
              let storageKey = 'popup_' + tmp[i].id
              if(WGFORMAT.targetDateInDateBetwen(tmp[i].startTime, tmp[i].endTime, now) && !wx.getStorageSync(storageKey)) { // 在活动时间内并且还没显示过弹窗
              //进入小程序，弹出开屏推广的页面曝光次数、曝光人数
              console.log(tmp[i].id)
                WGTRACK.logCustomEvent('exposure_openScreen', tmp[i].id)
                this.setData({
                  isShow: true,
                  activePopUp: tmp[i]
                })
                if(tmp[i].type == 3 && wx.getStorageSync(storageKey + '_' + now.getDate())) { // 今天已经显示过啦
                  this.setData({
                    isShow: false
                  })
                } 
                
                return
              }
            }
          }
        })
      }
    },
  }
})