import { FILTER } from '../../../utils/index'
import api from '../../../api/index'

Component({
  data: {
    seckillPrice: '',
    originalPrice: '',
    day: 0,
    hour: 0,
    minute: 0,
    second: 0,
    text: '开始'
  },
  properties: {
    buyNow: {
      type: Object,
      value: null
    },
    pId: {
      type: Number
    }
  },
  methods: {
    intervalTicker(endTime) {
      api.getTime().then(now => {
        let yu = endTime - now,
            d = 0,
            h = 0,
            m = 0,
            s = 0,
            self = this;
        const ticker = setInterval(function(){
          yu = yu - 1000
          if(yu <= 0) {
            clearInterval(ticker)
            self.refreshPage()
          } else {
            d = parseInt(yu/86400000)
            h = parseInt((yu-d*86400000)/3600000)
            m = parseInt((yu-d*86400000-h*3600000)/60000)
            s = parseInt((yu-d*86400000-h*3600000-m*60000)/1000)
            self.setData({
              day: d,
              hour: h,
              minute: m,
              second: s
            })
          }
        },1000)
      })
    },
    refreshPage() {
      wx.redirectTo({
        url: 'ProductDetail?pId=' + this.data.pId
      })
    }
  },
  ready() {
    if(this.data.buyNow) {
      let tmp = this.data.buyNow.buyNowSkus
      let originalPriceArr = []  // 虚标价
      let seckillPriceArr = [] // 秒杀价
      let noVirtualPrice = true
      for(let i=0;i<tmp.length;i++) {
        // if(tmp[i].product.virtualPrice) {  // 存在虚标价
        //   originalPriceArr.push(tmp[i].product.virtualPrice)
        // }
        originalPriceArr.push(tmp[i].product.virtualPrice || tmp[i].product.price)
        seckillPriceArr.push(tmp[i].buyNowPrice)
      }
      if(originalPriceArr.length < 1) {
        noVirtualPrice = false
      }
      let originalPrice = FILTER.getPriceRange(originalPriceArr, 1)
      this.setData({
        seckillPrice: FILTER.getPriceRange(seckillPriceArr, 1),
        originalPrice: originalPrice,
        noVirtualPrice: noVirtualPrice
      })
      let startT = this.data.buyNow.startTime;  // 开始时间
      let endT = this.data.buyNow.endTime;  // 结束时间
      // let now = new Date().getTime();
      api.getTime().then(now => {
        if(!now) {
          now = new Date().getTime()
        }
        if(now < startT) {   // 还未开始，开始倒计时
          this.intervalTicker(startT);
        }
        if(now < endT && now >= startT) { // 还未结束，开始结束倒计时
          this.intervalTicker(endT);
          this.setData({
            text: '结束'
          })
        }
      })
    }
  }
})