import API from "../../../api/index";
import { SHOPCARTSERVER } from "../../../utils/index";
import { WGCOMMON } from "../../../wgUtils/index";

Component({
  data: {
    products: []
  },
  methods: {
    getExchangeProducts() { // 获取可兑换的积分商品
      let cusId = wx.getStorageSync('cusId')
      let products = []
      if(cusId) {
        API.product.productRedeemList(cusId).then(res => {
          if(res && res.length > 0) {
            for(let i=0;i<res.length;i++) {
              for(let j=0;j<res[i].products.length;j++) {
                if(res[i].products[j].isRedeem === 1 && res[i].products[j].enable == 0 && res[i].products[j].stock > 0) {
                  let tmp = res[i].products[j]
                  tmp['warehouseCode'] = res[i].warehouseCode
                  tmp['integralStatus'] = res[i].integralStatus
                  tmp['productCategory'] = res[i].productCategory
                  if(!res[i].products[j].imgUrl) {
                    res[i].products[j].imgUrl = res[i].groupedImages.icon[0].imageUrl?res[i].groupedImages.icon[0].imageUrl:res[i].groupedImages.banner[0].imageUrl
                  }
                  products.push(tmp)
                }
              }
            }
            products.sort((a, b) => b.redeemPrice - a.redeemPrice)
            this.setData({ products })
          }
        })
      }
    },
    toDetail(e) {
      wx.navigateTo({
        url: '/pages/ProductDetail/ProductDetail?pId=' + e.currentTarget.dataset.item.productTemplateId + '&from=shopcart'
      })
    },
    addCart(e) {
      let item = e.currentTarget.dataset.item      
      let validPoint =  parseInt(wx.getStorageSync('validPoint'))
      if(item.redeemPrice <= validPoint) { // 加入购物车
        let cartItem = {
          skuName: item.skuName,
          id: item.id,
          productId: item.id,
          name: item.productName,
          productTemplateId: item.productTemplateId,
          quantity: 1,
          price: item.price,
          originPrice: item.price,
          redeemPrice: item.redeemPrice,
          isChecked: true,
          icon: item.imgUrl,
          stock: item.stock,
          limitQuantity: item.purchaseLimitQuantity,
          isRedeem: item.isRedeem,
          warehouseCode: item.warehouseCode, // 在模板层面
          integralStatus: item.integralStatus, // 在模板层面
          productCategory: item.productCategory, // 在模板层面
          cartProTag: '积分兑换',
          endTime: null
        }
        SHOPCARTSERVER.addCart(cartItem)
        this.triggerEvent('addInterPro', cartItem)
      } else {
        WGCOMMON.toast(`您的账户只有${validPoint}积分，不够兑换此产品`)
        return
      }
    },
    getIntegral() { // 查看用户账号有多少可用积分
      let cusId = wx.getStorageSync('cusId')
      if (cusId) {
        API.user.info(cusId).then(res => {
          if(res) {
            wx.setStorageSync('validPoint', res.validPoint)
          }
        })
      }
    }
  },
  lifetimes: {
  },
  pageLifetimes: {
    show() {
      this.getExchangeProducts()
      this.getIntegral()
    }
  },
})