import { SHOPCARTSERVER, FILTER } from '../../../utils/index'
import API from '../../../api/index'

Component({
  data: {
    products: []
  },
  methods: {
    getRecommendProducts() { // 获取猜你喜欢商品
      
      let cartModule = SHOPCARTSERVER.getCart()
      let num = 0
      let pIds = []
      let isAllRedeem = false
      if (!cartModule.length) {
        pIds = []
      } else {
        for (let i in cartModule) {
          if (cartModule[i].isRedeem) {
            num++
          }
          pIds.push(cartModule[i].productTemplateId)
        }
        if (num == cartModule.length) {
          isAllRedeem = true
        }
      }
      API.product.recommend(isAllRedeem ? [] : pIds).then(res => {
        if(res && res.length > 0) {
          res.filter(item => {
            item.superPrice = FILTER.getPriceRange([item.minPrice], 0.95)
          })
          this.setData({ products: res })
        }
      })
    },
    goDetail(e) {
      wx.navigateTo({
        url: '/pages/ProductDetail/ProductDetail?pId=' + e.currentTarget.dataset.id + '&from=cartRecommend',
      })
    }
  },
  lifetimes: {
    attached: function() {
      this.getRecommendProducts()
    },
  }
})