import API from '../../../api/index'
Component({
  data: {
    svipValidType: 0, // 默认0，年卡90天内快过期1，月卡3天内快过期2
    saveEconomize: 99 // 节省的金额
  },
  methods: {
    getSvipStatus() {
      let cusId = wx.getStorageSync('cusId')
      if (cusId) {
        API.user.isWillOverdue(cusId).then(res => {
          if (res && res.willOverdue) { // 年卡30天内快过期
            this.setData({
              svipValidType: 1
            })
            API.user.economize(cusId).then(res => {
              this.setData({
                saveEconomize: res.ecoFee
              })
            })
          } else if (res && res.willOverdueMonthCard) { // 月卡3天内快过期
            this.setData({
              svipValidType: 2
            })
          } else {
            this.setData({
              svipValidType: 0 // 默认0，年卡90天内快过期1，月卡3天内快过期2
            })
          }
        })
      }
    }
  },
  lifetimes: {
    attached: function() { // 在组件实例进入页面节点树时执行
      this.getSvipStatus()
    },
  }
})