import api from '../../api/index'
import { LOADING,REQUEST } from '../../utils/index'
import { WGAUTH,WGTRACK,WGENV} from '../../wgUtils/index'

const app = getApp()

Component({
  properties: {
    rowitem:{
      type: Object,
      value: {}
    },
  },
  data: {
    canIUseGetUserProfile: false,
  },
  methods: {
    getShopCoupon: function(params) {
      // 插件返回信息在params.detail
      console.log('getcoupon', params)
      // console.log(params.detail.send_coupon_result[0].code)
      // if(params.detail.errcode == "OK") {
      if(params.detail.send_coupon_result[0].code == "SUCCESS") {
        console.log(new Date().getTime())
        this.merchantNotice(params.detail.send_coupon_result[0])
      } else {
        console.log('test++++++++'+params.detail.send_coupon_result[0].code)
        this.triggerEvent('isOnload')
      }
    },
    shopCouponReceive(){
      console.log(1)
    },
    redirectuser(){
      this.triggerEvent('isOnload')
    },
    bindgetphonenumber(e) { // 登录
      if (e.detail.errMsg === 'getPhoneNumber:ok') {
        LOADING.show({
          title: '登录中...'
        })
        WGAUTH.getPhoneNumber(e).then(res => {
          this.triggerEvent('isOnload')
          LOADING.hide()
        }).catch((e) => {
          LOADING.hide()
          TOAST.warning(e)
        })
      }
    },
    merchantNotice(event){
      let baseUrl = WGENV.env == "TEST" ? 'https://newapitest.wgmf.com/' : 'https://newapi.wgmf.com/'
      let that = this;
      console.log(event)
      let url = 'order/merchant/coupon/receive/notice'
      let data ={
        "couponCode": event.coupon_code,
        "cusId": wx.getStorageSync('cusId'),
        "expiredTime": JSON.parse(event.end_time),
        "merchantCouponSettingsId": this.data.rowitem.merchantCouponSettingsId,
        "stockId": event.stock_id
      }
      data = JSON.stringify(data), 
      REQUEST.post(baseUrl + url, {
        data: data,
        header: {
          'content-type': 'application/json'
        }
      }).then((res) => {
        const {
          status,
          data
        } = res.data
        if (res.data.code === 0) {
          console.log(res)
        }
      })
    },
    statusStr(e){
      wx.showToast({
        icon: 'none',
        title: e.currentTarget.dataset.item,
        duration: 1500
      })
    },
  },
  observers:{
    // 'rowitem'(data){  // canvasUrl: 父组件传递过来的值
    //   console.log(this.data.rowitem)
    // }
  },
  ready() { 
    console.log(this.data.rowitem)
  },
  pageLifetimes: {
  },
})