Component({
  /**
   * 组件的属性列表
   */
  properties: {
    styleData: String,
    navInfo: String
  },
  attached() {
    this.setNavSize();
  },
  data: {
    statusHeight: 20,
    menuBtnInfo: {},
  },
  methods: { // 通过获取系统信息计算导航栏高度
    setNavSize() {
      // 获取右上角的胶囊位置信息
      try {
        if(wx.getMenuButtonBoundingClientRect) {
          let t = wx.getMenuButtonBoundingClientRect()
          this.setData({
            menuBtnInfo: t
          })
          console.log('胶囊信息', t)
        } else {
          throw new Error('getMenuButtonBoundingClientRect error')
        }
      } catch (error) {
        this.getSystemInfo()
        console.log('微信版本太低，不支持获取胶囊的位置信息')
      }
      // 获取状态栏的高度
      try {
        let t = wx.getSystemInfoSync()
        this.data.statusBarHeight = t.statusBarHeight
        console.log('状态栏的高度', this.data.statusHeight)
      } catch (error) {
        console.log('微信版本太低，无法获取状态栏的高度')
      }
    },
    getSystemInfo() {
      // 获取用户的设备型号
      let that = this
      try {
        wx.getSystemInfo({
          success(res) {
            console.log(res)
            if (res.model.indexOf('iPhone X') != -1) {
              console.log('iPhone X手机')
              that.setData({
                menuBtnInfo: { top: 50, height: 32 }
              })
              return
            } else if(res.system.indexOf('iOS') != -1) {
              console.log(res.model + '手机', '苹果手机')
              that.setData({
                menuBtnInfo: { top: 26, height: 32 }
              })
              return
            } else {
              console.log(res.model + '手机', '安卓手机')
              that.setData({
                menuBtnInfo: { top: 28, height: 32 }
              })
            }
          }
        })
      } catch (error) {
        console.log('微信版本太低，无法获取设备型号')
      }
    },
    search() {
      wx.navigateTo({
        url: '../Search/Search',
      })
    }
  }
})