// components/waterfallFlow/waterfallFlow.js
import API from '../../api/index'
Component({
  /**
   * 组件的属性列表
   */
  properties: {
    // currentIndex: {
    //   type: Number,
    //   value: 1,
    // },
    colCount: { //默认一行两个
      type: Number,
      value: 2
    },
    imgWidth: { //单张图片的宽度
      type: Number,
      value: 348
    },
    spacing: { //上下间距
      type: Number,
      value: 16
    },
    classifyData:{
      type: Object,
      value: {}
    },
    isOnReachBottom: Number,
    recommendHeight: Number,
    proportion: Number
  },

  /**
   * 组件的初始数据
   */
  data: {
    pageData:[], //原始数据,按分页获取
    dataList:[], //瀑布流前,整合后,按分页获取
    collist: [ //瀑布流
      [],
      []
    ],
    col1H: 0,
    col2H: 0,
    loadingCount: 0,
    loginType: 1, // 1手机号授权，2用户信息授权
    isLogin: false,
    noResultData: {
      'imgUrl': 'https://img.wgmf.com/contentmp/img_biji.png',
      'message': '没有相关的内容哦~'
    },
    loading: false,
    canPullDownRefresh: true, // 是否可以上拉下一页
    curPage: 0,
  },
  observers: {
    'isOnReachBottom': function(val) {
      // 可以加载下一页且现在没有正在加载的数据
      if(this.data.canPullDownRefresh && !this.data.loading) {
        this.setData({
          curPage: this.data.curPage + 1,
          loading: true,
        })
        this.getListByPage()
      }
    },
    // 'currentIndex': function(val) {
    //   // 切换页签
    //   this.setData({
    //     curPage: 1,
    //     loading: true,
    //   })
    //   this.getListByPage()
    // },
  },
  /**
   * 组件的方法列表
   */
  methods: {
    // getImageInfoFn(imgUrl,item, type){
    //   let that = this
    //     // wx.request({
    //     //   url: imgUrl+'?imageInfo',
    //     //   header: {'content-type': 'application/json' },
    //     //   method: 'GET',
    //     //   success: function (res) {
    //     //     // 图片高度 + 内边距12 + 文字高度140
    //     //     item.height = res.data.height * (that.data.imgWidth/res.data.width) + 22 + (type=="advertisingList" ? 0 : 140)
    //     //     isGetImgInfo--
    //     //     if(isGetImgInfo <= 0){
    //     //       that.rewriteLayout()
    //     //     }
    //     //   },
    //     //   fail: function (err) {
    //     //     item.height = 348 + 22 + 140 // 默认高度
    //     //     isGetImgInfo--
    //     //     if(isGetImgInfo <= 0){
    //     //       that.rewriteLayout()
    //     //     }
    //     //     console.log(err,imgUrl )
    //     //   }
    //     // })
    //     wx.getImageInfo({
    //       src: imgUrl,
    //       success (res) {
    //         // 图片高度 + 内边距12 + 文字高度140
    //         item.height = res.height * (that.data.imgWidth/res.width) + 22 + (type=="advertisingList" ? 0 : 140)
    //         isGetImgInfo--
    //         if(isGetImgInfo <= 0){
    //           that.rewriteLayout()
    //         }
    //       },
    //       fail: function (err) {
    //         item.height = 348 + 22 + 140 // 默认高度
    //         isGetImgInfo--
    //         if(isGetImgInfo <= 0){
    //           that.rewriteLayout()
    //         }
    //         console.log(err,imgUrl )
    //       }
    //     })
    // },
    // 整合数组 
    integrationList(){
      let that = this
      let arr = JSON.parse(JSON.stringify(this.data.pageData.productList))
      let advertisingList = JSON.parse(JSON.stringify(this.data.pageData.advertisingList))
      let isGetImgInfo = this.data.pageData.productList.length + this.data.pageData.advertisingList.length
      arr.map(item=>{
        item.pImage = item.pImage || 'https://img.wgmf.com/img_home_banner_default.png'
        if(item.pImage.search(/^http:\/\/7xqiu3.com1.z0.glb.clouddn.com/) != -1 ){
          item.pImage =  'https://img.wgmf.com/img_home_banner_default.png'
        }

        item.pImage = item.pImage.replace(/^http:/i,"https:")
        // this.getImageInfoFn(item.pImage, item, 'productList')
        wx.getImageInfo({
          src: item.pImage+'?imageslim',
          success (res) {
            // 图片高度 + 内边距12 + 文字高度140
            item.height = res.height * (that.data.imgWidth/res.width) + 22 + 140
            isGetImgInfo--
            if(isGetImgInfo <= 0){
              that.rewriteLayout()
            }
          },
          fail: function (err) {
            item.height = 348 + 22 + 140 // 默认高度
            isGetImgInfo--
            if(isGetImgInfo <= 0){
              that.rewriteLayout()
            }
            console.log(err,item.pImage )
          }
        })
      })
      if(advertisingList && advertisingList.length > 0){
        advertisingList.map((item)=>{
          item.advertisingImgList[0].imgUrl = item.advertisingImgList[0].imgUrl || 'https://img.wgmf.com/img_home_banner_default.png'
          if(item.advertisingImgList[0].imgUrl.search(/^http:\/\/7xqiu3.com1.z0.glb.clouddn.com/) != -1 ){
            item.advertisingImgList[0].imgUrl = 'https://img.wgmf.com/img_home_banner_default.png'
          }
          item.advertisingImgList[0].imgUrl = item.advertisingImgList[0].imgUrl.replace(/^http:/i,"https:")
          item.carouselIntervalMs=item.carouselInterval*1000
          // this.getImageInfoFn(item.advertisingImgList[0].imgUrl, item, 'advertisingList')
          wx.getImageInfo({
            src: item.advertisingImgList[0].imgUrl+'?imageslim',
            success (res) {
              item.height = res.height * (that.data.imgWidth/res.width) + 22
              isGetImgInfo--
              if(isGetImgInfo <= 0){
                that.rewriteLayout()
              }
            },fail: function (err) {
              console.log(err,item.advertisingImgList[0].imgUrl )
              item.height = 534 + 22  // 默认高度
              isGetImgInfo--
              if(isGetImgInfo <= 0){
                that.rewriteLayout()
              }
            }
          })
          item.advertisingImgList.map(i=>{
            i.link = i.imgSkipUrl
          })
          item.link = item.imgSkipUrl
          arr.splice(item.launchLocation+9-this.data.curPage*10, 0, item) //排序按页数累加且从1开始，所以第一页要减去 (页数-1)*10
        })
      }
      this.setData({
        dataList: arr,
      })
    },
    // 计算瀑布流
    rewriteLayout(){
      let collist = this.data.collist;
      this.data.dataList.map((item, index) => {
        if (this.data.col1H <= this.data.col2H) {
          this.setData({
            col1H: item.height + this.data.col1H + this.data.spacing
          });
          collist[0].push(item);
        } else {
          this.setData({
            col2H: item.height + this.data.col2H + this.data.spacing
          });
          collist[1].push(item);
        }
      })
      let data = {
        collist: collist,
        loading: false
      };
      this.setData(data);
      // // 重新获取高度，否则计算不准确
      // const query = wx.createSelectorQuery().in(this)
      // let that = this
      // query.select('.waterfall-center-0')
      // .boundingClientRect(function(res){
      //   if(res){
      //     that.setData({
      //       col1H: res.height * that.data.proportion
      //     });
      //   }
      // }).exec()
      // query.select('.waterfall-center-1')
      // .boundingClientRect(function(res){
      //   if(res){
      //     that.setData({
      //       col2H: res.height * that.data.proportion
      //     });
      //   }
      // }).exec()
    },
    getListByPage(){
      let params = {
        classifyId: this.data.classifyData.id, 
        pageNum: this.data.curPage, 
      }
      API.modules.queryProductByClassId(params).then(res=>{
        if(res) {
          if(res.productList.length == 0 && res.advertisingList.length == 0){
            this.setData({
              loading: false,
            })
          }
          this.setData({
            pageData: res,
            canPullDownRefresh: (res.advertisingList.length + res.productList.length) >= 10 ? true: false, //是否存在下一页
          })
          this.integrationList()
        }
      }).catch(err=>{
        this.setData({
          loading: false,
        })
      })
    },
    toDetail(e) {
      let pId = e.currentTarget.dataset.item.pId
      wx.navigateTo({ url: '/pages/ProductDetail/ProductDetail?pId=' + pId })
    },
  }
})