import { WGHTTP,WGTRACK } from '../../../wgUtils/index'

export default {
  /**
   * @param { evaluationTag, curPage, pageSize }
   */
  fanCommentList: data => { // 谷粉说首页/根据笔记分类查询评价
    return WGHTTP.get('wechat-shop-back/evaluation/fansList', data)
  },
  postComment: data => { // 谷粉说-发帖子
    return WGHTTP.post('wechat-shop-back/evaluation/confirm', data)
  },
  /**
   * @param { ratingDesc, curPage, pageSize }
   */
  searchComment: data => { // 根据评价内容模糊查找评价信息列表
    return WGHTTP.get('wechat-shop-back/evaluation/search', data)
  },
  /**
   * @param { productTemplateId, curPage, pageSize }
   */
  searchCommentByPId: data => { // 根据产品pid查找评论信息列表
    return WGHTTP.get('wechat-shop-back/evaluation/listByProductId', data)
  },
  getEvaTagList: () => { // 查找笔记分类列表
    return WGHTTP.get('wechat-shop-back/evaluation/getEvaTagList')
  },
  /**
   * @param evaId
  */
  getProducts: evaId => { /** 查找该评论关联的产品 */
    return WGHTTP.get('wechat-shop-back/evaluation/getProductByEvaId', { evaId: evaId })
  },
  browse: evaId => { // 浏览
    return WGHTTP.get('wechat-shop-back/evaluation/browse', { evaId: evaId })
  },
  thumdUp: data => { // 点赞
    return WGHTTP.get('wechat-shop-back/evaluation/thumdUp', data)
  },
  getPageById: id => {
    return WGHTTP.post('wechat-shop-back/miniApp/getHomePageById?id=' + id)
  },
  replyNewEvaluation: data => {
    return WGHTTP.post('wechat-shop-back/evaluation/replyNewEvaluation', data)
  },
  getReplyByEvaId: data => {
    return WGHTTP.get('wechat-shop-back/evaluation/getReplyByEvaId', data)
  },
  // 是否参与过谷粉说送积分活动
  queryUserActStatus: () => {
    return WGHTTP.post(`sygj-ewx/customerInformation/queryUserActStatus?mobile=${wx.getStorageSync('phone')}&unionId=${wx.getStorageSync('unionId')}&type=221`)
  },
  // experienceFlag 1.获取社区首页2.获取营养百科3.获取谷粉说4.试用报告
  // sortNum 排序，最新排序0推荐排序1
  // evaluationTagId 分类id
  /**
   * @data { experienceFlag, curPage, sortNum, evaluationTagId }
   */
  getEvaListByFlag: data => {
    let queryStr = ''
    for(let key in data) {
      if(data[key] != null) {
        queryStr += `${key}=${data[key]}&`
      }
    }
    return WGHTTP.get(`wechat-shop-back/evaluation/getEvaListByFlag?${queryStr}pageSize=10`)
  },
  /** 根据展示区域获取分类标签列表
   * displayAreaA (integer, optional): 展示区域：社区首页0否1是 ,
    displayAreaB (integer, optional): 展示区域：营养百科0否1是 ,
    displayAreaC (integer, optional): 展示区域：谷粉超话0否1是 ,
   */
  getTagListByDisplayArea: (displayAreaA, displayAreaB, displayAreaC) => WGHTTP.get(`wechat-shop-back/evaluation/getTagListByDisplayArea?displayAreaA=${displayAreaA}&displayAreaB=${displayAreaB}&displayAreaC=${displayAreaC}`),
  /**
   * @data { ratingDesc,experienceFlag,curPage,pageSize }
   */
  search: data => {
    let queryStr = ''
    for(let key in data) {
      if(data[key] != null) {
        queryStr += `${key}=${data[key]}&`
      }
    }
    return WGHTTP.get(`wechat-shop-back/evaluation/search?${queryStr}`)
  },
  /** 分享+1 */
  share: (evaId) => {
    // 发送分享埋点 evaluationShare 带参数谷粉说id
    WGTRACK.logCustomEvent('evaluationShare', evaId)
    return WGHTTP.get(`wechat-shop-back/evaluation/share?evaId=${evaId}`)
  }, 
  
  // 猜你喜欢
  getLikeByEvaId: evaId => WGHTTP.get(`wechat-shop-back/evaluation/getLikeByEvaId?evaId=${evaId}`),
  get_newEvaMessageRemind: (miniOpenId) => {
    // 浏览
    return WGHTTP.get("wechat-shop-back/evaluation/getNewEvaMessageRemind", {
      miniOpenId: miniOpenId,
    });
  }, //根据小程序openId获取新评论点赞提示 2021-9-9

  get_newEvaMessage: (data) => {
    // 点赞
    return WGHTTP.get("wechat-shop-back/evaluation/getNewEvaMessage", data);
  }, //根据小程序openId获取新评论点赞列表列表 2021-9-9
  get_getEvaListByCusId: (data) => {
    return WGHTTP.get("wechat-shop-back/evaluation/getEvaListByCusId", data);
  }, // 获取个人笔记 2022-03-21
  getSendPoint: customerId => WGHTTP.get(`wechat-shop-back/evaluation/sendPoint?customerId=${customerId}`),
   //发积分 2021-9-9
}