// components/Banner/Banner.js
import { WGROUTER } from "../../../../wgUtils/index"
import HELPER from "../../utils/helper"
import ROUTER from "../../utils/fanCommunityRouter"
Component({
  /**
   * 组件的属性列表
   */
  properties: {
    bannerInfoArray: Array,
  },

  /**
   * 组件的初始数据
   */
  data: {},

  /**
   * 组件的方法列表
   */
  methods: {
    tapSwiperItem(event) {
      let targetRouter =
        event.currentTarget.dataset.currentItem.carouselImagelLink;
      const params = HELPER.getParamsOfUrl(targetRouter);
      const linkType = params.linkType;
      switch (Number(linkType)) {
        case 0:
        case 1:
          {
            const accountInfo = wx.getAccountInfoSync();
            if(accountInfo.miniProgram.appId === params.appid) {
              //内容小程序内部跳转
              let array1 = targetRouter.split('?');
              let array2 = array1[0].split('/');
              WGROUTER.linkToPage(array2[array2.length - 1], `?${array1[array1.length - 1]}`);
            } else {
              //跳转其他小程序
              wx.navigateToMiniProgram({
                appId: params.appid,
                path: targetRouter,
                extraData: {
                  foo: "bar",
                },
                envVersion: "release",
                success(res) {
                  // 打开成功
                },
              });
            }
          }
          break;
        case 2:
          {
            //跳转H5网页
            const router = `${ROUTER.router_web_entry}?targetWebUrl=${targetRouter}`;
            WGROUTER.navigateTo(router);
          }
          break;
        default:
          break;
      }
    },
  },
});
