import API from '../../api/index'
import { WGCOMMON, WGFORMAT, WGENV,WGSUBSCRIBE,WGTRACK, WGAUTH } from '../../../../wgUtils/index'
import { REQUEST } from '../../../../utils/index'
Component({
  properties: {
    evaId: null, // 笔记id
    replyNumber: {
      type: Number,
      value: 0
    }, // 评论数
  },
  data: {
    canIUseGetUserProfile: false,
    hideTextarea: true, // 是否隐藏评论输入的文本框
    focusTextarea: false, // 是否自动聚集输入文本框
    textareaText: '', // 评论文本框的输入内容
    textareaLen: 0, // 评论文本框输入长度
    textareaPlaceholder: '说点啥呢...', // 评论文本框信息提示

    curPage: 1, // 评论列表的当前页码
    discussArr: [], // 评论列表数组
    evaLevel: 1, // 一级评论传1，二级评论传2
    evaReplyId: 0, // evaLevel为1则传0,evaLevel为2则传评论id
    upLevelId: 0, // 一级评论id，无则传0

    showSubscribeTip: false,
    canLoadMore: true,
    myVipCusStatus: 0,
    firstInit: true,
  },
  onShow() {
    getApp().watch(this.watchBack)
  },
  methods: {
    pullUpKeyBoard() { // 拉起评论的输入键盘
      this.setData({
        hideTextarea: false
      }, () => {
        this.setData({
          focusTextarea: true
        })
      })
    },
    hideKeyboard() { // 隐藏评论输入的文本框
      this.setData({
        hideTextarea: true,
        focusTextarea: false,
      })
    },
    watchBack(showSubscribeGif) {
      console.log('showSubscribeGif--------', showSubscribeGif)
      this.setData({
        showSubscribeTip: showSubscribeGif
      })
    },
    sureSendComment() { // 点击发送评论
      let val = this.data.textareaText
      if (val.trim() == '') return false
      let _self = this
      WGCOMMON.showLoading()
      API.replyNewEvaluation({
        evaLevel: this.data.evaLevel, // 一级评论传1，二级评论传2
        evaReplyId: this.data.evaReplyId, // evaLevel为1则传0,evaLevel为2则传评论id
        upLevelId: this.data.upLevelId, // 一级评论id，无则传0
        evaluatorHeadImgUrl: wx.getStorageSync('avatarUrl'),
        evaluatorName: wx.getStorageSync('nickName'),
        miniOpenId: wx.getStorageSync('openId'),
        vipCusStatus: wx.getStorageSync('vipCusStatus') ? wx.getStorageSync('vipCusStatus') : 0,
        orderProductEvaluationId: this.data.evaId, // 谷粉说id
        ratingDesc: val,
        unionid: wx.getStorageSync('unionId'),
      }).then(res => {
        if(res) {
          this.setData({
            textareaText: '',
            textareaLen: 0,
            curPage: 1,
            showSubscribeTip: true,
            canLoadMore: true
          })
          this.hideKeyboard()
          this.getReplyByEvaId()
          this.toComment()
          this.triggerEvent('postcommentsuccess')
          WGSUBSCRIBE('gufenComment').then((res) => {
            console.log(res)
            _self.setData({
              showSubscribeTip: false
            })
          }).catch(() => {
            _self.setData({
              showSubscribeTip: false
            })
          })
          if(this.data.evaLevel == 1) {
            // 发送评论埋点 sureSendComment 带参数谷粉说id
            WGTRACK.logCustomEvent('sureSendComment',this.data.evaId)
          }
          WGCOMMON.toast('评论发布成功！', 2000)
        }
        WGCOMMON.hideLoading()
      }).catch(() => {
        WGCOMMON.hideLoading()
      })
    },
    getMoreEval() { // 加载下一页评论
      this.setData({
        curPage: this.data.curPage + 1
      })
      this.getReplyByEvaId()
    },
    getReplyByEvaId() { // 获取该谷粉说的评论信息列表
      if(this.data.evaId) {
        API.getReplyByEvaId({
          evaId: this.data.evaId,
          curPage: this.data.curPage,
          pageSize: 10
        }).then(res => {
          if (res.length < 10) {
            this.setData({
              canLoadMore: false
            })
          }
          for (let i = 0; i < res.length; i++) {
            res[i].firstEvaluationReply['formatDate'] = WGFORMAT.formatDateToChineseDesc(res[i].firstEvaluationReply.createDate)
            res[i].firstEvaluationReply['formatThumbUpNumber'] = WGFORMAT.formatNumber(res[i].firstEvaluationReply.thumbUpNumber)
            res[i].firstEvaluationReply['isLiked'] = false
            res[i].secondMaxIndex = 2 // 二级评论初始以2条显示，显示更多以+5叠加
            let secondEvaluationReply = res[i].secondEvaluationReply
            for (let j = 0; j < secondEvaluationReply.length; j++) {
              res[i].secondEvaluationReply[j]['formatDate'] = WGFORMAT.formatDateToChineseDesc(secondEvaluationReply[j].createDate)
              res[i].secondEvaluationReply[j]['formatThumbUpNumber'] = WGFORMAT.formatNumber(secondEvaluationReply[j].thumbUpNumber)
              res[i].secondEvaluationReply[j]['isLiked'] = false
            }
          }
          let arr = (this.data.curPage == 1)?[]:this.data.discussArr
          arr.push(...res)
          this.setData({
            discussArr: arr
          })
        })
      }
    },
    toComment() { // 点击评论页面跳到评论区域
      this.setData({
        intoView: 'comment'
      })
    },
    firstReply() { // 发表一级评论---点击文本框输入区域
      this.setData({
        evaLevel: 1, // 一级评论传1，二级评论传2
        evaReplyId: 0,
        textareaPlaceholder: '说点啥呢...',
        upLevelId: 0,
      })
      this.pullUpKeyBoard()
    },
    secondReply(e) { // 发表二级评论---点击已有评论
      this.setData({
        evaLevel: 2, // 一级评论传1，二级评论传2
        evaReplyId: e.currentTarget.dataset.id,
        textareaPlaceholder: '回复 ' + e.currentTarget.dataset.authorname + '：',
        upLevelId: e.currentTarget.dataset.firstid
      })
      this.pullUpKeyBoard()
    },
    bindinput(e) { // 评论文本框输入
      this.setData({
        textareaLen: e.detail.value.length,
        textareaText: e.detail.value
      })
    },
    showMoreSecondReply(e) { // 展开更多二级评论回复
      let pindex = e.currentTarget.dataset.pindex,
        key = 'discussArr[' + pindex + '].secondMaxIndex',
        oldVal = this.data.discussArr[pindex].secondMaxIndex
      this.setData({
        [key]: oldVal + 5
      })
    },
    clickThump(e) { // 点赞：0点赞谷粉说  3点赞一级评论 4点赞二级评论
      let type = parseInt(e.currentTarget.dataset.type)
      console.log('this.clickThump', type)
      if (type == 0) { // 点赞谷粉说
        if (wx.getStorageSync('openId') && wx.getStorageSync('unionId')) {
          console.log('clickThump' + this.data.evaId)
          REQUEST.get(WGENV.baseUrl + 'wechat-shop-back/evaluation/thumdUp', {
            data: {
              evaId: this.data.evaId,
              unionid: wx.getStorageSync('unionId'),
              miniOpenId: wx.getStorageSync('openId'),
              isThumdUpFlag: this.data.isLike ? 1 : 0, // 点赞0取消点赞1状态2
              evaReplyId: 0,
            }
          }).then(res => {
            // 点赞谷粉说埋点 clickThump 带参数谷粉说id
            console.log('clickThump' + this.data.evaId)
            WGTRACK.logCustomEvent('clickThump',this.data.evaId)
            this.setData({
              isLike: !this.data.isLike
            })
          })
        }
      } else if (type == 3) { // 点赞一级评论
        let replyId = e.currentTarget.dataset.id, // 一级评论的id
          index = e.currentTarget.dataset.index, // 一级评论的index
          oldVal = this.data.discussArr[index].firstEvaluationReply.isLiked, // 当前评论的点赞状态 true红色  false非红色
          oldThumpNumer = this.data.discussArr[index].firstEvaluationReply.thumbUpNumber, // 当前评论的点赞数量
          key1 = 'discussArr[' + index + '].firstEvaluationReply.isLiked', // 点赞状态的key值
          key2 = 'discussArr[' + index + '].firstEvaluationReply.formatThumbUpNumber', // 点赞数量的key值
          key3 = 'discussArr[' + index + '].firstEvaluationReply.thumbUpNumber'
        this.getReplyLikeStatus(replyId).then(res => {
          oldVal = (res == 0) ? false : true
          this.setData({
            [key1]: !oldVal,
            [key2]: WGFORMAT.formatNumber(oldVal ? oldThumpNumer - 1 : oldThumpNumer + 1),
            [key3]: oldVal ? oldThumpNumer - 1 : oldThumpNumer + 1
          })
          this.likeReply(replyId, oldVal ? 1 : 0) // 点赞0 取消点赞1 查询2
        })
      } else { // 点赞二级评论
        let replyId = e.currentTarget.dataset.id, // 二级评论的id
          pindex = e.currentTarget.dataset.pindex, // 一级评论的index
          cindex = e.currentTarget.dataset.cindex, // 二级评论的index
          oldVal = this.data.discussArr[pindex].secondEvaluationReply[cindex].isLiked, // 当前评论的点赞状态
          oldThumpNumer = this.data.discussArr[pindex].secondEvaluationReply[cindex].thumbUpNumber, // 当前评论的点赞数量
          key1 = 'discussArr[' + pindex + '].secondEvaluationReply[' + cindex + '].isLiked', // 点赞状态的key值
          key2 = 'discussArr[' + pindex + '].secondEvaluationReply[' + cindex + '].formatThumbUpNumber', // 点赞数量的key值
          key3 = 'discussArr[' + pindex + '].secondEvaluationReply[' + cindex + '].thumbUpNumber'
        this.getReplyLikeStatus(replyId).then(res => {
          oldVal = (res == 0) ? false : true
          this.setData({
            [key1]: !oldVal,
            [key2]: WGFORMAT.formatNumber(oldVal ? oldThumpNumer - 1 : oldThumpNumer + 1),
            [key3]: oldVal ? oldThumpNumer - 1 : oldThumpNumer + 1
          })
          this.likeReply(replyId, oldVal ? 1 : 0) // 点赞0 取消点赞1 查询2
        })
      }
    },
    getReplyLikeStatus(replyId) { // 获取评论的点赞状态
      return new Promise((resolve, reject) => {
        REQUEST.get(WGENV.baseUrl + 'wechat-shop-back/evaluation/thumdUp', {
          data: {
            evaId: 0,
            unionid: wx.getStorageSync('unionId'),
            miniOpenId: wx.getStorageSync('openId'),
            isThumdUpFlag: 2, // 点赞0取消点赞1状态2
            evaReplyId: replyId,
          }
        }).then(res => {
          resolve(res.data.status)
        })
      })
    },
    likeReply(replyId) { // 点赞评论
      this.getReplyLikeStatus(replyId).then(res => {
        let val = (res == 0) ? 0 : 1
        REQUEST.get(WGENV.baseUrl + 'wechat-shop-back/evaluation/thumdUp', {
          data: {
            evaId: 0,
            unionid: wx.getStorageSync('unionId'),
            miniOpenId: wx.getStorageSync('openId'),
            isThumdUpFlag: val, // 点赞0取消点赞1状态2
            evaReplyId: replyId,
          }
        }).then(res => {
        })
      })
    },
    getUserProfile(e) {
      let type = parseInt(e.currentTarget.dataset.type)
      WGAUTH.getUserProfile().then(() => {
        if (type == 1) { // 发表一级评论
          this.firstReply(e)
        } else if (type == 2) { // 发表二级评论
          this.secondReply(e)
        } else if (type == 0) { // 点赞谷粉说
          this.clickThump(e)
        } else { // 点赞评论
          this.clickThump(e)
        }
        this.setData({
          needLogin: false,
          myAvatarUrl: wx.getStorageSync('avatarUrl') ? wx.getStorageSync('avatarUrl') : 'https://img.wgmf.com/img_default1.png',
          myVipCusStatus: wx.getStorageSync('vipCusStatus') ? wx.getStorageSync('vipCusStatus') : 0,
          myOpenId: wx.getStorageSync('openId') ? wx.getStorageSync('openId') : ''
        })
      })
    },
    bindgetuserinfo(e) { // 用户信息授权：0点赞谷粉说需要授权  1一级评论需要授权  2二级评论需要授权  3点赞一级评论需要授权  4点赞二级评论需要授权
      let type = parseInt(e.currentTarget.dataset.type)
      WGAUTH.getUserInfo(e).then(res => {
        if (type == 1) { // 发表一级评论
          this.firstReply(e)
        } else if (type == 2) { // 发表二级评论
          this.secondReply(e)
        } else if (type == 0) { // 点赞谷粉说
          this.clickThump(e)
        } else { // 点赞评论
          this.clickThump(e)
        }
        this.setData({
          needLogin: false,
          myAvatarUrl: wx.getStorageSync('avatarUrl') ? wx.getStorageSync('avatarUrl') : 'https://img.wgmf.com/img_default1.png',
          myVipCusStatus: wx.getStorageSync('vipCusStatus') ? wx.getStorageSync('vipCusStatus') : 0,
          myOpenId: wx.getStorageSync('openId') ? wx.getStorageSync('openId') : ''
        })
      })
    },
  },
  lifetimes: {
    attached: function() { // 在组件实例进入页面节点树时执行
    },
  },
  pageLifetimes: {
    show() {
      if(this.data.firstInit && this.data.evaId) {
        this.getReplyByEvaId() // 初始化评论信息
        this.data.firstInit = false
      }
      this.setData({
        needLogin: (wx.getStorageSync('openId') && wx.getStorageSync('unionId') && wx.getStorageSync('nickName') && wx.getStorageSync('avatarUrl'))?false:true,
        myAvatarUrl: wx.getStorageSync('avatarUrl') ? wx.getStorageSync('avatarUrl') : 'https://img.wgmf.com/img_default1.png',
        myVipCusStatus: wx.getStorageSync('vipCusStatus') ? wx.getStorageSync('vipCusStatus') : 0,
        myOpenId: wx.getStorageSync('openId') ? wx.getStorageSync('openId') : ''
      })
      if (wx.getUserProfile) {
        this.setData({
          canIUseGetUserProfile: true
        })
      }
    }
  },
})