import { WGFORMAT, WGROUTER, WGENV, WGCOMMON } from "../../../../wgUtils/index"
import { REQUEST } from '../../../../utils/index'

Component({
  properties: {
    contentData: Object,
  },
  data: {
    showAuth: false // 显示授权登录面板
  },
  methods: {
    tapToGiveLike() { // 点击点赞
      if (this.checkAuthPhoneNumber()) {
        let tmp = this.data.contentData
        let key1 = 'contentData.isLike'
        let key2 = 'contentData.thumbUpNumberCn'
        REQUEST.get(WGENV.baseUrl + 'wechat-shop-back/evaluation/thumdUp', { // 查看用户是否已经点赞
          data: {
            isThumdUpFlag: 2,
            evaId: tmp.id,
            unionid: wx.getStorageSync('unionId'),
            miniOpenId: wx.getStorageSync('openId'),
          }
        }).then(res => {
          if (res.data.status == 1) { // 已经点赞过
            this.setData({
              [key1]: true
            })
            WGCOMMON.toast('您已经点过赞了', 1000)
          } else { // 还未点赞过
            REQUEST.get(WGENV.baseUrl + 'wechat-shop-back/evaluation/thumdUp', {
              data: {
                evaId: tmp.id,
                unionid: wx.getStorageSync('unionId'),
                miniOpenId: wx.getStorageSync('openId'),
                isThumdUpFlag: 0 // 点赞0  取消点赞1  状态2
              }
            }).then(res => {
              this.setData({
                [key1]: true,
                [key2]: WGFORMAT.formatNumber(tmp.thumbUpNumber + 1 + tmp.virtualThumbUpNumber)
              })
            })
          }
        })
      }
    },
    checkAuthPhoneNumber() {
      if(wx.getStorageSync('unionId') && wx.getStorageSync('openId')) { // 有登录信息
        this.setData({
          showAuth: false
        })
        return true
      } else { // 无登录信息
        this.setData({
          showAuth: true
        })
        return false
      }
    },
    authSuccess() {
      this.setData({showAuth: false})
      this.tapToGiveLike() //记录点赞
    },
    authFail() {
      this.setData({showAuth: false})
    },
    tapToCheckDetailContent() {
      if(this.data.contentData.experienceFlag == 4) {
        WGROUTER.navigateTo('/modules/FanCommunity/pages/ContentDetail/ContentDetail?id=' + this.data.contentData.id)
      } else {
        WGROUTER.navigateTo('/modules/FanCommunity/pages/CommentDetail/CommentDetail?id=' + this.data.contentData.id)
      }
    }
  },
  lifetimes: {
    attached: function () {
    }
  }
})
