// components/MenuView/MenuView.js
Component({
  /**
   * 组件的属性列表
   */
  properties: {
    menuInfo : {
      type: Array,
      value: []
    }
  },

  /**
   * 组件的初始数据
   */
  data: {
    selectedMenuIndex: 1,
    toView : 'item0',
    showingMenu : true,
    menuIconSrc : 'https://img.wgmf.com/ma-shop/ic_xiala.png'
  },
  
  /**
   * 组件的方法列表
   */
  methods: {
    //选择更多菜单
    tapToSelectMoreMenu (e){
      const showingMenu = false
      const menuIconSrc = 'https://img.wgmf.com/ma-shop/ic_xiala.png'
      this.setData({ showingMenu, menuIconSrc })

      if (e.target.dataset.currentIndex !== this.data.selectedMenuIndex) {
        const selectedMenuIndex = e.target.dataset.currentIndex
        const toView = `item-${e.target.dataset.currentIndex}`
        this.setData({ selectedMenuIndex, toView })
        if(selectedMenuIndex < 2) {
          this.triggerEvent('selectMenuEvent', selectedMenuIndex)
          return
        }
        this.triggerEvent('selectMenuEvent', this.properties.menuInfo[selectedMenuIndex - 2])
      }
    },
    //查看更多菜单
    tapToShowMoreMunu () {
      const showingMenu = !this.data.showingMenu
      const menuIconSrc = showingMenu ? 'https://img.wgmf.com/ma-shop/ic_xiala_1.png' : 'https://img.wgmf.com/ma-shop/ic_xiala.png'
      this.setData({ showingMenu, menuIconSrc })
    },
    // 选择菜单
    selectCurrentMunu: function (event) {
      if (event.target.dataset.currentIndex !== this.data.selectedMenuIndex) {
        const selectedMenuIndex = event.target.dataset.currentIndex
        this.setData({ selectedMenuIndex })
        if(selectedMenuIndex < 2) {
          this.triggerEvent('selectMenuEvent', selectedMenuIndex)
          return
        }
        this.triggerEvent('selectMenuEvent', this.properties.menuInfo[selectedMenuIndex - 2])
      }
    }
  },
  lifetimes: {
    attached: function () {
      setTimeout(()=>{
        this.setData({
          showingMenu: false,
        })
      },3000)
    }
  }
})
