import {
  REQUEST,
  LOADING,
} from '../../../../utils/index'
import {
  WGFORMAT,
  WGAUTH,
  WGENV,
  WGCOMMON,
  WGTRACK,
  Page
} from '../../../../wgUtils/index'

import API from '../../api/index'

Page({
  data: {
    id: null, // 谷粉说id
    comment: null, // 谷粉说内容

    bannerHeight: 350, // 轮播图高度
    currentIndex: 1, // 轮播图的指示点index
    totalImgsLen: 1, // 轮播图指示点数量

    products: [], // 产品 

    isLike: false, // 是否点赞了这条谷粉说
    needLogin: false, // 是否需要用户信息授权

    textareaLen: 0, // 评论文本框输入长度
    textareaText: '', // 评论文本框内容
    textareaPlaceholder: '说点啥呢...', // 评论文本框信息提示
    hideTextarea: true, // 评论文本框隐藏
    focusTextarea: false, // 聚焦评论文本框

    curPage: 1, // 评论列表的当前页码
    discussArr: [], // 评论列表数组
    evaLevel: 1, // 一级评论传1，二级评论传2
    evaReplyId: 0, // evaLevel为1则传0,evaLevel为2则传评论id
    upLevelId: 0, // 一级评论id，无则传0

    canLoadMore: true,

    myVipCusStatus: 0,
    canIUseGetUserProfile: false,
    canShare: true,
  },
  loadImg(e) { // 轮播图加载，获取图片高度，设置banner高度
    var imgh = e.detail.height;　　　　　　　　　　　　　　　　 //图片高度
    var imgw = e.detail.width;
    let index = e.currentTarget.dataset.index
    if (this.data.bannerHeight == 350 && index == 0) {
      this.setData({
        bannerHeight: (imgh / imgw) * 750 > 1000 ? 1000 : (imgh / imgw) * 750
      })
    }
  },
  changeSwiper(e) { // 切换轮播图的index
    this.setData({
      currentIndex: e.detail.current + 1
    })
  },
  preview(e) { // 预览轮播图图片
    let index = e.currentTarget.dataset.index
    let originImgs = this.data.comment.evaluationImages
    let imgs = []
    for (let i = 0; i < originImgs.length; i++) {
      imgs.push(originImgs[i].imgUrl)
    }
    wx.previewImage({
      current: imgs[index], // 当前显示图片的http链接
      urls: imgs // 需要预览的图片http链接列表
    })
  },
  initTrialReport(id) { // 初始化谷粉说内容
    LOADING.show()
    REQUEST.get(WGENV.baseUrl + 'wechat-shop-back/evaluation/getByEvaId?evaId=' + id).then(r => {
      if (r.data.status === 0) {
        let res = r.data.data[0]
        let imgs = res.evaluationImages
        res['createDate'] = WGFORMAT.formatDate(res.createDate, 'yyyy-MM-dd')
        this.setData({
          totalImgsLen: imgs.length
        })
        imgs.sort(function(a, b) {
          if (a.sortingOrder - b.sortingOrder == 0) {
            return a.id - b.id
          }
          return a.sortingOrder - b.sortingOrder
        })
        res['evaluationImages'] = imgs
        this.setData({
          comment: res
        })
        console.log(this.data.comment.customerId)
      }
      LOADING.hide()
    })
  },
  getProductsList(id) { // 获取该谷粉说关联的产品
    API.getProducts(id).then(res => {
      this.setData({
        products: res
      })
    })
  },
  postCommentSuccess() {
    this.initTrialReport(this.data.id)
  },
  clickThump(e) { // 点赞：0点赞谷粉说  3点赞一级评论 4点赞二级评论
    let type = parseInt(e.currentTarget.dataset.type)
    if (type == 0) { // 点赞谷粉说
      if (wx.getStorageSync('openId') && wx.getStorageSync('unionId')) {
        REQUEST.get(WGENV.baseUrl + 'wechat-shop-back/evaluation/thumdUp', {
          data: {
            evaId: this.data.id,
            unionid: wx.getStorageSync('unionId'),
            miniOpenId: wx.getStorageSync('openId'),
            isThumdUpFlag: this.data.isLike ? 1 : 0, // 点赞0取消点赞1状态2
            evaReplyId: 0,
          }
        }).then(res => {
          console.log('clickThump' + this.data.id)
          WGTRACK.logCustomEvent('clickThump',this.data.id)
          this.setData({
            isLike: !this.data.isLike
          })
        })
      }
    } else if (type == 3) { // 点赞一级评论
      let replyId = e.currentTarget.dataset.id, // 一级评论的id
        index = e.currentTarget.dataset.index, // 一级评论的index
        oldVal = this.data.discussArr[index].firstEvaluationReply.isLiked, // 当前评论的点赞状态 true红色  false非红色
        oldThumpNumer = this.data.discussArr[index].firstEvaluationReply.thumbUpNumber, // 当前评论的点赞数量
        key1 = 'discussArr[' + index + '].firstEvaluationReply.isLiked', // 点赞状态的key值
        key2 = 'discussArr[' + index + '].firstEvaluationReply.formatThumbUpNumber', // 点赞数量的key值
        key3 = 'discussArr[' + index + '].firstEvaluationReply.thumbUpNumber'
      this.getReplyLikeStatus(replyId).then(res => {
        // 0未点赞  1已点赞
        // if(res == 1 && !oldVal) {
        //   // WGCOMMON.toast('您已经点赞过这条评论了', 1000)
        // }
        oldVal = (res == 0) ? false : true
        this.setData({
          [key1]: !oldVal,
          [key2]: WGFORMAT.formatNumber(oldVal ? oldThumpNumer - 1 : oldThumpNumer + 1),
          [key3]: oldVal ? oldThumpNumer - 1 : oldThumpNumer + 1
        })
        // 点赞0 取消点赞1 查询2
        this.likeReply(replyId, oldVal ? 1 : 0)
      })
    } else { // 点赞二级评论
      let replyId = e.currentTarget.dataset.id, // 二级评论的id
        pindex = e.currentTarget.dataset.pindex, // 一级评论的index
        cindex = e.currentTarget.dataset.cindex, // 二级评论的index
        oldVal = this.data.discussArr[pindex].secondEvaluationReply[cindex].isLiked, // 当前评论的点赞状态
        oldThumpNumer = this.data.discussArr[pindex].secondEvaluationReply[cindex].thumbUpNumber, // 当前评论的点赞数量
        key1 = 'discussArr[' + pindex + '].secondEvaluationReply[' + cindex + '].isLiked', // 点赞状态的key值
        key2 = 'discussArr[' + pindex + '].secondEvaluationReply[' + cindex + '].formatThumbUpNumber', // 点赞数量的key值
        key3 = 'discussArr[' + pindex + '].secondEvaluationReply[' + cindex + '].thumbUpNumber'
      this.getReplyLikeStatus(replyId).then(res => {
        // 0未点赞  1已点赞
        // if(res == 1 && !oldVal) {
        //   WGCOMMON.toast('您已经点赞过这条评论了', 1000)
        // }
        oldVal = (res == 0) ? false : true
        this.setData({
          [key1]: !oldVal,
          [key2]: WGFORMAT.formatNumber(oldVal ? oldThumpNumer - 1 : oldThumpNumer + 1),
          [key3]: oldVal ? oldThumpNumer - 1 : oldThumpNumer + 1
        })
        // 点赞0 取消点赞1 查询2
        this.likeReply(replyId, oldVal ? 1 : 0)
      })
      // this.setData({
      //   [key1]: !oldVal,
      //   [key2]: WGFORMAT.formatNumber(oldVal?oldThumpNumer - 1:oldThumpNumer + 1),
      //   [key3]: oldVal?oldThumpNumer - 1:oldThumpNumer + 1
      // })
      // // 点赞0 取消点赞1 查询2
      // this.likeReply(replyId, oldVal?1:0)
    }
  },
  getUserProfile(e) {
    let type = parseInt(e.currentTarget.dataset.type)
    WGAUTH.getUserProfile().then(() => {
      if (type == 1) { // 发表一级评论
        this.firstReply(e)
      } else if (type == 2) { // 发表二级评论
        this.secondReply(e)
      } else if (type == 0) { // 点赞谷粉说
        this.clickThump(e)
      } else { // 点赞评论
        this.clickThump(e)
      }
      this.setData({
        needLogin: false,
        myAvatarUrl: wx.getStorageSync('avatarUrl') ? wx.getStorageSync('avatarUrl') : 'https://img.wgmf.com/img_default1.png',
        myVipCusStatus: wx.getStorageSync('vipCusStatus') ? wx.getStorageSync('vipCusStatus') : 0,
        myOpenId: wx.getStorageSync('openId') ? wx.getStorageSync('openId') : ''
      })
    })
  },
  bindgetuserinfo(e) { // 用户信息授权：0点赞谷粉说需要授权  1一级评论需要授权  2二级评论需要授权  3点赞一级评论需要授权  4点赞二级评论需要授权
    let type = parseInt(e.currentTarget.dataset.type)
    WGAUTH.getUserInfo(e).then(res => {
      if (type == 1) { // 发表一级评论
        this.firstReply(e)
      } else if (type == 2) { // 发表二级评论
        this.secondReply(e)
      } else if (type == 0) { // 点赞谷粉说
        this.clickThump(e)
      } else { // 点赞评论
        this.clickThump(e)
      }
      this.setData({
        needLogin: false,
        myAvatarUrl: wx.getStorageSync('avatarUrl') ? wx.getStorageSync('avatarUrl') : 'https://img.wgmf.com/img_default1.png',
        myVipCusStatus: wx.getStorageSync('vipCusStatus') ? wx.getStorageSync('vipCusStatus') : 0,
        myOpenId: wx.getStorageSync('openId') ? wx.getStorageSync('openId') : ''
      })
    })
  },
  getPageQuery() {
    let str = ''
    let obj = this.data.option
    for(let key in obj) {
      str += `${key}=${obj[key]}&`
    }
    return str
  },
  onLoad(option) {
    let cusId = wx.getStorageSync('cusId')
    this.data.option = option
    // 735353475 13686432019 龙素平
    // 733621538 15986746847 李文婷
    if((cusId && option.noShare && ['735353475', '733621538'].indexOf(cusId) == -1) || (!cusId && option.noShare)) { // 禁止转发分享
      wx.hideShareMenu()
      this.setData({ canShare: false })
      wx.updateShareMenu({
        withShareTicket: true,
        isPrivateMessage: true,
      })
    } 
    if (wx.getUserProfile) {
      this.setData({
        canIUseGetUserProfile: true
      })
    }
    // 如果已登录则获取点赞信息
    if (wx.getStorageSync('openId') && wx.getStorageSync('unionId') && wx.getStorageSync('nickName') && wx.getStorageSync('avatarUrl')) {
      REQUEST.get(WGENV.baseUrl + 'wechat-shop-back/evaluation/thumdUp', {
        data: {
          evaReplyId: 0,
          isThumdUpFlag: 2,
          evaId: option.id,
          unionid: wx.getStorageSync('unionId'),
          miniOpenId: wx.getStorageSync('openId'),
        }
      }).then(res => {
        if (res.data.status == 1) {
          this.setData({
            isLike: true
          })
        }
      })
    } else {
      this.setData({
        needLogin: true
      })
    }
    this.setData({
      id: option.id,
      myAvatarUrl: wx.getStorageSync('avatarUrl') ? wx.getStorageSync('avatarUrl') : 'https://img.wgmf.com/img_default1.png',
      myVipCusStatus: wx.getStorageSync('vipCusStatus') ? wx.getStorageSync('vipCusStatus') : 0,
      myOpenId: wx.getStorageSync('openId') ? wx.getStorageSync('openId') : ''
    })
    this.initTrialReport(option.id) // 初始化谷粉说内容
    this.getProductsList(option.id) // 初始化谷粉说关联的产品信息
    API.browse(option.id) // 谷粉说的浏览量+1
    try {   
      wx.onCopyUrl(() => {
        return { query: WGFORMAT.formatQueryByOptions(option) }
      })
    } catch (error) {
      console.warn('暂不支持wx.onCopyUrl')
    }
  },
  getShareTitle() {
    let title = this.data.comment.contentTitle?this.data.comment.contentTitle:this.data.comment.ratingDesc.trim().substr(0, 40)
    if(title.length < 3) title = "我发现一篇超赞的分享笔记，快点来看！"
    return title
  },
  onHide() {},
  onShareAppMessage: function() { // 自定义点击右上角转发内容
    API.share(this.data.id)
    return {
      title: this.getShareTitle(),
      imageUrl: this.data.comment.evaluationImages[0].imgUrl,
      path: 'modules/FanCommunity/pages/CommentDetail/CommentDetail?' + this.getPageQuery()
    }
  },
  onShareTimeline() { // 分享朋友圈
    API.share(this.data.id)
    return {
      title: this.getShareTitle(),
      imageUrl: this.data.comment.evaluationImages[0].imgUrl,
      path: 'modules/FanCommunity/pages/CommentDetail/CommentDetail?' + this.getPageQuery()
    }
  },
})