// modules/FanCommunity/pages/CommentList/CommentList.js
import { WGFORMAT,WGHTTP, WGTRACK, WGCOMMON,WGENV,WGSUBSCRIBE,} from "../../../../wgUtils/index"
import API from '../../api/fanCommunityApi'
import api from '../../api/index'
import { TOAST,REQUEST, } from '../../../../utils/index'
import ROUTER from "../../utils/fanCommunityRouter"

Page({

  /**
   * 页面的初始数据
   */
  data: {
    orderProductEvaluationId:'',
    newEvaMessage:[],
    hideTextarea: true, // 评论文本框隐藏
    textareaLen: 0, // 评论文本框输入长度
    textareaText: '', // 评论文本框内容
    textareaPlaceholder: '说点啥呢...', // 评论文本框信息提示
    focusTextarea: false, // 聚焦评论文本框

    curPage: 1, // 评论列表的当前页码
    discussArr: [], // 评论列表数组
    evaLevel: 1, // 一级评论传1，二级评论传2
    evaReplyId: 0, // evaLevel为1则传0,evaLevel为2则传评论id
    upLevelId: 0, // 一级评论id，无则传0
    canLoadMore: true,
    ischeck: 'comment',
    EvaList:[], // 笔记列表
    thumbUpReplyFlag: '0',
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (option) {
    if (wx.getStorageSync('openId') && wx.getStorageSync('unionId') && wx.getStorageSync('nickName') && wx.getStorageSync('avatarUrl')) {
    } else {
      this.setData({
        needLogin: true
      })
    }

    this.setData({
      id: option.id,
      myAvatarUrl: wx.getStorageSync('avatarUrl') ? wx.getStorageSync('avatarUrl') : 'https://img.wgmf.com/img_default1.png',
      myVipCusStatus: wx.getStorageSync('vipCusStatus') ? wx.getStorageSync('vipCusStatus') : 0,
      myOpenId: wx.getStorageSync('openId') ? wx.getStorageSync('openId') : ''
    })
    let flag;
    if(option.thumbUpReplyFlag) {
      if(option.thumbUpReplyFlag == '1') {
        flag = 'like'
        this.getNewEvaMessage(option.thumbUpReplyFlag)
      } else if(option.thumbUpReplyFlag == '2') {
        flag = 'my'
        this.getEvaList()
      } else {
        flag = 'comment'
        this.getNewEvaMessage(option.thumbUpReplyFlag)
      }
      this.setData({
        thumbUpReplyFlag: option.thumbUpReplyFlag,
        ischeck:flag
      })
    }
  },
  //根据小程序openId获取新评论点赞列表列表
  getNewEvaMessage(thumbUpReplyFlags){
    const myOpenId = wx.getStorageSync('openId');
    let thumbUpReplyFlag = thumbUpReplyFlags || 0
    let result = this.data.newEvaMessage
    let that = this
    
    api.get_newEvaMessage({
      // miniOpenId: 'oWGIv1UTgNrJKdxQSuDidQyEbcB8',
      miniOpenId: myOpenId,
      thumbUpReplyFlag: thumbUpReplyFlag,
      curPage: that.data.curPage,
      pageSize: 10,
    }).then(res => {
      if (res.length < 10) {
        that.setData({
          canLoadMore: false
        })
      }
      for(let i = 0; i<res.length; i++) {
        console.log(res[i])
        res[i].createDate = WGFORMAT.formatDate(res[i].createDate, 'yyyy-MM-dd hh:mm:ss')
        // data.submitDateLabel = FILTER.dateFormat(data.submitDate, 'yyyy-MM-dd hh:mm:ss')
      }
      console.log(result)
      if (res) {
        result = result.concat(res)
        console.log(res)
        console.log(result)
        that.setData({
          newEvaMessage: result
        })
      }
      console.log(this.data.newEvaMessage)
    })
    .catch((error) => {
      console.log(error);
    });
  },
  // 获取笔记列表
  getEvaList(){
    api.get_getEvaListByCusId({
      cusId: wx.getStorageSync('cusId'),
      curPage: this.data.curPage, //笔记列表当前页码
      pageSize: 10
    }).then(res=>{
      if (res.length < 10) {
        this.setData({
          canLoadMore: false
        })
      }
      console.log(res)
      for(let i=0;i<res.length;i++) {
        res[i]['isLike'] = false
        res[i]['browseNumberCn'] = WGFORMAT.formatNumber(res[i].browseNumber + res[i].virtualBrowseNumber)
        res[i]['thumbUpNumberCn'] = WGFORMAT.formatNumber(res[i].thumbUpNumber + res[i].virtualThumbUpNumber)
        if((res[i].contentFrontUrl == null || res[i].contentFrontUrl == "") && res[i].evaluationImages.length != 0) {
          res[i].contentFrontUrl = res[i].evaluationImages[0].imgUrl
        }
      }
      let arr = (this.data.curPage == 1)?[]:this.data.newEvaMessage
      arr.push(...res)
      this.setData({
        newEvaMessage: arr
      })
    }).catch((error) => {
      console.log(error);
    });
  },
  
  pullUpKeyBoard() { // 拉起评论的输入键盘
    this.setData({
      hideTextarea: false
    }, () => {
      this.setData({
        focusTextarea: true
      })
    })
  },
  hideKeyboard() { // 隐藏评论的输入键盘
    this.setData({
      hideTextarea: true,
      focusTextarea: false,
    })
  },
  sureSendComment() { // 确认发表评论---点击‘发送’
    let val = this.data.textareaText
    if (val.trim() == '') return
    WGCOMMON.showLoading()
    console.log(this.data.orderProductEvaluationId)
    api.replyNewEvaluation({
      orderProductEvaluationId:this.data.orderProductEvaluationId, // 被评价评价id ,
      evaLevel: this.data.evaLevel, // 一级评论传1，二级评论传2
      evaReplyId: this.data.evaReplyId, // evaLevel为1则传0,evaLevel为2则传评论id
      upLevelId: this.data.upLevelId, // 一级评论id，无则传0
      evaluatorHeadImgUrl: wx.getStorageSync('avatarUrl'),
      evaluatorName: wx.getStorageSync('nickName'),
      miniOpenId: wx.getStorageSync('openId'),
      vipCusStatus: wx.getStorageSync('vipCusStatus') ? wx.getStorageSync('vipCusStatus') : 0,
      ratingDesc: val,
      unionid: wx.getStorageSync('unionId'),
    }).then(res => {
      if (res) {
        this.hideKeyboard()
        this.setData({
          textareaText: '',
          textareaLen: 0
        })
        this.setData({
          // curPage: 1,
          // newEvaMessage:[],
          canLoadMore: true,
        })
        // this.getNewEvaMessage(0)
        WGCOMMON.hideLoading()
        WGCOMMON.toast('评论发表成功！', 1500)
      }
    }).catch(e => {
      WGCOMMON.hideLoading()
    })
  },
  bindinput(e) { // 评论文本框输入
    this.setData({
      textareaLen: e.detail.value.length,
      textareaText: e.detail.value
    })
  },
  tapReply(e) { // 发表二级评论---点击已有评论
    console.log(e)
    this.setData({
      curPage: 1,
      canLoadMore: true,
      orderProductEvaluationId:e.currentTarget.dataset.orderproductevaluationid,
      evaLevel: 2, // 一级评论传1，二级评论传2
      evaReplyId: e.currentTarget.dataset.id,
      textareaPlaceholder: '回复 ' + e.currentTarget.dataset.evaluatorname + '：',
      upLevelId: e.currentTarget.dataset.firstid
    })
    console.log(e)
    this.pullUpKeyBoard()
  },
  tapLike(e){
    let that = this
    
    let newEvaMessage = that.data.newEvaMessage
    var item = e.currentTarget.dataset.gid
    // if(item.thumbUpFlag == 1) {
    //   thumbUpFlag = 0
    // } else if (item.thumbUpFlag == 0) {
    //   thumbUpFlag = 1
    // }
    console.log(item)
    REQUEST.get(WGENV.baseUrl + 'wechat-shop-back/evaluation/thumdUp', {
      data: {
        evaId: 0,
        unionid: wx.getStorageSync('unionId'),
        miniOpenId: wx.getStorageSync('openId'),
        isThumdUpFlag: item.thumbUpFlag, //0否1是
        evaReplyId: item.newEvaReplyId,
      }
    }).then(res => {
      // console.log(res.data.status)  // 0未点赞，1已点赞
      // that.setData({
      //   curPage: 1,
      //   newEvaMessage:[],
      // })
      // that.getNewEvaMessage(0)
      for (let index = 0; index < that.data.newEvaMessage.length; index++) {
        if(that.data.newEvaMessage[index].id==item.id){
          if(item.thumbUpFlag == 1) {
            newEvaMessage[index].thumbUpFlag = 0
          } else if (item.thumbUpFlag == 0) {
            newEvaMessage[index].thumbUpFlag = 1
          }
          that.setData({
            newEvaMessage: newEvaMessage
          })
        }
      }
    })
  },
  getMoreEval() { // 加载下一页评论
    this.setData({
      curPage: this.data.curPage + 1
    })
    if(this.data.thumbUpReplyFlag == '1' || this.data.thumbUpReplyFlag == '0'){
      this.getNewEvaMessage(this.data.thumbUpReplyFlag)
    } else if(this.data.thumbUpReplyFlag == '2') {
      this.getEvaList()
    }
  },
  
  toFansSay (e) {
    console.log(e)
    REQUEST.get(WGENV.baseUrl + 'wechat-shop-back/evaluation/getByEvaId?evaId=' + e.currentTarget.dataset.id).then(r => {
      console.log(r)
      if (r.data.status === 0) {
        wx.navigateTo({
          url: '/modules/FanCommunity/pages/CommentDetail/CommentDetail?id=' + e.currentTarget.dataset.id
        })
      } else {
        // console.log(r)
        WGCOMMON.toast(r.msg, 1500)
      }
    })
  },
  tapSwitch(event){
    var that = this;
    var item = event.currentTarget.dataset.gid
    let thumbUpReplyFlag = ''
    // let flag = ''
    that.setData({
      curPage: 1,
      newEvaMessage:[],
      canLoadMore: true,
      ischeck:item
    })
    if(item == 'like') {
      // flag = 'like'
      thumbUpReplyFlag ='1'
      that.getNewEvaMessage(thumbUpReplyFlag)
    } else if(item == 'my') {
      // flag = 'my'
      thumbUpReplyFlag ='2'
      that.getEvaList()
    } else {
      // flag = 'comment'
      thumbUpReplyFlag ='0'
      that.getNewEvaMessage(thumbUpReplyFlag)
    }
    this.setData({
      thumbUpReplyFlag: thumbUpReplyFlag
    })
  },
  commentListSub(){
    let cusId = wx.getStorageSync('cusId')
    WGSUBSCRIBE('commentList').then((res) => {
    //   console.log(res)
      api.getSendPoint(cusId).then(res => {
        WGCOMMON.toastSuccess(res.msg)
      })
      .catch((error) => {
        console.log(error);
      });
    })
  }
  
})