import {
  WGFORMAT,
  WGENV,
  WGCOMMON,
  Page
} from "../../../../wgUtils/index"
import {
  REQUEST,
} from '../../../../utils/index'
import API from "../../api/index"

Page({
  data: {
    contentInfo: null, // 文章
    isLike: false, // 我的点赞详情
    isLoadingContent: true, // 是否加载中
    showAuth: false,
    content: '', // 文章内容
    itemDatas: [], //猜你喜欢
    canShare: true,
  },
  postCommentSuccess() {
    this.initNote(this.data.id)
  },
  initNote(id) { // 初始化文章
    WGCOMMON.showLoading()
    REQUEST.get(WGENV.baseUrl + 'wechat-shop-back/evaluation/getContentByEvaId?evaId=' + id).then(r => {
      if (r.data.status === 0) {
        let res = r.data.data[0].orderProductEvaluation
        res['createDate'] = WGFORMAT.formatDate(res.createDate, 'yyyy-MM-dd')
        res['browseNumberCn'] = WGFORMAT.formatNumber(res.browseNumber + res.virtualBrowseNumber)
        res['thumbUpNumberCn'] = WGFORMAT.formatNumber(res.thumbUpNumber + res.virtualThumbUpNumber)
        res['shareCountCn'] = WGFORMAT.formatNumber(res.shareCount + res.virtualShareCount)
        this.setData({
          contentInfo: res,
          content: r.data.data[0].content
        })
        WGCOMMON.hideLoading()
        this.setData({
          isLoadingContent: false
        })
      }
    }).catch(() => {
      this.setData({
        isLoadingContent: false
      })
    })
  },
  initLikeDetail(id) { // 初始化点赞详情
    if (wx.getStorageSync('openId') && wx.getStorageSync('unionId')) { // 如果已登录则获取点赞信息
      REQUEST.get(WGENV.baseUrl + 'wechat-shop-back/evaluation/thumdUp', {
        data: {
          evaReplyId: 0,
          isThumdUpFlag: 2,
          evaId: id,
          unionid: wx.getStorageSync('unionId'),
          miniOpenId: wx.getStorageSync('openId'),
        }
      }).then(res => {
        if (res.data.status == 1) {
          this.setData({
            isLike: true
          })
        }
      })
    }
  },
  authSuccess() {
    this.setData({showAuth: false})
    this.tapToGiveLike() //记录点赞
  },
  authFail() {
    this.setData({showAuth: false})
  },
  tapToLike() {
    if (this.checkAuthPhoneNumber()) {
      let tmp = this.data.contentInfo
      let key1 = 'isLike'
      let key2 = 'contentInfo.thumbUpNumberCn'
      let key3 = 'contentInfo.thumbUpNumber'
      // shareCountCn
      REQUEST.get(WGENV.baseUrl + 'wechat-shop-back/evaluation/thumdUp', {
        data: {
          evaId: tmp.id,
          unionid: wx.getStorageSync('unionId'),
          miniOpenId: wx.getStorageSync('openId'),
          isThumdUpFlag: this.data.isLike ? 1 : 0 // 点赞0  取消点赞1  状态2
        }
      }).then(res => {
        this.setData({
          [key1]: !this.data.isLike,
          [key2]: this.data.isLike?WGFORMAT.formatNumber(tmp.thumbUpNumber - 1 + tmp.virtualThumbUpNumber):WGFORMAT.formatNumber(tmp.thumbUpNumber + 1 + tmp.virtualThumbUpNumber),
          [key3]: this.data.isLike?tmp.thumbUpNumber - 1:tmp.thumbUpNumber + 1
        })
      })
    }
  },
  getContentList(id) { // 获取'猜你喜欢'内容列表内容
    API.getLikeByEvaId(id).then(res => {
      for(let i=0;i<res.length;i++) {
        res[i]['isLike'] = false
        res[i]['browseNumberCn'] = WGFORMAT.formatNumber(res[i].browseNumber + res[i].virtualBrowseNumber)
        res[i]['thumbUpNumberCn'] = WGFORMAT.formatNumber(res[i].thumbUpNumber + res[i].virtualThumbUpNumber)
        if((res[i].contentFrontUrl == null || res[i].contentFrontUrl == "") && res[i].evaluationImages.length != 0) {
          res[i].contentFrontUrl = res[i].evaluationImages[0].imgUrl
        }
      }
      this.setData({
        itemDatas: res
      })
    })
  },
  checkAuthPhoneNumber() {
    if(wx.getStorageSync('unionId') && wx.getStorageSync('openId')) { // 有登录信息
      this.setData({
        showAuth: false
      })
      return true
    } else { // 无登录信息
      this.setData({
        showAuth: true
      })
      return false
    }
  },
  getPhoneNumberSuccessListener() {
    this.setData({ unauthorizedPhone: false });
    //记录点赞
    this.tapToLike();
  },
  getPageQuery() {
    let str = ''
    let obj = this.data.option
    for(let key in obj) {
      str += `${key}=${obj[key]}&`
    }
    return str
  },
  onLoad(option) {
    this.data.option = option
    let cusId = wx.getStorageSync('cusId')
    // 735353475 13686432019 龙素平
    // 733621538 15986746847 李文婷
    if((cusId && option.noShare && ['735353475', '733621538'].indexOf(cusId) == -1) || (!cusId && option.noShare)) { // 禁止转发分享
      wx.hideShareMenu()
      this.setData({ canShare: false })
      wx.updateShareMenu({
        withShareTicket: true,
        isPrivateMessage: true,
      })
    } 
    if(option.id) {
      this.initNote(option.id)
      this.initLikeDetail(option.id)
      this.setData({
        id: option.id
      })
      API.browse(option.id)
      this.getContentList(option.id)
    } else {
      wx.redirectTo({
        url: '/modules/FanCommunity/pages/HealthGuide/HealthGuide'
      })
    }
    try {   
      wx.onCopyUrl(() => {
        return { query: WGFORMAT.formatQueryByOptions(option) }
      })
    } catch (error) {
      console.warn('暂不支持wx.onCopyUrl')
    }
  },
  onShareAppMessage: function () {
    let tmp = this.data.contentInfo
    API.share(this.data.id).then(res => {
      this.setData({
        'contentInfo.shareCountCn': WGFORMAT.formatNumber(tmp.shareCount + tmp.virtualShareCount + 1),
        'contentInfo.shareCount': tmp.shareCount + 1
      })
    })
    console.log('转发链接：', 'modules/FanCommunity/pages/ContentDetail/ContentDetail?' + this.getPageQuery())
    return {
      title: this.data.contentInfo.contentTitle,
      path: 'modules/FanCommunity/pages/ContentDetail/ContentDetail?' + this.getPageQuery(),
      imageUrl: this.data.contentInfo.contentFrontUrl?this.data.contentInfo.contentFrontUrl:this.data.contentInfo.evaluationImages[0].imgUrl
    }
  },
  onShareTimeline() { // 分享朋友圈
    API.share(this.data.id)
    return {
      title: this.data.contentInfo.contentTitle,
      path: 'modules/FanCommunity/pages/ContentDetail/ContentDetail?' + this.getPageQuery(),
      imageUrl: this.data.contentInfo.contentFrontUrl?this.data.contentInfo.contentFrontUrl:this.data.contentInfo.evaluationImages[0].imgUrl
    }
  },
})