import { Page, WGENV, WGROUTER, WGFORMAT, WGCOMMON } from '../../../../wgUtils/index'
import API from '../../api/index'
import MODULES from '../../../../utils/modules'

Page({
  data: {
    modulesData: null, // 轮播图
    swiperIndex: 0,
    menuInfo: [], // 顶部分类标签菜单
    itemDatas: [], // 页面数据
    isLoading: false, // 页面数据是否正在加载中
    canPullDownRefresh: true, // 是否可以上拉下一页
    queryData: {
      experienceFlag: 2, // experienceFlag 1.获取社区首页2.获取营养百科3.获取谷粉说
      curPage: 1, // 
      sortNum: 1, // 最新排序0  推荐排序1
      evaluationTagId: null,
    },
    noResultData: {'imgUrl':'https://img.wgmf.com/contentmp/img_biji.png', 'message':'没有相关的内容哦~'},
  },
  initBanner() { // 初始化页面顶部轮播图
    API.getPageById(WGENV.env == 'TEST'?131:284).then(r => {
      if (r) {
        let newpage = MODULES.formatModules(r)
        this.setData({
          modulesData: newpage,
          swiperIndex: 0,
        })
      }
    })
  },
  initCategroy() { // 初始化顶部分类标签
    API.getTagListByDisplayArea(0,1,0).then(res => {
      let left = []
      let right = []
      for(let i=0;i<res.length;i++) {
        if(res[i].stickFlag == 1) {
          left.push(res[i])
        } else {
          right.push(res[i])
        }
      }
      this.setData({
        menuInfo: [...left, ...right]
      })
    })
  },
  clearQueryData() { // 清空查询结果
    this.data.queryData.curPage = 1
    this.data.queryData.evaluationTagId = null
    this.data.queryData.sortNum = null
  },
  selectMenuEventListener(e) { // 点击顶部分类标签
    this.clearQueryData()
    if(e.detail == 0 || e.detail == '0') {
      this.data.queryData.sortNum = 0
    } else if(e.detail == 1 || e.detail == '1') {
      this.data.queryData.sortNum = 1 
    } else {
      this.data.queryData.evaluationTagId = e.detail.id
    } 
    this.getListByPage()
  },
  toHome() { // 跳转到首页
    app.globalData.queryObj = {
      _campaign: '2020S12GFSQ'
    }
    wx.switchTab({
      url: '/pages/Home/Home?_campaign=2020S12GFSQ' // switchtab不支持带参
    })
  },
  getListByPage() { // 加载页面数据
    if(this.data.isLoading) return
    this.setData({
      isLoading: true
    })
    if(this.data.queryData.curPage == 1) {
      WGCOMMON.showLoading()
    }
    API.getEvaListByFlag(this.data.queryData).then(res => {
      for(let i=0;i<res.length;i++) {
        res[i]['isLike'] = false
        res[i]['browseNumberCn'] = WGFORMAT.formatNumber(res[i].browseNumber + res[i].virtualBrowseNumber)
        res[i]['thumbUpNumberCn'] = WGFORMAT.formatNumber(res[i].thumbUpNumber + res[i].virtualThumbUpNumber)
        if((res[i].contentFrontUrl == null || res[i].contentFrontUrl == "") && res[i].evaluationImages.length != 0) {
          res[i].contentFrontUrl = res[i].evaluationImages[0].imgUrl
        }
      }
      let arr = (this.data.queryData.curPage == 1)?[]:this.data.itemDatas
      arr.push(...res)
      this.setData({ 
        itemDatas: arr,
        isLoading: false,
        canPullDownRefresh: res.length < 10?false:true
      })
      WGCOMMON.hideLoading()
    }).catch(() => {
      this.setData({
        isLoading: false
      })
      WGCOMMON.hideLoading()
    })
  },
  onLoad() {
    this.initBanner()
    this.initCategroy()
    this.getListByPage()
  },
  onReachBottom() {
    if(this.data.canPullDownRefresh) {
      this.data.queryData.curPage ++
      this.getListByPage()
    }
  },
  onShareAppMessage() { // 转发
    return {
      title: '超赞的营养百科知识，快点来看！',
      path: 'modules/FanCommunity/pages/HealthGuide/HealthGuide'
    }
  },
  onShareTimeline() { // 分享朋友圈
    return {
      title: '超赞的营养百科知识，快点来看！',
      path: 'modules/FanCommunity/pages/HealthGuide/HealthGuide'
    }
  }
})