import API from '../../api/index'
import {
  WGAUTH,
  WGENV,
  WGCOMMON,
  WGFORMAT,
  Page
} from '../../../../wgUtils/index'
import {
  REQUEST
} from '../../../../utils/index'
import modules from '../../../../utils/modules'

const app = getApp()

Page({
  data: {
    hideLoginModal: true,
    curPage: 1,
    moreTxt: '查看更多...',
    commentModule: [],
    tags: [],
    thumbUpTag: 1,
    selectedTagId: 0,
    needUserInfoAuth: false,
    pageId: WGENV.env == 'TEST' ? 132 : 84,
    modulesData: null,
    swiperIndex: 0,
    isRefresh: false,
    canIUseGetUserProfile: false,
  },
  toHome() {
    app.globalData.queryObj = {
      chan_id: '2_3'
    }
    wx.switchTab({
      url: '/pages/Home/Home?chan_id=2_3'  // switchtab不支持带参
    })
  },
  initPage() {
    API.getPageById(this.data.pageId).then(r => {
      if (r) {
        let newpage = modules.formatModules(r)
        this.setData({
          modulesData: newpage,
          swiperIndex: 0,
        })
      }
    })
  },
  closeLoginModal() {
    this.setData({
      hideLoginModal: true
    })
  },
  bindgetphonenumber(e) {
    WGAUTH.getPhoneNumber(e).then(res => {
      wx.navigateTo({
        url: '../PostComment/PostComment'
      })
    })
  },
  toDetail(e) {
    wx.navigateTo({
      url: '../CommentDetail/CommentDetail?id=' + e.currentTarget.dataset.id
    })
  },
  thumbUp(evaId, index) {
    let that = this
    let key1 = 'commentModule[' + index + '].isLike'
    let key2 = 'commentModule[' + index + '].formatThumbUpNumber'
    REQUEST.get(WGENV.baseUrl + 'wechat-shop-back/evaluation/thumdUp', {
      data: {
        isThumdUpFlag: 2,
        evaId: evaId,
        unionid: wx.getStorageSync('unionId'),
        miniOpenId: wx.getStorageSync('openId'),
      }
    }).then(res => {
      if (res.data.status == 1) { // 已经点赞过
        this.setData({
          [key1]: true
        })
        WGCOMMON.toast('您已经点过赞了', 1000)
      } else { // 还未点赞过
        REQUEST.get(WGENV.baseUrl + 'wechat-shop-back/evaluation/thumdUp', {
          data: {
            evaId: evaId,
            unionid: wx.getStorageSync('unionId'),
            miniOpenId: wx.getStorageSync('openId'),
            isThumdUpFlag: 0 // 点赞0  取消点赞1  状态2
          }
        }).then(res => {
          this.setData({
            [key1]: true,
            [key2]: WGFORMAT.formatNumber(that.data.commentModule[index].thumbUpNumber + that.data.commentModule[index].virtualThumbUpNumber + 1)
          })
        })
      }
    })
  },
  clickThumbUp(e) {
    this.thumbUp(e.currentTarget.dataset.id, e.currentTarget.dataset.index)
  },
  toPostComment() {
    if (wx.getStorageSync('cusId')) {
      wx.navigateTo({
        url: '../PostComment/PostComment'
      })
    } else {
      this.setData({
        hideLoginModal: false,
      })
    }
  },
  bindGetUserInfo(e) {
    WGAUTH.getUserInfo(e).then(res => {
      this.thumbUp(e.currentTarget.dataset.id, e.currentTarget.dataset.index)
      this.setData({
        needUserInfoAuth: false
      })
    })
  },
  getUserProfile() {
    WGAUTH.getUserProfile().then(res => {
      this.thumbUp(e.currentTarget.dataset.id, e.currentTarget.dataset.index)
      this.setData({
        needUserInfoAuth: false
      })
    })
  },
  initDataByPage(append) {
    if (this.data.moreTxt == '别拖啦，到底啦~') return false
    let curPage = this.data.curPage
    if (curPage === 1) {
      WGCOMMON.showLoading()
    }
    let queryData = {
      experienceFlag: 3, // experienceFlag 1.获取社区首页2.获取营养百科3.获取谷粉说
      curPage: this.data.curPage, // 
      sortNum: this.data.thumbUpTag, // 0最新  1推荐
      evaluationTagId: this.data.selectedTagId?this.data.selectedTagId:null,
    }
    API.getEvaListByFlag(queryData).then(data => {
      if (data.length > 0) {
        let commentModule = (this.data.curPage == 1)?[]:this.data.commentModule
        for (let i = 0; i < data.length; i++) {
          data[i].isLike = false
          data[i].formatThumbUpNumber = WGFORMAT.formatNumber(data[i].thumbUpNumber)
          data[i].formatBrowseNumber = WGFORMAT.formatNumber(data[i].browseNumber)
          let imgs = data[i].evaluationImages
          imgs.sort(function(a, b) {
            if (a.sortingOrder - b.sortingOrder == 0) {
              return a.id - b.id
            }
            return a.sortingOrder - b.sortingOrder
          })
          data[i]['evaluationImages'] = imgs
        }
        this.setData({
          curPage: curPage + 1,
          commentModule: [...commentModule, ...data],
        })
      }
      if(data.length < 10) {
        this.setData({
          moreTxt: '别拖啦，到底啦~'
        })
      }
      wx.hideLoading()
      if (this.data.isRefresh) {
        wx.stopPullDownRefresh()
        this.setData({
          isRefresh: false
        })
      }
      if(this.data.curPage === 1 && data.length == 0) {
        this.setData({
          commentModule: []
        })
      }
    }).catch(() => {
      if (!append) {
        this.setData({
          commentModule: []
        })
      }
      this.setData({
        moreTxt: '别拖啦，到底啦~'
      })
    })
  },
  initTag() { // 初始化笔记分类
    API.getTagListByDisplayArea(0,0,1).then(res => {
      let left = []
      let right = []
      for(let i=0;i<res.length;i++) {
        if(res[i].stickFlag == 1) {
          left.push(res[i])
        } else {
          right.push(res[i])
        }
      }
      this.setData({
        tags: [...left, ...right]
      })
    })  
  },
  selectedTag(e) { // 选择笔记分类
    let tagId = Number(e.currentTarget.dataset.id)
    if (tagId != this.data.selectedTagId) {
      this.setData({
        selectedTagId: tagId,
        curPage: 1,
        moreTxt: '查看更多...'
      })
      this.initDataByPage()
      wx.pageScrollTo({
        scrollTop: 0,
        duration: 300
      })
      this.data.pageOption['tagId'] = e.currentTarget.dataset.id
    }
  },
  sortByHot(e) {
    let target = Number(e.currentTarget.dataset.type)
    if (target == this.data.thumbUpTag) {
      return
    }
    this.setData({
      thumbUpTag: target,
      curPage: 1,
      moreTxt: '查看更多...'
    })
    this.initDataByPage()
    wx.pageScrollTo({
      scrollTop: 0,
      duration: 300
    })
  },
  onLoad(option) {
    this.initDataByPage()
    this.initTag()
    this.initPage()
    this.setData({
      pageOption: option,
      needUserInfoAuth: (wx.getStorageSync('openId') && wx.getStorageSync('unionId'))?false:true
    })
    if (wx.getUserProfile) {
      this.setData({
        canIUseGetUserProfile: true
      })
    }
  },
  onHide() {},
  onPullDownRefresh() { // 上拉刷新
    // this.setData({
    //   isRefresh: true,
    //   curPage: 1
    // })
    // this.initDataByPage()
  },
  onReachBottom() {
    if (this.data.moreTxt == '别拖啦，到底啦~') return false
    this.setData({
      moreTxt: '玩命加载中......'
    })
    this.initDataByPage(1)
  },
  onShareAppMessage: function(res) { // 自定义点击右上角转发内容
    return {
      title: '五谷磨房，创造精致生活的更多种选择',
      path: 'modules/FanCommunity/pages/Index/Index'
    }
  },
  onShareTimeline() { // 分享朋友圈
    return {
      title: '五谷磨房，创造精致生活的更多种选择',
      path: 'modules/FanCommunity/pages/Index/Index'
    }
  },
  onShow() {
  },
})