// import api from '../../api/index'
import {
  REQUEST
} from '../../../../utils/index'
import {
  WGENV,
  Page
} from '../../../../wgUtils/index'

Page({
  data: {
    inputTxt: '',
    curPage: 1,
    moreTxt: '查看更多...',
    commentModule: [],
    noData: false
  },
  searchKeyInput(e) { // 输入文本
    this.setData({
      inputTxt: e.detail.value
    })
  },
  searchConfirm(e) { // 确认搜索
    let value = e.detail.value ? e.detail.value : e.currentTarget.dataset.text
    wx.pageScrollTo({
      scrollTop: 0,
      duration: 300
    })
    if (value != '') {
      this.setData({
        inputTxt: value,
        curPage: 1,
        noData: false,
        moreTxt: '查看更多...',
        commentModule: [],
      })
      this.search()
    } else {
      this.setData({
        inputTxt: value,
        curPage: 1,
        noData: false,
        moreTxt: '查看更多...',
        commentModule: [],
      })
      this.initDataByPage()
    }
  },
  initDataByPage(append) {
    if (this.data.moreTxt == '别拖啦，到底啦~') return false
    let curPage = this.data.curPage
    if (curPage === 1) {
      wx.showLoading({})
    }
    wx.showNavigationBarLoading()
    REQUEST.get(WGENV.baseUrl + 'wechat-shop-back/evaluation/fansList', {
      data: {
        thumbUpTag: 0, // 粉丝说笔记分类，按推荐排序0非1是
        evaluationTag: 0, // 粉丝说笔记分类，首页则传0
        pageSize: 20,
        curPage: this.data.curPage
      }
    }).then(res => {
      if (res.data.status == 0) {
        let data = res.data.data
        if (data.length > 0) {
          let commentModule = append ? this.data.commentModule : []
          for (let i = 0; i < data.length; i++) {
            let imgs = data[i].evaluationImages
            imgs.sort(function(a, b) {
              if (a.sortingOrder - b.sortingOrder == 0) {
                return a.id - b.id
              }
              return a.sortingOrder - b.sortingOrder
            })
            data[i]['evaluationImages'] = imgs
          }
          this.setData({
            curPage: curPage + 1,
            commentModule: [...commentModule, ...data],
          })
        } else {
          this.setData({
            moreTxt: '别拖啦，到底啦~'
          })
        }
      } else {
        if (!append) {
          this.setData({
            commentModule: []
          })
        }
        this.setData({
          moreTxt: '别拖啦，到底啦~'
        })
      }
      wx.hideLoading()
      wx.hideNavigationBarLoading()
    })
  },
  toDetail(e) {
    wx.navigateTo({
      url: '../CommentDetail/CommentDetail?id=' + e.currentTarget.dataset.id
    })
  },
  search() {
    if (this.data.moreTxt == '别拖啦，到底啦~') return false
    let curPage = this.data.curPage
    if (curPage === 1) {
      wx.showLoading({})
    }
    REQUEST.get(WGENV.baseUrl + 'wechat-shop-back/evaluation/search', {
      data: {
        ratingDesc: this.data.inputTxt,
        curPage: curPage,
        pageSize: 20,
        experienceFlag: 3
      }
    }).then(res => {
      wx.hideLoading()
      if (res.data.status == 0) {
        let list = res.data.data
        if (list.length > 0) {
          let commentModule = this.data.commentModule
          this.setData({
            curPage: curPage + 1,
            commentModule: [...commentModule, ...list]
          })
        } else {
          this.setData({
            moreTxt: '别拖啦，到底啦~'
          })
        }
      } else {
        this.setData({
          moreTxt: '别拖啦，到底啦~'
        })
        if (curPage == 1) {
          this.setData({
            noData: true
          })
        }
      }
    })
  },
  onReachBottom() {
    if (this.data.moreTxt == '别拖啦，到底啦~') return false
    this.setData({
      moreTxt: '玩命加载中......'
    })
    if (this.data.inputTxt == '') {
      this.initDataByPage(1)
    } else {
      this.search()
    }
  },
  // onShareAppMessage: function() { // 自定义点击右上角转发内容
  //   return {
  //     title: '五谷磨房，创造精致生活的更多种选择',
  //     path: 'modules/FanCommunity/pages/SearchComment/SearchComment'
  //   }
  // },
  onLoad(e) {
  }
})