import { Page, WGENV, WGROUTER, WGFORMAT, WGCOMMON } from '../../../../wgUtils/index'
import API from '../../api/index'
import MODULES from '../../../../utils/modules'

const app = getApp()
Page({
  data: {
    modulesData: null, // 轮播图
    swiperIndex: 0,
    topicDataArray: [{"id":1,"topicName":"营养百科","imageUrl":"https://img.wgmf.com/contentmp/ic_chabei.png","backgroundUrl":"https://img.wgmf.com/contentmp/img_dongyangsheng.png"},{"id":2,"topicName":"谷粉超话","imageUrl":"https://img.wgmf.com/contentmp/ic_grass.png","backgroundUrl":"https://img.wgmf.com/contentmp/img_aizhongcao.png"}],
    menuInfo: [], // 顶部分类标签菜单
    itemDatas: [], // 页面数据
    loading: false, // 页面数据是否正在加载中
    canPullDownRefresh: true, // 是否可以上拉下一页
    queryData: {
      experienceFlag: 1, // experienceFlag 1.获取社区首页2.获取营养百科3.获取谷粉说
      curPage: 1, // 
      sortNum: 1, // 最新排序0  推荐排序1
      evaluationTagId: null,
    },
    noResultData: {
      'imgUrl': 'https://img.wgmf.com/contentmp/img_biji.png',
      'message': '没有相关的内容哦~'
    },
    remind:{
      messageRemindNumber:0,
      remindMessage:''
    },
    gifImageUrl: '' // 临时活动动图
  },
  initBanner() { // 初始化页面顶部轮播图
    API.getPageById(WGENV.env == 'TEST'?130:283).then(r => {
      if (r) {
        let newpage = MODULES.formatModules(r)
        this.setData({
          modulesData: newpage,
          swiperIndex: 0,
        })
      }
    })
  },
  initCategroy() { // 初始化顶部分类标签
    API.getTagListByDisplayArea(1,0,0).then(res => {
      let left = []
      let right = []
      for(let i=0;i<res.length;i++) {
        if(res[i].stickFlag == 1) {
          left.push(res[i])
        } else {
          right.push(res[i])
        }
      }
      this.setData({
        menuInfo: [...left, ...right]
      })
    })
  },
  tapToKnowHealth() { // 跳转到营养百科
    WGROUTER.navigateTo('/modules/FanCommunity/pages/HealthGuide/HealthGuide');
  },
  tapToLetYouLike() { // 跳转到谷粉超话
    WGROUTER.navigateTo('/modules/FanCommunity/pages/Index/Index');
  },
  clearQueryData() { // 清空查询结果
    this.data.queryData.curPage = 1
    this.data.queryData.evaluationTagId = null
    this.data.queryData.sortNum = null
  },
  selectMenuEventListener(e) { // 点击顶部分类标签
    this.clearQueryData()
    if(e.detail == 0 || e.detail == '0') {
      this.data.queryData.sortNum = 0
    } else if(e.detail == 1 || e.detail == '1') {
      this.data.queryData.sortNum = 1 
    } else {
      this.data.queryData.evaluationTagId = e.detail.id
    } 
    this.getListByPage()
  },
  toHome() { // 跳转到首页
    // app.globalData.queryObj = {
    //   _campaign: '2021NHJGFSQ'
    // }
    // wx.switchTab({
    //   url: '/pages/Home/Home?_campaign=2021NHJGFSQ'  // switchtab不支持带参
    // })
    // wx.navigateTo({
    //   url: '/modules/MemberPlan/pages/MemberPlan/MemberPlan?_campaign=HYTZJHSQ'
    // })
    let _now = new Date()
    if(WGFORMAT.targetDateInDateBetwen('2021-10-01 00:00:00', '2021-10-08 23:59:59', _now)) {
      wx.navigateToMiniProgram({
        appId: 'wx7aeaa095f033dca0',
        path: 'pages/LotteryList/LotteryList?actId=&cusId=&openid=&_appid=android&_adTag=wx&_campaign=CJBX',
        extraData: {
          foo: 'bar'
        },
        envVersion: 'release',
        success(res) {
          // 打开成功
        }
      })
    } else if(WGFORMAT.targetDateInDateBetwen('2021-10-09 00:00:00', '2021-10-28 23:59:59', _now)) {
      wx.navigateToMiniProgram({
        appId: 'wx7aeaa095f033dca0',
        path: 'pages/LotteryList/LotteryList?actId=&cusId=&openid=&_appid=android&_adTag=wx&_campaign=CJQB',
        extraData: {
          foo: 'bar'
        },
        envVersion: 'release',
        success(res) {
          // 打开成功
        }
      })
    } else if(WGFORMAT.targetDateInDateBetwen('2021-11-05 00:00:00', '2021-11-14 23:59:59', _now)) {
      wx.switchTab({
        url: '/pages/Home/Home?actId=&_campaign=S11ZSQICON'  // switchtab不支持带参
      })
    } else if(WGFORMAT.targetDateInDateBetwen('2021-12-05 00:00:00', '2021-12-12 23:59:59', _now)) {
      wx.switchTab({
        url: '/pages/Home/Home?actId=&_campaign=ICON2021S12'  // switchtab不支持带参
      })
    }else if(WGFORMAT.targetDateInDateBetwen('2022-01-01 00:00:00', '2022-01-04 23:59:59', _now)) { //购物金储值卡
      wx.navigateTo({
        url: '/modules/ShoppingMoney/pages/Stored/Stored?actId=&_campaign=CZKNHJICON'
      })
    }else if(WGFORMAT.targetDateInDateBetwen('2022-01-05 00:00:00', '2022-01-05 23:59:59', _now)) {  //超会日双倍积分
      wx.switchTab({
        url: '/pages/Home/Home?actId=&_campaign=CHRICON'  // switchtab不支持带参
      })
    }else if(WGFORMAT.targetDateInDateBetwen('2022-01-06 08:00:00', '2022-01-06 22:59:59', _now)) { //年货节直播
      wx.navigateTo({
        url: '/modules/LivePlay/pages/LiveRoom/LiveRoom?roomId=140&_campaign=zbicon'
      })
    }else if(WGFORMAT.targetDateInDateBetwen('2022-01-07 00:00:00', '2022-01-13 23:59:59', _now)) {  //年货节活动宣传
      wx.switchTab({
        url: '/pages/Home/Home?actId=&_campaign=NHJHDXCICON'  // switchtab不支持带参
      }) 
    }else if(WGFORMAT.targetDateInDateBetwen('2022-01-14 00:00:00', '2022-01-16 23:59:59', _now)) {  //天降红包
      wx.switchTab({
        url: '/pages/Home/Home?actId=&_campaign=TJHBICON'  // switchtab不支持带参
      })
    }else if(WGFORMAT.targetDateInDateBetwen('2022-02-26 00:00:00', '2022-03-13 23:59:59', _now)) {  //花颜节
      wx.navigateTo({
        url: '/pages/ActivePage/ActivePage?id=571&_campaign=sygl38'  
      })
    }else if(WGFORMAT.targetDateInDateBetwen('2022-05-01 00:00:00', '2022-05-08 23:59:59', _now)) {  //母亲节
      wx.switchTab({
        url: '/pages/Home/Home?actId=&_campaign=2022MQJGFSQX'  
      })
    }else if(WGFORMAT.targetDateInDateBetwen('2022-06-01 00:00:00', '2022-06-21 23:59:59',  _now)) {  //618
      wx.switchTab({
        url: '/pages/Home/Home?actId=&_campaign=2022MQJGFSQX'  
      })
    }
  },
  getListByPage() { // 加载页面数据
    if(this.data.loading) return
    this.setData({
      loading: true
    })
    if(this.data.queryData.curPage == 1) {
      WGCOMMON.showLoading()
    }
    API.getEvaListByFlag(this.data.queryData).then(res => {
      for(let i=0;i<res.length;i++) {
        res[i]['isLike'] = false
        res[i]['browseNumberCn'] = WGFORMAT.formatNumber(res[i].browseNumber + res[i].virtualBrowseNumber)
        res[i]['thumbUpNumberCn'] = WGFORMAT.formatNumber(res[i].thumbUpNumber + res[i].virtualThumbUpNumber)
        if((res[i].contentFrontUrl == null || res[i].contentFrontUrl == "") && res[i].evaluationImages.length != 0) {
          res[i].contentFrontUrl = res[i].evaluationImages[0].imgUrl
        }
      }
      let arr = (this.data.queryData.curPage == 1)?[]:this.data.itemDatas
      arr.push(...res)
      this.setData({ 
        itemDatas: arr,
        loading: false,
        canPullDownRefresh: res.length < 10?false:true
      })
      WGCOMMON.hideLoading()
    }).catch(() => {
      this.setData({
        loading: false
      })
      WGCOMMON.hideLoading()
    })
  },
  onLoad(options) {
    this.initBanner()
    this.getNewEvaMessageRemind()
    this.initCategroy()
    this.getListByPage()
    try {   
      wx.onCopyUrl(() => {
        return { query: WGFORMAT.formatQueryByOptions(options) }
      })
    } catch (error) {
      console.warn('暂不支持wx.onCopyUrl')
    }
    
    let now = new Date()
    if(WGFORMAT.targetDateInDateBetwen('2021-10-01 00:00:00', '2021-10-08 23:59:59', now)) {
      this.setData({
        gifImageUrl: 'https://img.wgmf.com/wgmall/fridge.gif'
        
      }) 
    } else if(WGFORMAT.targetDateInDateBetwen('2021-10-09 00:00:00', '2021-10-28 23:59:59', now)) {
      this.setData({
        gifImageUrl: 'https://img.wgmf.com/wgmall/100.gif'
      }) 
    }else if(WGFORMAT.targetDateInDateBetwen('2021-11-05 00:00:00', '2021-11-14 22:59:59', now)) {
      this.setData({
        gifImageUrl: 'https://img.wgmf.com/wgmall/icon.gif'
      }) 
    }else if(WGFORMAT.targetDateInDateBetwen('2021-12-05 00:00:00', '2021-12-12 22:59:59', now)) {
      this.setData({
        gifImageUrl: 'https://img.wgmf.com/wgmall/icon_2121_12_05.gif'
      }) 
    }else if(WGFORMAT.targetDateInDateBetwen('2022-01-01 00:00:00', '2022-01-04 23:59:59', now)) { //购物金储值卡
      this.setData({
        gifImageUrl: 'https://img.wgmf.com/wgmall/nhj-20220101-icon.gif'
      }) 
    }else if(WGFORMAT.targetDateInDateBetwen('2022-01-05 00:00:00', '2022-01-05 23:59:59', now)) {  //超会日双倍积分
      this.setData({
        gifImageUrl: 'https://img.wgmf.com/wgmall/nhj-20220105-icon.gif'
      }) 
    }else if(WGFORMAT.targetDateInDateBetwen('2022-01-06 08:00:00', '2022-01-06 22:59:59', now)) { //年货节直播
      this.setData({
        gifImageUrl: 'https://img.wgmf.com/wgmall/nhj-20220106-icon.gif'
      }) 
    }else if(WGFORMAT.targetDateInDateBetwen('2022-01-07 00:00:00', '2022-01-13 23:59:59', now)) {  //年货节活动宣传
      this.setData({
        gifImageUrl: 'https://img.wgmf.com/wgmall/nhj-20220107-icon.gif'
      }) 
    }else if(WGFORMAT.targetDateInDateBetwen('2022-01-14 00:00:00', '2022-01-16 23:59:59', now)) {  //天降红包
      this.setData({
        gifImageUrl: 'https://img.wgmf.com/wgmall/nhj-20220114-icon.gif'
      }) 
    }else if(WGFORMAT.targetDateInDateBetwen('2022-02-26 00:00:00', '2022-03-13 23:59:59', now)) {  //天降红包
      this.setData({
        gifImageUrl: 'https://img.wgmf.com/38icon200.gif'
      }) 
    }else if(WGFORMAT.targetDateInDateBetwen('2022-05-01 00:00:00', '2022-05-08 23:59:59', now)) {  //母亲节
      this.setData({
        gifImageUrl: 'https://img.wgmf.com/wgmall%2Ficon_mother_%20day.gif'
      }) 
    }else if(WGFORMAT.targetDateInDateBetwen('2022-06-01 00:00:00', '2022-06-21 23:59:59', now)) {  //618
      this.setData({
        gifImageUrl: 'https://img.wgmf.com/618Icon.gif'
      }) 
    } else {
      this.setData({
        gifImageUrl: ''
      })
    }

  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {},

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
  },
  onReachBottom() {
    if(this.data.canPullDownRefresh) {
      this.data.queryData.curPage ++
      this.getListByPage()
    }
  },
  onShareAppMessage() {
    return {
      title: '超赞的营养百科知识，快点来看！',
      path: 'modules/FanCommunity/pages/WgFans/WgFans'
    }
  },
  onShareTimeline() {
    return {
      title: '超赞的营养百科知识，快点来看！',
      path: 'modules/FanCommunity/pages/WgFans/WgFans'
    }
  },
  //评论列表
  tapToCommentList() {
    const myOpenId = wx.getStorageSync('openId');
    let that = this
    
    API.get_newEvaMessage({
      miniOpenId: myOpenId,
      thumbUpReplyFlag: 0,
      curPage: 1,
      pageSize: 10,
    }).then(res => {
      WGROUTER.navigateTo("/modules/FanCommunity/pages/CommentList/CommentList");
    })
    .catch((error) => {
      console.log(error);
    });
  },
  //根据小程序openId获取新评论点赞提示
  getNewEvaMessageRemind() {
    let that = this;
    const myOpenId = wx.getStorageSync("openId");
    let remind = {};
    API.get_newEvaMessageRemind(myOpenId).then((res) => {
      console.log(res);
      if (res.number >= 1) {
        remind.messageRemindNumber = res.number >= 100 ? "99+" : res.number
        remind.remindMessage = res.remindMessage
        that.setData({
          remind: remind,
        });
      }
    });
  },
})