// pages/LiveRoom/LiveRoom.js
import {
  TOAST,
  LOADING
} from '../../../../utils/index'
import LIVEPLAYAPI from '../../api/livePlayApi'
import {
  WGSUBSCRIBE,
  WGIMAGE,
  WGTRACK,
  Page,
  WGHTTP
} from '../../../../wgUtils/index'
const app = getApp()
Page({
  /**
   * 页面的初始数据
   */
  data: {
    roomId: '',
    isGetLiveInfo: false,
    isSharing: false,
    liveInfo: {},
    shareLiveInfo: {},
    environment: '', //是否是企业微信环境
    staffId: '', //企业微信员工Id
    liveStatus: null, //直播间状态
    _campaign: null, //直播渠道字段
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    /** 浏览记录上报 */

    let scene = decodeURIComponent(options.scene).split('&')
    let query = {}
    for (let i in scene) {
      let item = scene[i].split('=')
      let itemKey = item[0]
      let itemVal = item[1]
      query[itemKey] = itemVal
    }
    let roomId = options.roomId;
    if (!roomId) { // 拿不到roomId
      roomId = query.roomId;
    }
    this.setData({
      roomId
    });
    //渠道路径
    let _campaign = options._campaign;
    if (!_campaign) {
      _campaign = query._campaign;
    }
    if (_campaign && _campaign.length > 0) {
      this.setData({_campaign});
    }
    //企业员工分享 参数staffId
    let shareStaffId = options.shareStaffId || options.staffId;
    console.log(options)
    if (!shareStaffId) {
      shareStaffId = query.shareStaffId || query.staffId;
    }
    if (shareStaffId && shareStaffId.length > 0) {
      this.setData({
        staffId: shareStaffId
      });
    }
    const systemInfoResult = wx.getSystemInfoSync();
    const environment = systemInfoResult.environment;
    if (environment === 'wxwork') {
      //覆盖路径链接带的staffId
      const staffId = wx.getStorageSync('staffId');
      this.setData({
        staffId
      });
    }
    this.setData({
      environment
    });
    WGTRACK.setChan(roomId)
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    this.getLiveRoomInfo();
    this.getMiniLiveShareInfo();
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {},

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {
    const pages = getCurrentPages();
    const currentPage = pages[pages.length - 1];
    const url = `/${currentPage.route}`;
    const params = currentPage.options;
    let paramStr = '';
    for (const key in params) {
      if (key === 'shareStaffId') {
        //排除原链接自带的shareStaffId 2021-8-23
        continue;
      }
      paramStr += "&" + key + "=" + params[key];
    }
    paramStr = paramStr.substr(1);
    let routerUrl = `${url}?${paramStr}`;
    if (this.data.environment === 'wxwork') {
      const staffId = wx.getStorageSync('staffId');
      routerUrl += `&shareStaffId=${staffId}`;
    }
    return {
      title: this.data.shareLiveInfo.shareDesc,
      imageUrl: this.data.shareLiveInfo.shareUrl,
      path: routerUrl
    }
  },
  onShareTimeline() { // 分享朋友圈
    const pages = getCurrentPages();
    const currentPage = pages[pages.length - 1];
    const url = `/${currentPage.route}`;
    const params = currentPage.options;
    let paramStr = '';
    for (const key in params) {
      if (key === 'shareStaffId') {
        //排除原链接自带的shareStaffId 2021-8-23
        continue;
      }
      paramStr += "&" + key + "=" + params[key];
    }
    paramStr = paramStr.substr(1);
    let routerUrl = `${url}?${paramStr}`;
    if (this.data.environment === 'wxwork') {
      const staffId = wx.getStorageSync('staffId');
      routerUrl += `&shareStaffId=${staffId}`;
    }
    return {
      title: this.data.shareLiveInfo.shareDesc,
      imageUrl: this.data.shareLiveInfo.shareUrl,
      path: routerUrl
    }
  },
  goToHomePage: function () {
    wx.switchTab({
      url: '/pages/Home/Home'
    })
  },
  getLiveRoomInfo: function () {
    LOADING.show({
      title: '正在进入直播间',
    });
    const url = LIVEPLAYAPI.miniLiveRoomInfo + '?roomId=' + this.data.roomId
    WGHTTP.get(url).then(res => {
      LOADING.hide();
      let liveInfo = res;
      this.setData({
        liveStatus: liveInfo.liveStatus
      });
      if (liveInfo.liveStatus == 102) {
        let endIndex = liveInfo.startTime.length - 3;
        liveInfo.startTime = (liveInfo.startTime.substring(0, endIndex)).replace(/\-/g, '.');
        const isGetLiveInfo = true;
        this.setData({
          liveInfo,
          isGetLiveInfo
        });
      } else {
        if (liveInfo.liveStatus == 101) {
          this.getSubscribeInfo();
        }
        let customParams = encodeURIComponent(JSON.stringify({
          shareStaffId: this.data.staffId
        }));
        const staffIdParam = this.data.staffId.length > 0 ? `&custom_params=${customParams}` : '';
        console.log(staffIdParam)
        const router = `${LIVEPLAYAPI.WXLiveRoomRouter}?room_id=${this.data.roomId}${staffIdParam}`;
        wx.navigateTo({
          //跳转直播间
          url: router
        });
      }
    }).catch(e => {
      LOADING.hide();
    })
  },
  getMiniLiveShareInfo: function () {
    const url = LIVEPLAYAPI.miniLiveShareInfo + '?roomId=' + this.data.roomId;
    WGHTTP.get(url).then(res => {
      const shareLiveInfo = res;
      this.setData({
        shareLiveInfo
      });
    })
  },
  showMiniLiveShareInfo: function () {
    const isSharing = true;
    this.setData({
      isSharing
    });
  },
  /**
   * 分享直播间
   */
  shareLiveRoom: function () {
    this.showMiniLiveShareInfo();
  },
  /**
   * 关闭分享分享
   */
  closeShare: function () {
    const isSharing = false;
    this.setData({
      isSharing
    });
  },
  /**
   * 订阅通知
   */
  subscibeNotification: function () {
    WGSUBSCRIBE('remindLiveRoom').then(r => {
      if (r == 1) {
        TOAST.success('订阅成功!');
      }
    });
    this.getSubscribeInfo();
  },
  //存储直播订阅信息
  getSubscribeInfo() {
    const currentOpenId = wx.getStorageSync('openId');
    const params = {
      openId: currentOpenId,
      staffId: this.data.staffId,
      roomId: this.data.roomId,
      liveStatus: this.data.liveStatus,
      campaign: this.data._campaign
    };
    WGHTTP.get(LIVEPLAYAPI.miniLiveSubscribeMsg, params).then(res => {});
  },
  /**
   * 保存海报
   */
  savePlacard: function () {
    WGIMAGE.saveImage(this.data.shareLiveInfo.posterUrl)
  }
})