import {
  WGHTTP,
  NEWWGHTTP
} from '../../../wgUtils/index'

export default {
  getPageById: id => {
    return WGHTTP.post('wechat-shop-back/miniApp/getHomePageById?id=' + id)
  },
  newProductNoticeList: () => {
    let cusId = wx.getStorageSync('cusId')
    return WGHTTP.get(`wechat-shop-back/newProductNotice/list${cusId?'?cusId='+cusId:''}`)
  },
  newProductNoticeFollow: id => {
    return WGHTTP.post(`wechat-shop-back/newProductNotice/follow?newProductNoticeId=${id}&openid=${wx.getStorageSync('openId')}&cusId=${wx.getStorageSync('cusId')}&source=2`)
  },
  likesProList: () => { // 获取点赞首页活动商品列表
    return WGHTTP.get('wechat-shop-back/likesOrder/list')
  },
  getLastLikes: () => WGHTTP.get('wechat-shop-back/likesOrder/getLastLikes'),
  getLikesNumber: () => { // 根据customerId获取今日剩余点赞数
    return WGHTTP.get(`wechat-shop-back/likesOrder/getLikesNumber/${wx.getStorageSync('cusId')}`)
  },
  likesOrder: data => { // 参与点赞
    return WGHTTP.post('wechat-shop-back/likesOrder', data)
  },
  getShareLikesOrder: (likesId) => { // 根据分享人customerId获取邀请好友点赞列表
    return WGHTTP.get(`wechat-shop-back/likesOrder/getShareLikesOrder/${wx.getStorageSync('cusId')}?likesId=${likesId}`)
  },
  getCheckPameter: () => {
    return WGHTTP.get('wechat-shop-back/likesOrder/getCheckPameter')
  },
  // 根据customerId获取梯度奖品信息和领取状态
  getLikesGiftInfo: ( cusId, likesId) => WGHTTP.get(`wechat-shop-back/likesOrder/getLikesGiftInfo/${cusId}?likesId=${likesId}`),

  // 领取奖品 wechat-shop-back/likesOrder/receiveLikesGiftInfo/16809932?likesId=1&likesGiftId=1
  receiveLikesGiftInfo: (cusId, likesId, likesGiftId) => WGHTTP.get(`wechat-shop-back/likesOrder/receiveLikesGiftInfo/${cusId}?likesId=${likesId}&likesGiftId=${likesGiftId}`),

  // 一键领取奖品 wechat-shop-back/likesOrder/receiveAllLikesGift/16809932?likesId=1
  receiveAllLikesGift: (cusId, likesId) => WGHTTP.get(`wechat-shop-back/likesOrder/receiveAllLikesGift/${cusId}?likesId=${likesId}`),

  /**
   *   http://app.wgmf.com/app/activity/activitypoint?mobile=13751033134&pts=50&ptype=261&promotionid=0
   */
  activitypoint: data => { // 送积分的接口
    return WGHTTP.get('app/activity/activitypoint', data)
  },
  /**
   * post /customerInformation/queryUserActStatus 
   */
  queryUserActStatus: data => { //查询用户是否 查询用户是否已经参与过某送积分活动    
    return WGHTTP.post('sygj-ewx/customerInformation/queryUserActStatus', data, "formdata")
  },
  /**
   * post /customerInformation/sendPointTemplateMsg 
   */
  sendPointTemplateMsg: data => { //发送积分变动通知    
    return WGHTTP.post('sygj-ewx/customerInformation/sendPointTemplateMsg', data, "formdata")
  },
  getGroupBenefits: mobile => { // 进取福利领取200积分
    return WGHTTP.get(`app/information/getGroupBenefits?mobile=${mobile}`, { mobile, mobile }, 'json', 1)
  },
  queryCustomMembershipInvitation: cusId => WGHTTP.get(`app/information/queryCustomMembershipInvitation?cusId=${cusId}`),
  joinCustomMembershipInvitation: cusId => WGHTTP.get(`app/information/joinCustomMembershipInvitation?cusId=${cusId}`),
  cardCollection: cusId => WGHTTP.post(`/wechat-shop-back/cardCollection/list?cusId=${cusId}`, null, 'json', 1),
  composeCard: (cusId, collectionId) => WGHTTP.get(`/wechat-shop-back/cardCollection/composeCard?collectionId=${collectionId}&cusId=${cusId}`),
  querySaveMoneyTickets: cusId => WGHTTP.post(`/sygj-ewx/SaveMoneyCard/querySaveMoneyTickets?cusId=${cusId}`),
  subscribeTicket: memberId => WGHTTP.post(`/sygj-ewx/SaveMoneyCard/subscribeTicket?memberId=${memberId}`),
  isBuyCard: cusId => WGHTTP.get(`wechat-shop-back/discountCard/isBuyCard?cusId=${cusId}`),
  getByShareCusId: cusId => WGHTTP.get(`/wechat-shop-back/discountCard/getByShareCusId?shareCusId=${cusId}`), 
  drawGwt: cusId => WGHTTP.get(`/wechat-shop-back/discountCard/drawGwt?cusId=${cusId}`),
  querySaveMoney: cusId => WGHTTP.post(`/sygj-ewx/SaveMoneyCard/querySaveMoney?cusId=${cusId}`),
  exchangePoints: data => NEWWGHTTP.post(`order/mini/exchange/points`, data), //电商订单号兑换会员商场积分
}

