// modules/ActivityCenter/pages/IntegralActivity/IntegralActivity.js
// 线下扫码领积分-活动积分领取
import api from '../../api/index'
import {
  WGAUTH,
  WGCOMMON,
  Page
} from '../../../../wgUtils/index'
Page({
  data: {
    openDialog: false,
    dialogTips: '您已经领取过积分了',
    mobile: '',
    status: 2, // 1已有手机号，2未有手机号，3全新用户无手机号和无unionid
    tips: '您还未绑定手机号',
    btnTxt: '绑定手机号并领取',
    authModal: false, // 显示手机号授权弹窗
    canIUseGetUserProfile: false,
  },
  onLoad: function (options) {
    wx.showShareMenu({
      withShareTicket: true
    })
    wx.hideShareMenu()
    wx.hideShareMenu({
      menus: ['shareAppMessage', 'shareTimeline']
    })
    if(!options._campaign) { // 不带campaign不能正常访问
      WGCOMMON.showModal('提示', '您无此页面访问权限').then(() => {
        wx.switchTab({
          url: '/pages/Home/Home'
        })
      }).catch(() => {
        wx.switchTab({
          url: '/pages/Home/Home'
        })
      })
    }
    if (wx.getUserProfile) {
      this.setData({
        canIUseGetUserProfile: true
      })
    }
  },
  onShow: function () {
    this.setStatus()
  },
  bindgetphonenumber(e) {
    WGAUTH.getPhoneNumber(e).then(() => {
      this.setData({
        authModal: false
      })
      this.setStatus()
      this.getAward()
    }).catch(e => {
      WGCOMMON.toast(e, 3500)
    })
  },
  bindgetuserinfo(e) {
    WGAUTH.getUserInfo(e).then(res => {
      if(!wx.getStorageSync('phone')) {
        this.setData({
          authModal: true
        })
      }
    })
  },
  getUserProfile() {
    WGAUTH.getUserProfile().then(res => {
      if(!wx.getStorageSync('phone')) {
        this.setData({
          authModal: true
        })
      }
    })
  },
  setStatus() {
    this.setData({
      status: wx.getStorageSync('phone')?1:2,
      mobile: wx.getStorageSync('phone'),
    })
    if(!wx.getStorageSync('phone') && !wx.getStorageSync('unionId')) {
      this.setData({
        status: 3
      })
    }
    this.setTips()
  },
  setTips() {
    if (this.data.status == 2 || this.data.status == 3) {
      this.setData({
        tips: '您还未绑定手机号',
        btnTxt: '绑定手机号并领取'
      })
    } else {
      this.setData({
        tips: '当前账户：' + this.data.mobile,
        btnTxt: '立即领取'
      })
    }
  },
  // 立即领取
  getAward() {
    WGCOMMON.toast('抱歉，该活动现已暂停。')
    return
    if (this.data.mobile) {
      api.getGroupBenefits(this.data.mobile).then(res => {
        this.setData({
          dialogTips: res.msgInfo
        })
        this.openDialog()
      })
    }
  },
  // 积分变动消息
  pushMsg() {
    api.sendPointTemplateMsg({
      mobile: wx.getStorageSync('phone'), //  openid
      unionId: wx.getStorageSync('unionId'), //  openid
      points: '200' //  200积分
    })
  },
  // 前往积分商城
  goDetail() {
    wx.navigateTo({
      url: '/pages/CreditsExchange/CreditsExchange',
    })
  },
  openDialog() {
    this.setData({
      openDialog: true
    })
  },
  closeDialog() {
    this.setData({
      openDialog: false
    })
  },
  onShareAppMessage() {
    wx.updateShareMenu({
      withShareTicket: true
    })
    // return {
    //   title: '五谷磨房，创造精致生活的更多种选择',
    //   path: `/pages/Home/Home`,
    //   imageUrl: 'https://wx.qlogo.cn/mmhead/Q3auHgzwzM4LZMFQTpSJdibeWX2mtLuHLvq3Tlqv9ZvI2IPvAtEADWQ/0'
    // }
    return {
      title: '恭喜获得首次入群200积分福利，点击卡片领取↓↓↓',
      path: `/modules/MallPromotion/pages/IntegralActivity/IntegralActivity`,
      imageUrl: 'https://img.wgmf.com/wgmall/invite-img.jpg'
    }
  }
})
