import {
  Page, WGSUBSCRIBE, WGCOMMON,
} from '../../../../wgUtils/index'
import api from '../../api/index';
Page({
  data: {
    likesId: -1,
    needLogin: 0,
    num: 0,
    users: [],
    acitivityEnd: 1,
    resultImg: 'https://img.wgmf.com/wgmall/20210308/img_gift_01.png?imageslim',
    resultPro: '',
    resultLiangCi: '',
    progressHeight: 0,
    prizes: [],
    receiverText:'',
    receiverFlag: false
  },
  authFail() {},
  authSuccess() {
    this.setData({
      needLogin: 0
    })
    this.initPrize()
  },
  computeProgress(currentNum) { // 梯度计算
    let prizes = this.data.prizes
    let [cha1 , cha2, cha3] = [prizes[0].likesGift.expectLikes, prizes[1].likesGift.expectLikes, prizes[2].likesGift.expectLikes]
    let step1 = cha2 - cha1
    let step2 = cha3 - cha2
    if(currentNum >= cha3) return 100
    if(currentNum == cha2) return 50
    if(currentNum <= cha1) return 0
    console.log(currentNum, cha1, cha2, cha3, step1, step1)
    if(currentNum > cha1 && currentNum < cha2) {
      return (currentNum/step1)*50
    }
    return ((currentNum-cha2)/step2)*50+50
  },
  initList() {
    if(wx.getStorageSync('cusId')) {
      api.getShareLikesOrder(this.data.likesId).then(res => {
        let len = res.length
        let progressHeight = this.computeProgress(len);
        console.log(progressHeight, 'progressHeight--------')
        let img = 'https://img.wgmf.com/ic_gift1@2x.png'
        let resultPro = ''
        let resultLiangCi = ''
        if(len >= 10) {
          img = 'https://img.wgmf.com/img_gfj_gift_01.png?imageslim'
          resultPro = '5积分'
          resultLiangCi = '份'
        } else if(len >= 5 && len < 10) {
          img = 'https://img.wgmf.com/img_gfj_gift_02.png?imageslim'
          resultPro = '10元购物金'
          resultLiangCi = '份'
        } else {
          img = 'https://img.wgmf.com/img_gfj_gift_03.png?imageslim'
          resultPro = '黑芝麻丸赠品券'
          resultLiangCi = '张'
        }
        this.setData({
          users: res,
          num: len,
          resultImg: img,
          resultPro: resultPro,
          resultLiangCi: resultLiangCi,
          progressHeight: progressHeight
        })
      })
    }
  },
  initPrize() {
    if(wx.getStorageSync('cusId')) {
      api.getLikesGiftInfo(wx.getStorageSync('cusId'), this.data.likesId).then(res => {
        console.log('初始化奖品')
        console.log(res,res[2], res[2].hasOwnProperty('giftStatus'), `ddddd`)
        if(!res[2].hasOwnProperty('giftStatus')) {
          res[2]['giftStatus'] = 0
        }
        let receiverNumber = 0;
        let receiverFlag = false;
        let receiverText = '';
        res.map(res=>{
          if(res.giftStatus ==1) {
            receiverNumber++
            receiverFlag = true;
          } else if(res.giftStatus ==0) {
            receiverFlag = true;
          }
        })
        console.log(receiverNumber)
        console.log(receiverFlag)
         if(receiverFlag == false){
          receiverText= '已领取'
        }else if(receiverNumber>=2){
          receiverText= '一键领取'
        } else{
          receiverText= '立即邀请'
        }
        this.setData({
          prizes: res.reverse(),
          receiverFlag: receiverFlag,
          receiverNumber: receiverNumber,
          receiverText: receiverText
        })
        console.log(this.data.prizes)
        this.initList()
      })
    }
  },
  receivePrize(e) {
    WGSUBSCRIBE('remindCoupon').then(() => {
      api.receiveLikesGiftInfo(wx.getStorageSync('cusId'), this.data.likesId, e.currentTarget.dataset.id).then(res => {
        WGCOMMON.toastSuccess('领取成功！')
        this.initPrize()
      })
    })
  },
  showActivityEndTip() {
    WGCOMMON.toast('活动已结束，不能领取')
  },
  receiverAll() {
    WGSUBSCRIBE('remindCoupon').then(() => {
      api.receiveAllLikesGift(wx.getStorageSync('cusId'), this.data.likesId).then(res => {
        WGCOMMON.toastSuccess('领取成功！')
        console.log(res)
        this.initPrize()
      })
    })
  },
  toastTip1() {
    WGCOMMON.toast('请到首页参与点赞领取奖品')
  },
  toastTip2() {
    WGCOMMON.toast('您还未达到领取条件，快邀请好友来助力吧')
  },
  onLoad (option) {
    api.getLastLikes().then(res => {
      if(res) {
        this.data.likesId = res.id
      }
    })
    if(wx.getStorageSync('cusId')) {
      this.setData({
        needLogin: 0
      })
    } else {
      this.setData({
        needLogin: 1
      })
    }
    let that = this 
    setTimeout(function() {
      if(wx.getStorageSync('cusId')) {
        that.setData({
          needLogin: 0
        })
      } else {
        that.setData({
          needLogin: 1
        })
      }
    }, 1500)
    api.likesProList().then(res => { // 获取点赞活动详情
      if(res) {
        let now = new Date().getTime()
        if(now > res.endTime) { // 活动已经结束了
          this.setData({
            acitivityEnd: 1
          })
        } else {
          let arr = res.likesProductResult?res.likesProductResult: []
          this.data.likesId = arr.length > 0?arr[0].likesProduct.likesId:this.data.likesId
          this.setData({
            acitivityEnd: 0
          })
        }
      }
      this.initPrize() // 初始化奖品
    })
  },
  onShareAppMessage: function(res) { // 自定义点击右上角转发内容
    return {
      title: '快点一下，帮我赚5倍积分！你还能免费拿奖品哦~',
      imageUrl: 'https://img.wgmf.com/img_gfj_share2.png',
      path: '/modules/MallPromotion/pages/ThumbUp2Deprice/ThumbUp2Deprice?shareCustomerId=' + wx.getStorageSync('cusId'),
    }
  },
  onShareTimeline() { // 分享朋友圈
    return {
      title: '快点一下，帮我赚5倍积分！你还能免费拿奖品哦~',
      imageUrl: 'https://img.wgmf.com/img_gfj_share2.png',
      path: '/modules/MallPromotion/pages/ThumbUp2Deprice/ThumbUp2Deprice?shareCustomerId=' + wx.getStorageSync('cusId'),
    }
  }
})