import {
  Page, WGCOMMON, WGAUTH, WGFORMAT, WGTRACK, WGSUBSCRIBE,
} from '../../../../wgUtils/index'
import api from '../../api/index';
var tick = null
Page({
  data: {
    cusId: '',
    ysf: {
      title: '会员日邀请函',
      config: JSON.stringify({
        "level": '', // vip等级
        "foreignid": wx.getStorageSync('cusId'),
        "data": JSON.stringify([{
          "index": 7,
          "type": "crm_param",
          "key": "partnerId",
          "value": 'cs' + wx.getStorageSync('cusId')
        }])
      })
    },
    userInfo: {
      cusId: "",
      grade: "",
      gradeCoefficient: 1,
      joinNum: "0",
      list: [],
      validPoint: 0,
      joined: false
    },
    show: false,
    showThankCard: false,
    tickNum: 0,
    joinedNum: 0,
    hidePulldow: false,
    showPart3: false
  },
  handleContact(e) {
    var path = e.detail.path,
      query = e.detail.query,
      params = '';
    if (path) {
      for (var key in query) {
        params = key + '=' + query[key] + '&';
      }
      params = params.slice(0, params.length - 1);
      if (path.indexOf('Home/Home') != -1 || path.indexOf('ProductIndex/ProductIndex') != -1 || path.indexOf('FanCommunity/pages/WgFans/WgFans') != -1 || path.indexOf('MyCart/MyCart') != -1 || path.indexOf('PersonalCenter/PersonalCenter') != -1) {
        wx.switchTab({
          url: path + '?' + params
        })
      } else {
        wx.navigateTo({
          url: path + '?' + params
        })
      }
    }
  },
  initData(flag) {
    if(wx.getStorageSync('cusId')) {
      api.queryCustomMembershipInvitation(wx.getStorageSync('cusId')).then(res => {
        let showPart3 = false
        if(res.inCareList) {
          switch(res.grade) {
            case '谷谷': showPart3 = 2;break;
            case '钻谷': showPart3 = 1;break;
            default:break;
          }
        }
        this.setData({
          userInfo: res,
          showPart3: showPart3
        })
        if(flag) {
          this.countNumber(this.data.userInfo.joinNum)
        }
      })
    }
  },
  joinIn() { // 点击我要参与
    // if(wx.getStorageSync('cusId')) {
    if(wx.getStorageSync('cusId') && !this.data.userInfo.joined) {
      WGTRACK.logCustomEvent('click_join_invitation')
      WGSUBSCRIBE('invitation').then(r => {
        if (r == 1) {
          TOAST.success('订阅成功!');
        }
      });
      api.joinCustomMembershipInvitation(wx.getStorageSync('cusId')).then(res => {
        clearInterval(tick)
        this.initData(1)
        this.setData({
          showThankCard: true,
          'userInfo.joined': true,
        })
      })
    }
    this.setData({
      showThankCard: true,
    })
  },
  showPage() {
    this.setData({
      show: true
    })
    WGTRACK.logCustomEvent('click_see_invitation')
  },
  hideCard() {
    this.setData({
      showThankCard: false
    })
  },
  toExchangePage() {
    wx.navigateTo({
      url: '/pages/CreditsExchange/CreditsExchange?from=invitesvip'
    })
  },
  authSuccess() {
    this.setData({
      cusId: wx.getStorageSync('cusId')?wx.getStorageSync('cusId'):'',
      ysf: {
        title: '会员日邀请函',
        config: JSON.stringify({
          "level": '', // vip等级
          "foreignid": wx.getStorageSync('cusId'),
          "data": JSON.stringify([{
            "index": 7,
            "type": "crm_param",
            "key": "partnerId",
            "value": 'cs' + wx.getStorageSync('cusId')
          }])
        })
      }
    })
    this.initData()
  },
  authFail() {
    wx.clearStorage()
    WGCOMMON.toast('授权失败，请重试')
    WGAUTH.wxLogin()
  },
  onLoad(options) {
    try {   
      wx.onCopyUrl(() => {
        return { query: WGFORMAT.formatQueryByOptions(options) }
      })
    } catch (error) {
      console.warn('暂不支持wx.onCopyUrl')
    }
    WGTRACK.logCustomEvent('exposure_popup_invitation')
  },
  onShow() {
    this.setData({
      cusId: wx.getStorageSync('cusId')?wx.getStorageSync('cusId'):''
    })
    this.initData()
  },
  onShareAppMessage: function() { // 自定义点击右上角转发内容
    return {
      title: '点我领双倍积分！还有高级七叶风扇放肆抽',
      imageUrl: 'https://img.wgmf.com/wgmall/invite-svip-202206/img_share_invitation_june.png?imageslim',
      path: 'modules/MallPromotion/pages/InviteSvip/InviteSvip',
    }
  },
  onShareTimeline() { // 分享朋友圈
    return {
      title: '点我领双倍积分！还有高级七叶风扇放肆抽',
      imageUrl: 'https://img.wgmf.com/wgmall/invite-svip-202206/img_share_invitation_june.png?imageslim',
      path: 'modules/MallPromotion/pages/InviteSvip/InviteSvip',
    }
  },
  countNumber(num) {
    num = parseInt(num)
    this.data.tickNum = parseInt(this.data.tickNum)
    if(num <= this.data.tickNum) {
      return
    }
    console.log(num, this.data.tickNum, this.data.tickNum >= num)
    var that = this
    var step = parseInt((parseInt(num)-parseInt(that.data.tickNum))/6)
    step = step < 1?1:step
    tick = setInterval(function() {
      if(parseInt(that.data.tickNum) >= parseInt(num)) {
        clearInterval(tick)
      } else {
        that.data.tickNum = (that.data.tickNum + step) > num?num:that.data.tickNum + step
        that.setData({
          joinedNum: that.data.tickNum.toString()
        })
      }
    }, 300)
  },
  onReachBottom() {
    this.countNumber(this.data.userInfo.joinNum)
    // this.countNumber(6520)
  },
  onPageScroll(e) {
    if(e.scrollTop > 150) {
      this.setData({
        hidePulldow: true
      })
    } else {
      this.setData({
        hidePulldow: false
      })
    }
  },
})