import {
  Page,
  WGENV,
  WGSUBSCRIBE
} from '../../../../wgUtils/index'
import modules from '../../../../utils/modules'
import api from '../../api/index'

Page({
  data: {
    modulesData: [null, null],
    swiperIndex: [0, 0],
    products: [],
    needLogin: 0, // 需要登录
    hideSubscribe: true
  },
  authFail() {},
  authSuccess() {
    this.setData({
      needLogin: 0
    })
  },
  initPage(pageId, index) {
    api.getPageById(pageId).then(r => {
      if (r) {
        let newpage = modules.formatModules(r)
        this.setData({
          ['modulesData['+ index +']']: newpage,
          ['swiperIndex[' + index +']']: 0,
        })
      }
    })
  },
  initList() {
    api.newProductNoticeList().then(res => {
      for(let i=0;i<res.length;i++) {
        for(let j=0;j<res[i].productImages.length;j++) {
          if(res[i].productImages[j].imageGroup == 'icon') {
            res[i]['imgUrl'] = res[i].productImages[j].imageUrl
            break
          }
        }
      }
      this.setData({
        products: res
      })
    })
  },
  toDetail(e) {
    let pId = e.currentTarget.dataset.pid
    wx.navigateTo({
      url: '/pages/ProductDetail/ProductDetail?pId=' + pId
    })
  },
  checkLogin(e) {
    console.log('checkLogin')
    if(wx.getStorageSync('cusId') && wx.getStorageSync('openId')) {
      this.followProduct(e)
    } else {
      this.setData({
        needLogin: 1
      })
    }
  },
  followProduct(e) {
    let cusIsFollow = e.currentTarget.dataset.isfollow
    let id = e.currentTarget.dataset.id
    let num = e.currentTarget.dataset.num
    let index = e.currentTarget.dataset.index
    let key = 'products[' + index +'].follows'
    let key1 = 'products[' + index +'].cusIsFollow'
    if(cusIsFollow == 0) {
      this.setData({
        hideSubscribe: false
      })
      WGSUBSCRIBE('remindStock').then(res => {
        console.log(res)
        if(res) {
          api.newProductNoticeFollow(id).then(r => {
            this.setData({
              [key]: num + 1,
              [key1]: 1
            })
          })
        }
        this.setData({
          hideSubscribe: true
        })
      }).catch(() => {
        this.setData({
          hideSubscribe: true
        })
      })
    }
  },
  onLoad (options) {
    if(options.shareTitle) { // 自定义了转发标题
      this.data.shareTitle = options.shareTitle
    }
    this.initPage(WGENV.env == 'TEST' ? 116 : 128, 0)
    this.initPage(WGENV.env == 'TEST' ? 137 : 355, 1)
    this.initList()
  },
  onShareAppMessage: function(res) { // 自定义点击右上角转发内容
    return {
      title: this.data.shareTitle?this.data.shareTitle:'快来看看，我发现了超多优惠活动，马上预约不错过~',
      // imageUrl: 'https://img.wgmf.com/wgmall/20210308/newpro-notice.jpg',
      path: '/modules/MallPromotion/pages/NewProductNotice/NewProductNotice',
    }
  },
  onShareTimeline() { // 分享朋友圈
    return {
      title: this.data.shareTitle?this.data.shareTitle:'快来看看，我发现了超多优惠活动，马上预约不错过~',
      // imageUrl: 'https://img.wgmf.com/wgmall/20210308/newpro-notice.jpg',
      path: '/modules/MallPromotion/pages/NewProductNotice/NewProductNotice',
    }
  }
})