import { Page, WGCOMMON, WGDATATYPE, WGENV, WGFORMAT, WGSUBSCRIBE, WGTRACK, WGUSER } from '../../../../wgUtils/index'
import WGAPI from '../../../../api/index'
import MODULES from '../../../../utils/modules'
import API from '../../api/index'

Page({
  data: {
    modulesData: [],
    swiperIndex: 0,
    saveMoney: 0,
    hidePopUp: true,
    popupImg: [
      'https://img.wgmf.com/wgmall/sqk/img_pop_obtain_3yuan.png', // 3元购物金
      'https://img.wgmf.com/wgmall/sqk/img_pop_obtain_6yuan.png', // 6元购物金
      'https://img.wgmf.com/wgmall/sqk/img_pop_over.png', // 活动结束
    ],
    shareLen: 0,
    activePopImg: '',
    hideRulePopUp: true,
    userName: '',
    avatarUrl: 'https://img.wgmf.com/img_default1.png',
    couponsList: [],
    shareCustomers: ['https://img.wgmf.com/wgmall/sqk/img_head_portrait_gray_sqk_1.png', 'https://img.wgmf.com/wgmall/sqk/img_head_portrait_gray_sqk_1.png'],
    showSubscribeTip: false,
    buttonType: -1, // 1立即邀请，2立即领取，3已领取, 4已结束
    rules: [
      {
        title: '一、618省钱卡',
        content: [
          '1.618省钱卡（以下简称省钱卡）是五谷磨房2021年限时发售的虚拟商品；',
          '2.发售时间：2021年5月20日00:00:00-2021年6月15日24:00:00；',
          '3.使用时间：2021年6月3日00:00:00-2021年6月18日24:00:00，逾期失效；',
          '4.省钱卡仅限商城购买及使用，同一用户仅能购买1张省钱卡；',
          '5.购买省钱卡后，618期间未使用任意卡券，则卡费全额退款。',
        ]
      },
      {
        title: '二、省钱卡的使用',
        content: [
          '1.省钱卡内含有优惠券及赠品券共18张，同类券无法叠加使用；',
          '2.优惠券逾期失效，请分别在优惠券有效期内使用；',
          '3.对应直采品牌优惠券、赠品券，限购买该品牌产品并满足条件时使用；',
          '4.除花养花外所有直采品牌，消费金额累计赠品不累加；',
          '5.五谷磨房自营产品满减券、红枣赠品券不叠加直采产品、初心蜜、鲜炖燕窝使用。',
        ]
      },
      {
        title: '三、邀请好友购卡活动',
        content: [
          '1.仅已购卡用户可参加邀好友购省钱卡返购物金的活动；',
          '2.邀好友购省钱卡的活动时间：2021年5月20日00:00:00-2021年6月15日24:00:00；',
          '3.活动时间内，用户每成功邀请1人购卡，即可获得3元购物金，最多可获得6元购物金；',
          '4.购物金需要用户在活动页面主动领取后到账，领取时间：2021年6月16日-2021年6月20日，逾期失效；',
          '5.购物金可叠加红包优惠券使用，领取后的12个月内有效。',
        ]
      },
      {
        title: '四、其他',
        content: [
          '活动期间购买省钱卡的用户，在活动结束后，未使用省钱卡任一卡券（包含赠品券及优惠券等），则卡费全额以购物金的形式，自动返还至原购物账户。',
        ]
      },
    ]
  },
  remindCoupon(e) {
    let index = e.currentTarget.dataset.index
    let item = e.currentTarget.dataset.item
    if(item.subscribeStatus != 1) {
      WGSUBSCRIBE('remindCoupon').then(res => {
        if(res == 1) {
          API.subscribeTicket(item.memberId).then(() => {
            this.setData({
              ['couponsList[' + index +'].subscribeStatus']: 1
            })
          })
        }
        this.setData({
          showSubscribeTip: false
        })
      }).catch(() => {
        this.setData({
          showSubscribeTip: false
        })
      })
    }
  },
  toHome() {
    this.setData({ hidePopUp: false })
    wx.switchTab({ url: '/pages/Home/Home' }) 
  },
  toggleHideRulePopup() {
    this.setData({ hideRulePopUp: !this.data.hideRulePopUp })
  },
  initModule(pageId) {
    WGAPI.modules.getById(pageId).then(r => {
      if(r) {
        let newpage = MODULES.formatModules(r)
        this.setData({
          modulesData: newpage,
        })
      }
      WGCOMMON.hideLoading()
    })
  },
  initCoupons(cusId) {
    if(cusId) {
      API.querySaveMoneyTickets(cusId).then(res => {
        /**
         * activityStatus (integer, optional): 券对应的活动状态 （0.待开始，1进行中，2.已结束） ,
         * subscribeStatus (string, optional): 券订阅状态 （0.未订阅，1.已订阅） ,
         */
        this.setData({
          couponsList: res
        })
        WGCOMMON.hideLoading()
      }).catch(() => {
        WGCOMMON.hideLoading()
      })
    }
  },
  watchBack(showSubscribeGif) {
    console.log('showSubscribeGif--------', showSubscribeGif)
    this.setData({
      showSubscribeTip: showSubscribeGif
    })
  },
  goToUse() {
    wx.switchTab({
      url: '/pages/Home/Home'
    })
  },
  receiveGwj() { // 领取购物金奖励
    API.drawGwt(wx.getStorageSync('cusId')).then(res => {
      if(res) {
        if(this.data.shareLen == 1) {
          this.setData({
            hidePopUp: false,
            activePopImg: this.data.popupImg[0]
          })
        } else if(this.data.shareLen > 1) {
          this.setData({
            hidePopUp: false,
            activePopImg: this.data.popupImg[1]
          })
        }
      }
    })
  },
  initPage() {
    WGCOMMON.showLoading()
    let cusId = wx.getStorageSync('cusId')
    if(cusId) { // 已登录
      API.isBuyCard(cusId).then(res => {
        if(res && res.isBuyCard == 1) { // 已经购买了省钱卡
          API.querySaveMoney(cusId).then(res => {
            // console.error('节省金额', res )
            this.setData({ saveMoney: res })
          })
          this.initCoupons(cusId) // 初始化券列表
          getApp().watch(this.watchBack)
          this.initModule(WGENV.env == 'TEST'?138:366) // 初始化页面底部配置项
          API.getByShareCusId(cusId).then(res => { // 获取分享列表
            if(WGDATATYPE.isArray(res) && res.length > 0) {
              this.setData({
                shareLen: res.length,
                ['shareCustomers[0]']: res[0].discountCardHeadImgUrl,
                ['shareCustomers[1]']: res.length > 1?res[1].discountCardHeadImgUrl: 'https://img.wgmf.com/wgmall/sqk/img_head_portrait_gray_sqk_1.png'
              })
            }
          })
          if(wx.getStorageSync('avatarUrl')) {
            this.setData({
              avatarUrl: wx.getStorageSync('avatarUrl')
            })
          }
          if(wx.getStorageSync('nickName')) {
            this.setData({
              userName: wx.getStorageSync('nickName')
            })
          } else {
            WGUSER.getCustomerInfo().then(res => {
              this.setData({
                userName: wx.getStorageSync('nickName')?wx.getStorageSync('nickName'):'匿名',
                avatarUrl: wx.getStorageSync('avatarUrl')?wx.getStorageSync('avatarUrl'):'https://img.wgmf.com/img_default1.png'
              })
            })
          }
          if(res.isSendGwg == 1) { // 已经领取了购物金
            this.setData({
              buttonType: 3 // 1立即邀请，2立即领取，3已领取
            })
          } else if(res.isSendGwg == 0 && WGFORMAT.targetDateInDateBetwen('2021-06-16 00:00:00', '2021-06-20 23:59:59', new Date())) {
            /** 邀请结算期 6/16 - 6/20 */
            this.setData({
              buttonType: 2
            })
          }
        } else { // 没有购买省钱卡
          WGCOMMON.hideLoading()
          WGCOMMON.showModal('提示', '您还未购买省钱卡，前往购买省钱卡->>').then(() => {
            wx.redirectTo({
              url: '/pages/ProductDetail/ProductDetail?pId=2081'
            })
          })
        }
      })
      /**
       * 省钱卡发售期：可以邀请：发售时间：2021年5月20日00:00:00-2021年6月15日24:00:00
       */
      if(WGFORMAT.targetDateInDateBetwen('2021-05-20 00:00:00', '2021-06-15 23:59:59', new Date())) {
        this.setData({
          buttonType: 1
        })
      }
    } else { // 未登录
      WGCOMMON.hideLoading()
      WGCOMMON.showModal('提示', '您还未登录，请先前往登录').then(() => {
        wx.navigateTo({
          url: '/pages/AuthPage/AuthPage'
        })
      })
    }
  },
  hidePopUpHandler() {
    this.setData({
      hidePopUp: true
    })
  },
  onShow() {
    this.initPage()    
  },
  onLoad(options) {
    let now = new Date().getTime()
    let endTime = new Date('2021/06/20 23:59:59').getTime() // 活动结束时间
    if(now > endTime) { // 活动已经结束了
      this.setData({
        hidePopUp: false,
        activePopImg: this.data.popupImg[2]
      })
    }
  },
  onShareAppMessage() {
    WGTRACK.logCustomEvent('share_saveMoneyCard')
    return {
      title: '618福利丨6元开卡省1000+，分享还能赚钱？！',
      imageUrl: 'https://img.wgmf.com/wgmall/sqk/sharecover-sqk.png',
      path: '/pages/ProductDetail/ProductDetail?pId=2081&shareCusId=' + wx.getStorageSync('cusId'),
    }
  },
  onShareTimeline() {
    WGTRACK.logCustomEvent('shareTimeline_saveMoneyCard')
    return {
      title: '618福利丨6元开卡省1000+，分享还能赚钱？！',
      imageUrl: 'https://img.wgmf.com/wgmall/sqk/sharecover-sqk.png',
      path: '/pages/ProductDetail/ProductDetail?pId=2081&shareCusId=' + wx.getStorageSync('cusId'),
    }
  },
})