import {
  Page,
  WGCOMMON,
  WGFORMAT,
  WGSUBSCRIBE
} from '../../../../wgUtils/index'
import api from '../../api/index'

Page({
  data: {
    activity: null,
    todayNum: 5,
    acitivityEnd: 0, // 0活动未结束  1活动已结束
    likesId: -1,
    likesProductId: null,
    shareCustomerId: null,
    needLogin: 0,
    progress: 0,
    hideRule: true,
    showGuide1: false, // 是否显示引导步骤1
    showGuide2: false, // 是否显示引导步骤2
    showGuide3: false, // 是否显示引导步骤3
    showShare: true,
    loginType: 2,
    deadLine: false,
  },
  toggleRule() {
    this.setData({
      hideRule: !this.data.hideRule
    })
  },
  authFail() {
    WGCOMMON.toast('喔，网络开小差了~请重新尝试授权')
    // wx.removeS
  },
  authSuccess() {
    this.setData({
      needLogin: 0
    })
    this.submitLike()
  },
  toDetail(e) { 
    wx.navigateTo({
      url: '/pages/ProductDetail/ProductDetail?pId=' + e.currentTarget.dataset.pid
    })
  },
  attendLike(e) {
    if(this.data.showGuide1) {
      this.hideGuide1()
      return
    }
    if(this.data.showGuide2) {
      this.hideGuide2()
      return
    }
    if(this.data.showGuide3) {
      this.hideGuide3()
      return
    }
    if(wx.getStorageSync('cusId') && wx.getStorageSync('unionId')) {
      if(wx.getStorageSync('nickName') && wx.getStorageSync('avatarUrl')) {
        this.setData({
          needLogin: 0
        })
      } else {
        this.setData({
          loginType: 1
        })
      }
    } else {
      this.setData({
        loginType: 2
      })
    }
    console.log('loginType---------------', this.data.loginType)
    this.setData({
      likesId: e.currentTarget.dataset.likeid,
      likesProductId: e.currentTarget.dataset.productid
    })
    if(wx.getStorageSync('cusId') && wx.getStorageSync('avatarUrl') && wx.getStorageSync('unionId')) {
      this.setData({
        needLogin: 0
      })
      this.submitLike()
    } else {
      this.setData({
        needLogin: 1
      })
    }
  },
  submitLike() {
    if(this.data.todayNum == 0) {
      WGCOMMON.toast('今日点赞次数已用完', 2000)
      if(!wx.getStorageSync('showNewGuide2') && this.data.showShare) {
        wx.pageScrollTo({
          scrollTop: 0
        }) 
        this.setData({
          showGuide2: true
        })
      }
      return
    }
    // return
    api.likesOrder({
      unionid: wx.getStorageSync('unionId'),
      customerId: Number(wx.getStorageSync('cusId')), //  (integer, optional): 客户id ,
      likesId: this.data.likesId, //  (integer, optional): 点赞降价活动id ,
      likesProductId: this.data.likesProductId,
      openId: wx.getStorageSync('openId'),
      shareCustomerId: this.data.shareCustomerId, //  (integer, optional): 分享人id ,
      wechatHeadImgUrl: wx.getStorageSync('avatarUrl'), //  (string, optional): 点赞人微信头像地址 ,
      wechatName: wx.getStorageSync('nickName') //  (string, optional): 点赞人昵称
    }).then(res => {
      if(wx.getStorageSync('likesSubscribeFlag') == 1) {
        this.getTodayNum(1)
        this.initList()
      } else {
        console.log('订阅消息啊')
        WGSUBSCRIBE('remindSeckill').then(res => {
          console.log('订阅消息成功啦啦啦啦啊')
          this.getTodayNum(1)
          this.initList()
          wx.setStorageSync('likesSubscribeFlag', 1)
        })
      }
    })
  },
  toSharePage() {
    if(this.data.acitivityEnd == 0){
      wx.navigateTo({
        url: '/modules/MallPromotion/pages/InviteDeprice/InviteDeprice'
      })
    } else {
      WGCOMMON.toast('活动已结束')
    }
  },
  receiverAll() {
    WGSUBSCRIBE('remindCoupon').then(() => {
      api.receiveAllLikesGift(wx.getStorageSync('cusId'), this.data.likesId).then(res => {
        WGCOMMON.toastSuccess('领取成功！')
        console.log(res)
        this.initPrize()
      })
    })
  },
  initList() {
    api.likesProList().then(res => {
      if(res) {
        if(res.hasOwnProperty('likesProductResult')) {
          let now = new Date().getTime()
          if(now > res.endTime) { // 活动已经结束啦
            this.setData({
              acitivityEnd: 1
            })
          }else {
            //testTime
            // let deadStartTime = '1628438400000'
            //正式时间
            let deadStartTime = '1629302400000'
            let deadEndTime = '1629907200000'
            console.log(1629302400000)
            console.log(now)
            console.log(1629907200000)
            if(deadStartTime <= now && now<= deadEndTime){
              this.setData({
                deadLine: true
              })
            }
          }
          let arr = res.likesProductResult
          for(let i=0;i<arr.length;i++) {
            let parr = arr[i].likesProduct.likesProductPrices // 活动产品数组
            let actualLikes = arr[i].likesProduct.actualLikes // 总点赞数
            arr[i].likesProduct['actualLikesCn'] = WGFORMAT.formatNumber(actualLikes, 'cn')
            let progress = 0
            let step = 100/(parr.length - 1) // 活动梯度
            let lastLike = 0
            for(let j=0;j<parr.length;j++) {
              if(parr[j].isOriginalPrice == 0) {
                if(actualLikes >= parr[j].expectLikes) { // 实际点赞数超过当前梯度
                  lastLike = parr[j].expectLikes
                  progress += step
                } else { // 实际点赞数未超过当前梯度
                  let chazhi = actualLikes - lastLike  // 比上一个梯度多多少
                  let valstep = step / (parr[j].expectLikes - lastLike - 1)
                  progress += (chazhi * valstep)
                  break
                }
              }
            }
            res.likesProductResult[i]['progress'] = progress>100?100:progress
          }
          this.setData({
            activity: res
          })
          if(!wx.getStorageSync('showNewGuide1')) { // 没有显示过指引步骤
            this.setData({
              showGuide1: true
            })
            wx.pageScrollTo({
              scrollTop: 200
            })      
          }
        } else {
          this.setData({
            acitivityEnd: 1
          })
        }
      }
    })
  },
  showActivityEndTip() {
    WGCOMMON.toast('活动已结束')
  },
  getTodayNum(flag) {
    if(wx.getStorageSync('cusId')) {
      api.getLikesNumber().then(res => {
        this.setData({
          todayNum: res
        })
        if(flag == 1) {
          if(res == 0) {
            WGCOMMON.toast('今日点赞任务已完成，赠送5积分', 3500)
            if(!wx.getStorageSync('showNewGuide2') && this.data.showShare) {
              wx.pageScrollTo({
                scrollTop: 0
              }) 
              this.setData({
                showGuide2: true
              })
            }
          } else {
            WGCOMMON.toast('点赞+1', 2000)
          }
        }
      })
    }
  },
  initPrize() {
    if(wx.getStorageSync('cusId')) {
      api.getLikesGiftInfo(wx.getStorageSync('cusId'), this.data.likesId).then(res => {
        console.log('初始化奖品')
        // console.log(res,res[2], res[2].hasOwnProperty('giftStatus'), `ddddd`)
        // if(!res[2].hasOwnProperty('giftStatus')) {
        //   res[2]['giftStatus'] = 0
        // }
        let receiverNumber = 0;
        let receiverFlag = false;
        let receiverText = '';
        res.map(res=>{
          if(res.giftStatus ==1) {
            receiverNumber++
            receiverFlag = true;
          } else if(res.giftStatus ==0) {
            receiverFlag = true;
          }
        })
        console.log(receiverNumber)
        console.log(receiverFlag)
         if(receiverFlag == false){
          receiverText= '已领取'
        }else if(receiverNumber>=2){
          receiverText= '一键领取'
        } else{
          receiverText= '立即邀请'
        }
        this.setData({
          prizes: res.reverse(),
          receiverFlag: receiverFlag,
          receiverNumber: receiverNumber,
          receiverText: receiverText
        })
        console.log(this.data.prizes)
        this.initList()
      })
    }
  },
  hideGuide() {
    if(this.data.showGuide1) {
      this.hideGuide1()
      return
    }
    if(this.data.showGuide2) {
      this.hideGuide2()
      return
    }
    if(this.data.showGuide3) {
      this.hideGuide3()
      return
    }
  },
  hideGuide1() {
    this.setData({
      showGuide1: false
    })
    wx.setStorageSync('showNewGuide1', 1)
  },
  hideGuide2() {
    this.setData({
      showGuide2: false,
      showGuide3: true
    })
    wx.setStorageSync('showNewGuide2', 1)
  },
  hideGuide3() {
    this.setData({
      showGuide3: false
    })
    wx.setStorageSync('showNewGuide3', 1)
  },
  onLoad (option) {
    api.getLastLikes().then(res => {
      if(res) {
        this.data.likesId = res.id
      }
    })
    if(option.shareCustomerId) { // 分享人的cusId
      this.setData({
        shareCustomerId: option.shareCustomerId
      })
    }
    let that = this
    setTimeout(function() {
      that.getTodayNum()
    }, 1000)
  },
  // initPrize() {
  //   if(wx.getStorageSync('cusId')) {
  //     api.getLikesGiftInfo(wx.getStorageSync('cusId'), this.data.likesId).then(res => {
  //       console.log('初始化奖品')
  //       this.setData({
  //         prizes: res.reverse()
  //       })
  //       this.initList()
  //     })
  //   }
  // },
  onShow() {
    this.initList()
    this.getTodayNum()
    this.initPrize()
    api.getCheckPameter().then(res => {
      if(res && res.hasOwnProperty('value')) {
        if(res.value == 1) {
          this.setData({
            showShare: false
          })
        }
      }
    })
  },
  onShareAppMessage: function(res) { // 自定义点击右上角转发内容
    return {
      title: '快点一下，帮我赚5倍积分！你还能免费拿奖品哦~',
      imageUrl: 'https://img.wgmf.com/img_gfj_share2.png',
      path: '/modules/MallPromotion/pages/ThumbUp2Deprice/ThumbUp2Deprice?shareCustomerId=' + wx.getStorageSync('cusId'),
    }
  },
  onShareTimeline() { // 分享朋友圈
    return {
      title: '快点一下，帮我赚5倍积分！你还能免费拿奖品哦~',
      imageUrl: 'hhttps://img.wgmf.com/img_gfj_share2.png',
      path: '/modules/MallPromotion/pages/ThumbUp2Deprice/ThumbUp2Deprice?shareCustomerId=' + wx.getStorageSync('cusId'),
    }
  }
})