import {
  WGAUTH,
  Page,
  WGTRACK,
} from '../../../../wgUtils/index';
import {
  LOADING,
  TOAST
} from '../../../../utils/index'
import api from '../../api/index'
Page({

  /**
   * 页面的初始数据
   */
  data: {
    orderCode: '', 
    isLogin: false,
    cusId: '',
    showModal: 0,
    disabled: false,
    showMsg: ''
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    this.initUser()
  },
  onShow() {
    WGTRACK.logCustomEvent('exposure_pointExchange')
  },
  initUser() {
    let cusId = wx.getStorageSync('cusId')
    if(cusId){
      this.setData({
        isLogin: true,
        cusId
      })
    }else {
      this.setData({
        isLogin: false,
        cusId
      })
    }
  },
  getPhoneNumber(e) {
    if (e.detail.errMsg === 'getPhoneNumber:ok') {
      LOADING.show({
        title: '登录中...'
      })
      WGAUTH.getPhoneNumber(e).then(res => {
        LOADING.hide()
        this.initUser()
      })
    }
  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },
  closeModal(){
    this.setData({
      showModal: 0,
      showMsg: ''
    })
  },
  bindKeyInput: function (e) {
    this.setData({
      orderCode: e.detail.value
    })
  },
  deleteInput(){
    this.setData({
      orderCode: ''
    })
  },
  toPage(){ //跳转个人积分
    wx.navigateTo({
      url: '/pages/CreditsExchange/CreditsExchange'
    })
  },
  toHome(){
    WGTRACK.logCustomEvent('click_pointExchange_adimg')
    wx.switchTab({
      url: '/pages/Home/Home'
    })
  },
  submit(){
    this.setData({
      disabled: true
    })
    WGTRACK.logCustomEvent('click_pointExchange_submit')
    api.exchangePoints({orderCode: this.data.orderCode, cusId: wx.getStorageSync('cusId')}).then(res=>{
      if(res.code != 0){
        WGTRACK.logCustomEvent('exposure_pointExchange_error')
        this.setData({
          showModal: 2,
          showMsg: res.message
        })
      }else {
        WGTRACK.logCustomEvent('exposure_pointExchange_sucess')
        this.setData({
          showModal: 1,
          showMsg: res.message
        })
      }
    }).finally(()=>{
      this.setData({
        disabled: false
      })
    })
  },
  onShareAppMessage: function() { // 自定义点击右上角转发内容
    WGTRACK.logCustomEvent('click_pointExchange_share')
    return {
      title: '淘宝订单兑积分，多重好礼等你换',
      imageUrl: 'https://img.wgmf.com/wgmall%2F%E4%BC%81%E4%B8%9A%E5%BE%AE%E4%BF%A1%E6%88%AA%E5%9B%BE_16557972465542.png?imageslim',
      path: 'modules/MallPromotion/pages/pointExchange/pointExchange',
    }
  },
  onShareTimeline() { // 分享朋友圈
    WGTRACK.logCustomEvent('click_pointExchange_share')
    return {
      title: '淘宝订单兑积分，多重好礼等你换',
      imageUrl: 'https://img.wgmf.com/wgmall%2F%E4%BC%81%E4%B8%9A%E5%BE%AE%E4%BF%A1%E6%88%AA%E5%9B%BE_16557972465542.png?imageslim',
      path: 'modules/MallPromotion/pages/pointExchange/pointExchange',
    }
  },
})