import { Page, WGCOMMON,WGTRACK, WGFORMAT } from '../../../../wgUtils/index'
import API from '../../api/index'

Page({
  data: {
    completed: 0, // 进度条
    rewardFee: 0, // 目标金额
    actualFee: 0, // 实际金额
    needMorePay: 0, // 还需要消费多少金额
    animationData4: null,
    ticker: null,
    infoRule: false,
  },
  setProgressAnimation(moveLength) {
    var animation = wx.createAnimation({
      duration: 2000,
      timingFunction: 'ease',
      delay: 0
    })
    var animation2 = wx.createAnimation({
      duration: 0,
      timingFunction: 'ease',
      delay: 0
    })
    var next = true
    this.animation = animation
    this.data.ticker = setInterval(function () { // 无限循环动画
      if (next) {
        animation.translateX(moveLength + 'rpx').step()
        next = !next;
        this.setData({
          animationData4: animation.export()
        })
      } else {
        animation2.translate(0, 0).step()
        next = !next;
        this.setData({
          animationData4: animation2.export()
        })
      }
    }.bind(this), 2000)
  },
  onLoad() {
    let cusId = wx.getStorageSync('cusId')
    if(cusId) {
      WGCOMMON.showLoading()
      Promise.all([
        API.getCouponDetail(),
        API.getOrderFee()
      ]).then(res => {
        // res[1] = 500
        let len = (res[1] / res[0].rewardFee) * 320
        let completed = len < 0 ? 0: (len > 320 ?320 : len)
        this.setData({
          completed: completed,
          rewardFee: res[0].rewardFee,
          actualFee: res[1],
          needMorePay: WGFORMAT.formatCurrency(res[0].rewardFee - res[1])
        })
        // this.setProgressAnimation(completed)
        WGCOMMON.hideLoading()
      })
    }
  },
  infoRule(){
    let infoRule = !this.data.infoRule;
    this.setData({
      infoRule: infoRule
    })
  },
  onUnload() {
    clearInterval(this.data.ticker) // 清除计时器
  },
  onShareAppMessage () {
    WGTRACK.logCustomEvent('shareTimeline_challenge')
    return {
      title: '618消费返红包，买越多送越多，最高返60%！！',
      imageUrl: 'https://img.wgmf.com/challenge/img_hytzjh_share.png',
      path: '/modules/MemberPlan/pages/MemberPlan/MemberPlan',
    }
  },
  onShareTimeline() { // 分享朋友圈
    WGTRACK.logCustomEvent('share_challenge')
    return {
      title: '618消费返红包，买越多送越多，最高返60%！！',
      imageUrl: 'https://img.wgmf.com/challenge/img_hytzjh_share.png',
      path: '/modules/MemberPlan/pages/MemberPlan/MemberPlan',
    }
  }
})