import {
  Page,
  WGCOMMON,
  WGTRACK,
  WGFORMAT,
  WGSUBSCRIBE
} from '../../../../wgUtils/index'
import API from '../../api/index'

Page({
  data: {
    cusId: null,
    completed: 0, // 进度条
    rewardFee: 0, // 目标金额
    actualFee: 0, // 实际金额
    needMorePay: 0, // 还需要消费多少金额
    scrollImg: [
      'https://img.wgmf.com/img_hytzjh_prize_20.png',
      'https://img.wgmf.com/img_hytzjh_prize_30.png',
      'https://img.wgmf.com/img_hytzjh_prize_100.png',
      'https://img.wgmf.com/img_hytzjh_prize_200.png',
      'https://img.wgmf.com/img_hytzjh_prize_20.png',
      'https://img.wgmf.com/img_hytzjh_prize_30.png',
      'https://img.wgmf.com/img_hytzjh_prize_100.png',
      'https://img.wgmf.com/img_hytzjh_prize_200.png',
      'https://img.wgmf.com/img_hytzjh_prize_20.png',
      'https://img.wgmf.com/img_hytzjh_prize_30.png',
      'https://img.wgmf.com/img_hytzjh_prize_20.png',
      'https://img.wgmf.com/img_hytzjh_prize_30.png',
      'https://img.wgmf.com/img_hytzjh_prize_100.png',
      'https://img.wgmf.com/img_hytzjh_prize_200.png',
    ],
    animationData1: null, // 绑定的动画效果
    animationData2: null, // 绑定的动画效果
    animationData3: null, // 绑定的动画效果
    showReciveBtn: true, // 展示领取按钮
    infoRule: false,
  },
  infoRule(){
    let infoRule = !this.data.infoRule;
    this.setData({
      infoRule: infoRule
    })
  },
  startScroll () { // 老虎机滚动动画
    // 创建一个动画实例1
    let animation1 = wx.createAnimation({
      duration: 4000,
      timingFunction: 'ease'
    })
    // 获取元素总高度
    let height1 =  (this.data.scrollImg.length-1) * 240
    // 向上移动
    animation1.translateY(-height1 + 'rpx').step()

    // 创建一个动画实例2
    let animation2 = wx.createAnimation({
      duration: 4000,
      timingFunction: 'ease'
    })
    // 获取元素总高度
    let height2 =  (this.data.scrollImg.length-2) * 240
    // 向上移动
    animation2.translateY(-height2 + 'rpx').step()

    // 创建一个动画实例3
    let animation3 = wx.createAnimation({
      duration: 4000,
      timingFunction: 'ease'
    })
    // 获取元素总高度
    let height3 =  (this.data.scrollImg.length-3) * 240
    // 向上移动
    animation3.translateY(-height3 + 'rpx').step()

    // 将动画效果赋值
    this.setData({
      animationData1: animation1.export(),
      animationData2: animation2.export(),
      animationData3: animation3.export()
    })
  },
  recivePrize() { // 领取奖品
    if(this.data.cusId) {
      WGSUBSCRIBE('remindLiveRoom').then(() => {
        API.receive(this.data.cusId).then(res => {
          if(res) {
            WGCOMMON.showModal('恭喜你！', '奖品领取成功！记得使用哦~')
            this.setData({
              showReciveBtn: false
            })
          }
        })
      })
    }
  },
  onLoad() {
    let cusId = wx.getStorageSync('cusId')
    WGCOMMON.showLoading()
    if (cusId) {
      this.data.cusId = cusId
      Promise.all([
        API.getCouponDetail(),
        API.getOrderFee()
      ]).then(res => {
        WGCOMMON.hideLoading()
        let scrollImg = []
        for (let index = 0; index < 6; index++) {
          scrollImg.push(res[0].couponUrl1)
          scrollImg.push(res[0].couponUrl2)
          scrollImg.push(res[0].couponUrl3)
        }
        // res[1] = 205
        let len = res[1] / (res[0].rewardFee * 320)
        this.setData({
          completed: len < 0 ? 0 : len,
          rewardFee: res[0].rewardFee,
          actualFee: res[1],
          needMorePay: WGFORMAT.formatCurrency(res[0].rewardFee - res[1]),
          scrollImg: scrollImg,
        })
        this.startScroll()
      })
    }
  },
  onUnload() {},
  onShareAppMessage () {
    WGTRACK.logCustomEvent('shareTimeline_challenge')
    return {
      title: '618消费返红包，买越多送越多，最高返60%！！',
      imageUrl: 'https://img.wgmf.com/challenge/img_hytzjh_share.png',
      path: '/modules/MemberPlan/pages/MemberPlan/MemberPlan',
    }
  },
  onShareTimeline() { // 分享朋友圈
    WGTRACK.logCustomEvent('share_challenge')
    return {
      title: '618消费返红包，买越多送越多，最高返60%！！',
      imageUrl: 'https://img.wgmf.com/challenge/img_hytzjh_share.png',
      path: '/modules/MemberPlan/pages/MemberPlan/MemberPlan',
    }
  },
})