import {
  Page,
  WGCOMMON,
  WGAUTH,
  WGFORMAT,
  WGENV,
  WGTRACK,
  WGSUBSCRIBE
} from '../../../../wgUtils/index'
import api from '../../api/index'
import {
  REQUEST,
  API
} from '../../../../utils/index';
import WGAPI from '../../../../api/index'
import MODULES from '../../../../utils/modules'

Page({
  /**
   * 页面的初始数据
   */
  data: {
    modulesData: [],
    swiperIndex: 0,
    scrollImg: [
      'https://img.wgmf.com/img_hytzjh_prize_20.png',
      'https://img.wgmf.com/img_hytzjh_prize_30.png',
      'https://img.wgmf.com/img_hytzjh_prize_100.png',
      'https://img.wgmf.com/img_hytzjh_prize_200.png',
      'https://img.wgmf.com/img_hytzjh_prize_20.png',
      'https://img.wgmf.com/img_hytzjh_prize_30.png',
      'https://img.wgmf.com/img_hytzjh_prize_100.png',
      'https://img.wgmf.com/img_hytzjh_prize_200.png',
      'https://img.wgmf.com/img_hytzjh_prize_20.png',
      'https://img.wgmf.com/img_hytzjh_prize_30.png',
      'https://img.wgmf.com/img_hytzjh_prize_20.png',
      'https://img.wgmf.com/img_hytzjh_prize_30.png',
      'https://img.wgmf.com/img_hytzjh_prize_100.png',
      'https://img.wgmf.com/img_hytzjh_prize_200.png',], 
    animationData1: null, // 绑定的动画效果
    animationData2: null, // 绑定的动画效果
    animationData3: null, // 绑定的动画效果
    couponDetail: null,
    giftFee: '?00',
    rewardFee: '?00',
    completed: 0,
    animationData4: null, // 绑定的动画效果
    showSuccessful: false,
    h: '',
    m: '',
    s: '',
    infoRule: false,
    actPay: 0,
    needMorePay: 0,
    countTick: false
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.init()
    this.countdown()
    this.initModule(WGENV.env == 'TEST' ? 138 : 386) // 初始化页面底部配置项
  },
  initModule(pageId) {
    WGAPI.modules.getById(pageId).then(r => {
      if (r) {
        let newpage = MODULES.formatModules(r)
        this.setData({
          modulesData: newpage,
        })
      }
      WGCOMMON.hideLoading()
    })
  },
  subscribe() {
    WGSUBSCRIBE('getCoupon').then(res => {
      WGCOMMON.toast('预约提醒成功！')
    })
  },
  // 开始滚动
  startScroll() {
    // 创建一个动画实例1
    let animation1 = wx.createAnimation({
      duration: 5000,
      timingFunction: 'ease'
    })
    // 获取元素总高度
    let height1 = (this.data.scrollImg.length - 1) * 240
    // 向上移动
    animation1.translateY(-height1 + 'rpx').step()

    // 创建一个动画实例2
    let animation2 = wx.createAnimation({
      duration: 5000,
      timingFunction: 'ease'
    })
    // 获取元素总高度
    let height2 = (this.data.scrollImg.length - 2) * 240
    // 向上移动
    animation2.translateY(-height2 + 'rpx').step()

    // 创建一个动画实例3
    let animation3 = wx.createAnimation({
      duration: 5000,
      timingFunction: 'ease'
    })
    // 获取元素总高度
    let height3 = (this.data.scrollImg.length - 3) * 240
    // 向上移动
    animation3.translateY(-height3 + 'rpx').step()

    // 将动画效果赋值
    this.setData({
      animationData1: animation1.export(),
      animationData2: animation2.export(),
      animationData3: animation3.export()
    })
  },
  //报名人数数据结构处理
  checkPeoson(fictitiousNumber) {
    let personNumber = fictitiousNumber + '' || '100000000';
    personNumber = personNumber.split('');
    this.setData({
      personNumber: personNumber
    })
  },
  init() {
    let that = this
    api.getCouponDetail().then(res => {
      let scrollImg = []
      for (let index = 0; index < 6; index++) {
        scrollImg.push(res.couponUrl1)
        scrollImg.push(res.couponUrl2)
        scrollImg.push(res.couponUrl3)
      }
      that.checkPeoson(res.fictitiousNumber)
      that.setGiftData(res)
      that.setData({
        couponDetail: res,
        scrollImg: scrollImg
      })
      // this.startScroll()
    })
  },
  setGiftData(res) {
    let that = this
    that.getOrderFee()
    setTimeout(function () {
      that.setData({
        rewardFee: res.rewardFee,
        giftFee: res.giftFee
      })
      //首页暂时不需要动画效果
    }, 2000)
  },
  getOrderFee() {
    api.getOrderFee().then(res => {
      // res = 600
      this.setData({
        needMorePay: WGFORMAT.formatCurrency(this.data.couponDetail.rewardFee - res), // 还差多少钱
        actPay: WGFORMAT.formatCurrency(res) // 活动期间实际消费金额
      })
      var animation = wx.createAnimation({
        duration: 2000,
        timingFunction: 'ease',
        delay: 0
      });
      var animation2 = wx.createAnimation({
        duration: 0,
        timingFunction: 'ease',
        delay: 0
      });
      let moveLength = (res) / (this.data.couponDetail.rewardFee) * 320
      if (moveLength <= 0) {
        moveLength = 0
      }
      if(moveLength >= 320) {
        moveLength = 320
      }
      this.setData({
        completed: moveLength
      })
      this.animation = animation
      var next = true;  
      setInterval(function () { // 无限循环动画
        if (next) {
          animation.translateX(moveLength + 'rpx').step()
          next = !next;
          this.setData({
            animationData4: animation.export()
          })
        } else {
          animation2.translate(0, 0).step()
          next = !next;
          this.setData({
            animationData4: animation2.export()
          })
        }
      }.bind(this), 2000)
    })
  },
  infoRule() { // 查看活动规则弹窗
    let infoRule = !this.data.infoRule;
    this.setData({
      infoRule: infoRule
    })
  },
  countdown() { // 挑战倒计时
    let now = new Date().getTime()
    var time = new Date('2021/06/18 23:59:59').getTime();
    var startTime = new Date('2021/06/17 00:00:00').getTime();  // 发版前记得将此行复原
    // var startTime = new Date('2021/06/08 00:00:00').getTime();  // 发版前记得将此行注释掉
    if(now > startTime) {
      var timer = null;
      var that = this;
      timer = setInterval(function () {
        var leftTime = time - new Date().getTime();
  
        //倒计时结束
        if (leftTime <= 1) {
          clearInterval(timer);
          that.setData({
            d: '00',
            h: '00',
            m: '00',
            s: '00',
            timer: null
          })
          return;
        }
  
        var leftSecond = parseInt(leftTime / 1000);
        var Day = Math.floor(leftSecond / (60 * 60 * 24)); //天数
        var Hour = Math.floor((leftSecond - Day * 24 * 60 * 60) / 3600); //小时
        var Hour2 = Math.floor((leftSecond - Day * 24 * 60 * 60) / 3600) + (Day * 24); //小时
        var Minute = Math.floor((leftSecond - Day * 24 * 60 * 60 - Hour * 3600) / 60); //分钟
        var Second = Math.floor(leftSecond - Day * 24 * 60 * 60 - Hour * 3600 - Minute * 60); //秒数
        if (Minute >= 0 && Second >= 0) {
          that.setData({
            d: Day < 10 ? '0' + Day : Day,
            h: Hour2 < 10 ? '0' + Hour2 : Hour2,
            m: Minute < 10 ? '0' + Minute : Minute,
            s: Second < 10 ? '0' + Second : Second,
          })
        }
      }, 1000)
      this.setData({
        countTick: true
      })
    } else {
      this.setData({
        countTick: false
      })
    }
  },
  onShareAppMessage () {
    WGTRACK.logCustomEvent('shareTimeline_challenge')
    return {
      title: '618消费返红包，买越多送越多，最高返60%！！',
      imageUrl: 'https://img.wgmf.com/challenge/img_hytzjh_share.png',
      path: '/modules/MemberPlan/pages/MemberPlan/MemberPlan',
    }
  },
  onShareTimeline() {
    WGTRACK.logCustomEvent('share_challenge')
    return {
      title: '618消费返红包，买越多送越多，最高返60%！！',
      imageUrl: 'https://img.wgmf.com/challenge/img_hytzjh_share.png',
      path: '/modules/MemberPlan/pages/MemberPlan/MemberPlan',
    }
  }
})