import { WGHTTP } from '../../../wgUtils/index'

export default {
  getPageById: id => {
    return WGHTTP.post('wechat-shop-back/miniApp/getHomePageById?id=' + id)
  },
  list: () => { // 获取首页新品试用明细
    // return WGHTTP.post(`wechat-shop-back/trial/list?miniOpenId=`)
    return WGHTTP.post(`wechat-shop-back/trial/list?miniOpenId=${wx.getStorageSync('openId')}`)
  },
  reserve: data=> { // 预约提醒新品试用
    let queryStr = ''
    for(let key in data) {
      if(data[key] != null) {
        queryStr += `${key}=${data[key]}&`
      }
    }
    // return WGHTTP.get(`wechat-shop-back/evaluation/getEvaListByFlag?${queryStr}pageSize=10`)
    return WGHTTP.post(`wechat-shop-back/trial/reserve?${queryStr}openId=${wx.getStorageSync('openId')}&cusId=${wx.getStorageSync('cusId')}&source=2`)
  },
  reserveNew: parmm=> { // 预约提醒新品试用
    let data = {
      ...parmm,
      openId: wx.getStorageSync('openId'),
      customerId: wx.getStorageSync('cusId'),
      source: 2,
      wechatHeadImgUrl: wx.getStorageSync('avatarUrl'),
      wechatName: wx.getStorageSync('nickName')
    }
    return WGHTTP.post(`wechat-shop-back/trial/reserveNew`, data)
  },
  canTrial: trialId => { // 根据活动id和cusId判断用户是否满足条件
    return WGHTTP.get(`wechat-shop-back/trial/isTrial?trialId=${trialId}&customerId=${wx.getStorageSync('cusId')}`, null, null, 1)
  },
  detail: (trialId,curtPage) => { // 获取新品试用详情
    // return WGHTTP.get(`wechat-shop-back/trial/getTrialDetail?trialId=${trialId}&customerId=&miniOpenId=`)
    return WGHTTP.get(`wechat-shop-back/trial/getTrialDetail?trialId=${trialId}&customerId=${wx.getStorageSync('cusId')}&miniOpenId=${wx.getStorageSync('openId')}&curPage=${curtPage || 1}&pageSize=10`)
  },
  submit: data => { // 提交申请试用表单
    return WGHTTP.post('wechat-shop-back/trial/confirmTrial', data)
  },
  myTrial: (page) => { // 获取我的新品试用信息列表
    return WGHTTP.get(`wechat-shop-back/trial/getTrialByCusId?customerId=${wx.getStorageSync('cusId')}&curPage=${page}&pageSize=1000`)
  },
  getProduct: pid => { // 获取商品详情
    return WGHTTP.get('wechat-shop-back/product/info/template/' + pid)
  },
  orderDetail: orderId => { // 订单详情
    return WGHTTP.get('wechat-shop-back/order/orderDetail/' + orderId)
  },
  trialReport: ( trialId, page ) => {
    return WGHTTP.get(`wechat-shop-back/evaluation/listByTrialId?trialId=${trialId}&curPage=${page}&pageSize=10`)
  },
  getTrialTpicResult: ( trialId ) => {
    return WGHTTP.get(`wechat-shop-back/trial/getTrialTpicResult?trialId=${trialId}`)
  },
    // experienceFlag 1.获取社区首页2.获取营养百科3.获取谷粉说4.试用报告
  // sortNum 排序，最新排序0推荐排序1
  // evaluationTagId 分类id
  /**
   * @data { experienceFlag, curPage, sortNum, evaluationTagId }
   */
  getEvaListByFlag: data => {
    let queryStr = ''
    for(let key in data) {
      if(data[key] != null) {
        queryStr += `${key}=${data[key]}&`
      }
    }
    return WGHTTP.get(`wechat-shop-back/evaluation/getEvaListByFlag?${queryStr}pageSize=10`)
  },
  getTrialProductResult: trialId => {
    return WGHTTP.get(`wechat-shop-back/trial/getTrialProductResult?trialId=${trialId}`)
  },
  getReserveInfo: (trialId, customerId) => {  //根据活动id和cusId判断用户是否申请
    return WGHTTP.get(`wechat-shop-back/trial/getReserveInfo?trialId=${trialId}&customerId=${customerId}`)
  },
}