import WGAPI from '../../api/index'
import {
  Page,
  WGFORMAT,
  WGSUBSCRIBE,
  WGCOMMON,
  WGTRACK
} from '../../../../wgUtils/index'

Page({
  data: {
    activity: null, // 活动详情
    time: { // 活动结束倒计时
      d: '00',
      h: '00',
      m: '00',
      s: '00'
    },
    hideModal1: true,  // 弹窗 - 需要金谷以上会员才能申请试用
    hideModal2: true, // 弹窗 - 之前的试用报告审核通过后才能申请其他试用
    hideModal3: true, // 弹窗-联系客服添加营养师
    hideModal4: true, // 弹窗 - 需要超级会员才能申请
    needLogin: false, // 是否需要登录
    trialId: null, // 活动id
    tmpOperate: null,
    reserveInfo: null, 
    ticker: null, // 定时器
  },
  startTick() {
    let endTime = this.data.activity.trial.endTime
    let now = new Date().getTime()
    let yu = endTime - now,
        d = 0,
        h = 0,
        m = 0,
        s = 0,
        self = this;
    this.data.ticker = setInterval(function () {
      yu = yu - 1000
      if (yu <= 0) {
        clearInterval(this.data.ticker)
        self.initActivity()
      } else {
        d = parseInt(yu / 86400000)
        h = parseInt((yu - d * 86400000) / 3600000)
        m = parseInt((yu - d * 86400000 - h * 3600000) / 60000)
        s = parseInt((yu - d * 86400000 - h * 3600000 - m * 60000) / 1000)
        self.setData({
          time: {
            d: d,
            h: h,
            m: m,
            s: s
          }
        })
      }
    }, 1000)
  },
  initActivity (trialId) {
    let id = trialId?trialId:this.data.trialId
    WGAPI.detail(id).then(res => {  // 获取试用活动详情
      let now = new Date().getTime()
      let isStart = WGFORMAT.targetDateInDateBetwen(res.trial.startTime, res.trial.endTime, now)  // 活动是否在进行中
      res['startTime'] = WGFORMAT.formatDate(res.trial.startTime, 'MM月dd日hh:mm')
      res['startTimeEn'] = WGFORMAT.formatDate(res.trial.startTime, 'yyyy.MM.dd hh:mm')
      res['endTimeEn'] = WGFORMAT.formatDate(res.trial.endTime, 'yyyy.MM.dd hh:mm')
      res['status'] = isStart?1:0  // 活动状态，0未开始，1进行中，2已结束
      res['isRemind'] = res.isBespoke?1:0  // 是否已经提醒我参加，1已提醒，0未提醒
      wx.setNavigationBarTitle({
        title: res.trial.name,
      })
  
      if(now > res.trial.endTime) { // 活动已结束
        res.status = 2
      }
      console.log(res)
      if(res.hasOwnProperty('trialOrderList')) {
        for(let i=0;i<res.trialOrderList.length;i++) {
          res.trialOrderList[i]['submitDateCn'] = WGFORMAT.formatDate(res.trialOrderList[i].submitDate, 'yyyy.MM.dd hh:mm:ss')
        }
      }
      res['applied'] = 0
      if(res.hasOwnProperty('trialOrder') && res.trialOrder.applyStatus > 0) {
        res['applied'] = 1
      }
      console.log('activity活动详情-------', res)
      this.setData({
        activity: res
      })
      if(isStart) { // 进行中，则开始倒计时
        this.startTick()
      }
    })
  },
  handleContact(e) {
    var path = e.detail.path,
    query = e.detail.query,
    params = '';
    if (path) {
      for (var key in query) {
        params = key + '=' + query[key] + '&';
      }
      params = params.slice(0, params.length - 1);
      console.log('path, params------', path, params)
      if(path.indexOf('Home/Home') != -1 || path.indexOf('ProductIndex/ProductIndex') != -1 || path.indexOf('FanCommunity/pages/Index/Index') != -1 || path.indexOf('MyCart/MyCart') != -1 || path.indexOf('PersonalCenter/PersonalCenter') != -1) {
        wx.switchTab({
          url: path + '?' + params
        })
      } else {
        wx.navigateTo({
          url: path + '?' + params
        })
      }
    }
  },
  closeModal () { // 关闭弹窗
    this.setData({
      hideModal1: true,
      hideModal2: true,
      hideModal3: true,
      hideModal4: true
    })
  },
  showContact() {
    // this.setData({
    //   hideModal3: false
    // })
    wx.navigateTo({
      url: `/modules/ProductTrial/pages/enterpriseImg/enterpriseImg?url=${this.data.activity.trial.enterpriseImgUrl}&title=添加营养师&mode=widthFix`
    })
    // wx.navigateTo({
    //   url: `/pages/WebView/WebView?title=添加营养师&url=${this.data.activity.trial.enterpriseImgUrl}`
    // })
  },
  authSuccess() {
    this.setData({
      needLogin: false
    })
    this.initActivity(this.data.trialId)
    switch(this.data.tmpOperate) {
      case 1:this.remindAttend();return;
      case 2:this.applyTrial();return;
      default: return;
    }
  },
  authFail() {
    wx.clearStorage()
    WGAUTH.wxLogin()
    WGCOMMON.toast('授权失败，请重试', 2500)
    this.setData({
      needLogin: false
    })
  },
  checkLogin() { // 检查是否登录
    if(!wx.getStorageSync('openId') || !wx.getStorageSync('cusId') || !wx.getStorageSync('unionId') || !wx.getStorageSync('nickName')) {
      this.setData({
        needLogin: true
      })
      return false // 未登录
    }
    this.setData({
      needLogin: false
    })
    return true // 已经登录了
  },
  remindAttend() { // 提醒我参与新品试用,点击 我要试用  partStatus参与新品试用状态默认0未参与,1参与
    if(this.checkLogin()) {
      WGAPI.reserveNew({trialId: this.data.activity.trial.id, partStatus: 0}).then(() => {
        WGSUBSCRIBE('remindSeckill').then(res => {
          this.initActivity(this.data.trialId)
        })
      })
    } else {
      this.data.tmpOperate = 1
    }
  },
  applyTrial() { // 点击‘我要试用’
    WGTRACK.logCustomEvent('click_trial_ActivityDetail')
    if(this.checkLogin()) {
      let id = this.data.activity.trial.id
      WGAPI.canTrial(id).then(res => { // 是否满足申请条件
        if(res.msg == '需要金谷以上会员才能参与哦') {  // 需要金谷以上会员才能参与哦
          this.setData({
            hideModal1: false
          })
          return
        }
        if(res.msg == '需要超会才能参与哦') {  // 需要超会才能参与哦
          this.setData({
            hideModal4: false
          })
          return
        }
        if(res.msg == '您之前的试用报告通过后才能申请其他试用哦') {
          this.setData({
            hideModal2: false
          })
          return
        }
        if(res.status == -1) {
          WGCOMMON.toast(res.msg, 3500)
          return 
        }
        // 申请试用
        WGAPI.reserveNew({trialId: this.data.activity.trial.id, partStatus: 1}).then((res) => {
            // 订阅
            WGSUBSCRIBE('productTrial').then(res => {
              // this.initActivity(this.data.trialId)
            }).finally(()=>{
              // 订阅完成后
              WGCOMMON.toast('已申请，等待开奖结果', 3500)
              this.initActivity(this.data.trialId)
              this.initReserveInfo(this.data.trialId)
            })
        })
      })
    } else {
      this.data.tmpOperate = 2
    }
  },
  initReserveInfo(trialId){
    if(this.checkLogin()) {
      let cusId = wx.getStorageSync('cusId')
      WGAPI.getReserveInfo(trialId,cusId).then(res =>{
        if(res.status == 0 && res.msg == '操作成功'){
          this.setData({
            reserveInfo: false,
          })
        }else {
          this.setData({
            reserveInfo: res
          })
        }
      })
    }else {
      this.data.tmpOperate = 1
    }
    
  },
  
  onLoad(option) {
    this.setData({
      trialId: option.id
    })
  },
  onShow() {
    this.initActivity(this.data.trialId)
    this.initReserveInfo(this.data.trialId)
    WGTRACK.logCustomEvent('exposure_popup_ActivityDetail')
  },
  onHide() {
    clearInterval(this.data.ticker)
  },
  onShareAppMessage() {
    let that = this
    let title = `${wx.getStorageSync('nickName')}邀请您参加新品试用:` + that.data.activity.trial.name
    if(that.data.activity.status == 2) { // 活动已结束
      title = that.data.activity.trial.name
    }
    return {
      imgUrl: that.data.activity.trial.imgUrl,
      title: title,
    }
  },
  onShareTimeline() { // 分享朋友圈
    let that = this
    let title = `${wx.getStorageSync('nickName')}邀请您参加新品试用:` + that.data.activity.trial.name
    if(that.data.activity.status == 2) { // 活动已结束
      title = that.data.activity.trial.name
    }
    return {
      imgUrl: that.data.activity.trial.imgUrl,
      title: title,
    }
  },
})