import {
  Page, WGCOMMON, WGFORMAT,WGENV
} from '../../../../wgUtils/index'
import api from '../../api/index'
import { REQUEST, API } from '../../../../utils/index';
const app = getApp()

Page({
  data: {
    currentProgress: 0,  // 当前进度 1已申请/2付款/3.提交报告/4审核报告通过/5审核报给未通过/6平台返款
    propercentage: 0,
    status: -1, // 试用报告状态，0申请通过，1被拒
    detail: null, // 试用活动详情
    order: null, // 订单详情
    report: null, // 试用报告
    cusId: wx.getStorageSync('cusId'),
    hideModal1: true,
    hideModal2: true,
    hideModal3: true,
    trialId: null,
    pId: null,
		orderId: null,
		// activity: null,
    // deliveFee: '',
    form: { // 申请表单
      addressId: null, // (integer, optional): 地址id ,
      // applyResc: '', // (string, optional): 申请理由 ,
      // ageStage: '',
			trialTpicRequest : [],
      customerId: wx.getStorageSync('cusId'), // (integer, optional): 客户id ,
      isSvipCustomer: wx.getStorageSync('vipCusStatus') == 1?1:0, // (integer, optional): 是否超级会员0否1是 ,
      miniOpenId: wx.getStorageSync('openId'), // (string, optional): 小程序openId ,
      trialId: null, // (integer, optional): 新品试用活动Id ,
      unionid: wx.getStorageSync('unionId'), // (string, optional): 用户unionid ,
      wechatHeadImgUrl: wx.getStorageSync('avatarUrl'), // (string, optional): 微信头像地址 ,
      wechatName: wx.getStorageSync('nickName'), // (string, optional): 新品试用人昵称
      deliveFee: 0, // 运费,全部默认为0
    },
    triaTpicList:[],
    selectReason:[],
  },
  showQyModal() {
    // this.setData({
    //   hideModal3: false
    // })
    wx.navigateTo({
      url: `/modules/ProductTrial/pages/enterpriseImg/enterpriseImg?url=${this.data.detail.trial.enterpriseImgUrl}&title=添加营养师&mode=widthFix`
    })
    // wx.navigateTo({
    //   url: `/pages/WebView/WebView?title=添加营养师&url=${this.data.detail.trial.enterpriseImgUrlv}`
    // })
  },
  closeModal() {
    this.setData({
      hideModal1: true,
      hideModal2: true,
      hideModal3: true
    })
  },
  handleContact(e) {
    var path = e.detail.path,
    query = e.detail.query,
    params = '';
    if (path) {
      for (var key in query) {
        params = key + '=' + query[key] + '&';
      }
      params = params.slice(0, params.length - 1);
      console.log('path, params------', path, params)
      if(path.indexOf('Home/Home') != -1 || path.indexOf('ProductIndex/ProductIndex') != -1 || path.indexOf('FanCommunity/pages/Index/Index') != -1 || path.indexOf('MyCart/MyCart') != -1 || path.indexOf('PersonalCenter/PersonalCenter') != -1) {
        wx.switchTab({
          url: path + '?' + params
        })
      } else {
        wx.navigateTo({
          url: path + '?' + params
        })
      }
    }
  },
  initOrder() { // 初始化订单
    WGCOMMON.showLoading()
    let fn;
    if(this.data.orderId){
      fn = api.orderDetail(this.data.orderId)
    }else {
      fn = api.getTrialProductResult(this.data.trialId)
    }
    fn.then(res => {
      console.log(res)
      this.setData({
        order: res
      })
      WGCOMMON.hideLoading()
    })
  },
  initReport() { // 试用报告初始化
    let id = this.data.orderId?this.data.orderId:app.globalData.myApplyDetail.trialOrder.orderId
    REQUEST.get(API.get_commentDetail + id).then(r => {
      if(r.data.status == 0) {
        let res = r.data.data
        this.setData({
          report: res[0]
        })
        if(this.data.currentProgress < 1) {
          this.setData({
            currentProgress: 1
          })
        }
      }
    })
  },
  toActivity() {
    wx.navigateTo({
      url: '/modules/ProductTrial/pages/OverActivity/OverActivity?id=' + this.data.trialId
    })
  },
  submitReport() { // 提交试用报告
    let orderStatusId = this.data.order.orderStatusId
    if(orderStatusId == 3 || orderStatusId == 2 || orderStatusId == 9) {  // 待收货- 商品确认收货后 才能提交试用报告
      this.setData({
        hideModal1: false
      })
      return
    }
    if(orderStatusId != 1 && orderStatusId !=7) { // 提交试用报告 - 未支付或交易关闭不可以提交试用报告
      app.globalData['trialData'] = { // 试用信息
        activity: this.data.detail,
        order: this.data.order,
        report: this.data.report?this.data.report:null
      }
      wx.navigateTo({
        url: `/modules/FanCommunity/pages/PostComment/PostComment?isTrial=1&trialId=${this.data.trialId}&pId=${this.data.pId}&orderId=${this.data.orderId}` 
      })
    }
  },
  submitForm() { // 提交申请表单
    console.log(this.data.form)
    let that = this
    if(!this.data.form.addressId) {
      WGCOMMON.toast('请填写收货地址')
      return
    }
    let noReasonArr = [] 
    this.data.selectReason.map((item, i) => {
      if(!item || item.length == 0) {
        noReasonArr.push(i+1)
      }
    })
    if(noReasonArr.length > 0) {
      WGCOMMON.toast(`请选择申请理由`)
      return
    }
    this.data.form.wechatHeadImgUrl = wx.getStorageSync('avatarUrl')
    this.data.form.wechatName = wx.getStorageSync('nickName')
    this.data.form.unionid = wx.getStorageSync('unionId')
    this.data.form.miniOpenId = wx.getStorageSync('openId')
    this.data.form.customerId = wx.getStorageSync('cusId')
    if(!this.data.applying) { // 没有正在申请中
      this.setData({ // 锁启动，用户重新点击不会重复下单
        applying: true
      })
      WGCOMMON.showLoading()
      // 下单   应该要改，因为要有抽奖逻辑
      REQUEST.post(WGENV.baseUrl + 'wechat-shop-back/trial/confirmTrial', {
        header: {
          'content-type': 'application/json'
        },
        data: {...this.data.form, trialId: this.data.trialId, trialTpicRequest: this.data.selectReason}
      }).then(r => {
        if(r.data.status == 0) {
          let res = r.data.data
          let item = {
            trial: this.data.detail.trial,
            trialOrder: res
          }
          item.trial['startTimeEn'] = WGFORMAT.formatDate(item.trial.startTime, 'yyyy.MM.dd hh:mm')
          item.trial['endTimeEn'] = WGFORMAT.formatDate(item.trial.endTime, 'yyyy.MM.dd hh:mm')
          app.globalData['myApplyDetail'] = item
          console.log('myApplyDetail----------', item)
          if(res) {
            let orderId = res.orderId
            that.setData({
              orderId: res.orderId
            })
            api.orderDetail(res.orderId).then(res => {
              if(res) {
                wx.request({
                  url: WGENV.baseUrl + 'wechat-pay/pay/bill/ma' + res.orderCode,
                  method: 'POST',
                  header: {
                    'content-type': 'application/x-www-form-urlencoded'
                  },
                  data: {
                    openId: wx.getStorageSync('openId')
                  },
                  success(res) {
                    if(res) {
                      let data = res.data
                      // 支付
                      wx.requestPayment({
                        'timeStamp': data.timeStamp,
                        'nonceStr': data.nonceStr,
                        'package': data.packageStr,
                        'signType': data.signType || 'MD5',
                        'paySign': data.paySign,
                        'success': function(res) { // 支付成功跳转到申请详情页
                          // app.globalData['myApplyDetail'] = item
                          WGCOMMON.hideLoading()
                          this.setData({
                            order: res
                          })
                          that.setData({
                            applying: false
                          })
                        },
                        'fail': function (res) { // 未支付or支付失败，跳转到订单详情页
                          WGCOMMON.hideLoading()
                          that.setData({
                            applying: false
                          })
                          wx.redirectTo({
                            url: '/pages/OrderDetail/OrderDetail?billId=' + orderId
                          })
                        }
                      })
                    } else {
                      this.setData({
                        applying: false
                      })
                    }
                  },
                  fail(err) {
                    WGCOMMON.toast(err)
                    that.setData({
                      applying: false
                    })
                    WGCOMMON.hideLoading()
                  }
                })
              } else {
                that.setData({
                  applying: false
                })
                WGCOMMON.hideLoading()
              }
            })
          } else {
            that.setData({
              applying: false
            })
            WGCOMMON.hideLoading()
          }
        } else if (r.data.status == -2) {
          WGCOMMON.hideLoading()
          that.setData({
            applying: false
          })
          if(that.data.detail.trial.giftCouponId){
            that.setData({
              hideModal2: false,
            })
          }else {
            WGCOMMON.toast(r.data.msg)
          }
        } else {
          that.setData({
            applying: false
          })
          WGCOMMON.hideLoading()
          WGCOMMON.toast(r.data.msg)
        }
      }).catch(e => {
        that.setData({
          applying: false
        })
        WGCOMMON.hideLoading()
      })
    }
  },
  setCurProgress() {

    // applyStatus (integer, optional): 申请状态 
    // 0 ，已申请  1，付款    6，提交报告  7，试用报告未通过  8，平台返款
    // currentProgress: 0,  // 当前进度 1已申请/2付款/3.提交报告/4审核报告通过/5审核报给未通过/6平台返款
    let status = this.data.detail.trialOrder ? this.data.detail.trialOrder.applyStatus : 0
    console.log('当前试用状态-----', status)
    if(status == 1) { // 付款 
      this.setData({
        status: -1, // 试用报告状态，0申请通过，1被拒
        propercentage: 25,
        currentProgress: 2
      })
      return
    }
    if(status == 5) { // 确认收货
      this.setData({
        status: -1, // 试用报告状态，0申请通过，1被拒
        propercentage: 25,
        currentProgress: 2
      })
      return
    }
    if(status == 6) { //  6，提交报告
      this.setData({
        status: -1, // 试用报告状态，0申请通过，1被拒
        propercentage: 50,
        currentProgress: 3
      })
      return
    }
    if(status == 7) { // 7，试用报告未通过 
      this.setData({
        status: 1,
        propercentage: 75,
        currentProgress: 5
      })
      return
    }
   
    if(status == 8) { //  8，平台返款
      this.setData({
        status: 0,
        propercentage: 100,
        currentProgress: 6
      })
      return
    }


  },
  // 单选
  triaTpicRadio(e){
    let selectArr = JSON.parse(JSON.stringify(this.data.selectReason))
    selectArr[e.currentTarget.dataset.index] = {
      triaTpicAnswers: e.currentTarget.dataset.item.id + '',
      trialTopicId: this.data.triaTpicList[e.currentTarget.dataset.index].triaTpic.id
    }
    this.setData({
      selectReason: selectArr
    })
  },
  // 多选
  triaTpicMultiple(e){
    let selectArr = JSON.parse(JSON.stringify(this.data.selectReason))
    let data = selectArr[e.currentTarget.dataset.index]
    if(!selectArr[e.currentTarget.dataset.index] || !selectArr[e.currentTarget.dataset.index].triaTpicAnswers) {
      selectArr[e.currentTarget.dataset.index] = {
        triaTpicAnswers: '',
        trialTopicId: ''
      }
    }
    let triaTpicListClone = JSON.parse(JSON.stringify(this.data.triaTpicList))
    let arr = selectArr[e.currentTarget.dataset.index].triaTpicAnswers ? selectArr[e.currentTarget.dataset.index].triaTpicAnswers.split(',') : []
    let idx = arr.findIndex((i)=>{return i == e.currentTarget.dataset.item.id })
    if(idx != -1){
      arr.splice(idx,1)
      triaTpicListClone[e.currentTarget.dataset.index].answerTrialList[e.currentTarget.dataset.idx].chencked = false
      selectArr[e.currentTarget.dataset.index].trialTopicId = this.data.triaTpicList[e.currentTarget.dataset.index].triaTpic.id
    } else {
      arr.push(e.currentTarget.dataset.item.id)
      triaTpicListClone[e.currentTarget.dataset.index].answerTrialList[e.currentTarget.dataset.idx].chencked = true
      selectArr[e.currentTarget.dataset.index].trialTopicId = this.data.triaTpicList[e.currentTarget.dataset.index].triaTpic.id
    }
    selectArr[e.currentTarget.dataset.index].triaTpicAnswers = arr.join()
    this.setData({
      selectReason: selectArr,
      triaTpicList: triaTpicListClone,
    })
  },
  initTrial() {
    let id = this.data.trialId
    api.detail(id).then(res => {  // 获取试用活动详情
      this.setData({
        detail: res,
        selectReason: res.trialTpicDetail
      })
      api.getTrialTpicResult(this.data.trialId).then(data => {  // 获取试用活动申请原因
        let arr = []
        // 付款后
        if(res.trialTpicDetail && res.trialTpicDetail.length > 0) {
          arr = res.trialTpicDetail
        }
        this.setData({
          triaTpicList: arr.length > 0 ? arr : data,
          selectReason: (new Array(data.length)).fill(undefined)
        })
      })
      this.setCurProgress()
    })
  },

	getAddress (args) {
    this.setData({
      ['form.addressId']: args.detail.address.id,
      // ['form.deliveFee']: args.detail.deliveFee,
    })
  },
  onLoad(option) {
    this.setData({
      trialId: option.trialId,
      orderId: option.orderId,
      pId: option.pId,
      detail: app.globalData.myApplyDetail,
    })
    
  },
  onShow() {
    this.closeModal()
    this.initTrial()
    this.initOrder()
    if(this.data.orderId){
      this.initReport()
    }
  },
})