import {
  Page, WGCOMMON, WGFORMAT
} from '../../../../wgUtils/index'
import api from '../../api/index'
import { REQUEST, API } from '../../../../utils/index';
const app = getApp()

Page({
  data: {
    currentProgress: 0,  // 当前进度 1已申请/2报告待提交/3报告待审核/4试用结果
    propercentage: 0,
    status: -1, // 试用报告状态，0申请通过，1被拒
    detail: null, // 试用活动详情
    order: null, // 订单详情
    report: null, // 试用报告
    cusId: wx.getStorageSync('cusId'),
    hideModal1: true,
    hideModal2: true,
    trialId: null,
    pId: null,
    orderId: null
  },
  showQyModal() {
    // this.setData({
    //   hideModal2: false
    // })
    wx.navigateTo({
      url: '/pages/HowBeGold/HowBeGold?type=4'
    })
  },
  closeModal() {
    this.setData({
      hideModal1: true,
      hideModal2: true
    })
  },
  handleContact(e) {
    var path = e.detail.path,
    query = e.detail.query,
    params = '';
    if (path) {
      for (var key in query) {
        params = key + '=' + query[key] + '&';
      }
      params = params.slice(0, params.length - 1);
      console.log('path, params------', path, params)
      if(path.indexOf('Home/Home') != -1 || path.indexOf('ProductIndex/ProductIndex') != -1 || path.indexOf('FanCommunity/pages/Index/Index') != -1 || path.indexOf('MyCart/MyCart') != -1 || path.indexOf('PersonalCenter/PersonalCenter') != -1) {
        wx.switchTab({
          url: path + '?' + params
        })
      } else {
        wx.navigateTo({
          url: path + '?' + params
        })
      }
    }
  },
  initOrder() { // 初始化订单
    WGCOMMON.showLoading()
    let id = this.data.orderId?this.data.orderId:app.globalData.myApplyDetail.trialOrder.orderId
    api.orderDetail(id).then(res => {
      this.setData({
        order: res
      })
      WGCOMMON.hideLoading()
    })
  },
  initReport() { // 试用报告初始化
    let id = this.data.orderId?this.data.orderId:app.globalData.myApplyDetail.trialOrder.orderId
    REQUEST.get(API.get_commentDetail + id).then(r => {
      if(r.data.status == 0) {
        let res = r.data.data
        this.setData({
          report: res[0]
        })
        if(this.data.currentProgress < 2) {
          this.setData({
            currentProgress: 2
          })
        }
      }
    })
  },
  toActivity() {
    wx.navigateTo({
      url: '/modules/ProductTrial/pages/OverActivity/OverActivity?id=' + this.data.trialId
    })
  },
  submitReport() { // 提交试用报告
    let orderStatusId = this.data.order.orderStatusId
    if(orderStatusId == 3 || orderStatusId == 2 || orderStatusId == 9) {  // 待收货- 商品确认收货后 才能提交试用报告
      this.setData({
        hideModal1: false
      })
      return
    }
    if(orderStatusId != 1 && orderStatusId !=7) { // 提交试用报告 - 未支付或交易关闭不可以提交试用报告
      app.globalData['trialData'] = { // 试用信息
        activity: this.data.detail,
        order: this.data.order,
        report: this.data.report?this.data.report:null
      }
      wx.navigateTo({
        url: `/modules/FanCommunity/pages/PostComment/PostComment?isTrial=1&trialId=${this.data.trialId}&pId=${this.data.pId}&orderId=${this.data.orderId}` 
      })
    }
  },
  setCurProgress() {
    // applyStatus (integer, optional): 申请状态 
    // 0 ，未申请 1，已申请 
    // 2，待审核 3，审核通过 4，审核拒绝 5，试用报告待提交 
    // 6，试用报告待审核 7，试用报告未通过 8，试用报告已完成 
    let status = this.data.detail.trialOrder.applyStatus
    console.log('当前试用状态-----', status)
    if(status == 7) { // 7，试用报告未通过
      this.setData({
        status: 1,
        propercentage: 66.6,
        currentProgress: 4
      })
      return
    }
    if(status == 8) { // 8，试用报告已完成
      this.setData({
        status: 0,
        propercentage: 100,
        currentProgress: 4
      })
      return
    }
    if(status == 5) { // 5，试用报告待提交
      this.setData({
        propercentage: 33.3,
        currentProgress: 2
      })
      return
    }
    if(status == 6) {
      this.setData({
        propercentage: 66.66,
        currentProgress: 3
      })
      return
    }
  },
  initTrial() {
    let id = this.data.trialId
    api.detail(id).then(res => {  // 获取试用活动详情
      let now = new Date().getTime()
      let isStart = WGFORMAT.targetDateInDateBetwen(res.trial.startTime, res.trial.endTime, now)  // 活动是否在进行中
      res.trial['startTimeEn'] = WGFORMAT.formatDate(res.trial.startTime, 'yyyy.MM.dd hh:mm')
      res.trial['endTimeEn'] = WGFORMAT.formatDate(res.trial.endTime, 'yyyy.MM.dd hh:mm')
      res['status'] = isStart?1:0  // 活动状态，0未开始，1进行中，2已结束
      res['isRemind'] = res.isBespoke?1:0  // 是否已经提醒我参加，1已提醒，0未提醒
      console.log('res.trial----------', res)
      this.setData({
        detail: res
      })
      this.setCurProgress()
    })
  },
  onLoad(option) {
    this.setData({
      trialId: option.trialId,
      orderId: option.orderId,
      pId: option.pId,
      detail: app.globalData.myApplyDetail
    })
  },
  onShow() {
    this.closeModal()
    this.initOrder()
    this.initReport()
    this.initTrial()
  },
})