import WGAPI from '../../api/index'
import {
  WGENV,
  Page,
  WGCOMMON,
  WGFORMAT
} from '../../../../wgUtils/index'
import {
  REQUEST, API
} from '../../../../utils/index'

Page({
  data: {
    curPage: 1,
    curPage1: 1, //试用名单分页
    showMorePeople: true,
    trialId: null,
    currentTabIndex: 0,
    moreTxt: '拖动加载下一页',
    activity: {
      id: 2,
      title: '解码少女新肌密细滑弹亮养肤套盒试用装', // 试用活动名称
      imgUrl: 'http://img.wgmf.com/pro_11课1583400427421.jpg', // 图片
      quantity: 100, // 试用份数
      startTime: '5月1日20:00', // 活动开始时间
      endTimne: 1589126399000, // 活动结束时间
      status: 1, // 0未开始，1进行中，2已结束
      applyPeople: 186, // 申请人数
      applyPeopleList: [
        {
          id: 1,
          nickname: '千与千寻',
          avatar: 'http://thirdwx.qlogo.cn/mmopen/Q3auHgzwzM4nDQk9dZGsQvNMJYibmqBfSoGeicUXbdF8fHfFic3wCH59kRceqMBb6d9ejKvibyib7mjXF2N7cvnicprvkNCN9PJXcqXNSr3GkOmUA/132',
          applyDate: '2020-05-28 18:00:08'
        },
        {
          id: 2,
          nickname: '青玉',
          avatar: 'http://thirdwx.qlogo.cn/mmopen/Q3auHgzwzM4nDQk9dZGsQvNMJYibmqBfSoGeicUXbdF8fHfFic3wCH59kRceqMBb6d9ejKvibyib7mjXF2N7cvnicprvkNCN9PJXcqXNSr3GkOmUA/132',
          applyDate: '2020-05-28 18:00:08'
        },
        {
          id: 3,
          nickname: '五谷磨房小王',
          avatar: 'http://thirdwx.qlogo.cn/mmopen/Q3auHgzwzM4nDQk9dZGsQvNMJYibmqBfSoGeicUXbdF8fHfFic3wCH59kRceqMBb6d9ejKvibyib7mjXF2N7cvnicprvkNCN9PJXcqXNSr3GkOmUA/132',
          applyDate: '2020-05-28 18:00:08'
        },
      ]
    },
    canIUseGetUserProfile: false,
    trialReports: [], // 试用报告
    myReports: [], // 我的试用报告
    trialPeople: [] // 试用名单
  },
  changeTabIndex(e) {
    let index = Number(e.currentTarget.dataset.index)
    if (index != this.data.currentTabIndex) {
      this.setData({
        currentTabIndex: index
      })
    }
  },
  loadMorePeople(){
    this.setData({
      curPage1: this.data.curPage1 + 1
    })
    this.initActivity(this.data.trialId)
  },
  initActivity(id) { // 试用活动详情
    WGAPI.detail(id, this.data.curPage1).then(res => {
      if(res.hasOwnProperty('trialOrder')) {
        this.initMyReport(res.trialOrder.orderId)
      }
      this.setData({
        activity: res
      })
      // let applyList = res.trialOrderList
      let applyList = res.trialBespokeList
      if(applyList.length < 10){
        this.setData({
          showMorePeople: false
        })
      }
      let arr = []
      for(let i=0;i<applyList.length;i++) {
        // if(applyList[i].applyStatus > 0) {
          arr.push({
            avatar: applyList[i].wechatHeadImgUrl?applyList[i].wechatHeadImgUrl:'https://img.wgmf.com/img_default1.png',
            nickname: applyList[i].wechatName?applyList[i].wechatName:'匿名',
            applyDate: WGFORMAT.formatDate(applyList[i].submitDate, 'yyyy.MM.dd hh:mm:ss')
          })
        // }
      }
      console.log('applyList-------', arr)
      this.setData({
        trialPeople: [ ...this.data.trialPeople, ...arr]
      })
      console.log(this.data.trialPeople)
    })
  },
  toFansSay (e) {
    wx.navigateTo({
      url: '/modules/FanCommunity/pages/CommentDetail/CommentDetail?id=' + e.currentTarget.dataset.id
    })
  },
  initMyReport(orderId) { // 我的报告初始化
    let cusId = wx.getStorageSync('cusId')
    if(cusId && orderId) {
      REQUEST.get(API.get_commentDetail + orderId).then(r => {
        if(r.data.status == 0) {
          let data = r.data.data
          console.log('我的试用报告', data)
          for (let i = 0; i < data.length; i++) {
            data[i].isLike = false
            data[i].formatThumbUpNumber = WGFORMAT.formatNumber(data[i].thumbUpNumber)
            data[i].formatBrowseNumber = WGFORMAT.formatNumber(data[i].browseNumber)
            data[i]['isMine'] = (cusId == data[i].cusId)?true:false
            let imgs = data[i].evaluationImages
            imgs.sort(function(a, b) {
              if (a.sortingOrder - b.sortingOrder == 0) {
                return a.id - b.id
              }
              return a.sortingOrder - b.sortingOrder
            })
            data[i]['evaluationImages'] = imgs
          }
          this.setData({
            myReports: data
          })
        }
      })
    }
  },
  initReport() {
    let cusId = wx.getStorageSync('cusId')
    if (this.data.moreTxt == '别拖啦，到底啦~') return false
    let arr = this.data.trialReports
    let curPage = this.data.curPage
    if(curPage == 1) {
      arr = []
      WGCOMMON.showLoading()
    }
    REQUEST.get(WGENV.baseUrl + `wechat-shop-back/evaluation/listByTrialId?trialId=${this.data.trialId}&curPage=${curPage}&pageSize=10`).then(res => {
      let data = res.data.data
      if (res.data.status == 0 && data.length > 0) {
        for (let i = 0; i < data.length; i++) {
          data[i].isLike = false
          data[i].formatThumbUpNumber = WGFORMAT.formatNumber(data[i].thumbUpNumber)
          data[i].formatBrowseNumber = WGFORMAT.formatNumber(data[i].browseNumber)
          data[i]['isMine'] = (cusId == data[i].cusId)?true:false
          let imgs = data[i].evaluationImages
          imgs.sort(function(a, b) {
            if (a.sortingOrder - b.sortingOrder == 0) {
              return a.id - b.id
            }
            return a.sortingOrder - b.sortingOrder
          })
          data[i]['evaluationImages'] = imgs
        }
        this.setData({
          curPage: curPage + 1,
          trialReports: [...arr, ...data]
        })
      } else {
        this.setData({
          moreTxt: '别拖啦，到底啦~'
        })
      }
      WGCOMMON.hideLoading()
    })
  },
  toProductDetail(){
    wx.navigateTo({
      url: '/pages/ProductDetail/ProductDetail?pId=' + this.data.activity.trial.productTemplateId,
    })
  },
  onReachBottom() {
    this.initReport()
  },
  onLoad(option) {
    this.setData({
      trialId: option.id
    })
    this.initActivity(option.id)
    this.initReport()
    if (wx.getUserProfile) {
      this.setData({
        canIUseGetUserProfile: true
      })
    }
  },
  onShareAppMessage() {
    let that = this
    return {
      title: that.data.activity.trial.name,
      imgUrl: that.data.activity.trial.imgUrl
    }
  },
  onShareTimeline() { // 分享朋友圈
    let that = this
    return {
      title: that.data.activity.trial.name,
      imgUrl: that.data.activity.trial.imgUrl
    }
  },
})