import WGAPI from '../../api/index'
import {
  WGENV,
  Page,
  WGFORMAT,
  WGAUTH,
  WGCOMMON,
  WGTRACK
} from '../../../../wgUtils/index'
import modules from '../../../../utils/modules'
const app = getApp()

Page({
  data: {
    modulesData: null,
    swiperIndex: 0,
    pageId: WGENV.env == 'TEST' ? 115 : 137, // 试用中心顶部banner在后台编辑
    scrollTop: 0, 
    currentTabIndex: 0,  // 当前tabindex
    activityList: [], // 试用活动列表
    myTrialList: [],  // 我的试用列表
    page: 1, 
    needLogin: false, //  是否显示登陆弹窗
    tmpArgs: null, // 下一步操作的参数
    tmpOperate: null, // 下一步操作：1切换tabIndex，2跳转到活动详情，3提醒我参与活动
    len: 0, //正在进行中的数量
    tickerList:[],
  },
  authSuccess() {
    this.setData({
      needLogin: false
    })
    this.initMyList()
    this.initList()
    switch(this.data.tmpOperate) {
      case 1:this.changeTabIndex(this.data.tmpArgs);return;
      case 2:this.toDetail(this.data.tmpArgs);return;
      case 3:this.remindAttend(this.data.tmpArgs);return;
      default: return;
    }
  },
  authFail() {
    wx.clearStorage()
    WGAUTH.wxLogin()
    WGCOMMON.toast('授权失败，请重试', 2500)
    this.setData({
      needLogin: false
    })
  },
  checkLogin() { // 检查是否登录
    if(!wx.getStorageSync('openId') || !wx.getStorageSync('cusId') || !wx.getStorageSync('unionId') || !wx.getStorageSync('nickName')) {
      this.setData({
        needLogin: true // 需要登录
      })
      return false // 未登录
    }
    this.setData({
      needLogin: false
    })
    return true // 已经登录了
  },
  initPage() { // 初始化顶部banner图
    WGAPI.getPageById(this.data.pageId).then(r => {
      if (r) {
        let newpage = modules.formatModules(r)
        this.setData({
          modulesData: newpage,
          swiperIndex: 0,
        })
      }
    })
  },
  scrollTopFun(e){
    this.setData({
      scrollTop: e.detail.scrollTop
    })
  },
  changeTabIndex (e) { // 切换topbar
    let index = e.currentTarget.dataset.index
    if(index == 1) {
      this.initMyList()
    } else {
      this.initList()
    }
    if(index == 1 && !this.checkLogin()) {
      this.data.tmpOperate = 1
      this.data.tmpArgs = e
      return
    }
    this.setData({
      currentTabIndex: index
    })
  },
  toDetail (e) { // 跳转到活动详情页或购买同款
    WGTRACK.logCustomEvent('click_trial_toActivityDetail')
    if(this.checkLogin()) {
      let item = e.currentTarget.dataset.item
      if(item.status == 2) { // 活动已经结束，跳转到同款详情页
        wx.navigateTo({
          url: '/pages/ProductDetail/ProductDetail?pId=' + item.trial.productTemplateId
        })
      } else { // 跳转到活动详情页
        wx.navigateTo({
          url: '/modules/ProductTrial/pages/ActivityDetail/ActivityDetail?id=' + item.trial.id
        })
      }
    } else {
      this.setData({
        tmpOperate: 2,
        tmpArgs: e,
      })
    }
  },
  // 查看试用报告/活动已结束
  toTrialDetail(e){
    WGTRACK.logCustomEvent('click_trial_toActivityDetail')
    if(this.checkLogin()) {
      let item = e.currentTarget.dataset.item
      if(item.status == 2) { // 活动已经结束，跳转到试用详情页
        wx.navigateTo({
          url: '/modules/ProductTrial/pages/OverActivity/OverActivity?id=' + item.trial.id
        })
      // } else { // 跳转到活动详情页
      //   wx.navigateTo({
      //     url: '/modules/ProductTrial/pages/ActivityDetail/ActivityDetail?id=' + item.trial.id
      //   })
      }
    } else {
      this.setData({
        tmpOperate: 2,
        tmpArgs: e,
      })
    }
  },
  startTick() {
    let now = new Date().getTime()
    this.data.tickerList = new Array(this.data.len)
    for(let i = 1; i < this.data.len; i++){
      let yu = this.data.activityList[i-1].trial.endTime - now,
        d = 0,
        h = 0,
        m = 0,
        s = 0,
        self = this;
      const ticker = setInterval(function () {
        yu = yu - 1000
        if (yu <= 0) {
          clearInterval(this.data.tickerList[i-1])
          self.initList()
        } else {
          d = parseInt(yu / 86400000)
          h = parseInt((yu - d * 86400000) / 3600000)
          m = parseInt((yu - d * 86400000 - h * 3600000) / 60000)
          s = parseInt((yu - d * 86400000 - h * 3600000 - m * 60000) / 1000)
          let activityList = self.data.activityList
          activityList[i-1].time =  {
            d: d,
            h: h,
            m: m,
            s: s
          }
          self.setData({
            activityList: activityList
          })
        }
      }, 1000)
      let tickerList = this.data.tickerList;
      tickerList[i-1] = ticker;
      this.setData({
        tickerList: tickerList 
      })
    }
  },
  initList() { // 初始化试用中心活动列表
    WGCOMMON.showLoading()
    WGAPI.list().then(res => {
      let arr = []
      for(let i=0;i<res.onTrialList.length;i++) {
        res.onTrialList[i]['status'] = 1 // 0未开始，1进行中，2已结束
        res.onTrialList[i]['startTime'] = WGFORMAT.formatDate(res.onTrialList[i].trial.startTime, 'MM月dd日hh:mm')
        res.onTrialList[i]['endTime'] = WGFORMAT.formatDate(res.onTrialList[i].trial.endTime, 'MM月dd日hh:mm')
        res.time = {}
      }
      for(let i=0;i<res.beginTrialList.length;i++) {
        res.beginTrialList[i]['status'] = 0 // 0未开始，1进行中，2已结束
        res.beginTrialList[i]['startTime'] = WGFORMAT.formatDate(res.beginTrialList[i].trial.startTime, 'MM月dd日hh:mm')
        res.beginTrialList[i]['endTime'] = WGFORMAT.formatDate(res.beginTrialList[i].trial.endTime, 'MM月dd日hh:mm')
        res.beginTrialList[i]['isRemind'] = res.beginTrialList[i].isBespoke?1:0  // isBespoke (integer, optional): 是否提醒0否1是 ,
      }
      for(let i=0;i<res.endTrialList.length;i++) {
        res.endTrialList[i]['status'] = 2 // 0未开始，1进行中，2已结束
        res.endTrialList[i]['startTime'] = WGFORMAT.formatDate(res.endTrialList[i].trial.startTime, 'MM月dd日hh:mm')
        res.endTrialList[i]['endTime'] = WGFORMAT.formatDate(res.endTrialList[i].trial.endTime, 'MM月dd日hh:mm')
      }
      arr.push(...res.onTrialList, ...res.beginTrialList, ...res.endTrialList)
      let narr = []
      for(let i=0;i<arr.length;i++) {
        if(arr[i].trial.shelvesStatus == 1) {
          narr.push(arr[i])
        }
      }
      this.setData({
        activityList: narr,
        len: res.onTrialList.length
      })
      this.startTick()
      WGCOMMON.hideLoading()
    }).catch(() => {
      WGCOMMON.hideLoading()
    })
  },
  getStatusCn(i) {
    switch(i) {
      case 0: return '未申请';
      case 1: return '试用报告待提交';
      case 2: return '待审核';
      case 3: return '审核通过';
      case 4: return '审核拒绝';
      case 5: return '试用报告待提交';
      case 6: return '试用报告审核中';
      case 7: return '试用报告未通过';
      case 8: return '试用报告已完成';
    }
  },
  initMyList() { // 初始化我的申请试用列表
    WGAPI.myTrial(this.data.page).then(res => {
      let arr1 = res.myTrialDetailResult
      let arr2 = res.mySelectTrialDetailResult
      for(let i=0;i<arr1.length;i++) {
        arr1[i].trialOrder['applyStatusCn'] = this.getStatusCn(arr1[i].trialOrder.applyStatus)
      }
      for(let i=0;i<arr2.length;i++) {
        // selected (integer, optional): 是否被选上：0否，1是 ,
        let text = ''
        if(arr2[i].trial.endTime > new Date().valueOf()){
          text = '待开奖'
        }else if(!arr2[i].trialBespoke.partStatus) {
          text='未申请'
        }else if(arr2[i].trialBespoke.partStatus == 1 && arr2[i].trialBespoke.selected == 0){
          text = '未获得本次试用资格'
        } else if(arr2[i].trialBespoke.partStatus == 1 && arr2[i].trialBespoke.selected == 1){
          text = '待付款'
        }
        arr2[i].trial['applyStatusCn'] = text
      }
      this.setData({
        myTrialList: [...arr1, ...arr2]
      })
    })
  },
  remindAttend(e) { // 提醒我参与新品试用
    if(this.checkLogin()) {
      WGAPI.reserve({trialId: e.currentTarget.dataset.id}).then(() => {
        WGSUBSCRIBE('remindSeckill').then(() => {
          this.initList()
        })
      })
    } else {
      this.data.tmpOperate = 3
      this.data.tmpArgs = e
    }
  },
  toApplyDetail(e) { // 跳转到申请详情
    let item = e.currentTarget.dataset.item
    item.trial['startTimeEn'] = WGFORMAT.formatDate(item.trial.startTime, 'yyyy.MM.dd hh:mm')
    item.trial['endTimeEn'] = WGFORMAT.formatDate(item.trial.endTime, 'yyyy.MM.dd hh:mm')
    app.globalData['myApplyDetail'] = item
    console.log('myApplyDetail----------', item)
    // 没有新品试用权限不跳转
    // 待开奖
    if(item.trial.endTime > new Date().valueOf()){
      wx.navigateTo({
        url: '/modules/ProductTrial/pages/ActivityDetail/ActivityDetail?id=' + item.trial.id
      })
      return
    }
    if(item.trial.applyStatusCn =='未获得本次试用资格' || (item.trialBespoke ? !item.trialBespoke.partStatus: false)) {
      return
    }
    wx.navigateTo({
      url: `/modules/ProductTrial/pages/ApplicationDetails/ApplicationDetails?trialId=${item.trial.id}&orderId=${item.trialOrder ? item.trialOrder.orderId : ''}&pId=${item.trial.productTemplateId}` 
    })
  },
  onLoad(option) {
    if(option.tabIndex) {
      this.setData({
        currentTabIndex: Number(option.tabIndex)
      })
    }
    try {   
      wx.onCopyUrl(() => {
        return { query: WGFORMAT.formatQueryByOptions(option) }
      })
    } catch (error) {
      console.warn('暂不支持wx.onCopyUrl')
    }
  },
  onShow() {
    this.initPage()
    if(this.data.currentTabIndex == 1 && !this.checkLogin()){
      this.setData({
        tmpOperate: 1,
        tmpArgs: 1,
      })
    }
    if(this.data.currentTabIndex == 1 && this.checkLogin()){
      this.initMyList()
    } else {
      this.initList()
    }
    // 埋点  活动页PV，UV
    WGTRACK.logCustomEvent('exposure_popup_trial')
  },
  onHide(){
    for(let i=0; i < this.data.len-1; i++){
      clearInterval(this.data.tickerList[i])
    }
  },
  onShareAppMessage() {
    return {
      title: '五谷磨房新品试用中心'
    }
  },
  onShareTimeline() { // 分享朋友圈
    return {
      title: '五谷磨房新品试用中心'
    }
  },
})