import WGAPI from '../../api/index'
import {
  WGENV,
  Page,
  WGCOMMON,
  WGFORMAT
} from '../../../../wgUtils/index'
import {
  REQUEST, API
} from '../../../../utils/index'

Page({
  data: {
    trialId: null,
    currentTabIndex: 0,
    
    canIUseGetUserProfile: false,
    trialReports: {
      allReports: [], // 试用报告
      myReports: [], // 我的试用报告
    },
    // trialReports: [],
    // allReports: [], // 试用报告
    // myReports: [], // 我的试用报告
    reportQueryData: {
      experienceFlag: 4, // experienceFlag 1.获取社区首页2.获取营养百科3.获取谷粉说4.试用报告
      sortNum: 1, // 最新排序0  推荐排序1
    },

    allCurPage: 1, // 
    myCurPage: 1, // 
    allMoreTxt: '拖动加载下一页',
    myMoreTxt: '拖动加载下一页',
    allLoading: false, // 页面数据是否正在加载中
    myLoading: false, // 页面数据是否正在加载中
    allCanPullDownRefresh: true, // 是否可以上拉下一页
    myCanPullDownRefresh: true, // 是否可以上拉下一页
  },
  changeTabIndex(e) {
    let index = Number(e.currentTarget.dataset.index)
    if (index != this.data.currentTabIndex) {
      this.setData({
        currentTabIndex: index
      })
    }
  },
  toFansSay (e) {
    wx.navigateTo({
      url: '/modules/FanCommunity/pages/CommentDetail/CommentDetail?id=' + e.currentTarget.dataset.id
    })
  },
  toApplyList(){
    wx.navigateTo({
      url: '/modules/ProductTrial/pages/TrialCenter/TrialCenter'
    })
  },
  initReport(type) {
    let cusId = wx.getStorageSync('cusId')
    if (this.data[type+'MoreTxt'] == '别拖啦，到底啦~' || this.data[type+'Loading']) return false
    this.setData({
      [type+'Loading']: true
    })
    let arr = this.data.trialReports[type+'Reports']
    let curPage = this.data[type+'CurPage']
    if(curPage == 1) {
      arr = []
      WGCOMMON.showLoading()
    }
    let param = {}
    if(type == 'my'){
      param = {
        ...this.data.reportQueryData, 
        curPage: curPage, 
        cusId: cusId
      }
    }else {
      param = {
        ...this.data.reportQueryData, 
        curPage: curPage, 
      }
    }
    WGAPI.getEvaListByFlag(param).then(res => {
      let data = res
      if (data.length > 0) {
        for (let i = 0; i < data.length; i++) {
          data[i].isLike = false
          data[i].formatThumbUpNumber = WGFORMAT.formatNumber(data[i].thumbUpNumber)
          data[i].formatBrowseNumber = WGFORMAT.formatNumber(data[i].browseNumber)
          data[i]['isMine'] = (cusId == data[i].cusId)?true:false
          let imgs = data[i].evaluationImages
          imgs.sort(function(a, b) {
            if (a.sortingOrder - b.sortingOrder == 0) {
              return a.id - b.id
            }
            return a.sortingOrder - b.sortingOrder
          })
          data[i]['evaluationImages'] = imgs
        }
        this.setData({
          [type+'CurPage']: curPage + 1,
          trialReports: {
            ...this.data.trialReports,
            [type+'Reports']: [...arr, ...data],
          },
          [type+'CanPullDownRefresh']: res.length < 10?false:true,
          [type+'Loading']: false,
        })
        console.log(this.data.trialReports[type+'Reports'])
      } else {
        this.setData({
          [type+'CanPullDownRefresh']: false,
          [type+'Loading']: false,
        })
      }
      WGCOMMON.hideLoading()
    }).catch(() => {
      this.setData({
        [type+'Loading']: false
      })
      WGCOMMON.hideLoading()
    })
  },
  onReachBottom() {
    let type = this.data.currentTabIndex? 'my': 'all'
    if(this.data[type+'CanPullDownRefresh']) {
      this.initReport(type)
    }
  },
  onLoad(option) {
    this.setData({
      trialId: option.id
    })
    this.initReport('all')
    this.initReport('my')
    if (wx.getUserProfile) {
      this.setData({
        canIUseGetUserProfile: true
      })
    }
  },
  onShareAppMessage() {
    let that = this
    return {
      title: that.data.activity.trial.name,
      imgUrl: that.data.activity.trial.imgUrl
    }
  },
  onShareTimeline() { // 分享朋友圈
    let that = this
    return {
      title: that.data.activity.trial.name,
      imgUrl: that.data.activity.trial.imgUrl
    }
  },
})