import {
  Page, WGCOMMON, WGAUTH, WGFORMAT,WGSUBSCRIBE
} from '../../../../wgUtils/index'
import api from '../../api/index'
import { REQUEST, API, TOAST, LOADING} from '../../../../utils/index';
import env1 from '../../../../utils/env1'
import WGPAY from '../../../../utils/pay'

Page({

  /**
   * 页面的初始数据
   */
  data: {
    purchaseHistoryList:[],
    showInfo: true,
    customPopupTxt:'确定要激活吗？',
    customPopupShow:false,
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {

  },
  activation(e){
    //自用激活
    let item = e.currentTarget.dataset.item;
    this.setData({
      customPopupShow : true,
      storedValueCardOrderId: item.id
    })
  },
  initStored(){
    let cusId = wx.getStorageSync('cusId');
    let that = this;
    api.getStoredOrderByCusId(cusId ).then(res => {
      
      for(let i=0;i<res.length;i++) {
        res[i].activationDate = WGFORMAT.formatDate(res[i].activationDate,'yyyy-MM-dd hh:mm:ss')
        res[i].createDate = WGFORMAT.formatDate(res[i].createDate,'yyyy-MM-dd hh:mm:ss')
        res[i].endDate= WGFORMAT.formatDate(res[i].endDate,'yyyy-MM-dd hh:mm:ss')
        res[i].sendDate = WGFORMAT.formatDate(res[i].sendDate,'yyyy-MM-dd hh:mm:ss')
      }
      that.setData({
        purchaseHistoryList: res
      })
    })
  },
  handsel(e){
    //赠好友
    let storedValueCardOrdId = e.currentTarget.dataset.item.id;
    wx.navigateTo({
      url: '/modules/ShoppingMoney/pages/Handsel/Handsel?storedValueCardOrdId='+storedValueCardOrdId
    })
  },
  goUse(){
    wx.switchTab({
      url: '/pages/Home/Home?_campaign=storedCardList' // switchtab不支持带参
    })
  },
  lookDetails(e){
    let item = e.currentTarget.dataset.item
    console.log(item)
    this.setData({
      showInfo: false,
      purchaseHistoryItem: item
    })
  },
  clickConfirm(){
    //确认弹窗
    let that = this
    this.setData({
      customPopupShow : false,
      checkId: 2
    })
    api.activationGwjAccount(JSON.stringify(this.data.storedValueCardOrderId)).then(res => {
      if(res){
        TOAST.success({
          title: '当前卡已激活，请尽快使用',
          duration: 2000
        })
        wx.navigateTo({
          url: '/modules/ShoppingMoney/pages/StoredList/StoredList?checkId=2'
        })
      }
    })
  },
  clickCancel(){
    //取消弹窗
    this.setData({
      customPopupShow : false
    })
  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    this.initStored()
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {
    return {
      title: '对你的爱都在卡里，记得领啊！',
      imageUrl: 'https://img.wgmf.com/img_shopping_gold_card_share.png?imageslim',
      path: 'modules/ShoppingMoney/pages/Stored/Stored'
    }
  }
})