import {
  Page, WGCOMMON, WGAUTH, WGFORMAT,WGSUBSCRIBE,WGTRACK
} from '../../../../wgUtils/index'
import api from '../../api/index'
import { REQUEST, API, TOAST, LOADING} from '../../../../utils/index';
import env1 from '../../../../utils/env1'
import WGPAY from '../../../../utils/pay'

Page({

  /**
   * 页面的初始数据
   */
  data: {
    env: env1,
    StoredNum: 0,
    matureMoney: 0,
    couponArr:[],
    couponId: 0,
    showId:0,
    initOrderDetails:{},
    isAgree: false, // 是否已同意购买规则
    isDead:false
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    if(WGFORMAT.targetDateInDateBetwen('2022-01-01 00:00:00', '2022-01-03 23:59:59', new Date())) { // 正式
      this.setData({
        isDead: true
      })
    }
  },
  toggleAgreeBuyRule() { // 切换同意购买规则按钮
    let isAgree = !this.data.isAgree
    this.setData({ isAgree })
  },
  initStored(){
    let that = this;
    api.storedList().then(res => {
      that.setData({
        couponArr:res[0],//第一条数据为当前可用数据
        initOrderDetails:res[0].storedValueCardSku[0]
      })
    })
  },
  gwjExpiringAmount(){
    let that = this;
    api.gwjExpiringAmount().then(res => {
      console.log(res)
      that.setData({
        matureMoney: res
      })
    })
  },
  goUse(){
    wx.switchTab({
      url: '/pages/Home/Home'
    })
  },
  getGwjRelate() {
    let that = this;
    api.get_gwj_relate().then(res => {
      console.log(res)
      that.setData({
        balance: res.balance
      })
    })
  },
  checkCoupon(e){
    console.log(e)
    this.setData({
      couponId: e.currentTarget.dataset.index,
      initOrderDetails:e.currentTarget.dataset.item
    })
  },
  bannerJump(e){
    console.log(e)
    if(e.detail == 1) {
      wx.redirectTo({
        url: '/modules/ShoppingMoney/pages/StoredList/StoredList'
      })
    }
    if(e.detail == 2) {
      wx.redirectTo({
        url: '/modules/ShoppingMoney/pages/StoredDetail/StoredDetail'
      })
    }
  },
  payOrder(){
    if(!this.data.isAgree) {
      WGCOMMON.toast('请先阅读并同意使用规则', 2500)
      return false
    }
    LOADING.show()
    let _self = this
    let h5openId = wx.getStorageSync('h5openId')
    let param ={
      isSvipCustomer: 0,
      addressId: (env1 == 'TEST' ? 2187077 : 2487713),
      customerId:wx.getStorageSync('cusId'),
      miniOpenId:wx.getStorageSync('openId'),
      customerOpenId:h5openId?((typeof h5openId == "string" && h5openId.length >= 20)?h5openId:""):"", // H5的openId，不用填,
      buyerMemo:"",// 买家留言
      campaign: WGTRACK.getChanId(), //存在有数埋点则以有数埋点优先
      orderDetails:[
        {
          productId:this.data.initOrderDetails.skuId,
          quantity:1,
          activityGrade:this.data.couponArr.integralMultiplier
        }
      ],
      isPurchaseOrder:0,// 是否是代购（小程序没有代购单，不用处理）
      orderType:22,// 订单类型
      phone:wx.getStorageSync('phone'),
      orderOrigin:1,// 下单来源 1-从产品下单，0-加购下单
      source:2,// 下单来源 0公众号 1网页 2小程序
      virtualMoney:0,// 购物金
      cusHeadImgUrl: (wx.getStorageSync('avatarUrl') ? wx.getStorageSync('avatarUrl') : 'https://img.wgmf.com/img_default.png'),// 购买人头像地址 ,
      cusName: wx.getStorageSync('nickName')?wx.getStorageSync('nickName'):'匿名',// 购买人昵称 ,
      storedValueCardId:this.data.couponArr.id ,
      storedValueCardSkuId:this.data.initOrderDetails.id,
      staffId: wx.getStorageSync('shareStaffId') ? wx.getStorageSync('shareStaffId') : '', // 顾问分享id
    }
    api.storedValue(param).then(res => {
      const {
        status,
        data,
        msg
      } = res
      console.log(status)
      console.log(data)
      console.log(msg)
      console.log(res)
      this.setData({
        id: res.id
      })
      LOADING.hide()
      let params = {
        orderCode: res.orderCode,
        orderType: res.orderType,
        id: res.id,
        orderStatus: {
          id: 1
        }
      }
      WGPAY({
        params,
        paySuccessFn: _self.paySuccessFn.bind(this),
        payErrorFn: _self.payErrorFn.bind(this),
        orderType: res.orderType,
        customOrderParams: res,
        isSvip: 0
      })
    })
  },
  paySuccessFn() {
    console.log('!!!!!!!!!!!!!!!!!!!!!')
  }, // 支付成功
  payErrorFn() {}, // 支付失败
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    this.initStored()
    this.getGwjRelate()
    this.gwjExpiringAmount()
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {
    return {
      title: '购储值卡，优惠尽享折上折',
      imageUrl: 'https://img.wgmf.com/img_shopping_gold_card_share.png?imageslimgeslim',
      path: 'modules/ShoppingMoney/pages/Stored/Stored'
    }
  }
})