import {
  Page, WGCOMMON, WGAUTH, WGFORMAT
} from '../../../../wgUtils/index'
import api from '../../api/index'
import { REQUEST, API, TOAST,LOADING } from '../../../../utils/index';
import env1 from '../../../../utils/env1'
import WGPAY from '../../../../utils/pay'

Page({

  /**
   * 页面的初始数据
   */
  data: {
    showId:2,
    reqParams: {
      cusId: wx.getStorageSync('cusId'),
      page: 1,
      amount: 20,
      matureMoney:0
    },
    gwjModule: [],
    noData: false,
    LoginShow: false,
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {

  },
  bannerJump(e){
    console.log(e)
    if(e.detail == 0) {
      wx.redirectTo({
        url: '/modules/ShoppingMoney/pages/Stored/Stored'
      })
    }
    if(e.detail == 1) {
      wx.redirectTo({
        url: '/modules/ShoppingMoney/pages/StoredList/StoredList'
      })
    }
  },
  gwjExpiringAmount(){
    let that = this;
    api.gwjExpiringAmount().then(res => {
      console.log(res)
      that.setData({
        matureMoney: res
      })
    })
  },
  getGwjList() {
    if (!wx.getStorageSync('cusId') || !wx.getStorageSync('unionId')) {
      this.setData({
        LoginShow: true
      })
      return false
    }
    LOADING.show()
    api.get_cash_detail(this.data.reqParams).then(res => {
      if (res.length > 0) {
        let oldVal = this.data.gwjModule
        ++this.data.reqParams.page
        this.setData({
          gwjModule: oldVal.concat(res),
        })
      } else {
        this.setData({
          noData: true
        }, () => {
          TOAST.warning({
            title: '没有数据了哦！',
            duration: 1500
          })
        })
      }
      console.log(1)
      LOADING.hide()
    })
  },
  login() {
    this.data.reqParams.cusId = wx.getStorageSync('cusId')
    this.setData({
      LoginShow: false,
    }, () => {
      this.getGwjList()
      this.getGwjRelate()
    })
  },
  
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    this.data.reqParams.cusId = wx.getStorageSync('cusId')
    this.getGwjList()
    this.gwjExpiringAmount()
    
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  onReachBottom: function () {
    if (!this.data.noData) {
      this.getGwjList()
    } else {
      TOAST.warning({
        title: '没有数据了哦！',
        duration: 1500
      })
    }
  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {
    return {
      title: '对你的爱都在卡里，记得领啊！',
      imageUrl: 'https://img.wgmf.com/img_shopping_gold_card_share.png?imageslim',
      path: 'modules/ShoppingMoney/pages/Stored/Stored'
    }
  }
})