
import {
  Page, WGCOMMON, WGAUTH, WGFORMAT
} from '../../../../wgUtils/index'
import api from '../../api/index'
import { REQUEST, API, LOADING} from '../../../../utils/index';

Page({

  /**
   * 页面的初始数据
   */
  data: {
    customerId: wx.getStorageSync('cusId'), // (integer, optional): 客户id ,
    miniOpenId: wx.getStorageSync('openId'), // (string, optional): 小程序openId ,
    isSvipCustomer:false,
    extension:[],
    isSelect: true,
    orderType: 0,
    integralList:[],
    unusedList:[],
    validStatus:0, //积分延期卡过期状态：0，未过期；1，已过期
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    LOADING.show()
    Promise.all([
      this.initExtension(),
      this.initPointsList()
    ]).finally(() => {
      LOADING.hide()
    })
    this.setData({
      isSvipCustomer: wx.getStorageSync('vipCusStatus') == 1?true:false, // (integer, optional): 是否超级会员0否1是,
    })
  },
  initPointsList(){
    return new Promise((resolve, reject) => {
      let that = this
      if(wx.getStorageSync('cusId')) {
        api.pointsList(that.data.orderType).then(res => {
          console.log(res)
          that.setData({
            integralList: res
          })
          resolve(true);
        }).catch((e) => {
          reject(e);
        });
      }
    });
  },
  initExtension(){//初始化积分延期卡
    return new Promise((resolve, reject) => {
      let that = this
      let unusedList = []
      console.log(wx.getStorageSync('cusId'))
      if(wx.getStorageSync('cusId')) {
        api.pointsDelayCard().then(res => {
          res.forEach((item)=>{
            if(that.data.isSvipCustomer != true){
              item.url ='https://img.wgmf.com/img_svip_integral_delay_card_01.png';
              item.tips ='专属特权';
            }else {
              if(item.useStatus == '0'){
                item.url ='https://img.wgmf.com/img_svip_integral_delay_card_01.png';
                item.tips ='待使用';
                unusedList.push(item.cardId)
              } else {
                item.url ='https://img.wgmf.com/img_svip_integral_delay_card_02.png';
                item.tips ='已使用';
                item.gary= true;
              }
            }
          })
          console.log(unusedList)
          this.setData({ extension: res, unusedList:unusedList })
          resolve(true);
        }).catch((e) => {
          reject(e);
        });
      }
    });
  },
  linkToSvip() {
    wx.navigateTo({
      url: '/pages/superMember/superMember'
    })
  },
  choose(){
    let isSelect = this.data.isSelect
    let orderType = this.data.orderType
    if(orderType == 0) {
      orderType = 1
    } else {
      orderType = 0
    }
    this.setData({
      isSelect: !isSelect,
      orderType: orderType
    })
    this.initPointsList()
  },
  extensionClick(e){
    let query = e.currentTarget.dataset.index;
    let cardId =this.data.unusedList[0];
    let pointId = query.ptsId;
    if(cardId) {
      api.usePointsDelayCard(cardId,pointId).then(res => {
        console.log(res)
        WGCOMMON.toast('操作成功,积分有效期已延长至'+res)
        this.initExtension()
        this.initPointsList()
      })
    } else {
      WGCOMMON.toast('您暂无可用的延期卡')
    }
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
  },
  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  }
})