// modules/Svip/pages/MonthlyCoupons/MonthlyCoupons.js
import {
  Page, WGCOMMON, WGAUTH, WGFORMAT
} from '../../../../wgUtils/index'
import api from '../../api/index'
import { REQUEST, API } from '../../../../utils/index';

Page({

  /**
   * 页面的初始数据
   */
  data: {
    boxList: null,
    customerId: wx.getStorageSync('cusId'), // (integer, optional): 客户id ,
    isSvipCustomer:  wx.getStorageSync('vipCusStatus') == 1?1:0, // (integer, optional): 是否超级会员0否1是,
    miniOpenId: wx.getStorageSync('openId'), // (string, optional): 小程序openId ,
    fllowAll: false,//全部奖品都领完
    condition:null,//当前消费状态与下一级仍需消费多少
    moveLength:0,//小金币与进度条 移动距离
    difference:0,//还差多少钱可翻牌
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.setData({
      isSvipCustomer: wx.getStorageSync('vipCusStatus') == 1?1:0, // (integer, optional): 是否超级会员0否1是,
    })
  },
  initFlopLottery(){
    let that = this
    WGCOMMON.showLoading()
    api.flopGet().then(res => {
      res.animationMain = null;
      res.animationBack = null;
      if(res) {
        that.setData({
          boxList:res
        })
      }
      WGCOMMON.hideLoading()
    })
  },
  flopCheck(){
    WGCOMMON.showLoading()
    api.flopCheck().then(res => {
      //(当前累计金额 - 上一级所需金额 ）/ (下一级所需金额-上一级所需金额) * 6  （1%等于6rpx）
      let moveLength = (res.currentCumulativeFee - res.preCumulativeFee) / (res.nextCumulativeFee-res.preCumulativeFee) * 600
      console.log(moveLength)
      if(res.chanceNum>=1){
        moveLength = 600
      }
      let difference = (res.nextCumulativeFee -res.currentCumulativeFee).toFixed(2)
      if(difference<=0) {
        difference = 0
      }
      this.setData({
        condition:res,
        difference:difference,
        moveLength:moveLength
      })
      WGCOMMON.hideLoading()
    })
  },
  rotateFn(e) {
    var item = e.currentTarget.dataset.item
    var index = e.currentTarget.dataset.index
    console.log(index)
    let clickFlag = true
    this.animation_main = wx.createAnimation({
        duration:400,
        timingFunction:'linear'
      })
      this.animation_back = wx.createAnimation({
        duration:400,
        timingFunction:'linear'
      })
    // 点击正面
  
    if (item.isFlop == 0 && this.data.condition.chanceNum >=1 && this.data.isSvipCustomer == 1 && clickFlag == true) {
      WGCOMMON.showLoading()
      clickFlag = false
      api.flopLottery(index).then(res => {
        // let prizeId = item.id
        clickFlag = true
        this.flopCheck()
        // api.flopReceivePrize(prizeId).then(res => {
          this.animation_main.rotateY(180).step()
          this.animation_back.rotateY(0).step()
          let key = 'boxList['+ index+'].animationMain'
          let key2 = 'boxList['+ index+'].animationBack'
          let key3 = 'boxList['+ index+'].imgUrl'
          this.setData({
            [key]: this.animation_main.export(),
            [key2]: this.animation_back.export(),
            [key3]: res.imgUrl
          })
          WGCOMMON.hideLoading()
        // })
      })
    }
    // 点击背面
    else{
      if(item.isFlop==0 || this.data.isSvipCustomer == 0){
        WGCOMMON.toast('您未满足翻牌条件！')
      }
      // this.animation_main.rotateY(0).step()
      // this.animation_back.rotateY(-180).step()
      // this.setData({
      //   animationMain: this.animation_main.export(),
      //   animationBack: this.animation_back.export(),
      // })
    }
  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    this.initFlopLottery()
    this.flopCheck()
  },
  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  }
})