// modules/redEnvelopes/pages/redEnvelopesList/redEnvelopesList.js
import WGAPI from '../../api/index'
import {
  Page,
  WGSUBSCRIBE,
  WGCOMMON,
  WGTRACK,
  WGFORMAT,
} from '../../../../wgUtils/index'
Page({

  /**
   * 页面的初始数据
   */
  data: {
    showAuth: false, // 显示授权登录面板
    shareId:'', //朋友分享的红包封面id,不一定有
    shareMiniOpenId: '', // 分享人MiniOpenId
    shareWechatName: '', //分享人微信名
    // shareWechatHeadImgUrl: '', //分享人头像
    shareCusId: '', //分享人cusId
    isShareCust: false, //是否是分享人自己
    showToSupportDialog: false, //助力
    showSupport: false,
    lotteryNum: 0,  //已抽奖数
    lotteryAllNum: 0,// 总可抽奖数
    supportList: [], //助力列表
    showRules: false, //是否显示活动规则
    rulesList: [ // 活动规则
      '选择您想参与的红包封面进行抽奖，系统将生成对应的抽奖编号，并复制到手机。',
      '点击<span class="tip">【进入五谷磨房视频号】</span>，关注后点击私信，发送刚刚复制的抽奖编号，即可成功参与抽奖。',
      `本次活动共有4个红包封面抽奖，每分享<span class="tip">3</span>名好友助力，即可解锁<span class="tip">1</span>个红包封面抽奖资格。`,
      `系统将在2022年1月24日早上10点自动开奖，并对参与用户下发小程序中奖通知。<span class="tip">中奖用户如在1月30日仍未领取红包封面，则过期无效。</span>`
    ],
    dataList: [],
    authType: null,
    redPackageCoverOrderList: {}, //参与信息
    isDraw: false, //是否开奖
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    // true,说明大于该时间，已开奖
    if(WGFORMAT.targetDateInDateBetwen('2022-01-24 10:00:00', '', new Date())){
      this.setData({
        isDraw: true
      })
    }
    WGTRACK.logCustomEvent('exposure_redEnvelopesList')  
    if (options.shareId) {
      this.setData({
        shareId: options.shareId,
        shareWechatName: options.wechatName,
        // shareWechatHeadImgUrl: options.wechatHeadImgUrl,
        shareCusId: options.shareCusId
      })
    }
    if (options.shareMiniOpenId) {
      this.setData({
        shareMiniOpenId: options.shareMiniOpenId
      })
    }
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {
    this.checkLoginType()
  },
  authSuccess() {
    this.checkLoginType()
  },
  authFail() {
    this.checkLoginType()
  },
  checkLoginType() { // 检查登录类型  // 1手机号授权，2用户信息授权
    let cusId = wx.getStorageSync('cusId')
    let unionId = wx.getStorageSync('unionId')
    let nickName = wx.getStorageSync('nickName')
    let avatarUrl = wx.getStorageSync('avatarUrl')
    if (!cusId) { // 没有cusId
      this.setData({
        authType: 2,
        showAuth: true
      })
      return false
    } else if (cusId && (!unionId || !nickName || !avatarUrl)) { // 有cusId但是没有unionId，选择授权用户信息
      this.setData({
        authType: 1,
        showAuth: true,
      })
      return false
    } else { // 既有cusId又有手机号  // 说明已授权
      this.setData({
        showAuth: false
      })
      // 获取页面数据
      this.initPage()
      this.getShareListFn()
      // 分享
      if (this.data.shareMiniOpenId && this.data.shareId) {
        // 分享人是自己
        if (this.data.shareMiniOpenId == wx.getStorageSync('openId')) {
          this.setData({
            showToSupportDialog: true,
            isShareCust: true
          })
        } else {
          this.setData({
            showToSupportDialog: true,
            isShareCust: false
          })
        }
      }
      return true
    }
  },
  initPage() {
    // 封面信息
    WGAPI.redPackageList().then(res => {
      res.redPackageCoverDetailList.map(item =>{
        if(item.isPart){
          let obj = res.redPackageCoverOrderList.find(i=> {return i.redPackageId == item.redPackageCover.id})
          item.isDraw = obj.isDraw //是否中奖
          item.newStatus = obj.newStatus
          if(obj.isDraw){ //0，未开奖，1有中奖，2未中奖
            item.drawRedPackageText = item.redPackageCover.id== obj.drawRedPackageId ? '已中奖' : '未中奖' //是否是当前中奖
          }else {
            item.drawRedPackageText = '已参与'
          }
        }
      })
      this.setData({
        lotteryNum: res.redPackageCoverOrderList.length, 
        dataList: res.redPackageCoverDetailList,
        redPackageCoverOrderList: res.redPackageCoverOrderList
      })
    })
  },
  toPosterPage(e){
    let data = e.currentTarget.dataset.item
    wx.navigateTo({
      url: `/modules/redEnvelopes/pages/posterPage/posterPage?redPackageId=${data.redPackageCover.id}&miniOpenId=${wx.getStorageSync('openId')}&isDraw=${data.isDraw}&newStatus=${data.newStatus}`,
    })
  },
  // 助力人信息
  getShareListFn(){
    WGAPI.getShareList().then(res => {
      this.setData({
        supportList: res,
        lotteryAllNum: Math.floor((res.length + 3)/3)
      })
    })
  },
  // 参与抽奖
  onPartake(e) {
    // true,说明大于该时间，已开奖
    if(WGFORMAT.targetDateInDateBetwen('2022-01-24 10:00:00', '', new Date())){
      this.initPage()  //刷新开奖信息
      this.setData({
        isDraw: true
      })
      WGCOMMON.toast('抽奖活动已结束', 3500)
      return
    }
    let data = e.currentTarget.dataset.item
    if(data.isPart) {
      // 已经参与
      WGCOMMON.toast('您已参与该抽奖', 3500)
      return
    }
    // 先判断是否能抽奖,参与次数大于等于总可参与次数，直接return
    if(this.data.lotteryNum >= this.data.lotteryAllNum) {
      // WGCOMMON.toast('您的抽奖机会已用完哦', 3500)
      return
    }
    // 提交，否则没有抽奖编号
    let params = {
      customerId: wx.getStorageSync('cusId'),
      miniOpenId: wx.getStorageSync('openId'),
      redPackageId: data.redPackageCover.id,
      wechatHeadImgUrl: wx.getStorageSync('avatarUrl'),
      wechatName: wx.getStorageSync('nickName'),
      unionid: wx.getStorageSync('unionId')
    }
    WGTRACK.logCustomEvent('click_join_redEnvelopes')
    WGAPI.partRedPackage(params).then(res=>{
      if(res.status === 0) {
       
        // WGCOMMON.toast(res.msg, 3500)
        // 订阅
        WGSUBSCRIBE('redEnvelopes').then(res => {

        }).finally(() => {
          // 订阅完成后， 打开视频号弹窗
          let that = this
          wx.setClipboardData({
            data: 'WGMF032906', //抽奖编号,固定的
            success(res) {
              that.setData({
                showFollow: true
              })
            }
          })
        })
         this.initPage()
      }else {
        WGCOMMON.toast(res.msg, 3500)
      }
    })
  },
  // 中奖名单
  toWinnerList: function () {
    wx.navigateTo({
      url: '/modules/redEnvelopes/pages/winnerList/winnerList',
    })
  },
  // 关闭弹窗
  closeDialog() {
    this.setData({
      showSupport: false,
      showRules: false,
      showToSupportDialog: false,
      showFollow: false,
    })
  },
  // 展示活动规则
  showDialog(e) {
    let type = e.currentTarget.dataset.type
    this.setData({
      ['show' + type]: true,
    })
  },
  // 预览
  preview(e){
    console.log( e.currentTarget.dataset.item.redPackageCover.previewUrl)
    wx.navigateTo({
      url: `/modules/redEnvelopes/pages/preview/preview?url=${e.currentTarget.dataset.item.redPackageCover.previewUrl}&title=封面预览`
    })
  },
  // 进入视频号主页
  toOpenChannelsUserProfile() {
    // if (wx.openChannelsUserProfile) { //基础库 2.21.2 开始支持，还是先不用了
    //   wx.openChannelsUserProfile({
    //     finderUserName: 'sphmTN8rmxUL5cq',
    //     success(res){
    //       console.log(res);
    //     },
    //     fail(err){
    //       console.log(err)
    //       wx.navigateTo({
    //         url: '/pages/WebView/WebView?url=https://mp.weixin.qq.com/s/xHAgVyejaM0QPdZuFBZXRw&_campaign=CJGZSPH'
    //       })
    //     }
    //   })
    // } else {
    WGTRACK.logCustomEvent('click_toVideo_redEnvelopes')
    wx.navigateTo({
      // url: '/pages/WebView/WebView?url=https://mp.weixin.qq.com/s/tmNCDnviZn_a8sd-J0tptQ&title=关注五谷磨房视频号&_campaign=sgdkg' 
      url: '/pages/WebView/WebView?url=https://mp.weixin.qq.com/s/BwsmMlOWJvpZg42AdSVvIA&title=关注五谷磨房视频号&actId=&cusId=&openid=&_appid=android&_adTag=wx&_campaign=agl' 
    })
    this.setData({
      showFollow: false,
    })
    // }

  },
  // 给好友助力
  toSupport() {
    let params = {
      customerId: this.data.shareCusId * 1,
      oldOpenId: this.data.shareMiniOpenId,
      miniOpenId: wx.getStorageSync('openId'),
      wechatHeadImgUrl: wx.getStorageSync('avatarUrl'),
      wechatName: wx.getStorageSync('nickName'),
      redPackageId: this.data.shareId * 1,
    }
    WGAPI.shareRedPackage(params).then(res => {
      if (res.hasOwnProperty('status')) {
        if(res.status === 0){
          // 助力后关闭弹窗
          this.setData({
            showToSupportDialog: false,
          })
        }
        WGCOMMON.toast(res.msg, 3500)
      } else {
        // 助力后关闭弹窗
        this.setData({
          showToSupportDialog: false,
        })
        WGCOMMON.toast('助力成功', 3500)
      }
    })
  },
  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function (e) {
    let imageUrl = '';
    let shareId = ''
    let shareTitle = ''
    let shareMiniOpenId = wx.getStorageSync('openId')
    if (e.from == 'menu') {
      imageUrl = 'https://img.wgmf.com/redEnvelopes_share_1.png';
      shareTitle = '快来！五谷磨房微信红包封面开发领取中'
    } else {
      imageUrl = 'https://img.wgmf.com/redEnvelopes_support.png';
      shareId = e.target.dataset.item.redPackageCover.id
      shareTitle = '就差你了！是朋友就帮点一下，爱你哦~'
    }
    // true,说明大于该时间，已开奖
    if(WGFORMAT.targetDateInDateBetwen('2022-01-24 10:00:00', '', new Date())){
      this.initPage()  //刷新开奖信息
      this.setData({
        isDraw: true
      })
    }
    return {
      title: shareTitle,
      // path: `modules/redEnvelopes/pages/redEnvelopesList/redEnvelopesList?shareCusId=${wx.getStorageSync('cusId')}&shareId=${shareId}&wechatName=${wx.getStorageSync('nickName')}&wechatHeadImgUrl=${wx.getStorageSync('avatarUrl')}`,
      // path: `modules/redEnvelopes/pages/redEnvelopesList/redEnvelopesList?shareCusId=${wx.getStorageSync('cusId')}&shareMiniOpenId=${shareMiniOpenId}&shareId=${shareId}&wechatName=${wx.getStorageSync('nickName')}&wechatHeadImgUrl=${wx.getStorageSync('avatarUrl')}`,
      path: `modules/redEnvelopes/pages/redEnvelopesList/redEnvelopesList?shareCusId=${wx.getStorageSync('cusId')}&shareMiniOpenId=${shareMiniOpenId}&shareId=${shareId}&wechatName=${wx.getStorageSync('nickName')}`,
      imageUrl: imageUrl
    }
  },
  onShareTimeline() { // 分享朋友圈
    return {
      title: '快来！五谷磨房微信红包封面开发领取中',
      path: `modules/redEnvelopes/pages/redEnvelopesList/redEnvelopesList?shareCusId=${wx.getStorageSync('cusId')}&shareMiniOpenId=${shareMiniOpenId}&wechatName=${wx.getStorageSync('nickName')}`,
      imageUrl: 'https://img.wgmf.com/redEnvelopes_share_1.png'
    }
  },
})