import api from '../../api/index'
import modules from '../../utils/modules'
import staffShare from '../../utils/staffShare.js'
const app = getApp() // app可以调用全局的方法&全局的变量
import {
  REQUEST,
  API,
  LOADING,
  FILTER,
  UTIL,
  SRTRACK,
  SHOPCARTSERVER
} from '../../utils/index.js'
import {
  Page, 
  WGAUTH,
  WGHTTP,
  WGFORMAT,
  WGTRACK,
  WGUSER
} from '../../wgUtils/index';
import User from '../../store/index.js'
let isTrack = false
Page({
  data: {
    pageId: null,
    pageName: '五谷磨房微信会员商城',
    modulesData: null,
    swiperIndex: 0,
    isRefresh: false,
    shareTitle: '',
    canBuyJinBuCard: false,
    pId: '',
    chooseSkuShow: false,
    pageId: null,
    productDetail: {
      actType: 0, // 商品类型：0普通商品 6预售 8拼团 9积分兑换 11优惠券 14超级会员 16团购 17秒杀 18分期发货 19套餐搭配 29专柜临时销售渠道
      integralStatus: 1,
      operationType: 0, // 0-加入购物车，1-立即购买， 2-拼团购买/预付定金/团购购买  3-分期发货购买
      stock: 1,
      vipCusStatus: 0,
      isSendIntergral: 1, // 该款产品是否送积分
      isGwtStatus: 0, // 秒杀是否可以使用购物金， 默认否
    },
    product: {
      integralStatus: 1
    },
    isLogin: false,
    loginType: 1, // 1手机号授权，2用户信息授权
    isAuthorize: false,
    skuIds: '',
    empty: false
  },
  goPage(event) { // 页面跳转，首页/购物车
    switch (event.currentTarget.dataset.item) {
      case 'home':
        wx.switchTab({
          url: '/pages/Home/Home'
        })
        break;
      case 'cart':
        wx.switchTab({
          url:'/pages/MyCart/MyCart'
        })
        break;
    }
  },
  initPage() {
    api.modules.getById(this.data.pageId).then(r => {
      if (r) {
        let newpage = modules.formatModules(r)
        // this.data.pageName = r.name
        this.setData({
          modulesData: newpage,
          swiperIndex: 0,
        })
        if (this.data.isRefresh) {
          wx.stopPullDownRefresh()
          this.setData({
            isRefresh: false
          })
        }
      }
      wx.hideLoading()
    })
  },
  getMoreShareQuery() {
    let query = ''
    if(this.data.shareTitle) {
      query = `shareTitle=${this.data.shareTitle}`
    }
    if(this.data.pageName) {
      if(query != '') {
        query += `&pageName=${this.data.pageName}`
      } else {
        query += `pageName=${this.data.pageName}`
      }
    }
    return query
  },
  onPullDownRefresh() {
    this.setData({
      isRefresh: true
    })
    this.initPage()
  },
  onLoad(options) {
    // this.data.pageId = parseInt(options.id)
    this.setData({
      pId: options.pId || '',
      shareStaffId: options.ssd || options.shareStaffId || '',
      pageId: parseInt(options.id)
    })
    wx.showLoading({})
    if(this.data.pageId == '681'){  //芝养卡
      this.init()
      this.checkBuyJinBuCard()
    }
    this.initPage()
    options.shareStaffId = options.ssd || options.shareStaffId;
    staffShare.setShareStaffIdByShare(options) //拿到分享人工号,存入本地
    app.globalData.actType = 0
    if (options.pageName) {
      wx.setNavigationBarTitle({
        title: options.pageName
      })
      this.data.pageName = options.pageName
    }
    try {   
      wx.onCopyUrl(() => {
        return { query: WGFORMAT.formatQueryByOptions(options) }
      })
    } catch (error) {
      console.warn('暂不支持wx.onCopyUrl')
    }
    if(options.shareTitle) { // 自定义了转发标题
      this.data.shareTitle = options.shareTitle
    }
    if(options.shareCover) { // 自定义转发封面
      this.data.shareCover = options.shareCover
    }
    if(options.noShare) { // 禁止转发分享
      wx.hideShareMenu()
      wx.updateShareMenu({
        withShareTicket: true,
        isPrivateMessage: true,
      })
    }
  },
  init() { // 初始化页面数据
    this.getData().then(() => {
      if(!isTrack && this.data.productType != 8) {
        isTrack = true
        WGTRACK.pageBrowse(this.data.productType)
      }
    }) // 获取商品详情
  },
  getPriceRange(arr) { // 获取价格区间
    if (!arr) return ''
    let max = Math.max.apply(Math, arr)
    let min = Math.min.apply(Math, arr)
    if (min === max) {
      return min
    } else {
      return min + '~' + max
    }
  },
  getData() { // 获取商品详情 接口 -> wechat-shop-back/product/info/template/${id}
    return new Promise((resolve, reject) => {
      REQUEST.get(API.get_productDetail + this.data.pId).then((res) => {
        const {
          status,
          data
        } = res.data
        const priceArr = []
        let virtualPrice = []
        var sold = 0
        var stock = 0
        var products = []
        var redeemPrices = []
        let result = {}
        let skuIds = []
        let taoWord = ''
        let showPrice = true
        if (status == 0) {

          this.setData({
            product: data
          })
          data.products.forEach((item) => {
            if (item.enable == 0) { // enable 0显示 1不显示
              skuIds.push(item.id)
              products.push(item)
              priceArr.push(item.price)
              sold += (item.sold || 0)
              if (item.virtualPrice) virtualPrice.push(item.virtualPrice)
              if (item.stock && item.stock > 0) stock += item.stock
              redeemPrices.push(item.redeemPrice)
            }
          })
          data.products[0].price = data.buyCoupon.buyCouponLines[0].actionPrice
          result.id = data.id
          result.price = data.buyCoupon.buyCouponLines[0].actionPrice
          result.virtualPrice = this.getPriceRange(virtualPrice)
          result.sold = sold
          result.stock = stock
          result.products = products
          result.redeemPrices = this.getPriceRange(redeemPrices)
          result.groupedImages = data.groupedImages
          result.warehouseCode = data.warehouseCode
          result.productTemplateName = data.productTemplateName
          result.presell = data.presell
          result.isAddShoppingCart = data.isAddShoppingCart
          result.productProperties = data.productProperties
          result.groupPurchase = data.groupPurchase
          result.isSendIntergral = data.integralStatus
          result.productCategory = data.productCategory
          SRTRACK.setTrackData('browse_sku_page', data)
          if (data.hotWord) { // 营销热词
            result.hotWord = [data.hotWord]
          }
          this.setData({
            productDetail: Object.assign({}, this.data.productDetail, result),
            isLogin: (UTIL.getInfo('cusId').length != 0) && (UTIL.getInfo('openId').length != 0),
            'productDetail.isLogin': (UTIL.getInfo('cusId').length != 0) && (UTIL.getInfo('openId').length != 0),
            isAuthorize: (wx.getStorageSync('avatarUrl') && wx.getStorageSync('nickName')) ? true : false,
            skuIds: skuIds.join(','),
            "productDetail.buyCouponId": data.buyCoupon.id,
            "productDetail.actType": 11,
          })
          this.getActivity(Object.assign({}, this.data.productDetail, result))
          this.getIntergral()
          this.setCommonActivityTick()
        } else {
          this.setData({
            empty: true
          })
        }
        resolve()
      }).catch((e) => {
        reject()
      })
    })
  },
  getPhoneNumber(e) { // 获取当前账号手机号码
    let that = this;
    if (e.detail.errMsg === 'getPhoneNumber:ok') {
      LOADING.show({
        title: '登录中...'
      })
      WGAUTH.getPhoneNumber(e).then(res => {
        WGUSER.webLogin(res).then(data=>{
          LOADING.hide()
            let r = this.checkLoginType()
            if (r) {
              this.setData({
                'productDetail.isLogin': true
              })
              this.init()
              this.checkBuyJinBuCard()
            }
        })
      })
    } else {
      console.log(e.detail.errMsg)
    }
  },
  getUserProfile(e) {
    LOADING.show()
    WGAUTH.getUserProfile().then(res => {
      LOADING.hide()
      if (this.checkLoginType()) {
        this.setData({
          'productDetail.isLogin': true
        })
        this.init()
        this.canTrialAgain()
        this.addCart(e)
      }
    })
  },
  bindgetuserinfo(e) { // 获取用户昵称信息
    LOADING.show()
    WGAUTH.getUserInfo(e).then(res => {
      LOADING.hide()
      if (this.checkLoginType()) {
        this.setData({
          'productDetail.isLogin': true
        })
        this.init()
        this.canTrialAgain()
        this.addCart(e)
      }
    })
  },
  checkLoginType() { // 检查登录类型  // 1手机号授权，2用户信息授权
    let cusId = wx.getStorageSync('cusId')
    let unionId = wx.getStorageSync('unionId')
    if (!cusId) { // 没有cusId，选择授权手机号
      this.setData({
        loginType: 1,
        isLogin: false
      })
      return false
    } else if (cusId && !unionId) { // 有cusId但是没有unionId，选择授权用户信息
      this.setData({
        loginType: 2,
        isLogin: false,
      })
      return false
    } else { // 既有cusId又有手机号
      this.setData({
        isLogin: true
      })
      return true
    }
  },
  bindgetuserinfo(e) { // 获取用户昵称信息
    LOADING.show()
    WGAUTH.getUserInfo(e).then(res => {
      LOADING.hide()
      if (this.checkLoginType()) {
        this.setData({
          // isLogin: true,
          'productDetail.isLogin': true
        })
        this.init()
        this.canTrialAgain()
        this.addCart(e)
      }
    })
  },
  checkBuyJinBuCard() { // 检查用户是否有资格购买芝养卡
    if(wx.getStorageSync('cusId')) {
      WGHTTP.get('app/checkCardTargetCus?cusId=' + wx.getStorageSync('cusId') + '&staffId=' +  this.data.shareStaffId + '&type=1').then(res => {
        console.log(res.showFlag, '用户是否有资格购买五谷进补卡，true表示可以购买，false表示不可以购买')
        this.setData({
          canBuyJinBuCard: res.showFlag // 用户是否有资格购买五谷进补卡，true表示可以购买，false表示不可以购买
        })
        if(!res.showFlag){
          let phone = wx.getStorageSync('phone')
          wx.showModal({
            title: '哎呀，锦鲤游走啦！',
            content: `尊敬的${phone}用户,本次幸运福利与你擦肩而过了~不要灰心哦，持续关注五谷磨房，未来更多惊喜，等着花样宠你！
            Tips：若绑定的手机号与消费手机号不一致，可点击按钮解绑后重新绑定`,
            confirmColor: "#ff491d",
            confirmText: '去解绑',
            success(res) {
              if (res.confirm) {
                wx.navigateTo({
                  url: '/pages/ReplacePhone/ReplacePhone'
                })
              }
            }
          }) 
        }
      })
    }else {
      this.setData({
        canBuyJinBuCard: true // 用户是否有资格购买五谷进补卡，true表示可以购买，false表示不可以购买
      })
    }
  },
  addCart(event) { // 加入购物车
    let orderInfo = this.data.productDetail.products[0],
      info = this.data.productDetail,
      moreQuery = '';
    var params = {
      skuName: orderInfo.curSKUName,
      id: orderInfo.id,
      productId: orderInfo.curSKUId,
      productTemplateId: orderInfo.productTemplateId,
      // pName: info.productTemplateName,
      name: this.data.productDetail.productTemplateName,
      quantity: 1,
      price: orderInfo.price,
      originPrice: info.originPrice?info.originPrice:orderInfo.originPrice,
      redeemPrice: info.actType == 9 ? orderInfo.price : 0,
      noSvipPrice: orderInfo.noSvipPrice,
      isChecked: true,
      icon: info.groupedImages.icon ? info.groupedImages.icon[0].imageUrl : info.groupedImages.banner[0].imageUrl,
      stock: orderInfo.stock,
      limitQuantity: orderInfo.purchaseLimitQuantity,
      warehouseCode: orderInfo.warehouseCode,
      isRedeem: info.actType == 9 ? orderInfo.isRedeem : 0,
      integralStatus: info.integralStatus,
      cartProTag: info.cartProTag, // 商品的活动标签
      endTime: info.endTime,
      productCategory: info.productCategory,
      buyCouponId : info.buyCouponId
    }
    if(info.actType == 11) { // 优惠券类型
      moreQuery += `couponType=${info.couponType}&`
    }
    SHOPCARTSERVER.setBuyNow(params)
    wx.navigateTo({
      url: `/pages/PayOrderEquity/PayOrderEquity?productId=${params.id}&type=${info.actType}${moreQuery}`
    })
  },
  onHide() {
  },
  getShareInfo() {
    return {
      imageUrl: this.data.shareCover?this.data.shareCover:null,
      title: this.data.shareTitle?this.data.shareTitle:'五谷磨房，创造精致生活的更多种选择',
      path: '/pages/ActivePage/ActivePage?id=' + this.data.pageId + '&' + staffShare.getShareParams() + '&' + this.getMoreShareQuery() //分享人工号，此时分享人为登录者本人
    }
  },
  onShareAppMessage: function () { // 自定义点击右上角转发内容
    return this.getShareInfo()
  },
  onShareTimeline() { // 分享朋友圈
    return this.getShareInfo()
  },
})