import api from '../../api/index'
import {
  LOADING
} from '../../utils/index'
import staffShare from '../../utils/staffShare'
import {
  WGAUTH,
  Page,
  WGFORMAT
} from '../../wgUtils/index'

const app = getApp()

Page({
  data: {
    list: null,
    hideLoginPanel: true,
  },
  linkToPage(e) {
    let link = e.currentTarget.dataset.link
    console.log(link, typeof link)
    // let t = Number(link)
    // console.log('t', t)
    // var reg = /^\d+$/
    if (/^[0-9]+.?[0-9]*$/.test(link)) {
      // if (typeof link == 'number') { // 跳转到产品详情页
      wx.navigateTo({
        url: '/pages/ProductDetail/ProductDetail?pId=' + link
      })
    } else {
      if (link.indexOf('productIndex.html') != -1) { // 首页
        wx.switchTab({
          url: '/pages/Home/Home'
        })
      } else if (link.indexOf('productList.html') != -1) { // 分类页
        wx.switchTab({
          url: '/pages/ProductIndex/ProductIndex'
        })
      } else if (link.indexOf('myCart.html') != -1) { // 购物车
        wx.switchTab({
          url: '/pages/MyCart/MyCart'
        })
      } else if (link == 'top') { // 返回顶部
        wx.pageScrollTo({
          scrollTop: 0,
          duration: 300
        })
      }
      // else if(link.indexOf('superMember.html') != -1) { // 超级会员页
      //   wx.switchTab({ url: "/pages/superMember/superMember" })
      // } 
      else if (link.indexOf('ticket_') != -1) { // 领取优惠券
        this.getCoupons(link.split('_')[1])
      } else if (link.indexOf('.wgmf.com/wechat-html/html/shop/product/') != -1) { // 跳转到二级页面
        let arr = link.split('?')
        let a = arr[0]
        let b = a.split('/')
        let url = b[b.length - 1]
        let query = arr.length > 1 ? arr[1] : ''
        console.log(url, query)
        this.linkToOtherPage(url, query)
      }
    }
  },
  linkToOtherPage(url, query) {
    api.modules.getActivityPageId(url).then(r => {
      if (r.id) {
        wx.navigateTo({
          url: '/pages/ActivityPage/ActivityPage?id=' + r.id + '&' + query
        })
      }
    })
  },
  getPhoneNumber(e) {
    if (e.detail.errMsg === 'getPhoneNumber:ok') {
      LOADING.show({
        title: '登录中...'
      })
      WGAUTH.getPhoneNumber(e).then(res => {
        LOADING.hide()
        this.setData({
          isLogin: true
        })
        wx.showToast({
          icon: 'none',
          title: '登录成功！',
          duration: 1500
        })
      })
    }
  },
  closeModal() {
    this.setData({
      hideLoginPanel: true
    })
  },
  getCoupons(id) {
    let cusId = wx.getStorageSync('cusId')
    if (cusId) {
      api.coupons.detail(id).then(r => {
        if (r.needPoints == 0) {
          api.coupons.receive(cusId, id, r.userTkcpAmount)
        } else {
          wx.showModal({
            title: '提示',
            content: '领一张券需扣您' + r.needPoints + '积分，您确定要领吗?',
            success(res) {
              if (res.confirm) {
                api.coupons.receive(cusId, id, r.userTkcpAmount)
              }
            }
          })
        }
      })
    } else {
      this.setData({
        hideLoginPanel: false
      })
    }
  },
  onHide() {
  },
  onLoad(option) {
    if (option.pageName) {
      wx.setNavigationBarTitle({
        title: option.pageName
      })
    }
    let id = option.id
    api.modules.exchange(id).then(r => {
      let obj = JSON.parse(r.jsonData)
      this.setData({
        list: obj,
        id: option.id
      })
    })
    staffShare.setShareStaffIdByShare(option)

    try {   
      wx.onCopyUrl(() => {
        return { query: WGFORMAT.formatQueryByOptions(option) }
      })
    } catch (error) {
      console.warn('暂不支持wx.onCopyUrl')
    }

    if(option.noShare) { // 禁止转发分享
      wx.hideShareMenu()
      wx.updateShareMenu({
        withShareTicket: true,
        isPrivateMessage: true,
      })
    }
  },
  onShareAppMessage: function () { // 自定义点击右上角转发内容
    return {
      title: '五谷磨房，创造精致生活的更多种选择',
      path: '/pages/ActivityPage/ActivityPage?id=' + this.data.id + '&' + staffShare.getShareParams() //分享人工号，此时分享人为登录者本人
    }
  },
  onShareTimeline() { // 分享朋友圈
    return {
      title: '五谷磨房，创造精致生活的更多种选择',
      path: '/pages/ActivityPage/ActivityPage?id=' + this.data.id + '&' + staffShare.getShareParams() //分享人工号，此时分享人为登录者本人
    }
  },
})