import {
  REQUEST,
  API,
  LOADING
} from '../../utils/index'
import {
  Page
} from '../../wgUtils/index';

const app = getApp()
const data = {
  addressModule: null,
  adIndex: null,
  source: 0,
  msg: '暂无数据'
}
const methods = {
  close(event) {
    var myEventOption = {} // 触发事件的选项
    let param = {
      checkIndex: event.currentTarget.dataset.index
    }
    this.triggerEvent('toAddressList', param, myEventOption)
  },
  toManage(e) { // 管理地址
    if (e.currentTarget.dataset.type == 'true') {
      wx.setStorageSync('add', 3)
    } else {}
    wx.navigateTo({
      url: "/pages/AddressManage/AddressManage?isEdit=" + e.currentTarget.dataset.type,
    })
  },
  check(e) {
    app.globalData.adIndex = e.currentTarget.dataset.checkId
    var pages = getCurrentPages();
    var currPage = pages[pages.length - 1]
    var prevPage = pages[pages.length - 2]
    prevPage.setData({
      adIndex: e.currentTarget.dataset.checkId
    })
    wx.navigateBack()
  },
  getAddressList() {
    let cusId = wx.getStorageSync('cusId')
    if (cusId) {
      return new Promise((resolve, reject) => {
        REQUEST.get(API.get_address, {
          data: {
            openId: '',
            cusId: cusId
          }
        }).then((res) => {
          const {
            status,
            data
          } = res.data
          let defaultAddress = null
          if (status == 0) {
            if (data.length == 1) {
              data[0].isChecked = true
            } else {
              for (let i = 0; i < data.length; i++) {
                if (app.globalData.adIndex == null) { // 未设置
                  if (data[i].isDefault) {
                    data[i].isChecked = true
                    defaultAddress = data[i]
                  } else {
                    data[i].isChecked = false
                  }
                } else {
                  if (data[i].id == app.globalData.adIndex) { // 选择
                    data[i].isChecked = true
                    defaultAddress = data[i]
                  } else {
                    data[i].isChecked = false
                  }
                }
              }
            }
            this.setData({
              addressModule: data,
              defaultAddress: defaultAddress
            })
          } else if (status == 10021) {
            this.setData({
              addressModule: []
            })
          }
          resolve(defaultAddress)
        }).catch((e) => {
          reject(e)
        })
      })
    } else {
      return Promise.resolve('无cusId')
    }
  }
}
Page({
  data,
  ...methods,
  onShow: function () {
    wx.hideShareMenu()
    LOADING.show()
    this.setData({
      adIndex: app.globalData.adIndex
    })
    this.getAddressList().then((res) => {
      LOADING.hide()
    })
  },
  onLoad(e) {
  },
  onHide() {},
})