import {
  REQUEST,
  API
} from '../../utils/index'
import {
  Page
} from '../../wgUtils/index';

const data = {
  isEdit: true,
  editModule: {
    receiverName: null,
    receiverPhone: null,
    additional: null,
    region: []
  },
  origin: '',
  addressModule: []
}
const app = getApp()
const methods = {
  edit(e) {
    if (e.detail.type == 'false') { // 编辑
      let region = [e.detail.item.province.regionName, e.detail.item.city.regionName, e.detail.item.district.regionName]
      this.setData({
        isEdit: true,
        editModule: e.detail.item,
        region: region,
        'editModule.provinceId': e.detail.item.province.id,
        'editModule.cityId': e.detail.item.city.id,
        'editModule.districtId': e.detail.item.district.id
      })
    } else { // 新增
      this.setData({
        isEdit: true,
        region: [],
        editModule: {
          receiverName: '',
          receiverPhone: '',
          additional: '',
          region: []
        }
      })
    }
  },
  getAddressList(id) {
    let cusId = wx.getStorageSync('cusId')
    if (cusId) {
      REQUEST.get(API.get_address, {
        data: {
          openId: '',
          cusId: wx.getStorageSync('cusId')
        }
      }).then((res) => {
        const {
          status,
          data
        } = res.data
        if (status == 0) {
          if (data.length > 0) {
            for (let i = 0; i < data.length; i++) {
              if (data[i].isDefault) {
                if (app.globalData.adIndex == id) {
                  app.globalData.adIndex = data[i].id
                }
                data[i].isChecked = true
                break;
              }
              data[i].isChecked = false
            }
            this.setData({
              addressModule: data
            })
          } else {
            this.setData({
              addressModule: []
            })
          }
        } else if (status == 10021) { // 地址无效: 地址为空
          this.setData({
            addressModule: []
          })
        }
      }).catch((e) => {})
    }
  },
  editShow() {
    this.getAddressList()
    this.setData({
      isEdit: false
    })
  }
}
Page({
  data,
  ...methods,
  onLoad: function (options) {
    if (options.isEdit == 'true') { // 新增
      this.setData({
        isEdit: true,
        actType: options.actType ? options.actType : 0
      })
    } else { // 编辑
      this.setData({
        isEdit: false
      })
    }
    if (options.from == 'user') {
      this.setData({
        origin: 'user'
      })
    }
  },
  onHide() {},
  onShow: function (options) {
    wx.hideShareMenu()
    this.getAddressList()
  }
})