import {
  WGAUTH,
  WGCOMMON,
  Page,
  WGTRACK
} from '../../wgUtils/index'

Page({
  data: {
    hidePopUp: true,
    canIUseGetUserProfile: false
  },
  bindgetuserinfo(e) {
    WGCOMMON.showLoading()
    WGAUTH.getUserInfo(e).then(res => {
      WGCOMMON.hideLoading()
      this.setData({
        hidePopUp: false
      })
    }).catch(() => {
      wx.clearStorageSync()
      WGCOMMON.toast('发生错误，请重试')
      WGAUTH.wxLogin()
      WGCOMMON.hideLoading()
    })
  },
  bindgetphonenumber(e) {
    WGCOMMON.showLoading()
    WGAUTH.getPhoneNumber(e).then(() => {
      WGCOMMON.hideLoading()
      WGCOMMON.toast('登录成功，3s后将返回上一页！您的会员ID为：' + wx.getStorageSync('cusId'), 3000)
      let pages = getCurrentPages() // 获取页面信息栈
      // let currentPage = pages[pages.length - 1]  // 获取当前访问页面的信息
      let prevPage = pages[pages.length - 2] // 获取上一个页面信息栈
      if(prevPage) {
        setTimeout(function () {
          wx.redirectTo({
            url: '/' + prevPage.route + WGTRACK.getQueryString(prevPage.options)
          })
        }, 3000)
        return
      }
      setTimeout(function () {
        wx.switchTab({
          url: '/pages/Home/Home'
        })
      }, 3000)
    }).catch(() => {
      wx.clearStorageSync()
      WGCOMMON.toast('发生错误，请重试')
      WGAUTH.wxLogin()
      WGCOMMON.hideLoading()
    })
  },
  getUserProfile(e) {
    WGCOMMON.showLoading()
    WGAUTH.getUserProfile().then(() => {
      WGCOMMON.hideLoading()
      this.setData({
        hidePopUp: false
      })
    }).catch(() => {
      WGCOMMON.toast('微信授权错误，请重试')
      WGCOMMON.hideLoading()
    })
  },
  onLoad() {
    if (wx.getUserProfile) {
      this.setData({
        canIUseGetUserProfile: true
      })
    }
  }
})