import json from './data'
import api from '../../api/index'
import {
  LOADING
} from '../../utils/index'
import env1 from '../../utils/env1'
import {
  WGAUTH,
  Page,
  WGFORMAT,
  WGTRACK
} from '../../wgUtils/index';

const app = getApp()

Page({
  data: {
    isLogin: false,
    banner: '',
    user: null,
    list: null,
    showModal: false,
    showModal1: false,
    gzh: true,
    isShowGif: false
  },
  toHome() {
    wx.switchTab({
      url: '/pages/Home/Home?_campaign=jifenmall-ico'
    })
  },
  binderror(e) {
    console.log('加载关注公众号组件失败')
    this.setData({
      gzh: false
    })
  },
  bindload(e) {
    console.log('加载关注公众号组件成功')
    this.setData({
      gzh: true
    })
  },
  goExtension(){
    wx.navigateTo({
      url: '/modules/Svip/pages/ExtensionCar/ExtensionCar'
    })
  },
  linkToPage(e) {
    let link = e.currentTarget.dataset.link
    if(link == 'shequn') {
      this.setData({
        showModal1: true
      })
    }
    if(link == 'https://mp.weixin.qq.com/s/2ROy0cYNgjINrCe9VOq_6g'){
      wx.navigateTo({
        url: '/pages/WebView/WebView?url=https://mp.weixin.qq.com/s/2ROy0cYNgjINrCe9VOq_6g'
      })
    }
    console.log(e)
    if(link == 'https://www.gzuni.com/apps/kingcard/b2i/num_mall/wgmf_wk' || link == 'https://www.gzuni.com/apps/kingcard/b2i/num_mall/wgmf_msk' || link == 'https://www.gzuni.com/apps/kingcard/b2i/num_mall/wgmf_czk'){
      // 埋点
      if(link == 'https://www.gzuni.com/apps/kingcard/b2i/num_mall/wgmf_wk'){
        WGTRACK.logCustomEvent('click_menu_wgmf_wk')
      } else if(link == 'https://www.gzuni.com/apps/kingcard/b2i/num_mall/wgmf_msk'){
        WGTRACK.logCustomEvent('click_menu_wgmf_msk')
      } else if(link == 'https://www.gzuni.com/apps/kingcard/b2i/num_mall/wgmf_czk'){
        WGTRACK.logCustomEvent('click_menu_wgmf_czk')
      }
      wx.navigateTo({
        url: '/pages/WebView/WebView?url='+ link
      })
    }
    if (typeof link == 'number') {
      wx.navigateTo({
        url: '/pages/ProductDetail/ProductDetail?pId=' + link
      })
    } else {
      let sl = link.split('?')[0]
      if (sl == 'http://wx.wgmf.com/wechat-html/html/farm/chooseSeed.html' || sl == 'http://wx.wgmf.com/wechat-html/html/breakfastTime/breakfastTime.html') {
        console.log('农场签到')
        this.setData({
          showModal: true
        })
      } else if (sl == 'https://wx.wgmf.com/shop-web/shop/productIndex.html') {
        console.log('购买产品')
        wx.switchTab({
          url: '/pages/Home/Home'
        })
      } else if (sl == 'http://wx.wgmf.com/wechat-html/html/member/wanshanData.html') {
        wx.showToast({
          title: '前往“五谷磨房”公众号完善资料哦~',
          icon: 'none'
        })
        console.log('完善资料')
      }
    }
  },
  exchangeRule() {
    wx.navigateTo({
      url: '/pages/IntegralAccount/IntegralAccount'
    })
  },
  closeModal() {
    this.setData({
      showModal: false,
      showModal1: false
    })
  },
  initUser() {
    let cusId = wx.getStorageSync('cusId')
    if (cusId) {
      api.user.info(cusId).then(r => {
        if (r) {
          let levelImg = 'https://img.wgmf.com/leve_1.png'
          switch (r.customerGrade) {
            case '谷谷会员':
              levelImg = 'https://img.wgmf.com/leve_1.png';
              break;
            case '银谷会员':
              levelImg = 'https://img.wgmf.com/leve_2.png';
              break;
            case '金谷会员':
              levelImg = 'https://img.wgmf.com/leve_3.png';
              break;
            case '钻谷会员':
              levelImg = 'https://img.wgmf.com/leve_4.png';
              break;
          }
          this.setData({
            isLogin: true,
            user: {
              nickname: wx.getStorageSync('nickName') ? wx.getStorageSync('nickName') : (r.customerName ? r.customerName : '匿名'),
              avatarUrl: wx.getStorageSync('avatarUrl') ? wx.getStorageSync('avatarUrl') : (r.headImgUrl ? r.headImgUrl : 'https://img.wgmf.com/img_default1.png'),
              intergral: r.validPoint,
              phone: r.customerMobile,
              level: r.customerGrade,
              levelImg: levelImg
            }
          })
        }
      })
    } else {
      this.setData({
        isLogin: false
      })
    }
  },
  getPhoneNumber(e) {
    if (e.detail.errMsg === 'getPhoneNumber:ok') {
      LOADING.show({
        title: '登录中...'
      })
      WGAUTH.getPhoneNumber(e).then(res => {
        LOADING.hide()
        this.initUser()
      })
    }
  },
  // 长按保存图片
  saveImage(e) {
    let url = e.currentTarget.dataset.url;
    //用户需要授权
    wx.getSetting({
      success: (res) => {
        if (!res.authSetting['scope.writePhotosAlbum']) {
          wx.authorize({
            scope: 'scope.writePhotosAlbum',
            success: () => {
              this.saveImg1(url); // 同意授权
            },
            fail: (res) => {
              console.log(res);
            }
          })
        } else { // 已经授权了
          this.saveImg1(url);
        }
      },
      fail: (res) => {
        console.log(res);
      }
    })
  },
  saveImg1(url) {
    let that = this
    wx.getImageInfo({
      src: url,
      success: (res) => {
        let path = res.path;
        wx.saveImageToPhotosAlbum({
          filePath: path,
          success: (res) => {
            console.log(res);
            that.setData({
              showModal: false
            })
            wx.showToast({
              icon: 'none',
              title: '二维码保存成功！记得关注“五谷磨房”公众号，前往五谷农场签到领积分~',
              duration: 3500
            })
          },
          fail: (res) => {
            console.log(res);
          }
        })
      },
      fail: (res) => {
        console.log(res);
      }
    })
  },
  onHide() {},
  onLoad(option) {
    this.setData({
      list: json,
      banner: json[0]
    })
    // 正式环境 id  623
    // 测试环境 id  427
    let id = 623
    if (env1 == 'TEST') {
      id = 427
    }
    api.modules.exchange(id).then(r => {
      if (r) {
        let obj = JSON.parse(r.jsonData)
        this.setData({
          list: obj,
          banner: obj[0]
        })
      }
    })
    this.initUser()
    try {   
      wx.onCopyUrl(() => {
        return { query: WGFORMAT.formatQueryByOptions(option) }
      })
    } catch (error) {
      console.warn('暂不支持wx.onCopyUrl')
    }
  },
  onShareAppMessage: function (res) { // 自定义点击右上角转发内容
    return {
      title: '五谷磨房积分商城',
    }
  },
  onShareTimeline() { // 分享朋友圈
    return {
      title: '五谷磨房积分商城',
    }
  },
  onShow() {
    let now = new Date().getTime()
    let option1 = WGFORMAT.targetDateInDateBetwen('2020-08-19 20:00:00', '2020-08-28 23:59:59', now)
    console.log('option1------', option1)
    if (option1) {
      this.setData({
        isShowGif: true
      })
    }
  }
})