import {
  WGAUTH,
  Page,
  WGCOMMON
} from '../../wgUtils/index'
import WGAPI from '../../api/index'

Page({
  data: {
    coupon: null,
    hideLoginPanel: true
  },
  closeModal() {
    this.setData({
      hideLoginPanel: true
    })
  },
  getPhoneNumber(e) {
    if (e.detail.errMsg === 'getPhoneNumber:ok') {
      WGCOMMON.showLoading('登录中...')
      WGAUTH.getPhoneNumber(e).then(res => {
        WGCOMMON.hideLoading()
        this.setData({
          hideLoginPanel: true
        })
        wx.showToast({
          icon: 'none',
          title: '登录成功！',
          duration: 1500
        })
      }).catch(e => {
        WGCOMMON.toast('发生错误，请重试')
        wx.clearStorageSync()
        WGAUTH.wxLogin()
      })
    }
  },
  linkToPage(link) {
    if (!link) return
    if (link.indexOf('productDetail.html') != -1) {
      let query = link.split('?')
      wx.navigateTo({
        url: '/pages/ProductDetail/ProductDetail?' + query[1]
      })
    } else if (link.indexOf('productIndex.html') != -1) { // 首页
      wx.switchTab({
        url: '/pages/Home/Home'
      })
    } else if (link.indexOf('productList.html') != -1) { // 分类页
      wx.switchTab({
        url: '/pages/ProductIndex/ProductIndex'
      })
    } else if (link.indexOf('myCart.html') != -1) { // 购物车
      wx.switchTab({
        url: '/pages/MyCart/MyCart'
      })
    } else if (link.indexOf('ticketList.html') != -1) { // 我的优惠券
      wx.navigateTo({
        url: '/pages/TicketsAccount/TicketsAccount'
      })
    } else {
      return
    }
  },
  linkToTargetPage(maTkcpButtonUrl, tkcpButtonUrl) {
    if (maTkcpButtonUrl) {
      if (maTkcpButtonUrl.indexOf('/pages/Home/Home') != -1 || maTkcpButtonUrl.indexOf('modules/FanCommunity/pages/Index/Index') != -1 || maTkcpButtonUrl.indexOf('/pages/ProductIndex/ProductIndex') != -1 || maTkcpButtonUrl.indexOf('/pages/MyCart/MyCart') != -1 || maTkcpButtonUrl.indexOf('/pages/PersonalCenter/PersonalCenter') != -1) { // 首页 + 超级会员
        wx.switchTab({
          url: maTkcpButtonUrl
        })
      } else if (maTkcpButtonUrl.indexOf('.wgmf.com/shop-web/shop/') != -1) {
        this.linkToPage(maTkcpButtonUrl)
      } else {
        wx.navigateTo({
          url: maTkcpButtonUrl
        })
      }
    } else {
      this.linkToPage(tkcpButtonUrl)
    }
  },
  getTicket() {
    let cusId = wx.getStorageSync('cusId')
    let that = this
    if (cusId) {
      if (this.data.coupon.needPoints == 0) {
        WGAPI.coupons.receive(cusId, this.data.coupon.id, this.data.coupon.userTkcpAmount).then(res => {
          if (res.data.status == 0 || res.data.msg == '领券成功！') {
            setTimeout(function () {
              that.linkToTargetPage(that.data.coupon.maTkcpButtonUrl, that.data.coupon.tkcpButtonUrl)
            }, 1500)
          } else if (res.data.msg == '你已经达到参加次数上限') {
            setTimeout(function () {
              wx.navigateTo({
                url: '/pages/TicketsAccount/TicketsAccount'
              })
            }, 2000)
          }
        })
      } else {
        WGCOMMON.showModal('提示', '领一张券需扣您' + this.data.coupon.needPoints + '积分，您确定要领吗?').then(res => {
          WGAPI.coupons.receive(cusId, this.data.coupon.id, this.data.coupon.userTkcpAmount).then(res => {
            if (res.data.status == 0 || res.data.msg == '领券成功！') {
              setTimeout(function () {
                that.linkToTargetPage(that.data.coupon.maTkcpButtonUrl, that.data.coupon.tkcpButtonUrl)
              }, 1500)
            } else if (res.data.msg == '你已经达到参加次数上限') {
              setTimeout(function () {
                wx.navigateTo({
                  url: '/pages/TicketsAccount/TicketsAccount'
                })
              }, 2000)
            }
          })
        }).catch(() => {})
      }
    } else {
      this.setData({
        hideLoginPanel: false
      })
    }
  },
  onLoad(e) {
    if (e.id) {
      WGAPI.coupons.detail(e.id).then(res => {
        this.setData({
          coupon: res
        })
      })
    } else {
      WGCOMMON.toast('优惠券id错误或无传入优惠券id')
    }
    wx.showShareMenu({
      withShareTicket: true
    })
    wx.hideShareMenu()
  },
  // onShareAppMessage: function (res) { // 自定义点击右上角转发内容
  //   return {
  //     title: '五谷磨房，创造精致生活的更多种选择',
  //     path: '/pages/Home/Home',
  //     imageUrl: 'http://img.wgmf.com/pro_p_011581483471197.jpg'
  //   }
  // },
})