import {
  REQUEST,
  API,
  LOADING,
  TOAST
} from '../../utils/index.js'
import {
  Page
} from '../../wgUtils/index.js';
const app = getApp()

const data = {
  gwjRules: [{
      "label": "1、什么是购物金？",
      "content": "购物金是会员商城的一种虚拟奖励金，在会员商城消费时可按照一定比例抵扣订单金额，不足部分需补足差额，每笔订单需至少支付人民币0.01元。如有购物金剩余可在后续订单中使用。每个活动获取购物金的有效期限不同，到期未使用的购物金可能会被清零。"
    },
    {
      "label": "2、购物金的使用条件",
      "content": "购物金可与优惠券同时使用，但不适用于定金产品，且一个账户中的购物金仅限于一个账户购买时使用。不得转赠送他人，不得提现。"
    },
    {
      "label": "3、如何获得购物金？",
      "content": "会不定期推出购物金的活动，每个活动中获得的购物金规则与金额不同，具体以各个活动的通知详情为准。"
    }, {
      "label": "4、如何使用购物金？",
      "content": "购物金在可使用期间，在会员商城下单时会根据抵扣规则自动使用购物金，可在结算页面查看到该笔订单。"
    },
    {
      "label": "5、如何查看我的购物金？",
      "content": "用户直接进入【五谷磨房会员商城】→【个人中心】→【购物金】即可查看可使用购物金金额，点击可实时查看购物金金额变动明细。"
    },
    {
      "label": "6、购物金有效期是多久？",
      "content": "每笔购物金有效期为一年，逾期未使用将自动作废并扣除，可在明细中查看过期时间。"
    }
  ],
  showRules: false,
  reqParams: {
    cusId: wx.getStorageSync('cusId'),
    page: 1,
    amount: 20
  },
  gwjModule: [],
  noData: false,
  LoginShow: false,
  gwjNum: 0,
  balanceOut: 0,
  expiredBalance: 0
}
const methods = {
  showRules() {
    this.setData({
      showRules: !this.data.showRules
    })
  },
  getGwjList() {
    if (!wx.getStorageSync('cusId') || !wx.getStorageSync('unionId')) {
      this.setData({
        LoginShow: true
      })
      return false
    }
    LOADING.show()
    REQUEST.get(API.get_cash_detail, {
      data: this.data.reqParams
    }).then((res) => {
      if (res.data.length > 0) {
        let oldVal = this.data.gwjModule
        ++this.data.reqParams.page
        this.setData({
          gwjModule: oldVal.concat(res.data),
        })
      } else {
        this.setData({
          noData: true
        }, () => {
          TOAST.warning({
            title: '没有数据了哦！',
            duration: 1500
          })
        })
      }
      LOADING.hide()
    })
  },
  goIndex() {
    if (this.data.gwjNum == 0) {
      TOAST.warning({
        title: '账户余额不足，不可使用！'
      })
      return false
    }
    wx.switchTab({
      url: '/pages/Home/Home'
    })
  },
  login() {
    this.data.reqParams.cusId = wx.getStorageSync('cusId')
    this.setData({
      LoginShow: false,
    }, () => {
      this.getGwjList()
      this.getGwjRelate()
    })
  },
  getGwjRelate() {
    let url = API.get_gwj_relate + '?openId=' + wx.getStorageSync('openId') + '&cusId=' + wx.getStorageSync('cusId') + '&sourceType=1'
    REQUEST.get(url).then((res) => {
      const {
        status,
        retCode,
        data
      } = res.data
      if (data && status == 0) {
        this.setData({
          gwjNum: data.balance ? data.balance : 0,
          balanceOut: data.balanceOut ? data.balanceOut : 0,
          expiredBalance: data.expiredBalance
        })
      }
    })
  }
}
Page({
  data,
  ...methods,
  onLoad: function (option) {
  },
  onHide() {},
  onShow: function () {
    this.data.reqParams.cusId = wx.getStorageSync('cusId')
    this.getGwjList()
    this.getGwjRelate()
  },
  onReachBottom: function () {
    if (!this.data.noData) {
      this.getGwjList()
    } else {
      TOAST.warning({
        title: '没有数据了哦！',
        duration: 1500
      })
    }
  },
  onShareAppMessage: function () {
    return {
      title: '五谷磨房个人中心'
    }
  }
})