import api from '../../api/index'
import {
  LOADING,
  FILTER
} from '../../utils/index'
import User from '../../store/index.js'
const app = getApp()
import {
  WGAUTH,
  WGFORMAT,
  Page
} from '../../wgUtils/index';

Page({
  data: {
    isVip: false, // 是否是超级会员
    product: null, // 产品信息
    group: null, // 团购信息
    ticker: null, // 倒计时计时器
    tickerTime: {
      h: '00',
      m: '00',
      s: '00'
    }, // 倒计时时间
    type: 0, // 0未登录 1已登录参加别人的团 2已登录邀请别人来参团 3已登录团已结束自己开团
    // 0未登录   1已登录未参团   2已登录已参团   3团已结束
    myHeadImg: '', // 头像
    chooseSkuShow: false, // 是否显示选择sku弹窗
    productInfo: { // sku组件需要的产品数据
      actType: 16, // 16团购
      operationType: 2 // 2团购立即购买
    },
    weikBanner: false,
    noticeModule: null, // notice相关信息
    bannerTarget: '',
    bannerUrl: '',
    canIUseGetUserProfile: false,
    showSecModal: false,
    noBuy: 0
  },
  toggleShowSecModal() {
    this.setData({ showSecModal: true })
  },
  startTick(endTime, nowTime) { // 开始倒计时
    let that = this
    let time = parseInt((endTime - nowTime) / 1000)
    let h = 0,
      m = 0,
      s = 0
    if (time > 0) {
      let tickerFn = setInterval(function () {
        h = parseInt(time / 3600)
        m = parseInt((time - h * 3600) / 60)
        s = parseInt(time - h * 3600 - m * 60)
        that.setData({
          tickerTime: {
            h: h < 10 ? '0' + h : h,
            m: m < 10 ? '0' + m : m,
            s: s < 10 ? '0' + s : s
          }
        })
        time--
        if (time <= 0) {
          clearInterval(tickerFn)
          clearInterval(that.data.ticker)
        }
      }, 1000)
      this.setData({
        ticker: tickerFn
      })
    }
  },
  initGroup(code) { // 初始化团购信息 wechat-shop-back/groupPurchase/groupInfo/cashBack/${团购单号}
    LOADING.show()
    api.promotion.groupB(code).then(res => {
      let submitDate = new Date(res.groupPurchaseOrder.startTime)
      let date = {
        y: submitDate.getFullYear(),
        M: submitDate.getMonth() + 1,
        d: submitDate.getDate(),
        h: submitDate.getHours(),
        m: submitDate.getMinutes(),
        s: submitDate.getSeconds()
      }
      res.submitDate = `${date.y}-${date.M<10?'0'+date.M:date.M}-${date.d<10?'0'+date.d:date.d} ${date.h<10?'0'+date.h:date.h}:${date.m<10?'0'+date.m:date.m}:${date.s<10?'0'+date.s:date.s}`
      res.groupPurchaseOrder.groupPurchaseOrderDetailRes = res.groupPurchaseOrder.groupPurchaseOrderDetailRes.slice(0, 20)
      this.setData({
        group: res, // 团购信息
        orderCusId: res.groupPurchaseOrder.colonelCusId, // 团长cusId
        orderStatus: res.groupPurchaseOrder.purchaseStatus, // 团购状态 1团购中 2团购成功
        'productInfo.groupObj.id': res.groupPurchase.id, // 团购id
      })
      let orders = res.groupPurchaseOrder.groupPurchaseOrderDetailRes // 团内所有人的订单列表
      let isInGroup = false // 是否参团标志
      let cusId = wx.getStorageSync('cusId')
      for (let i = 0; i < orders.length; i++) {
        if (orders[i].cusId == cusId) {
          isInGroup = true
          i = orders.length
        }
      }
      this.setData({
        isInGroup: isInGroup
      })
      // LOADING.hide()
      this.getSvipStatus()
      this.refreshType()
      this.startTick(res.groupPurchaseOrder.endTime, res.nowDate)
      this.initProduct(res.groupPurchase.productTemplateId)
      // LOADING.hide()
    })
  },
  initProduct(id) { // 初始化产品信息 wechat-shop-back/product/info/template/${pId}
    LOADING.show()
    api.product.detail(id).then(res => {
      if (res.groupedImages && res.groupedImages.icon) {
        res.cover = res.groupedImages.icon[0].imageUrl
      } else {
        res.cover = 'http://7xv1io.com1.z0.glb.clouddn.com/product/image/shareLogo.jpg'
      }
      let groupSku = []
      let purchaseLimit = 0
      for (let i = 0; i < res.groupPurchase.length; i++) {
        if (res.groupPurchase[i].productTemplateId == id && res.groupPurchase[i].groupPurchaseLines.length > 0) {
          purchaseLimit = res.groupPurchase[i].purchaseLimit
          groupSku.push(...res.groupPurchase[i].groupPurchaseLines)
        }
      }
      groupSku.sort(function (a, b) {
        return a.purchasePrice - b.purchasePrice
      })
      let min = groupSku[0].purchasePrice
      let max = groupSku[groupSku.length - 1].purchasePrice
      if (min == max) {
        res.priceCn = min
        res.vipPriceCn = WGFORMAT.formatCurrency(min * 0.95) * 100 / 100
      } else {
        res.priceCn = min + '~' + max
        res.vipPriceCn = (WGFORMAT.formatCurrency(min * 0.95)) * 100 / 100 + '~' + WGFORMAT.formatCurrency(max * 0.95) * 100 / 100
      }
      let stock = 0
      // let productsArr = []
      let curSKU = ''
      let productIcon = ''
      let price = this._getPrice(res.products)
      if (res.groupedImages && res.groupedImages.icon) { // 商品缩略图
        productIcon = res.groupedImages.icon[0].imageUrl
      } else {
        productIcon = 'http://7xv1io.com1.z0.glb.clouddn.com/product/image/shareLogo.jpg'
      }
      for (let i = 0; i < res.products.length; i++) {
        if (res.products[i].enable === 0) {
          // productsArr.push(res.products[i])
          stock += res.products[i].stock
          for (let j = 0; j < groupSku.length; j++) {
            if (res.products[i].id == groupSku[j].productId) {
              res.products[i].groupPrice = groupSku[j].purchasePrice
              res.products[i].groupLimit = purchaseLimit
            }
          }
        }
      }
      console.log(stock)
      if (res.products.length === 1) curSKU = res.products[0]
      console.log(res.products)
      this.setData({
        'productInfo.isVipOnly': res.groupPurchase[0].isVipOnly,
        product: res,
        'productInfo.products': res.products,
        'productInfo.productTemplateName': res.productTemplateName,
        'productInfo.groupedImages': res.groupedImages,
        'productInfo.stock': stock,
        'productInfo.warehouseCode': res.warehouseCode,
        'productInfo.price': price,
        'productInfo.groupPrice': res.priceCn,
        'productInfo.superPrice': res.vipPriceCn,
        curSKU: curSKU,
        productIcon: productIcon,
      })
      LOADING.hide()
    })
  },
  _getPrice(products) { // 商品原价区间
    if (products) {
      if (!products) return '-'
      let arr = []
      for (let i = 0; i < products.length; i++) {
        arr.push(products[i].price)
      }
      return FILTER.getPriceRange(arr)
    }
  },
  getSvipStatus() { // 获取超级会员信息
    User.getSvipStatus(wx.getStorageSync('cusId')).then(res => {
      wx.setStorageSync('vipCusStatus', res.resultInfo.vipCusStatus)
      this.setData({
        isVip: res.resultInfo.vipCusStatus == 1,
        'productInfo.vipCusStatus': res.resultInfo.vipCusStatus
        // 'productInfo.vipCusStatus': 1
      })
    })
  },
  bindgetphonenumber(e) { // 登录
    if (e.detail.errMsg === 'getPhoneNumber:ok') {
      LOADING.show({
        title: '登录中...'
      })
      WGAUTH.getPhoneNumber(e).then(res => {
        LOADING.hide()
        this.getSvipStatus()
        this.refreshType()
      }).catch((e) => {
        LOADING.hide()
        TOAST.warning(e)
      })
    }
  },
  getUserProfile() {
    WGAUTH.getUserProfile().then(res => {
      app.globalData.userAvatarUrl = wx.getStorageSync('avatarUrl')
      app.globalData.nickName = wx.getStorageSync('nickName')
      this.setData({
        myHeadImg: wx.getStorageSync('avatarUrl')
      })
      this.showChooseSku()
    })
  },
  onGotUserInfo(e) { // 获取用户头像
    if (e.detail.errMsg === 'getUserInfo:ok') {
      WGAUTH.getUserInfo(e).then(res => {
        app.globalData.userAvatarUrl = JSON.parse(e.detail.rawData).avatarUrl
        app.globalData.nickName = JSON.parse(e.detail.rawData).nickName
        this.setData({
          myHeadImg: JSON.parse(e.detail.rawData).avatarUrl
        })
        this.showChooseSku()
      })
    }
  },
  goDetail() {
    let moreQuery = this.data.noBuy == 1?'&noBuy=1':''
    wx.navigateTo({
      url: '/pages/ProductDetail/ProductDetail?pId=' + this.data.group.groupPurchase.productTemplateId + moreQuery,
    })
  },
  refreshType() {
    let cusId = wx.getStorageSync('cusId')
    let status = this.data.orderStatus
    if (cusId) { // 已登录
      if (status == 1) { // 拼团中
        if (this.data.isInGroup) {
          this.setData({
            type: 2
          })
        } else {
          this.setData({
            type: 1
          })
        }
      } else { // 拼团结束
        this.setData({
          type: 3
        })
      }
    } else { // 未登录
      this.setData({
        type: 0
      })
    }
  },
  showChooseSku() {
    if(this.data.productInfo.vipCusStatus != 1 && this.data.productInfo.isVipOnly == 1) {
      this.toggleShowSecModal()
      return
    }
    this.setData({
      chooseSkuShow: true
    })
  },
  closeSku(e) {
    app.globalData.selectedData = null
    let data = this.data.productInfo
    this.setData({
      chooseSkuShow: e.detail,
      productInfo: data
    })
  },
  getBanner() { // 获取产品详情页公告
    let now = new Date().getTime()
    api.product.banner().then(res => {
      for(let i=0;i<res.length;i++) {
        if(res[i].isDeleted == 0 && WGFORMAT.targetDateInDateBetwen(res[i].startTime, res[i].endTime, now)) {
          this.setData({
            weikBanner: true,
            bannerUrl: res[i].imgUrl,
            bannerTarget: res[i].noticeLink
          })
        }
      }
    })
  },
  toBannerTarget() {
    let link = this.data.bannerTarget
    if(!link) return
    if(link.indexOf('shop-web/shop/productIndex.html') != -1 || link.indexOf('/Home/Home') != -1) { // 首页
      wx.switchTab({
        url: '/pages/Home/Home'
      })
    } else if(link.indexOf('.wgmf.com/wechat-html/html/shop/product/') != -1) { // H5二级页面
      let arr = link.split('?')
      let a = arr[0]
      let b = a.split('/')
      let url = b[b.length - 1]
      let query = arr.length > 1 ? arr[1] : ''
      this.linkToOtherPage(url, query)
    } else if(link.indexOf('orderList.html') != -1 || link.indexOf('OrderList/OrderList') != -1) { // 订单列表
      wx.navigateTo({
        url: '/pages/OrderList/OrderList?orderType=1'
      })
    } else if (link.indexOf('productList.html') != -1) { // 分类页
      wx.switchTab({
        url: '/pages/ProductIndex/ProductIndex'
      })
    } else if (link.indexOf('myCart.html') != -1 || link.indexOf('MyCart/MyCart') != -1) { // 购物车
      wx.switchTab({
        url: '/pages/MyCart/MyCart'
      })
    } else if(link.indexOf('superMember.html') != -1) { // 超级会员页
      wx.navigateTo({ 
        url: "/pages/superMember/superMember" 
      })
    } else if(link.indexOf('/WgFans/WgFans') != -1) {  // 谷粉社区
      wx.switchTab({
        url: '/modules/FanCommunity/pages/WgFans/WgFans'
      })
    } else {
      wx.navigateTo({
        url: link
      })
    }
  },
  onShareAppMessage: function (res) {
    return {
      title: '我正在抢购' + this.data.product.productTemplateName + '，快来一起参与团购吧！',
      path: '/pages/GroupBDetail/GroupBDetail?grouppurchaseCode=' + this.data.grouppurchaseCode + '&_campaign=share',
      imageUrl: this.data.product.cover
    }
  },
  onHide() {},
  onLoad(e) {
    if(wx.getStorageSync('avatarUrl')) {
      this.setData({
        myHeadImg: wx.getStorageSync('avatarUrl')
      })
    }
    this.initGroup(e.grouppurchaseCode)
    let cusId = wx.getStorageSync('cusId')
    if (!cusId) { // 未登录
      this.setData({
        type: 0
      })
    } 
    this.setData({
      grouppurchaseCode: e.grouppurchaseCode,
      'productInfo.groupObj.code': e.grouppurchaseCode
    })
    this.getBanner()

    try {   
      wx.onCopyUrl(() => {
        return { query: WGFORMAT.formatQueryByOptions(e) }
      })
    } catch (error) {
      console.warn('暂不支持wx.onCopyUrl')
    }
    if (wx.getUserProfile) {
      this.setData({
        canIUseGetUserProfile: true
      })
    }
    if(e.noBuy) { // 不让开团
      this.data.noBuy = 1
    }
  },
  onUnload() {
    clearInterval(this.data.ticker)
  }
})