import {
  REQUEST,
  API,
  LOADING,
  TOAST,
  FILTER,
} from '../../utils/index'
import router from '../../router/index.js'
import User from '../../store/index.js'
import {
  WGAUTH,
  Page,
  WGFORMAT
} from '../../wgUtils/index';
import api from '../../api/index'

const app = getApp()
const data = {
  groupStatus: 'http://7xv1io.com1.z0.glb.clouddn.com/mark_group_booking.png',
  groupBtn: '邀请好友拼团',
  chooseSkuShow: false,
  productInfo: {
    actType: 8,
    operationType: 2
  },
  grouppurchaseCode: '',
  pageShow: false,
  shareCardShow: false,
  weikBanner: false,
  noticeModule: null, // notice相关信息
  bannerTarget: '',
  bannerUrl: '',
  canIUseGetUserProfile: false,
  showSecModal: false
}
const methods = {
  toggleShowSecModal() {
    this.setData({ showSecModal: true })
  },
  getSvipStatus() {
    User.getSvipStatus(wx.getStorageSync('cusId')).then(res => {
      this.setData({
        'productInfo.vipCusStatus': res.resultInfo.vipCusStatus
      })
    }, {
      // no cusid
    })
  },
  initData() {
    return new Promise((resolve, reject) => {
      let url = API.group_detail + this.data.grouppurchaseCode
      REQUEST.get(url).then((res) => {
        const {
          status,
          data
        } = res.data
        if (status == 0) {
          let openId = wx.getStorageSync('openId')
          let cusId = wx.getStorageSync('cusId')
          let groupCheaf = null
          let members = []
          let isInGroup = false
          let groupBtn = ' 邀请好友开团'

          let groupPrice = FILTER.getPriceRange(this._getPriceRange(data.groupPurchase.groupPurchaseLines))
          let superPrice = FILTER.getPriceRange(this._getPriceRange(data.groupPurchase.groupPurchaseLines), 0.95)
          // FILTER.getPriceRange(_originalPriceArr)
          let order = data.groupPurchaseOrder.groupPurchaseOrderDetailRes
          let isLogin = false
          for (let i = 0; i < order.length; i++) {
            if (order[i].purchaseIdentity == 1) {
              groupCheaf = order[i]
            } else {
              members.push(order[i])
            }
            if ((openId && openId == order[i].openId) || (cusId && order[i].cusId == cusId)) {
              isInGroup = true
              // app.globalData.userAvatarUrl = groupCheaf.evaluatorHeadImgUrl ? groupCheaf.evaluatorHeadImgUrl : "https://img.wgmf.com/img_default.png"
              // console.log('拼团详情头像', app.globalData.userAvatarUrl)
            }
          }
          data.groupPurchaseOrder.startTime = FILTER.dateFormat(data.groupPurchaseOrder.startTime, 'yyyy-MM-dd hh:mm:ss')
          if (!cusId) {
            // TODU 登陆
            groupBtn = '登录'
            isLogin = true
            this.setData({
              pageShow: true
            })
          } else { // 已登录
            if (data.groupPurchaseOrder.purchaseStatus == 1) {
              if (isInGroup) {
                groupBtn = '邀请好友拼团'
              } else {
                groupBtn = '我也要参团'
              }
              // TODU 过期时间
            } else {
              groupBtn = '我也开个团'
            }

          }
          this.setData({
            groupPurchase: data.groupPurchase,
            groupPurchaseOrder: data.groupPurchaseOrder,
            groupBtn: groupBtn,
            groupCheaf: groupCheaf,
            members: members,
            isInGroup: isInGroup,
            'productInfo.groupPrice': groupPrice,
            'productInfo.superPrice': superPrice,
            nowDate: data.nowDate,
            isLogin: isLogin,
            'productInfo.groupObj.id': data.groupPurchase.id,
            isAuthorize: app.globalData.userAvatarUrl ? true : false
          })
          this._getGroupStatus()
          if (data.groupPurchaseOrder.purchaseStatus == 2 || data.groupPurchaseOrder.purchaseStatus == 3) {
            this.setData({
              h: '00',
              m: '00',
              s: '00'
            })
          } else {
            this.fnCountDown(data.nowDate)
          }
          resolve(data.groupPurchase.productTemplateId)
        }
      }).catch((e) => {
        reject(e)
      })
    })
  },
  _getProDetail(productTemplateId) {
    let url = API.get_productDetail + productTemplateId
    REQUEST.get(url).then((res) => {
      const {
        status,
        data
      } = res.data
      if (status === 0) {
        let groupSku = this.data.groupPurchase.groupPurchaseLines
        let arr = []
        let stock = 0
        let curSKU = ''
        let productIcon = ''
        let price = this._getPrice(data.products)
        for (let i = 0; i < data.products.length; i++) {
          let item = data.products[i]
          if (item.enable === 0) {
            arr.push(item)
          }
        }
        if (arr.length !== 0) {
          for (let i = 0; i < arr.length; i++) {
            for (let j = 0; j < groupSku.length; j++) {
              if (arr[i].id === groupSku[j].productId) {
                arr[i].groupPrice = groupSku[j].purchasePrice
                arr[i].groupLimit = this.data.groupPurchase.purchaseLimit
              }
            }
            if (arr[i].stock > 0) {
              stock = stock + arr[i].stock
            }
          }
        }
        if (data.products.length === 1) {
          curSKU = data.products[0]
        }
        data.products.stock = stock
        if (data.groupedImages && data.groupedImages.icon) { // 商品缩略图
          productIcon = data.groupedImages.icon[0].imageUrl
        } else {
          productIcon = 'http://7xv1io.com1.z0.glb.clouddn.com/product/image/shareLogo.jpg'
        }
        this.setData({
          'productInfo.isVipOnly': data.groupPurchase[0].isVipOnly,
          'productInfo.products': data.products,
          'productInfo.productTemplateName': data.productTemplateName,
          'productInfo.groupedImages': data.groupedImages,
          'productInfo.stock': stock,
          'productInfo.warehouseCode': data.warehouseCode,
          productIcon: productIcon,
          curSKU: curSKU,
          'productInfo.price': price,
          pageShow: true
        })
      }
    }).catch((e) => {

    })
  },
  _getPriceRange(lines) {
    if (lines) {
      if (!lines) return '-'
      let arr = []
      for (let i = 0; i < lines.length; i++) {
        arr.push(lines[i].purchasePrice)
      }
      return arr
    }
  },
  _getPrice(products) { // 商品原价区间
    if (products) {
      if (!products) return '-'
      let arr = []
      for (let i = 0; i < products.length; i++) {
        arr.push(products[i].price)
      }
      return FILTER.getPriceRange(arr)
    }
  },
  _getGroupStatus() { // 拼团状态
    if (this.data.groupPurchaseOrder) {
      let status = this.data.groupPurchaseOrder.purchaseStatus || 0
      let text = ['', 'group_booking', 'group_success', 'group_failure']
      this.setData({
        groupStatus: 'http://7xv1io.com1.z0.glb.clouddn.com/mark_' + text[status] + '.png'
      })
    }
  },
  goHome() {
    wx.switchTab({
      url: '/pages/Home/Home',
    })
  },
  closeSku(e) {
    app.globalData.selectedData = null
    let data = this.data.productInfo
    this.setData({
      chooseSkuShow: e.detail,
      productInfo: data
    })
  },
  fnCountDown(nowDate) {
    var lastTime = Math.floor((this.data.groupPurchaseOrder.endTime - nowDate) / 1000)
    let _self = this
    if (lastTime > 0) {
      let h = 0
      let m = 0
      let s = 0
      let timer
      let tick = function () {
        lastTime -= 1
        if (lastTime <= 0) {
          clearInterval(timer)
        }
        h = Math.floor(lastTime / (60 * 60))
        m = Math.floor(lastTime % (60 * 60) / 60)
        s = Math.floor(lastTime % 60)
        _self.setData({
          h: FILTER.toFixed(h),
          m: FILTER.toFixed(m),
          s: FILTER.toFixed(s)
        })
      }
      timer = setInterval(tick, 1000)
    } else {
      _self.setData({
        h: '00',
        m: '00',
        s: '00'
      })
    }
  },
  bindgetphonenumber(e) {
    if (e.detail.errMsg === 'getPhoneNumber:ok') {
      LOADING.show({
        title: '登录中...'
      })
      WGAUTH.getPhoneNumber(e).then(res => {
        // AUTH.requestUsersecret(e.detail).then((res) => {
        LOADING.hide()
        this.setData({
          isLogin: false
        })
        this.getSvipStatus()
        this.refreshStatus()
        if (this.data.isAuthorize) {
          this.buyNow()
        }
      }).catch((e) => {
        TOAST.warning(e)
      })
    }
  },
  refreshStatus() {
    let order = this.data.groupPurchaseOrder.groupPurchaseOrderDetailRes
    let openId = wx.getStorageSync('openId')
    let cusId = wx.getStorageSync('cusId')
    let isInGroup = false
    let groupBtn = '邀请好友拼团'
    for (let i = 0; i < order.length; i++) {
      if ((openId && openId == order[i].openId) || (cusId && order[i].cusId == cusId)) {
        isInGroup = true
      }
    }
    if (this.data.groupPurchaseOrder.purchaseStatus == 1) {
      if (isInGroup) {
        groupBtn = '邀请好友拼团'
      } else {
        groupBtn = '我也要参团'
      }
    } else {
      groupBtn = '我也开个团'
    }
    this.setData({
      unLogged: false,
      groupBtn: groupBtn,
      isInGroup: isInGroup
    })
  },
  buyNow() { // 底部btn
    if (!wx.getStorageSync('cusId')) return false
    if(this.data.productInfo.vipCusStatus != 1 && this.data.productInfo.isVipOnly == 1) {
      this.toggleShowSecModal()
      return false
    }
    if (this.data.groupPurchaseOrder.purchaseStatus == 1) { // 拼团中
      if (this.data.isInGroup) { // 已参团
        // TODU  分享
      } else {
        if (this.data.productInfo.stock > 0) {
          this.setData({
            chooseSkuShow: true
          })
        } else {
          TOAST.success({
            title: '库存不足'
          })
        }
      }
    } else {
      let pId = this.data.groupPurchase.productTemplateId
      wx.navigateTo({
        url: '/pages/ProductDetail/ProductDetail?pId=' + pId,
      })
    }
  },
  _getMembers() {
    let m = this.data.groupPurchase.peopleLimit - 1
    if (m >= 11) {
      m = 11
    }
    this.setData({
      memberLimit: m
    })
  },
  getUserProfile() {
    WGAUTH.getUserProfile().then(res => {
      app.globalData.userAvatarUrl = wx.getStorageSync('avatarUrl') 
      app.globalData.nickName = wx.getStorageSync('nickName') 
      this.setData({
        isAuthorize: true
      })
      if (!this.data.isLogin) {
        this.buyNow()
      }
    })
  },
  onGotUserInfo(e) {
    if (e.detail.errMsg === 'getUserInfo:ok') {
      app.globalData.userAvatarUrl = JSON.parse(e.detail.rawData).avatarUrl
      app.globalData.nickName = JSON.parse(e.detail.rawData).nickName
      WGAUTH.getUserInfo(e).then(res => {})
      this.setData({
        isAuthorize: true
      })
      if (!this.data.isLogin) {
        this.buyNow()
      }
    }
  },
  _share() {
    this.setData({
      shareCardShow: !this.data.shareCardShow
    })
  },
  goSharePoster() {
    wx.navigateTo({
      url: router({
        name: 'SharePoster',
        search: {
          productTemplateName: this.data.productInfo.productTemplateName,
          productIcon: this.data.groupPurchase.imgUrl.replace(/^http/, 'https'),
          groupPrice: this.data.productInfo.groupPrice,
          price: this.data.productInfo.price,
          shareTitle: this.data.groupPurchase.shareTitle,
          grouppurchaseCode: this.data.grouppurchaseCode,
          origin: 'detail'
        }
      })
    })
  },
  goDetail() {
    wx.navigateTo({
      url: '/pages/ProductDetail/ProductDetail?pId=' + this.data.groupPurchase.productTemplateId,
    })
  },
  getBanner() { // 获取产品详情页公告
    let now = new Date().getTime()
    api.product.banner().then(res => {
      for(let i=0;i<res.length;i++) {
        if(res[i].isDeleted == 0 && WGFORMAT.targetDateInDateBetwen(res[i].startTime, res[i].endTime, now)) {
          this.setData({
            weikBanner: true,
            bannerUrl: res[i].imgUrl,
            bannerTarget: res[i].noticeLink
          })
        }
      }
    })
  },
  toBannerTarget() {
    let link = this.data.bannerTarget
    if(!link) return
    if(link.indexOf('shop-web/shop/productIndex.html') != -1 || link.indexOf('/Home/Home') != -1) { // 首页
      wx.switchTab({
        url: '/pages/Home/Home'
      })
    } else if(link.indexOf('.wgmf.com/wechat-html/html/shop/product/') != -1) { // H5二级页面
      let arr = link.split('?')
      let a = arr[0]
      let b = a.split('/')
      let url = b[b.length - 1]
      let query = arr.length > 1 ? arr[1] : ''
      this.linkToOtherPage(url, query)
    } else if(link.indexOf('orderList.html') != -1 || link.indexOf('OrderList/OrderList') != -1) { // 订单列表
      wx.navigateTo({
        url: '/pages/OrderList/OrderList?orderType=1'
      })
    } else if (link.indexOf('productList.html') != -1) { // 分类页
      wx.switchTab({
        url: '/pages/ProductIndex/ProductIndex'
      })
    } else if (link.indexOf('myCart.html') != -1 || link.indexOf('MyCart/MyCart') != -1) { // 购物车
      wx.switchTab({
        url: '/pages/MyCart/MyCart'
      })
    } else if(link.indexOf('superMember.html') != -1) { // 超级会员页
      wx.navigateTo({ 
        url: "/pages/superMember/superMember" 
      })
    } else if(link.indexOf('/WgFans/WgFans') != -1) {  // 谷粉社区
      wx.switchTab({
        url: '/modules/FanCommunity/pages/WgFans/WgFans'
      })
    } else {
      wx.navigateTo({
        url: link
      })
    }
  },
}
Page({
  data,
  ...methods,
  onHide() {},
  onLoad: function (options) {
    let _self = this
    let grouppurchaseCode = options.grouppurchaseCode ? options.grouppurchaseCode : options.code
    _self.setData({
      grouppurchaseCode: grouppurchaseCode,
      'productInfo.groupObj.code': grouppurchaseCode
    })
    LOADING.show()
    _self.getSvipStatus()
    _self.initData().then(res => {
      _self._getProDetail(res)
      _self._getMembers()
      LOADING.hide()
    }).catch((e) => {
      LOADING.hide()
    })
    _self.getBanner()

    try {   
      wx.onCopyUrl(() => {
        return { query: WGFORMAT.formatQueryByOptions(options) }
      })
    } catch (error) {
      console.warn('暂不支持wx.onCopyUrl')
    }

    if (wx.getUserProfile) {
      this.setData({
        canIUseGetUserProfile: true
      })
    }

  },
  onShareAppMessage: function (res) {
    if (res.from === 'button') {
      return {
        imageUrl: this.data.productIcon,
        title: this.data.groupPurchase.shareTitle,
        path: '/pages/GroupDetail/GroupDetail?grouppurchaseCode=' + this.data.grouppurchaseCode + '&_campaign=share'
      }
    }
    return {
      title: this.data.groupPurchase.shareTitle,
      path: '/pages/GroupDetail/GroupDetail?grouppurchaseCode=' + this.data.grouppurchaseCode + '&_campaign=share'
    }
  }
})