import api from '../../api/index'
import modules from '../../utils/modules'
import env1 from '../../utils/env1'
import staffShare from '../../utils/staffShare.js'
const app = getApp() // app可以调用全局的方法&全局的变量
import {
  Page,
  WGSUBSCRIBE,
  WGCOMMON,
  WGFORMAT,
  WGTRACK,
  WGIMAGE,
  WGUSER,
  WGAUTH,
} from '../../wgUtils/index'
Page({
  data: {
    env1: env1,
    modulesData: null,
    swiperIndex: 0,
    addtominiprogram: app.globalData.addtominiprogram, // 是否显示“将小程序添加至我的小程序教程卡片”
    isRefresh: false,
    isChecked: false,
    svipXufeiModal: true,
    svipValidType: 1, // 超会即将过期类型  1年卡过期-30天内，2月卡过期-3天内 
    statusHeight: 20,
    menuBtnInfo: {},
    textUserData: {
      cusId: '',
      openId: '',
      unionId: ''
    },
    homeModal: true, // 双十一返场弹窗，默认隐藏，打开条件：11.12-11.14当天首次打开首页
    showBrithday: false,//超会生日福利打开条件：生日当天首次打开首页
    classifyList: [],// 商品推荐
    isOnReachBottom: 0, //随机值，默认0
    pageScroll: 0, //滚动高度
    navInfo:'', // 首页头部信息
  },
  closeModal2() { // 隐藏双十一返场弹窗
    this.setData({
      homeModal: true
    })
  },
  closeBrithday() {
    this.setData({
      showBrithday: false
    })
  },
  toActivePage() {
    wx.navigateTo({
      url: '/pages/ActivePage/ActivePage?id=229&_campaign=CSYM1106'
    })
    this.closeModal2()
    wx.setStorageSync('homeModal', 1) // 已经显示过弹窗啦
  },
  goReserve(){
    WGSUBSCRIBE('goReserve').then((res) => {
    }).catch(() => {
    })
    // wx.navigateTo({
    //   url: '/pages/ActivePage/ActivePage?id=571&_campaign=sygl38'
    // })
  },
  checkModal2() { // 双十一返场弹窗
    // if(!wx.getStorageSync('homeModal') && WGFORMAT.targetDateInDateBetwen('2020-11-09 00:00:00', '2020-11-14 23:59:59', new Date())) { // 正式
    if(!wx.getStorageSync('homeModal') && WGFORMAT.targetDateInDateBetwen('2020-11-12 00:00:00', '2020-11-14 23:59:59', new Date())) { // 正式
      this.setData({
        homeModal: false
      })
    }
  },
  onInpuBlur(e) {
    let key = 'textUserData.' + e.currentTarget.dataset.key
    this.setData({
      [key]: e.detail.value
    })
  },
  setTestData() {
    if (this.data.textUserData.cusId) wx.setStorageSync('cusId', this.data.textUserData.cusId)
    if (this.data.textUserData.openId) wx.setStorageSync('openId', this.data.textUserData.openId)
    if (this.data.textUserData.unionId) wx.setStorageSync('unionId', this.data.textUserData.unionId)
    WGCOMMON.toast('设置成功')
  },
  isOnloads(){
    this.onShow()
  },
  clearStorage() {
    wx.showModal({
      title: '提示',
      content: '确定清除小程序的缓存吗？',
      success(res) {
        if (res.confirm) {
          wx.clearStorage()
        }
      }
    })
  },
  subscribeTest() {
    WGSUBSCRIBE('payPresale')
  },
  queryProduct(){
    if(!this.data.modulesData) {
      return
    }
    api.modules.getClassify(this.data.modulesData.id).then(res=>{
      this.setData({
        classifyList: res
      })
    })
  },
  // 调用瀑布流上拉加载更多
  onReachBottom() {
    console.log('onReachBottom')
    this.setData({
      isOnReachBottom: Math.random()
    })
  },
  initHomePage1(arr) {
    api.modules.get().then(res => {
      if (res) {
        let navInfo = res.modules.find(item => {
          return item.moduleType == 20
        })
        let newpage = modules.formatModules(res, arr)
        let navInfoStr = ''
        if(navInfo && navInfo.cells[0]){
          navInfoStr += navInfo.cells[0].imgTag || navInfo.cells[0].imgUrl ?  '': 'background-color: #FBC93E;';
          navInfoStr += navInfo.cells[0].imgTag? `background-color: ${navInfo.cells[0].imgTag};`: '';
          navInfoStr += navInfo.cells[0].imgUrl? `background-image: url(${navInfo.cells[0].imgUrl});`: '';
        } else {
          navInfoStr += 'background-color: #FBC93E;';
        }
        
        this.setData({
          modulesData: newpage,
          swiperIndex: 0,
          navInfo: navInfoStr
        })
        this.queryProduct()
      } else {
        this.setData({
          modulesData: null,
          swiperIndex: 0
        })
      }
      wx.hideLoading({})
      if (this.data.isRefresh) {
        wx.stopPullDownRefresh()
        this.setData({
          isRefresh: false
        })
      }
    })
  },
  initHomePage() {
    /** 模板首页 start */
    // api.modules.getById(79).then(r => {
    api.modules.imgBorder().then(arr => {
      this.initHomePage1(arr)
    }).catch(e => {
      this.initHomePage1()
    })
    /** 模板首页 end  */
  },
  onPullDownRefresh() {
    this.setData({
      isRefresh: true
    })
    this.initHomePage()
  },
  close() { // 关闭“将小程序添加至我的小程序教程卡片”
    this.setData({
      addtominiprogram: false
    })
    wx.setStorageSync('flag', true)
    app.globalData.addtominiprogram = false
  },
  closeModal1() {
    this.setData({
      svipXufeiModal: true
    })
  },
  noMoreTipModal() {
    let val = this.data.isChecked
    this.setData({
      isChecked: !val
    })
    if (!val) {
      wx.setStorageSync('svipXufeiTip', 1)
    } else {
      wx.removeStorageSync('svipXufeiTip')
    }
  },
  setNavSize() {
    // 获取右上角的胶囊位置信息
    try {
      if (wx.getMenuButtonBoundingClientRect) {
        let t = wx.getMenuButtonBoundingClientRect()
        this.setData({
          menuBtnInfo: t
        })
        console.log('胶囊信息', t)
      } else {
        throw new Error('getMenuButtonBoundingClientRect error')
      }
    } catch (error) {
      this.getSystemInfo()
      console.log('微信版本太低，不支持获取胶囊的位置信息')
    }
    // 获取状态栏的高度
    try {
      let t = wx.getSystemInfoSync()
      this.setData({
        statusHeight: t.statusBarHeight
      })
      console.log('状态栏的高度', this.data.statusHeight)
    } catch (error) {
      console.log('微信版本太低，无法获取状态栏的高度')
    }
  },
  getSystemInfo() {
    // 获取用户的设备型号
    let that = this
    try {
      wx.getSystemInfo({
        success(res) {
          console.log(res)
          if (res.model.indexOf('iPhone X') != -1) {
            console.log('iPhone X手机')
            that.setData({
              menuBtnInfo: {
                top: 50,
                height: 32
              }
            })
            return
          } else if (res.system.indexOf('iOS') != -1) {
            console.log(res.model + '手机', '苹果手机')
            that.setData({
              menuBtnInfo: {
                top: 26,
                height: 32
              }
            })
            return
          } else {
            console.log(res.model + '手机', '安卓手机')
            that.setData({
              menuBtnInfo: {
                top: 28,
                height: 32
              }
            })
          }
        }
      })
    } catch (error) {
      console.log('微信版本太低，无法获取设备型号')
    }
  },
  onLoad(options) {
    this.setNavSize()
    wx.showLoading({})
    // this.initHomePage()
    //拿到分享人工号,存入本地
    console.log('Home Page OnLoad Options', options)
    staffShare.setShareStaffIdByShare(options)
    app.globalData.actType = 0
    try {   
      wx.onCopyUrl(() => {
        return { query: WGFORMAT.formatQueryByOptions(options) }
      })
    } catch (error) {
      console.warn('暂不支持wx.onCopyUrl')
    }
  },
  onHide() {
  },
  initPage(){
    this.initHomePage()
    app.globalData.switchTabQueryObj = null
    if(wx.getStorageSync('cusId')) {
      api.user.isWillOverdue(wx.getStorageSync('cusId')).then(res => {
        /**
         * payCustomer: false 是否是付费会员
          willOverdue: false  年卡是否是30天内快过期
          willOverdueMonthCard: false  月卡是否是3天内快过期
         */
        if (res) {
          wx.setStorageSync('payCustomer', res.payCustomer)
        }
        if (res && res.willOverdue) { // 年卡30天内快过期
          this.setData({
            svipXufeiModal: false,
            isChecked: false,
            svipValidType: 1, // 过期类型  1年卡过期，2月卡过期 
          })
        } else if (res && res.willOverdueMonthCard) { // 月卡3天内快过期
          this.setData({
            svipXufeiModal: false,
            isChecked: false,
            svipValidType: 2, // 过期类型  1年卡过期，2月卡过期 
          })
        }
        if (wx.getStorageSync('svipXufeiTip')) {
          this.setData({
            svipXufeiModal: true, // 隐藏超会续费弹窗
            isChecked: true
          })
        }
      })
    }
    this.checkModal2()
  },
  onShow() {
    if(wx.getStorageSync('custChannel') === ''){
      WGAUTH.wxLogin().then(()=>{
        WGUSER.queryChannel().finally(()=>{  //不管是否成功，都调用
          this.initPage()
        })
      })
    }else {
      this.initPage()
    } 
  },
  onShareAppMessage: function (res) { // 自定义点击右上角转发内容
    WGTRACK.logCustomEvent('share_mall') // 转发商城首页
    return {
      title: '五谷磨房，创造精致生活的更多种选择',
      path: '/pages/Home/Home?' + staffShare.getShareParams(), //分享人工号，此时分享人为登录者本人
    }
  },
  onShareTimeline() { // 分享朋友圈
    WGTRACK.logCustomEvent('shareTimeline_mall') // 转发商城首页到朋友圈
    return {
      title: '五谷磨房，创造精致生活的更多种选择',
      path: '/pages/Home/Home?' + staffShare.getShareParams(), //分享人工号，此时分享人为登录者本人
    }
  },
  onPageScroll(e){
    this.setData({
      pageScroll: e.scrollTop
    })
  },
})