import {
  REQUEST,
  API,
  LOADING,
  TOAST
} from '../../utils/index.js'
import {
  Page
} from '../../wgUtils/index.js';

const data = {
  reqParams: {
    custId: wx.getStorageSync('cusId'),
    phoneNo: '',
    openId: '',
    pageNo: 1,
    pageSize: 20,
    LoginShow: false
  },
  willInvalidpoint: '',
  // giftNotice: '',
  allPointList: [],
  noData: false,
  showRules: false,
  rules: [{
      "label": "1.什么是积分？",
      "content": "答：积分即平台的通用货币，可用于兑换相应的礼品。"
    },
    {
      "label": "2.积分是否有有效期？",
      "content": "答：每笔产生的积分从生成之日起有效期为1年。"
    }, {
      "label": "3.如何赚取积分？",
      "content": "答：可通过购买产品获得积分，购买的金额等量获得相应的积分；也可参加微信大转盘或其他活动获得积分。"
    }, {
      "label": "4.如何兑换礼品？",
      "content": "答：选中需要兑换的礼品，到就近门店提供手机号码，即可兑换您心仪的礼品。"
    }
  ]
}
const methods = {
  initData() {
    if (!wx.getStorageSync('cusId') || !wx.getStorageSync('unionId')) {
      this.setData({
        LoginShow: true
      })
      return false
    }
    LOADING.show()
    let url = API.get_integral_detail + '?custId=' + wx.getStorageSync('cusId') + '&phoneNo=' + '&openId=' + '&pageNo=' + this.data.reqParams.pageNo + '&pageSize=' + this.data.reqParams.pageSize
    REQUEST.get(url).then((res) => {
      const {
        ret,
        datalist
      } = res.data
      if (ret == 0) {
        let allPointList = this.data.allPointList
        if (datalist[0].allPointList.length > 0) {
          for (let i = 0; i < datalist[0].allPointList.length; i++) {
            let item = {
              ptsType: datalist[0].allPointList[i].ptsType,
              ptsGetDate: datalist[0].allPointList[i].ptsGetDate,
              ptsValid: datalist[0].allPointList[i].ptsValid,
              ptsNumber: datalist[0].allPointList[i].ptsNumber,
              validStatus: datalist[0].allPointList[i].validStatus
            }
            allPointList.push(item)
          }
          this.data.reqParams.pageNo = this.data.reqParams.pageNo + 1
          this.setData({
            allPointList: allPointList,
          })
        } else {
          this.setData({
            noData: true
          }, () => {
            TOAST.warning({
              title: '没有数据了哦！',
              duration: 1500
            })
          })
        }
        this.setData({
          willInvalidpoint: datalist[0].willInvalidpoint
          // giftNotice: datalist[0].giftNotice
        })
        LOADING.hide()
      }
    })
  },
  showRules() {
    this.setData({
      showRules: !this.data.showRules
    })
  },
  login() {
    this.setData({
      LoginShow: false
    }, () => {
      this.initData()
      this.getGradeInfo()
    })
  },
  getGradeInfo() {
    let url = API.get_user_grade_info + '?openId=' + '&cusId=' + wx.getStorageSync('cusId')
    REQUEST.get(url).then((res) => {
      const {
        msgCode,
        returnBean
      } = res.data
      if (msgCode == 0) {
        this.setData({
          intergal: returnBean.returnList[0].validPoint ? returnBean.returnList[0].validPoint : 0
        })
      }
    })
  }
}
Page({
  data,
  ...methods,
  onHide() {},
  onLoad: function (options) {
    this.setData({
      intergal: options.intergal
    })
    this.initData()
    this.getGradeInfo()
  },
  onReachBottom: function () {
    if (!this.data.noData) {
      this.initData()
    } else {
      TOAST.warning({
        title: '没有数据了哦！',
        duration: 1500
      })
    }
  },
  goExtension(){
    wx.navigateTo({
      url: '/modules/Svip/pages/ExtensionCar/ExtensionCar'
    })
  },
  onShareAppMessage: function () {
    return {
      title: '五谷磨房个人中心'
    }
  }
})