import {
  REQUEST,
  API,
  LOADING,
} from '../../utils/index'
import {
  Page
} from '../../wgUtils/index';
const app = getApp()
const data = {
  logistics: Object,
  pageShow: false
}
const methods = {
  getLogistics() {
    LOADING.show()
    let url = `${API.get_logistics}?shipmentCode=${this.data.shipmentCode.trim()}&deliveryPartyCode=${this.data.deliveryPartyCode.trim()}`
    REQUEST.get(url).then((res) => {
      if (res.statusCode == 200) {
        this.setData({
          logistics: res.data,
          pageShow: true
        })
        LOADING.hide()
      }
    })
  }
}
Page({
  data,
  ...methods,
  onLoad: function (options) {
    if (app.globalData.delivery) {
      this.setData({
        shipmentCode: app.globalData.delivery.shipmentCode,
        deliveryPartyCode: app.globalData.delivery.deliveryPartyCode
      })
      this.getLogistics()
    }
    wx.hideShareMenu()
  }
})