import { Page, WGCOMMON, WGFORMAT, WGAUTH, WGUSER, WGTRACK } from "../../wgUtils/index"
import { FILTER, LOADING } from '../../utils/index'
import SVIPDETAILS from '../../assets/json/member'
import WGAPI from '../../api/index'

Page({
  data: {
    svipDetails: SVIPDETAILS,
    buyBtnType: 4,
    economicTotalFee: 0,
    isAgree: false,
    current: 0,
    num: 0,
    isLogin: false,
    hideQyModal: true,
    hideGroupModal: true,
    brithday: '', // 生日,格式yyyy-MM-dd
    canUpdateBrithday: 0,
    startDate: "",
    endDate: "",
    vipCusStatus: 0,
    cusId: "",
    windowHeight: 1334,
    cardHeight: 900,
    isRecovery:0, //购买超会是否回本， 0否1是
    isDisabled: true, 
  },
  bindanimationfinish(e){
    this.setData({
      isDisabled: false
    })
  },
  bindchange(e) {
    if(this.data.isDisabled){
      return
    }
    let index = e.detail.current
    this.setData({
      current: index
    })
    if (index > 2) {
      this.setData({
        num: 70 * (index - 2)
      })
    } else {
      this.setData({
        num: 0
      })
    }
    WGTRACK.logCustomEvent('slide_svipBenefits', { title: this.data.svipDetails[index].title, index: index + 1 })
  },
  handleContact(e) {
    var path = e.detail.path,
    query = e.detail.query,
    params = '';
    if (path) {
      for (var key in query) {
        params = key + '=' + query[key] + '&';
      }
      params = params.slice(0, params.length - 1);
      if(path.indexOf('Home/Home') != -1 || path.indexOf('ProductIndex/ProductIndex') != -1 || path.indexOf('FanCommunity/pages/WgFans/WgFans') != -1 || path.indexOf('MyCart/MyCart') != -1 || path.indexOf('PersonalCenter/PersonalCenter') != -1) {
        wx.switchTab({
          url: path + '?' + params
        })
      } else {
        wx.navigateTo({
          url: path + '?' + params
        })
      }
    }
  },
  chooseIcon(e) {
    let index = e.currentTarget.dataset.index
    if(this.data.current != index) {
      this.setData({
        current: index
      })
      WGTRACK.logCustomEvent('click_svipBenefits', { title: this.data.svipDetails[index].title, index: index + 1 })
    }
  },
  checkLogin() {
    if(wx.getStorageSync('cusId')) {
      this.setData({ isLogin: true, cusId: wx.getStorageSync('cusId') })
      return true
    } else {
      this.setData({ isLogin: false })
      return false
    }
  },
  toggleShowQrcode() { // 切换显示加粉二维码
    this.setData({
      hideQyModal: !this.data.hideQyModal
    })
  },
  toggleShowGroup() { // 切换显示加群二维码
    this.setData({
      hideGroupModal: !this.data.hideGroupModal
    })
  },
  initMyBirthDay() {
    if(this.checkLogin()) {
      WGAPI.user.myBirth(this.data.cusId).then(res => {
        this.setData({
          brithday: res.brithday, // 生日,格式yyyy-MM-dd
          canUpdateBrithday: res.canUpdateBrithday // 0:可修改生日，1不可修改生日
        })
      })
    }
  },
  bindDateChange(e) {
    WGCOMMON.showModal('生日确认', '生日(' + e.detail.value + ')确认后无法修改，请谨慎填写哦~确认无误后点击确定').then(res => {
      let val = e.detail.value
      WGAPI.user.updateMyBirth(wx.getStorageSync('cusId'), val).then(res => {
        this.setData({
          brithday: val, // 生日,格式yyyy-MM-dd
          canUpdateBrithday: 1 // 0:可修改生日，1不可修改生日
        })
        WGCOMMON.toast('生日修改成功！')
      })
    }).catch(e => {})
  },
  toggleAgreeBuyRule() { // 切换同意购买规则按钮
    let isAgree = !this.data.isAgree
    this.setData({ isAgree })
  },
  buySvip() { // 点击购买超会
    if(!this.data.isAgree) {
      WGCOMMON.toast('请先阅读并同意《五谷磨房超级会员服务协议》', 2500)
      return false
    }
    wx.navigateTo({
      url: `/pages/PayOrder/PayOrder?isSvip=1`
    })
  },
  login() {
    this.checkLogin()
  },
  getEconomicFeeBySvipStatus(cusId) {
    if(this.data.vipCusStatus == 1) {
      return WGAPI.svip.economizeNew(cusId) // 已节省金额计算
    } else {
      return WGAPI.svip.getNewEconomicFee() // 预计节省金额（非超会）
    }
  },
  initUserInfo() {
    if(this.checkLogin()) {
      WGCOMMON.showLoading()
      let buyBtnType = 4
      Promise.all([
        WGUSER.getCustomerInfo(),
        WGUSER.querySVipOnlineCusInfo(),
        this.getEconomicFeeBySvipStatus(this.data.cusId),
      ]).then(res => {
        let isJinGu = (res[0].customerGrade == '金谷会员' ? 1 : (res[0].customerGrade == '钻谷会员' ? 1 : 0))
        let vipCusStatus = res[1].vipCusStatus
        let economicTotalFee = res[2].economicTotalFee
        let isRecovery = res[2].isRecovery
        /** 1:未开通超会的金谷以下, 2:未开通超会金谷以上,3:续费；4非续费期内的有效超会 */
        if(vipCusStatus == 0) { // 非超会
          buyBtnType = isJinGu?2:1
        } else if(vipCusStatus == 1) { // 有效超会
          buyBtnType = FILTER.validTimestamp(res[1].vipInvalidTime, 90)?3:4
        } else if(vipCusStatus == 2) { // 过期超会
          buyBtnType = 3
        }
        let height = this.initSwiperHeight()
        let cardHeight = buyBtnType == 4?height-180:(height-420)
        let textHeight = cardHeight - 230
        this.setData({ buyBtnType, vipCusStatus, economicTotalFee, cardHeight, textHeight, isRecovery })
        WGCOMMON.hideLoading()
      })
    }
  },
  initSwiperHeight() {
    try {
      const res = wx.getSystemInfoSync()
      let height = res.windowHeight * (750 / res.windowWidth)
      return height-92
    } catch (e) {
    }
  },
  onLoad(options) {
    this.checkLogin()
    this.setData({
      buyBtnType: options.buyBtnType,
      economicTotalFee: options.saveTotal,
      vipCusStatus: options.vipCusStatus,
      current: options.types, 
      isDisabled: true
    })
    if(!options.buyBtnType) {
      this.initUserInfo()
    } else {
      let h = this.initSwiperHeight()
      let ch = options.buyBtnType == 4?h-180:h-420
      this.setData({
        cardHeight: ch,
        textHeight: ch-230
      })
    }
    this.initMyBirthDay()
  },
  // onShareAppMessage() {},
  // onShareTimeline() {}
})