import {
  REQUEST,
  API,
  LOADING,
  TOAST
} from '../../utils/index.js'
import qiniuUploader from '../../utils/qiniuUploader.js'
import {
  Page, WGENV
} from '../../wgUtils/index.js';
import api from '../../modules/FanCommunity/api/index.js';

const app = getApp()
let sortNum = 1
const serviceArr = ['', '非常不满意', '不满意', '一般', '满意', '非常满意']
const serviceDescription = ['分享您的购买心得，有机会获得积分/优惠好礼哦~~', '告诉我哪里做的不好，下次努力改正', '告诉我哪里做的不好，下次努力改正', '告诉我哪里做的不好，下次努力改正', '感谢您的鼓励，我们会继续努力的哦', '感谢您的鼓励，我们会继续努力的哦', '分享您的试用体验，有机会获得积分/优惠好礼哦~~', ]
const data = {
  domain: 'https://img.wgmf.com/',
  content: '',
  commentModule: [{
    ratingScore: 5,
    count: 0
  }],
  token: '',
  cusServiceScore: 0,
  cusServiceContent: '',
  deliveryScore: 0,
  deliveryContent: '',
  experienceFlag: 0, // 试用报告  0非 1是
  hideTrailToast: true,
  maxInputLen: 200,
  isCopyToFansTalk: true, // 是否同步到谷粉说
  needAuthUser: false, // 需要授权用户信息
  loginType: 2,
  fanGetPoint: false, // 是否参与过谷粉说送10积分活动
}
const methods = {
  authUserSuccess() {
    this.setData({
      needAuthUser: false
    })
  },
  authUserFail() {
    this.setData({
      isCopyToFansTalk: false
    })
  },
  toggleFansTalk() { // 同步谷粉说开关
    let tmp = this.data.isCopyToFansTalk
    this.setData({
      isCopyToFansTalk: !tmp
    })
  },
  init() {
    let commentModule = app.globalData.commentDetail
    console.log(commentModule)
    // console.log(JSON.stringify(commentModule))
    let newVal = commentModule.filter(function (item) {
      return item.giftStatus != 1
    })
    if (newVal) {
      for (let i = 0; i < newVal.length; i++) {
        newVal[i].ratingDesc = ''
        newVal[i].ratingScore = 0
        newVal[i].node1 = i
        newVal[i].evaluationImages = []
        newVal[i].serviceContent = ''
        newVal[i].tips = serviceDescription[0]
        newVal[i].count = 0
      }
      this.setData({
        commentModule: newVal
      })
    }
    console.log('newVal------', newVal)
    if (this.data.experienceFlag == 1) {
      this.initTrialReport(newVal[0].orderId)
    }
  },
  uptokenFun() {
    REQUEST.get(API.uptoken_fun).then((res) => {
      this.setData({
        token: res.data.retInfo
      })
    })
  },
  myFn(filePath) {
    let that = this
    return new Promise((resolve, reject) => {
      qiniuUploader.upload(filePath, (res) => {
        resolve(that.data.domain + res.retInfo)
      }, (error) => {
        reject(error)
        console.log('error: ' + error)

      }, {
        region: 'ECN',
        domain: that.data.domain,
        uptoken: that.data.token // 由其他程序生成七牛 uptoken
      })
    })
  },
  chooseImg(e) {
    let that = this
    let commentModule = that.data.commentModule
    let oldVal = that.data.commentModule[e.currentTarget.dataset.i].evaluationImages
    let newVal = 'commentModule[' + e.currentTarget.dataset.i + '].evaluationImages'
    // commentModule[0].evaluationImages.length <= 0
    if (commentModule[0].evaluationImages.length >= 9) {
      TOAST.success('最多上传9张图片哦~')
      return false
    }
    let count = 5
    if (this.data.experienceFlag == 1) {
      count = 9 - commentModule[0].evaluationImages.length
    }
    wx.chooseImage({
      count: count,
      success: function (res) {
        console.log(res)
        for (let i = 0; i < res.tempFilePaths.length; i++) {
          that.myFn(res.tempFilePaths[i]).then((url) => {
            let item = {
              imgUrl: url,
              sortingOrder: sortNum++
            }
            console.log(i)
            oldVal.push(item)
            // if (i == res.tempFilePaths.length - 1) {
            console.log(i)
            that.setData({
              [newVal]: oldVal
            })
            // }
          })
        }
      }
    })
  },
  uploadImg(filePath) {
    // TODU 每次上传一张，分多次同步上传
    let that = this
    let commentModule = that.data.commentModule
    let num = 1
    // return new Promise((resolve, reject) => {
    for (let i = 0; i < commentModule.length; i++) {
      for (let j = 0; j < commentModule[i].evaluationImages.length; j++) {
        console.log(commentModule[i].evaluationImages[j])
        num++;
        new Promise((resolve, reject) => {
          qiniuUploader.upload(filePath, (res) => {
            resolve(that.data.domain + res.retInfo)
          }, (error) => {
            reject(error)
            console.log('error: ' + error)
          }, {
            region: 'ECN',
            domain: that.data.domain,
            uptoken: that.data.token // 由其他程序生成七牛 uptoken
          })
        }).then()
      }
    }
    // })
  },
  uploadMain() {
    qiniuUploader.upload(commentModule[i].evaluationImages[j].imgUrl, (res) => {
      commentModule[i].evaluationImages[j].imgUrl = that.data.domain + res.retInfo
      if (num == that.data.num) {
        console.log(commentModule)
        resolve(commentModule)
      }
    }, (error) => {
      reject(error)
    }, {
      region: 'ECN',
      domain: that.data.domain,
      uptoken: that.data.token // 由其他程序生成七牛 uptoken
    })
  },
  del(e) { // 删除图片
    console.log(e)
    let commentModule = this.data.commentModule
    // if (e.currentTarget.dataset.index == 0) {
    //   commentModule[e.currentTarget.dataset.i].evaluationImages = []
    // } else {
    commentModule[e.currentTarget.dataset.i].evaluationImages.splice(e.currentTarget.dataset.index, 1)
    // }
    let changeVal = 'commentModule[' + e.currentTarget.dataset.i + '].evaluationImages'
    this.setData({
      [changeVal]: commentModule[e.currentTarget.dataset.i].evaluationImages
    })
  },
  chooseStar(e) { // 选择星级
    let commentModule = this.data.commentModule
    let changeVal = 'commentModule[' + e.currentTarget.dataset.i + '].ratingScore'
    let serviceVal = 'commentModule[' + e.currentTarget.dataset.i + '].serviceContent'
    let tipsVal = 'commentModule[' + e.currentTarget.dataset.i + '].tips'
    this.setData({
      [changeVal]: e.currentTarget.dataset.index,
      [serviceVal]: serviceArr[e.currentTarget.dataset.index],
      [tipsVal]: serviceDescription[e.currentTarget.dataset.index]
    })
  },
  chooseDeliveryScore(e) { // 选择快递星级
    this.setData({
      deliveryScore: e.currentTarget.dataset.index,
      deliveryContent: serviceArr[e.currentTarget.dataset.index]
    })
  },
  chooseCusServiceScore(e) { // 选择客服星级
    this.setData({
      cusServiceScore: e.currentTarget.dataset.index,
      cusServiceContent: serviceArr[e.currentTarget.dataset.index]
    })
  },
  onTextAreaBlur(e) { // 评论
    console.log(e)
    let commentModule = this.data.commentModule
    let changeVal = 'commentModule[' + Number(e.target.id) + '].ratingDesc'
    let l = 'commentModule[' + Number(e.target.id) + '].count'
    this.setData({
      [changeVal]: e.detail.value,
      [l]: e.detail.cursor
    })
  },
  submit() { // 提交评价
    let _self = this
    let commentModule = _self.data.commentModule
    let test = []
    let flag = false
    for (let i = 0; i < commentModule.length; i++) {
      if (!commentModule[i].ratingScore) {
        TOAST.success({
          title: `请选择${commentModule[i].productTemplateName}的星级`
        })
        flag = true
        break;
      }
      if (!commentModule[i].ratingDesc) {
        TOAST.success({
          title: `请输入${commentModule[i].productTemplateName}的评价信息`
        })
        flag = true
        break;
      }
    }
    if (flag) return
    if (!this.data.cusServiceScore) {
      TOAST.warning({
        title: '请选择客服评星'
      })
      return
    }
    if (!this.data.deliveryScore) {
      TOAST.warning({
        title: '请选择快递评星'
      })
      return
    }
    if (this.data.experienceFlag == 1 && commentModule[0].evaluationImages.length <= 0) { // 试用报告必须提交图片，并且至少1张图片
      TOAST.warning({
        title: '请上传图片'
      })
      return
    }
    let uploadFlag = false
    let fansTalkArr = []
    for (let i = 0; i < commentModule.length; i++) {
      if (this.data.isCopyToFansTalk && commentModule[i].evaluationImages.length == 0) {
        TOAST.warning({
          title: '已开启同步谷粉说，请添加图片'
        })
        return
      }
      let item = {
        ratingDesc: commentModule[i].ratingDesc,
        ratingScore: commentModule[i].ratingScore,
        productId: commentModule[i].productId,
        productTemplateId: commentModule[i].productTemplateId,
        orderDetailId: commentModule[i].id,
        orderId: commentModule[i].orderId,
        customerId: commentModule[i].customerId,
        cusId: wx.getStorageSync('cusId'),
        evaluationImages: commentModule[i].evaluationImages,
        cusServiceScore: this.data.cusServiceScore,
        deliveryScore: this.data.deliveryScore,
        experienceFlag: this.data.experienceFlag,
        isDelete: 0,
        virtualBrowseNumber: 0, //  (integer, optional): 虚拟粉丝说浏览个数 ,
        virtualShareCount: 0, //  (integer, optional): 虚拟分享数 ,
        virtualThumbUpNumber: 0,
        shareCount: 0,
        getThroughFlag: 0,
        stickFlag: 0,
        evaluatorHeadImgUrl: wx.getStorageSync('avatarUrl'),
        evaluatorName: wx.getStorageSync('nickName'),
      }
      if (commentModule[i].commentId) {
        item['id'] = commentModule[i].commentId
      }
      let imgs = commentModule[i].evaluationImages
      for (let j = 0; j < imgs.length; j++) {
        imgs[j].sortingOrder = j + 1
      }
      commentModule[i].evaluationImages = imgs
      test.push(item)
      if (this.data.isCopyToFansTalk && commentModule[i].product.isRedeem == 0 && this.data.orderType != 3) {
        fansTalkArr.push({
          cusId: wx.getStorageSync('cusId'),
          customerId: wx.getStorageSync('openId'),
          evaluatorHeadImgUrl: wx.getStorageSync('avatarUrl'),
          evaluatorName: wx.getStorageSync('nickName'),
          vipCusStatus: wx.getStorageSync('vipCusStatus'),
          cusServiceScore: this.data.cusServiceScore,
          deliveryScore: this.data.deliveryScore,
          evaluationImages: commentModule[i].evaluationImages,
          evaluationTag: WGENV.env == 'TEST'?41:9, // 谷粉说笔记分类 - 用户晒单
          evaluationTags: WGENV.env == 'TEST'?[ {evaluationTagId: 41} ]:[ {evaluationTagId: 9} ],
          experienceFlag: 2, // 谷粉说评价 1订单评价，2谷粉说
          productTemplates: commentModule[i].productTemplateId.toString(), //  谷粉说产品（产品id以英文逗号分隔） ,
          ratingDesc: commentModule[i].ratingDesc, // 评价说明 
          ratingScore: 5, // 评价分数
          productId: commentModule[i].productId,
          productTemplateId: commentModule[i].productTemplateId,
          orderId: commentModule[0].orderId,
          orderDetailId: commentModule[0].id,
          isDelete: 0,
          virtualBrowseNumber: 0, //  (integer, optional): 虚拟粉丝说浏览个数 ,
          virtualShareCount: 0, //  (integer, optional): 虚拟分享数 ,
          virtualThumbUpNumber: 0,
          shareCount: 0,
          getThroughFlag: 0,
          stickFlag: 0,
        })
      }
    }
    LOADING.show({
      title: '数据提交中'
    })
    if (fansTalkArr.length > 0 && this.data.isCopyToFansTalk) {
      this.publishFansTalk(fansTalkArr)
    }
    REQUEST.post(API.comment, {
      data: test,
      header: {
        'content-type': 'application/json'
      }
    }).then((res) => {
      if (res.data.status == 0) {
        LOADING.hide()
        if (this.data.experienceFlag == 1) {
          _self.setData({
            hideTrailToast: false
          })
          setTimeout(function () {
            _self.setData({
              hideTrailToast: true
            })
            if (_self.data.billId != '') {
              wx.navigateTo({
                url: '/pages/OrderDetail/OrderDetail?billId=' + _self.data.billId
              })
            } else {
              wx.navigateBack()
            }
          }, 2000)
        } else {
          if (!this.data.fanGetPoint && this.data.isCopyToFansTalk && fansTalkArr.length > 0) {
            TOAST.success({
              title: '积分+10',
              duration: 2500
            })
            setTimeout(() => {
              TOAST.success({
                title: '评价成功,感谢您的评价！',
                duration: 2000
              }).then(res => {
                if (_self.data.billId != '') {
                  wx.navigateTo({
                    url: '/pages/OrderDetail/OrderDetail?billId=' + _self.data.billId
                  })
                } else {
                  wx.navigateBack()
                }
              })
            }, 2500);
          } else {
            TOAST.success({
              title: '评价成功,感谢您的评价！',
              duration: 2000
            }).then(res => {
              if (_self.data.billId != '') {
                wx.navigateTo({
                  url: '/pages/OrderDetail/OrderDetail?billId=' + _self.data.billId
                })
              } else {
                wx.navigateBack()
              }
            })
          }
        }
      } else {
        TOAST.warning({
          title: '操作失败'
        })
      }
    }).catch((e) => {
      LOADING.hide()
    })
  },
  publishFansTalk(fansTalkArr) { // 发表谷粉说
    api.postComment(fansTalkArr).then(res => {})
  },
  initTrialReport(orderId) {
    let newVal = this.data.commentModule
    LOADING.show()
    REQUEST.get(API.get_commentDetail + orderId).then(r => {
      // console.log(res)
      if (r.data.status === 0) {
        let res = r.data.data
        console.log('productCommentByOrderId-----', res)
        if (newVal) {
          for (let i = 0; i < newVal.length; i++) {
            newVal[i].ratingDesc = res[i].ratingDesc
            newVal[i].ratingScore = res[i].ratingScore
            newVal[i].node1 = i
            newVal[i].evaluationImages = res[i].evaluationImages
            newVal[i].serviceContent = ''
            newVal[i].tips = serviceDescription[6]
            newVal[i].count = 0
            newVal[i].commentId = res[i].id
            let evaluationImages = res[i].evaluationImages
            evaluationImages.sort(function (a, b) {
              if (a.sortingOrder - b.sortingOrder == 0) {
                return a.id - b.id
              }
              return a.sortingOrder - b.sortingOrder
            })
            newVal[i].evaluationImages = evaluationImages

            for (let j = 0; j < evaluationImages.length; j++) {
              delete newVal[i].evaluationImages[j].id
              delete newVal[i].evaluationImages[j].orderProductEvaluationId
            }
          }
          this.setData({
            commentModule: newVal,
            deliveryScore: res[0].deliveryScore,
            cusServiceScore: res[0].cusServiceScore
          })
        }
      }
      LOADING.hide()
    })
  }
}
Page({
  data,
  ...methods,
  onLoad: function (options) {
    if (options.isTrialComment == 1 || options.isTrialComment == '1') {
      this.setData({
        experienceFlag: 1,
        maxInputLen: 800,
        cusServiceScore: 5,
        deliveryScore: 5
      })
    }
    this.setData({
      billId: options.billId ? options.billId : '',
      orderType: options.orderType
    })
    this.init()
    this.uptokenFun()
    wx.hideShareMenu()
  },
  onShow: function () {
    if (wx.getStorageSync('nickName')) {
      this.setData({
        needAuthUser: false
      })
    } else {
      this.setData({
        needAuthUser: true
      })
    }
    api.queryUserActStatus().then(res => {
      this.setData({
        fanGetPoint: res
      })
    })
  },
  onHide() {},
  onShareAppMessage: function () {
    return{
      title:"订单评论"
    }
  }
})