import {
  REQUEST,
  API,
  LOADING,
  TOAST,
  SRTRACK,
  FILTER,
  PAY,
  orderOperator
} from '../../utils/index'
import api from '../../api/index'
import {
  Page,
  WGCOMMON,
  WGFORMAT,
  WGENV,
} from '../../wgUtils/index';

const app = getApp()
const methods = {
  bindload(){
    this.setData({
      officialImg: true
    })
  },
  binderror(){
    this.setData({
      officialImg: false
    })
  },
  goLotteryMiniProgram() { // 打开五谷免费抽奖小程序
    wx.navigateToMiniProgram({
      appId: 'wx7aeaa095f033dca0',
      path: 'pages/LotteryList/LotteryList',
      extraData: {
        foo: 'bar'
      },
      envVersion: 'release',
      success(res) {
        // 打开成功
      }
    })
  },
  closeLotteryModal() {
    this.setData({
      showLottModal: false
    })
  },
  handleContact(e) {
    var path = e.detail.path,
    query = e.detail.query,
    params = '';
    if (path) {
      for (var key in query) {
        params = key + '=' + query[key] + '&';
      }
      params = params.slice(0, params.length - 1);
      console.log('path, params------', path, params)
      if(path.indexOf('Home/Home') != -1 || path.indexOf('ProductIndex/ProductIndex') != -1 || path.indexOf('FanCommunity/pages/Index/Index') != -1 || path.indexOf('MyCart/MyCart') != -1 || path.indexOf('PersonalCenter/PersonalCenter') != -1) {
        wx.switchTab({
          url: path + '?' + params
        })
      } else {
        wx.navigateTo({
          url: path + '?' + params
        })
      }
    }
  },
  fnCountDown(submitDate, type) {
    let _self = this
    if (submitDate) {
      let counter = 1000 * 60 * 60 * 2 - (Date.now() - submitDate) // 倒计时2小时     
      if (type === 5) { // 秒杀单倒计时为10分钟
        counter = 1000 * 60 * 10 - (Date.now() - submitDate)
      }
      if (counter < 0) {
        return;
      }
      counter = counter / 1000
      let hour, minute, sec
      const ticker = setInterval(function () {
        counter = counter - 1
        if (counter < 0) {
          clearInterval(ticker)
          _self.setData({
            saveTime: ''
          })
        } else {
          hour = Math.floor(counter / (60 * 60))
          minute = Math.floor(counter % (60 * 60) / 60)
          sec = Math.floor(counter % 60)
          _self.setData({
            saveTime: (hour < 10 ? "0" + hour : hour) + ":" + (minute < 10 ? "0" + minute : minute) + ":" + (sec < 10 ? "0" + sec : sec)
          })
        }
      }, 1000)
    }
  },
  getData(billId) {
    LOADING.show()
    let _self = this
    return new Promise((resolve, reject) => {
      let url = API.get_orderDetail + this.data.id
      // let url = API.get_orderDetail + '3006184'
      REQUEST.get(url).then((res) => {
        const {
          status,
          data
        } = res.data
        if (status == 0) {
          if (data == '') return false
          let submitDate = data.submitDate
          this.checkDraw(data)
          data.submitDateLabel = FILTER.dateFormat(data.submitDate, 'yyyy-MM-dd hh:mm:ss')
          data.address = JSON.parse(data.addressSnapshot)
          if (data.orderType == 6) { // 预售
            if (data.orderStatus.id == 15) {
              this.checkBalancePayment(data)
            }
            if (data.orderDownPayment.presellMoney && data.orderDownPayment.presellMoney > 0) {
              data.orderDownPayment.presellMoney = FILTER.currency(data.orderDownPayment.presellMoney)
              data.orderDownPayment.balancePaymentStartTimeLabel = FILTER.dateFormat(data.orderDownPayment.balancePaymentStartTime, 'yyyy.MM.dd ')
              data.orderDownPayment.balancePaymentEndTimeLabel = FILTER.dateFormat(data.orderDownPayment.balancePaymentEndTime, 'yyyy.MM.dd')
            }
            data.banlancePay = '¥' + FILTER.currency(data.totalFee - data.orderDownPayment.presellMoney)
          }
          for (let i = 0; i < data.orderDetails.length; i++) {
            if (data.orderDetails[i].product.imgUrl) {
              data.orderDetails[i].icon = data.orderDetails[i].product.imgUrl
            } else {
              if (data.orderDetails[i].productTemplate.groupedImages.icon && data.orderDetails[i].productTemplate.groupedImages.icon[0].imageUrl) {
                data.orderDetails[i].icon = data.orderDetails[i].productTemplate.groupedImages.icon[0].imageUrl
              }
            }
          }
          if (data.orderType == 5 && data.orderStatusId == 1) { // 5秒杀单待付款
            _self.fnCountDown(data.submitDate, 5)
          } else {
            _self.fnCountDown(data.submitDate, data.orderType)
          }
          if (data.orderType == 9 && data.payStatus == 1) { // 分期发货单已付款
            this.setData({
              installmentId: data.id
            })
            this.initInstallment(data.id)
          }
          if (data.orderType == 16 && data.orderStatusId == 16) {
            data.orderStatus.statusName = '团购中'
          }
          if(data.orderDelivery && data.orderStatusId == 3) { // 全部发货
            let dates = []
            data.orderDelivery.forEach(function(item) {
              dates.push(item.createTime)
            })
            let maxtime = Math.max.apply(this, dates)
            let text = WGFORMAT.formatDate2EndText(maxtime + 15*24*60*60*1000)
            // console.error(new Date(maxtime + 15*24*60*60*1000).toDateString())
            this.setData({ autoDelivery: text })
          }
          resolve(res.data.data)
        }
        LOADING.hide()
      }).catch((e) => {
        LOADING.hide()
      })
    })
  },
  checkBalancePayment(params) {
    this.getServerTime().then((curTime) => {
      let startTime = params.orderDownPayment.balancePaymentStartTime
      let endTime = params.orderDownPayment.balancePaymentEndTime
      if ((curTime >= startTime) && (curTime <= endTime)) {
        this.setData({
          isPayFinal: true
        })
      }
    })
  },
  goOrderDetail() {
    wx.navigateTo({
      url: '/pages/OrderDetail/OrderDetail?billId=' + this.data.itemModule.id,
    })
  },
  goIndex() {
    wx.switchTab({
      url: '/pages/Home/Home',
    })
  },
  goGoldAccount() {
    wx.navigateTo({
      url: '/pages/GoldAccount/GoldAccount'
    })
  },
  closeMask() {
    this.setData({
      gwjStatus: false
    })
  },
  checkComment(order) {
    var flag1 = order.evaluationStatus != 1
    var flag2 = order.orderStatus.id == 6
    var flag3 = false
    var list = order.orderDelivery
    var dates = []
    if (list && list.length > 0) {
      for (var i = 0; i < list.length; i++) {
        dates.push(list[i].shippingDate)
      }
      var minDate = Math.min.apply(null, dates)
      flag3 = (Date.now() - minDate - 60 * 24 * 60 * 60 * 1000) <= 0
    }
    return flag1 && flag2 && flag3
  },
  delOrder(e) { // 删除订单
    let _self = this
    orderOperator.delOrder(this.data.itemModule.id).then(() => {
      wx.navigateBack()
    })
  },
  cancelOrder(e) { // 取消订单
    let _self = this
    orderOperator.cancelOrder(this.data.itemModule.id).then(() => {
      _self.getData().then((data) => {
        SRTRACK.customOrder(data, "cancel_give_order")
        _self.setData({
          itemModule: data,
          total: FILTER.totalPrice(data.orderDetails), // 商品金额
          transportFee: FILTER.currency(data.transportFee), // 运费
          discount: FILTER.currency(data.discount > 0 ? -data.discount : 0), // 优惠
          virtualMoney: data.virtualMoney > 0 ? '-' + FILTER.currency(data.virtualMoney) : 0, // 购物金
          totalRedeemPrice: FILTER.currency('-' + data.totalRedeemPrice), // 兑换积分
          totalFee: FILTER.currency(data.totalFee), // 应付金额
          isDel: [6, 7, 8].indexOf(data.orderStatusId) > -1, // 是否可删除订单
          isComment: _self.checkComment(data), // 是否可评价
          gwjStatus: (data.gwtOrderDetail.length != 0 ? data.gwtOrderDetail[0].sendStatus : "") && this.data.isPayed,
          gwtSendNum: data.gwtOrderDetail.length != 0 ? data.gwtOrderDetail[0].gwtSend : ''
        })
      })
    })
  },
  confirmOrder() { // 确认收货
    orderOperator.confirmOrder(this.data.itemModule.id).then(() => {
      app.globalData.commentDetail = orderOperator.returnFormFilter(this.data.itemModule.orderDetails)
      if (this.data.isTrial) {
        wx.navigateBack()
      } else {
        if (this.data.itemModule.orderType == 19) {
          WGCOMMON.toast('确认收货后前往试用中心填写试用报告哦~', 3000)
          setTimeout(function () {
            wx.navigateTo({ // 跳转到我的试用
              url: '/modules/ProductTrial/pages/TrialCenter/TrialCenter?tabIndex=1'
            })
          }, 3000)
        } else {
          wx.navigateTo({
            url: '/pages/OrderComment/OrderComment?billId=' + this.data.id + '&orderType=' + this.data.itemModule.orderType
          })
        }
      }
    }).catch((e) => {})
  },
  getServerTime() {
    return new Promise((resolve, reejct) => {
      REQUEST.get(API.get_serverTime).then((res) => {
        const {
          status,
          data
        } = res.data
        if (status == 0 && data) {
          resolve(data)
        } else {
          reject()
        }
      }).catch(() => {
        reject()
      })
    })
  },
  pay() { // 支付
    let _self = this
    // if (this.data.itemModule.source != 2) {
    //   TOAST.warning({
    //     title: '订单不能跨平台支付，请去您下单的地方支付！'
    //   })
    // } else {
    if (this.data.itemModule.orderType != 11) {
      let params = {
        orderCode: this.data.itemModule.orderCode,
        id: this.data.itemModule.id,
        orderType: this.data.itemModule.orderType,
        orderStatus: this.data.itemModule.orderStatus
      }
      if (this.data.itemModule.orderDownPayment) {
        params.orderDownPayment = this.data.itemModule.orderDownPayment
      }
      PAY({
        params,
        paySuccessFn: _self.paySuccessFn.bind(this),
        payErrorFn: _self.payErrorFn.bind(this),
        customOrderParams: this.data.itemModule,
        isSvip: 0
      })
    }
    // }
  },
  paySuccessFn() {},
  payErrorFn() {
    TOAST.warning('支付失败').then(() => {
      wx.navigateTo({
        url: '/pages/OrderDetail/OrderDetail?billId=' + this.data.id,
      })
    })
  },
  goGroupDetail(e) { //查看拼团详情 
    wx.navigateTo({
      url: '/pages/GroupDetail/GroupDetail?grouppurchaseCode=' + e.currentTarget.dataset.code,
    })
  },
  goGroupBDetail(e) { //查看团购详情 
    wx.navigateTo({
      url: '/pages/GroupBDetail/GroupBDetail?grouppurchaseCode=' + this.data.itemModule.grouppurchaseCode
    })
  },
  goEquityCard(){
    wx.navigateTo({
      url: '/pages/EquityCard/EquityCard'
    })
  },
  goSaveCard() {
    wx.navigateTo({
      url: '/modules/MallPromotion/pages/SaveMoneyCard/SaveMoneyCard'
    })
  },
  goComment(e) { // 去评价
    let item = e.currentTarget.dataset.item
    let url = '/pages/OrderComment/OrderComment?orderType=' + this.data.itemModule.orderType
    if (e.currentTarget.dataset.istrial == '1') { // 试用报告
      WGCOMMON.toast('前往试用中心填写或查看试用报告哦~', 3000)
      setTimeout(function () {
        wx.navigateTo({ // 跳转到我的试用
          url: '/modules/ProductTrial/pages/TrialCenter/TrialCenter?tabIndex=1'
        })
      }, 3000)
    } else { // 正常订单评价
      for (let i = 0; i < item.length; i++) {
        if (item[i].product.imgUrl) {
          item[i].icon = item[i].product.imgUrl
        } else {
          if (item[i].productTemplate.groupedImages.icon && item[i].productTemplate.groupedImages.icon[0].imageUrl) {
            item.icon = item[i].productTemplate.groupedImages.icon[0].imageUrl
          }
        }
      }
      app.globalData.commentDetail = item
      if (app.globalData.commentDetail) {
        wx.navigateTo({
          url: url
        })
      }
    }
  },
  goLogistics(e) { // 查看物流
    this.setData({
      logisiticsShow: false
    })
    app.globalData.delivery = e.currentTarget.dataset.item || e.detail
    wx.navigateTo({
      url: '/pages/Logistics/Logistics'
    })
  },
  goLogisticsList(e) {
    if (!e.detail) {
      this.setData({
        logisiticsShow: false
      })
    } else {
      if (e.currentTarget.dataset.item.length > 1) {
        this.setData({
          logisiticsShow: true
        })
      } else {
        app.globalData.delivery = e.currentTarget.dataset.item[0]
        wx.navigateTo({
          url: '/pages/Logistics/Logistics'
        })
      }
    }
  },
  invitePeople() {
    wx.navigateTo({
      url: '/pages/GroupDetail/GroupDetail?grouppurchaseCode=' + this.data.itemModule.grouppurchaseCode
    })
  },
  drawTipsShow() {
    this.setData({
      drawTipsShow: !this.data.drawTipsShow
    })
  },
  checkDraw(info) {
    // 判断是否可以参与抽奖
    if (info.payStatus == 1) {
      let startDate = new Date(2019, 8, 15, 0, 0, 0).getTime()
      let endDate = new Date(2019, 8, 31, 23, 59, 59).getTime()
      let startDate1 = new Date(2019, 8, 15, 0, 0, 0).getTime()
      let endDate1 = new Date(2019, 8, 21, 23, 59, 59).getTime()
      let startDate2 = new Date(2021, 3, 2, 0, 0, 0).getTime()
      let endDate2 = new Date(2022, 3, 13, 23, 59, 59).getTime()
      // if(info.orderType == 9) {
      //   this.setData({
      //     canDraw: true
      //   })
      // }
      this.getServerTime().then((curTime) => {
        if (!curTime) {
          curTime = new Date().getTime()
        }
        if ((curTime >= startDate) && (curTime <= endDate)) {
          if (info.orderType == 9 && (info.submitDate >= startDate1) && (info.submitDate <= endDate1)) {
            this.setData({
              canDraw: true
            })
          }
        }
        if(this.data.totalFee>=300 && (curTime >= startDate2) && (curTime <= endDate2)) {
          this.setData({
            canShow: true
          })
        }
      })
    }
  },
  copyOrderCode(e) {
    wx.setClipboardData({
      data: e.currentTarget.dataset.copy,
      success(res) {
        wx.getClipboardData({
          success(res) {
            console.log('复制成功！')
          }
        })
      }
    })
  },
  initInstallment(id) { // 分期发货 @author-wucl
    api.installment.list(id).then(res => {
      // let nowdate = new Date().getTime()
      let now = new Date()
      let nowdate = new Date(now.getFullYear(), now.getMonth(), now.getDate()).getTime()
      let date = null
      for (let i = 0, len = res.length; i < len; i++) {
        let tmp = new Date(res[i].preShippingDate).getTime()
        // 计算预计下次发货时间
        if (tmp >= nowdate && (date == null || tmp <= date) && (res[i].installmentStatus == 1 || res[i].installmentStatus == 2)) {
          date = tmp;
        }
        let arr = res[i].preShippingDate.substr(5, 10).split('-')
        res[i]["date"] = `${arr[0]}月${arr[1]}日`
      }
      const installment = {
        interval: res[0].deliveryInterval, // 发货时间间隔
        nextShippingDate: `${new Date(date).getMonth()+1}月${new Date(date).getDate()}日`, // 下次发货时间
        list: res
      }
      this.setData({
        installment: installment
      })
    }).catch(e => {
      console.error(e);
    })
  },
  showQrcode() { // 显示加粉二维码
    this.setData({
      hideQyModal: false
    })
  },
  closeQyModal() {
    this.setData({
      hideQyModal: true
    })
  },
  //点击保存图片按钮
  downloadImage(e) {
    LOADING.show()
    this.saveImage(e)
  },
  goHowBeGold(){
    let url='/pages/HowBeGold/HowBeGold?type=3&imgName=jj_1645783926695&imgType=png&_campaign=jszficon'
    console.log(url)
    wx.navigateTo({
      url: url
    })
  },
  // 长按保存图片
  saveImage(e) {
    let url = e.currentTarget.dataset.url;
    LOADING.hide()
    //用户需要授权
    wx.getSetting({
      success: (res) => {
        if (!res.authSetting['scope.writePhotosAlbum']) {
          wx.authorize({
            scope: 'scope.writePhotosAlbum',
            success: () => {
              // 同意授权
              this.saveImg1(url);
            },
            fail: (res) => {
              console.log(res);
            }
          })
        } else {
          // 已经授权了
          this.saveImg1(url);
        }
      },
      fail: (res) => {
        console.log(res);
      }
    })
  },
  goDraw (){
    var newUrl = encodeURIComponent(this.data.getPayGift.storedValueCardUrl);
    let url='/pages/WebView/WebView?url=' +newUrl
    console.log(url)
    wx.navigateTo({
      url: url
    })
  },
  saveImg1(url) {
    LOADING.show()
    wx.getImageInfo({
      src: url,
      success: (res) => {
        let path = res.path;
        wx.saveImageToPhotosAlbum({
          filePath: path,
          success: (res) => {
            console.log(res);
          },
          fail: (res) => {
            console.log(res);
          }
        })
        LOADING.hide()
        TOAST.success({
          title: '保存成功！',
          duration: 1500
        })
      },
      fail: (res) => {
        console.log(res);
        LOADING.hide()
        TOAST.warning({
          title: '保存失败，请重试！',
          duration: 1500
        })
      }
    })
  },
}
Page({
  data: {
    officialImg: false,
    itemModule: {},
    logisiticsShow: false,
    id: '',
    isPayFinal: false,
    drawTipsShow: false,
    canDraw: false,
    canShow: false,
    showLottModal: false,
    hideQyModal: true,
    isTrial: false,
    modal2code: [
      'https://img.wgmf.com/pop_list_pay_code.png',
      'https://img.wgmf.com/pop_list_pid_code.png',
      'https://img.wgmf.com/pop_list_svip_code.png',
    ],
    clientType: 0,
    autoDelivery: '',
    getPayGift:{},//支付有礼
    isLimtFri: false, // 燕窝的分期发货订单限制周五 [ 1993    1966     1964   1937  1920 ] 测试环境18 
    isEquitycard: false, //是否是权益卡 正式1891， 测试1364
  },
  ...methods,
  onLoad: function (options) {
    this.setData({
      cusId: wx.getStorageSync('cusId'),
      id: options.billId,
      isTrial: options.isTrial ? true : false,
      isPayed: options.isPay || 0
    }, () => {
      this.getData().then((data) => {
        if (data.orderType == 16) {
          let payFlag = data.payStatus == 1
          let groupBFlag = data.orderStatusId == 16
          data.isGroupB = (payFlag && groupBFlag)
          data.isGroupB2 = (payFlag && !groupBFlag)
        }
        console.log(WGENV)
      //  权益卡
        if((WGENV.env == "TEST" && data.orderDetails[0].productTemplateId == 1364) || (WGENV.env == "PROD" && data.orderDetails[0].productTemplateId == 1891)){
          this.setData({
            isEquitycard: true
          })
        }else {
          this.setData({
            isEquitycard: false
          })
        }
        this.setData({
          itemModule: data,
          total: FILTER.totalPrice(data.orderDetails), // 商品金额
          transportFee: FILTER.currency(data.transportFee), // 运费
          discount: FILTER.currency(data.discount > 0 ? -data.discount : 0), // 优惠
          virtualMoney: data.virtualMoney > 0 ? '-' + FILTER.currency(data.virtualMoney) : 0, // 购物金
          totalRedeemPrice: FILTER.currency('-' + data.totalRedeemPrice), // 兑换积分
          totalFee: FILTER.currency(data.totalFee), // 应付金额
          isDel: [6, 7, 8].indexOf(data.orderStatusId) > -1, // 是否可删除订单
          isComment: this.checkComment(data), // 是否可评价
          gwjStatus: (data.gwtOrderDetail.length != 0 ? data.gwtOrderDetail[0].sendStatus : "") && this.data.isPayed,
          gwtSendNum: data.gwtOrderDetail.length != 0 ? data.gwtOrderDetail[0].gwtSend : ''
        })
        if (data.payStatus == 1 && this.data.isPayed) { // 加粉二维码弹窗显示
          this.showQrcode()
        }
        if (data.payStatus == 1) { // 已付款，下单广告行为转化
          /** 支付成功 */
          let gdt = wx.getStorageSync('gdt')
          if (gdt) {
            /** 测试通过后 gtd.pid == 20需要删除 */
            let pids = []
            for (let i = 0; i < data.orderDetails.length; i++) {
              pids.push(data.orderDetails[i].productTemplateId.toString())
            }
            if (pids.indexOf(gdt.pid) != -1) {
              api.clickId.upload({
                actionType: 'COMPLETE_ORDER',
                clickId: gdt.gdt_vid,
                actionUrl: gdt.gdt_url
              })
              wx.removeStorageSync('gdt')
            }
          }
          if(this.data.installmentId) { // 分期发货订单
            let targetPids = [1993,1966,1964,1937,1920,18]
            for (let i = 0; i < data.orderDetails.length; i++) {
              console.error('分期发货', targetPids, data.orderDetails[i].productTemplateId,targetPids.indexOf(data.orderDetails[i].productTemplateId) != -1 )
              if(targetPids.indexOf(data.orderDetails[i].productTemplateId) != -1) {
                this.setData({ isLimtFri: true })
                break
              }
            }
          }
        }
      });
      api.order.getPayGift(wx.getStorageSync('cusId'),this.data.id).then(res => {
        console.log(res)
        this.setData({
          getPayGift :res
        })
      })
    })
    app.globalData.adIndex = null
    app.globalData.tickets = {
      ticket1: null,
      ticket2: null,
      ticket3: null
    }
    app.globalData.actType = 0
  },
  onShow: function () {
    if (this.data.installmentId) {
      this.initInstallment(this.data.installmentId)
    }
  },
  onHide: function () {
    clearInterval(this.data.tick)
  },
  onShareAppMessage: function () {
    return {
      title: '我正在抢购' + this.data.itemModule.orderDetails[0].productTemplateName + '，快来和我一起参与拼团吧！',
      path: '/pages/GroupDetail/GroupDetail?grouppurchaseCode=' + this.data.itemModule.grouppurchaseCode
    }
  }
})