import {
  REQUEST,
  SRTRACK,
  API,
  LOADING,
  TOAST,
  UTIL
} from '../../utils/index'
import {
  Page
} from '../../wgUtils/index';

const app = getApp()
const data = {
  orderModule: [],
  curPage: 1,
  pageSize: 10,
  groupStatus: 1, // 1.全部订单 2.待付款 3.待收货 4.待评价 5.售后
  listShow: true,
  itemModule: Object,
  pageShow: false,
  allShow: true,
  noData: 0,
  LoginShow: false,
  emptyShow: false,
  shareInfo: { // 邀请拼团信息
    title: '',
    grouppurchaseCode: ''
  },
  logisiticsShow: false
}
const methods = {
  goPage(event) {
    let type = event.currentTarget.dataset.type
    this.data.noData = 0
    this.data.curPage = 1
    this.setData({
      groupStatus: type,
      orderModule: []
    }, () => {
      console.log('goPage getOrderList')
      this.getOrderList()
    })
  },
  updateData() { // 删除部分后更新数据
    this.data.noData = 0
    this.data.curPage = 1
    this.setData({
      orderModule: []
    }, () => {
      console.log('updateData getOrderList')
      this.getOrderList()
    })
  },
  getOrderList() {
    if (!wx.getStorageSync('cusId') || !wx.getStorageSync('unionId')) {
      this.setData({
        LoginShow: true,
        allShow: true
      })
      return false
    }
    if (this.data.noData) {
      TOAST.success({
        title: '没有数据了哦'
      })
      return false
    }
    this.setData({
      pageShow: false,
      LoginShow: false,
      emptyShow: false
    })
    LOADING.show()
    let _self = this
    let params = {
      cusId: UTIL.getInfo('cusId'),
      openId: '',
      curPage: _self.data.curPage,
      pageSize: _self.data.pageSize,
      groupStatus: _self.data.groupStatus
    }
    REQUEST.get(API.get_orderList, {
      data: params
    }).then((res) => {
      const {
        status,
        data
      } = res.data
      let orderModule = this.data.orderModule
      let curPage = this.data.curPage
      // if(curPage == 1) {
      //   orderModule = []
      // }
      if (status == 0) {
        if (!data) { // 无数据
          this.data.noData = 1
          if (this.data.orderModule.length == 0) {
            this.setData({
              emptyShow: true
            })
          }
        }
        if (data.length > 0) { // 存在数据
          for (let i = 0; i < data.length; i++) {
            let item = {
              id: data[i].id,
              orderType: data[i].orderType,
              submitDate: data[i].submitDate,
              orderStatusId: data[i].orderStatusId,
              totalFee: data[i].totalFee,
              transportFee: data[i].transportFee,
              payStatus: data[i].payStatus,
              orderStatus: data[i].orderStatus,
              orderDelivery: data[i].orderDelivery,
              isPurchaseOrder: data[i].isPurchaseOrder,
              orderDetails: data[i].orderDetails,
              grouppurchaseCode: data[i].grouppurchaseCode,
              groupStatus: data[i].groupStatus,
              evaluationStatus: data[i].evaluationStatus,
              orderCode: data[i].orderCode,
              orderDownPayment: data[i].orderType == 6 ? data[i].orderDownPayment : [],
              source: data[i].source
            }
            orderModule.push(item)
          }
          _self.data.curPage = curPage + 1
          _self.setData({
            orderModule: orderModule,
          })
        }
        this.setData({
          allShow: true,
          pageShow: true
        })
        LOADING.hide()
      }
    }).catch((e) => {
      LOADING.hide()
    })
  },
  login() {
    console.log('login getOrderList')
    this.getOrderList()
  },
  goLogistics1(e) { // 查看物流
    if (e.detail.length > 1) {
      this.setData({
        logisticsInfo: e.detail,
        logisiticsShow: true
      })
    } else {
      this.setData({
        logisiticsShow: false
      })
      app.globalData.delivery = e.detail[0]
      wx.navigateTo({
        url: '/pages/Logistics/Logistics'
      })
    }
  },
  goLogistics(e) {
    app.globalData.delivery = e.detail
    this.setData({
      logisiticsShow: false
    })
    wx.navigateTo({
      url: '/pages/Logistics/Logistics'
    })
  },
  goLogisticsList() { // 关闭物流MODAL
    this.setData({
      logisiticsShow: false
    })
  }
}
Page({
  data,
  ...methods,
  onLoad: function (options) {
    wx.hideShareMenu()
    this.setData({
      groupStatus: options.orderType ? options.orderType : 1
    })
  },
  onHide() {},
  onShow: function () {
    this.data.noData = 0
    this.data.curPage = 1
    this.data.orderModule = []
    console.log('onShow getOrderList')
    this.getOrderList()
  },
  onReachBottom: function (e) {
    console.log('onReachBottom getOrderList')
    this.getOrderList()
  },
  onShareAppMessage: function () {
    return {
      title: '五谷磨房个人中心'
    }
  }
})