import {
  SHOPCARTSERVER,
  REQUEST,
  API,
  LOADING,
  COUPON,
  TOAST,
} from '../../utils/index'
import {
  WGCOMMON,
  WGFORMAT,
  Page,
  WGTRACK,
  WGENV,
} from '../../wgUtils/index'
import WGAPI from '../../api/index'
import WGPAY from '../../utils/pay'
import env1 from '../../utils/env1'

const app = getApp()
const globalData = getApp().globalData
const couponsCache = [ null, null ] // 两套优惠券缓存方案 0正常方案，1随单购买超会方案

Page({
  data: {
    env: env1,

    isSvip: 0, // 是否单独购买超级会员
    isSpecial: 0, // 专柜临时销售渠道
    selectedSvip: false, // 是否选择随单购买超会
    showSvipGuide: false, // 结算页是否显示随单开通超会引导
    svipParams: { // 购买超级会员的参数
      shareStatus: false, // 推荐会员状态
      vipStatus: false, // 当前会员状态
      shareId: '', // 推荐人id
      shareSvipStatus: 0, // 推荐人的超会状态
      vipInvalidTime: '', // 当前会员的过期时间
      giftProList: [], // 购买超级会员赠品，
      selectedGift: null, // 选择的赠品
      expiresTime: '', // 预计到期时间
      payCustomer: false, // 付费会员
      isRenewal: 0, // 是否续费，续费下单传1
      price: 0,
      isBuysvipProduct: 0 // 是否是购买超会
    },
    svipProduct: { // 超会虚拟产品
      title: '超级会员',
      imgUrl: 'http://img.wgmf.com/chaohui99_1616481877271.png'
    },
    
    actType: 0, // 前端下单类型
    orderType: 0, // 订单类型
    productList: [], // 购买的商品列表（后台计算好，按照优惠券活动分类了）
    skuIds: [], // 所有skuid
    pIds: [], // 所有pId
    finalTotalPrice: { // 订单的最终计算结果
      integralBack: 0, // 本单可获得积分
      vipSave: 0, // 超级会员专享 - 本单节省金额
      vipBackGwj: 0, // 超级会员专享 - 本单可获得购物金
      productTotal: 0, // 商品金额总价
      addMoney: 0, // 换购金额/加购金额
      deliverFee: 0, // 运费
      couponSave: 0, // 优惠金额
      gwj: 0, // 购物金
      reedomIntegral: 0, // 兑换需要扣的积分
      actualPricePay: 0, // 最终实付金额
    },
    gwj: { // 购物金
      useHb: 0, // 可使用的购物金金额
      hbCheck: true, // 用户是否选择使用购物金
      canUseOrNot: 1 // 根据订单类型判断是否可以使用购物金
    },

    /** 优惠券 */
    canUseCouponOrNot: 1, // 根据订单类型判断是否可以使用所有优惠券
    canUseCoupon1OrNot: 1, // 根据订单类型判断是否可以使用满减券
    canUseCoupon2OrNot: 1, // 根据订单类型判断是否可以使用加购券
    ticketList1: [], // 满减券
    ticketList2: [], // 积分券
    ticketList3: [], // 满赠券
    ticketList4: [], // 换购券
    ticketList5: [], // 梯度满赠券
    giftList: [], // 赠品数据
    detailImgsShow: false, // 赠品的产品详情介绍弹窗

    address: { /** 收货地址 */
      addressModule: [], // 我的收货地址列表
      selectedAddress: null, // 选中的收货地址
      show: true
    },

    intergral: { /** 积分计算相关参数 */
      upgrade: 1, // 用户等级
      grade: 1, // 送积分倍数
      sendJifen: true
    },

    couponsId: [], // 优惠券id
    buyerMemo: env1 == 'TEST' ? '测试订单不发货' : '', // 买家留言
    orderOrigin: 1, // 下单来源 1-从产品下单，0-加购下单
    activityParams: [], // 下单的优惠券参数
    orderDetails: [], // 下单的商品参数
    allTickets: [], // 所有优惠券
    showJifenExchange: false, // 是否显示“线上积分商城已开通”一栏：非活动订单 && 含仓库555的商品 && 不含积分兑换sku
    promation: { // 活动订单数据
      type: 0, // 活动类型
      seckill: { // 秒杀活动/秒杀订单
        buyNowId: -1,
      }, 
      coupon: { // 购买优惠券
        buyCouponId: -1
      }, 
      package: { // 套餐搭配
        packageId: -1,
        orderActivityId: -1,
        comboActivityId: -1,
        productIds: [],
      }, 
      divide: { // 季卡/分期购/分期发货订单
        divideId: -1,
        divideTimes: -1,
        divideInterval: -1
      }, 
      groupA: { // 拼团
        id: -1,
        groupPurchaseId: null,
        grouppurchaseCode: null,
        groupHeadImgUrl: null,
        nickName: null,
        orderActivityId: null
      }, 
      groupB: { // 团购
        id: -1
      }, 
      presale: { // 预售 
        isAgree: false,
        lastPrice: 0
      }, 
      svip: { // 购买超级会员
        id: -1
      }, 
    },
    extraPromationData: {}, // 额外的活动订单数据，下单时需要取这些数据
    vipCusStatus: 0, // 0非会员 1会员 2过期会员
    cardType: 0, // 0年卡，1月卡
    disablePayBtn: false, // 支付按钮是否禁用
    containRedeemSku: 0, // 购买的商品中是否含有积分兑换产品
    wareHouseCodeIs555: 0, // 非积分兑换产品是否含有团风仓的产品（团风仓仓库代码：555）
    wareHouseCodeIs204: 0, // 非积分兑换产品是否含有东莞仓的产品（东莞仓仓库代码：CAN204） 
    groupLimitShow: false, // 拼团仅限新人弹窗
    isAllReedom: false, // 是否全是积分兑换产品 - 不可以使用购物金
    hideGuanGPopup: true, // 换购弹窗
    showJifenCoudan: false, // 显示积分商品凑单免运费提醒
    showAllCoupons: false, // 是否显示所有满赠券
    showRecheckAddr: false, // 生鲜收货地址确认弹窗
    isAgree: false, // 阅读并同意《五谷磨房超级会员服务协议》
    canOrderRequest: true, // 是否可以发起下单请求
    addProductId:'',//加购所有产品skuid逗号隔开
    deadline:false,
    showTips: false,
  },


  // 地址邮费相关操作 start ----------------------------------------------
  getDefaulAddress(type) { // 获取默认收货地址
    let _self = this
    let cusId = wx.getStorageSync('cusId')
    if (cusId) {
      return new Promise((resolve, reject) => {
        WGAPI.address.list({
          cusId: cusId,
          openId: wx.getStorageSync('openId')
        }).then(res => {
          let tmpObj = {
            addressModule: res,
            selectedAddress: null,
            show: _self.data.address.show
          }
          for (let i = 0; i < res.length; i++) {
            if (app.globalData.adIndex != null) {
              if (res[i].id == app.globalData.adIndex) {
                tmpObj.selectedAddress = res[i]
                break
              }
            } else {
              if (res[i].isDefault) {
                tmpObj.selectedAddress = res[i]
                break
              }
            }
          }
          if (!tmpObj.selectedAddress && res.length > 0) {
            tmpObj.selectedAddress = res[0]
          }
          _self.setData({
            address: tmpObj
          })
          if((tmpObj.selectedAddress.city.regionName=='北京市' && (tmpObj.selectedAddress.district.regionName == '朝阳区' || tmpObj.selectedAddress.district.regionName == '房山区' || tmpObj.selectedAddress.district.regionName == '丰台区')) || tmpObj.selectedAddress.city.regionName=='上海市'){
            _self.setData({
              showTips: true
            })
          }else {
            _self.setData({
              showTips: false
            })
          }

        
          console.log("获取默认收货地址:", tmpObj.selectedAddress)
          if (type) { // 初次onLoad需要获取运费
            this.getTransportFee().then(() => {
              resolve()
            })
          } else {
            resolve()
          }
        }).catch(e => {
          if(this.data.options.couponType == 1 || this.data.isSvip == 1 || this.data.options.couponType == 0) {
            // 购买线下优惠券不需要填地址 & 购买超级会员不需要填地址 & 购买线上优惠券
            resolve()
            return
          }
          console.log('你的收货地址为空，是否添加新的收货地址？', e)
          WGCOMMON.showModal('提示', '你的收货地址为空，是否添加新的收货地址？').then(() => {
            wx.setStorageSync('add', 1)
            wx.navigateTo({
              url: '/pages/AddressManage/AddressManage?isEdit=true&actType=' + _self.data.actType,
            })
          })
          resolve()
        })
      })
    } else {
      return Promise.resolve('无cusId')
    }
  },
  selectOtherAddress() { // 去选择其他地址
    wx.navigateTo({
      url: '/pages/AddressList/AddressList'
    })
  },
  addAddress() { // 新增收货地址
    wx.setStorageSync('add', 1)
    wx.navigateTo({
      url: '/pages/AddressManage/AddressManage?isEdit=true&actType=' + this.data.actType,
    })
  },
  changeAddress() { // 更换收货地址
    let adIndex = app.globalData.adIndex
    if (adIndex != null) {
      console.log('更换收货地址', adIndex)
      this.getDefaulAddress().then(res => {
        let addList = this.data.address.addressModule
        for (let i = 0; i < addList.length; i++) {
          if (addList[i].id == adIndex) {
            this.setData({
              ['address.selectedAddress']: addList[i]
            })
            this.getTransportFee().then(() => {
              if (this.data.isSvip == 1) {
                this.buySvip(app.globalData.payUrlOption)
              } else {
                this.computeTotalNew()
              }
            })
            break
          }
        }
      })
    }
  },
  getTransportFee() { // 根据收货地址获取运费
    /**
     * （1）邮费（先判断a，再判断b,c）：
        a.如果订单类型是购买优惠券单/直接购买超会单/营养顾问下团购单，则邮费直接取0；
        b.如果订单都是积分兑换sku；或订单是混合sku（同时有积分兑换sku和非积分兑换sku）且非积分兑换sku都不是团风仓、东莞仓（团风仓仓库代码：555，东莞仓仓库代码：CAN204），则邮费 = max （地区邮费，10）；
        c.其他条件，邮费 = max（地区邮费，0）；
    */
    console.log('本次下单的选中地址-------------', this.data.address.selectedAddress)
    if (this.data.address.selectedAddress) {
      if (this.data.isSvip == 1 || this.data.orderType == 11 || this.data.actType == 11 || (this.data.isStaffGroupB && this.data.actType == 16)) { // 营养顾问下团购单 或者购买优惠券，运费为0
        this.setData({
          ['finalTotalPrice.deliverFee']: 0
        })
        return Promise.resolve('营养顾问下团购单/购买优惠券/单独购买超会，运费为0')
      } else {
        return new Promise((resolve, reject) => {
          let tmp = this.data.address.selectedAddress
          WGAPI.address.deliveFee({
            provinceId: tmp.provinceId,
            cityId: tmp.cityId,
            distId: tmp.districtId ? tmp.districtId : (tmp.distId ? tmp.distId : '')
          }).then(res => {
            console.log('获取运费：', res.postage > 0 ? res.postage : 0)
            this.setData({
              ['finalTotalPrice.deliverFee']: res.postage > 0 ? res.postage : 0
            })
            /** 是否含有积分兑换产品 */
            if (this.data.containRedeemSku == 1 && (this.data.wareHouseCodeIs555 == 0 && this.data.wareHouseCodeIs204 == 0)) {
              let postage = Math.max(res.postage, 10)
              this.setData({
                ['finalTotalPrice.deliverFee']: postage
              })
            }
            console.log('getTransportFee算出来的最终运费', this.data.finalTotalPrice.deliverFee)
            this.checkJifenCoudan(this.data.moduleVal)
            resolve(res.postage > 0 ? res.postage : 0)
          })
        })
      }
    } else {
      return Promise.reject('无地址')
    }
  },
  // 地址邮费相关操作 end-------------------------------------------------


  // 用户身份相关操作 start ----------------------------------------------
  getUserLevel() { // 获取用户等级(钻谷、金谷、银谷、谷谷)，用于计算积分
    return new Promise((resolve, reject) => {
      WGAPI.user.level({
        openId: wx.getStorageSync('openId'),
        cusId: wx.getStorageSync('cusId')
      }).then(res => {
        if (res) {
          wx.setStorageSync('isJinGu', res.customerGrade == '金谷会员' ? 1 : (res.customerGrade == '钻谷会员' ? 1 : 0)) // 是否是金谷
          console.log('获取用户等级', res.upgradeCoefficient ? res.upgradeCoefficient : 1)
          this.setData({
            ['intergral.upgrade']: res.upgradeCoefficient ? res.upgradeCoefficient : 1,
            isJinGu: res.customerGrade == '金谷会员' ? 1 : (res.customerGrade == '钻谷会员' ? 1 : 0)
          })
        }
        resolve()
      }).catch(e => {
        reject(e)
      })
    })
  },
  getVipCusStatus() { // 获取超级会员状态 0非会员 1非过期会员 2已过期会员
    let cusId = wx.getStorageSync('cusId')
    if (cusId) {
      console.log(this.data.isSpecial)
      if(this.data.isSpecial == 1) {
        this.setData({
          vipCusStatus: 0
        })
      } else {
        return new Promise((resolve, reject) => {
          WGAPI.user.isWillOverdue(cusId).then(res => {
            if(res) {
              this.data.extraPromationData['isRenewal'] = res.payCustomer ? 1 : 0, // 是否是超会续费
              this.setData({
                ['svipParams.payCustomer']: res.payCustomer,
                ['svipParams.isRenewal']: res.payCustomer ? 1 : 0,
                ['svipParams.willOverdue']: res.willOverdue // 超会是否30年内即将过期
              })
            }
            WGAPI.user.getVipCusStatus(cusId).then(res => {
              if(res) {
                wx.setStorageSync('vipCusStatus', res.vipCusStatus)
                this.data['trialStatus'] = res.trialStatus // 超会的试用状态
                this.setData({
                  vipCusStatus: res.vipCusStatus,
                  cardType: res.cardType,
                  ['svipParams.vipInvalidTime']: res.vipInvalidTime
                })
              }
              resolve()
            }).catch(e => {
              reject(e)
            })
          })
        })
      }
    } else {
      return Promise.reject('无cusId')
    }
  },
  getShareVipCusStatus(query) { // 获取分享者的会员状态
    return new Promise((resolve, reject) => {
      if (query.shareId == wx.getStorageSync('cusId')) { // 分享者id是自己
        resolve(-1)
      } else {
        WGAPI.user.getVipCusStatus(query.shareId).then(res => {
          if (res) {
            console.log('获取分享者超级会员状态:', res.vipCusStatus)
            if (res.vipCusStatus == 1 || res.vipCusStatus == '1') {
              // console.log('获取分享者超级会员状态:', res.vipCusStatus)
              this.setData({
                ['svipParams.shareSvipStatus']: parseInt(res.vipCusStatus),
                ['svipParams.shareId']: query.shareId,
                ['finalTotalPrice.actualPricePay']: 99, // 分享者是超会
                ['extraPromationData.referrerCustomerId']: query.shareId // 推荐购买的客户id
              })
              /**
               * 超会产品变成99元的
               */
              this.initSvipProduct(query.shareId)
              resolve(1)
            }
            resolve(0)
          } else {
            resolve(-1)
          }
        })
      }
    })
  },
  // 用户身份相关操作 end-------------------------------------------------


  // 购买超级会员相关操作 start ----------------------------------------------
  svipDetail() {
    WGTRACK.logCustomEvent('click_seeMoreSvipDetail')
    wx.navigateTo({ url: '/pages/superMember/superMember' })
  },
  initSvipProduct(isValidShare) { // 初始化超会年卡产品并获取产品下单参数
    /**
     * 测试环境
     * ￥199超会 pId-1291，skuId-496
     * ￥99超会  pId-1290，skuId-495
     */
    /**
     * 正式环境
     * ￥199超会 pId-1936，skuId-2761
     * ￥99超会  pId-1935，skuId-2760
     */
    /**
     * 开通超会费用：金谷以上￥99，金谷以下￥199
     * 续费一律￥99
     */
    /** 默认199 */
    let pId = null
    let skuId = null
    if(isValidShare) { // 有效超会的推荐，一律99元
      if(WGENV.env == 'TEST') {
        pId = 1290
        skuId = 495
      } else {
        pId = 1935
        skuId = 2760
      }
    } else {
      if(WGENV.env == 'TEST') {
        pId = 1291
        skuId = 496
        if(this.getSvipPrice() == 99) {
          pId = 1290
          skuId = 495
        }
      } else {
        pId = 1936
        skuId = 2761
        if(this.getSvipPrice() == 99) {
          pId = 1935
          skuId = 2760
        }
      }
    }
    WGAPI.product.detail(pId).then(res => {
      this.setData({
        'svipProduct.title': res.productTemplateName,
        'svipProduct.imgUrl': res.groupedImages.icon[0].imageUrl,
        'svipProduct.skuName': res.products[0].skuName
      })
    })
    return {
      activityGrade: 1, // 产品活动积分赠送系数（默认为1） ,
      productId: skuId, // 产品id ,
      quantity: 1, // 购买数量
    }
  },
  getSvipPrice(isValidShare) {
    if(isValidShare) { // 有效超会的推荐，一律99元
      return 99
    }
    let vipCusStatus = wx.getStorageSync('vipCusStatus')
    if((vipCusStatus == 1 || vipCusStatus == 2) && this.data.svipParams.payCustomer) {
      return 99
    }
    if(this.data.isJinGu) {
      return 99
    }
    return 199
  },
  buySvip(query) { // 购买超级会员
    wx.setNavigationBarColor({
      frontColor: '#000000',
      backgroundColor: '#ffffff',
    })
    this.getVipCusStatus().then(res => {
      this.initSvipProduct() // 获取超会的虚拟产品
      let vipCusStatus = this.data.vipCusStatus,
        isJinGu = wx.getStorageSync('isJinGu'),
        vipInvalidTime = this.data.svipParams.vipInvalidTime // 超会的过期时间
      let date = vipCusStatus == 1?new Date(vipInvalidTime):new Date()
      let year = date.getFullYear() + 1
      let month = date.getMonth() + 1 
      let day = date.getDate()
      this.setData({
        ['finalTotalPrice.actualPricePay']: this.getSvipPrice(),
        orderType: 14,
        ['svipParams.expiresTime']: `${year}/${month}/${day}`, // 到期时间
        ['finalTotalPrice.gwj']: 0, // 不可以使用购物金
        ['extraPromationData.roleType']: isJinGu, // 银谷、谷谷0金谷、钻谷1
        ['address.show']: false
      })
      this.setData({
        'address.selectedAddress': { 
          id: (this.data.env == 'TEST' ? 2000493 : 2186976)
        }
      })
      this.noUseCoupon()
      if(query.shareId) {
        this.getShareVipCusStatus(query)
      }
      LOADING.hide()
    })
  },
  setBuySvipGuide() { // 是否显示购买超级会员引导（非超会/已过期超会/45天内即将过期的有效超会）
    if (this.data.vipCusStatus == 0 || this.data.vipCusStatus == 2 || (this.data.vipCusStatus == 1 && this.data.svipParams.willOverdue)) {
      this.setData({
        showSvipGuide: true,
        ['svipParams.price']: this.getSvipPrice() 
      })
      console.log('显示随单购买超会面板，立即给他送一个50元的无门槛券')
      WGAPI.coupons.sendFirstTicketByVip(wx.getStorageSync('cusId'))
    }
  },
  toggleSelectSvip() { // 选择随单购买超会
    LOADING.show()
    let selectedVal = !this.data.selectedSvip // 勾选随单购买超会
    if(selectedVal && !this.data.isAgree) {
      WGCOMMON.toast('请先勾选“阅读并同意《五谷磨房超级会员服务协议》”', 2500)
      return
    }
    this.setData({
      selectedSvip: selectedVal,
      vipCusStatus: selectedVal?1:0,
    })
    LOADING.show()
    Promise.all([ // 重新获取优惠券并计算价格
      this.getCouponsNew(this.data.moduleVal, globalData.payUrlOption)
    ]).then(res => {
      this.setOrderType(globalData.payUrlOption, this.data.moduleVal).then(() => {
        this.computeTotalNew() // 计算最终价格
        LOADING.hide()
      })
    })
  },
  agreeRule() { // 勾选“阅读并同意”《五谷磨房超级会员服务协议》”
    this.setData({
      isAgree: !this.data.isAgree
    })
    if(this.data.isAgree && !this.data.selectedSvip) {
      this.toggleSelectSvip()
    }
  },
  scrollAgreeRulePosition() { // 滚动到“阅读并同意《五谷磨房超级会员服务协议》”位置
    const query = wx.createSelectorQuery()
    query.select('#svip-agree-panel').boundingClientRect()
    query.selectViewport().scrollOffset()
    query.exec(function(res){
      wx.pageScrollTo({
        scrollTop: res[0].top + res[1].scrollTop - 300,
        duration: 300
      })
    })
  },
  // 购买超级会员相关操作 end-------------------------------------------------


  // 优惠券相关操作 start ----------------------------------------------
  fliterCouponType(type) { // 优惠券标签类型
    /**
     *  优惠券activityType的活动类型
       1买送活动,2满赠活动,3满减活动,4折扣活动,5买兑活动,6满兑活动,7积分兑活动,
       8免费赠送活动,9特价活动,10.以老带新,11,100积分抵扣券,12团购活动,
       15梯度满减活动,16梯度满赠活动,17梯度买减,18梯度买赠,19团购(立享优惠),
       20.第二件半价 21梯度满送 , 22.梯度买送, 23.满送, 25.加购, 13.送积分活动
     */
    let word = ''
    switch (type) {
      case 1:
        word = '买赠';
        break;
      case 2:
        word = '满赠';
        break;
      case 3:
        word = '满减';
        break;
      case 4:
        word = '折扣';
        break;
      case 5:
        word = '买兑';
        break;
      case 6:
        word = '满兑';
        break;
      case 7:
        word = '积分兑';
        break;
      case 8:
        word = '免费赠送';
        break;
      case 9:
        word = '特价';
        break;
      case 10:
        word = '以老带新';
        break;
      case 11:
        word = '100积分抵扣券';
        break;
      case 12:
        word = '团购';
        break;
      case 13:
        word = '送积分';
        break;
      case 15:
        word = '梯度满减';
        break;
      case 16:
        word = '梯度满赠';
        break;
      case 17:
        word = '梯度买减';
        break;
      case 18:
        word = '梯度买赠';
        break;
      case 19:
        word = '团购(立享优惠)';
        break;
      case 20:
        word = '第二件半价';
        break;
      case 21:
        word = '梯度满送';
        break;
      case 22:
        word = '梯度买送';
        break;
      case 23:
        word = '满送';
        break;
      case 25:
        word = '换购';
        break;
    }
    return word
  },
  resetCouponNewByQueryType(coupons, query) { // 根据订单类型reset后的优惠券，即有些优惠券不可用，需清空
    if (query && query.type) {
      if (query.type == 17 || query.type == 16 || query.type == 8 || query.type == 11) { // 不可以使用所有优惠券
        for (let i = 0; i < coupons.praList.length; i++) {
          coupons.praList[i].rActivityList = []
        }
        coupons.otherActivityList = []
        coupons.classifyActList = []
      }
    }
    console.log('根据订单类型reset后的优惠券', coupons)
    return coupons
  },
  toggleSvipCoupon(data, query) {},
  getCouponsNew(data, query) { // 新的优惠券接口
    if (!data) return Promise.reject('无产品信息')
    return new Promise((resolve, reject) => {
      console.log('购物车的商品:', data)
      let proList = [],
        skuIds = [],
        orderDetails = [],
        showJifenExchange1 = this.data.actType == 0 ? true : false,
        showJifenExchange2 = false,
        showJifenExchange3 = true,
        reedeemTotal = this.data.finalTotalPrice.reedomIntegral, // 需扣积分
        vipCusStatus = parseInt(wx.getStorageSync('vipCusStatus')),
        preSaleLastPrice = 0 // 预售尾款
      let isAllReedom = true // 全是积分兑换产品
      for (let i = 0; i < data.length; i++) {
        this.data.pIds.push(parseInt(data[i].productTemplateId))
        proList.push({
          // id: data[i].id,
          num: data[i].quantity,
          name: data[i].name,
          price: data[i].redeemPrice ? 0 : (vipCusStatus == 1?(data[i].noSvipPrice?data[i].noSvipPrice:(WGFORMAT.formatCurrency(data[i].price/0.95))):data[i].price), // 是否有积分兑换价格
          redeemPrice: data[i].redeemPrice ? data[i].redeemPrice : 0,
          specialPrice: 0,
          code: data[i].productId,
          proImage: data[i].icon,
          wareHouseCode: data[i].warehouseCode ? data[i].warehouseCode : data[i].wareHouseCode,
          templateId: data[i].productTemplateId,
          skuName: data[i].skuName,
          stock: data[i].stock
        })
        if (data[i].isRedeem == 1) { // 含有积分兑换产品
          this.setData({
            containRedeemSku: 1 // 购买的商品这含有积分兑换产品
          })
        }
        if (data[i].isRedeem !== 1) {
          isAllReedom = false
        }
        if (data[i].warehouseCode == '555' && data[i].isRedeem == 0) { // 含有团风仓的产品
          this.setData({
            wareHouseCodeIs555: 1
          })
        }
        if (data[i].warehouseCode == 'CAN204' && data[i].isRedeem == 0) { // 是否含有东莞仓的产品
          this.setData({
            wareHouseCodeIs204: 1
          })
        }
        reedeemTotal += data[i].redeemPrice ? (Number(data[i].redeemPrice) * Number(data[i].quantity)) : 0
        skuIds.push(parseInt(data[i].productId))
        console.log(data[i])
        orderDetails.push({
          productId: data[i].productId,
          quantity: data[i].quantity,
          activityGrade: data[i].activityGrade || 1
        })
        if (data[i].warehouseCode == '555') {
          showJifenExchange2 = true
        }
        if (data[i].isRedeem == 1) {
          showJifenExchange3 = false
        }
        if (data[i].buyNowId) { // 秒杀
          this.data.promation.seckill.buyNowId = data[i].buyNowId
        } else if (data[i].buyCouponId) { // 购买优惠券
          this.data.promation.coupon.buyCouponId = data[i].buyCouponId
        } else if (data[i].packageId) { // 购买套餐
          this.data.promation.package.packageId = data[i].packageId
        } else if (data[i].divideId) { // 分期发货/季卡
          this.data.promation.divide.divideId = data[i].divideId
        } else if (this.data.actType == 6) { // 预售
          preSaleLastPrice += (data[i].presellProductMoney - data[i].originPrice) * data[i].quantity
        }
      }
      if (this.data.actType == 6) {
        this.setData({
          ['promation.presale.lastPrice']: this.data.selectedSvip?WGFORMAT.formatCurrency(preSaleLastPrice * 0.95):(wx.getStorageSync('vipCusStatus') == 1 ? WGFORMAT.formatCurrency(preSaleLastPrice * 0.95) : WGFORMAT.formatCurrency(preSaleLastPrice))
        })
      }
      this.setData({
        skuIds: skuIds,
        orderDetails: orderDetails,
        ['finalTotalPrice.reedomIntegral']: reedeemTotal,
        ['finalTotalPrice.addMoney']: 0,
        showJifenExchange: showJifenExchange1 && showJifenExchange2 && showJifenExchange3,
        activityParams: [],
        giftList: []
      })
      console.log('this.data.selectedSvip---------', this.data.selectedSvip)
      let params = {
        activityId: 0,
        phone: wx.getStorageSync('phone'),
        cusId: wx.getStorageSync('cusId'),
        openId: wx.getStorageSync('openId'),
        exchangeCode: '',
        orderContext: {
          proList: proList
        },
        // vipCusStatus: 1,
        vipCusStatus: (this.data.selectedSvip?1:wx.getStorageSync('vipCusStatus')),
        orderResultContext: null
      }
      this.setData({
        isAllReedom: isAllReedom
      })
      console.log('是否全是积分兑换产品', isAllReedom)
      console.log('获取优惠券接口的参数', params)
      WGCOMMON.copy(params)
      REQUEST.post(API.get_coupons_new, {
        data: params,
        header: {
          'content-type': 'application/json'
        }
      }).then(res => {
        couponsCache[0] = res // 缓存一下正常购买的优惠券方案
        if (res.data.msgCode == 0) {
          /** 各类订单类型优惠券使用规则
           * 秒杀单(5)：不可以使用所有优惠券，不可以使用购物金
           * 预售单(6)：不可以使用满减券，不显示本单可获得积分，超级会员节省价和返利价需根据预付和尾款的价格总和计算
           * 拼团单(8)：不可以使用所有优惠券，显示“拼团成功才送积分”
           * 团购单(16)：不可以使用所有优惠券
           * 优惠券单(11)：不可以使用所有优惠券，运费设置为0
           * 分期发货单(9)：常规流程
           */
          console.log('获取优惠券：', res.data.resultInfo)
          let resultInfo = this.resetCouponNewByQueryType(res.data.resultInfo, query)
          let vipCusStatus
          if(this.data.isSpecial == 1){
            vipCusStatus = 0
          } else {
            vipCusStatus =this.data.selectedSvip?1:wx.getStorageSync('vipCusStatus')
          }
          let temp = resultInfo.praList
          let productTotal = 0 // 商品总价
          let vipSave = 0 // 超级会员节省价
          console.log(temp)
          for (let i = 0; i < temp.length; i++) {
            let price = temp[i].productInfo.price
            temp[i].productInfo.price = (vipCusStatus == 1) ? WGFORMAT.formatCurrency(price * 0.95) : price
            productTotal += temp[i].productInfo.price * temp[i].productInfo.num
            console.log(productTotal)
            vipSave += WGFORMAT.formatCurrency(price * 0.05 * temp[i].productInfo.num)
            let rActivityList = temp[i].rActivityList
            for (let j = 0; j < rActivityList.length; j++) {
              /** 设置商品优惠券标签 */
              resultInfo.praList[i].rActivityList[j]['couponTypeText'] = this.fliterCouponType(rActivityList[j].activtyInfo.activityType)
              /**
               * 如果商品券有加购券，需要把他放到全场券中，主要为了‘点击换购处理’
               */
              if (rActivityList[j].activtyInfo.activityType == 25) {
                resultInfo.otherActivityList.push(rActivityList[j])
              }
            }
          }
          /** 设置全场券优惠券标签 */
          let quanchangCouponLen = 0
          for (let i = 0; i < resultInfo.otherActivityList.length; i++) {
            resultInfo.otherActivityList[i]['couponTypeText'] = this.fliterCouponType(resultInfo.otherActivityList[i].activtyInfo.activityType)
            if (resultInfo.otherActivityList[i].activtyInfo.activityType != 25) {
              quanchangCouponLen++
            }
          }
          this.setData({
            productList: resultInfo.praList, // 商品+商品券
            otherActivityList: resultInfo.otherActivityList, // 全场券
            quanchangCouponLen: quanchangCouponLen, // 剔除换购券的全场券的数量 - 主要为了页面的显示效果
            ['finalTotalPrice.productTotal']: WGFORMAT.formatCurrency(productTotal), // 商品总价
            ['finalTotalPrice.vipSave']: WGFORMAT.formatCurrency(vipSave), // 超级会员节省
            ['finalTotalPrice.couponSave']: resultInfo.allGiftRuleResultContext ? resultInfo.allGiftRuleResultContext.giftMoney : 0 // 优惠金额
          })

          this.initCouponNew(resultInfo.classifyActList, proList, params)
          this.setData({
            proList: proList // 下单时每张优惠券里需要用到的参数 ：购买的所有商品
          })
          resolve()
        } else {
          WGCOMMON.toast(res.data.msgInfo)
          reject('获取优惠券：' + res.data.msgInfo)
        }
      })
    })
  },
  /** 不可以使用所有优惠券：秒杀5/拼团8/团购16/优惠券单11 /专柜临时销售渠道29*/
  filterRequestByOrderType() { // 不可以使用优惠券，就不要发起获取满赠优惠券请求
    if(this.data.actType == 17 || this.data.actType == 11 || this.data.actType == 16 || this.data.actType == 8|| this.data.actType == 29) {
      return false
    }
    return true
  },
  getUnShareSendCoupons(params, ticketList3, proList, onlyKeyStart) { // 获取不同享的满赠优惠券
    console.log(this.filterRequestByOrderType())
    if(!this.filterRequestByOrderType()) return
    let ticket3Len = ticketList3.length
    let giftList = [] // 赠品
    let activityParams = this.data.activityParams // 优惠券参数
    WGAPI.promotion.getUnShareActivity(params).then(res => {
      console.log('获取不同享的满赠优惠券----', res)
      if (res.length == 0) {
        this.getGradientGiftCoupons(params, proList, onlyKeyStart)
        return
      }
      for (let i = 0; i < res.length; i++) {
        res[i]['unShare'] = 1 // 不同享标记
        res[i]['selected'] = 0
        res[i]['onlyKey'] = onlyKeyStart + i
      }
      if (ticket3Len == 0) { // 默认选中第一项
        res[0]['selected'] = 1
        giftList.push({ // 不同享的赠品
          onlyKey: res[0].onlyKey,
          activityType: res[0].activityInfo.activityType,
          activityId: res[0].activityInfo.activityId,
          proList: res[0].giftRuleResultContext.giftProductInfo,
          unShare: 1
        })
        activityParams.push({
          unShare: 1,
          activityId: res[0].activityInfo.activityId,
          activityType: res[0].activityInfo.activityType,
          couponId: res[0].activityInfo.couponsId,
          expand: res[0].activityInfo.expand,
          onlyKey: res[0].onlyKey,
          cusId: wx.getStorageSync('cusId'),
          openId: "",
          orderContext: {
            // proList: proList
            proList: res[0].validProList
          },
          orderResultContext: {
            addOnMoney: res[0].giftRuleResultContext.addOnMoney,
            giftMoney: res[0].giftRuleResultContext.giftMoney,
            giftPoint: res[0].giftRuleResultContext.giftPoint,
            giftProductInfo: res[0].giftRuleResultContext.giftProductInfo,
          },
        })
        console.log(activityParams,'+++++++++++++++')
        this.data.activityParams = activityParams
        this.setData({
          giftList: giftList
        })
      }
      ticketList3.push(...res)
      this.setData({
        ticketList3: ticketList3
      })
      this.getGradientGiftCoupons(params, proList, onlyKeyStart + res.length)
    })
  },
  getGradientGiftCoupons(params, proList, onlyKeyStart) { // 获取梯度满赠券
    if(!this.filterRequestByOrderType()) return
    WGAPI.promotion.getGradientActivity(params).then(res => {
      console.log('获取梯度满赠优惠券----', res)
      if (res.length == 0) return
      this.setData({
        ticketList5: res,
      })
      // 梯度满赠券默认使用
      let giftList = this.data.giftList
      let activityParams = this.data.activityParams
      for (let i = 0; i < res.length; i++) {
        res[i]['unShare'] = 0 // 同享标记
        res[i]['selected'] = 1
        res[i]['onlyKey'] = onlyKeyStart + i
        giftList.push({ // 梯度满赠赠品
          onlyKey: res[i].onlyKey,
          activityType: res[i].activityInfo.activityType,
          activityId: res[i].activityInfo.activityId,
          proList: res[i].giftRuleResultContext.giftProductInfo,
          unShare: 0
        })
        activityParams.push({
          unShare: 0,
          activityId: res[i].activityInfo.activityId,
          activityType: res[i].activityInfo.activityType,
          couponId: res[i].activityInfo.couponsId,
          expand: res[i].activityInfo.expand,
          onlyKey: res[i].onlyKey,
          cusId: wx.getStorageSync('cusId'),
          openId: "",
          orderContext: {
            // proList: proList
            proList: res[i].validProList
          },
          orderResultContext: {
            addOnMoney: res[i].giftRuleResultContext.addOnMoney,
            giftMoney: res[i].giftRuleResultContext.giftMoney,
            giftPoint: res[i].giftRuleResultContext.giftPoint,
            giftProductInfo: res[i].giftRuleResultContext.giftProductInfo,
          },
        })
      }
      this.setData({
        giftList: giftList
      })
      console.log(activityParams,'+++++++++++++++')
      this.data.activityParams = activityParams
    })
  },
  setCouponOnlyId(data) { // 给优惠券设置唯一键值
    for (let i = 0; i < data.length; i++) {
      data[i]['onlyKey'] = i
    }
    return data
  },
  initCouponNew(data, proList, couponParams) { // 分类优惠券  满减券/积分券/满赠券/加购券
    // if (data.length == 0) {
    //   this.getUnShareSendCoupons(couponParams, [], proList, 0)
    //   return
    // }
    data = this.setCouponOnlyId(data)
    let activityParams = [],
      cusId = wx.getStorageSync('cusId'),
      giftList = [] // 赠品
    for (let i = 0; i < data.length; i++) {
      if (data[i].activityInfo.activityType != 25) { // 不是加购券
        data[i]['selected'] = 1
        activityParams.push({
          unShare: data[i].hasOwnProperty('unShare') ? data[i].unShare : 0,
          activityId: data[i].activityInfo.activityId,
          activityType: data[i].activityInfo.activityType,
          couponId: data[i].activityInfo.couponsId,
          expand: data[i].activityInfo.expand,
          onlyKey: data[i].onlyKey,
          cusId: cusId,
          openId: "",
          orderContext: {
            // proList: proList
            proList: data[i].validProList
          },
          orderResultContext: {
            addOnMoney: data[i].giftRuleResultContext.addOnMoney,
            giftMoney: data[i].giftRuleResultContext.giftMoney,
            giftPoint: data[i].giftRuleResultContext.giftPoint,
            giftProductInfo: data[i].giftRuleResultContext.giftProductInfo,
          },
        })
      } else {
        data[i]['selected'] = 0
      }
      if (data[i].giftRuleResultContext.giftProductInfo && data[i].activityInfo.activityType != 25) { // 有赠品
        giftList.push({ // 同享的赠品券
          onlyKey: data[i].onlyKey,
          activityType: data[i].activityInfo.activityType,
          activityId: data[i].activityInfo.activityId,
          proList: data[i].giftRuleResultContext.giftProductInfo,
          unShare: 0
        })
      }
      console.log(data[i],'+++++++++++++++++++++++++++++++++++')
      if(data[i].activityInfo.activityType == 13) {//送积分活动
        console.log(data[i])
        let memberAccelerateFlag = data[i].activityInfo.memberAccelerateFlag
        if(data[i].activityInfo.rule.productInfo == null && memberAccelerateFlag == 1) {
          memberAccelerateFlag = 2
        }
        for(let j =0; j<activityParams.length; j++) {
          console.log(activityParams[j])
          if(activityParams[j].activityId == data[i].activityInfo.activityId) {
            activityParams[j].memberAccelerateFlag= memberAccelerateFlag,
            activityParams[j].orderResultContext.productInfo = data[i].activityInfo.rule.productInfo
          }
        }
      }
    }
    let tickets = COUPON.filterList(data, this.data.info)
    console.log('优惠券分类：', tickets)
    let ticketList1 = tickets.ticketList1.length > 0 ? tickets.ticketList1 : [], // 满减券
      ticketList2 = tickets.ticketList3.length > 0 ? tickets.ticketList3 : [], // 积分券
      ticketList3 = tickets.ticketList2.length > 0 ? tickets.ticketList2 : [], // 满赠券
      ticketList4 = tickets.ticketList4.length > 0 ? tickets.ticketList4 : [] // 加购券
    if (this.data.actType == 16) { // 团购不可以使用满减券和积分券
      ticketList1 = []
      ticketList2 = []
    }
    console.log(activityParams,'+++++++++++++++++++')
    this.data.activityParams = activityParams
    this.data.allTickets = data
    this.setData({
      ticketList1: ticketList1,
      ticketList2: ticketList2,
      ticketList3: ticketList3,
      ticketList4: ticketList4,
      giftList: giftList,
    })
    /**
     * 积分券需要重置 orderDetails里该款对应产品的积分倍数 activityGrade
     *  */
    if (ticketList2.length > 0) {
      this.setActivityGrade()
    }
    /**
     * 有换购券需要显示换购弹窗
     */
    console.log('有换购券需要显示换购弹窗++++++++++++', )
    if (ticketList4.length > 0 && this.data.actType != 29) {
      console.log('有换购券需要显示换购弹窗++++++++++++', this.data.actType)
      //新建参数addProductId (string, optional): 加购所有产品skuid逗号隔开 ,用于订单提交
      let addProductId='';
      console.log(ticketList4)
      for (let index = 0; index < ticketList4.length; index++) {
        const element = ticketList4[index].giftRuleResultContext.giftProductInfo[0].code;
        if(addProductId!=''){
          addProductId=addProductId+','+element
        } else {
          addProductId=element
        }
      }
      if(this.data.canUseCoupon2OrNot == 0) {
        addProductId = '';
      }
      this.setData({
        addProductId: addProductId,
        hideGuanGPopup: false
      })
    }
    console.log('优惠券initCouponNew--------', this.data.activityParams, tickets)
    this.getUnShareSendCoupons(couponParams, ticketList3, proList, data.length)
  },
  toggleShowAllCoupons() { // 查看更多满赠券/收起更多满赠券
    let t = this.data.showAllCoupons
    this.setData({
      showAllCoupons: !t
    })
  },
  toggleCoupon3(onlyKey, selected, activityId, item) { // 选择赠品券
    let giftList = this.data.giftList
    if (selected == 0) { // 取消赠品券
      console.log(giftList, onlyKey)
      for (let i = 0; i < giftList.length; i++) {
        if (giftList[i].onlyKey == onlyKey) {
          giftList.splice(i, 1)
          this.setData({
            giftList: giftList
          })
          return
        }
      }
      return
    }
    if (selected == 1) {
      giftList.push({
        activityId: activityId,
        onlyKey: onlyKey,
        proList: item.giftRuleResultContext.giftProductInfo,
        activityType: item.activityInfo.activityType,
        unShare: item.hasOwnProperty('unShare') ? item.unShare : 0
      })
      this.setData({
        giftList: giftList
      })
      return
    }
  },
  selectCouponNew(e) { // 选择优惠券 bingtap事件
    let type = e.currentTarget.dataset.type, // 券的类型
      index = e.currentTarget.dataset.index, // 券的数组下标
      onlyKey = e.currentTarget.dataset.onlykey,
      key = type + '[' + index + '].selected', // 键值
      oldVal = this.data[type][index].selected, // 该券是否被选中
      activityId = e.currentTarget.dataset.activityid, // 该券的id
      activityParams = this.data.activityParams, // 目前下单选中的所有优惠券参数
      item = e.currentTarget.dataset.item, // 该优惠券的所有信息
      saveCouponMoney = Number(this.data.finalTotalPrice.couponSave), // 总的优惠金额
      thisCouponSaveMoney = Number(item.giftRuleResultContext.giftMoney) // 该优惠券的优惠金额
      
      console.log(this.data.activityParams)
    console.log('该优惠券的onlyKey------', onlyKey)
    if (oldVal == 1) { // 取消优惠券
      console.log('取消优惠券的onlyKey是---', onlyKey)
      for (let i = 0; i < activityParams.length; i++) {
        if (activityParams[i].onlyKey == onlyKey) {
          activityParams.splice(i, 1)
        }
      }
      saveCouponMoney -= thisCouponSaveMoney
      this.toggleCoupon3(onlyKey, 0, activityId)
      if (type == 'ticketList2' && this.data.ticketList2.length > 0) { // 有积分券并且取消了积分券，需要将该款产品的活动积分倍数还原
        this.setActivityGrade('cancel', item)
      }
    } else { // 选中优惠券
      console.log('选中优惠券的onlyKey是---', item.onlyKey)
      if (type == 'ticketList2' && this.data.ticketList2.length > 0) { // 有积分券并且选中了积分券，需要将该款产品的活动积分倍数设置为活动积分倍数
        this.setActivityGrade('check', item)
      }
      if (type == 'ticketList3' && this.data.ticketList3.length > 0) { // 如果选中的是赠品券，需要做同享与不同享的互斥关系
        let ticketList3 = this.data.ticketList3
        let giftList = this.data.giftList
        if (item.hasOwnProperty('unShare') && item.unShare == 1) { // 选中不同享券
          for (let i = 0; i < ticketList3.length; i++) {
            ticketList3[i]['selected'] = 0
          }
          for (let i = 0; i < giftList.length; i++) {
            // if (giftList[i].activityType == 16 || giftList[i].activityType == 2) {
            if (giftList[i].activityType == 2) {
              giftList.splice(i, 1)
              i--
            }
          }
          for (let i = 0; i < activityParams.length; i++) {
            // if (activityParams[i].activityType == 16 || activityParams[i].activityType == 2) {
            if (activityParams[i].activityType == 2) {
              activityParams.splice(i, 1)
              i--
            }
          }
          this.setData({
            giftList: giftList,
            ticketList3: ticketList3
          })
        } else { // 选中同享券
          for (let i = 0; i < ticketList3.length; i++) {
            if (ticketList3[i].hasOwnProperty('unShare') && ticketList3[i]['unShare'] == 1) {
              ticketList3[i]['selected'] = 0
            }
          }
          for (let i = 0; i < giftList.length; i++) {
            if ((giftList[i].activityType == 16 || giftList[i].activityType == 2) && (giftList[i].hasOwnProperty('unShare') && giftList[i]['unShare'] == 1)) {
              giftList.splice(i, 1)
              i--
            }
          }
          for (let i = 0; i < activityParams.length; i++) {
            if ((activityParams[i].activityType == 16 || activityParams[i].activityType == 2) && (activityParams[i].hasOwnProperty('unShare') && activityParams[i]['unShare'] == 1)) {
              activityParams.splice(i, 1)
              i--
            }
          }
          this.setData({
            giftList: giftList,
            ticketList3: ticketList3
          })
        }
      }
      if (item.giftRuleResultContext.giftProductInfo) { // 如果有赠品
        this.toggleCoupon3(onlyKey, 1, activityId, item)
      }
      console.log(item)
      activityParams.push({
        unShare: item.hasOwnProperty('unShare') ? item.unShare : 0,
        activityId: item.activityInfo.activityId,
        activityType: item.activityInfo.activityType,
        cusId: this.data.cusId,
        openId: "",
        couponId: item.activityInfo.couponsId,
        expand: item.activityInfo.expand,
        onlyKey: item.onlyKey,
        orderContext: {
          proList: item.validProList
        },
        orderResultContext: {
          addOnMoney: item.giftRuleResultContext.addOnMoney,
          giftMoney: item.giftRuleResultContext.giftMoney,
          giftPoint: item.giftRuleResultContext.giftPoint,
          giftProductInfo: item.giftRuleResultContext.giftProductInfo,
        },
      })
      if(item.activityInfo.activityType == 13) {//送积分活动
        let memberAccelerateFlag = item.activityInfo.memberAccelerateFlag
        if(item.activityInfo.rule.productInfo == null && memberAccelerateFlag == 1) {
          memberAccelerateFlag = 2
        }
        console.log(item,'-------------------')
        for(let j =0; j<activityParams.length; j++) {
          if(activityParams[j].activityId == item.activityInfo.activityId) {
            activityParams[j].memberAccelerateFlag= memberAccelerateFlag,
            activityParams[j].orderResultContext.productInfo = item.activityInfo.rule.productInfo
          }
        }
      }
      console.log(activityParams)
      saveCouponMoney += thisCouponSaveMoney
    }
    console.log(activityParams,'+++++++++++++++++')
    this.data.activityParams = activityParams
    this.setData({
      // activityParams: activityParams,
      ['finalTotalPrice.couponSave']: WGFORMAT.formatCurrency(saveCouponMoney),
      [key]: oldVal == 1 ? 0 : 1
    })
    console.log('优惠券参数activityParams---------------------', activityParams)
    this.computeTotalNew()
  },
  getExpand() { // 获取优惠券的额外扩展参数
    let expandParams = ''
    let activityParams = this.data.activityParams
    for (let i = 0; i < activityParams.length; i++) {
      if (activityParams[i].expand) {
        if (expandParams != '') {
          expandParams += `,${activityParams[i].expand.toString()}`
        } else {
          expandParams += activityParams[i].expand.toString()
        }
      }
    }
    return expandParams
  },
  getCouponIds() { // 获取优惠券的id
    let couponIdsParams = ''
    let activityParams = this.data.activityParams
    for (let i = 0; i < activityParams.length; i++) {
      if (activityParams[i].couponId) {
        if (couponIdsParams != '') {
          couponIdsParams += `,${activityParams[i].couponId.toString()}`
        } else {
          couponIdsParams += activityParams[i].couponId.toString()
        }
      }
    }
    console.log('getCouponIds获取优惠券的id/////////', couponIdsParams)
    return couponIdsParams
  },
  noUseCoupon() { // 不可以使用所有优惠券
    this.data.activityParams = []
    this.setData({
      ['finalTotalPrice.couponSave']: 0, // 订单最终优惠金额为0
      // activityParams: [], // 优惠券参数为空，下单不传优惠券参数
      canUseCouponOrNot: 0, // 不可以使用优惠券
    })
    console.log('noUseCoupon不可以使用所有优惠券//////')
  },
  noUseCoupon1() { // 不可以使用满减券
    let activityParams = this.data.activityParams, // 下单的优惠券参数
      newActivityParams = [], // 新的下单优惠券参数（把满减券剔除）
      otherActivityList = this.data.otherActivityList, // 全场优惠券
      newOtherActivityList = [], // 新的全场优惠券
      productList = this.data.productList, // 商品信息（包含商品券）
      newProductList = [] // 新的商品信息
    for (let i = 0; i < activityParams.length; i++) { // 把满减券从下单参数中剔除
      if (activityParams[i].activityType != 3 && activityParams[i].activityType != 15 && activityParams[i].activityType != 17) {
        newActivityParams.push(activityParams[i])
      }
    }
    for (let i = 0; i < otherActivityList.length; i++) { // 把满减券从全场券中剔除
      if (otherActivityList[i].activtyInfo.activityType != 3 && otherActivityList[i].activtyInfo.activityType != 15 && otherActivityList[i].activtyInfo.activityType != 17) {
        newOtherActivityList.push(otherActivityList[i])
      }
    }
    for (let i = 0; i < productList.length; i++) { // 把满减券从商品券中剔除
      let rActivityList = productList[i].rActivityList
      for (let j = 0; j < rActivityList.length; j++) {
        if (rActivityList[j].activtyInfo.activityType == 3 || rActivityList[j].activtyInfo.activityType == 15 || rActivityList[j].activtyInfo.activityType == 17) {
          rActivityList.splice(j, 1)
          j--
        }
      }
    }
    console.log(newActivityParams,'++++++++++++++')
    this.data.activityParams = newActivityParams
    this.setData({
      ['finalTotalPrice.couponSave']: 0, // 优惠金额为0
      // activityParams: newActivityParams, // 把满减券从下单参数中剔除
      otherActivityList: newOtherActivityList, // 把满减券从全场券中剔除
      canUseCoupon1OrNot: 0, // 不可以使用满减券
      ticketList1: [], // 清空满减券
      productList: productList, // 从商品券中剔除满减券
    })
  },
  noUseCoupon2() { // 不可以使用加购券
    this.setData({
      canUseCoupon2OrNot: 0
    })
  },
  // 优惠券相关操作 end-------------------------------------------------


  // 换购相关操作 start ----------------------------------------------
  cancelHuanGou() { // 关闭换购弹窗
    this.setData({
      hideGuanGPopup: true
    })
  },
  confirmHuanGou(e) { // 确认换购
    let hgCoupons = e.detail
    // console.error('confirmHuanGou', hgCoupons)
    for (let i = 0; i < hgCoupons.length; i++) {
      if (hgCoupons[i].selected == 1) {
        this.sureHuanGouByPopUp(hgCoupons[i])
      }
    }
    this.setData({
      hideGuanGPopup: true
    })
  },
  sureHuanGou(e) { // 点击换购
    let dataset = e.currentTarget.dataset,
      onlyKey = e.currentTarget.dataset.onlyKey,
      coupon = dataset.item,
      index = dataset.index,
      giftList = this.data.giftList, // 当前赠品列表
      currentGiftPro = coupon.giftRuleResultContext.giftProductInfo, // 换购的赠品
      currentHuanGouPrice = this.data.finalTotalPrice.addMoney // 加购金额
    currentGiftPro[0].price = coupon.activtyInfo.giftRule.addOnMoney // 加购金额
    giftList.push({ // 添加换购的赠品
      activityType: 25,
      activityId: coupon.activtyInfo.activityId,
      proList: currentGiftPro,
      onlyKey: 'huangou',
    })
    this.setData({
      ['otherActivityList[' + index + '].selected']: true,
      ['finalTotalPrice.addMoney']: WGFORMAT.formatCurrency(coupon.activtyInfo.giftRule.addOnMoney + currentHuanGouPrice),
      giftList: giftList,
    })
    console.log('点击换购', coupon)
    this.pushCouponInOrderParams(coupon)
    this.computeTotalNew() // 从新计算总价
  },
  sureHuanGouByPopUp(e) { // 点击换购
    let onlyKey = e.onlyKey,
      coupon = e,
      index = e.onlyKey,
      giftList = this.data.giftList, // 当前赠品列表
      currentGiftPro = coupon.giftRuleResultContext.giftProductInfo, // 换购的赠品
      currentHuanGouPrice = this.data.finalTotalPrice.addMoney // 加购金额
    currentGiftPro[0].price = coupon.activityInfo.giftRule.addOnMoney // 加购金额
    giftList.push({ // 添加换购的赠品
      activityType: 25,
      activityId: coupon.activityInfo.activityId,
      proList: currentGiftPro,
      onlyKey: 'huangou',
    })
    this.setData({
      ['otherActivityList[' + index + '].selected']: true,
      ['finalTotalPrice.addMoney']: WGFORMAT.formatCurrency(coupon.activityInfo.giftRule.addOnMoney + currentHuanGouPrice),
      giftList: giftList,
    })
    console.log('点击换购', coupon)
    this.pushCouponInOrderParams(coupon)
    this.computeTotalNew() // 从新计算总价
  },
  pushCouponInOrderParams(coupon) { // 选择完券后把券加入下单参数中(点击换购)
    console.log('选择加购的优惠券---', coupon)
    //新建参数isAddOrderFlag记录否加价购类型单0否1是，
    let isAddOrderFlag = 1;
    let curActivityParams = this.data.activityParams
    let activityInfo = coupon.hasOwnProperty('activityInfo') ? coupon.activityInfo : coupon.activtyInfo
    curActivityParams.push({
      activityId: activityInfo.activityId,
      couponId: activityInfo.couponsId,
      expand: activityInfo.expand,
      onlyKey: coupon.onlyKey,
      cusId: this.data.cusId,
      openId: "",
      orderContext: {
        proList: coupon.validProList ? coupon.validProList : this.data.proList
      },
      orderResultContext: {
        addOnMoney: activityInfo.giftRule.addOnMoney,
        giftMoney: coupon.giftRuleResultContext.giftMoney,
        giftPoint: coupon.giftRuleResultContext.giftPoint,
        giftProductInfo: coupon.giftRuleResultContext.giftProductInfo,
      },
    })
    console.log(curActivityParams,'++++++++++++++++++++++')
    this.data.activityParams = curActivityParams
    this.setData({
      isAddOrderFlag: isAddOrderFlag,
    })
  },
  // 换购相关操作 end-------------------------------------------------


  // 购物金相关操作 start ----------------------------------------------
  getGwj() { // 获取用户的购物金
    return new Promise((resolve, reject) => {
      WGAPI.user.gwj({
        openId: wx.getStorageSync('openId'),
        cusId: wx.getStorageSync('cusId'),
        sourceType: 1
      }).then(res => {
        console.log('获取用户的购物金', (res && res.balance && res.duringAct) ? res.balance : 0)
        this.setData({
          ['gwj.useHb']: (res && res.balance && res.duringAct) ? res.balance : 0
        })
        resolve()
      })
    })
  },
  toggleHb() { // 切换是否使用购物金
    let currentD = this.data.gwj.hbCheck
    this.setData({
      ['gwj.hbCheck']: !currentD,
      ['finalTotalPrice.gwj']: currentD ? 0 : this.data.gwj.useHb
    })
    this.computeTotalNew()
  },
  noUseGwj() { // 不可以使用购物金
    this.setData({
      ['gwj.canUseOrNot']: 0, // 不可以使用购物金
      ['gwj.useHb']: 0, // 可以使用的购物金为0
    })
  },
  // 购物金相关操作 end-------------------------------------------------


  // 积分相关操作 start ----------------------------------------------
  getIntergralUpgrade() { // 获取送积分倍数，用于计算积分
    return new Promise((resolve, reject) => {
      WGAPI.user.integralGrade().then(res => {
        console.log('获取送积分倍数:', res > 0 ? res : 1)
        this.setData({
          ['intergral.grade']: res > 0 ? res : 1 // 送积分倍数
        })
        resolve()
      })
    })
  },
  setActivityGrade(setType, coupon) { // 设置产品的积分倍数
    let tickets = this.data.ticketList2,
      orderDetails = this.data.orderDetails,
      skuIds = this.data.skuIds
    if (setType) { // 取消某一张积分券
      let validProList = coupon.validProList
      for (let i = 0; i < validProList.length; i++) {
        let index = skuIds.indexOf(parseInt(validProList[i].code))
        if (index != -1) {
          orderDetails[index].activityGrade = setType == 'cancel' ? 1 : coupon.giftRuleResultContext.multiplePoint
        }
      }
    } else { // 初始化所有选中的积分券
      for (let i = 0; i < tickets.length; i++) {
        if (tickets[i].selected == 1) {
          let validProList = tickets[i].validProList
          for (let j = 0; j < validProList.length; j++) {
            let index = skuIds.indexOf(parseInt(validProList[j].code))
            if (index != -1) {
              orderDetails[index].activityGrade = tickets[i].giftRuleResultContext.multiplePoint
            }
          }
        }
      }
    }
    this.setData({
      orderDetails: orderDetails
    })
  },
  computeActivityIntergral() { // 计算优惠券积分/活动积分
    /**
     * 活动积分 = 取整(（实付产品平摊金额 * （优惠券积分倍数 - 1）） * 会员等级系数)  [如果没有优惠券积分，则取全场积分倍数]
     */
    let intergral = 0,
      price = 0,
      vipCusStatus = this.data.vipCusStatus,
      productTotal = this.data.finalTotalPrice.productTotal,
      ticketList2 = this.data.ticketList2 // 所有积分券
    for (let i = 0; i < ticketList2.length; i++) {
      if (ticketList2[i].selected == 1) {
        let validProList = ticketList2[i].validProList
        price = 0
        for (let j = 0; j < validProList.length; j++) {
          price += (validProList[j].num * (vipCusStatus == 1 ? WGFORMAT.formatCurrency(validProList[j].price * 0.95) : validProList[j].price))
        }
        let avgPrice = (this.data.finalTotalPrice.actualPricePay * price) / productTotal // 活动积分产品金额平摊价格
        intergral += (avgPrice * (ticketList2[i].giftRuleResultContext.multiplePoint - this.data.intergral.grade) * this.data.intergral.upgrade)
        console.log('活动积分产品金额平摊价格', avgPrice)
      }
    }
    return intergral
  },
  getIntergralByInterface() { // 通过后台接口计算本单可获得积分
    let params = this.getOrderParams() // 获得下单参数
    params['memberGrade'] = this.data.intergral.upgrade
    WGAPI.order.integralBack(params).then(res => {
      console.log('getIntergralByInterface计算本单可获得积分数：', res)
      this.setData({
        ['finalTotalPrice.integralBack']: res<0?0:res, // 可获得积分
      })
    }).catch(e => {
      console.log(e)
    })
  },
  // 积分相关操作 end-------------------------------------------------


  // 弹窗&用户行为 相关操作 start ----------------------------------------------
  closeSku(e) { // 老客不可参与，拼团限制，老客不可参与弹窗
    this.setData({
      groupLimitShow: e.detail
    })
  },
  isAgreeFun(e) { // 预付定金：是否同意预售规则
    this.setData({
      ['promation.presale.isAgree']: e.detail,
      disablePayBtn: !e.detail
    })
  },
  // 弹窗&用户行为 相关操作 end ----------------------------------------------


  // 支付相关操作 start ----------------------------------------------
  surePay() { // 点击“支付”按钮
    if (!wx.getStorageSync('openId') || !wx.getStorageSync('cusId')) { // 下单没有openid
      WGCOMMON.toast('您的登录信息无效，需要重新登录！')
      setTimeout(function () {
        wx.removeStorageSync('cusId')
        wx.removeStorageSync('openId')
        wx.removeStorageSync('unionId')
        wx.removeStorageSync('sessionKey')
        wx.navigateTo({
          url: '/pages/AuthPage/AuthPage'
        })
      }, 1500)
      return
    }
    if (this.data.orderType == 6 && this.data.disablePayBtn) { // 请先同意预付款规则
      WGCOMMON.toast('请先同意预付款规则')
      return
    }
    if (this.data.address.selectedAddress == null) { // 请填写地址
      WGCOMMON.toast('请填写地址', 2000)
      return
    }
    if(this.data.selectedSvip && !this.data.isAgree) { // 随单购买超会但是没有勾选同意书
      WGCOMMON.toast('请先勾选“阅读并同意《五谷磨房超级会员服务协议》”', 2000)
      this.scrollAgreeRulePosition()
      return
    }
    // 如果购买的是生鲜核桃需要进行地址确认
    let shengXianPIds = [1053, 1049, 390, 386, 384, 7, 1696] // 生鲜核桃的pid
    let pIds = new Set(this.data.pIds)
    for(let i=0;i<shengXianPIds.length;i++) {
      if(pIds.has(shengXianPIds[i])) {
        this.setData({
          showRecheckAddr: true
        })
        return
      }
    }
    this.orderPay()
  },
  orderPay() { // 下单支付
    let _self = this
    LOADING.show()
    let h5openId = wx.getStorageSync('h5openId')
    let isSvipCustomer 
    if(this.data.isSpecial == 1){
      isSvipCustomer = 0
    } else {
      isSvipCustomer =(this.data.selectedSvip?1:wx.getStorageSync('vipCusStatus')) == 1 ? 1 : 0;
    } 
    let params = { // 下单参数
      addressId: this.data.address.selectedAddress.id, // 收货地址
      buyerMemo: env1 == 'TEST' ? '测试单不要发货' : this.data.buyerMemo, // 买家留言
      customerId: wx.getStorageSync('cusId'), // 下单cusId
      isPurchaseOrder: 0, // 是否是代购（小程序没有代购单，不用处理）
      isSvipCustomer: isSvipCustomer, // 是否是超级会员
      isAddOrderFlag:this.data.isAddOrderFlag ||0, //否加价购类型单0否1是 ,
      addProductId:this.data.addProductId || '', //加购所有产品skuid逗号隔开
      miniOpenId: wx.getStorageSync('openId'), // 下单的小程序openid
      orderOrigin: this.data.orderOrigin, // 下单来源 1-从产品下单，0-加购下单
      customerOpenId: h5openId?((typeof h5openId == "string" && h5openId.length >= 20)?h5openId:""):"", // H5的openId，不用填
      expand: this.getExpand(), // 拓展字段-活动识别码  - 暂未用到
      couponId: this.getCouponIds(),
      orderType: this.data.orderType, // 订单类型 /** 订单类型，1是普通单，2是送礼单，3是内购单，4蜂爆行动单，5抢购单, 6预付单,7是套餐搭配,8团购单,9是分期发货单,10代购单,11优惠券单,12免费单,13积分兑换单,14购买超级会员订单,15超级会员开卡赠送16团购单,17礼品卡单,22储值卡 */
      productIds: this.data.skuIds, // 购买的skuid集合
      productTotal: this.data.finalTotalPrice.productTotal, // 商品金额总价
      source: 2, // 下单来源 0公众号 1网页 2小程序
      staffId: wx.getStorageSync('shareStaffId') ? wx.getStorageSync('shareStaffId') : '', // 顾问分享id
      virtualMoney: this.data.finalTotalPrice.gwj, // 购物金
      activityParams: this.data.activityParams, // 优惠券-优惠券校验信息
      orderDetails: this.data.orderDetails, // 商品数据+价格
      otherDetail: null, // 不参与优化产品明细
      chanWxappScene: wx.getStorageSync('chan_wxapp_scene'), // 就是小程序场景值，
      chanReferAppId: wx.getStorageSync('chan_refer_app_id'), // 来源公众号或小程序appID
      campaign: WGTRACK.getChanId(), //存在有数埋点则以有数埋点优先
      miniOrderOrigin: wx.getStorageSync('custChannel') === 1 ? 2 : '',   //电商传2
    }
    for (let key in this.data.extraPromationData) { // 添加额外的活动订单参数
      params[key] = this.data.extraPromationData[key]
    }
    // wgUtils.copy(JSON.stringify(params))
    let orderUrl = this.data.isSvip ? API.svipOrder : API.get_order // 下单地址(购买超级会员 or 购买产品)
    let scenceTYpe = 0;
    if(this.data.sceneType.scene == 1175) {
      scenceTYpe = 1
    } else if (this.data.sceneType.scene == 1177) {
      scenceTYpe = 2
    } else if (this.data.sceneType.scene == 1191) {
      scenceTYpe = 3
    }
    params.sceneType = scenceTYpe || 0
    if (this.data.orderType == 5) { // 下秒杀单
      orderUrl = API.order_seckill
    }
    if(this.data.selectedSvip) { // 随单购买超会，将超会产品加到下单参数中
      params.otherDetail = this.initSvipProduct()
    }
    // console.log(params)
    // return
    if (this.data.isSvip) { // 单独购买超会
      params.addressId = (env1 == 'TEST' ? 2000493 : 2186976)
      params.isRenewal = this.data.svipParams.isRenewal
      params.orderDetails = [this.initSvipProduct()]
      params.orderType = 14
      params.virtualMoney = 0
      params.activityParams = []
      params.roleType = wx.getStorageSync('isJinGu')
      params.productTotal = this.getSvipPrice()
    }
    if (this.data.isSpecial) { // 单独购买超会
      params.orderType = 29
    }
    if(this.data.orderType == 5 || this.data.orderType == 16 || this.data.orderType == 11 || this.data.orderType == 21 || this.data.orderType == 8) { // 不可以使用所有优惠券：秒杀+团购+优惠券+拼团
      params.activityParams = []
    }
    console.log('下单接口：-------------', orderUrl)
    console.log('下单参数params：----------------------', params)
    console.log('最终下单的优惠券参数params：----------------------', params.activityParams)
    LOADING.hide()
    // return // 调试下单
    if(this.data.canOrderRequest) {
      this.data.canOrderRequest = false
      REQUEST.post(orderUrl, {
        header: {
          'content-type': 'application/json'
        },
        data: params
      }).then(res => {
        LOADING.hide()
        const {
          status,
          data,
          msg
        } = res.data
        if (status == 0) {
          SHOPCARTSERVER.removeProducts(this.data.skuIds, this.data.productId)
          this.setData({
            id: data.id
          })
          let params = {
            orderCode: data.orderCode,
            orderType: data.orderType,
            id: data.id,
            orderStatus: {
              id: 1
            }
          }
          if (data.orderType == 6) {
            params.orderDownPayment = {
              frontMoneyStartTime: app.globalData.preData.frontMoneyStartTime,
              frontMoneyEndTime: app.globalData.preData.frontMoneyEndTime,
              balancePaymentStartTime: app.globalData.preData.balancePaymentStartTime,
              balancePaymentEndTime: app.globalData.preData.balancePaymentEndTime
            }
          }
          app.globalData.leaveMessage = ''
          WGPAY({
            params,
            paySuccessFn: _self.paySuccessFn.bind(this),
            payErrorFn: _self.payErrorFn.bind(this),
            isSvip: this.data.isSvip,
            isBuysvipProduct: this.data.isBuysvipProduct,
            isBuyCoupon: (data.orderType == 11) ? true : false,
            orderType: data.orderType,
            customOrderParams: data
          })
        } else if (status == 10061) {
          /** 老客不可参与，拼团限制，老客不可参与弹窗 */
          this.setData({
            groupLimitShow: true
          })
        } else if( status == 10095) {
          WGCOMMON.showModal('提示', '抱歉，您已超过该优惠券累计购买数量。您可以前往订单列表查看是否有未支付的订单->>').then(r => {
            wx.navigateTo({ url: '/pages/OrderList/OrderList' })
          }).catch(() => {})
        } else {
          TOAST.warning({
            title: res.data.msg,
            duration: 3000
          })
        }
        this.data.canOrderRequest = true
      }).catch(e => {
        console.error(e);
        WGCOMMON.toast(e)
        LOADING.hide()
        this.data.canOrderRequest = true
      })
    }
  },
  paySuccessFn() {}, // 支付成功
  payErrorFn() {}, // 支付失败
  // 支付相关操作 end ----------------------------------------------


  // 订单相关操作 start ----------------------------------------
  getOrderParams() { // 获得下单参数
    let h5openId = wx.getStorageSync('h5openId')
    let params = { // 下单参数
      addressId: this.data.address.selectedAddress?this.data.address.selectedAddress.id:null, // 收货地址
      buyerMemo: env1 == 'TEST' ? '测试单不要发货' : this.data.buyerMemo, // 买家留言
      customerId: wx.getStorageSync('cusId'), // 下单cusId
      isPurchaseOrder: 0, // 是否是代购（小程序没有代购单，不用处理）
      isSvipCustomer: (this.data.selectedSvip?1:wx.getStorageSync('vipCusStatus')) == 1 ? 1 : 0, // 是否是超级会员
      miniOpenId: wx.getStorageSync('openId'), // 下单的小程序openid

      orderOrigin: this.data.orderOrigin, // 下单来源 1-从产品下单，0-加购下单
      customerOpenId: h5openId?((typeof h5openId == "string" && h5openId.length >= 20)?h5openId:""):"", // H5的openId，不用填
      expand: this.getExpand(), // 拓展字段-活动识别码  - 暂未用到
      couponId: this.getCouponIds(),
      orderType: this.data.orderType, // 订单类型 /** 订单类型，1是普通单，2是送礼单，3是内购单，4蜂爆行动单，5抢购单, 6预付单,7是套餐搭配,8团购单,9是分期发货单,10代购单,11优惠券单,12免费单,13积分兑换单,14购买超级会员订单,15超级会员开卡赠送16团购单,17礼品卡单 */
      productIds: this.data.skuIds, // 购买的skuid集合
      productTotal: this.data.finalTotalPrice.productTotal, // 商品金额总价
      source: 2, // 下单来源 0公众号 1网页 2小程序
      staffId: wx.getStorageSync('shareStaffId') ? wx.getStorageSync('shareStaffId') : '', // 顾问分享id
      virtualMoney: this.data.finalTotalPrice.gwj, // 购物金
      activityParams: this.data.activityParams, // 优惠券-优惠券校验信息
      orderDetails: this.data.orderDetails, // 商品数据+价格
      otherDetail: null, // 不参与优化产品明细
      chanWxappScene: wx.getStorageSync('chan_wxapp_scene'), // 就是小程序场景值，
      chanReferAppId: wx.getStorageSync('chan_refer_app_id'), // 来源公众号或小程序appID
      campaign: WGTRACK.getChanId(), //存在有数埋点则以有数埋点优先
    }
    for (let key in this.data.extraPromationData) { // 添加额外的活动订单参数
      params[key] = this.data.extraPromationData[key]
    }
    if(this.data.selectedSvip) { // 随单购买超会，将超会产品加到下单参数中
      params.otherDetail = this.initSvipProduct()
    }
    if(this.data.orderType == 5 || this.data.orderType == 16 || this.data.orderType == 11 || this.data.orderType == 21 || this.data.orderType == 8) { // 不可以使用所有优惠券：秒杀+团购+优惠券+拼团
      params.activityParams = []
    }
    return params
  },
  isStaff() { // 是否是营养顾问下团购单
    let cusId = wx.getStorageSync('cusId')
    REQUEST.get(API.is_staff + cusId).then(res => {
      if (res.data.status == 0 && res.data.data) { // 营养顾问下团购单
        this.setData({
          ['promation.groupB.staffId']: res.data.data.userName,
        })
      }
    })
  },
  setOrderType(query, moduleVal) { // 设置订单类型
    /** 各类订单类型下单规则
     * 秒杀单(5)：不可以使用所有优惠券，不可以使用购物金
     * 预售单(6)：不可以使用满减券&加购券，不显示本单可获得积分，超级会员节省价和返利价需根据预付和尾款的价格总和计算
     * 拼团单(8)：不可以使用所有优惠券，显示“拼团成功才送积分”
     * 团购单(16)：不可以使用所有优惠券
     * 优惠券单(11)：不可以使用所有优惠券，运费设置为0
     * 分期发货单(9)：常规流程
     */
    console.log('setOrderType设置订单类型',moduleVal)
    console.log('setOrderType设置订单类型',query)
    return new Promise((resolve, reject) => {
      let actType = 0,
        orderType = 0,
        extraPromationData = {},
        promation = this.data.promation
      if (query.isSvip && (query.isSvip == '1' || query.isSvip == 1)) { // 购买超级会员
        orderType = 14
        this.noUseGwj()
        this.noUseCoupon()
        this.setData({
          isSvip: 1,
          actType: 14,
          orderType: 14,
          ['promation.type']: 14,
          isJinGu: wx.getStorageSync('isJinGu')
        })
        this.buySvip(query)
      }
      console.log(this.data.moduleVal)
      if(this.data.moduleVal[0].type ==29){
        this.noUseGwj()
        this.noUseCoupon()
        orderType = 29
      }
      if (query.type) {
        if (query.type == 17) { // 秒杀(不可以使用优惠券and购物金)
          extraPromationData['buyNowId'] = promation.seckill.buyNowId // 秒杀id
          orderType = 5
           // 秒杀配置是否使用购物金，而不是全部不能使用
          if(!this.data.moduleVal[0].isGwtStatus) {
            this.noUseGwj()
          }
          this.noUseCoupon()
        } else if (query.type == 6) { // 预售(不可以使用优惠券)
          extraPromationData['orderActivityId'] = query.yfk
          orderType = 6
          this.noUseCoupon1()
          this.noUseCoupon2()
        } else if (query.type == 16) { // 团购
          this.noUseCoupon()
          orderType = 16
          extraPromationData['groupPurchaseId'] = query.groupPurchaseId
          extraPromationData['groupHeadImgUrl'] = wx.getStorageSync('avatarUrl') ? wx.getStorageSync('avatarUrl') : globalData.userAvatarUrl
          extraPromationData['nickName'] = wx.getStorageSync('nickName') ? wx.getStorageSync('nickName') : globalData.nickName
          extraPromationData['grouppurchaseCode'] = query.grouppurchaseCode ? query.grouppurchaseCode : null
          extraPromationData['orderActivityId'] = query.groupPurchaseId
        } else if (query.type == 18) { // 季卡/分期发货
          extraPromationData['orderActivityId'] = promation.divide.divideId
          orderType = 9
          this.setData({
            ['promation.divide.divideTimes']: wx.getStorageSync('divideTimes'),
            ['promation.divide.divideInterval']: wx.getStorageSync('divideInterval')
          })
        } else if (query.type == 19) { // 套餐搭配
          extraPromationData['orderActivityId'] = promation.package.packageId
          extraPromationData['comboActivityId'] = promation.package.packageId
          orderType = 7
        } else if (query.type == 8) { // 拼团（不可以使用优惠券）
          this.noUseCoupon()
          orderType = 8
          extraPromationData['groupPurchaseId'] = query.groupPurchaseId
          extraPromationData['groupHeadImgUrl'] = wx.getStorageSync('avatarUrl') ? wx.getStorageSync('avatarUrl') : globalData.userAvatarUrl
          extraPromationData['nickName'] = wx.getStorageSync('nickName') ? wx.getStorageSync('nickName') : globalData.nickName
          extraPromationData['grouppurchaseCode'] = query.grouppurchaseCode ? query.grouppurchaseCode : null
          extraPromationData['orderActivityId'] = query.groupPurchaseId
        } else if (query.type == 9) { // 积分兑换
          orderType = 13
        } else if (query.type == 11 ) { // 购买优惠券（不可以使用优惠券） 购买优惠券，运费设置为0
          extraPromationData['orderActivityId'] = promation.coupon.buyCouponId
          orderType = 11
          this.noUseCoupon()
          this.setData({
            ['finalTotalPrice.deliverFee']: 0
          })
          if(query.couponType == 0 || query.couponType == 1) { // 购买优惠券使用虚拟地址
            this.setData({
              'address.show': false,
            })
            if(!this.data.address.selectedAddress) { // 无地址时使用虚拟地址
              this.setData({
                'address.selectedAddress': { 
                  id: (env1 == 'TEST' ? 2000493 : 2186976)
                }
              })
            }
          }
          if(query.couponType == 1) {  // 购买的是线下优惠券，不需要填写地址
            orderType = 21
          }
        }
      }
      if(query.isSendIntergral == 0) {  // 不送积分
        this.setData({
          'intergral.sendJifen': false
        })
      }
      if (this.data.isAllReedom) { // 纯积分兑换订单
        this.noUseGwj()
        this.noUseCoupon()
        orderType = 13
      }
      if (query.orderAttribution) { // 产品下单来源
        extraPromationData['orderAttribution'] = query.orderAttribution // 订单归属
      }
      extraPromationData['referrerCustomerId'] = query.referrerCustomerId
      
      this.data.extraPromationData = extraPromationData
      this.setData({
        actType: query.type,
        orderType: orderType,
        // extraPromationData: extraPromationData,
      })
      resolve()
    })
  },
  computeTotalNew() { // 计算总价
    let final = this.data.finalTotalPrice
    // 原付金额 = 商品金额 + 加购金额 + 运费
    console.log(final.productTotal)
    console.log(final.addMoney)
    console.log(final.deliverFee)
    let originPay = WGFORMAT.formatCurrency(Number(final.productTotal) + Number(final.addMoney) + Number(final.deliverFee)),
      // 购物金
      maxGwj = 0
    // 最多可使用购物金 = min（我的购物金，原付金额-优惠-0.01）
    if (this.data.gwj.hbCheck) { // 用户选择使用购物金
      maxGwj = WGFORMAT.formatCurrency(Math.min(Number(this.data.gwj.useHb), originPay - final.couponSave - 0.01))
    }
    // 实付金额 = 商品金额 + 加购金额 + 运费 - 优惠 - 购物金
    let actualPay = WGFORMAT.formatCurrency(originPay - final.couponSave - maxGwj)
    if(this.data.selectedSvip) { // 随单购买超会，实付金额+9.9
      actualPay = WGFORMAT.formatCurrency(actualPay + this.getSvipPrice())
    } else {
      this.data.svipParams.price = 0
    }
    console.log(actualPay)
    this.setData({
      ['finalTotalPrice.actualPricePay']: actualPay, // 实付金额
    })
    /**
     * 本单可获得积分 = 消费积分 + 活动积分 = 消费积分 + （ 全场积分 + 优惠券积分 ） 
     * 消费积分 = 取整(实付金额 * 会员等级系数) 
     * 活动积分 = 取整(（实付产品平摊金额 * （优惠券积分倍数 - 1）） * 会员等级系数)  [如果没有优惠券积分，则取全场积分倍数]
     * 活动积分又等于全场积分+优惠券积分（优惠券积分可能为负数[当优惠券积分倍数小于全场积分倍数时]）
     * 全场积分 = 实付金额 * （全场积分倍数 - 1） * 会员等级系数
     * 优惠券积分 = 活动产品的实付平摊金额 * （优惠券积分倍数 - 全场积分倍数） * 会员等级
     * 活动积分 = 取整（全场积分 + 优惠券积分）
     */
    let integral = parseInt(actualPay * this.data.intergral.upgrade) + parseInt((actualPay * (this.data.intergral.grade - 1) * this.data.intergral.upgrade) + this.computeActivityIntergral()),
      // 超级会员可获得实付金额5%的购物金返利
      backBenefit = WGFORMAT.formatCurrency((actualPay - this.data.svipParams.price) * 0.05)
    console.log('消费积分', parseInt(actualPay * this.data.intergral.upgrade))
    console.log('活动积分', parseInt((actualPay * (this.data.intergral.grade - 1) * this.data.intergral.upgrade) + this.computeActivityIntergral()))
    if (this.data.orderType == 6) {
      let preprice = this.data.finalTotalPrice.productTotal,
        lastprice = this.data.promation.presale.lastPrice,
        vipCusStatus = (this.data.selectedSvip?1:wx.getStorageSync('vipCusStatus'))
      if (vipCusStatus == 1) {
        let all = WGFORMAT.formatCurrency((preprice / 0.95 + lastprice / 0.95) * 0.05) // 超级会员节省
        backBenefit = WGFORMAT.formatCurrency((preprice + lastprice - maxGwj) * 0.05)
        this.setData({
          ['finalTotalPrice.vipSave']: all
        })
      }
    }
    this.setData({
      ['finalTotalPrice.actualPricePay']: actualPay, // 实付金额
      ['finalTotalPrice.gwj']: maxGwj, // 购物金
      ['finalTotalPrice.integralBack']: parseInt(integral), // 可获得积分
      tempTestIntegral: parseInt(integral),
      ['finalTotalPrice.vipBackGwj']: backBenefit, // 超级会员可获得实付金额5%的购物金返利
    })
    this.getIntergralByInterface()
  },
  checkJifenCoudan(shopModule) { // 积分凑单提示
    // productCategory产品大类：1电商产品、2会员产品、4代销产品
    if (shopModule) {
      console.log('shopModule--------', shopModule)
      let res = false
      let jifenLen = 0
      let feiJifenLen = 0
      for (let i = 0; i < shopModule.length; i++) {
        if (shopModule[i].isChecked && shopModule[i].isRedeem == 1) {
          jifenLen++ // 积分兑换产品+1
        }
        if (shopModule[i].isChecked && shopModule[i].isRedeem == 0 && shopModule[i].productCategory != 4) {
          feiJifenLen++ // 自营产品+1
        }
      }
      // 有积分产品且有自营产品，邮费为0
      console.log('shopModule[i].productCategory', shopModule, jifenLen, feiJifenLen)
      if (jifenLen > 0 && feiJifenLen > 0) {
        this.setData({
          ['finalTotalPrice.deliverFee']: 0
        })
      }
      // 有积分产品但是没有自营产品，需要提示凑单
      if (jifenLen > 0 && feiJifenLen == 0) res = true
      this.setData({
        showJifenCoudan: res
      })
      return res
    } else {
      return
    }
  },
  // 订单相关操作 end ----------------------------------------


  onLoadInitMethod(query) { // 页面初始化：并发请求 优惠券+地址+购物金+用户等级+送积分倍数+超级会员状态
    LOADING.show('加载中')
    let moduleVal = []
    this.setData({
      actType: query.type
    })
    if (query.isSvip && query.isSvip == 1) { // 购买超级会员
      this.setData({
        isSvip: 1,
        actType: 14,
        orderType: 14,
        ['promation.type']: 14,
        isJinGu: wx.getStorageSync('isJinGu') // 是否是金谷以上会员
      })
      this.buySvip(query) // 购买超级会员
    } else { // 正常订单
      if(query.type == 6) { // 预售订单
        this.setData({
          disablePayBtn: true
        })
      }
      console.log(query)
      if (query.productId && query.productId != '') { // 直接购买
        moduleVal = SHOPCARTSERVER.getBuyNow()
        this.setData({
          orderOrigin: 1,
          actType: query.type,
          productId: query.productId,
        })
      console.log(moduleVal)

        if(moduleVal[0].type == 29) {
          this.data.isSpecial = 1;
          this.setData({
            actType: moduleVal[0].type,
          })
        }
      } else { // 购物车
        moduleVal = SHOPCARTSERVER.getCheckedCart()
        this.setData({
          orderOrigin: 0
        })
      }
      if (moduleVal.length == 0) return
      this.setData({
        moduleVal: moduleVal
      })
      Promise.all([
        this.getVipCusStatus(), // 超级会员状态
        this.getGwj(), // 可使用购物金
        this.getUserLevel(), // 用户等级
        this.getIntergralUpgrade(), // 送积分倍数
        this.getDefaulAddress(1), // 收货地址
        this.getCouponsNew(moduleVal, query), // 优惠券
      ]).then(res => {
        this.setOrderType(query, moduleVal).then(() => {
          this.computeTotalNew() // 计算最终价格
          LOADING.hide()
        })
        this.setBuySvipGuide() // 是否显示随单购买超会面板
      })
    }
  },
  onLoad(query) {
    console.log(query)
    if (!wx.getStorageSync('openId') || !wx.getStorageSync('cusId')) { // 下单没有openid
      WGCOMMON.toast('您的登录信息无效，需要重新登录！')
      setTimeout(function () {
        wx.removeStorageSync('cusId')
        wx.removeStorageSync('openId')
        wx.removeStorageSync('unionId')
        wx.removeStorageSync('sessionKey')
        wx.navigateTo({
          url: '/pages/AuthPage/AuthPage'
        })
      }, 1500)
      return
    }
    let _now = new Date()
    if(WGFORMAT.targetDateInDateBetwen('2022-01-28 16:30:00', '2022-02-04 23:59:59', _now)){
      this.setData({
        deadline: true,
      })
    }
    this.data.options = query
    globalData.payUrlOption = query
    this.setData({
      cusId: wx.getStorageSync('cusId'),
      sceneType: wx.getEnterOptionsSync()
    })
    this.onLoadInitMethod(query)
  },
  onShow() {
    wx.hideShareMenu()
    this.changeAddress() // 选完地址切换回来，需要重新计算运费和总价
    this.setData({ // 写完买家留言切换回来，需要重置该页面的买家留言
      buyerMemo: globalData.leaveMessage
    })
  },
  onUnload: function () {
    app.globalData.leaveMessage = ''
    app.globalData.adIndex = null
    app.globalData.tickets = {
      ticket1: null,
      ticket2: null,
      ticket3: null
    }
    app.globalData.orderOrigin = null
  }
})