import {
  SHOPCARTSERVER,
  REQUEST,
  API,
  LOADING,
  COUPON,
  TOAST,
} from '../../utils/index'
import {
  WGCOMMON,
  WGFORMAT,
  Page,
  WGTRACK,
  WGENV,
} from '../../wgUtils/index'
import WGAPI from '../../api/index'
import WGPAY from '../../utils/pay'
import env1 from '../../utils/env1'

const app = getApp()
const globalData = getApp().globalData
const couponsCache = [ null, null ] // 两套优惠券缓存方案 0正常方案，1随单购买超会方案

Page({
  data: {
    env: env1,
    expireDate: '',
    moduleVal: {},
    canOrderRequest: true, // 是否可以发起下单请求
  },

  // 支付相关操作 start ----------------------------------------------
  surePay() { // 点击“支付”按钮
    if (!wx.getStorageSync('openId') || !wx.getStorageSync('cusId')) { // 下单没有openid
      WGCOMMON.toast('您的登录信息无效，需要重新登录！')
      setTimeout(function () {
        wx.removeStorageSync('cusId')
        wx.removeStorageSync('openId')
        wx.removeStorageSync('unionId')
        wx.removeStorageSync('sessionKey')
        wx.navigateTo({
          url: '/pages/AuthPage/AuthPage'
        })
      }, 1500)
      return
    }
    this.orderPay()
  },
  orderPay() { // 下单支付
    let _self = this
    LOADING.show()
    let h5openId = wx.getStorageSync('h5openId')
    let params = { // 下单参数
      addressId: this.data.env == 'TEST' ? 2000493 : 2186976, // 收货地址
      buyerMemo: env1 == 'TEST' ? '测试单不要发货' : '', // 买家留言
      customerId: wx.getStorageSync('cusId'), // 下单cusId
      isPurchaseOrder: 0, // 是否是代购（小程序没有代购单，不用处理）
      isSvipCustomer: wx.getStorageSync('vipCusStatus') == 1 ? 1 : 0, // 是否是超级会员
      isAddOrderFlag:this.data.isAddOrderFlag ||0, //否加价购类型单0否1是 ,
      addProductId:this.data.addProductId || '', //加购所有产品skuid逗号隔开
      miniOpenId: wx.getStorageSync('openId'), // 下单的小程序openid
      orderOrigin: this.data.orderOrigin, // 下单来源 1-从产品下单，0-加购下单
      customerOpenId: h5openId?((typeof h5openId == "string" && h5openId.length >= 20)?h5openId:""):"", // H5的openId，不用填
      expand: '', // 拓展字段-活动识别码  - 暂未用到
      couponId: '',
      orderType: 21, // 订单类型 /** 订单类型，1是普通单，2是送礼单，3是内购单，4蜂爆行动单，5抢购单, 6预付单,7是套餐搭配,8团购单,9是分期发货单,10代购单,11优惠券单,12免费单,13积分兑换单,14购买超级会员订单,15超级会员开卡赠送16团购单,17礼品卡单,22储值卡,  21权益卡 */
      productIds: [this.data.moduleVal[0].id], // 购买的skuid集合
      productTotal: this.data.moduleVal[0].price, // 商品金额总价
      source: 2, // 下单来源 0公众号 1网页 2小程序
      staffId: wx.getStorageSync('shareStaffId') ? wx.getStorageSync('shareStaffId') : '', // 顾问分享id
      virtualMoney: 0, // 购物金
      activityParams: [], // 优惠券-优惠券校验信息
      orderDetails:        [{
        productId: this.data.moduleVal[0].id,
        quantity: 1,
        activityGrade: 1
      }],// 商品数据+价格
      otherDetail: null, // 不参与优化产品明细
      chanWxappScene: wx.getStorageSync('chan_wxapp_scene'), // 就是小程序场景值，
      chanReferAppId: wx.getStorageSync('chan_refer_app_id'), // 来源公众号或小程序appID
      campaign: WGTRACK.getChanId(), //存在有数埋点则以有数埋点优先
      miniOrderOrigin: wx.getStorageSync('custChannel') === 1 ? 2 : '',   //电商传2
      orderActivityId: this.data.moduleVal[0].buyCouponId,
      
    }

    // wgUtils.copy(JSON.stringify(params))
    let orderUrl = API.get_order // 下单地址(购买超级会员 or 购买产品)

    params.sceneType = 0

    console.log('下单接口：-------------', orderUrl)
    console.log('下单参数params：----------------------', params)
    console.log('最终下单的优惠券参数params：----------------------', params.activityParams)
    LOADING.hide()
    // return // 调试下单
    if(this.data.canOrderRequest) {
      this.data.canOrderRequest = false
      REQUEST.post(orderUrl, {
        header: {
          'content-type': 'application/json'
        },
        data: params
      }).then(res => {
        LOADING.hide()
        const {
          status,
          data,
          msg
        } = res.data
        if (status == 0) {
          SHOPCARTSERVER.removeProducts(this.data.skuIds, this.data.productId)
          this.setData({
            id: data.id
          })
          let params = {
            orderCode: data.orderCode,
            orderType: data.orderType,
            id: data.id,
            orderStatus: {
              id: 1
            }
          }
          if (data.orderType == 6) {
            params.orderDownPayment = {
              frontMoneyStartTime: app.globalData.preData.frontMoneyStartTime,
              frontMoneyEndTime: app.globalData.preData.frontMoneyEndTime,
              balancePaymentStartTime: app.globalData.preData.balancePaymentStartTime,
              balancePaymentEndTime: app.globalData.preData.balancePaymentEndTime
            }
          }
          app.globalData.leaveMessage = ''
          WGPAY({
            params,
            paySuccessFn: _self.paySuccessFn.bind(this),
            payErrorFn: _self.payErrorFn.bind(this),
            isSvip: this.data.isSvip,
            isBuysvipProduct: this.data.isBuysvipProduct,
            isBuyCoupon: (data.orderType == 11) ? true : false,
            orderType: data.orderType,
            customOrderParams: data
          })
        } else if (status == 10061) {
          /** 老客不可参与，拼团限制，老客不可参与弹窗 */
          this.setData({
            groupLimitShow: true
          })
        } else if( status == 10095) {
          WGCOMMON.showModal('提示', '抱歉，您已超过该优惠券累计购买数量。您可以前往订单列表查看是否有未支付的订单->>').then(r => {
            wx.navigateTo({ url: '/pages/OrderList/OrderList' })
          }).catch(() => {})
        } else {
          TOAST.warning({
            title: res.data.msg,
            duration: 3000
          })
        }
        this.data.canOrderRequest = true
      }).catch(e => {
        console.error(e);
        WGCOMMON.toast(e)
        LOADING.hide()
        this.data.canOrderRequest = true
      })
    }
  },
  paySuccessFn() {}, // 支付成功
  payErrorFn() {}, // 支付失败
  // 支付相关操作 end ----------------------------------------------


  onLoadInitMethod(query) { // 页面初始化：并发请求 优惠券+地址+购物金+用户等级+送积分倍数+超级会员状态
    // LOADING.show('加载中')
    let moduleVal = []
    this.setData({
      actType: query.type,
    })
    console.log(query)
    if (query.productId && query.productId != '') { // 直接购买
      moduleVal = SHOPCARTSERVER.getBuyNow()
      this.setData({
        orderOrigin: 1,
        actType: query.type,
        productId: query.productId,
      })
    console.log(moduleVal)
    } else { // 购物车
      moduleVal = SHOPCARTSERVER.getCheckedCart()
      this.setData({
        orderOrigin: 0
      })
    }
    if (moduleVal.length == 0) return
    this.setData({
      moduleVal: moduleVal
    })
     
  },
  onLoad(query) {
    console.log(query)
    if (!wx.getStorageSync('openId') || !wx.getStorageSync('cusId')) { // 下单没有openid
      WGCOMMON.toast('您的登录信息无效，需要重新登录！')
      setTimeout(function () {
        wx.removeStorageSync('cusId')
        wx.removeStorageSync('openId')
        wx.removeStorageSync('unionId')
        wx.removeStorageSync('sessionKey')
        wx.navigateTo({
          url: '/pages/AuthPage/AuthPage'
        })
      }, 1500)
      return
    }
    let _now = new Date()
    if(WGFORMAT.targetDateInDateBetwen('2022-01-28 16:30:00', '2022-02-04 23:59:59', _now)){
      this.setData({
        deadline: true,
      })
    }
    this.data.options = query
    globalData.payUrlOption = query
    this.setData({
      cusId: wx.getStorageSync('cusId'),
      sceneType: wx.getEnterOptionsSync()
    })
    this.onLoadInitMethod(query)
  },
  onShow() {
    wx.hideShareMenu()
    // 计算预计到期时间
    let date = Date.parse(new Date()) + 180 * 24 * 60 *60 *1000
    let date1 = new Date(date )
    const year = date1.getFullYear()
    const month = date1.getMonth() + 1
    const day = date1.getDate()
    this.setData({
      expireDate: year+'/'+month+'/'+day
    })
  },
  onUnload: function () {
    app.globalData.leaveMessage = ''
    app.globalData.adIndex = null
    app.globalData.tickets = {
      ticket1: null,
      ticket2: null,
      ticket3: null
    }
    app.globalData.orderOrigin = null
  }
})