import {
  REQUEST,
  API,
  LOADING,
  TOAST
} from '../../utils/index.js'
import router from '../../router/index.js'
import User from '../../store/index.js'
import {
  WGAUTH,
  Page,
  WGENV,
  WGFORMAT,
  WGTRACK
} from '../../wgUtils/index.js';
import WGAPI from '../../api/index'

const customerGradeThumb = [
  'https://img.wgmf.com/leve_1%202.png', // 谷谷会员
  'https://img.wgmf.com/leve_2%202.png', // 银谷会员
  'https://img.wgmf.com/leve_3%202.png', // 金谷会员
  'https://img.wgmf.com/leve_4%202.png' // 钻谷会员
]
const app = getApp()
const data = {
  isWillOverdue: false,
  svipBannerType: 1, // 超会即将过期类型  1年卡过期-30天内，2月卡过期-3天内 
  cusId: wx.getStorageSync('cusId'),
  level: '',
  ysf: {
    title: '详情页',
    config: JSON.stringify({
      "level": '', // vip等级
      "foreignid": wx.getStorageSync('cusId'),
      "data": JSON.stringify([{
        "index": 7,
        "type": "crm_param",
        "key": "partnerId",
        "value": 'cs' + wx.getStorageSync('cusId')
      }])
    })
  },
  userInfo: {
    headImgUrl: '',
    customerName: '',
    customerMobile: '',
    customerGradeThumb: '',
    validPoint: 0,
    couponNum: 0,
    gwjNum: 0,
    cashNum: 0,
    balanceOut: 0,
    needConsumptionNum: 0,
    needConsumptionAmount: 0,
    nextGrade: '',
    gradeLabel: ''
  },
  LoginShow: false,
  isShowHuanG: false,
  showSvipBanner: false,
  payCustomer: false,
  canIUseGetUserProfile: false,
  saveCardStatus: -1
}
const methods = {
  setSvipBanner() {
    let vipCusStatus = wx.getStorageSync('vipCusStatus') || this.data.userInfo.vipCusStatus
    let isJinGu = wx.getStorageSync('isJinGu') || this.data.userInfo.isJinGu
    /** 引导用户开通超会：过期超会+金谷以上会员 */
    if(vipCusStatus == 2 || (vipCusStatus == 0 && isJinGu)) { // 超会已经过期+金谷以上非超会
      this.setData({ showSvipBanner: true })
    }
  },
  getLevel() {
    let cusId = wx.getStorageSync('cusId')
    if (cusId) {
      let that = this
      wx.request({
        url: 'https://app.wgmf.com/app/information/getCrmCusInfo?cusId=' + cusId,
        success(res) {
          if (res.data.msgCode == 0) {
            that.data.level = res.data.resultInfo.level
            that.setData({
              cusId: cusId,
              ysf: {
                title: '详情页',
                config: JSON.stringify({
                  "level": res.data.resultInfo.level == 1 ? 1 : '', // vip等级
                  "foreignid": cusId,
                  "data": JSON.stringify([{
                    "index": 7,
                    "type": "crm_param",
                    "key": "partnerId",
                    "value": 'cs' + cusId
                  }])
                })
              },
            })
          }
        }
      })
    }
  },
  toHowBeGold() {
    wx.navigateTo({
      url: '/pages/HowBeGold/HowBeGold'
      // url: '/pages/ScanQrcode/ScanQrcode'
    })
  },
  handleContact(e) {
    console.log(this.data.ysf.config)
    this.setData({
      cusId: wx.getStorageSync('cusId'),
      ysf: {
        title: '详情页',
        config: JSON.stringify({
          "level": this.data.level == 1 ? 1 : '', // vip等级
          "foreignid": wx.getStorageSync('cusId'),
          "data": JSON.stringify([{
            "index": 7,
            "type": "crm_param",
            "key": "partnerId",
            "value": 'cs' + wx.getStorageSync('cusId')
          }])
        })
      },
    })
    console.log(this.data.ysf.config)
    var path = e.detail.path,
    query = e.detail.query,
    params = '';
    if (path) {
      for (var key in query) {
        params = key + '=' + query[key] + '&';
      }
      params = params.slice(0, params.length - 1);
      console.log('path, params------', path, params)
      if(path.indexOf('Home/Home') != -1 || path.indexOf('ProductIndex/ProductIndex') != -1 || path.indexOf('FanCommunity/pages/Index/Index') != -1 || path.indexOf('MyCart/MyCart') != -1 || path.indexOf('PersonalCenter/PersonalCenter') != -1) {
        wx.switchTab({
          url: path + '?' + params
        })
      } else {
        wx.navigateTo({
          url: path + '?' + params
        })
      }
    }
  },
  getSvipStatus() {
    return new Promise((resolve, reject) => {
      User.getSvipStatus(wx.getStorageSync('cusId')).then(res => {
        this.setData({
          'userInfo.vipCusStatus': res.resultInfo.vipCusStatus,
          'userInfo.cardType': res.resultInfo.cardType
        })
        wx.setStorageSync('vipCusStatus', res.resultInfo.vipCusStatus)
        if (res.resultInfo.vipCusStatus == '1' || res.resultInfo.vipCusStatus == 1) {
          this.setData({
            isShowHuanG: true
          })
        }
        resolve()
      }).catch(e => {
        console.error('getSvipStatus报错', e, '无cusID');
      })
    })
  },
  goOrder(e) {
    wx.navigateTo({
      url: '/pages/OrderList/OrderList?orderType=' + e.currentTarget.dataset.type
    })
  },
  replace(e) {
    wx.navigateTo({
      url: '/pages/ReplacePhone/ReplacePhone'
    })
  },
  
  checkCustomerGrade(customerGrade) {
    let gradeThumb = ''
    switch (customerGrade) {
      case '谷谷会员':
        gradeThumb = customerGradeThumb[0];
        break;
      case '银谷会员':
        gradeThumb = customerGradeThumb[1];
        break;
      case '金谷会员':
        gradeThumb = customerGradeThumb[2];
        break;
      case '钻谷会员':
        gradeThumb = customerGradeThumb[3];
        break;
      default:
        ;
    }
    this.setData({
      'userInfo.customerGradeThumb': gradeThumb
    })
  },
  login() {
    this.initData()
  },
  initData() {
    if(wx.getStorageSync('cusId')) {
      this.getSvipStatus().then(res => {
        this.getCouponRelate()
        this.setSvipBanner()
      })
      this.getGradeInfo()
      this.getUserInfo()
      this.getGwjRelate()
      this.getCashRelate()
      this.getLevel()
    } else {
      this.setData({
        LoginShow: true
      })
    }
  },
  getUserProfile() {
    WGAUTH.getUserProfile().then(res => {
      let nickName = wx.getStorageSync('nickName')
      let avatarUrl = wx.getStorageSync('avatarUrl')
      if (nickName && avatarUrl) {
        this.setData({
          'userInfo.headImgUrl': avatarUrl,
          'userInfo.customerName': nickName
        })
      }
    })
  },
  bindgetuserinfo(e) {
    WGAUTH.getUserInfo(e).then(res => {
      let nickName = wx.getStorageSync('nickName')
      let avatarUrl = wx.getStorageSync('avatarUrl')
      if (nickName && avatarUrl) {
        this.setData({
          'userInfo.headImgUrl': avatarUrl,
          'userInfo.customerName': nickName
        })
      }
    })
  },
  getUserInfo() {
    if (!wx.getStorageSync('cusId') || !wx.getStorageSync('openId') || !wx.getStorageSync('unionId')) {
      this.setData({
        LoginShow: true
      })
      return false
    }
    LOADING.show()
    this.setData({
      LoginShow: false
    })
    let url = `${API.get_user_info}?openId=${wx.getStorageSync('openId')}&cusId=${wx.getStorageSync('cusId')}&unionId=${wx.getStorageSync('unionId')}`
    REQUEST.post(url).then((res) => {
      const {
        msgCode,
        resultInfo,
        msgInfo
      } = res.data
      if (msgCode == 0) {
        let nickName = wx.getStorageSync('nickName')
        let avatarUrl = wx.getStorageSync('avatarUrl')
        this.setData({
          'userInfo.headImgUrl': avatarUrl ? avatarUrl : (resultInfo.headImgUrl ? resultInfo.headImgUrl : 'https://img.wgmf.com/img_default1.png'),
          'userInfo.customerName': nickName ? nickName : (resultInfo.customerName ? resultInfo.customerName : '匿名'),
          'userInfo.customerMobile': resultInfo.customerMobile ? resultInfo.customerMobile : '',
          'userInfo.validPoint': resultInfo.validPoint > 0 ? resultInfo.validPoint : 0,
          "userInfo.isJinGu": resultInfo.customerGrade == '金谷会员' ? 1 : (resultInfo.customerGrade == '钻谷会员' ? 1 : 0),
        })
        this.data['distanceConsDay'] = parseInt(resultInfo.distanceConsDay)
        wx.setStorageSync('isJinGu', this.data.userInfo.isJinGu)
        if(resultInfo.customerMobile) {
          wx.setStorageSync('phone', resultInfo.customerMobile)
        }
        if(resultInfo.hasOwnProperty("wechartNo") && resultInfo.wechartNo && resultInfo.wechartNo.length > 0) {
          wx.setStorageSync('h5openId', resultInfo.wechartNo?resultInfo.wechartNo:"")
        }
        this.checkCustomerGrade(resultInfo.customerGrade)
        this.setSvipBanner()
        LOADING.hide()
      } else {
        TOAST.warning({
          title: msgInfo
        }).then(() => {
          LOADING.hide()
        })
      }
    })
  },
  getGradeInfo() {
    let url = API.get_user_grade_info + '?openId=' + '&cusId=' + wx.getStorageSync('cusId')
    REQUEST.get(url).then((res) => {
      const {
        msgCode,
        returnBean
      } = res.data
      if (msgCode == 0) {
        this.setData({
          'userInfo.needConsumptionNum': returnBean.returnList[0].needConsumptionNum,
          'userInfo.needConsumptionAmount': returnBean.returnList[0].needConsumptionAmount,
          'userInfo.nextGrade': returnBean.returnList[0].nextGrade,
          intergal: returnBean.returnList[0].validPoint ? returnBean.returnList[0].validPoint : 0
        })
        this.checkGradeLabel(returnBean.returnList[0].needConsumptionNum, returnBean.returnList[0].needConsumptionAmount, returnBean.returnList[0].nextGrade)
      }
    })
  },
  getCouponRelate() {
    let url = API.get_coupon_relate + '?openId=' + '&cusId=' + wx.getStorageSync('cusId') + '&vipCusStatus=' + this.data.userInfo.vipCusStatus
    REQUEST.get(url).then((res) => {
      const {
        msgCode,
        resultInfo
      } = res.data
      if (msgCode == 0) {
        this.setData({
          'userInfo.couponNum': resultInfo > 0 ? resultInfo : 0
        })
      }
    })
  },
  getGwjRelate() {
    let url = API.get_gwj_relate + '?openId=' + wx.getStorageSync('openId') + '&cusId=' + wx.getStorageSync('cusId') + '&sourceType=1'
    REQUEST.get(url).then((res) => {
      const {
        status,
        retCode,
        data
      } = res.data
      if (data && status == 0) {
        this.setData({
          'userInfo.gwjNum': data.balance ? data.balance : 0,
          'userInfo.balanceOut': data.balanceOut ? data.balanceOut : 0
        })
        if(data.hasOwnProperty('openId') && data.openId && data.openId.length > 0) {
          wx.setStorageSync('h5openId', data.openId?data.openId:"")
        }
      }
    })
  },
  getCashRelate() {
    let url = API.get_cash_relate + '?openId=' + wx.getStorageSync('openId') + '&cusId=' + wx.getStorageSync('cusId') + '&sourceType=1'
    REQUEST.get(url).then((res) => {
      if (res.data.ret == 0 && res.data.data) {
        this.setData({
          'userInfo.cashNum': res.data.data.balance ? res.data.data.balance : 0
        })
      }
    })
  },
  goGwj() {
    wx.navigateTo({
      url: '/modules/ShoppingMoney/pages/Stored/Stored'
    })
  },
  goIntegral() {
    wx.navigateTo({
      url: '/pages/IntegralAccount/IntegralAccount?intergal=' + this.data.intergal
    })
  },
  goSuper() {
    wx.navigateTo({
      url: '/pages/superMember/superMember'
    })
  },
  goTickets() {
    wx.navigateTo({
      url: router({
        name: 'TicketsAccount',
        search: {
          name: 1,
          age: 18
        }
      })
    })
  },
  goFeedBack() {
    wx.navigateTo({
      url: '/pages/FeedBack/FeedBack'
    })
  },
  goIndex() {
    wx.switchTab({
      url: '/pages/Home/Home'
    })
  },
  goAddress() {
    wx.navigateTo({
      url: '/pages/AddressManage/AddressManage?from=user'
    })
  },
  goEva(){
    wx.navigateTo({
      url: '/modules/FanCommunity/pages/CommentList/CommentList?thumbUpReplyFlag=2'
    })
  },
  goLuckyCenter() {
    wx.navigateToMiniProgram({
      appId: 'wx7aeaa095f033dca0',
      path: 'pages/LotteryCenter/LotteryCenter',
      extraData: {
        foo: 'bar'
      },
      envVersion: 'release',
      success(res) {
        // 打开成功
      }
    })
  },
  goPointExchange(){ //积分兑换
    WGTRACK.logCustomEvent('click_toPointExchange')
    wx.navigateTo({
      url: '/modules/MallPromotion/pages/pointExchange/pointExchange'
    })
  },
  checkGradeLabel(needConsumptionNum, needConsumptionAmount, nextGrade) {
    if (nextGrade == null) {
      this.setData({
        'userInfo.gradeLabel': ''
      })
    } else {
      if (needConsumptionAmount > 0 && needConsumptionNum > 0) {
        this.setData({
          'userInfo.gradeLabel': '再购买' + needConsumptionNum + '次，且总金额大于' + needConsumptionAmount + '元，可升级为' + nextGrade
        })
      } else if (needConsumptionNum > 0 && needConsumptionAmount <= 0) {
        this.setData({
          'userInfo.gradeLabel': '再购买' + needConsumptionNum + '次可升级为' + nextGrade
        })
      } else if (needConsumptionAmount > 0 && needConsumptionNum <= 0) {
        this.setData({
          'userInfo.gradeLabel': '再购买金额大于' + needConsumptionAmount + '元可升级为' + nextGrade
        })
      }
    }
  },
  toSaveCardPage() {
    wx.navigateTo({
      url: '/modules/MallPromotion/pages/SaveMoneyCard/SaveMoneyCard'
    })
  },
  toSaveCardProduct() {
    wx.navigateTo({
      url: '/pages/ProductDetail/ProductDetail?pId=2081'
    })
  },
}
Page({
  data,
  ...methods,
  onHide() {},
  onLoad(option) {
    wx.hideShareMenu()
    if (wx.getUserProfile) {
      this.setData({
        canIUseGetUserProfile: true
      })
    }
  },
  onShow: function () {
    console.log('onShow PC----------------------')
    this.initData()
    let cusId = wx.getStorageSync('cusId')
    if (cusId) {
      WGAPI.user.isWillOverdue(cusId).then(res => {
        if (res) {
          wx.setStorageSync('payCustomer', res.payCustomer) // 付费超会
          this.data.payCustomer = res.payCustomer
          this.setData({
            isWillOverdue: res.willOverdue || res.willOverdueMonthCard, // 超会快过期
          })
          this.setSvipBanner()
        }
      })
      if(WGFORMAT.targetDateInDateBetwen('2021-05-20 00:00:00', '2021-06-15 23:59:59', new Date())) {
        WGAPI.promotion.isBuyCard(cusId).then(res => { 
          /**
           * 省钱卡PId  正式 2081    测试 1293
           * 1 省钱卡发售期：已购卡的引导用户分享
           * 0 省钱卡发售期：未购卡的引导用户购卡
           */
          this.setData({
            saveCardStatus: res?res.isBuyCard:0
          })
        })
      }
    }
  },
  onShareAppMessage(e) {
    if(e.from == 'button') {
      WGTRACK.logCustomEvent('share_saveMoneyCard')
      return {
        title: '618福利丨6元开卡省1000+，分享还能赚钱？！',
        path: '/pages/ProductDetail/ProductDetail?pId=2081&shareCusId=' + wx.getStorageSync('cusId'),
        imageUrl: 'https://img.wgmf.com/wgmall/sqk/img_share_sqk.png',
      }
    }
  },
  onShareTimeline(e) {
    if(e.from == 'button') {
      WGTRACK.logCustomEvent('shareTimeline_saveMoneyCard')
      return {
        title: '618福利丨6元开卡省1000+，分享还能赚钱？！',
        path: '/pages/ProductDetail/ProductDetail?pId=2081&shareCusId=' + wx.getStorageSync('cusId'),
        imageUrl: 'https://img.wgmf.com/wgmall/sqk/img_share_sqk.png',
      }
    }
  },
})