/**
 *  @ApiModelProperty(value = "订单类型，orderType
 * 1是普通单，2是送礼单，3是内购单，4是蜂爆行动初心蜜单，5是秒杀单，6是预售单,7是套餐搭配,8团购单,
 * 9是分期发货单10代购单,11优惠券单12,免费单,13积分兑换单,14购买超级会员订单,15超级会员开卡赠送 29专柜临时销售渠道")
 */
import {
  REQUEST,
  API,
  LOADING,
  FILTER,
  UTIL,
  TOAST,
  COUPON,
  SRTRACK,
  SHOPCARTSERVER,
} from '../../utils/index.js'
import api from '../../api/index'
import User from '../../store/index.js'
import staffShare from '../../utils/staffShare.js'
import {
  WGAUTH,
  WGSUBSCRIBE,
  Page,
  WGHTTP,
  WGENV,
  WGCOMMON,
  WGFORMAT,
  WGTRACK,
  WGUSER
} from '../../wgUtils/index';

let isTrack = false
// var zj = require('../../xhr.js')

var timeData = []
const app = getApp()

const data = {
  goLiveInfo: false, //是否显示直播按钮
  getChannelsLiveInfoRes: {}, // 直播信息
  referrerCustomerId: null, // 推荐人
  chooseSkuShow: false,
  hideCouponModal: true,
  id: 0,
  showOperate: true,
  productDetail: {
    actType: 0, // 商品类型：0普通商品 6预售 8拼团 9积分兑换 11优惠券 14超级会员 16团购 17秒杀 18分期发货 19套餐搭配 29专柜临时销售渠道
    integralStatus: 1,
    operationType: 0, // 0-加入购物车，1-立即购买， 2-拼团购买/预付定金/团购购买  3-分期发货购买
    stock: 1,
    vipCusStatus: 0,
    isSendIntergral: 1, // 该款产品是否送积分
    isGwtStatus: 0, // 秒杀是否可以使用购物金， 默认否
  },
  curSku: null,
  commentModule: '',
  commentListShow: false, // 是否显示评论列表
  starHot: 'https://img.wgmf.com/ic_xingxing@2x.png', // 评价星级
  starDefault: 'https://img.wgmf.com/ic_huixingxing@2x.png',
  startIndex: 0,
  transform: 'translate3d(0, 0, 0)',
  groupNum: '', // 拼团人数
  groupQRCode: null,
  groupPurchasePhoneList: [], // 正在拼团members
  groupPurchasePrimaryList: [], // 拼团团长列表
  cartNum: 0,
  couponListShow: false,
  shopCouponListShow: false,
  allShow: false,
  translateY: 0,
  purchaseModule: '',
  transitionDuration: '0s',
  empty: false,
  showTips: false,
  isTips: true,
  userImg: 'http://7xv1io.com1.z0.glb.clouddn.com/img_default.png',
  scrollTop: 0,
  translateY1: 0,
  transitionDuration: '0s',
  transitionDuration1: '0s',
  startIndex1: 0,
  arr: [1, 2, 3, 4, 5, 6, 7, 8, 9, 10],
  isTips1: false,
  preEndLabel: null, // 尾款支付时间
  isAuthorize: false,
  _campaign: '',
  showFavModal: false,
  product: {
    integralStatus: 1
  },
  promotion: { // 促销活动  5秒杀 9分期发货 11优惠券  12新品试用
    type: 0
  },
  showSecModal: false,
  isStaffGroupB: false, // 是否是营养顾问下团购单
  isGiftCard: false,
  noTrialAgain: 0,
  loginType: 1, // 1手机号授权，2用户信息授权
  showCommonTick: false,
  commonTickEndTime: null,
  productType: 0, // 产品类型
  isRefresh: false,
  pIdIntergralGrade: [], // sku产品的积分倍数
  imgBorder: '',  // 活动图片外壳
  whiteBannerImg: '',  // 轮播白底图
  canBuyJinBuCard: true, // 用户是否有资格购买五谷进补卡，true表示可以购买，false表示不可以购买
  xiangou1586: false, // 产品pid1586仅限新人购买
  canIUseGetUserProfile: false,
  luckyDrawId: '',
  LuckyDrawCusId: '',
  copyToTaobao: false,
  isLottery:false, 
  toView: '', // 配置默认显示view
  scrollHeight: 30, // 初始值不能给0
  scrollTop: 0,
}
const methods = {
  loadImg(e) { // 优惠券弹窗，让优惠券图片自适应
    let scale = e.detail.width / e.detail.height
    let h = 600 / scale
    this.setData({
      couponImgHeight: h
    })
  },
  hideCouModal() { // 关闭优惠券弹窗
    this.setData({
      hideCouponModal: true
    })
  },
  closeFavModal() { // 关闭顶部收藏小程序弹窗
    this.setData({
      showFavModal: false
    })
  },
  init() { // 初始化页面数据
    this.initMerchantCoupon()// 商家券查询列表
    this.getSvipLEvelOnline() // 获取超级会员信息
    this.getData().then(() => {
      if(!isTrack && this.data.productType != 8) {
        isTrack = true
        WGTRACK.pageBrowse(this.data.productType)
      }
    }) // 获取商品详情
    this.getCommentCount() // 第一条评论
    // this.getIntergral() // 积分
    // this.intoProductDetail() // 珠玑行为上报商品id
  },
  // intoProductDetail: function () { // 珠玑行为上报商品id
  //   const params = {
  //     Action: 'CreateUserAction', //表示调用行为上报接口
  //     Version: app.globalData.version,
  //     Uid: UTIL.getInfo('openId'), //用户ID
  //     UidType: 2, //用户ID类型，具体支持哪些用户ID可参考API文档
  //     SceneId: this.data._campaign, //发生行为的场景，由您自定义
  //     ActionType: 1, //行为类型，具体类型可参考API文档
  //     ItemIds: this.data.id //产生行为的商品  对应商城PId
  //   }
  //   zj.post(params) //上报行为
  // },
  getCartNum() { // 获取购物车商品数量
    this.setData({
      cartNum: SHOPCARTSERVER.getCartNum()
    })
  },
  getIntergral() { // 获取后台配置的会员日积分倍数  接口 -> wechat-shop-back/integral/integral/grade
    let _self = this
    let integral = this.data.productDetail.integralStatus
    // console.error('获取后台配置的会员日积分倍数 this.data.productDetail.integralStatus', integral)
    REQUEST.get(API.get_intergral).then((res) => {
      const {
        status,
        data
      } = res.data
      if (status == 0) {
        if (_self.data.pIdIntergralGrade.length < _self.data.productDetail.products.length) {
          _self.data.pIdIntergralGrade.push(data == 0 ? 1 : data)
        }
        let min = Math.min(..._self.data.pIdIntergralGrade)
        _self.setData({
          'productDetail.integralStatus': min,
          'product.integralStatus': min,
        })
        console.log('jifenbeishu', _self.data.pIdIntergralGrade, data, min)
      }
    }).catch((e) => {
      console.error('API.get_intergral报错---------', e)
    })
  },
  checkLoginType() { // 检查登录类型  // 1手机号授权，2用户信息授权
    let cusId = wx.getStorageSync('cusId')
    let unionId = wx.getStorageSync('unionId')
    if (!cusId) { // 没有cusId，选择授权手机号
      this.setData({
        loginType: 1,
        isLogin: false
      })
      return false
    } else if (cusId && !unionId) { // 有cusId但是没有unionId，选择授权用户信息
      this.setData({
        loginType: 2,
        isLogin: false,
      })
      return false
    } else { // 既有cusId又有手机号
      this.setData({
        isLogin: true
      })
      return true
    }
  },
  getShopCoupon: function(params) {
    // 插件返回信息在params.detail
    console.log('getcoupon', params)
    // console.log(params.detail.send_coupon_result[0].code)
    // if(params.detail.errcode == "OK") {
    if(params.detail.send_coupon_result[0].code == "SUCCESS") {
      console.log(new Date().getTime())
      this.merchantNotice(params.detail.send_coupon_result[0])
    }
  },
  shopCouponReceive(){
    console.log(1)
  },
  merchantNotice(event){
    let baseUrl = WGENV.env == "TEST" ? 'https://newapitest.wgmf.com/' : 'https://newapi.wgmf.com/'
    let that = this;
    console.log(event)
    let url = 'order/merchant/coupon/receive/notice'
    let data ={
      "couponCode": event.coupon_code,
      "cusId": wx.getStorageSync('cusId'),
      "expiredTime": JSON.parse(event.end_time),
      "stockId": event.stock_id
    }
    data = JSON.stringify(data), 
    REQUEST.post(baseUrl + url, {
      data: data,
      header: {
        'content-type': 'application/json'
      }
    }).then((res) => {
      const {
        status,
        data
      } = res.data
      if (res.data.code === 0) {
        console.log(res)
        that.initMerchantCoupon()
      }
    })
  },
  initMerchantCoupon() { // 商家券查询列表 -> promotion-online/coupon/queryMerchantCoupon
    let that = this
    REQUEST.post(API.queryMerchantCoupon + wx.getStorageSync('cusId')).then((res) => {
      // TUDO 优惠券
      const {
        msgCode,
        resultInfo
      } = res.data
      resultInfo.forEach(item => {
        console.log(item)
        if(item.mcas) {
          item.send_coupon_params = [{
            'stock_id':item.mcas.stockId,
            'out_request_no':item.mcas.outRequestNo,
          }]
        }
      })
      console.log(resultInfo)
      console.log(msgCode)
      if (msgCode === 0) {
        that.setData({
          merchantCoupon: resultInfo
        })
      }
    })
  },
  getData() { // 获取商品详情 接口 -> wechat-shop-back/product/info/template/${id}
    return new Promise((resolve, reject) => {
      REQUEST.get(API.get_productDetail + this.data.id).then((res) => {
        const {
          status,
          data
        } = res.data
        const priceArr = []
        let virtualPrice = []
        var sold = 0
        var stock = 0
        var products = []
        var redeemPrices = []
        let result = {}
        let skuIds = []
        let taoWord = ''
        let showPrice = true
        if (status == 0) {
          let channel = wx.getStorageSync('custChannel')
          if(channel !== ''){
            if(data.channelType == 1 && channel == 1 && wx.getStorageSync('vipCusStatus') != 1){
              this.setData({
                // showOperate: false
                taoWord: data.taoWord
              })
            }
          } else {
            let ticker = setInterval(()=>{
              channel = wx.getStorageSync('custChannel')
              if(channel !== ''){
                if(data.channelType == 1 && channel == 1 && wx.getStorageSync('vipCusStatus') != 1){
                  this.setData({
                    taoWord: data.taoWord
                  })
                }
                clearInterval(ticker)
              }
            }, 100)
          }
          this.setData({
            product: data
          })
          data.products.forEach((item) => {
            if (item.enable == 0) { // enable 0显示 1不显示
              if (item.addGiftCard == 1) {
                this.setData({
                  isGiftCard: true
                })
              }
              skuIds.push(item.id)
              products.push(item)
              priceArr.push(item.price)
              sold += (item.sold || 0)
              if (item.virtualPrice) virtualPrice.push(item.virtualPrice)
              if (item.stock && item.stock > 0) stock += item.stock
              redeemPrices.push(item.redeemPrice)
            }
          })
          wx.setNavigationBarTitle({ // 设置页面标题
            title: '五谷磨房' + data.productTemplateName
          })
          result.id = data.id
          result.price = this.getPriceRange(priceArr) // 原价
          result.superPrice = FILTER.getPriceRange(priceArr, 0.95) // 计算活动后的超级会员价
          result.superOwnPrice = FILTER.getPriceRange(priceArr, 0.95) // 不计算活动的超级会员价
          result.virtualPrice = this.getPriceRange(virtualPrice)
          result.sold = sold
          result.stock = stock
          result.products = products
          result.redeemPrices = this.getPriceRange(redeemPrices)
          result.groupedImages = data.groupedImages
          result.warehouseCode = data.warehouseCode
          result.productTemplateName = data.productTemplateName
          result.presell = data.presell
          result.isAddShoppingCart = data.isAddShoppingCart
          result.productProperties = data.productProperties
          result.groupPurchase = data.groupPurchase
          result.isSendIntergral = data.integralStatus
          result.productCategory = data.productCategory
          SRTRACK.setTrackData('browse_sku_page', data)

          if (data.id == 1274) {
            wx.setStorageSync('isTrialProduct', 1) // 购买试用新品
            this.setData({
              "promotion.type": 12
            })
          } else if (data.id == 964) {
            this.data.productType = 11
          }

          if (data.ladderPrice) { /** 阶梯价 */
            this.data.productType = 5
            if(WGFORMAT.targetDateInDateBetwen(data.ladderPrice.startTime, data.ladderPrice.endTime)) {
              result.cartProTag = '特价'
              result.endTime = data.ladderPrice.endTime
              let loadderSkus = data.ladderPrice.ladderPriceSku.ladderPriceSkuLines
              for(let i=0;i<loadderSkus.length;i++) { 
                for(let j=0;j<products.length;j++) {
                  if(data.ladderPrice.ladderPriceSku.skuId == products[j].id && loadderSkus[i].isOriginalPrice == 1) {
                    result.products[j]['originPrice'] = loadderSkus[i].price
                    break
                  }
                }
              }
            }
          } else if (data.productDiscountSchedule) { // 限时折扣活动 - @author-wucl
            this.data.productType = 1
            result.productDiscountSchedule = data.productDiscountSchedule
            result.productDiscountSchedule.isStart = false; // 未开始
            result.productDiscountSchedule.isEnd = false; // 未结束
            let nowdate = new Date().getTime();
            if (nowdate >= result.productDiscountSchedule.startTime) {
              result.productDiscountSchedule.isStart = true; // 已开始
            }
            if (nowdate >= result.productDiscountSchedule.endTime) {
              result.productDiscountSchedule.isEnd = true; // 已结束
            }
            let dicountStartTime = new Date(result.productDiscountSchedule.startTime);
            let s = `${dicountStartTime.getMonth() + 1}月${dicountStartTime.getDate()}日${dicountStartTime.getHours()}点${dicountStartTime.getMinutes()}分`;
            result.productDiscountSchedule.startTime = s; // 活动开始时间
            let max = 0; // 折扣最大力度
            let discountProuct = result.productDiscountSchedule.productDiscountScheduleSkus
            for (let i = 0; i < discountProuct.length; i++) {
              let tmp = discountProuct[i].originalPrice - discountProuct[i].discountPrice;
              if (max < tmp) {
                max = tmp
              }
              for(let j=0;j<products.length;j++) {
                if(products[j].id == discountProuct[i].productId) {
                  result.products[j]['originPrice'] = discountProuct[i].originalPrice?discountProuct[i].originalPrice:result.products[j].virtualPrice
                  break
                }
              }
            }
            max = max.toFixed(2)
            result.productDiscountSchedule.discount = max
            result.productDiscountSchedule.price = result.price
            if(result.productDiscountSchedule.isStart && !result.productDiscountSchedule.isEnd) {
              // 活动已开始但未结束
              result.cartProTag = '限时折扣'
              result.endTime = result.productDiscountSchedule.endTime
            }
          }

          if (data.hotWord) { // 营销热词
            result.hotWord = [data.hotWord]
          }
          if(data.groupedImages.hasOwnProperty('white') && data.groupedImages.white.length > 0) { // 有轮播白底图
            this.initImgBorder(data.groupedImages.white[0].imageUrl)  // 初始化活动图片外框
          }

          this.setData({
            productDetail: Object.assign({}, this.data.productDetail, result),
            isLogin: (UTIL.getInfo('cusId').length != 0) && (UTIL.getInfo('openId').length != 0),
            'productDetail.isLogin': (UTIL.getInfo('cusId').length != 0) && (UTIL.getInfo('openId').length != 0),
            isAuthorize: (wx.getStorageSync('avatarUrl') && wx.getStorageSync('nickName')) ? true : false,
            skuIds: skuIds.join(',')
          })
          this.getActivity(Object.assign({}, this.data.productDetail, result))
          this.getIntergral()
          
          if (data.groupPurchase && data.groupPurchase.length > 0) { /** 拼团 start */
            this.data.productType = 8
            this.setData({
              "productDetail.actType": 8,
            })
            let list = data.groupPurchase
            for (let i = 0; i < list.length; i++) {
              if (list[i].enable == 0) {
                this.groupBuy(list[i])
              }
            }
            this.initOtherPurchase(data.id)
          } else if (data.buyNow) { /** 秒杀 start */
            result.actType = 17
            this.data.productType = 2
            this.setData({
              "promotion.type": 5,
              'productDetail.isGwtStatus': result.isGwtStatus
            })
            this.initBuyNow(data.buyNow)
          } else if (data.divideDelivery) { /** 分期发货 start */
            result.actType = 18
            this.data.productType = 3
            this.setData({
              promotion: {
                type: 9,
                divide: data.divideDelivery
              }
            })
            this.initDivide(data.divideDelivery)
          } else if (data.buyCoupon) { /** 购买优惠券 start */
            result.actType = 11
            this.data.productType = 4
            this.setData({
              "promotion.type": 11
            })
            this.initBuyCoupon(data.buyCoupon)
          }
          this.setCommonActivityTick()
        } else {
          this.setData({
            empty: true
          })
        }
        if (this.data.isRefresh) {
          wx.stopPullDownRefresh()
          this.setData({
            isRefresh: false
          })
        }
        resolve()
      }).catch((e) => {
        if (this.data.isRefresh) {
          wx.stopPullDownRefresh()
          this.setData({
            isRefresh: false
          })
        }
        reject()
      })
    })
  },
  setCommonActivityTick() {
    /**
     * 在普通商品主图下方增加倒计时，只在活动期间显示。
     * 1、活动时间为5月7日00:00:00-5月10日23:59:59，倒计时只在活动期间显示，活动前后倒计时区域隐藏。
     * 2、倒计时截止时间为5月10日23:59:59，数字要动态变化（不要像现在限时折扣那样固定不动）。
     * 4、商城里所有非秒杀非限时折扣之类的普通商品详情页都要有
     */
    // 母亲节活动倒计时
    let monStartTime = new Date('2020/05/07 00:00:00').getTime()
    let monEndTime = new Date('2020/05/10 23:59:59').getTime()
    // 测试时间
    // let monStartTime = new Date('2020/04/30 18:32:00').getTime()
    // let monEndTime = new Date('2020/04/30 18:33:00').getTime()
    api.getTime().then(res => {
      console.log('现在的时间是', res)
      console.log('活动时间判断：普通产品 + 活动时间已结束 + 活动时间未开始', this.data.productDetail.actType, this.data.productDetail.actType != 0, res > monEndTime, res < monStartTime)
      if (this.data.productType != 0 || res > monEndTime || res < monStartTime) {
        this.setData({
          showCommonTick: false,
          commonTickEndTime: null
        })
        return
      }
      console.log('符合活动时间，显示活动倒计时')
      this.setData({
        commonTickEndTime: monEndTime,
        showCommonTick: true,
      })
    })
  },
  getActivity(info) { // 设置商品类型actType 8拼团 9积分兑换 6预售
    if (info.products && info.products.length > 0) {
      for (let i = 0; i < info.products.length; i++) {
        if (info.products[i].isRedeem == 1) {
          this.setData({
            'productDetail.isRedeem': info.products[i].isRedeem
          })
          info.isRedeem = info.products[i].isRedeem
        }
      }
    }
    if (info.isRedeem == 1) { // 积分兑换
      this.data.productType = 9
      this.setData({
        showCommonTick: false,
        'productDetail.actType': 9
      })
      this.initCoupon()
    } else if (info.presell) { // 预售 
      this.data.productType = 6
      this.setData({
        showCommonTick: false,
      })
      this.preSale(info.presell)
    } else if (info.groupPurchase && info.groupPurchase.length > 0) { // 拼团
      this.data.productType = 8
      this.setData({
        showCommonTick: false,
        'productDetail.actType': 8 // 拼团
      })
    } else { // 普通
      this.setData({
        'productDetail.actType': 0
      })
      this.initCoupon()
    }
  },
  getSvipLEvelOnline() { // 获取本账户的会员信息  app/information/querySVipOnlineCusInfo
    let _self = this
    User.getSvipStatus(wx.getStorageSync('cusId')).then((res) => {
      _self.setData({
        'productDetail.vipCusStatus': res.resultInfo.vipCusStatus
      })
    }).catch(e => {
      console.error('User.getSvipStatus报错---------', e);
    })
  },
  initCoupon() { // 初始化优惠券 promotion-online/online/vipActivity?cusId=
    let url = API.get_coupon + wx.getStorageSync('cusId') + '&vipCusStatus=' + this.data.productDetail.vipCusStatus
    REQUEST.get(url).then((res) => {
      // TUDO 优惠券
      const {
        msgCode,
        resultInfo
      } = res.data
      if (msgCode === 0) {
        if (resultInfo && resultInfo.length > 0) {
          let ticket = COUPON.getProductTicket(resultInfo, this.data.id)
          console.log('初始化优惠券--------------------', ticket)
          if (ticket) {
            this.setData({
              ticketImg: ticket.picUrl,
            })
            if (ticket.picUrl) {
              this.setData({
                hideCouponModal: false
              })
            }
          }
          let arr = []
          for (let i = 0; i < this.data.productDetail.products.length; i++) {
            let val = this.data.productDetail.products[i]
            let item = {
              price: val.price,
              skuName: val.skuName,
              name: this.data.productDetail.productTemplateName,
              stock: val.stock,
              transportFee: val.transportFee,
              productId: val.id,
              productTemplateId: val.productTemplateId,
              warehouseCode: this.data.productDetail.warehouseCode,
              quantity: 1,
              integralStatus: this.data.productDetail.integralStatus
            }
            arr.push(item)
          }
          let tmpResult = COUPON.getNoRepeatTickets(resultInfo, arr, this.data.id)
          this.setData({
            tickets: tmpResult.tickets
          })
          console.log('tmpResult.pIdIntergralGrade-------', tmpResult.pIdIntergralGrade)
          if (tmpResult.pIdIntergralGrade.length > 0) {
            this.setData({
              // 'productDetail.integralStatus': tmpResult.pIdIntergralGrade,
              // 'product.integralStatus': tmpResult.pIdIntergralGrade,
              pIdIntergralGrade: tmpResult.pIdIntergralGrade
            })
            // console.error('获取优惠券积分倍数product.integralStatus', tmpResult.pIdIntergralGrade)
          }
          this.getIntergral() // 获取全场的积分倍数
          // console.error(this.data.tickets, arr)
        }
      }
    })
  },
  getPriceRange(arr) { // 获取价格区间
    if (!arr) return ''
    let max = Math.max.apply(Math, arr)
    let min = Math.min.apply(Math, arr)
    if (min === max) {
      return min
    } else {
      return min + '~' + max
    }
  },
  to(str) { // 页面跳转switchTab
    wx.switchTab({
      url: str
    })
  },
  goPage(event) { // 页面跳转，首页/购物车
    switch (event.currentTarget.dataset.item) {
      case 'home':
        this.to('/pages/Home/Home');
        break;
      case 'cart':
        this.to('/pages/MyCart/MyCart');
        break;
    }
  },
  closeSku(e) { // 关闭选择商品规格弹窗
    app.globalData.selectedData = null
    this.getCartNum()
    this.setData({
      chooseSkuShow: e.detail
    })
  },
  copy(){
    let that = this
    wx.setClipboardData({
      data: that.data.taoWord,
      success (res) {
        wx.getClipboardData({
          success (res) {
            console.log(res.data) // data
            that.setData({
              copyToTaobao: false
            })
            WGCOMMON.toast('复制成功打开淘宝完成操作')
          }
        })
      }
    })

  },
  addCart(event) { // 加入购物车
    let that = this
    console.log(              that.data,
      )
    if(that.data.product.channelType == 1 && wx.getStorageSync('custChannel')==1 && wx.getStorageSync('vipCusStatus')  != 1){
      that.setData({
        copyToTaobao: true
      })
      // wx.showModal({
      //   title: '操作指引',
      //   content: '①复制链接>>②打开淘宝>>③搜索栏粘贴链接>>④点击搜索即可下单购买',
      //   confirmColor: "#ff491d",
      //   confirmText: '一键复制',
      //   success(res) {
      //     if (res.confirm) {
      //       wx.setClipboardData({
      //         data: that.data.taoWord,
      //         success (res) {
      //           wx.getClipboardData({
      //             success (res) {
      //               console.log(res.data) // data
      //               WGCOMMON.toast('复制成功打开淘宝完成操作')
      //             }
      //           })
      //         }
      //       })
      //     }
      //   }
      // })
      // return
    }else{ 
    if((this.data.id == 1727 || this.data.id == 1769 || this.data.id == 1867 || this.data.id == 1891|| this.data.id == 96) && !this.data.canBuyJinBuCard) {
      let phone = wx.getStorageSync('phone')
      wx.showModal({
        title: '哎呀，锦鲤游走啦！',
        content: `尊敬的${phone}用户,本次幸运福利与你擦肩而过了~不要灰心哦，持续关注五谷磨房，未来更多惊喜，等着花样宠你！
        Tips：若绑定的手机号与消费手机号不一致，可点击按钮解绑后重新绑定`,
        confirmColor: "#ff491d",
        confirmText: '去解绑',
        success(res) {
          if (res.confirm) {
            wx.navigateTo({
              url: '/pages/ReplacePhone/ReplacePhone'
            })
          }
        }
      })
      return
    }
    let vipCusStatus = wx.getStorageSync('vipCusStatus')
    if(this.data.product.isVipOnly == 1 && vipCusStatus != 1 && this.data.productDetail.actType != 17) {
      wx.showModal({
        title: '提示',
        content: '您还不符合购买条件，本商品仅限超级会员购买',
        confirmColor: "#ff7900",
        confirmText: vipCusStatus == 2?'立即续费':'立即开通',
        success(res) {
          if (res.confirm) {
            wx.navigateTo({ url: "/pages/superMember/superMember" })
          }
        }
      })
      return
    }
    if(this.data.id == 1586) { // 仅限新人购买
      if(this.data.xiangou1586) {
        WGCOMMON.toast('该产品仅限新人购买哦~')
        return
      }
    }
    // 新品试用
    if (this.data.noTrialAgain == 1) {
      TOAST.success('您已经申请试用过，无法再次申请了哦~')
      return false
    }

    // 秒杀
    // console.error(this.data.productDetail.actType, this.data.productDetail.isVipOnly, this.data.productDetail.vipCusStatus, event.currentTarget.dataset.type)
    if (((this.data.promotion.type === 5 && this.data.promotion.buyNow.isOutsideAble === 0) || ((this.data.productDetail.actType == 8 || this.data.productDetail.actType == 16) && this.data.productDetail.isVipOnly == 1 && event.currentTarget.dataset.type == 2)) && this.data.productDetail.vipCusStatus != 1) { // 非超级会员不得参与秒杀
      this.setData({
        showSecModal: true // 秒杀非会员不能参加提示弹窗
      })
    } else {
      if (this.data.productDetail.stock <= 0) { // 库存不足
        TOAST.success({
          title: '库存不足'
        })
        return false
      }
      if (event.currentTarget.dataset.divide == 1) { // 分期发货活动
        this.setData({
          "productDetail.isDivide": true,
          "productDetail.actType": 18
        })
      }
      if (event.currentTarget.dataset.divide == 0) { // 分期发货活动-单独买
        this.setData({
          "productDetail.isDivide": false,
          "productDetail.actType": 0
        })
      }
      this.setData({
        chooseSkuShow: true,
        'productDetail.operationType': event.currentTarget.dataset.type
      })
    }
    }
  },
  getCommentCount() { // 获取商品的第一条评论 wechat-shop-back/evaluation/listCount
    REQUEST.get(API.get_commentCount, {
      data: {
        productTemplateId: this.data.id
      }
    }).then((res) => {
      const {
        status,
        data
      } = res.data
      if (status === 0) {
        if (data.count >= 1) {
          data.orderProductEvaluation.createDate = WGFORMAT.formatDate(data.orderProductEvaluation.createDate, 'yyyy-MM-dd')
          // data.orderProductEvaluation.createDate = FILTER.dateFormat(data.orderProductEvaluation.createDate, 'yyyy-MM-dd')
        }
        this.setData({
          commentModule: data
        })
      }
    }).catch((e) => {
      console.error('API.get_commentCount报错-----------', e)
    })
  },
  goComment(event) { // 点击查看全部评价
    if (event.detail === false) {
      this.setData({
        commentListShow: false
      })
    } else {
      this.setData({
        commentListShow: true
      })
    }
    WGTRACK.logCustomEvent('click_goComment')
  },
  
  goShopCoupon() { // 优惠券列表弹窗显示
    this.setData({
      shopCouponListShow: true
    })
  },
  closeShopCouponn() { // 关闭优惠券列表弹窗
    this.setData({
      shopCouponListShow: false
    })
  },
  goCoupon() { // 优惠券列表弹窗显示
    this.setData({
      couponListShow: true
    })
  },
  closeCoupon() { // 关闭优惠券列表弹窗
    this.setData({
      couponListShow: false
    })
  },
  uploadPageTrack(type) {
    if(!isTrack) {
      isTrack = true
      WGTRACK.pageBrowse(type)
    }
  },
  groupBuy(list) { // 拼团
    let _self = this
    let st = list.startTime
    let et = list.endTime
    let actType = 8
    if (list.grouppurchaseType == 1) { // 0拼团 1团购
      actType = 16
      _self.data.productType = 10
      _self.setData({
        groupB: {
          start: list.startTime,
          end: list.endTime,
          returnType: list.returnType // 返还类型，0-不返还；1-返还现金；2-返还购物金
        }
      })
      _self.uploadPageTrack(list.returnType == 1?10:11)
      _self.isStaff()
      _self.initGroupBSwiper(list.id)
    } else {
      _self.uploadPageTrack(8)
      _self.initGroupASwiper(list.id)
      actType = 8
    }
    _self.setData({
      'productDetail.isVipOnly':list.isVipOnly,
      'productDetail.actType': actType,
      'productDetail.groupObj.id': list.id,
      'productDetail.groupGZWX': list.wxgzStatus == 1 // wxgzStatus是否关注微信公众号,0-否;1-是
    })
    _self.getServerTime().then((curTime) => {
      if (curTime >= st && curTime <= et) {
        _self.groupInit(list)
        _self.fnCountDown(et - curTime)
      }
    }).catch((e) => {})
  },
  getServerTime() { // 获取服务器时间 wechat-shop-back/preSell/info/getTime
    return new Promise((resolve, reject) => {
      REQUEST.get(API.get_serverTime).then((res) => {
        try {
          const {
            status,
            data
          } = res.data
          if (status === 0) {
            resolve(data)
          }
        } catch (e) {}
      }).catch((e) => {
        reject(e)
      })
    })
  },
  groupInit(list) { // 拼团
    let _self = this
    if (list.peopleLimit) {
      _self.setData({
        groupNum: list.peopleLimit // peopleLimit拼团人数
      })
    }
    let limit = list.purchaseLimit // 每单限购数 
    let p = list.groupPurchaseLines // 预售详情 

    if (p) { // 匹配拼团商品详情
      var arr = []
      let proDetail = _self.data.productDetail
      for (let i = 0; i < p.length; i++) {
        arr.push(p[i].purchasePrice)
        for (var j = 0; j < _self.data.productDetail.products.length; j++) {
          if (p[i].productId == _self.data.productDetail.products[j].id) {
            proDetail.products[j].groupPrice = p[i].purchasePrice
            proDetail.products[j].groupprimaryPurchasePrice = p[i].primaryPurchasePrice
            proDetail.products[j].groupLimit = limit
          }
        }
        _self.setData({
          productDetail: proDetail
        })
      }
      let price = _self.getPriceRange(arr)
      _self.setData({
        'productDetail.groupPrice': price,
        'productDetail.superPrice': FILTER.getPriceRange(arr, 0.95),
      })
    }
    _self.groupDetail(list)
  },
  groupDetail(list) { // 正在参团的用户 wechat-shop-back/groupPurchase/productTemplate/
    let _self = this
    let url = API.get_groupPurchase + list.id
    REQUEST.get(url).then((res) => {
      const {
        status,
        data
      } = res.data
      if (status == 0) {
        this.setData({
          groupPurchasePhoneList: data.groupPurchasePhoneList,
          groupPurchasePrimaryList: data.groupPurchasePrimaryList
        })
        timeData = data.groupPurchasePrimaryList
        _self.fnPurchaseListDown(data.groupPurchasePhoneList.length)

        function test() {
          for (let i = 0; i < timeData.length; i++) {
            if (timeData[i].endTime) {
              if (timeData[i].endTime <= 0) {
                return '00:00:00'
              }
              let lastTime = timeData[i].endTime / 1000
              if (lastTime < 0) {
                clearInterval(timer)
              }
              var h = Math.floor(lastTime / (60 * 60))
              var m = Math.floor(lastTime % (60 * 60) / 60)
              var s = Math.floor(lastTime % 60)
              let result = FILTER.toFixed(h) + ':' + FILTER.toFixed(m) + ':' + FILTER.toFixed(s)
              timeData[i].endTime1 = result
              timeData[i].endTime = timeData[i].endTime - 1000
            }
          }
          _self.setData({
            groupPurchasePrimaryList: timeData
          })
        }
        let timer = null
        if (timer) {
          clearInterval(timer)
        }
        timer = setInterval(test, 1000)
        this.setData({
          timer: timer
        })
        _self.fnPrimaryListLoop(data.groupPurchasePrimaryList.length)
      }
    })
  },
  getPhoneNumber(e) { // 获取当前账号手机号码
    let that = this;
    if (e.detail.errMsg === 'getPhoneNumber:ok') {
      LOADING.show({
        title: '登录中...'
      })
      WGAUTH.getPhoneNumber(e).then(res => {
        WGUSER.webLogin(res).then(data=>{
          LOADING.hide()
          let channel = wx.getStorageSync('custChannel')
          // if(that.data.product.channelType == 1 && channel == 1){
          //   // WGCOMMON.toast('本款产品暂无库存')
          //   that.setData({
          //     // showOperate: false,
          //     // chooseSkuShow: false,
          //     taoWord: that.data.taoWord
          //   })
          // }else {
            let r = this.checkLoginType()
            if (r) {
              this.setData({
                // isLogin: true,
                'productDetail.isLogin': true
              })
              this.init()
              /** e.currentTarget.dataset.type
               * -1 到货提醒/兑换提醒
               * 1 立即购买 
               */
              this.canTrialAgain()
              if (e.currentTarget.dataset.type == -1) { // 到货提醒 + 兑换提醒
                this.reserveProduct()
              } else if (e.currentTarget.dataset.type == 17) {
                this.orderSeckill()
              } else {
                if (this.data.id == 1274) {
                  this.canTrialAgain().then(r => {
                    this.addCart(e)
                  })
                } else if(this.data.id == 1727 || this.data.id == 1769 || this.data.id == 1867 || this.data.id == 1891|| this.data.id == 96) { // 用户是否可以购买五谷进补卡
                  this.checkBuyJinBuCard()
                  return
                } else {
                  this.addCart(e)
                }
              }
              if (this.data.actType == 16) {
                this.isStaff()
              }
              /** 广告行为转化 */
              let gdt = wx.getStorageSync('gdt')
              if (gdt) {
                api.clickId.upload({
                  actionType: 'RESERVATION',
                  clickId: gdt.gdt_vid,
                  actionUrl: gdt.gdt_url
                })
              }
            }
          
          // }
        // AUTH.requestUsersecret(e.detail).then((res) => {
        
        })
      })
    } else {
      console.log(e.detail.errMsg)
    }
  },
  getUserProfile(e) {
    LOADING.show()
    WGAUTH.getUserProfile().then(res => {
      LOADING.hide()
      if (this.checkLoginType()) {
        this.setData({
          // isLogin: true,
          'productDetail.isLogin': true
        })
        this.init()
        /** e.currentTarget.dataset.type
         * -1 到货提醒/兑换提醒
         * 1 立即购买 
         */
        this.canTrialAgain()
        if (e.currentTarget.dataset.type == -1) { // 到货提醒 + 兑换提醒
          this.reserveProduct()
        } else if (e.currentTarget.dataset.type == 17) {
          this.orderSeckill()
        } else {
          if (this.data.id == 1274) {
            this.canTrialAgain().then(r => {
              this.addCart(e)
            })
          } else {
            this.addCart(e)
          }
        }
        if (this.data.actType == 16) {
          this.isStaff()
        }
        /** 广告行为转化 */
        let gdt = wx.getStorageSync('gdt')
        if (gdt) {
          api.clickId.upload({
            actionType: 'RESERVATION',
            clickId: gdt.gdt_vid,
            actionUrl: gdt.gdt_url
          })
        }
      }
    })
  },
  bindgetuserinfo(e) { // 获取用户昵称信息
    LOADING.show()
    WGAUTH.getUserInfo(e).then(res => {
      LOADING.hide()
      if (this.checkLoginType()) {
        this.setData({
          // isLogin: true,
          'productDetail.isLogin': true
        })
        this.init()
        /** e.currentTarget.dataset.type
         * -1 到货提醒/兑换提醒
         * 1 立即购买 
         */
        this.canTrialAgain()
        if (e.currentTarget.dataset.type == -1) { // 到货提醒 + 兑换提醒
          this.reserveProduct()
        } else if (e.currentTarget.dataset.type == 17) {
          this.orderSeckill()
        } else {
          if (this.data.id == 1274) {
            this.canTrialAgain().then(r => {
              this.addCart(e)
            })
          } else {
            this.addCart(e)
          }
        }
        if (this.data.actType == 16) {
          this.isStaff()
        }
        /** 广告行为转化 */
        let gdt = wx.getStorageSync('gdt')
        if (gdt) {
          api.clickId.upload({
            actionType: 'RESERVATION',
            clickId: gdt.gdt_vid,
            actionUrl: gdt.gdt_url
          })
        }
      }
    })
  },
  fnCountDown(lastTime) { // 倒计时
    let _self = this
    var leftTime = lastTime / 1000
    if (leftTime > 0) {
      var timer4 = setInterval(function () {
        leftTime = leftTime - 1
        if (leftTime < 0) {
          clearInterval(timer4)
        }
        var h = Math.floor(leftTime / (60 * 60))
        var m = Math.floor(leftTime % (60 * 60) / 60)
        var s = Math.floor(leftTime % 60)
        let result = FILTER.toFixed(h) + ':' + FILTER.toFixed(m) + ':' + FILTER.toFixed(s)
        _self.setData({
          'time.groupLastTime': result
        })
      }, 1000)
      this.setData({
        timer4: timer4
      })
    }
  },
  previewImg(e) { // 预览图片，保存已选择sku
    UTIL.previewImg(e.currentTarget.dataset.url, [e.currentTarget.dataset.url])
  },
  preSale(preInfo) { // 初始化预售
    let _self = this
    _self.getServerTime().then((curTime) => {
      _self.initPre(preInfo, curTime)
    })
  },
  initPre(preInfo, curDate) { // 初始化预售
    let actType = 0
    let presellMoney = []
    let presellProductMoney = []
    let presellLines = preInfo.presellLines
    let preTime = null
    let products = this.data.productDetail.products
    for (let i = 0; i < presellLines.length; i++) {
      presellMoney.push(presellLines[i].presellMoney)
      presellProductMoney.push(presellLines[i].presellProductMoney)
      for (let j = 0; j < products.length; j++) {
        if (presellLines[i].productId == products[j].id) {
          products[j].prePrice = presellLines[i].presellMoney
          products[j].price = presellLines[i].presellProductMoney
        }
      }
    }
    if (curDate < preInfo.frontMoneyStartTime) {
      actType = 5
    } else if (curDate < preInfo.frontMoneyEndTime) {
      actType = 6
    } else {
      actType = 7
    }
    preTime = FILTER.getFullDate(preInfo.balancePaymentStartTime, true) + '-' + FILTER.getFullDate(preInfo.balancePaymentEndTime, true)
    this.setData({
      'productDetail.actType': actType,
      'productDetail.presellMoney': FILTER.getPriceRange(presellMoney),
      'productDetail.presellProductMoney': FILTER.getPriceRange(presellProductMoney),
      'productDetail.preTime': preTime,
      'productDetail.preEndTimeLabel': FILTER.getFullDate(preInfo.frontMoneyEndTime, false),
      'productDetail.products': products,
      'productDetail.superPrice': FILTER.getPriceRange(presellProductMoney, 0.95), // 超级会员：预售价 * 0.95
      'productDetail.superPrePrice': FILTER.getPriceRange(presellMoney, 0.95)
    })
  },
  goOtherDetail(e) { // 跳转到其他拼团的详情页
    wx.navigateTo({
      url: '/pages/ProductDetail/ProductDetail?pId=' + e.currentTarget.dataset.id,
    })
  },
  initOtherPurchase(id) { // 其他推荐的拼团
    let url = API.get_purchaseList + id
    REQUEST.get(url).then((res) => {
      const {
        status,
        data
      } = res.data
      if (status == 0) {
        if (data.length != 0) {
          let groupALen = 0
          let groupBLen = 0
          for (let i = 0; i < data.length; i++) {
            let _originalPriceArr = []
            let _offerPriceArr = []
            for (let j = 0; j < data[i].groupPurchaseProductList.length; j++) {
              _originalPriceArr.push(data[i].groupPurchaseProductList[j].price)
              _offerPriceArr.push(data[i].groupPurchaseProductList[j].purchasePrice)
            }
            data[i].originalPrice = FILTER.getPriceRange(_originalPriceArr)
            data[i].superPrice = FILTER.getPriceRange(_offerPriceArr, 0.95)
            data[i].offerPrice = FILTER.getPriceRange(_offerPriceArr)
            // data[i].actType = 8

            if (data[i].grouppurchaseType == 1) { // 团购
              data[i].actType = 16
              groupBLen++
            } else { // 拼团
              data[i].actType = 8
              groupALen++
            }
          }
          this.setData({
            purchaseModule: data,
            groupALen: groupALen,
            groupBLen: groupBLen
          })
        }
      }
    }).catch((e) => {})
  },
  fnPurchaseListDown(n) { // 刚刚参团动画
    let _self = this
    if (_self.data.groupPurchasePhoneList.length <= 2) return false
    if (timer2) {
      clearInterval(timer2)
    }
    let time = function () {
      if (_self.data.startIndex >= _self.data.groupPurchasePhoneList.length - 1) {
        _self.setData({
          startIndex: 0,
          translateY: 0,
          transitionDuration: '0s'
        })
        return false
      }
      _self.setData({
        translateY: -24 * (_self.data.startIndex),
        transitionDuration: '1s',
        startIndex: _self.data.startIndex + 1
      })
    }
    let timer2 = setInterval(time, 3000)
    this.setData({
      timer2: timer2
    })
  },
  closeEmpty() { // 关闭“商品已售罄或已下架提示弹窗”
    this.setData({
      empty: false
    })
  },
  showTips(event) { // 是否展示提示文案
    if (event.currentTarget.dataset.scene === 'more') {
      this.setData({
        isTips: true,
        isTips1: false
      })
    } else {
      this.setData({
        isTips: false,
        isTips1: true
      })
    }
    this.setData({
      showTips: event.currentTarget.dataset.type == '1' ? false : true
    })
  },
  showTips1(event) { // 点击拼团列表查看更多
    this.setData({
      isTips1: event.currentTarget.dataset.type == '1' ? true : false,
      isTips: event.currentTarget.dataset.type == '1' ? false : true,
      showTips: event.currentTarget.dataset.type == '1' ? true : false
    })
  },
  goDetail(event) { // 跳转至拼团详情页
    this.setData({
      showTips: false,
      isTips: false,
      isTips1: false
    })
    wx.navigateTo({
      url: '/pages/GroupDetail/GroupDetail?grouppurchaseCode=' + event.currentTarget.dataset.code
    })
  },
  fnPrimaryListLoop(n) { // 正在参团用户轮播
    if (n <= 2) return false
    let _self = this
    if (timer1) {
      clearInterval(timer1)
    }
    let time1 = function () {
      if (_self.data.startIndex1 >= n - 1) {
        _self.setData({
          startIndex1: 0,
          translateY1: 0,
          transitionDuration1: '0s'
        })
        return false
      }
      _self.setData({
        translateY1: -109 * (_self.data.startIndex1),
        startIndex1: _self.data.startIndex1 + 1,
        transitionDuration1: '1s'
      })
    }
    let timer1 = setInterval(time1, 3000)
    this.setData({
      timer1: timer1
    })
  },
  addCartFilter(event) {
    let vipCusStatus = wx.getStorageSync('vipCusStatus')
    // 购买五谷进补卡
    /**
     * 权益卡一期：1727 - 芝养卡-试点
     * 权益卡二期：1769 - 食材卡-试点
     * 权益卡三期：1867 - 特权卡-永辉撤店
     * 权益卡四期：1891 - 全国推广的芝养卡
     */
    if((this.data.id == 1727 || this.data.id == 1769 || this.data.id == 1867 || this.data.id == 1891|| this.data.id == 96) && !this.data.canBuyJinBuCard) {
      let phone = wx.getStorageSync('phone')
      wx.showModal({
        title: '哎呀，锦鲤游走啦！',
        content: `尊敬的${phone}用户,本次幸运福利与你擦肩而过了~不要灰心哦，持续关注五谷磨房，未来更多惊喜，等着花样宠你！
        Tips：若绑定的手机号与消费手机号不一致，可点击按钮解绑后重新绑定`,
        confirmColor: "#ff491d",
        confirmText: '去解绑',
        success(res) {
          if (res.confirm) {
            wx.navigateTo({
              url: '/pages/ReplacePhone/ReplacePhone'
            })
          }
        }
      }) 
      return false
    }
    if(this.data.product.isVipOnly == 1 && vipCusStatus != 1 && this.data.productDetail.actType != 17) {
      wx.showModal({
        title: '提示',
        content: '您还不符合购买条件，本商品仅限超级会员购买',
        confirmColor: "#ff7900",
        confirmText: vipCusStatus == 2?'立即续费':'立即开通',
        success(res) {
          if (res.confirm) {
            wx.navigateTo({ url: "/pages/superMember/superMember" })
          }
        }
      })
      return false
    }
    if(this.data.id == 1586) { // 仅限新人购买
      if(this.data.xiangou1586) {
        WGCOMMON.toast('该产品仅限新人购买哦~')
        return false
      }
    }
    if (this.data.noTrialAgain == 1) { // 新品试用
      TOAST.success('您已经申请试用过，无法再次申请了哦~')
      return false
    }
    if (((this.data.promotion.type === 5 && this.data.promotion.buyNow.isOutsideAble === 0) || ((this.data.productDetail.actType == 8 || this.data.productDetail.actType == 16) && this.data.productDetail.isVipOnly == 1 && event.currentTarget.dataset.type == 2)) && this.data.productDetail.vipCusStatus != 1) { // 非超级会员不得参与秒杀
      this.setData({
        showSecModal: true // 秒杀非会员不能参加提示弹窗
      })
      return false
    }
    return true
  },
  onGotUserInfo(e) { // 获取用户头像
    if (e.detail.errMsg === 'getUserInfo:ok') {
      app.globalData.userAvatarUrl = JSON.parse(e.detail.rawData).avatarUrl
      app.globalData.nickName = JSON.parse(e.detail.rawData).nickName
      WGAUTH.getUserInfo(e).then(res => {
        if (this.data.isLogin && this.addCartFilter(e)) {
          this.setData({
            chooseSkuShow: true,
            'productDetail.operationType': 2
          })
        }
        this.setData({
          isAuthorize: true
        })
        console.log('授权拿到的头像--------', app.globalData.userAvatarUrl)
      })
    }
  },
  onGotUserInfo1(e) { // 获取用户头像
    WGAUTH.getUserProfile().then(res => {
      app.globalData.userAvatarUrl = wx.getStorageSync('avatarUrl')
      app.globalData.nickName = wx.getStorageSync('nickName')
      if (this.data.isLogin && this.addCartFilter(e)) {
        this.setData({
          chooseSkuShow: true,
          'productDetail.operationType': 2
        })
      }
      this.setData({
        isAuthorize: true
      })
    })
  },
  initBuyNow(buyNow) { // 秒杀活动 - @author-wucl
    let stock = buyNow.upperLimit,
      parr = [],
      isStart = false,
      isEnd = false,
      products = []
    for (let i = 0, len = buyNow.buyNowSkus.length; i < len; i++) {
      parr.push(buyNow.buyNowSkus[i].buyNowPrice)
      buyNow.buyNowSkus[i].product.price = buyNow.buyNowSkus[i].buyNowPrice
      buyNow.buyNowSkus[i].product.stock = stock
      buyNow.buyNowSkus[i].product.purchaseLimitQuantity = buyNow.quantity
      products.push(buyNow.buyNowSkus[i].product)
    }
    this.getServerTime().then(res => {
      let now = res || new Date().getTime()
      if (now > buyNow.startTime && now < buyNow.endTime) { // 已开始但还未结束
        isStart = true
      }
      if (now > buyNow.endTime) { // 已结束
        isEnd = true
      }
      let linkId
      if (buyNow.redirectionUrl) {
        let arr1 = buyNow.redirectionUrl.split('?')
        if (arr1 && arr1.length > 1) {
          let arr2 = arr1[1].split('&')
          if (arr2) {
            let arr3 = arr2[0].split('=')
            if (arr3[0] === 'pId') {
              linkId = arr3[1]
            }
          }
        }
      }
      this.setData({
        promotion: { // 促销活动
          type: 5, // 活动类型-5秒杀
          buyNow: {
            id: buyNow.id,
            linkId: linkId,
            productTemplateId: buyNow.productTemplateId,
            price: FILTER.getPriceRange(parr), // 价格
            stock: stock, // 库存
            startTime: buyNow.startTime, // 开始时间
            endTime: buyNow.endTime, // 结束时间
            isStart: isStart,
            isEnd: isEnd,
            isOutsideAble: buyNow.isOutsideAble, // 非会员能否参与,0-否;1-是
            isOgAble: buyNow.isOgAble // 老客是否能秒杀,0-否;1-是
          }
        },
        "productDetail.isGwtStatus": buyNow.isGwtStatus,
        "productDetail.stock": stock,
        "productDetail.sold": -1,
        "productDetail.superPrice": FILTER.getPriceRange(parr, 0.95),
        "productDetail.isAddShoppingCart": 0,
        "productDetail.actType": 17,
        "productDetail.operationType": 1,
        "productDetail.products": products,
        "productDetail.buyNowId": buyNow.id,
      })
    }).catch(e => {
      console.error('getServerTime报错--------', e);
    })
    // 秒杀库存需要从接口拿
    api.promotion.getStock(buyNow.id, this.data.id).then(res => {
      console.log('秒杀的库存是', res)
      this.setData({
        'productDetail.stock': res,
        'promotion.buyNow.stock': res
      })
    })
  },
  initDivide(divide) { // 分期发货活动 - @author-wucl
    let parr = [],
      products = []
    let times = {
      min: 999,
      max: -1
    }
    let interval = {
      min: 999,
      max: -1
    }
    const sku = divide.divideDeliverySkus
    for (let i = 0, len = sku.length; i < len; i++) {
      parr.push(sku[i].deliveryPrice)
      // divide.divideDeliverySkus[i].product.price = sku[i].deliveryPrice
      products.push(sku[i].product)
      times.min = (sku[i].deliveryTimes < times.min) ? sku[i].deliveryTimes : times.min
      times.max = (sku[i].deliveryTimes > times.max) ? sku[i].deliveryTimes : times.max
      interval.min = (sku[i].deliveryInterval < interval.min) ? sku[i].deliveryInterval : interval.min
      interval.max = (sku[i].deliveryInterval > interval.max) ? sku[i].deliveryInterval : interval.max
    }
    this.setData({
      "productDetail.divideSku": divide,
      "productDetail.dividePrice": FILTER.getPriceRange(parr),
      "productDetail.superDividePrice": FILTER.getPriceRange(parr, 0.95),
      "productDetail.actType": 18,
      "productDetail.operationType": 1,
      "productDetail.products": products,
      "productDetail.divideId": divide.id,
      "productDetail.times": (times.min == times.max) ? `${times.min}` : `${times.min}~${times.max}`,
      "productDetail.interval": (interval.min == interval.max) ? `${interval.min}` : `${interval.min}~${interval.max}`
    })
  },
  initBuyCoupon(buyCoupon) { // 购买优惠券活动 - @author-wucl
    let parr = [],
      products = {}
    for (let i = 0, len = buyCoupon.buyCouponLines.length; i < len; i++) {
      parr.push(buyCoupon.buyCouponLines[i].actionPrice)
      products[buyCoupon.buyCouponLines[i].productId] = {
        price: buyCoupon.buyCouponLines[i].actionPrice,
        purchaseLimit: buyCoupon.buyCouponLines[i].purchaseLimit
      }
    }
    let oldproducts = this.data.productDetail.products
    let newproducts = []
    for (let i = 0; i < oldproducts.length; i++) {
      if (products[oldproducts[i].id]) {
        oldproducts[i].price = products[oldproducts[i].id].price
        oldproducts[i].purchaseLimitQuantity = products[oldproducts[i].id].purchaseLimit
        newproducts.push(oldproducts[i])
      }
    }
    let now = new Date().getTime()
    let isStart = false,
      isEnd = false
    if (now > buyCoupon.startTime) { // 已开始
      isStart = true
    }
    if (now > buyCoupon.endTime) { // 已结束
      isEnd = true
    }
    this.setData({
      "productDetail.price": FILTER.getPriceRange(parr),
      "productDetail.superPrice": FILTER.getPriceRange(parr, 0.95),
      "productDetail.actType": 11,
      "productDetail.products": newproducts,
      "productDetail.buyCouponId": buyCoupon.id,
      "productDetail.operationType": 1,
      "productDetail.couponType": buyCoupon.activityType,  // 优惠券类型：0线上优惠券，1线下优惠券
      promotion: { // 促销活动
        type: 11, // 活动类型-11购买优惠券
        buyCoupon: {
          isStart: isStart,
          isEnd: isEnd,
          stock: this.data.productDetail.stock
        }
      }
    })
  },
  reserveProduct() { // 到货提醒 + 兑换提醒
    WGSUBSCRIBE('remindStock').then(r => {
      if (r == 1) {
        api.product.reserve(wx.getStorageSync('openId'), this.data.id, 2, this.data.luckyDrawId, this.data.LuckyDrawCusId).then(res => {
          if (res) {
            wx.showToast({
              icon: 'none',
              title: res
            })
          }
        })
      }
    })
  },
  orderSeckill() { // 预约秒杀 
    WGSUBSCRIBE('remindSeckill').then(r => {
      if (r == 1) {
        let buyNow = this.data.promotion.buyNow

        api.seckill.order({
          buyNowId: buyNow.id,
          openId: wx.getStorageSync('openId'),
          cusId: wx.getStorageSync('cusId'),
          productTemplateId: buyNow.productTemplateId,
          source: 2 // 0公众号 1网页 2小程序
        }).then(res => {
          if (res) {
            if (res == 'novip') {
              this.setData({
                showSecModal: true
              })
            } else {
              this.setData({
                "product.buyNow.bespeakCount": res
              })
              wx.showToast({
                title: '预约成功',
                icon: 'success',
                duration: 1500
              })
            }
          }
        }).catch(e => {
          console.error('预约秒杀报错----------', e)
        })
      }
    })
  },
  showBuyCouponModal(e) { // 购买优惠券提示弹窗（活动未开始/活动已结束）
    let type = e.currentTarget.dataset.type
    if (type == 1) {
      wx.showToast({
        title: '活动未开始',
        icon: 'none',
        duration: 1500
      })
    }
    if (type == 2) {
      wx.showToast({
        title: '活动已结束',
        icon: 'none',
        duration: 1500
      })
    }
  },
  isStaff() { // 是否是营养顾问下团购单
    let cusId = wx.getStorageSync('cusId')
    if (cusId) {
      REQUEST.get(API.is_staff + cusId).then(res => {
        if (res.data.status == 0 && res.data.data) { // 营养顾问下团购单
          this.setData({
            staffId: res.data.data.userName,
            isStaffGroupB: true
          })
        }
      })
    }
  },
  initGroupBSwiper(id) {
    api.promotion.groupBSwiper(id).then(res => {
      let list = res.groupPurchasePrimaryNumList
      for (let i = 0; i < list.length; i++) {
        if (!list[i].nickName) list[i].nickName = '匿名'
        if (!list[i].evaluatorHeadImgUrl) list[i].evaluatorHeadImgUrl = 'https://img.wgmf.com/img_default1.png'
        let len = list[i].nickName.length
        if (len > 4) {
          let mid = '*****'
          if (len == 5) mid = '***'
          if (len == 6) mid = '****'
          list[i].nickName = list[i].nickName[0] + mid + list[i].nickName[len - 1]
        }
      }
      this.setData({
        swiperList: res.groupPurchasePhoneList,
        groupBList: list,
      })
    })
  },
  initGroupASwiper(id) {
    api.promotion.groupASwiper(id).then(res => {
      let list = res.groupPurchasePhoneList
      this.setData({
        swiperList: res.groupPurchasePhoneList
      })
    })
  },
  canTrialAgain() {
    // 新品试用
    return new Promise((resolve, reject) => {
      if (this.data.id == 1274 && wx.getStorageSync('cusId')) {
        REQUEST.get(API.isEverBoughtProduct + `productTemplateId=${this.data.id}&cusId=${wx.getStorageSync('cusId')}`).then(r => {
          console.log('isEverBoughtProduct', r)
          if (r.data.status == 1) { // 已经买过了
            this.setData({
              noTrialAgain: 1
            })
          }
          resolve()
        })
      } else {
        resolve()
      }
    })
  },
  initImgBorder(whiteBannerImg) { // 初始化活动图片外框-轮播图首张图加外壳
    api.modules.imgBorder().then(res => {
      // this.data.borderImgs = res
      let val = 0
      switch(this.data.productType) {
        case 0: val = 1; break;
        case 1: val = 2; break;
        case 2: val = 3; break;
        case 3: val = 6; break;
        case 4: val = 7; break;
        case 5: val = 8; break;
        case 6: val = 4; break;
        case 7: val = 7; break;
        case 8: val = 5; break;
        case 10: val = 5; break;
        default: val = -1; break;
      }
      // this.data.imgBorder = val > 0?res[val - 1].sUrl:''
      this.setData({
        imgBorder: val > 0?res[val - 1].sUrl:'',
        whiteBannerImg: whiteBannerImg // 轮播白底图
      })
      console.log('imgBorder************************', this.data.imgBorder)
    }).catch(() => {})
  },
  checkBuyJinBuCard() { // 检查用户是否有资格购买五谷进补卡
    if(wx.getStorageSync('cusId')) {
      WGHTTP.get('app/checkCardTargetCus?cusId=' + wx.getStorageSync('cusId')).then(res => {
        this.setData({
          canBuyJinBuCard: (this.data.id == 1867)?res.showFlagSpec:res.showFlag // 权益卡三期 & 一期二期四期
        })
      })
    }
  },
  jumpToLottery(){
    //跳转到抽奖H5
    wx.navigateTo({
      url: '/pages/HowBeGold/HowBeGold?type=6'
    })
  },
  initSaveCard(options, cusId) { // 省钱卡
    if(options.shareCusId) {
      this.setData({
        referrerCustomerId: options.shareCusId
      })
    }
    if(cusId && options.pId == 2081) {
      api.promotion.isBuyCard(cusId).then(res => {
        if(res && res.isBuyCard == 1) { // 已经购买了省钱卡
          wx.redirectTo({
            url: '/modules/MallPromotion/pages/SaveMoneyCard/SaveMoneyCard'
          })
        }
      })
    }
  },
  linkToPage(e) {
    if(this.data.goLiveInfo == true) {
      wx.openChannelsLive({
        finderUserName: 'sphmTN8rmxUL5cq',
        feedId: this.data.getChannelsLiveInfoRes.feedId,
        nonceId: this.data.getChannelsLiveInfoRes.nonceId,
        success(_res) {
          console.log(_res)
        },
        fail(_res) {
          console.log('跳转视频号失败',_res)
        }
      })
    }
  },
  getChannelsLiveInfo(){
    let that = this
    wx.getChannelsLiveInfo({
      finderUserName: 'sphmTN8rmxUL5cq',
      success(res) {
        console.log(res)
        if(res.status == 2) {
          //直播中
          that.setData({
            goLiveInfo: true,
            getChannelsLiveInfoRes: res
          })
          
        } else if (res.status == 3) {
          console.log('直播已结束', res)
          //直播已结束
          that.setData({
            goLiveInfo: false,
            getChannelsLiveInfoRes: res
          })
        } else {
          // wx.showToast({
          //   icon: 'none',
          //   title: '当前暂无直播',
          //   duration: 1500
          // })
        }
      },
      fail(res) {
        console.log('视频号直播信息获取失败',res)
      }
    })
  },
}
Page({
  data,
  ...methods,
  onLoad: function (query) {
    // 判断渠道
    console.log(wx.getStorageSync('custChannel'))
    if(wx.getStorageSync('custChannel') === ''){
      WGAUTH.wxLogin().then(()=>{
        WGUSER.queryChannel()
      })
    }
    if (query.luckyDrawId) { //抽奖小程序进入
      this.setData({
        luckyDrawId: query.luckyDrawId || '',
        LuckyDrawCusId: query.cusId || ''
      })
    }
    if(query.noShare) { // 禁止转发分享
      wx.hideShareMenu()
      wx.updateShareMenu({
        withShareTicket: true,
        isPrivateMessage: true,
      })
    }
    this.data.shareTitle = query.shareTitle ? query.shareTitle : '' // 自定义了转发标题
    this.data.shareCover = query.shareCover ? query.shareCover : '' // 自定义转发封面
    isTrack = false
    /** 显示收藏弹窗 */
    if (!wx.getStorageSync('fav-modal')) {
      this.setData({
        showFavModal: true
      })
      wx.setStorageSync("fav-modal", 1)
    }

    /** 广告进入click_id */
    if (query.gdt_vid) {
      let pages = getCurrentPages()
      let currentPage = pages[pages.length - 1]
      let options = currentPage.options
      let optionsStr = ''
      for (let key in options) {
        optionsStr += `${key}=${options[key]}&`
      }
      let gdt = {
        pid: query.pId, // 产品id
        gdt_vid: query.gdt_vid, // 广告id
        gdt_url: currentPage.route + '?' + optionsStr.substr(0, optionsStr.length - 1) // 当前页面url
      }
      wx.setStorageSync('gdt', gdt)
    } else {
      wx.removeStorageSync('gdt')
    }

    let {
      pId
    } = query
    let {
      _campaign
    } = query

    this.setData({
      id: parseInt(pId)
    })
    var that = this
    that.setData({
      _campaign: typeof Number(_campaign) == 'number' && _campaign && _campaign.length == 4 ? _campaign : '0000',
    })
    // zj.init(app.globalData.secretId, app.globalData.secretKey) //初始化
 
    // 团购产品  2039, 1974, 1572, 1965, 2133, 2185  限制开团，不显示购买栏
    let noShowOperatePids = [ 964, 285, 1534, 1447, 1574, 1584, 1678, 1662, 1233, 1434, 2185 ] // 不显示购买栏的产品
    if (noShowOperatePids.indexOf(parseInt(pId)) != -1) { // 超级会员开卡礼盒
      this.setData({
        showOperate: false
      })
    }
    if(query.noBuy) { // 不让购买
      this.setData({
        showOperate: false
      })
    }
    //拿到分享人工号,存入本地
    this.canTrialAgain()
    staffShare.setShareStaffIdByShare(query)
    if (query.orderAttribution) { // 谷粉说产品来源标志
      let valid = 1 * 24 * 60 * 60 // 24小时有效
      let now = (new Date().getTime()) / 1000
      let orderAttribution = {}
      if (wx.getStorageSync('orderAttribution')) {
        orderAttribution = JSON.parse(wx.getStorageSync('orderAttribution'))
      }
      orderAttribution[query.pId.toString()] = {
        expiresTime: valid + now,
        referer: query.orderAttribution
      }
      wx.setStorageSync('orderAttribution', JSON.stringify(orderAttribution))
    }

    if(pId == 1586 && wx.getStorageSync('cusId')) {
      WGHTTP.get(`/wechat-shop-back/order/getByopenId?cusId=${wx.getStorageSync('cusId')}`, null, 'json', 1).then(res => {
        this.data.xiangou1586 = res.status == 1?true:false
      })
    }

    try {   
      wx.onCopyUrl(() => {
        return { query: WGFORMAT.formatQueryByOptions(query) }
      })
    } catch (error) {
      console.warn('暂不支持wx.onCopyUrl')
    }
    if (wx.getUserProfile) {
      this.setData({
        canIUseGetUserProfile: true
      })
    }
    this.initSaveCard(query, wx.getStorageSync('cusId'))
  },
  onShow: function () {
    LOADING.show()
    this.checkLoginType()
    if (this.data.promotion.type == 9) {
      this.setData({
        "productDetail.actType": 18
      })
    }
    this.init(this.data.id)
    this.setData({
      allShow: true
    }, () => {
      LOADING.hide()
    })
    this.getCartNum()
    let pId = this.data.id
    if(parseInt(pId) == 1727 || parseInt(pId) == 1769 || parseInt(pId) == 1867 || parseInt(pId) == 1891 || parseInt(pId) == 96) {  // 五谷进补卡
      this.checkBuyJinBuCard()
    }
    if(parseInt(pId) ==2528 ){
      //pid 2528 展示特定抽奖图片
      this.setData({
        "isLottery": true
      })
    }
    this.getChannelsLiveInfo() 
  },
  onHide: function () {
    clearInterval(this.data.timer)
    clearInterval(this.data.timer1)
    clearInterval(this.data.timer2)
    clearInterval(this.data.timer4)
  },
  onShareAppMessage: function (res) { // 自定义点击右上角转发内容
    let shareUrl = this.data.product.groupedImages.banner[0].imageUrl
    if(parseInt(this.data.id) == 1790) {
      shareUrl = 'https://img.wgmf.com/wgmall/shareImg.jpg'
    }
    shareUrl = this.data.shareCover ? this.data.shareCover : shareUrl
    let shareTitle = this.data.shareTitle ? this.data.shareTitle : (this.data.product.productWeshare.title ? this.data.product.productWeshare.title : this.data.product.productTemplateName)
    return {
      title: shareTitle,
      path: `/pages/ProductDetail/ProductDetail?pId=${this.data.id}&${staffShare.getShareParams()}`,
      imageUrl: shareUrl
    }
  },
  onShareTimeline() { // 分享朋友圈
    let shareUrl = this.data.product.groupedImages.banner[0].imageUrl
    if(parseInt(this.data.id) == 1790) {
      shareUrl = 'https://img.wgmf.com/wgmall/shareImg.jpg'
    }
    shareUrl = this.data.shareCover ? this.data.shareCover : shareUrl
    let shareTitle = this.data.shareTitle ? this.data.shareTitle : (this.data.product.productWeshare.title ? this.data.product.productWeshare.title : this.data.product.productTemplateName)
    return {
      title: shareTitle,
      path: `/pages/ProductDetail/ProductDetail?pId=${this.data.id}&${staffShare.getShareParams()}`,
      imageUrl: shareUrl
    }
  },
  onUnload: function () {
    clearInterval(this.data.timer)
    clearInterval(this.data.timer1)
    clearInterval(this.data.timer2)
    clearInterval(this.data.timer4)
  },
  onPullDownRefresh() { // 下拉刷新
    this.setData({
      isRefresh: true
    })
    LOADING.show()
    this.checkLoginType()
    if (this.data.promotion.type == 9) {
      this.setData({
        "productDetail.actType": 18
      })
    }
    this.init(this.data.id)
    this.setData({
      allShow: true
    }, () => {
      LOADING.hide()
    })
    this.getCartNum()
  }
})