import api from '../../api/index'
import {
  LOADING
} from '../../utils/index'
import {
  WGAUTH,
  WGSUBSCRIBE,
  WGROUTER,
  Page
} from '../../wgUtils/index';
const app = getApp()

Page({
  data: {
    templateProduct: null,
    selectedSku: null,
    isLogin: false
  },
  initData(pId) {
    api.product.detail(pId).then(r => {
      this.setData({
        templateProduct: r
      })
      wx.setNavigationBarTitle({
        title: '降价提醒 - ' + r.productTemplateName
      })
    })
  },
  getPhoneNumber(e) {
    if (e.detail.errMsg === 'getPhoneNumber:ok') {
      LOADING.show({
        title: '登录中...'
      })
      WGAUTH.getPhoneNumber(e).then(res => {
        // AUTH.requestUsersecret(e.detail).then((res) => {
        LOADING.hide()
        this.setData({
          isLogin: true
        })
        this.submit()
      })
    }
  },
  submit() {
    if (this.data.selectedSku) {
      WGSUBSCRIBE('remindPrice').then(res => {
        if (res == 1) {
          api.product.priceReduction({
            openId: wx.getStorageSync('openId'),
            cusId: wx.getStorageSync('cusId'),
            productId: this.data.selectedSku.id,
            productTemplateId: this.data.selectedSku.productTemplateId,
            price: this.data.selectedSku.price,
            source: 2
          }).then(r => {
            if (r) {
              wx.showToast({
                icon: 'none',
                title: r.msg,
                duration: 1500
              })
              setTimeout(function () {
                WGROUTER.navigateBack()
              }, 1500)
            }
          })
        }
      })
    } else {
      wx.showToast({
        title: '请选择规格',
        icon: 'none',
        duration: 1500
      })
    }
  },
  selected(e) {
    let item = e.currentTarget.dataset.item
    this.setData({
      selectedSku: item
    })
  },
  onLoad(option) {
    if (wx.getStorageSync('cusId')) {
      this.setData({
        isLogin: true
      })
    }
    this.initData(option.pId)
  },
})