import {
  REQUEST,
  API,
  TOAST,
  LOADING
} from '../../utils/index'
import {
  Page
} from '../../wgUtils/index';
const app = getApp()
const data = {
  listShow: false,
  logisticsList: [
    '请选择物流公司',
    'EMS',
    '韵达快递',
    '圆通速递',
    '申通速递',
    '百世快递',
    '天天快递',
    '中通快递',
    '顺丰速递',
    '全峰快递',
    '宅急送'
  ],
  index: 0,
  formInfo: {
    deliveryPartyName: '',
    shipmentCode: 0
  }
}
const methods = {
  onInputBlur(e) { // 物流单号
    this.setData({
      'formInfo.shipmentCode': e.detail.value
    })
  },
  listenerPickerSelected(e) { // 选择物流方式
    this.setData({
      index: e.detail.value,
      'formInfo.deliveryPartyName': this.data.logisticsList[e.detail.value]
    })
  },
  submit() {
    if (!this.data.formInfo.shipmentCode) {
      TOAST.success({
        title: '请填写物流单号'
      });
      return
    } else if (this.data.index == 0) {
      TOAST.success({
        title: '请选择物流方式'
      });
      return
    } else {
      LOADING.show({
        title: '数据提交中...'
      })
      let params = Object.assign(this.data.formInfo, app.globalData.returnFormDetail)
      REQUEST.post(API.returned_order, {
        data: params,
        header: {
          'content-type': 'application/json'
        }
      }).then((res) => {
        LOADING.hide()
        if (res.data.status == 0) {
          TOAST.success({
            title: '您已成功提交退货信息，我们收到包裹，核实无误后，将会给您退款！'
          }).then(() => {
            if (this.data.origin == 'detail') { // from detail
              wx.navigateTo({
                url: '/pages/OrderDetail/OrderDetail?billId=' + this.data.billId
              })
            } else { // from list
              wx.navigateBack()
            }
          })
        } else {
          TOAST.warning({
            title: '操作失败'
          })
        }
      }).catch(() => {})
    }
  }
}
Page({
  data,
  ...methods,
  onLoad: function (options) {
    wx.hideShareMenu()
    this.setData({
      billId: options.billId,
      origin: options.origin ? options.origin : ''
    })
  }
})