import {
  REQUEST,
  API,
  TOAST,
  LOADING
} from '../../utils/index.js'
import qiniuUploader from '../../utils/qiniuUploader.js'
import {
  WGSUBSCRIBE,
  Page
} from '../../wgUtils/index'
import api from '../../api/index';

const app = getApp()
let sortNum = 1
const methods = {
  chooseReason(e) {
    let index = e.currentTarget.dataset.index
    let reason = (this.data.requestType == 1) ? this.data.reason1[index] : this.data.reason2[index]
    this.setData({
      checkedIndex: index,
      reason: reason,
      checkedType: this.data.requestType,
    })
    var that = this
    setTimeout(function () {
      that.setData({
        hideReasonModal: true
      })
    }, 400)
    console.log('原因类型', this.data.requestType)
    console.log('原因描述', reason)
  },
  chooseType(e) {
    let type = e.currentTarget.dataset.type
    this.setData({
      hideReasonModal: false,
      requestType: type
    })
  },
  closeModal() {
    this.setData({
      hideReasonModal: true
    })
  },
  setJifenTipModal() {
    // wx.showModal({
    //   // title: '提示',
    //   content: '本次退款需扣除X积分，您的积分不足，无法全额退款，您可以选择：1. 申请少退（X/比例）元2. 申请全额退款，待积分充足时到账如有疑问，请联系商城客服哦~',
    //   cancelText: '积分充足再退',
    //   confirmText: '部分退款',
    //   success (res) {
    //     if (res.confirm) {
    //       console.log('用户点击确定')
    //     } else if (res.cancel) {
    //       console.log('用户点击取消')
    //     }
    //   }
    // })
  },
  init(refundDetail) {
    console.log('退款明细-------------', refundDetail)
    if (refundDetail) {
      let params = []
      for (let i = 0; i < refundDetail.length; i++) {
        refundDetail[i].index = i
        refundDetail[i].requestImages = []
        refundDetail[i].requestDesc = ''
        params.push({
          customerId: '',
          cusId: wx.getStorageSync('cusId')
        })
      }
      this.setData({
        params: params,
        refundDetail: refundDetail[0]
      })
    }
  },
  initOrder(orderId, orderCode) {
    api.order.detail(orderId).then(res => {
      if (res.gwtOrderDetail.length > 0) {
        console.log('此订单获得了购物金')
        this.setData({
          showGwjTip: true
        })
      } else {
        console.log('此订单没有获得购物金')
        this.setData({
          showGwjTip: false
        })
      }
    })
    api.user.info().then(res => {
      console.log(`我有${res.validPoint}个积分`)
      this.setData({
        myIntegral: res.validPoint
      })
    })
    api.order.integral(orderCode).then(res => {
      console.log(`此订单赠送了${res}个积分`)
      this.setData({
        returnJifen: res
      })
    })
  },
  uptokenFun() {
    REQUEST.get(API.uptoken_fun).then((res) => {
      this.setData({
        token: res.data.retInfo
      })
    })
  },
  myFn(filePath) {
    let that = this
    return new Promise((resolve, reject) => {
      qiniuUploader.upload(filePath, (res) => {
        resolve(that.data.domain + res.retInfo)
      }, (error) => {
        reject(error)
        console.error('qiniuUploader.upload报错------------' + error)
      }, {
        region: 'ECN',
        domain: that.data.domain,
        uptoken: that.data.token // 由其他程序生成七牛 uptoken
      })
    })
  },
  chooseImg(e) {
    let that = this
    let refundDetail = that.data.refundDetail
    let oldVal = that.data.refundDetail.requestImages ? that.data.refundDetail.requestImages : []
    let newVal = 'refundDetail.requestImages'
    wx.chooseImage({
      count: 5,
      success: function (res) {
        for (let i = 0; i < res.tempFilePaths.length; i++) {
          that.myFn(res.tempFilePaths[i]).then((url) => {
            let item = {
              imgUrl: url,
              sortingOrder: sortNum++
            }
            oldVal.push(item)
            that.setData({
              [newVal]: oldVal
            })
          })
        }
      }
    })
  },
  uploadImg(filePath) {
    let that = this
    return new Promise((resolve, reject) => {
      qiniuUploader.upload(filePath, (res) => {
        resolve(that.data.domain + res.retInfo)
      }, (error) => {
        reject(error)
        console.error('qiniuUploader.upload报错----------' + error)
      }, {
        region: 'ECN',
        domain: that.data.domain,
        uptoken: that.data.token // 由其他程序生成七牛 uptoken
      })
    })
  },
  del(e) { // 删除图片
    let refundDetail = this.data.refundDetail
    if (e.currentTarget.dataset.index == 0) {
      refundDetail.requestImages = []
    } else {
      refundDetail.requestImages.splice(e.currentTarget.dataset.index, 1)
    }
    let changeVal = 'refundDetail.requestImages'
    this.setData({
      [changeVal]: refundDetail.requestImages
    })
  },
  onTextAreaBlur(e) { // 评论
    let refundDetail = this.data.refundDetail
    let changeVal = 'refundDetail.requestDesc'
    this.setData({
      [changeVal]: e.detail.value
    })
  },
  sureSubmit(e) {
    console.log(`选择的退款类型${e.currentTarget.dataset.type}`) // 1部分退款,2积分充足再退
    this.setData({
      hadChoose: true,
      showJifenTip: false
    })
    this.submit(e.currentTarget.dataset.type)
  },
  submit(submitType) { // 提交
    let _self = this
    let refundDetail = _self.data.refundDetail
    if (_self.data.checkedType == 0) {
      TOAST.success({
        title: '请选择售后类型'
      })
      return false
    }
    if (_self.data.checkedIndex == -1) {
      TOAST.success({
        title: '请选择售后原因'
      })
      return false
    }
    if ((this.data.myIntegral < this.data.returnJifen) && !this.data.hadChoose && this.data.returnJifen > 0) { // 退款积分不足
      this.setData({
        showJifenTip: true
      })
      return false
    }
    let params = {
      requestImages: []
    }
    /**
     * requestDesc (string, optional): 问题描述 ,
     * requestImages (Array[], optional): 申请图片 ,
     * requestReason (string, optional): 售后原因 ,
     * requestType (integer, optional): 售后类型, 1 退货退款 2 退款 
     * */
    params.requestType = _self.data.checkedType
    params.orderDetailId = _self.data.orderDetailId
    params.orderId = _self.data.orderId
    params.customerId = wx.getStorageSync('cusId')
    params.requestDesc = refundDetail.requestDesc
    params.requestImages = refundDetail.requestImages
    params.requestReason = _self.data.reason
    params.requestState = parseInt(submitType ? submitType : 0)
    console.log('API.refund退款提交参数-------', params)
    WGSUBSCRIBE('refund').then(result => {
      LOADING.show({
        title: '数据提交中'
      })
      setTimeout(function () {
        REQUEST.post(API.refund, {
          data: params,
          header: {
            'content-type': 'application/json'
          }
        }).then((res) => {
          if (res.data.status == 0) {
            LOADING.hide()
            TOAST.success({
              title: '您已成功申请售后，我们的客服将在3个工作日内处理您的申请'
            }).then(() => {
              if (_self.data.origin == 'detail') {
                wx.navigateTo({
                  url: '/pages/OrderDetail/OrderDetail?billId=' + _self.data.orderId,
                })
              } else {
                wx.navigateBack()
              }
            })
          } else {
            LOADING.hide()
            TOAST.success({
              title: res.data
            })
          }
        })
      }, 100)
    })
  }
}
Page({
  data: {
    refundDetail: [{
      evaluationImages: []
    }],
    types: '请选择处理方式',
    requestType: 0,
    token: '',
    domain: 'https://img.wgmf.com/',
    reason1: ['商品质量问题', '商家少发/漏发', '包装/商品破损', '商家错发商品', '发票问题', '商品过期/临期', '客服问题', '其他'],
    reason2: ['拍错/多拍/不想要', '未按约定时间发货', '货物拒签', '快递一直未送达', '快递无跟踪记录', '空包裹/少件', '商家无法配送，联系我取消', '其他'],
    checkedIndex: -1, // 已选原因下标
    checkedType: 0, // 已选原因类型  1退回退款 2退款
    hideReasonModal: true,
    showGwjTip: false,
    hadChoose: false,
    showJifenTip: false, // 显示积分不足退款弹窗提示
    returnJifen: 0, // 退款需要返回的积分
    myIntegral: 0, // 我的积分
  },
  ...methods,
  onLoad: function (options) {
    wx.hideShareMenu()
    this.setData({
      orderDetailId: options.orderDetailId,
      orderId: options.orderId,
      origin: options.origin || ''
    })
    this.init(app.globalData.refundDetail)
    this.initOrder(options.orderId, options.orderCode)
    this.uptokenFun()
  },
  onShareAppMessage: function () {}
})