import {
  API,
  REQUEST,
  LOADING,
  TOAST
} from '../../utils/index'
import {
  Page
} from '../../wgUtils/index';
const methods = {
  saveToAlbum() {
    wx.canvasToTempFilePath({
      x: 0,
      y: 0,
      width: 500,
      height: 750,
      destWidth: 2000,
      destHeight: 3000,
      canvasId: 'share-canvas',
      quality: 1,
      success(res) {
        wx.saveImageToPhotosAlbum({
          filePath: res.tempFilePath,
          success(res) {
            TOAST.success({
              title: '保存成功！'
            })
          }
        })
      }
    })
  },
  getQrcode() {
    return new Promise((resolve, reject) => {
      let _self = this
      let scene = 'code=' + _self.data.grouppurchaseCode
      REQUEST.post(API.post_createQrcode + '?appId=wx29d1ac1fcd50aeb6', {
        header: {
          'content-type': 'application/json'
          // 'content-type': 'text/plain'
        },
        data: {
          page: "pages/GroupDetail/GroupDetail",
          scene: scene
        },
        // data: JSON.stringify({
        //   "path": "pages/GroupDetail/GroupDetail",
        //   "scene": scene
        // })
      }).then((res) => {
        if (res.data.msgCode == 0) {
          _self.setData({
            qrcodeUrl: res.data.resultInfo
          })
          resolve(res.data)
        } else {
          TOAST.warning({
            title: res.data.errmsg
          })
          LOADING.hide()
          reject(res.data)
        }
      }).catch((e) => {
        reject(e)
      })
    })
  },
  goOtherMiniProgram() {
    wx.navigateToMiniProgram({
      appId: 'wx29d1ac1fcd50aeb6',
      path: 'pages/Home/Home',
      extraData: {
        foo: 'bar'
      },
      envVersion: 'release',
      success(res) {
        // 打开成功
      }
    })
  },
  drawText(ctx, str, leftWidth, initHeight, canvasWidth, types, lines) {
    var lineWidth = 0;
    var lastSubStrIndex = 0; //每次开始截取的字符串的索引
    var num = 1
    var left = types ? 9 : 11
    if (types) { // 分享主题
      var titleHeight1 = Math.ceil(str.length / (this.data.canvasWidth * 0.916 / 13)) <= 2 ? (Math.ceil(str.length / (this.data.canvasWidth * 0.916 / 13)) * 13) : (2 * 13)
      this.setData({
        titleHeight1: titleHeight1
      })
    } else { // 产品名称,大于三行显示...
      var titleHeight = (Math.ceil(str.length / (this.data.canvasWidth * 0.916 / 14))) <= 3 ? (Math.ceil(str.length / (this.data.canvasWidth * 0.916 / 14)) * 16) : (3 * 16)
      this.setData({
        titleHeight: titleHeight
      })
    }
    for (let i = 0; i < str.length; i++) {
      lineWidth += ctx.measureText(str[i]).width;
      if (lineWidth > canvasWidth) {
        ctx.fillText(str.substring(lastSubStrIndex, i), leftWidth, initHeight)
        initHeight += (types ? 13 : 16)
        lineWidth = 0;
        lastSubStrIndex = i;
        num++
      } else {
        ctx.fillText(str.substring(lastSubStrIndex, i), leftWidth, initHeight)
        if (num >= lines && (lineWidth > (canvasWidth - 26))) {
          ctx.fillText('...', canvasWidth - left, initHeight)
          lineWidth = 0
          num = 0
          return
        }
      }
      if (i == str.length - 1) { //绘制剩余部分
        ctx.fillText(str.substring(lastSubStrIndex, i + 1), leftWidth, initHeight);
      }
    }
  },
  /**
   * 
   * @param {CanvasContext} ctx canvas上下文
   * @param {number} x 圆角矩形选区的左上角 x坐标
   * @param {number} y 圆角矩形选区的左上角 y坐标
   * @param {number} w 圆角矩形选区的宽度
   * @param {number} h 圆角矩形选区的高度
   * @param {number} r 圆角的半径
   */
  roundRect(ctx, x, y, w, h, r) { // 开始绘制
    ctx.beginPath() // 因为边缘描边存在锯齿，最好指定使用 transparent 填充
    // 这里是使用 fill 还是 stroke都可以，二选一即可
    ctx.setFillStyle('#F8493D') // 
    // 左上角
    ctx.arc(x + r, y + r, r, Math.PI, Math.PI * 1.5) // border-top
    ctx.moveTo(x + r, y)
    ctx.lineTo(x + w - r, y)
    ctx.lineTo(x + w, y + r) // 右上角
    ctx.arc(x + w - r, y + r, r, Math.PI * 1.5, Math.PI * 2)

    // border-right
    ctx.lineTo(x + w, y + h - r)
    ctx.lineTo(x + w - r, y + h) // 右下角
    ctx.arc(x + w - r, y + h - r, r, 0, Math.PI * 0.5)

    // border-bottom
    ctx.lineTo(x + r, y + h)
    ctx.lineTo(x, y + h - r) // 左下角
    ctx.arc(x + r, y + h - r, r, Math.PI * 0.5, Math.PI)

    // border-left
    ctx.lineTo(x, y + r)
    ctx.lineTo(x + r, y) // 这里是使用 fill 还是 stroke都可以，二选一即可，但是需要与上面对应
    ctx.fill()
    ctx.closePath() // 剪切
  },
  getImageInfo(url, type) {
    return new Promise((resolve, reject) => {
      wx.getImageInfo({
        src: url,
        success: (res) => {
          if (!type) {
            this.setData({
              productIconUrl: res.path
            })
          } else {
            this.setData({
              qrcodeUrl: res.path
            })
          }
          resolve()
        },
        fail: (res) => {
          reject(res)
        }
      })
    })
  },
  draw(data) {
    let _self = this
    _self.getImageInfo(_self.data.productIcon, 0).then(() => {
      _self.getImageInfo(data.resultInfo, 1).then(() => {
        wx.getSystemInfo({
          success: function (res) {
            _self.setData({
              canvasHeight: res.windowWidth,
              canvasWidth: res.windowWidth * 0.66
            })
            const ctx = wx.createCanvasContext('share-canvas', this)
            ctx.drawImage('https://img.wgmf.com/ma-shop/box_share_pt_xyh_3.png?imageslim', 0, 0, _self.data.canvasWidth, _self.data.canvasHeight)
            ctx.drawImage(_self.data.productIconUrl, _self.data.canvasWidth * 0.04, _self.data.canvasHeight * 0.174, _self.data.canvasWidth * 0.92, _self.data.canvasWidth * 0.92 * 0.50)
            ctx.setFillStyle('#333333')
            ctx.setFontSize(14)
            const mearText = ctx.measureText(_self.data.productTemplateName).width
            const multip = (_self.data.canvasWidth * 0.916 / 14)
            _self.drawText(ctx, _self.data.productTemplateName, _self.data.canvasWidth * 0.04, _self.data.canvasHeight * 0.55, _self.data.canvasWidth * 0.88, 0, 3);
            ctx.setFillStyle('#F8493D')
            // ctx.fillRect(_self.data.canvasWidth * 0.04, _self.data.canvasHeight * 0.54 + _self.data.titleHeight, _self.data.canvasWidth * 0.12, _self.data.canvasHeight * 0.034)
            _self.roundRect(ctx, _self.data.canvasWidth * 0.04, _self.data.canvasHeight * 0.54 + _self.data.titleHeight, _self.data.canvasWidth * 0.12, _self.data.canvasHeight * 0.034, 2)
            ctx.setFillStyle('#ffffff')
            ctx.setFontSize(8)
            ctx.setLineWidth(0.4)
            ctx.fillText('拼团价', _self.data.canvasWidth * 0.05, _self.data.canvasHeight * 0.54 + _self.data.titleHeight + _self.data.canvasHeight * 0.026)
            ctx.setFillStyle('#FF3600')
            ctx.setFontSize(12)
            let unitWidth = ctx.measureText('¥').width
            ctx.fillText('¥', _self.data.canvasWidth * 0.04, _self.data.canvasHeight * 0.55 + _self.data.titleHeight + 33)
            ctx.setFillStyle('#FF3600')
            ctx.setFontSize(14)
            let priceWidth = ctx.measureText(_self.data.groupPrice).width
            ctx.fillText(_self.data.groupPrice, _self.data.canvasWidth * 0.04 + unitWidth, _self.data.canvasHeight * 0.55 + _self.data.titleHeight + 33)
            ctx.setFillStyle('#999999')
            ctx.setFontSize(9)
            ctx.fillText('￥' + _self.data.price, _self.data.canvasWidth * 0.04 + unitWidth + priceWidth + 6, _self.data.canvasHeight * 0.55 + _self.data.titleHeight + 33)
            let priceWidth1 = ctx.measureText(_self.data.price).width
            ctx.beginPath()
            ctx.setLineWidth(1)
            ctx.setStrokeStyle('#999999')
            ctx.moveTo(_self.data.canvasWidth * 0.04 + unitWidth + priceWidth + 6, _self.data.canvasHeight * 0.55 + _self.data.titleHeight + 30)
            ctx.lineTo(_self.data.canvasWidth * 0.04 + unitWidth + priceWidth + 6 + priceWidth1 + 10, _self.data.canvasHeight * 0.55 + _self.data.titleHeight + 30)
            ctx.stroke()
            // ctx.fillText('', _self.data.canvasWidth * 0.04 + unitWidth + priceWidth + 6, _self.data.canvasHeight * 0.55 + _self.data.titleHeight + 33)
            ctx.setFillStyle('#999999')
            ctx.setFontSize(9)
            _self.drawText(ctx, _self.data.shareTitle, _self.data.canvasWidth * 0.04, _self.data.canvasHeight * 0.55 + _self.data.titleHeight + 56, _self.data.canvasWidth * 0.5, 1, 2)
            ctx.drawImage(_self.data.qrcodeUrl, _self.data.canvasWidth * 0.712, _self.data.canvasHeight * 0.54 + _self.data.titleHeight, _self.data.canvasWidth * 0.24, _self.data.canvasWidth * 0.24)
            ctx.setFillStyle('#999999')
            ctx.setFontSize(9)
            ctx.fillText('扫描/长按识别', _self.data.canvasWidth * 0.712, _self.data.canvasHeight * 0.54 + _self.data.titleHeight + _self.data.canvasWidth * 0.24 + 14)
            ctx.draw()
            LOADING.hide()
          },
        })
      })
    })
  }
}
Page({
  data: {
    canvasWidth: 100,
    canvasHeight: 1500,
    productInfo: Object,
    groupPurchase: Object,
    productTemplateName: '',
    productIcon: '',
    groupPrice: '',
    price: '',
    shareTitle: '',
    titleHeight: 0,
    titleHeight1: 0
  },
  ...methods,
  onLoad: function (options) {
    let _self = this
    this.setData({
      productTemplateName: options.productTemplateName,
      productIcon: options.productIcon,
      groupPrice: options.groupPrice,
      price: options.price,
      shareTitle: options.shareTitle,
      grouppurchaseCode: options.grouppurchaseCode,
      origin: options.origin
    }, () => {
      LOADING.show()
      _self.getQrcode().then((res) => {
        _self.draw(res)
      })
    })
  },
  onReady: function (e) {

  },
  onShow: function () {

  },
  onHide: function () {

  },
  onUnload: function () {

  },
  onPullDownRefresh: function () {

  },
  onReachBottom: function () {

  }
})