//Page Object
import api from '../../api/index'
import {
  Page, WGFORMAT
} from '../../wgUtils/index';
const app = getApp()
Page({
  data: {
    id: null,
    array: [],
    index: 0,
    info: null,
    isShowFooter: false, 
    isLimtFri: false, // 是否仅限周五
    fridayArr: [],
    dateIndex: 0,
  },
  updateDateFirDay(e) {
    this.updateDate({ detail: { value: this.data.fridayArr[e.detail.value] } })
  },
  updateDate(e) {
    let date = e.detail.value
    api.installment.updateDate(this.data.info.id, {
      preShippingDate: date
    }).then(res => {
      if (res) {
        wx.showToast({
          title: '修改成功',
          icon: 'success',
          duration: 1500
        });
        this.setData({
          "info.preShippingDate": res.preShippingDate
        })
      }
    }).catch(e => {
      console.error('报错---------', e);
    })
  },
  updateAddress() {
    app.globalData.editAddress = this.data.info.addressObj
    wx.navigateTo({
      url: '/pages/UpdateAddress/UpdateAddress?id=' + this.data.info.id
    });
  },
  mapStatus(s) {
    var arr = ['', '待发货', '部分发货', '全部发货', '交易完成', '交易关闭'];
    if (arr[s]) {
      return arr[s];
    } else {
      return '';
    }
  },
  initData(id, isLimtFri) {
    wx.showLoading({
      title: '加载中'
    });
    api.installment.detail(id).then(res => {
      let obj = JSON.parse(res.addressSnapshot)
      obj["receiverName"] = res.receiverNameSnapshot
      obj["receiverPhone"] = res.receiverPhoneSnapshot
      res["address"] = obj.province.regionName + obj.city.regionName + obj.district.regionName + obj.additional
      res["addressObj"] = obj
      res['statusName'] = this.mapStatus(res.installmentStatus)
      let show = false
      let nowdate = new Date().getTime()
      let tmp = new Date(res.preShippingDate).getTime()
      if (res.orderDelivery) {
        for (var i = 0; i < res.orderDelivery.length; i++) {
          let date = new Date(res.orderDelivery[i].shippingDate)
          res.orderDelivery[i]['date'] = `${date.getFullYear()}-${date.getMonth() + 1 < 10 ? '0' + (date.getMonth() + 1) : date.getMonth() + 1 }-${date.getDate() < 10? '0'+date.getDate():date.getDate()} ${date.getHours()}:${date.getMinutes()}:${date.getSeconds() < 10 ? '0' + date.getSeconds(): date.getSeconds()}`
        }
      }
      if (nowdate < tmp && res.installmentStatus == 1) {
        // 如果当前日期 < 该子订单的预计发货日期，且该子订单状态为待发货，则发货详情页底栏有2个按钮
        show = true
        if(isLimtFri) { // 仅限周五
          let week = new Date().getDay() // 返回值是 0（周日） 到 6（周六） 之间的一个整数。
          let firstFirday = nowdate + (1000*60*60*24*(week == 6?6:5-week))
          let fridayArr = []
          if(week != 5) {
            fridayArr.push(WGFORMAT.formatDate(new Date(firstFirday), 'yyyy-MM-dd'))
          }
          for(let i=0;i<30;i++) {
            firstFirday += (7*24*60*60*1000)
            fridayArr.push(WGFORMAT.formatDate(new Date(firstFirday), 'yyyy-MM-dd'))
          }
          this.setData({
            isLimtFri,
            fridayArr
          })
        }
      }
      this.setData({
        info: res,
        isShowFooter: show,
        date: res.preShippingDate
      })
      wx.hideLoading();
    }).catch(e => {
      console.error('api.installment.detail报错----------', e);
      wx.hideLoading();
    })
  },
  goLogistics(e) {
    app.globalData.delivery = this.data.info.orderDelivery[e.currentTarget.dataset.index]
    wx.navigateTo({
      url: '/pages/Logistics/Logistics'
    })
  },
  onLoad: function (e) {
    wx.hideShareMenu()
    var now1 = new Date().getTime() + 1000 * 60 * 60 * 24;
    var now = new Date(now1);
    var date = `${now.getFullYear()}-${now.getMonth()+1}-${now.getDate()}`;
    this.initData(e.id, e.isLimtFri)
    this.setData({
      array: app.globalData.installmentDate,
      id: e.id,
      nowdate: date
    })
    this.data.isLimtFri = e.isLimtFri
  },
  onShow() {
    this.initData(this.data.id, this.data.isLimtFri)
  }
});