import {
  REQUEST,
  LOADING,
  API
} from '../../utils/index'
import {
  Page
} from '../../wgUtils/index';

Page({
  data: {
    id: null,
    comment: null,
    starHot: 'https://img.wgmf.com/ic_star_2.png', // 评价星级
    starDefault: 'https://img.wgmf.com/ic_star_1.png',
  },

  initTrialReport(id) {
    LOADING.show()
    REQUEST.get(API.get_commentDetailById + id).then(r => {
      if (r.data.status === 0) {
        let res = r.data.data[0]
        let imgs = res.evaluationImages
        imgs.sort(function (a, b) {
          if (a.sortingOrder - b.sortingOrder == 0) {
            return a.id - b.id
          }
          return a.sortingOrder - b.sortingOrder
        })
        res['evaluationImages'] = imgs

        console.log(res)
        this.setData({
          comment: res
        })

      }
      LOADING.hide()
    })
  },
  preview(e) {
    let index = e.currentTarget.dataset.index
    let originImgs = this.data.comment.evaluationImages
    let imgs = []
    for (let i = 0; i < originImgs.length; i++) {
      imgs.push(originImgs[i].imgUrl)
    }
    wx.previewImage({
      current: imgs[index], // 当前显示图片的http链接
      urls: imgs // 需要预览的图片http链接列表
    })
  },
  onLoad(option) {
    this.initTrialReport(option.id)
    this.setData({
      id: option.id
    })
  },
  onHide() {},
  onShareAppMessage: function () { // 自定义点击右上角转发内容
    return {
      title: '五谷磨房，创造精致生活的更多种选择',
      path: '/pages/TrialReportDetail/TrialReportDetail?id=' + this.data.id
    }
  }
})