import {
  Page, WGCOMMON, WGENV, WGFORMAT, WGTRACK
} from '../../wgUtils/index'
import MODULES from '../../utils/modules'
import WGAPI from '../../api/index'
Page({
  data: {
    userInfo: null,
    currentGrade: '',
    modulesData: [],
    swiperIndex: 0,
    grades: [
      { name: '普通会员', progress: 0, card: 'https://img.wgmf.com/member_level_card_00.png', price: 0, times: 0, label: '', },
      { name: '谷谷会员', progress: 25, card: 'https://img.wgmf.com/member_level_card_01.png', price: 0, times: 1, label: '历史购买过1次', },
      { name: '银谷会员', progress: 50, card: 'https://img.wgmf.com/member_level_card_02.png', price: 0, times: 2, label: '一年内购买过2次及以上', },
      { name: '金谷会员', progress: 75, card: 'https://img.wgmf.com/member_level_card_03.png', price: 1000, times: 4, label: '一年内购买过4次及以上且购买金额≥1000元', },
      { name: '钻谷会员', progress: 100, card: 'https://img.wgmf.com/member_level_card_04.png', price: 3000, times: 6, label: '一年内购买过6次及以上且购买金额≥3000元', },
    ],
    stars: [0, 0, 0],
    cusRight: null,  // 顾问向我讲解了会员权益（0：否，1：是）")
    canSubmit: false,
    advise: '',
    hadVoucherCards: false, // 用户是否购买了权益卡
    showCommentPopUp: false,
    comment: null,
    submiting: false, // 提交中....
    canComment: true,
    campaign: '', // 来源
  },
  toRule() {
    wx.navigateTo({
      url: '/pages/HowBeGold/HowBeGold'
    })
  },
  toStoreList() {    
    WGTRACK.logCustomEvent('click_nearbyStoresNew')
    wx.navigateTo({
      url: '/pages/WebView/WebView?url=https://wx.wgmf.com/wechat-html/html/dist/#/?title=查看附近门店'
    })
  },
  toOtherModule(e) {
    let i = parseInt(e.currentTarget.dataset.index)
    let data = [
      // 专柜优惠券
      { event: 'click_menu_counterCoupon', vars: { title: '专柜优惠券', }, url: '/pages/HowBeGold/HowBeGold?type=1', },
      // 权益卡
      { event: 'click_menu_equityCard', vars: { title: '权益卡', }, url: '/pages/EquityCard/EquityCard', },
      // 积分商城
      { event: 'click_menu_integralMall', vars: { title: '积分商城', }, url: '/pages/ActivePage/ActivePage?id=413', },
      // 查看养生知识
      { event: 'click_menu_officialAccounts', vars: { title: '查看养生知识', }, url: '/pages/WebView/WebView?url=https://mp.weixin.qq.com/s/Wj0ftpQQNmWFaPmUuoTsdw&title=查看养生知识', },
      // 查看五谷农场
      { event: 'click_menu_farm', vars: { title: '五谷农场', }, url: '/pages/WebView/WebView?url=https://wx.wgmf.com/wechat-html/html/farm/chooseSeedUpDate.html?v=1.0&title=五谷农场', },
    ]
    WGTRACK.logCustomEvent(data[i].event, data[i].vars)
  },
  clickStar(e) {
    let i = e.currentTarget.dataset.index 
    let j = e.target.dataset.index
    if(this.data.stars[i] !== j+1) {
      this.setData({
        ['stars['+ i +']']: j+1
      })
      this.checkCanSubmit()
    }
  },
  clickOption(e) {
    let i = e.currentTarget.dataset.index 
    this.setData({ cusRight: i })
    this.checkCanSubmit()
  },
  bindinput(e) {
    this.data.advise = e.detail.value
  },
  checkCanSubmit() {
    this.data.stars.forEach(i => {
      if(i == 0) {
        this.setData({ canSubmit: false })
        return
      }
    })
    if(this.data.cusRight === null) return
    this.setData({
      canSubmit: true
    })
  },
  closePopup(type) {
    if(type !== 1) {
      WGTRACK.logCustomEvent('click_close_evaluation')
    }
    this.setData({ showCommentPopUp: false })
  },
  submit() {
    if(this.data.canSubmit && !this.data.submiting) {
      this.data.submiting = true // 提交中....
      this.data.comment.shoppeScore = this.data.stars[0]
      this.data.comment.salerScore = this.data.stars[1]
      this.data.comment.recommendScore = this.data.stars[2]
      this.data.comment.cusRight = this.data.cusRight
      this.data.comment.assess = this.data.advise
      this.data.comment.source = this.data.campaign
      WGAPI.user.showCommentByMiniApp(this.data.comment).then(res => {
        WGCOMMON.toastSuccess('感谢您的评价')
        this.closePopup(1)
        this.data.submiting = false
      }).catch(() => {
        this.data.submiting = false
      })
      WGTRACK.logCustomEvent('click_submit_evaluation')
    }
  },
  getShareInfo() {
    let shareVal = {}
    if(this.data.shareTitle) {
      shareVal['title'] = this.data.shareTitle
    }
    if(this.data.shareCover) {
      shareVal['imageUrl'] = this.data.shareCover
    }
    return shareVal
  },
  onShareAppMessage() {
    return this.getShareInfo()
  },
  onShareTimeline() {
    return this.getShareInfo()
  },
  onLoad(options) {
    this.data.shareTitle = options.shareTitle ? options.shareTitle : '查积分、参与活动、填评价...点这里↓↓'
    this.data.shareCover = options.shareCover ? options.shareCover : 'https://img.wgmf.com/4c98945f-37dc-40ab-bdda-a145669a04ba.png'
    this.data.canComment = options.noComment ? false : true // 是否可以弹出评价弹窗
    this.data.campaign = options._campaign ? options._campaign : ''
    // 当渠道来源带有noComment标志代表不能弹窗评价弹窗
    let cusId = wx.getStorageSync('cusId')
    if(cusId) {
      this.data.cusId = cusId
      // 获取配置模块展示
      WGAPI.modules.getById(WGENV.env == 'TEST'? 143 : 420).then(res => {
        if(res) {
          this.setData({ 
            modulesData: MODULES.formatModules(res),
            swiperIndex: 0 
          })
        }
      })
      // 获取用户等级身份
      WGAPI.user.getCustomerGradeInfo(cusId).then(res => {
        if(res.data.msgCode == 0) {
          let tmp = res.data.returnBean.returnList[0]
          tmp.nickName = tmp.nickName ? tmp.nickName : wx.getStorageSync('nickName')
          tmp.customerMobile = tmp.customerMobile ? tmp.customerMobile : wx.getStorageSync('phone')
          tmp.headImgUrl = tmp.headImgUrl ? tmp.headImgUrl : (wx.getStorageSync('avatarUrl') ? wx.getStorageSync('avatarUrl') : 'https://img.wgmf.com/img_default.png')
          let current = 0
          tmp.current = 0
          for(let i=0;i<5;i++) {
            if(this.data.grades[i].name == tmp.customerGrade) {
              tmp.current = i
              current = i
              this.data.grades[current].price = tmp.needConsumptionAmount
              i=5
              break
            }
          }
          tmp['progress'] = this.data.grades[tmp.current].progress
          tmp.gradeNextChangeTime = WGFORMAT.formatDate(tmp.gradeNextChangeTime, 'yyyy年MM月dd日')
          let str = `${tmp.gradeNextChangeTime?tmp.gradeNextChangeTime + '前':''}再购买${tmp.needConsumptionNum}次，且${current == 1? '＞0.00' : '≥' + this.data.grades[current].price}元可升级`
          if(current == 4) {
            str = `您已达到最高等级，${tmp.gradeNextChangeTime}后重新计算`
          }
          if(current == 0) {
            str = '购买一次即可升级为谷谷会员'
          }
          this.setData({
            userInfo: tmp,
            currentGrade: str
          })
        }
      })
      // 查看用户是否购买了权益卡
      WGAPI.product.hadVoucherCards(cusId).then(res => { 
        this.setData({ hadVoucherCards: res })
      })
      // 是否显示评价弹窗
      if(this.data.canComment) {
        WGAPI.user.showCommentCheck(cusId).then(res => {
          this.setData({ showCommentPopUp: res.show })
          res.cusId = cusId
          this.data.comment = res
          if(res.show) {
            WGTRACK.logCustomEvent('exposure_popup_evaluation')
          }
        })
      }
    } else {
      wx.navigateTo({ url: '/pages/AuthPage/AuthPage' })
    }
  },
  toggleToast(e) {
    this.data.modulesData.modules.forEach(item => {
      if(item.moduleType == 2){
        item.cells[0].forEach(i => {
          if(i.id == e.detail.id){
            WGTRACK.logCustomEvent('click_membership_activity_'+i.col)
          }
        })
      }
    })
  } 
})