import {
  API,
  REQUEST
} from '../utils/index.js'
class User {
  constructor() {
    this.vipCusStatus = null
  }
  static getSvipStatus(cusId) {
    let promise = new Promise((resolve, reject) => {
      if (!cusId) {
        reject({
          errno: -1
        })
      } else {
        REQUEST.post(API.post_querySVipOnlineCusInfo, {
          data: {
            cusId: cusId
          }
        }).then((res) => {
          const {
            msgCode,
            resultInfo
          } = res.data
          if (msgCode === 0) {
            resolve(res.data)
          }
        }, (err) => {
          console.log('request is rejected...', err)
        }).catch((e) => {
          throw new Error(e)
        })
      }
    })
    return promise
  }
  static page_scan(pageName, pId) {
    let promise = new Promise((resolve, reject) => {
      let url = `${API.mta_scan}${pageName}`
      REQUEST.get(pId ? `${url}&pId=${pId}` : url).then((res) => {
        resolve()
      }, (err) => {
        reject()
        console.error('API.mta_scan报错-----request is rejected...', err)
      }).catch((e) => {
        throw new Error(e)
      })
    })
    return promise
  }
}
export default User