import ENV from './env.js'
const api = {
  get_openid: 'wechat-pay/miniAppPay/jscode2session', // wx.login获取code调接口换取用户openid/sessionkey/unionid（参数jsCode）
  get_phoneNumber: 'wechat-pay/miniAppPay/getPhoneNumber', // 获取用户绑定的电话号码（参数 encryptedData & iv & sessionKey）
  getLocation: 'wechat-pay/miniAppPay/regeocoding', // 根据经纬度查询地理位置（参数 latitude & longitude）
  get_productList: "wechat-shop-back/product/list/template/1", // 查询产品分组信息列表（1普通版，2内购版）
  get_productDetail: "/wechat-shop-back/product/info/template/", // 查询产品信息 /{templateId}
  get_comment: '/wechat-shop-back/evaluation/listCount', // 获取评论列表（参数 productTemplateId ）
  get_intergral: 'wechat-shop-back/integral/integral/grade', // 送积分倍数/根据兑换码id获取兑换码详情
  get_virtualCoin: 'wechat-propagate-back/gwjAccount/info', // 获取购物金详情
  get_order: 'wechat-shop-back/order', // 下单
  order_seckill: 'wechat-shop-back/order/buyNow', // 秒杀下单
  get_address: 'wechat-shop-back/address/listAdd', // 获取收货地址
  get_defaultadress: 'wechat-shop-back/address/setDefault?id=', // 设置默认收货地址
  save_adress: 'wechat-shop-back/address/confirm', // 保存收获地址
  del_adress: 'wechat-shop-back/address/delete?id=', // 删除收货地址
  post_refreshData: 'wechat-shop-back/product/info/list', // 获取加入购物车商品的最新信息
  pay: 'wechat-pay/pay/bill/', // 生成订单
  login: 'app/information/webLogin', // 登陆
  get_checkCode: 'app/information/webLoginSendSMS', // 获取手机号
  get_orderList: 'wechat-shop-back/order/list/status', // 订单列表
  del_order: 'wechat-shop-back/order/delete?orderId=', // 删除订单
  get_orderDetail: 'wechat-shop-back/order/orderDetail/', // 订单详情
  get_commentList: 'wechat-shop-back/evaluation/list', // 获取某项产品所有评价
  get_commentDetail: 'wechat-shop-back/evaluation/getByOrderId?orderId=', // 根据订单id获取评价详情
  get_commentCount: 'wechat-shop-back/evaluation/listCount', // 获取某项产品评价第一条
  get_commentDetailById: 'wechat-shop-back/evaluation/getByEvaId?evaId=', // 根据评论id获取评论详情
  get_notice: 'wechat-shop-back/product/info/notice', // 获取某项产品notice信息
  get_serverTime: 'wechat-shop-back/preSell/info/getTime', // 获取服务器时间
  get_groupPurchase: 'wechat-shop-back/groupPurchase/productTemplate/', // 拼团相关信息
  group_detail: 'wechat-shop-back/groupPurchase/groupInfo/', // 拼团详情
  get_coupon: 'promotion-online/online/vipActivity?cusId=', // 优惠券
  get_transportFee: 'wechat-shop-back/region/getRegionLogisticsByAddressId', // 获取地区运费
  get_userLevel: 'app/customer/getCustBaseInfo', // 获取用户等级
  get_coupons: 'promotion-online/online/validActivity', // 获取优惠券，满减，满赠，积分等情况
  get_purchaseList: 'wechat-shop-back/groupPurchase/miniProgram/', // 获取拼团列表（首页）
  get_proList: 'wechat-shop-back/product/list/displayArea/3', // 获取小程序产品列表【3】
  cancel_order: 'wechat-shop-back/order/', // 订单操作：取消交易
  confirm_order: 'wechat-shop-back/order/receipt/', // 订单操作：确认收货
  cancel_refund: 'wechat-shop-back/afterSales/refund/changeStatus/', // 订单操作：取消退款
  get_logistics: 'wechat-shop-back/delivery/getDelivery', // 获取物流信息
  comment: 'wechat-shop-back/evaluation/confirm', // 评价
  uptoken_fun: 'qiniu/getUploadToken?content', // 获取上传token
  refund: 'wechat-shop-back/afterSales/confirm', // 申请退款
  returned_order: 'wechat-shop-back/returnedOrder/confirm', // 申请退货
  get_luckyDrawDetail: 'wechat-shop-back/luckyDraw/detail', // 获取抽奖详情
  get_luckyDrawList: 'wechat-shop-back/luckyDraw/list', // 获取抽奖明细
  get_luckyDrawWechatHeadImgUrl: 'wechat-shop-back/luckyDraw/getWechatHeadImgUrl', // 获取活动所有已参与人员的微信头像，一页100条数据
  getTime: 'wechat-shop-back/preSell/info/getTime', // 获取服务器时间
  miniAppPushCode: 'wechat-shop-back/miniAppPushCode/save', // 保存小程序推送码
  post_luckyDraw: 'wechat-shop-back/luckyDraw/confirm', // 保存抽奖内容
  lottery_create_order: 'wechat-shop-back/order/luckyDraw', // 抽奖活动：创建抽奖订单
  lottery_headImgList: 'wechat-shop-back/luckyDraw/getWechatHeadImgUrl', // 抽奖活动：已参与人列表
  lottery_getLuckyDrawList: 'wechat-shop-back/luckyDraw/getLuckyDrawByOpenId', // 抽奖活动：我的抽奖列表
  lottery_saveLuckyDraw: 'wechat-shop-back/luckyDraw/confirm', // 抽奖活动：保存抽奖内容
  lottery_getWinWechatMsg: 'wechat-shop-back/luckyDraw/getWinWechatMsg', // 抽奖活动：已中奖人列表
  get_luckyDrawDetail: 'wechat-shop-back/luckyDraw/detail', // 获取抽奖详情
  get_luckyDrawList: 'wechat-shop-back/luckyDraw/list', // 获取抽奖明细
  get_luckyDrawWechatHeadImgUrl: 'wechat-shop-back/luckyDraw/getWechatHeadImgUrl', // 获取活动所有已参与人员的微信头像，一页100条数据
  post_luckyDraw: 'wechat-shop-back/luckyDraw/confirm', // 保存抽奖内容
  lottery_order: 'wechat-shop-back/order/luckyDraw', // 创建新的抽奖订单
  miniAppMsgPayedMsg: 'wechat-shop-back/miniAppMsg/payedMsg', // 订单支付成功通知
  get_presell_miniInfo: 'wechat-shop-back/preSell/miniInfo', // 获取预售列表
  post_save_unionId: 'wechat-shop-back/miniApp/saveUnionId', // 保存用户
  get_user_info: 'sygj-ewx/customerInformation/getCustomerInfo', // 获取会员信息
  get_coupon_relate: 'promotion-online/getValidCodeNum', // 获取优惠券相关
  get_gwj_relate: 'wechat-propagate-back/gwjAccount/info', // 获取购物金相关
  get_cash_relate: 'wechat-propagate-back/personalCenter/userAccount', // 获取个人信息现金相关
  get_cash_detail: 'wechat-propagate-back/gwjAccount/detail/info', // 获取购物金明细
  get_integral_detail: 'app/custpts/detail', // 获取积分明细
  get_coupon_detail: 'promotion-online/activity/getSpecialAct', // 获取优惠券明细
  get_user_grade_info: 'app/information/getCustomerGradeInfo', // 获取用户等级信息
  // post_createQrcode: 'wechat-shop-back/miniApp/createQRCode',
  post_createQrcode: 'wechat-miniprogram-back/base/createQRCode',
  post_product_info: 'wechat-shop-back/product/info/productPushList/3', // 查询推荐产品列表
  post_getUserLevel: 'app/custpts/brief',
  post_querySVipOnlineCusInfo: 'app/information/querySVipOnlineCusInfo', // 查询会员等级
  getSpecialAct: 'promotion-online/activity/getSpecialAct', // 获取会员优惠券情况
  get_gift_product: 'wechat-shop-back/product/getProductPresent', // 获取赠品
  svipOrder: 'wechat-shop-back/svipOrder/createNewSvipOrder',
  svipMonthOrder: 'wechat-shop-back/svipOrder/createMonSvipOrder',
  getEconomicFee: 'wechat-shop-back/svipOrder/getEconomicFee', // 超级会员：获取节省金额
  getYearConsFee: 'app/information/querySVipOnlineCusCons', // 获取个人年度消费
  mta_scan: 'webstat/api/logPv?appId=miniprogram&_pageName=', // 自定义mta，页面浏览
  is_staff: 'wechat-shop-back/groupPurchase/internal/', // 该用户是否是营养顾问
  get_staffId: 'app/EnterWx/getSalerInfo', // 获取营养顾问工号
  get_hotSearch: 'wechat-shop-back/product/hotSearch', //产品选择接口
  get_goodSearch: 'wechat-shop-back/product/search', //产品选择接口
  isEverBoughtProduct: '/wechat-shop-back/order/getByCusId?', // 是否曾经购买过这款产品
  get_coupons_new: 'promotion-online/online/validActivityNew', // 获取线上专享活动优惠券（新接口）
  postUnbindUnionId: 'app/information/unbindUnionId', // 会员解绑，手机号对应的 openid设为空
  getModifyInfoFromMiniApp: 'app/information/modifyInfoFromMiniApp', // 小程序修改手机号【仅限小程序使用】
  postLoginFromMiniApp: 'app/information/loginFromMiniApp', // 小程序登录【仅限小程序使用】
  queryMerchantCoupon: 'promotion-online/coupon/queryMerchantCoupon?cusId=', // 商家券查询列表
}
for (var i in api) {
  api[i] = ENV + api[i]
}
export default api