import {
  API,
  REQUEST,
  TIPS,
  TOAST
} from './index'
class Auth {
  constructor() {
    this.config = {
      password: '###123'
    }
  }
  // 小程序登录
  wxLogin() {
    return new Promise((resolve, reject) => {
      wx.login({
        success: function (res) {
          wx.setStorageSync('code', res.code)
          resolve(res)
        },
        fail: function (res) {
          reject(res)
        }
      })
    }).catch(function (e) {
      console.error('wx.login报错---------', e);
    })
  }
  getKey1() {
    let _self = this
    return new Promise((resolve, reject) => {
      _self.wxLogin().then(() => {
        try {
          let url = API.get_openid + '?jsCode=' + wx.getStorageSync('code')
          REQUEST.get(url).then(res => {
            if (res.statusCode == 200) {
              wx.setStorageSync('openId', JSON.parse(res.data).openid)
              wx.setStorageSync('session_key', JSON.parse(res.data).session_key)
              wx.setStorageSync('unionId', JSON.parse(res.data).unionid)
              _self.saveUnionId(JSON.parse(res.data))
              resolve(res)
            }
          }).catch(e => {
            console.error('API.get_openid报错-------', e)
            reject(e)
          })
        } catch (e) {
          throw new Error(e)
        }
      })
    }).catch(function (e) {
      console.error('wxLogin报错----------', e);
    })
  }
  saveUnionId(data) {
    if (data.unionid) {
      let url = API.post_save_unionId + '?openId=' + data.openid + '&unionId=' + data.unionid
      REQUEST.post(url, {
        // data: JSON.stringify(params),
        header: {
          'content-type': 'application/json'
        }
      }).then(() => {}).catch(() => {})
    }
  }
  // 服务器登陆
  requestLogin(res) {
    let _self = this
    return new Promise((resolve, reject) => {
      REQUEST.post(API.login, {
        data: {
          mobile: JSON.parse(res.data).phoneNumber,
          checkCode: _self.config.password,
          unionId: wx.getStorageSync('unionId')
        }
      }).then((res) => {
        try {
          const {
            msgCode,
            resultInfo
          } = res.data || {}
          if (msgCode == 0) {
            wx.setStorageSync('cusId', resultInfo.customerId)
            resolve(res)
          }
        } catch (error) {}
      }).catch((e) => {
        reject(e)
      })
    }).catch(function (e) {
      console.error('API.login报错------', e);
    })
  }
  // 手机号解密
  decryptPhoneNumber(detail) {
    return new Promise((resolve, reject) => {
      REQUEST.get(API.get_phoneNumber, {
        data: {
          encryptedData: detail.encryptedData,
          iv: detail.iv,
          sessionKey: wx.getStorageSync('session_key')
        }
      }).then((res) => {
        try {
          // if (typeof res == 'Number') {
          resolve(res)
          // }
        } catch (error) {}
      }).catch((e) => {
        reject(e)
      })
    })
  }
  // 请求服务器授权
  requestUsersecret(detail) {
    const _self = this
    return new Promise((resolve, reject) => {
      try {
        _self.getKey1().then((res) => {
          _self.decryptPhoneNumber(detail).then(res => {

            _self.requestLogin(res).then(res => {
              resolve(res)
            }).catch((error) => {
              throw new Error(error)
            })
          }).catch((error) => {
            throw new Error(error)
          })
        }).catch((e) => {
          console.error('getKey1报错---------', e)
        })
      } catch (e) {
        reject(e)
      }
    })
  }
}

const instance = new Auth()

export default instance