function clone(Obj) {
  var buf;
  if (Obj instanceof Array) {
    buf = []; // 创建一个空的数组
    var i = Obj.length;
    while (i--) {
      buf[i] = clone(Obj[i]);
    }
    return buf;
  } else if (Obj instanceof Object) {
    buf = {}; // 创建一个空对象
    for (var k in Obj) { // 为这个对象添加新的属性
      buf[k] = clone(Obj[k]);
    }
    return buf;
  } else {
    return Obj;
  }
}
export default {
  orignalModules: (page) => { // 二维数组变一维数组
    let newpage = clone(page)
    for (let i = 1; i < page.modules.length; i++) {
      let cells = page.modules[i].cells
      newpage.modules[i].cells = new Array()
      for (let m = 0; m < cells.length; m++) {
        if (Object.prototype.toString.call(cells[m]) == '[object Array]') {
          for (let n = 0; n < cells[m].length; n++) {
            cells[m][n]['row'] = m
            cells[m][n]['col'] = n
            newpage.modules[i].cells.push(cells[m][n])
          }
        } else {
          cells[m]['row'] = 0
          cells[m]['col'] = m
          newpage.modules[i].cells.push(cells[m])
        }
      }
    }
    return newpage
  },
  formatModules: (page, imgsBorder) => { // 一维数组变二维
    page.modules.sort(function (a, b) {
      return a.moduleType - b.moduleType
    })
    let newpage = clone(page)
    let modules = page.modules
    imgsBorder = imgsBorder || []
    newpage.modules[0].cells.sort(function (a, b) {
      return a.col - b.col
    })
    for (let i = 1; i < modules.length; i++) {
      let newcells = []
      for (let j = 0; j < modules[i].cells.length; j++) {
        if(page.id == 349) { modules[i].cells[j]['type'] = 9 }
        modules[i].cells[j]['sUrl'] = ''
        modules[i].cells[j]['lUrl'] = ''
        modules[i].cells[j]['imgUrl'] = modules[i].cells[j].imgUrl? modules[i].cells[j].imgUrl + '?imageslim' : modules[i].cells[j].imgUrl
        let val = parseInt(modules[i].cells[j].product?modules[i].cells[j].product.activeType:-1)
        if(imgsBorder && imgsBorder.length > val + 1) {
          modules[i].cells[j]['sUrl'] = imgsBorder[val + 1].sUrl? imgsBorder[val + 1].sUrl + '?imageslim' : imgsBorder[val + 1].sUrl
          modules[i].cells[j]['lUrl'] = imgsBorder[val + 1].lUrl? imgsBorder[val + 1].lUrl + '?imageslim' : imgsBorder[val + 1].lUrl
        }
        let row = modules[i].cells[j].row
        let col = modules[i].cells[j].col
        if (newcells[row]) {

        } else {
          newcells[row] = []
        }
        newcells[row][col] = modules[i].cells[j]
      }
      newpage.modules[i].cells = newcells
    }
    if (!newpage.hasOwnProperty('style') || !page.style) {
      newpage['style'] = "background:#fff;"
    }
    return newpage
  }
}