import {
  REQUEST,
  API,
  LOADING
} from './index.js'
const app = getApp()
const applyRefundOrder = function (detail, id) { // 申请退款
  let params = []
  let groupedImages = detail.productTemplate.groupedImages
  let icon = detail.imgUrlSnapshot || (groupedImages.icon && groupedImages.icon[0] && groupedImages.icon[0].imageUrl)
  params.push({
    icon: icon,
    name: detail.productTemplateName,
    price: detail.price,
    quantity: detail.quantity
  })
  return params
}
const returnFormFilter = function (arr) {
  let params = []
  for (let i = 0; i < arr.length; i++) {
    let groupedImages = arr[i].productTemplate.groupedImages
    let icon = groupedImages.icon && groupedImages.icon[0] && groupedImages.icon[0].imageUrl
    let item = {
      icon: icon,
      name: arr[i].productTemplateName,
      quantity: arr[i].quantity,
      giftStatus: arr[i].giftStatus
    }
    params.push(item)
  }
  return params
}
const commentFilter = function (arr) {
  let params = []
  for (let i = 0; i < arr.length; i++) {
    if (arr[i].productTemplate.groupedImages.icon && arr[i].productTemplate.groupedImages.icon[0].imageUrl) {
      arr[i].icon = arr[i].productTemplate.groupedImages.icon[0].imageUrl
    } else {
      arr[i].icon = ''
    }
  }
  return params
}
const cancelRefund = function (id) { // 取消退款
  return new Promise((resolve, reject) => {
    wx.showModal({
      title: '提示',
      content: '您确定要取消退款吗？',
      confirmColor: '#FF4318',
      success: function (res) {
        if (res.confirm) {
          let url = API.cancel_refund + id + '/4'
          REQUEST.post(url).then((res) => {

          }).catch((e) => {})
        }
        resolve()
      },
      fail: function () {
        reject()
      }
    })
  })
}
const cancelOrder = function (id) { // 取消交易
  return new Promise((resolve, reject) => {
    wx.showModal({
      title: '提示',
      content: '您确定要取消交易吗？',
      confirmColor: '#FF4318',
      success: function (res) {
        if (res.confirm) {
          let url = API.cancel_order + id
          REQUEST.delete(url).then((res) => {
            if (res.data.status === 0) {
              resolve(res)
            }
          }).catch((e) => {
            reject(e)
          })
        }
      },
      fail: function (e) {
        reject(e)
      }
    })
  })
}
const confirmOrder = function (id) { // 确认收货
  return new Promise((resolve, reject) => {
    wx.showModal({
      title: '提示',
      content: '您确认收到包裹？',
      confirmColor: '#FF4318',
      success: function (res) {
        if (res.confirm) {
          let url = API.confirm_order + id
          REQUEST.get(url).then((res) => {
            resolve()
          })
        } else {}
      },
      fail: function () {
        reject()
      }
    })
  })
}
const delOrder = function (id) {
  return new Promise((resolve, reject) => {
    wx.showModal({
      title: '提示',
      content: '您确定要删除订单吗？',
      confirmColor: '#FF4318',
      success: function (res) {
        if (res.confirm) {
          let url = API.del_order + id
          REQUEST.get(url).then((res) => {
            if (res.data.status === 0) {
              resolve()
            }
          }).catch((e) => {
            TOAST.warning({
              title: e
            })
            reject(e)
          })
        }
      },
      fail: function (e) {
        reject(e)
      }
    })
  })
}
export default {
  confirmOrder,
  cancelOrder,
  cancelRefund,
  applyRefundOrder,
  delOrder,
  returnFormFilter,
  commentFilter
}