import {
  REQUEST,
  API,
  TOAST,
  SRTRACK,
} from '../utils/index'
import {
  WGSUBSCRIBE
} from '../wgUtils/index';

const getServerTime = function () {
  return new Promise((resolve, reejct) => {
    REQUEST.get(API.get_serverTime).then((res) => {
      const {
        status,
        data
      } = res.data
      if (status == 0 && data) {
        resolve(data)
      } else {
        reject()
      }
    }).catch(() => {
      reject()
    })
  })
}
let param
const _pay = function ({
  id,
  url,
  isPresalefront,
  paySuccessFn,
  payErrorFn,
  isSvip,
  isBuyMonthSvip,
  isBuyCoupon,
  orderType,
  payPreSale,
  extraData
}) {
  SRTRACK.customOrder(param, "give_order")
  let openId = wx.getStorageSync('openId')
  REQUEST.post(url, {
    data: {
      'openId': openId
    }
  }).then((res) => {
    const {
      data
    } = res
    console.log(res)
    if (data.payState == '5') {
      TOAST.warning({
        title: '拼团已结束，不能再付款了!'
      })
    } else if (data.payState == '0') {
      if(data.ticket) {
        console.log('视频号支付')
        wx.requestOrderPayment({
          'timeStamp': data.timeStamp,
          'nonceStr': data.nonceStr,
          'package': data.packageStr,
          'ticket': data.ticket || '',
          'signType': data.signType || 'MD5',
          'paySign': data.paySign,
          'success': function (res) {
            SRTRACK.customOrder(param, "pay")
            console.log('wx.requestPayment---------', res)
            let url = ''
            if (isSvip) {
              url = '/pages/OrderList/OrderList'
              if (orderType == 20) url = '/pages/superMember/superMember?showQy=1'
            } else if (isBuyCoupon) {
              if(extraData && extraData.pId == 2081) {
                url = '/modules/MallPromotion/pages/SaveMoneyCard/SaveMoneyCard'
              } else {
                url = '/pages/TicketsAccount/TicketsAccount'
              }
            } else {
              url = '/pages/OrderDetail/OrderDetail?billId=' + id + '&isPay=' + (isPresalefront ? '0' : '1')
            }
            if(orderType == 21) {
              if(extraData && (extraData.pId == 1891 || extraData.pId == 96)) {
                url = '/pages/EquityCard/EquityCard'
              } else {
                url = '/pages/HowBeGold/HowBeGold?type=1'
              }
            }
            let subscribeMsgType = 'paySuccess'
            console.log(orderType, 'orderType')
            switch (orderType) {
              case 8:
                subscribeMsgType = 'payGroupA';
                break; // 拼团
              case '8':
                subscribeMsgType = 'payGroupA';
                break; // 拼团
              case 9:
                subscribeMsgType = 'payInstallment';
                break; // 分期发货
              case '9':
                subscribeMsgType = 'payInstallment';
                break; // 分期发货
              case 16:
                subscribeMsgType = 'payGroupB';
                break; // 团购
              case '16':
                subscribeMsgType = 'payGroupB';
                break; // 团购
              case 20:
                subscribeMsgType = 'buySvip';
                break; // 购买超会月卡
              case '20':
                subscribeMsgType = 'buySvip';
                break; // 购买超会月卡
              default:
                break;
            }
            if ((orderType == 6 || orderType == '6') && (payPreSale == 1 || payPreSale == '1')) {
              subscribeMsgType = 'payPresale'
            }
            if(orderType == 22) {//购买储值卡
              subscribeMsgType = 'payStored'
              url = '/modules/ShoppingMoney/components/StoredPaySuccess/StoredPaySuccess?billId=' + param.orderCode
            }
            WGSUBSCRIBE(subscribeMsgType).then(r => {
              wx.redirectTo({
                url: url
              })
            })
          },
          'fail': function (res) {
            if (res.errMsg == "requestPayment:fail cancel") {
              SRTRACK.customOrder(param, "cancel_pay")
            }
            if(orderType == 22) {//购买储值卡不去订单页
              // TOAST.warning({
              //   title: '请重新下单'
              // })
              WGSUBSCRIBE('payStored').then(r => {})
            }else {
            WGSUBSCRIBE('payError').then(r => {
              if (!isSvip) {
                wx.navigateTo({
                  url: '/pages/OrderDetail/OrderDetail?billId=' + id + '&isPay=' + (isPresalefront ? '0' : '1'),
                })
              }
            })
          }
          },
          complete: function () {
  
          }
        })
      } else {
        console.log('正常支付', extraData)
        wx.requestPayment({
          'timeStamp': data.timeStamp,
          'nonceStr': data.nonceStr,
          'package': data.packageStr,
          'signType': data.signType || 'MD5',
          'paySign': data.paySign,
          'success': function (res) {
            SRTRACK.customOrder(param, "pay")
            console.log('wx.requestPayment---------', res)
            let url = ''
            if (isSvip) {
              url = '/pages/OrderList/OrderList'
              if (orderType == 20) url = '/pages/superMember/superMember?showQy=1'
            } else if (isBuyCoupon) {
              if(extraData && extraData.pId == 2081) {
                url = '/modules/MallPromotion/pages/SaveMoneyCard/SaveMoneyCard'
              } else {
                url = '/pages/TicketsAccount/TicketsAccount'
              }
            } else {
              url = '/pages/OrderDetail/OrderDetail?billId=' + id + '&isPay=' + (isPresalefront ? '0' : '1')
            }
            if(orderType == 21) {
              if(extraData && (extraData.pId == 1891 || extraData.pId == 96)) {
                url = '/pages/EquityCard/EquityCard'
              } else {
                url = '/pages/HowBeGold/HowBeGold?type=1'
              }
            }
            console.log(param)
            if(orderType == 14) {
              url = '/pages/superMember/superMember'
            }
            let subscribeMsgType = 'paySuccess'
            console.log(orderType, 'orderType')
            switch (orderType) {
              case 8:
                subscribeMsgType = 'payGroupA';
                break; // 拼团
              case '8':
                subscribeMsgType = 'payGroupA';
                break; // 拼团
              case 9:
                subscribeMsgType = 'payInstallment';
                break; // 分期发货
              case '9':
                subscribeMsgType = 'payInstallment';
                break; // 分期发货
              case 16:
                subscribeMsgType = 'payGroupB';
                break; // 团购
              case '16':
                subscribeMsgType = 'payGroupB';
                break; // 团购
              case 20:
                subscribeMsgType = 'buySvip';
                break; // 购买超会月卡
              case '20':
                subscribeMsgType = 'buySvip';
                break; // 购买超会月卡
              default:
                break;
            }
            if ((orderType == 6 || orderType == '6') && (payPreSale == 1 || payPreSale == '1')) {
              subscribeMsgType = 'payPresale'
            }
            if(orderType == 22) {//购买储值卡
              subscribeMsgType = 'payStored'
              url = '/modules/ShoppingMoney/components/StoredPaySuccess/StoredPaySuccess?billId=' + param.orderCode + '&orderId=' + param.id
            }
            if(orderType == 29) {//购买储值卡
              subscribeMsgType = 'payStored'
              url = '/pages/ActivePage/ActivePage?id=642&_campaign=2022MQJYGZG'
            }
            WGSUBSCRIBE(subscribeMsgType).then(r => {
              if(extraData && extraData.pId == 2081) {
                wx.reLaunch({ url: url })
              } else {
                wx.redirectTo({
                  url: url
                })
              }
            })
          },
          'fail': function (res) {
            if (res.errMsg == "requestPayment:fail cancel") {
              SRTRACK.customOrder(param, "cancel_pay")
            }
            
            if(orderType == 22) {//购买储值卡不去订单页
              // TOAST.warning({
              //   title: '请重新下单'
              // })
              WGSUBSCRIBE('payStored').then(r => {})
            }else {
              WGSUBSCRIBE('payError').then(r => {
                if (!isSvip) {
                  wx.navigateTo({
                    url: '/pages/OrderDetail/OrderDetail?billId=' + id + '&isPay=' + (isPresalefront ? '0' : '1'),
                  })
                }
              })
            }
          },
          complete: function () {
  
          }
        })
      }
    } else if (data.payState == '1') {
      TOAST.warning({
        title: '此订单已付款'
      })
    } else if (data.payState == '2') {
      TOAST.warning({
        title: '此订单不存在'
      })
    } else if (data.payState == '4') {
      TOAST.warning({
        title: '已付定金才能付尾款'
      })
    }
  }).catch((e) => {
    console.error(e);
  })
}
const pay = function ({
  params,
  paySuccessFn,
  payErrorFn,
  isSvip,
  isBuyMonthSvip,
  isBuyCoupon,
  orderType,
  customOrderParams,
}) {
  let url = null
  // console.error(customOrderParams.orderDetails[0].productTemplateId)
  param = customOrderParams
  if (params.orderType == 6) { // 预售活动
    getServerTime().then((curTime) => {
      if (params.orderStatus.id == 15) { // 已付定金未付尾款
        if (curTime >= params.orderDownPayment.balancePaymentStartTime && curTime <= params.orderDownPayment.balancePaymentEndTime) { // 支付尾款
          url = API.pay + 'ma' + params.orderCode
          _pay({
            url,
            id: params.id,
            isPresalefront: 0,
            paySuccessFn,
            payErrorFn,
            isSvip: isSvip,
            isBuyCoupon: isBuyCoupon,
            orderType: orderType,
            payPreSale: 0
          })
        }
      } else {
        if (curTime >= params.orderDownPayment.frontMoneyStartTime && curTime <= params.orderDownPayment.frontMoneyEndTime) { // 处于定金支付阶段
          url = API.pay + 'my' + params.orderCode
          _pay({
            url,
            id: params.id,
            isPresalefront: 1,
            paySuccessFn,
            payErrorFn,
            isSvip: isSvip,
            isBuyCoupon: isBuyCoupon,
            orderType: orderType,
            payPreSale: 1
          })
        } else {
          TOAST.warning({
            title: '付定金时间已结束，不能支付'
          })
        }
      }
    })
  } else {
    url = API.pay + 'ma' + params.orderCode
    _pay({
      url,
      id: params.id,
      isPresalefront: 0,
      paySuccessFn,
      payErrorFn,
      isSvip: isSvip,
      isBuyMonthSvip: isBuyMonthSvip,
      orderType: orderType,
      isBuyCoupon: isBuyCoupon,
      extraData: { pId: customOrderParams?customOrderParams.orderDetails[0].productTemplateId: null }
    })
  }
}
export default pay