import {
  WGTRACK
} from '../wgUtils/index';
import {
  SHOPCARTSERVER
} from '../utils/index'


const setTrackData = function (wgTrack, data, id = 'null', name = 'null') { // (商品卡曝光 /商品卡触发/商品页浏览):参数设置
  let trackData = {};
  if (data.constructor === Array) { //检测data,传入的data是产品数组列表的话则遍历数组，如果是单款产品只需直接获取产品参数
    data.map(item => {
      item.products.map(item2 => {
        trackData = {
          sku: {
            sku_id: item2.id.toString(),
            sku_name: item2.productName
          },
          spu: {
            spu_id: item.id.toString(), // 若商品无spu_id时，可传sku_id信息
            spu_name: item.productTemplateName //  若商品无spu_name时，可传sku_name信息
          },
          sku_category: [{
            sku_cat_id: id,
            sku_cat_name: name,
            sku_parent_cat_id: "null"
          }],
          primary_image_url: item.icon
        }
        WGTRACK.setSRTrack(wgTrack, trackData)
      })
    })
  } else {
    data.products.map(item => {
      trackData = {
        sku: {
          sku_id: item.id.toString(),
          sku_name: item.productName
        },
        spu: {
          spu_id: data.id.toString(), // 若商品无spu_id时，可传sku_id信息
          spu_name: data.productTemplateName //  若商品无spu_name时，可传sku_name信息
        },
        primary_image_url: data.icon
      }
      WGTRACK.setSRTrack(wgTrack, trackData)
    })
  }
}

const setAddCartData = function (param) { //分类页与产品详情页商品加购参数设置
  let data = param.info;
  let orderInfo = param.orderInfo;
  let curSKUId = orderInfo.curSKUId

  let moduleVal;
  moduleVal = SHOPCARTSERVER.getCheckedCart()
  let moduleValId = [];
  moduleVal.map(item => { // 获取购物车现有商品判断动作类型first_add_to_cart：首次加车；append_to_cart：再次加车；append_to_cart_in_cart：购物车追加；remove_from_cart：从购物车彻底移除
    moduleValId.push(item.id)
  })

  let action_type;
  var check_action_type = moduleValId.indexOf(curSKUId); //购物车中不存在指定SKU产品为初次加入
  if (check_action_type == -1) {
    action_type = 'first_add_to_cart'
  } else {
    action_type = 'append_to_cart';
  }

  let addData;
  data.products.map(item => { //获取加购SKU产品信息
    if (item.id == curSKUId) {
      addData = item
    }
  })

  let addCartData = {
    action_type: action_type,
    sku: {
      sku_id: addData.id.toString(),
      sku_name: addData.productName
    },
    spu: {
      spu_id: data.id.toString(), // 若商品无spu_id时，可传sku_id信息
      spu_name: data.productTemplateName //  若商品无spu_name时，可传sku_name信息
    },
    sku_num: param.quantity
  }
  WGTRACK.setSRTrack('add_to_cart', addCartData)
}

const myCartAddCart = function (param) { //购物车商品加购参数设置
  let addCartData = {
    action_type: 'append_to_cart_in_cart',
    sku: {
      sku_id: param.productId.toString(),
      sku_name: param.skuName
    },
    spu: {
      spu_id: param.productTemplateId.toString(), // 若商品无spu_id时，可传sku_id信息
      spu_name: param.name //  若商品无spu_name时，可传sku_name信息
    },
    sku_num: 1
  }
  WGTRACK.setSRTrack('add_to_cart', addCartData)
}

const deleteCart = function (param) { //从购物车彻底移除参数设置
  console.log(param)
  let addCartData = {
    action_type: 'append_to_cart_in_cart',
    sku: {
      sku_id: param.productId.toString(),
      sku_name: param.skuName
    },
    spu: {
      spu_id: param.productTemplateId.toString(), // 若商品无spu_id时，可传sku_id信息
      spu_name: param.name //  若商品无spu_name时，可传sku_name信息
    },
    sku_num: param.quantity
  }
  WGTRACK.setSRTrack('add_to_cart', addCartData)
}

const customOrder = function (param, order_status, pay_amt = null) { //订单状态变更 
  console.log('customOrder-------------', param)
  let timestamp = new Date().getTime()
  let customOrderData = {
    "order": {
      "order_id": param.orderCode.toString(),
      "order_time": param.submitDate,
      "order_status": order_status
    },
    "sub_orders": [{
      "sub_order_id": param.orderCode.toString(),
      "order_amt": param.productFee || param.pricePerUnit || param.totalFee || param.productTotal, //订单金额
      "pay_amt": pay_amt || param.priceActual || param.totalFee || param.productTotal //订单应付金额
    }],
  }
  if (order_status == 'cancel_pay') { //用户关闭支付密码浮层
    customOrderData.order.cancel_pay_time = timestamp
  } else if (order_status == 'cancel_give_order') { //用户取消订单
    customOrderData.order.cancel_time = timestamp
  } else if (order_status == 'pay') { //用户发起支付
    customOrderData.order.pay_time = timestamp
  } else if (order_status == 'refund') { //用户发起退货退款
    customOrderData.order.refund_time = timestamp
  }
  WGTRACK.setSRTrack('custom_order', customOrderData)
}

const search = function (keyword) { //搜索参数设置
  console.log(keyword)
  let searchKey = {
    keyword: keyword
  }
  WGTRACK.setSRTrack('search', searchKey)
}

export default {
  setTrackData,
  setAddCartData,
  myCartAddCart,
  deleteCart,
  customOrder,
  search,
}