export default {
  getShareStaffId() { // 获取分享人的工号
    return wx.getStorageSync('shareStaffId') ? wx.getStorageSync('shareStaffId') : ''
  },
  getMyStaffId() { // 获取我自己的工号
    return wx.getStorageSync('staffId') ? wx.getStorageSync('staffId') : ''
  },
  checkShareStaffId() { // 检查分享人工号是否过期, 打开小程序的时候就检查是否过期
    if (wx.getStorageSync('shareStaffId')) {
      let expiresTime = wx.getStorageSync('shareExpiresTime') // 过期时间
      let now = (new Date().getTime()) / 1000
      if (now > expiresTime) { // 已经过期了
        wx.removeStorageSync('shareStaffId')
        wx.removeStorageSync('shareExpiresTime')
      }
    }
  },
  setShareStaffId(id) { // 保存分享人的工号，设置七天过期, 从分享页面进来拿参数
    console.log(id)
    let valid = 7 * 24 * 60 * 60
    let now = (new Date().getTime()) / 1000
    wx.setStorageSync('shareStaffId', id)
    wx.setStorageSync('shareExpiresTime', valid + now)
  },
  setShareStaffIdByShare(option) {
    console.log(option)
    if (option.shareStaffId) {
      this.setShareStaffId(option.shareStaffId)
    }
    if(option.custom_params) {
      let shareStaffId = JSON.parse(decodeURIComponent(option.custom_params)).shareStaffId
      console.log(shareStaffId)
      this.setShareStaffId(shareStaffId)
    }
  },
  setMyStaffId(id) { // 保存我自己的工号
    wx.setStorageSync('staffId', id)
  },
  getShareParams() {
    if (this.getMyStaffId()) {
      return `shareStaffId=${this.getMyStaffId()}`
    }
    return ''
  }
}