import SHOPCARTSERVER from './shopcartserver.js'
const formatTime = function (date) {
  const year = date.getFullYear()
  const month = date.getMonth() + 1
  const day = date.getDate()
  const hour = date.getHours()
  const minute = date.getMinutes()
  const second = date.getSeconds()

  return [year, month, day].map(formatNumber).join('/') + ' ' + [hour, minute, second].map(formatNumber).join(':')
}

const formatNumber = n => {
  n = n.toString()
  return n[1] ? n : '0' + n
}

const getInfo = function (key) {
  return wx.getStorageSync(key)
}

const env = function () {
  var systemInfo = wx.getSystemInfoSync()
  if (systemInfo.platform == 'devtools') {
    return 'dev'
  } else {
    return 'prod'
  }
}

const currency = function (num) {
  if (num || num == 0) {
    return Math.round(num * 10) / 10
  } else {
    return ''
  }
}

const previewImg = function (curUrl, urls) {
  wx.previewImage({
    current: curUrl, // 当前显示图片的http链接
    urls: urls // 需要预览的图片http链接列表
  })
}
const setCartNum = function () {
  let cartNum = SHOPCARTSERVER.getCartNum()
  if (cartNum) {
    wx.setTabBarBadge({
      index: 3,
      text: cartNum.toString()
    })
  } else {
    wx.removeTabBarBadge({
      index: 3
    })
  }
}
const getQueryString = function (name) {}
module.exports = {
  formatTime,
  getInfo,
  env,
  currency,
  previewImg,
  setCartNum,
  getQueryString
}