import {
  WGTRACK,
  wgPageUtil,
  WGAUTH
} from './index'
import StaffShare from '../utils/staffShare'
const wgPage = function (config) {
  const { onLoad } = config
  
  config.onLoad = function (options) { // 页面创建时执行

    if(!wx.getStorageSync('openId')) {
      WGAUTH.wxLogin()  // 静默授权登录
    }
    
    WGTRACK.setUserOpenId(wx.getStorageSync('openId')) // 有数设置用户信息
    WGTRACK.setUserTag() // 有数设置用户身份标签

    if (typeof onLoad === 'function') {
      //由于官方没有提供页面标题的获取方式，不再支持全自动获取，为确保 page_title 获取，需要开发配合完成如下配置
      this.setData({
        title: wgPageUtil.routerIsString(wgPageUtil.getCurrentPageUrl())
      })
      //添加公共场景值取参方法
      if (options && options.scene) { //如果获取到场景值，则将场景值取出赋值给自定义参数
        let scene = decodeURIComponent(options.scene).split('&')
        for (let i in scene) {
          let item = scene[i].split('=')
          let itemKey = item[0]
          let itemVal = item[1]
          options[itemKey] = itemVal
        }
      }
      if (options && options.chan_id) {
        WGTRACK.setChanId(options.chan_id)
      }
      StaffShare.checkShareStaffId()
      if(options && options.shareStaffId) {
        StaffShare.setShareStaffId(options.shareStaffId)
      }
      onLoad.call(this, options)
      console.log("page onLoad 回调参数：---------------", options)
    }

    // 版本更新
    const updateManager = wx.getUpdateManager()
    if(updateManager) {
      updateManager.onCheckForUpdate(function (res) { // 请求完新版本信息的回调
        console.log(res.hasUpdate)
      })
      updateManager.onUpdateReady(function () {
        wx.showModal({
          title: '更新提示',
          content: '新版本已经准备好，是否重启应用？',
          success: function (res) {
            if (res.confirm) { // 新的版本已经下载好，调用 applyUpdate 应用新版本并重启
              updateManager.applyUpdate()
            }
          }
        })
      })
      updateManager.onUpdateFailed(function () { // 新版本下载失败
        wx.showToast({
          title: '新版本下载失败，请稍后重试。',
          icon: 'none',
          duration: 2000
        })
      })
    }
    if(this.data.title !== '产品详情页') {
      WGTRACK.pageBrowse() // 浏览记录上报
    }
  }
  // config.onHide = function() {
  // }
  let app = getApp()
  return Page(app.sr.page(config))
}

export default wgPage