// 一些性能优化的函数

/** 防抖函数 */
function debounce(fn, delay, that) {
  /** 一个需要频繁触发的函数，在规定时间内，只让最后一次生效，前面不生效 */
  var timer = null
  return function() {
    clearTimeout(timer)
    timer = setTimeout(function() {
      console.log('防抖函数触发')
      fn.apply(that)
    }, delay)
  }
}

export default {
  debounce
} 