/*  **************************************  五谷订阅消息通用方法 start  ****************************************** */
// 1. 使用方法
//    (1) 在 allTempIds 中填入小程序的所有订阅消息的模板id
//    (2) 在 tmplIds 中根据触发动作将模板id分类
//    (3) import wgSubscribe from '/wgUtils/wgSubscribe'
//        wgSubscribe('msgType').then(res => {
//          // can do  something....
//        })
//        wgSubscribe('paySuccess').then(res => {})

// 2. 订阅消息的版本支持情况说明：
//    (1) 基础库2.4.4开始支持订阅消息，低版本不支持，需做兼容处理。以下代码做了 try catch 处理。
//    (2) 基础库2.4.4-2.8.4仅支持一条订阅消息，2.8.4以上版本支持三条订阅消息。
//    (3) 微信版本支持三条订阅消息条件，ios大于等于7.0.6版本，Android大于等于7.0.7版本

// 3. 如果需要做订阅消息GIF图提示(即显示引导用户点击‘总是’动态指引gif图)，需要做“版本判断”和“总是判断”，判断条件如下：
//   (基础库大于等于2.8.4 && ( ios版本大于等于7.0.6 || Android版本大于等于7.0.7 ) && 没有点过'总是')
//   app.globalData.showSubscribeGif 表示是否显示GIF图指引，监听该值的变化即可实现显示隐藏gif图

/*  **************************************  五谷订阅消息通用方法 end  ****************************************** */


import wgEnv from './wgEnv'
import WGDATATYPE from './wgDataType'

const app = getApp()

let allTmpIds = [ // 所有模板id
  'baGZ6dmgA1TQAwHYBBzAczpg6oZs81QVSoQIQRCZX8I', // 0 订单支付成功通知 - 购买超会触发订阅
  'T7VdOrMft48bM7iR1bOReE0HM0U88gKIbut_GpKtoJQ', // 1 订单发货通知 - 下单触发订阅  
  'iV-PcSiiKSp3NTRnQXaZPrOMaA9QrPv9lnkdDJtGn0U', // 2 预约到货通知 - 点击“到货提醒”触发订阅 
  '7-6T8W3VlHsUJ2i9wK3sY4tIXQZYrBqdrmNecpfHR9k', // 3 订阅活动开始提醒 - 下单、秒杀预约、到货提醒、降价提醒、直播间预约等触发订阅
  'EKZU_rPu1ji30kANfrq1BQCED-P9Y6hT3PQ26XOO-i0', // 4 订单售后审核通知 - 申请退款触发订阅   
  'FoWHm_zyHdlLp93ad60iDK7ykZpprXbQ6M8yaku5VHM', // 5 尾款支付提醒 - 下预售订单触发订阅  
  'dncKuKvYcDhHRKAqnZ7Uu84MikeRs8VHHufKROg4e0k', // 6 拼团结果通知 - 下拼团/团购订单触发订阅  
  'fT2gV8ydL10jY2uMq89DGYqzko_6WC1xTYuP_AapUIQ', // 7 优惠券到账提醒 - 下单触发订阅
  'TijE135nH9scunLIjrH4gKJhfFR_baUcSLkNghg6eGI', // 8 优惠券过期提醒 - 点击“直播间预约”触发订阅
  '35dY598ClxwpHEaGb3ToBqCp5r5_-0jwPxU55BU1LSI', // 9 商品降价提醒 - 点击“降价提醒”触发订阅
  'Z5hMbEFoiPSMSFuBOZjctu4TtfxptRjIfu2J_1FJPQ8', // 10 新活动提醒 - 点击“直播间预约”触发订阅
  'jFBJT_U3Vwr4x1it6WEOmRlpqXTohdaNLhgOB-z7hqc', // 11 新订单提醒 - 下分期购订单触发订阅
  '9dmS5JtJzNxFPnpkv9gjVq9TW_T5DJOwwkrB9lJwytI', // 12 帖子被赞通知 - 谷粉说帖子被赞触发
  'WyfGUfoijwLfV5TOm9_ln7EZQmvDT8xGim7TCipPH-4', // 13 新的评论提醒 - 谷粉说有新评论触发
  'Xm6T8pyQMzwy3kVFij5ZsBeqbL97R2C_SSFqU-Ht7Qk', // 14 评论点赞通知 - 谷粉说评论被点赞触发
  'l_XEqEqFkOXreNo5umboR_HfXiiQ7HArBjYo8BH1Oso', // 15 评论回复通知 - 谷粉说评论被回复触发
  '1e984CYcMXd3A40RpAM-Z8wAreAnSIUPQisi_QUvHV4', // 16 购物金储值订阅提醒 - 新活动提醒
  'D_Y9FsdzeszWgG2k1-kgNjyLSnu2XIemnMjRp4LPZyY', // 17 购物金储值订阅提醒 - 红包临期提醒
  'Q8QW9PxqXytI1nQ3TZpPzef3TZoHGU8GNIqci3izvDo', // 18 购物金储值订阅提醒 - 会员活动提醒
  'tU9U3iAo95B_HPz7GQV7Wn2e5-Di_81yQG1joXzZaI4', // 19 购物金储值卡 - 特权卡开通提醒
  'fT2gV8ydL10jY2uMq89DGfuB9mjl1qC8hNrAom4Fveo', // 20 购物金储值卡 - 优惠券到账提醒
  '7-6T8W3VlHsUJ2i9wK3sYwH9oLQkiVYlK5Qow3ChbZY', // 21 购物金储值卡 - 订阅活动开始提醒
  'RPSmAWT3Q1_L9eBvb8_OHN9cGm5WnKzhAWOkSB-PkMg', // 22 购物金储值卡 - 好友领取成功提醒
  '7-6T8W3VlHsUJ2i9wK3sYwH9oLQkiVYlK5Qow3ChbZY', // 23 会员专题页- 订阅活动开始提醒
  'kDBzxtUthaRUX2z8_p2iOTJuYDChP7k2sF4p3YDba9A', // 24 购物金储值卡 - 礼物退回通知
  // 'rg6Trre8gYu1IYf0DSk_zAM-SRvxnEPBZdojpfeU1mA', // 25 新品试用 - 新品试用名单抽取
  'e3Suxtp-tqLYShHr_xrOBN_lyLgmFctIsWTYkvq6BSE',// 25 新品试用 - 中奖消息模版变更
  '8KAM5bplSOE3zdQs1hJfPW6W11ziXKyr2xwfbVnSwnA', // 26 新品试用 - 新品试用产品发货提醒
  '14NjLtU637KUnKqXETIh63uS51X_bvd_XofdU1xsDYI', // 27 新品试用 - 新品试用报告审核通过，退款
  'fT2gV8ydL10jY2uMq89DGfuB9mjl1qC8hNrAom4Fveo', // 28 红包封面 - 优惠券到账提醒（用户订阅后自动发送消息）
  'e3Suxtp-tqLYShHr_xrOBN_lyLgmFctIsWTYkvq6BSE', // 29 红包封面 - 抽奖结果通知（用户订阅后自动发送消息）
  '7-6T8W3VlHsUJ2i9wK3sYwH9oLQkiVYlK5Qow3ChbZY', // 30 红包封面 - 订阅活动开始提醒（不需要自动发送，后面运营手动发送）
  'Zf1vpiG_aFGl4TPmwPV3drZIpGuTum4n9inU6pqz9H8', // 31 订单支付成功通知 - 账户资金变动提醒
]
if (wgEnv.env == 'TEST') {
  allTmpIds = [
    'upWbD2kTBmteM64fCZSVwGoHggeVHX4Eqe4W-4XOJHc', // 0 订单支付成功通知 - 购买超会触发订阅
    'Q5dlh36a_sucR3MUqAaZ4o05abbJ8N7jVZc4G-JTg8E', // 1 订单发货通知 - 下单触发订阅  
    'HNMk69rvoDxOuJG4GnWIl-QECJ-hQ3wDG4TDXLVVcwk', // 2 预约到货通知 - 点击“到货提醒”触发订阅 
    'H_ZGJJTXVIdAsAzuQFuohgIkspGCpkSRcjXhkbPn9gM', // 3 订阅活动开始提醒 - 下单、秒杀预约、到货提醒、降价提醒、直播间预约等触发订阅
    'tNMQFAj31hEG_NIpsVFlMVIy2AapvxclJt-giCY0X8E', // 4 订单售后审核通知 - 申请退款触发订阅   
    '7yjqTlp4gjTsHFrVr8lmulTNSQj7ew9A-MY48jz7VKM', // 5 尾款支付提醒 - 下预售订单触发订阅  
    'QyTsNnkjW-sf36pCy6-PSqu3_Yic_YJgVMFAj1WrHGg', // 6 拼团结果通知 - 下拼团/团购订单触发订阅  
    'J1D8ihm_vqebL27HuoAZgLkSvLajgFlmSuREvEdb-qk', // 7 优惠券到账提醒 - 下单触发订阅
    '_aJUn1hCUDycI_9BZOK_Z4kayz104xiNnsNfz5WJrv0', // 8 优惠券过期提醒 - 点击“直播间预约”触发订阅
    'N4vCNtXJVKK4VDPdWQqgp4WLw6i3TzrWK-MngjB_SQQ', // 9 商品降价提醒 - 点击“降价提醒”触发订阅
    'kHnOrqhZx4798XpP7bSPKAT06STjItf2lzqwCjj3s9A', // 10 新活动提醒 - 点击“直播间预约”触发订阅
    'ueBAr5B7pGnnx32DDofIAY3xIM3oUQiXk9ItZ7JxGbU', // 11 新订单提醒 - 下分期购订单触发订阅
    '', // 12 占位
    '', // 13 占位
    '', // 14 占位
    '', // 15 占位
    '', // 16 占位
    'T9aCNIeXdBUd9F6iCHF7S7hd_SPvO5CigXB5NvvMJ4A', // 17 购物金储值订阅提醒 - 红包临期提醒
    '', // 18 占位
    '6fJhumKq3AACrAfSQvmcMNwiPPfl8aMrd7x0XcuHGSY', // 19 购物金储值卡 - 特权卡开通提醒
    'J1D8ihm_vqebL27HuoAZgJqK7mFpsV1zQiF3B-cQthw', // 20 购物金储值卡 - 优惠券到账提醒
    'H_ZGJJTXVIdAsAzuQFuohkmIuLrYOXZQv-P49xObxz0', // 21 购物金储值卡 - 订阅活动开始提醒
    '', // 22 占位
    'H_ZGJJTXVIdAsAzuQFuohkmIuLrYOXZQv-P49xObxz0', // 23 会员专题页- 订阅活动开始提醒
    '', // 24 占位
    '', // 25 占位
    '', // 26 占位
    '', // 27 占位
    // // 'e3Suxtp-tqLYShHr_xrOBN_lyLgmFctIsWTYkvq6BSE', // 25 新品试用 - 新品试用名单抽取
    // 'e3Suxtp-tqLYShHr_xrOBN_lyLgmFctIsWTYkvq6BSE',// 25 新品试用 - 中奖消息模版变更
    // '8KAM5bplSOE3zdQs1hJfPW6W11ziXKyr2xwfbVnSwnA', // 26 新品试用 - 新品试用产品发货提醒
    // '14NjLtU637KUnKqXETIh63uS51X_bvd_XofdU1xsDYI', // 27 新品试用 - 新品试用报告审核通过，退款
    '', // 28 占位
    '', // 29 占位
    '', // 30 占位
    '', // 31 占位
  ]
}
const tmplIds = { // 模板id根据订阅触发动作进行分类
  payError: [allTmpIds[3], allTmpIds[31]], // 支付失败  - 操作：任意产品调起支付但不要支付
  paySuccess: [allTmpIds[1], allTmpIds[3], allTmpIds[31]], // 支付成功 - 操作：任意产品支付下单
  payPresale: [allTmpIds[5], allTmpIds[3], allTmpIds[8]], // 预售支付定金 - 操作：预售产品支付定金
  payInstallment: [allTmpIds[1], allTmpIds[11], allTmpIds[3]], // 支付分期购订单 - 操作：分期购产品下单支付
  payGroupA: [allTmpIds[6], allTmpIds[1], allTmpIds[7]], // 支付拼团订单 - 操作：拼团产品支付下单
  payGroupB: [allTmpIds[6], allTmpIds[1], allTmpIds[7]], // 支付团购订单 - 操作：团购产品支付下单
  refund: [allTmpIds[4], allTmpIds[8], allTmpIds[3]], // 退款 - 操作：订单详情页或订单列表页进行退款操作
  remindPrice: [allTmpIds[9], allTmpIds[3]], // 降价提醒 - 操作：点击"降价提醒"进行预约
  remindStock: [allTmpIds[2], allTmpIds[8], allTmpIds[3]], // 到货通知 - 操作：点击"到货提醒"
  remindSeckill: [allTmpIds[3]], // 秒杀预约 - 操作：未开始秒杀产品点击"预约秒杀"
  remindLiveRoom: [allTmpIds[3], allTmpIds[10], allTmpIds[8]], // 直播间预约
  buySvip: [allTmpIds[7], allTmpIds[3], allTmpIds[0]], // 购买超级会员 - 操作：购买超会支付下单
  remindPromotion: [allTmpIds[3]], // 订阅活动
  remindCoupon: [allTmpIds[3], allTmpIds[8], allTmpIds[7]], // 订阅优惠券提醒
  getCoupon: [allTmpIds[7]], // 优惠券到账提醒
  commentList: [allTmpIds[12],allTmpIds[13],allTmpIds[15]],//社区评论列表订阅提醒
  postComment: [allTmpIds[12],allTmpIds[13]],//发布笔记订阅提醒
  gufenComment:[allTmpIds[14],allTmpIds[15]],//谷粉超话评论订阅提醒
  goReserve:[allTmpIds[16],allTmpIds[17],allTmpIds[18]],//购物金储值订阅提醒
  invitation:[allTmpIds[23]],//购物金储值订阅提醒
  payStored:[allTmpIds[19],allTmpIds[20],allTmpIds[24]],//购物金储值卡确认支付订阅消息提醒
  handselStored:[allTmpIds[22],allTmpIds[20],allTmpIds[21]],//购物金储值卡赠送好友订阅消息提醒
  productTrial:[allTmpIds[25],allTmpIds[26],allTmpIds[27]],//新品试用，点击申请订阅消息提醒
  redEnvelopes: [allTmpIds[28],allTmpIds[29],allTmpIds[30]],//红包封面，点击【参与抽奖】
}
function compareVersion(v1, v2) { // 版本比较
  // compareVersion('1.11.0', '1.9.9') // => 1    // 1 表示 1.11.0 比 1.9.9 要新
  // compareVersion('1.11.0', '1.11.0') // => 0   // 0 表示 1.11.0 和 1.9.9 是同一个版本
  // compareVersion('1.11.0', '1.99.0') // => -1  // -1 表示 1.11.0 比 1.99.0 要老
  v1 = v1.split('.')
  v2 = v2.split('.')

  let len = Math.max(v1.length, v2.length)

  while (v1.length < len) {
    v1.push('0')
  }
  while (v2.length < len) {
    v2.push('0')
  }

  for (let i = 0; i < len; i++) {
    let num1 = parseInt(v1[i])
    let num2 = parseInt(v2[i])

    if (num1 > num2) {
      return 1
    } else if (num1 < num2) {
      return -1
    }
  }

  return 0
}

function getSetting(tmplIds) { // 获得订阅消息设置（是否被用户选择了总是允许）
  return new Promise((resolve, reject) => {
    try {
      wx.getSetting({
        withSubscriptions: true,
        success(res) {
          if (res.hasOwnProperty('subscriptionsSetting')) {
            if (res.subscriptionsSetting.itemSettings) {
              let allAllowTmpIds = res.subscriptionsSetting.itemSettings
              if (WGDATATYPE.isArray(tmplIds)) {
                for (let i = 0; i < tmplIds.length; i++) {
                  if (allAllowTmpIds[tmplIds[i]]) {
                    resolve(true) // 点击了‘总是’
                  }
                }
              }
              resolve(false) // 没有‘总是’
            } else {
              resolve(false) // 没有点击‘总是’
            }
          } else {
            resolve(false)
          }
        },
      })
    } catch (e) {
      resolve(true)
    }
  })
}

function showAllwaysGif(msgType) { // 显示引导GIF图
  let systemInfo = wx.getSystemInfoSync(),
    app = getApp(),
    SDKVersion = systemInfo.SDKVersion, // 基础库版本
    version = systemInfo.version // 微信版本
  getSetting(tmplIds[msgType]).then(res => {
    let isAllways = res
    if (compareVersion(SDKVersion, '2.8.4') >= 0 && compareVersion(version, '7.0.7') >= 0 && !isAllways) {
      app.globalData['showSubscribeGif'] = true // 显示订阅消息GIF引导图
    } else {
      app.globalData['showSubscribeGif'] = false // 不显示订阅消息GIF引导图
    }
  })
}

function uploadTempIdsAndOpenid(tmplIds) { // 用户订阅消息上报 @接口提供 wenrc
  let uploadObj = {
    appId: wgEnv.appId,
    openId: wx.getStorageSync('openId'),
    templates: JSON.stringify(tmplIds),
  }
  wx.request({
    url: wgEnv.baseUrl + 'wechat-miniprogram-back/base/saveSubscribeMsg',
    method: 'POST',
    data: uploadObj,
    success(res) {},
  })
}

function wgSubscribe(msgType) {
  console.log(msgType)
  return new Promise((resolve, reject) => {
    try {
      showAllwaysGif()
      wx.requestSubscribeMessage({
        tmplIds: tmplIds[msgType],
        success(res) {
          console.log('wgSubscribe', res)
          if (res.errMsg == 'requestSubscribeMessage:ok') {
            let allowTmpIds = []
            for (let key in res) {
              if (res[key] == 'accept') {
                allowTmpIds.push({
                  templateId: key
                })
              }
            }
            if (allowTmpIds.length > 0) {
              uploadTempIdsAndOpenid(allowTmpIds)
              resolve(1)
            }
            resolve(0)
          } else {
            resolve(0)
          }
        },
        fail(err) {
          console.log('关闭订阅权限')
          console.log('wgSubscribe', err)
          resolve(err)
        },
        complete(r) {
          resolve(r)
        },
      })
    } catch (err) {
      console.error('微信版本过低，不支持订阅消息！')
      resolve(err)
    }
  })
}

export default wgSubscribe