/**
 * path 页面路径
 * elementTracks 页面元素埋点
 * methodTracks 执行函数埋点
 * comMethodTracks: 执行组件内函数埋点
 */
const trackConfig = [{
    title: '会员商城首页',
    path: 'pages/Home/Home',
    elementTracks: [{
      element: '.home-page',
      elementName: '首页点击埋点测试',
      dataKeys: ['env1'],
    }, {
      element: '.home-contact>>>.lxkf',
      elementName: '首页组件中点击埋点测试',
      dataKeys: ['level'],
    }],
    methodTracks: [{
      method: 'initHomePage',
      element: 'initHomePage',
      elementName: '首页方法埋点测试',
      dataKeys: ['addtominiprogram'],
    }],
    comMethodTracks: [{
      method: 'getLevel',
      element: 'getLevel',
      elementName: '首页组件中方法埋点测试',
      dataKeys: ['ysf'],
    }]
  },
  {
    title: '产品分类页',
    path: 'pages/ProductIndex/ProductIndex',
    elementTracks: [{
      element: '.p-category',
      elementName: '分类二级顶部菜单',
      dataKeys: [],
    }, {
      element: '.c-category',
      elementName: '分类二级底部菜单',
      dataKeys: [],
    }, ],
    methodTracks: [{
      method: 'clickMenuSeries',
      element: 'clickMenuSeries',
      elementName: '分类选择',
      dataKeys: [],
    }],
  },
  {
    title: '产品列表页',
    path: 'pages/ProductList/ProductList',
    methodTracks: [{
      method: 'goDetail',
      element: 'goDetail',
      elementName: '商品卡触发',
      dataKeys: [],
    }, {
      method: 'addCart',
      element: 'first_add_to_cart',
      elementName: '首次加购',
      dataKeys: [],
    }],
  },
  {
    title: '购物车',
    path: 'pages/MyCart/MyCart',
    methodTracks: [{
      method: 'goDetail',
      element: 'goDetail',
      elementName: '购物车商品卡触达',
      dataKeys: [],
    }, {
      method: 'add',
      element: 'append_to_cart_in_cart',
      elementName: '购物车追加',
      dataKeys: [],
    }, {
      method: 'reduce',
      element: 'reduce',
      elementName: '购物车减少商品',
      dataKeys: [],
    }, {
      method: 'deleteItem',
      element: 'deleteItem',
      elementName: '从购物车彻底移除',
      dataKeys: [],
    }, {
      method: 'pay',
      element: 'pay',
      elementName: '购物车跳转结算页',
      dataKeys: [],
    }],
  },
  {
    title: '产品详情页',
    path: 'pages/ProductDetail/ProductDetail',
    methodTracks: [{
      method: 'goCoupon',
      element: 'goCoupon',
      elementName: '产品详情跳转优惠券',
      dataKeys: [],
    }, {
      method: 'closeFavModal',
      element: 'closeFavModal',
      elementName: '关闭收藏小程序弹框',
      dataKeys: [],
    }, {
      method: 'showTips',
      element: 'showTips',
      elementName: '显示拼团规则',
      dataKeys: [],
    }, {
      method: 'goDetail',
      element: 'goDetail',
      elementName: '去参团',
      dataKeys: [],
    }, {
      method: 'goComment',
      element: 'goComment',
      elementName: '查看评论',
      dataKeys: [],
    }, {
      method: 'addCart',
      element: 'addCart',
      elementName: '加入购物车',
      dataKeys: [],
    }, {
      method: 'reserveProduct',
      element: 'reserveProduct',
      elementName: '到货提醒/兑换提醒',
      dataKeys: [],
    }, {
      method: 'goOtherDetail',
      element: 'goOtherDetail',
      elementName: '好物推荐',
      dataKeys: [],
    }, ],
  },
  {
    title: '拼团详情页',
    path: 'pages/GroupDetail/GroupDetail',
  },
  {
    title: '团购详情页',
    path: 'pages/GroupBDetail/GroupBDetail'
  },
  {
    title: '修改绑定手机号',
    path: 'pages/ReplacePhone/ReplacePhone'
  },
  {
    title: '订单列表页',
    path: 'pages/OrderList/OrderList',
    methodTracks: [],
    comMethodTracks: [{
      method: 'goDetail',
      element: 'goDetail',
      elementName: '订单列表跳转商品详情',
      dataKeys: ['pId'],
    }, {
      method: 'cancelRefund',
      element: 'cancelRefund',
      elementName: '取消退款',
      dataKeys: [],
    }, {
      method: 'applyRefundOrder',
      element: 'applyRefundOrder',
      elementName: '申请退款',
      dataKeys: [],
    }, {
      method: 'editReturnForm',
      element: 'editReturnForm',
      elementName: '填写退货信息',
      dataKeys: [],
    }, {
      method: 'goLogistics',
      element: 'goLogistics',
      elementName: '查看物流',
      dataKeys: [],
    }, {
      method: 'goComment',
      element: 'goComment',
      elementName: '去评价/试用报告',
      dataKeys: [],
    }, {
      method: 'goLogistics',
      element: 'goLogistics',
      elementName: '查看物流',
      dataKeys: [],
    }, {
      method: 'cancelOrder',
      element: 'cancelOrder',
      elementName: '取消交易',
      dataKeys: [],
    }, {
      method: 'confirmOrder',
      element: 'confirmOrder',
      elementName: '确认收货',
      dataKeys: [],
    }, {
      method: 'goGroupDetail',
      element: 'goGroupDetail',
      elementName: '查看拼团详情/邀请好友拼团/查看团购详情/邀请好友团购',
      dataKeys: [],
    }, {
      method: 'delOrder',
      element: 'delOrder',
      elementName: '删除订单',
      dataKeys: [],
    }, {
      method: 'pay',
      element: 'pay',
      elementName: '支付尾款',
      dataKeys: [],
    }]
  },
  {
    title: '订单详情页',
    path: 'pages/OrderDetail/OrderDetail',
    methodTracks: [{
      method: 'goLogistics',
      element: 'goLogistics',
      elementName: '快递信息',
      dataKeys: [],
    }, {
      method: 'copyOrderCode',
      element: 'copyOrderCode',
      elementName: '复制订单号',
      dataKeys: [],
    }, {
      method: 'goIndex',
      element: 'goIndex',
      elementName: '去首页',
      dataKeys: [],
    }, {
      method: 'goLogisticsList',
      element: 'goLogisticsList',
      elementName: '查看物流',
      dataKeys: [],
    }, {
      method: 'goComment',
      element: 'goComment',
      elementName: '去评价/试用报告',
      dataKeys: [],
    }, {
      method: 'delOrder',
      element: 'delOrder',
      elementName: '删除订单',
      dataKeys: [],
    }, {
      method: 'cancelOrder',
      element: 'cancelOrder',
      elementName: '取消交易',
      dataKeys: [],
    }, {
      method: 'pay',
      element: 'pay',
      elementName: '支付',
      dataKeys: [],
    }, {
      method: 'confirmOrder',
      element: 'confirmOrder',
      elementName: '确认收货',
      dataKeys: [],
    }, {
      method: 'invitePeople',
      element: 'invitePeople',
      elementName: '邀请好友拼团',
      dataKeys: [],
    }, {
      method: 'goGroupBDetail',
      element: 'goGroupBDetail',
      elementName: '邀请好友团购',
      dataKeys: [],
    }, {
      method: 'drawTipsShow',
      element: 'drawTipsShow',
      elementName: '点我抽奖',
      dataKeys: [],
    }, {
      method: 'closeQyModal',
      element: 'closeQyModal',
      elementName: '关闭企业微信号二维码弹窗',
      dataKeys: [],
    }, {
      method: 'closeSku',
      element: 'closeSku',
      elementName: '关闭购物金弹窗',
      dataKeys: [],
    }],
    comMethodTracks: [{
      method: 'goDetail',
      element: 'goDetail',
      elementName: '订单详情页跳转商品详情',
      dataKeys: [],
    }, {
      method: 'cancelRefund',
      element: 'cancelRefund',
      elementName: '取消退款',
      dataKeys: [],
    }, {
      method: 'applyRefundOrder',
      element: 'applyRefundOrder',
      elementName: '申请退款',
      dataKeys: [],
    }, {
      method: 'editReturnForm',
      element: 'editReturnForm',
      elementName: '填写退货信息',
      dataKeys: [],
    }]
  },
  {
    title: '套餐搭配详情页',
    path: 'pages/PackageDetail/PackageDetail'
  },
  {
    title: '订单结算页',
    path: 'pages/PayOrder/PayOrder',
    methodTracks: [{
      method: 'sureHuanGou',
      element: 'sureHuanGou',
      elementName: '点击换购',
      dataKeys: [],
    }, {
      method: 'selectCouponNew',
      element: 'selectCouponNew',
      elementName: '选择优惠券券',
      dataKeys: [],
    }, {
      method: 'toggleHb',
      element: 'toggleHb',
      elementName: '是否使用购物金',
      dataKeys: [],
    }, {
      method: 'selectedSvipGift',
      element: 'selectedSvipGift',
      elementName: '购买超级会员赠品选择',
      dataKeys: [],
    }, {
      method: 'viewDetail',
      element: 'viewDetail',
      elementName: '结算页跳转商品详情',
      dataKeys: [],
    }, {
      method: 'surePay',
      element: 'surePay',
      elementName: '点击微信安全支付按钮',
      dataKeys: [],
    }, {
      method: 'closeDetail',
      element: 'closeDetail',
      elementName: '关闭赠品的详情介绍弹窗',
      dataKeys: [],
    }]
  },
  {
    title: '芝养卡结算页',
    path: 'pages/PayOrderEquity/PayOrderEquity'
  },
  {
    title: '我的优惠券',
    path: 'pages/TicketsAccount/TicketsAccount'
  },
  {
    title: '个人中心',
    path: 'pages/PersonalCenter/PersonalCenter'
  },
  {
    title: '我的积分',
    path: 'pages/IntegralAccount/IntegralAccount'
  },
  {
    title: '积分兑换页',
    path: 'pages/CreditsExchange/CreditsExchange'
  },
  {
    title: '我的购物金',
    path: 'pages/GoldAccount/GoldAccount'
  },
  {
    title: '管理地址',
    path: 'pages/AddressManage/AddressManage'
  },
  {
    title: '地址列表页',
    path: 'pages/AddressList/AddressList'
  },
  {
    title: '修改地址',
    path: 'pages/UpdateAddress/UpdateAddress'
  },
  {
    title: "物流",
    path: 'pages/Logistics/Logistics'
  },
  {
    title: '给卖家留言',
    path: 'pages/LeaveMessage/LeaveMessage'
  },
  {
    title: '售后',
    path: 'pages/SaleServer/SaleServer'
  },
  {
    title: '退货',
    path: 'pages/ReturnForm/ReturnForm'
  },
  {
    title: '订单评论',
    path: 'pages/OrderComment/OrderComment'
  },
  {
    title: '评论详情',
    path: 'pages/CommentDetail/CommentDetail'
  },
  {
    title: '拼团分享',
    path: 'pages/SharePoster/SharePoster'
  },
  {
    title: '拼团预售页',
    path: 'pages/PromotionPage/PromotionPage'
  },
  {
    title: '降价提醒',
    path: 'pages/RemindPrice/RemindPrice'
  },
  {
    title: '分期发货单发货详情',
    path: 'pages/SubOrderDetail/SubOrderDetail'
  },
  {
    title: '我的微信商城超级会员',
    path: 'pages/superMember/superMember'
  },
  {
    title: '微信商城超级会员9大特权',
    path: 'pages/MemberDetail/MemberDetail'
  },
  {
    title: '试用报告列表页',
    path: 'pages/TrialReport/TrialReport'
  },
  {
    title: '试用报告详情页',
    path: 'pages/TrialReportDetail/TrialReportDetail'
  },
  {
    title: '如何成为金谷',
    path: 'pages/HowBeGold/HowBeGold'
  },
  {
    title: '小程序二级活动页',
    path: 'pages/ActivePage/ActivePage'
  },
  {
    title: 'H5二级活动页',
    path: 'pages/ActivityPage/ActivityPage'
  },
  {
    title: '直播间',
    path: 'modules/LivePlay/pages/LiveRoom/LiveRoom'
  },
  {
    title: '直播回放',
    path: 'modules/LivePlay/pages/Playback/Playback'
  },
  {
    title: '谷粉超话',
    path: 'modules/FanCommunity/pages/Index/Index'
  },
  {
    title: '搜索谷粉说',
    path: 'modules/FanCommunity/pages/SearchComment/SearchComment'
  },
  {
    title: '谷粉说发帖子',
    path: 'modules/FanCommunity/pages/PostComment/PostComment'
  },
  {
    title: '谷粉社区',
    path: 'modules/FanCommunity/pages/WgFans/WgFans'
  },
  {
    title: '谷粉社区H5文章详情',
    path: 'modules/FanCommunity/pages/WebEntry/WebEntry'
  },
  {
    title: '谷粉社区搜索页',
    path: 'modules/FanCommunity/pages/Search/Search'
  },
  {
    title: '谷粉社区内容详情',
    path: 'modules/FanCommunity/pages/UserNoteDetail/UserNoteDetail'
  },
  {
    title: '营养百科',
    path: 'modules/FanCommunity/pages/HealthGuide/HealthGuide'
  },
  {
    title: '营养百科文章详情',
    path: 'modules/FanCommunity/pages/ContentDetail/ContentDetail'
  },
  {
    title: '谷粉说详情页',
    path: 'modules/FanCommunity/pages/CommentDetail/CommentDetail'
  },
  {
    title: '谷粉社区',
    path: 'modules/FanCommunity/pages/CommentList/CommentList'
  },
  {
    title: '商品搜索',
    path: 'pages/Search/Search'
  },
  {
    title: '会员商城授权登录页面',
    path: 'pages/AuthPage/AuthPage'
  },
  {
    title: '五谷磨房超级会员服务协议',
    path: 'pages/UserRule/UserRule'
  },
  {
    title: '领取优惠券',
    path: 'pages/GetTicket/GetTicket'
  },
  {
    title: '试用中心',
    path: 'modules/ProductTrial/pages/TrialCenter/TrialCenter'
  },
  {
    title: '试用活动详情',
    path: 'modules/ProductTrial/pages/ActivityDetail/ActivityDetail'
  },
  {
    title: '已结束的试用活动详情页',
    path: 'modules/ProductTrial/pages/OverActivity/OverActivity'
  },
  {
    title: '申请详情',
    path: 'modules/ProductTrial/pages/ApplicationDetails/ApplicationDetails'
  },
  {
    title: '试用报告',
    path: 'modules/ProductTrial/pages/TrialReport/trialReport'
  },
  {
    title: '申请试用信息填写',
    path: 'modules/ProductTrial/pages/ApplyTrial/ApplyTrial'
  },
  {
    title: '申请试用详情',
    path: 'modules/ProductTrial/pages/ApplyDetail/ApplyDetail'
  },
  {
    title: '添加营养师',
    path: 'modules/ProductTrial/pages/enterpriseImg/enterpriseImg'
  },
  {
    title: '618点赞聚划算-邀好友点赞页',
    path: 'modules/MallPromotion/pages/InviteDeprice/InviteDeprice'
  },
  {
    title: '618点赞聚划算-首页',
    path: 'modules/MallPromotion/pages/ThumbUp2Deprice/ThumbUp2Deprice'
  },
  {
    title: '新品预告',
    path: 'modules/MallPromotion/pages/NewProductNotice/NewProductNotice',
  },
  {
    title: '活动积分领取',
    path: 'modules/MallPromotion/pages/IntegralActivity/IntegralActivity',
  },
  {
    title: '会员日邀请函',
    path: 'modules/MallPromotion/pages/InviteSvip/InviteSvip'
  },
  {
    title: '年货节集卡',
    path: 'modules/MallPromotion/pages/CollectCard/CollectCard'
  },
  {
    title: '618省钱卡',
    path: 'modules/MallPromotion/pages/SaveMoneyCard/SaveMoneyCard'
  },
  {
    title: '换积分',
    path: 'modules/MallPromotion/pages/pointExchange/pointExchange'
  },
  {
    title: '翻牌游戏',
    path: 'modules/Svip/pages/FilpGame/FilpGame'
  },
  {
    title: '会员挑战计划',
    path: 'modules/MemberPlan/pages/MemberPlan/MemberPlan'
  },
  {
    title: '每月券包',
    path: 'modules/Svip/pages/MonthlyCoupons/MonthlyCoupons'
  },
  {
    title: '权益卡详情页',
    path: 'pages/EquityCard/EquityCard'
  },
  {
    title: '会员挑战计划报名页',
    path: 'modules/MemberPlan/pages/MemberPlan/MemberPlan'
  },
  {
    title: '会员挑战计划-我的挑战进度',
    path: 'modules/MemberPlan/pages/MyPlan/MyPlan'
  },
  {
    title: '会员挑战计划-挑战成功',
    path: 'modules/MemberPlan/pages/ChallengeSuccess/ChallengeSuccess'
  },
  {
    title: '会员挑战计划-挑战失败',
    path: 'modules/MemberPlan/pages/ChallengeFail/ChallengeFail'
  },
  {
    title: '扫码加企微',
    path: 'pages/ScanQrcode/ScanQrcode'
  },
  {
    title: '会员专题页',
    path: 'pages/UserInfo/UserInfo'
  },
  {
    title: 'WebView',
    path: 'pages/WebView/WebView'
  },
  {
    title: '积分延期卡',
    path: 'modules/Svip/pages/ExtensionCar/ExtensionCar'
  },
  {
    title: '购买购物金',
    path: 'modules/ShoppingMoney/pages/Stored/Stored'
  },
  {
    title: '购物金明细',
    path: 'modules/ShoppingMoney/pages/StoredDetail/StoredDetail'
  },
  {
    title: '我的储值卡',
    path: 'modules/ShoppingMoney/pages/StoredList/StoredList'
  },
  {
    title: '赠送储值卡',
    path: 'modules/ShoppingMoney/pages/Handsel/Handsel'
  },
  {
    title: '领取储值卡',
    path: 'modules/ShoppingMoney/pages/StoredReceive/StoredReceive'
  },
  {
    title: '卡详情',
    path: 'modules/ShoppingMoney/pages/DeliveryRecord/DeliveryRecord'
  },
  {
    title: '购买历史',
    path: 'modules/ShoppingMoney/pages/PurchaseHistory/PurchaseHistory'
  },
  {
    title: '红包封面抽奖',
    path: 'modules/redEnvelopes/pages/redEnvelopesList/redEnvelopesList',
  },
  {
    title: '中奖名单',
    path: 'modules/redEnvelopes/pages/winnerList/winnerList',
  },
  {
    title: '服务通知',
    path: 'modules/redEnvelopes/pages/posterPage/posterPage',
  },
  {
    title: '封面预览',
    path: 'modules/redEnvelopes/pages/preview/preview',
  }
]
export default trackConfig;